/*
 * $Id: FixedNormalSite.java,v 1.2 2004/03/12 18:27:55 tims Exp $
 *
 * Copyright (c) 1998-2000 The Regents of the University of California.
 * All rights reserved. See the file COPYRIGHT for details.
 *
 */

package diva.canvas.connector;

import diva.canvas.Site;
import diva.canvas.SiteDecorator;

/** A site decorator that disallows changing the normal.  This is useful for
 * perimeter sites that stay at one point on a figure.  Normally connectors
 * change the normal of a site so that the figure looks better.  
 * This class is often used so that the site that points out of a terminal
 * can be properly manhattan routed so that it always leave the terminal in
 * the ight direction.
 *
 * @version	$Revision: 1.2 $
 * @author 	Steve Neuendorffer
 */
public class FixedNormalSite extends SiteDecorator {
    public FixedNormalSite(Site site) {
	super(site);
    }
    
    public void setNormal(double normal) {
	// Do nothing
    }
}





