package diva.graph;

import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import diva.canvas.interactor.CompositeInteractor;

public class NodeRightClickInteractor extends CompositeInteractor {
	/**
	 * The graph controller that manages this interactor.
	 */
	private GraphController _controller;
    
	/** Create a new NodeRightClickInteractor and give it a pointer
	 * to its controller so it can find other useful objects
	 */
	public NodeRightClickInteractor (GraphController controller) {
		_controller = controller;
	}
	
	public void openStats(){
		System.out.println("NodeRightClickInteractor.openStats()");
		JTabbedPane statsTabbedPane = (JTabbedPane) _controller.getStatsTabbedPane();
		
		ImageIcon icon = createImageIcon("resources/close.gif");
		statsTabbedPane.addTab("Stats 1", icon, new JPanel());
		
	}
	
	protected static ImageIcon createImageIcon(String path){
		java.net.URL imgURL = NodeRightClickInteractor.class.getResource(path);
		 if (imgURL != null) {
			 return new ImageIcon(imgURL);
		 } else {
			 System.err.println("Couldn't find file: " + path);
			 return null;
		 }
	}
	
}