/*
 * $Id: ArcRenderer.java,v 1.2 2004/03/12 18:27:54 tims Exp $
 *
 * Copyright (c) 1998-2000 The Regents of the University of California.
 * All rights reserved. See the file COPYRIGHT for details.
 */
package diva.graph.basic;

import java.awt.Font;

import diva.canvas.Site;
import diva.canvas.connector.ArcConnector;
import diva.canvas.connector.Arrowhead;
import diva.canvas.connector.Connector;
import diva.canvas.toolbox.LabelFigure;
import diva.graph.EdgeRenderer;

/**
 * An EdgeRenderer that draws arcs. To do so, it creates a new
 * instance of ArcConnector and initializes it.
 *
 * @author Edward A. Lee  (eal@eecs.berkeley.edu)
 * @version $Revision: 1.2 $
 * @rating Red
 */
public class ArcRenderer implements EdgeRenderer {
    /** Render a visual representation of the given edge.
     */
    public Connector render(Object edge, Site tailSite, Site headSite) {
        // FIXME: Find a way to set the curvature (the third argument).
        ArcConnector c = new ArcConnector(tailSite, headSite);
        Arrowhead arrow = new Arrowhead(
                headSite.getX(), headSite.getY(), headSite.getNormal());
	c.setHeadEnd(arrow);

        Object p = "edge";//edge.getProperty("label");
        String label = p == null ? "#" : (String) p;
	LabelFigure labelFigure = new LabelFigure(label);
        labelFigure.setStyle(Font.ITALIC);
        labelFigure.setSize(14);
        c.setLabelFigure(labelFigure);
        return c;
    }
}


