/*
 * $Id: Graph.java,v 1.2 2004/03/12 18:27:54 tims Exp $
 *
 * Copyright (c) 2000 The Regents of the University of California.
 * All rights reserved.  See the file COPYRIGHT for details.
 */
package diva.graph.modular;
import java.util.Iterator;

import diva.util.PropertyContainer;
import diva.util.SemanticObjectContainer;

/**
 * A graph is an object that contains nodes and
 * edges.  Edges are accessed through the nodes that
 * they connect.
 * 
 * @author Michael Shilman  (michaels@eecs.berkeley.edu)
 * @version $Revision: 1.2 $
 * @rating Red
 */
public interface Graph extends SemanticObjectContainer, PropertyContainer {
    /**
     * Return an iterator over the nodes that this graph contains.
     */
    public Iterator nodes();

    /**
     * Return a count of the nodes this graph contains.
     */
    public int getNodeCount();
}

