/*
 * $Id: MenuFactory.java,v 1.2 2004/03/12 18:27:55 tims Exp $
 *
 * Copyright (c) 1998-2000 The Regents of the University of California.
 * All rights reserved. See the file COPYRIGHT for details.
 */
package diva.gui.toolbox;

import diva.canvas.Figure;

/**
 * A factory for popup menus.  Use this class in conjuction with
 * a MenuCreator to implement context sensitive menus.
 *
 * @author Steve Neuendorffer (neuendor@eecs.berkeley.edu)
 * @version $Revision: 1.2 $
 */
public abstract class MenuFactory {
    /**
     * Create an instance of the menu associated with this factory.
     * If no menu should be displayed, then return null.
     */
    public abstract JContextMenu create(Figure figure);
}


