/*
 * $Id: AspectRatioFE.java,v 1.2 2004/03/12 18:27:54 tims Exp $
 *
 * Copyright (c) 1998-2000 The Regents of the University of California.
 * All rights reserved. See the file COPYRIGHT for details.
 */
package diva.sketch.features;
import java.awt.geom.Rectangle2D;

import diva.sketch.recognition.TimedStroke;

/**
 * AspectRatioFE calculates the ratio of the width and the height of a
 * stroke, (width/height).
 *
 * @author Heloise Hse (hwawen@eecs.berkeley.edu)
 * @version $Revision: 1.2 $
 */
public class AspectRatioFE implements FeatureExtractor {
    /**
     * StrokeBbox computes the bounding box of a stroke.
     */
    private StrokeBBox _strokeBbox = new StrokeBBox();   

    /**
     * Return the ratio of the width and height of the stroke.
     */
    public double apply(TimedStroke s) {
        Rectangle2D box = _strokeBbox.apply(s);
        return ((double)box.getWidth()/(double)box.getHeight());
    }

    /**
     * Return the name of the feature extractor.
     */    
    public String getName() {
        return "Aspect Ratio";
    }

}


