/*
 * $Id: NullIterator.java,v 1.1 2004/02/05 20:12:16 mnwaltz Exp $
 *
 * Copyright (c) 1998-2000 The Regents of the University of California.
 * All rights reserved. See the file COPYRIGHT for details.
 */
package diva.util;

import java.util.Iterator;
import java.util.NoSuchElementException;

/**
 * An iterator over nothing.
 *
 * @author John Reekie      (johnr@eecs.berkeley.edu)
 * @author Michael Shilman  (michaels@eecs.berkeley.edu)
 * @version $Revision: 1.1 $
 */
public class NullIterator implements Iterator {
  public boolean hasNext() {
    return false;
  }
  public Object next() {
    throw new NoSuchElementException("No more elements");
  }
  public void remove() {

    throw new UnsupportedOperationException("Can't remove element");
  }
}


