/*
 * $Id: VisualObjectContainer.java,v 1.1 2004/02/05 20:12:16 mnwaltz Exp $
 *
 * Copyright (c) 1998-2000 The Regents of the University of California.
 * All rights reserved. See the file COPYRIGHT for details.
 */
package diva.util;

import diva.graph.modular.Node;
/**
 * An object which is visually represented by a 
 * "visual object" which is its visible representation within
 * a visualization or editing application.
 *
 * @author John Reekie (johnr@eecs.berkeley.edu)
 * @author Michael Shilman (michaels@eecs.berkeley.edu)
 * @version $Revision: 1.1 $
 */
public interface VisualObjectContainer {
    /**
     * Return the visual object.
     */
    public Node getVisualObject();

    /**
     * Set the visual object.
     */
    public void setVisualObject(Node o);
}


