package edu.wpi.cs.dsrg.xmldb.xat.common.dompattern;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

/**
 * This Class defines the TextNode.
 * TextNode has a tagValue that represents a text string.
 * The tagName that is set to null. 
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0
 */

public class TextNodeImp extends DOMPatternNodeImp implements TextNode {
/**
 * The default TextNodeImp constructor.
 * @since 1.0
 */
public TextNodeImp() {
	super();
}
/**
 * The TextNodeImp constructor using given string as tag value.
 * @param text The string used to construct a TextNodeImp.
 * @since 1.0
 */
public TextNodeImp(String text) {
	super(null, text);
}
/**
 * The TextNodeImp constructor using given strings as tagName and tagValue.
 * @param name The tag name used to construct a TextNodeImp.
 * @param name The tag value used to construct a TextNodeImp. 
 * @since 1.0
 */

public TextNodeImp(String name, String value) {
	super(null, value);
}
}
