package edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATMultiSourceOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;

/**
 * An interface for the ifExpr opertor.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0      
 */

public interface IfExpr extends XATMultiSourceOperator {

    /**
     * Gets the else XAT tree
     * @return the else XAT tree.
     * @since   1.0          
     */
    XATTree getElseXAT();

    /**
     * Gets the if expression.
     * @return the if expression
     * @since   1.0          
     */
    Expression getIfExpr();

    /**
     * Gets the then XAT tree.
     * @return the then XAT tree.
     * @since   1.0          
     */

    XATTree getThenXAT();

    /**
     * Sets the else XAT tree
     * @param elseXAT the else XAT tree.
     * @since   1.0          
     */
    void setElseXAT(XATTree elseXAT);

    /**
     * Sets the if expression.
     * @param expr the if expression
     * @since   1.0          
     */
    void setIfExpr(Expression expr);

    /**
     * Sets the then XAT tree.
     * @param thenXAT the then XAT tree.
     * @since   1.0          
     */
    void setThenXAT(XATTree thenXAT);

}