package edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATMultiSourceOperatorImp;

/**
 * Implementation for the interface Or.
 * It will choose any branch underneath it to evaluation.
 * An op to represent multiple query plans.
 *
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0      
 */

public class OrImp extends XATMultiSourceOperatorImp implements Or {

    protected int executeBranch = 0;

    /**
     * OrImp constructor comment.
     * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
     * @since   1.0          
     */
    public OrImp(edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode node) {
        super(node);
    }
    /**
     * Get the number of the branch to be selected.
     * @return int
     * @since   1.0          
     */
    public int getExecuteBranch() {
        return executeBranch;
    }
    /**
     * Set the number of the branch to be selected.
     * @param newExecuteBranch int
     * @since   1.0          
     */
    public void setExecuteBranch(int newExecuteBranch) {
        executeBranch = newExecuteBranch;
    }
}
