package edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import java.text.DecimalFormat;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;

/**
 * The FunNUMFORMAT class.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0   
 */
public class FunNUMFORMAT extends FunCall {
    /**
    * Execution method for FunNUMFORMAT.
    * @param deRefParamV are the parameters
    * @return the result of execution.    
    * @throws Exception 
    * @since   1.0      
    */
    public Object exec(Vector paramV) throws Exception {
        if (paramV.size() != 2) {
            throw new Exception("Only two params are allowed!");
        } else {
            Object param1 = paramV.elementAt(0);
            Object param2 = paramV.elementAt(1);
            if (!(param1 instanceof String)) {
                throw new Exception("The first parameter should be number format!");
            } else {
                DecimalFormat df = new DecimalFormat((String) param1);
                String destString = new String();
                if (param2 instanceof String)
                    destString = (String) param2;
                else
                    if (param2 instanceof XATDataValue)
                        destString = ((XATDataValue) param2).convertToString();
                    else {
                        throw new Exception("The second parameter is invalid data type!");
                    }
                double d = new Double(destString).doubleValue();
                String result = df.format(d);
                return result;
            }
        }
    }
}