package edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

/**
 * It is used to represent the user defined functions in the XQuery.
 * These are not the functions implemented by the classes,
 * but specified in the input XQuery, e.g., recursive queries.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0   
*/
public class FunUserDefined extends FunctionImp {

    /**
     * Assign a node to this operator .
     * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
     * @since   1.0        
     */
    public FunUserDefined(XATNode node) {
        super(node);
    }

    /**
    * Recursively execute the user defined function in another execute visitor.
    * Functionality:
    *   - create a new execute visitor.
    *   - get the input table of this function F.
    *   - query the parser traverse to get the XAT for this user defined function.
    *   - get all the leave nodes of the XAT.
    *   - update their input XAT table as this input XAT table.
    *   - execute the XAT.
    *   - get the output table from the root of this XAT.
    *   - update the output table of this function f.
    *   - done.
    * @param f edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function.Function    
    * @since   1.0        
    */
    public void eval(Function f) {

    }
}