package edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.visitorpattern.Visitor;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

/**
 * Implementation for the Select interface.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0   
 */
public class SelectImp extends XATOperatorImp implements Select {

    protected Expression expression;

    /**
     * Assigns a node to this operator and an expression.
     * @param xnodInit edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
     * @param exp edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression
     * @since   1.0        
     */
    public SelectImp(XATNode xnodInit, Expression exp) {
        super(xnodInit);
        expression = exp;

    }
    /** 
     * Used to implement a visitor pattern. 
     * @param visitor for the visitor pattern
     * @since   1.0       
     */
    public void accept(Visitor visitor) {

    }
    /** 
    * Gets select expression. 
    * @return join expression
    * @since   1.0       
    */
    public Expression getExpression() {
        return expression;
    }
    /**
     * Set select expression.
     * @param new_expression New Select expression.
     * @since   1.0      
     */
    public void setExpression(Expression newExpression) {
        expression = newExpression;
    }

    /**
    * Returns a String that represents the value of this object.
    * @return a string representation of the receiver
    * @since   1.0          
    */
    public String toString() {
        return "Select[" + expression + "]";
    }
}