package edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.NavigationStep;

/**
 * The Navigate interface. The Navigate opertor takes the source and navigates through it given a specific XPath
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0   
 */
public interface Navigate extends XMLOperator {

    /** 
     * Gets the binding value.
     * @return String
     * @since   1.0  
     * @deprecated Use getOutputColumnName() instead.     
     */
    public String getBinding();
    /** 
     * Gets the destination.
     * @return an array of NavigationStep
     * @since   1.0        
     */
    public NavigationStep[] getDestination();
    /** 
     * Gets the entry point.
     * @return an array of NavigationStep
     * @since   1.0        
     */
    public NavigationStep[] getEntryPoint();
    /**
     * Returns a String that represents the value of this object.
     * @return a string representation of the receiver
     * @since   1.0          
     */
    public String printNode();
    /** 
     * Sets the binding value.
     * @param bind String
     * @since   1.0
     * @deprecated Use setOutputColumnName(String) instead.     
     */
    public void setBinding(String bind);
    /** 
     * Sets the destination.
     * @param destination is an array of NavigationStep
     * @since   1.0
     */
    public void setDestination(NavigationStep[] destination);
    /**
     * Sets the entry point. 
     * @param ept New entry point for this navigation operator.
     * @since   1.0     
     */
    public void setEntryPoint(NavigationStep[] ept);
}
