package edu.wpi.cs.dsrg.xmldb.xat.common.xatnode;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

/**
 * This class implemented the interface of XATDataSource.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0 
 */
public abstract class XATDataSourceImp extends edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObjectImp implements XATDataSource {
/**
 * The default XATDataSourceImp constructor.
 * @since 1.0
 */
public XATDataSourceImp() {
	super();	
}
/**
 * Deep clone an XATDataSource. 
 * The returned XATDataSource will be totally independent from this table.
 * This replaces XATTable.deepClone.
 * @return XATDataSource A new created unrelated clone from this DataSource, 
 * e.g., change to the clone will not affect this table.
 * @since 1.0
 */
public XATDataSource deepCloneDataSource() {
    try {
        return (XATDataSource) edu.wpi.cs.dsrg.utils.DeepCopyMaker.makeDeepCopy(this);
    } catch (Exception e) {
        e.printStackTrace(System.err);
        return null;
    }
}
/**
 * This method set the default properties that all datasources have.
 * @return void
 * @since 1.0
 */
protected void setDefaultProperties() {
	/** how many tuples are in the datasource */
    addProperty("TUPLE_COUNT", "0");    
}
}
