package edu.wpi.cs.dsrg.xmldb.xat.component.operatorexec;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////
import java.lang.reflect.Array;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Stack;
import java.util.Vector;

import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import edu.wpi.cs.dsrg.utils.DeepCopyMaker;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.ExecutionInvalidXATTreeException;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.XATException;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.XATNodeDoesNotExistException;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.XATTableColumnNoExistException;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.XATTableEmptyException;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.XATTableOutOfRangeException;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.XATTableSchemaNoMatchException;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.XATTableTupleNoMatchException;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnName;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Expose;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.FOR;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Merge;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.NameColumn;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.SQLStmt;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Source;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.SourceImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function.Function;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.CartesianProduct;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.CartesianProductImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Difference;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Distinct;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.GroupBy;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Intersection;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.LeftOuterJoin;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.LeftSemiJoin;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.OrderBy;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.OuterUnion;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Project;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.RightOuterJoin;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.RightSemiJoin;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Select;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.ThetaJoin;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Union;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Aggregate;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Composer;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollection;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnest;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Tagger;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.XMLDifference;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.XMLIntersection;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.XMLUnion;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.AttStep;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.DescendantStep;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.NavigationStep;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.NodeStep;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.TextStep;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.VarStep;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.DOMPattern;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.ListPattern;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTreeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.visitorpattern.InheritableVisitor;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataSource;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATTable;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATTableImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATValue;
import edu.wpi.cs.dsrg.xmldb.xat.testfiles.StatisticsGatheringVisitor;

/**
 * The ExecuteVisitor class is part of the visitor pattern that is used here to perform the execution of opertors in an XAT tree. 
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0   
 */
public class ExecuteVisitor extends InheritableVisitor {
    String connection, username, password;

    /**
    * The InvalidNavigationException class. 
    * @since   1.0   
    */
    private class InvalidNavigationException extends Exception {

    }

    /**
    * The ColumnRef class. It represents the column reference as table reference + column index pairs.
    * @since   1.0   
    */
    static class ColumnRef {
        XATTable xtab;
        int index;

        /**
         * Constructor
         * @param xtab - XAT table with data
         * @param index - index of the column
         * @since   1.0            
         */
        public ColumnRef(XATTable xtab, int index) {
            this.xtab = xtab;
            this.index = index;
        }

        /**        
         * Returns an XAT table.
         * @return XATTable
         * @since   1.0            
        	 */
        public XATTable getTable() {
            return xtab;
        }

        /** 
         * Returns a column index. 
         * @return XATTable
         * @since   1.0   
         */
        public int getIndex() {
            return index;
        }

        /** 
         * Returns the number of tuples in table
         * @return XATTable
         * @since   1.0            
         */
        public int countTuples() {
            return (xtab.getNumberOfTuples());
        }

        /** 
         * Returns a cell in the XAT table
         * @param row is row number for the cell
         * @since   1.0                     
        */
        public Object getCell(int row)
            throws XATTableEmptyException, XATTableOutOfRangeException {
            Object cellValue = xtab.getValue(index, row);
            return (cellValue);
        }
    }

    /**
     * Constructor.
     * @param XATNode edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
     * @since   1.0   
     */
    public ExecuteVisitor() {
    }

    /**
     * Assigns database connection, user name, and a passward.    
     * @param db - database connection address
     * @param username - database account username
     * @param password - database account password
     * @since   1.0        
     */
    public ExecuteVisitor(String db, String username, String password) {
        this.connection = db;
        this.username = username;
        this.password = password;
    }

    /**
     * Used to break down an XAT table into a vector of smaller tables based on the column names.
     * We will use hashtable to do the break down.
     * The order of the groups should be same as the first occurances of each unique value.
     * @param cols The list of column names used to break down the table.
     * @param xtbInput The input table to be broken.
     * @return a vector of XATTables.
     * @since   1.0        
     */
    Vector breakDown(String[] cols, XATTable xtbInput) throws XATException {

        // this is the hash table on the grouped columns, by their value,
        // with the XATTable as its values.
        Hashtable groups = new Hashtable();

        // make the keys out of the cols.
        Vector key = new Vector();

        for (int i = 0; i < xtbInput.getNumberOfTuples(); i++) {
            key = new Vector();
            // deref. the XAT values from the table.
            for (int j = 0; j < cols.length; j++) {
                key.add(xtbInput.getValue(xtbInput.getColumnPosition(cols[j]), i + 1));
            }
            // now we have an array of XATValue[]
            // The Key will be the toString() value of this array.
            String keyvalue = key.toString();
            if (groups.get(keyvalue) == null) {
                // if this is the first time to have this row,
                // make a new table out of it.
                XATTable group = xtbInput.cloneSchema();
                group.appendTuple(xtbInput.getTuple(i + 1));
                groups.put(keyvalue, group);
            } else {
                // then it has to be a XATTable.
                XATTable group = (XATTable) groups.get(keyvalue);
                // put the current tuple into that xattable.
                group.appendTuple(xtbInput.getTuple(i + 1));
            }
        }

        // reorder the result into the original order in the xtbInput.

        // the result vector.
        Vector result = new Vector();
        // check whether this group already added or not.
        Hashtable exist = new Hashtable();

        // final sort out of the values.
        for (int i = 0; i < xtbInput.getNumberOfTuples(); i++) {
            key = new Vector();
            // deref. the XAT values from the table, and make the key again.
            for (int j = 0; j < cols.length; j++) {
                key.add(xtbInput.getValue(xtbInput.getColumnPosition(cols[j]), i + 1));
            }
            // now we have an array of XATValue[]
            // The Key will be the to string value of this array.
            String keyvalue = key.toString();

            if (exist.get(keyvalue) == null) {
                // that's a new tuple.
                exist.put(keyvalue, keyvalue);
                // copy the tuple from the input table to the output table.
                result.add(groups.get(keyvalue));
            }
        }

        return result;
    }

    /**
     * Compare two tuples.
     * @param iA The position of the first tuple.
     * @param iB the position of the second tuple.
     * @param tab The table where the two tuples come from.
     * @return int; which will be 1: if iA > iB, 0: if equivalent, or -1: if iA < iB.
     * @since   1.0        
     */
    int compare(int iA, int iB, String[] cols, XATTable tab) throws XATException {
        // first convert the column names arrays into the column position arrays.
        int[] colPos = new int[cols.length];
        for (int i = 0; i < cols.length; i++) {
            colPos[i] = tab.getColumnPosition(cols[i]);
        }
        // then let's get the values and compare them.
        for (int i = 0; i < colPos.length; i++) {
            Object valA = tab.getValue(colPos[i], iA);
            Object valB = tab.getValue(colPos[i], iB);
            int result;
            if ((valA == null) && (valB == null)) {
                result = 0;
            } else
                if (valA == null) {
                    result = -1;
                } else
                    if (valB == null) {
                        result = 1;
                    } else
                        if ((valA instanceof Integer) && (valB instanceof Integer)) {
                            result = ((Integer) valA).compareTo((Integer) valB);
                        } else
                            if ((valA instanceof Number) && (valB instanceof Number)) {
                                result =
                                    (new Double(((Number) valA).doubleValue())).compareTo(
                                        new Double(((Number) valB).doubleValue()));
                            } else {
                                result = valA.toString().compareTo(valB.toString());
                            }
            if (result != 0) {
                return result;
            }
        }
        // well, then they are equivalent.
        return 0;
    }

    /**
     * Used only for deep first pre-order search for Nav "//navstep"
     * @param xtabOut XATTable
     * @param xtabOutColIndex int
     * @param xtabIn XATTable, is the input xattable     
     * @param sourceStepVector java.util.Vector
     * @param navVectorIndex int, begins from 0
     * @since   1.0        
     */
    private void dfsPreOrder(
        XATTable xtabOut,
        int xtabOutColIndex,
        XATTable xtabIn,
        Vector sourceStepVector,
        Vector navVector,
        int navVectorIndex) {

        Vector vCollection = (Vector) navVector.elementAt(navVectorIndex);

        //exit point
        if (vCollection == null)
            return;

        //19. If the collection is empty, delete the corresponding tuple in the output table.
        //Now we change by adding an EMPTY collection there instead of delete the tuple.
        //This is for Aggregation functions.
        if (vCollection.size() == 0) {
            //xtabInput.deleteTuple(iCursor);
            Vector tuple = xtabIn.getTuple(navVectorIndex + 1);
            xtabOut.appendTuple(tuple);
            xtabOut.updateValue(
                xtabOutColIndex,
                xtabOut.getNumberOfTuples(),
                new XATDataValueImp());
            navVector.setElementAt(null, navVectorIndex);
            return;
        }
        //18. If the collection has one value, directly put the value into the output table.
        if (vCollection.size() >= 1) {
            Vector oldTuple = xtabIn.getTuple(navVectorIndex + 1);
            for (int j = 0; j < vCollection.size(); j++) {
                //clone the to be added tuple.
                Vector tuple = (Vector) oldTuple.clone();
                xtabOut.appendTuple(tuple);
                xtabOut.updateValue(
                    xtabOutColIndex,
                    xtabOut.getNumberOfTuples(),
                    new XATDataValueImp(vCollection.elementAt(j)));
                //recursive step
                for (int k = 0; k < sourceStepVector.size(); k++) {
                    // compare by reference
                    if ((k != navVectorIndex)
                        && (((XATDataValueImp) sourceStepVector.get(k)).getValue()
                            == vCollection.elementAt(j))
                        && (((XATDataValueImp) sourceStepVector.get(k)).getValue()
                            != ((XATDataValueImp) sourceStepVector.get(j)).getValue())) {
                        dfsPreOrder(xtabOut, xtabOutColIndex, xtabIn, sourceStepVector, navVector, k);
                    }
                }
            }
            navVector.setElementAt(null, navVectorIndex);
            return;
        }
    }

    /**
     * used only for deep first pre-order search for Nav "//navstep" by follow >1 step
     * result will be Vector of items, will be adding one by one in dfs pre-order
     * source will be Vector of original items.
     * resultVector will be Vector of (Vector of items from source and nav)
     * index is index of both source and resultVector
     * resultVector will be changed to null after use.
     * @param result java.util.Vector
     * @param source java.util.Vector
     * @param result java.util.Vector      
     * @param resultVector java.util.Vector
     * @param index int 
     * @since   1.0             
     */
    private void dfsPreOrder(
        Vector result,
        Vector source,
        Vector resultVector,
        int index) {

        Vector vCollection = (Vector) resultVector.elementAt(index);

        //exit point
        if (vCollection == null)
            return;

        //If the collection is empty,
        if (vCollection.size() == 0) {
            return;
        }
        //18. If the collection has one value.
        if (vCollection.size() >= 1) {
            for (int j = 0; j < vCollection.size(); j++) {
                result.add(vCollection.elementAt(j));
                //recursive step
                for (int k = 0; k < source.size(); k++) {
                    // compare by reference
                    if ((k != index)
                        && (source.elementAt(k) == vCollection.elementAt(j))
                        && (source.elementAt(k) != source.elementAt(j))) {
                        dfsPreOrder(result, source, resultVector, k);
                    }
                }
            }
            resultVector.setElementAt(null, index);
            return;
        }
    }

    /**
     * used only for deep first pre order search for Nav "//"
     * @param result java.util.Vector
     * @param node org.w3c.dom.Element
     * @since   1.0          
     */
    private void dfsPreOrder(Vector result, Element node) {
        result.addElement(node);
        NodeList nlList = ((Element) node).getChildNodes();
        if (nlList != null) {
            for (int j = 0; j < nlList.getLength(); j++) {
                if (nlList.item(j) instanceof Element)
                    dfsPreOrder(result, (Element) nlList.item(j));
            }
        }

    }

    /** 
     * Used to implement a visitor pattern. 
     * @return null
     * @since   1.0       
     */
    public Object dispatch() {
        return null;
    }

    /** 
     * Used to implement a visitor pattern.
     * @param obj Object
     * @return null     
     * @since   1.0       
     */
    public Object dispatch(Object obj) {
        return null;
    }

    /** 
     * Used to implement a visitor pattern.
     * @param obj1 Object
     * @param obj2 Object     
     * @return null     
     * @since   1.0       
     */
    public Object dispatch(Object obj1, Object obj2) {
        return null;
    }

    /**
     * Constructor, visits a tree. 
     * @param xtree tree containing differnet XAT nodes
     * @return The resulting XATTable after all nodes have been executed
     * @since   1.0           
    */
    public XATTable execute(XATTree xtree) {
        visit(xtree);
        return (XATTable) xtree.getRoot().getOperator().getOutputDataSource();
    }

    /**
     * Executes a tree with a given input.
     * @param xtree tree containing a mix of SQL and XML nodes
     * @param input XATTable is the input XAT table.      
     * @return the resulting XATTable after all nodes have been executed
     * @since   1.0            
     */
    public XATTable execute(XATTree xtree, XATTable input) {
        XATTree xtClone = (XATTree) xtree.clone();

        // add a temporary source node to this given tree.
        XATNode sourceNode = new XATNodeImp();
        Source sourceTmp = new SourceImp(sourceNode);
        sourceTmp.setType(Source.TEMP);
        sourceNode.setOperator(sourceTmp);
        sourceTmp.setOutput(input);

        xtClone.appendXATNode(sourceNode);

        visit(xtClone);
        return (XATTable) xtClone.getRoot().getOperator().getOutputDataSource();
    }

    /**
     * This method is used by the navigate opertors. It follows an XML path and returns a vector of nodes reachable by that path.    
     * @param source is the node to follow (navigate) from 
     * @param destination is the NavigationStep array specifing the full path to extract.
     * @return a vector of nodes reachable by the path.
     * @since   1.0            
     */
    private Vector follow(Object source, NavigationStep[] destination) {

        Vector result = new Vector();

        // if the destination is null
        if (destination == null) {
            // the result will be same as the source.
            if (source instanceof Vector)
                result.addAll((Vector) source);
            else
                result.addElement(source);
            return result;
        }

        // add the source node in it.
        result.addElement(source);

        // Let's iterate through the destination path.
        for (int i = 0; i < destination.length; i++) {

            result = followStep(result, destination[i]);
        }
        return result;
    }

    /**
     * This method is called from the followStep method. 
     * It navigates from either a node or a collection, and return a Vector.
     * So far, we do not handle the case of descendant here.
     * @since   1.0                
    */
    Vector followOne(Object node, NavigationStep step) {
        Vector result = new Vector();
        String sStepValue = step.getStepValue();

        if (node instanceof Text) { // it's a text node.

            if (step instanceof TextStep) // it's a text step.
                result.addElement(((Text) node).getNodeValue());
        } else
            if (node instanceof Element) {
                if (step instanceof NodeStep) { // it's a node.

                    String sNodeTest = sStepValue;
                    NodeList nlList = ((Element) node).getChildNodes();
                    for (int j = 0; j < nlList.getLength(); j++) {
                        String sNodeName = nlList.item(j).getNodeName();
                        if (sNodeTest.equals("*")) // if that's the any match.
                            result.addElement(nlList.item(j));
                        else
                            if (sNodeTest.equals(sNodeName))
                                result.addElement(nlList.item(j));
                    }
                } else
                    if (step instanceof AttStep) { // it's an attribute.

                        String sAttTest = sStepValue; //.substring(1);
                        NamedNodeMap nmList = ((Element) node).getAttributes();
                        for (int j = 0; j < nmList.getLength(); j++) {
                            String sAttName = nmList.item(j).getNodeName();
                            if (sAttTest.equals("*")) // if that's any node.
                                result.addElement(nmList.item(j).getNodeValue());
                            else
                                if (sAttTest.equals(sAttName))
                                    result.addElement(nmList.item(j).getNodeValue());
                        }
                    } else
                        if (step instanceof TextStep) { // it's a text step.

                            String resultString = "";
                            String sNodeTest = "#text";
                            NodeList nlList = ((Element) node).getChildNodes();
                            for (int j = 0; j < nlList.getLength(); j++) {
                                String sNodeName = nlList.item(j).getNodeName();
                                if (sNodeTest.equals(sNodeName))
                                    resultString += nlList.item(j).getNodeValue();
                                else {
                                    //sNodeName is an intermediate tag, not text data yet
                                    //recursively apply finding text descendants
                                    //the vector can only contain one item since all descendants are coalesced to one
                                    resultString += (String) followOne((Object) nlList.item(j), step).get(0);
                                }
                            }
                            // get its texted typed child.
                            result.addElement(resultString);
                        } else
                            if (step instanceof DescendantStep) { // it's a descendant step.
                                // get all the elements include itself.

                                // recursively get all the descendents of this node.
                                // For Nav "//" we need do deep-first pre-order search.
                                // following is wide-first search using queue result.
                                dfsPreOrder(result, (Element) node);

                            } else {
                                System.err.println(
                                    "followOne:Sorry, this type ("
                                        + step.getClass().getName()
                                        + ") of NavigationStep is not handled.");
                            }
            } else
                if (node instanceof Attr) {
                    if (step instanceof TextStep) // it's a text step.
                        result.addElement(((Attr) node).getValue());
                } else
                    if (node instanceof Node) { // Node of text or other stuff.

                        if (step instanceof TextStep) // it's a text step.
                            result.addElement(((Text) node).getData());
                    } else
                        if (node instanceof Vector) { // if that's a collection

                            Vector collection = (Vector) node;
                            for (int j = 0; j < collection.size(); j++) {
                                // make it a datavalue.
                                XATDataValueImp data = new XATDataValueImp(collection.elementAt(j));
                                // follow it again.
                                result.addAll(followOne(data.convertToDOM(), step));
                            }
                        } else
                            if (node instanceof String) { // if that's a string value
                                // do nothing.
                            } else {
                                System.err.println(
                                    "followOne:Sorry, this type ("
                                        + node.getClass().getName()
                                        + ") of value ("
                                        + node.toString()
                                        + ") is not handled.");
                            }

        return result;
    }

    /**
     * This method is called by the follow method.
     * @param source The vector containing the nodes to be navigated from.
     * @param step The navigation step.
     * @return a vector of destination nodes of type Node.
     * @since   1.0                     
     */
    private Vector followStep(Vector source, NavigationStep step) {
        Vector result = new Vector();
        Vector resultVector = new Vector();

        String sStepValue = step.getStepValue();
        //iterate through the source.
        for (int i = 0; i < source.size(); i++) {
            Object node = source.elementAt(i);

            resultVector.add(followOne(node, step));
        }
        //adding following to make sure deep first pre order search.
        for (int i = 0; i < resultVector.size(); i++) {
            dfsPreOrder(result, source, resultVector, i);
        }
        return result;
    }

    /**
     * Gets Abort Info.
     * @return boolean
     * @since   1.0                     
     */
    public boolean isAbort() {
        return System.getProperty("AbortOnException") != null;
    }

    /**
     * Gets debug info.
     * @return boolean
     * @since   1.0                     
     */
    public boolean isDebug() {
        return System.getProperty("DEBUG_ExecuteVisitor") != null;
    }

    /**
     * System environment to test if we want to keep a clone of XATTable or not.
     * We keep clone for DEMO. We don't keep clone for EXP and Performance.
     * @return boolean
     * @since   1.0                     
     */
    public boolean isKeepClone() {
        return System.getProperty("ExecuteVisitor_KeepClone") != null;
    }

    /**
     * System environment from testing.
     * @return boolean
     * @since   1.0                     
     */
    public boolean isShowTable() {
        // NOTE: we use reverse logic here.
        return System.getProperty("DEBUG_ExecuteVisitor_NoXATTable") == null;
    }

    /* This method returns an object of ColumnRef that represents the reference - index pair.
     * @param xnode - XAT node
     * @param colname - name of the column
     * @return - ColumnRef object
     * @since   1.0                          
     */
    protected ColumnRef lookupColumn(XATNode xnode, String colname) {
        XATTable xtab;
        int index;
        XATNode[] children = xnode.getChildren();

        if (children.length != 1)
            throw new RuntimeException("Incorrect number of nodes for Tagger");

        xtab = (XATTable) children[0].getOperator().getOutputDataSource();
        try {
            index = xtab.getColumnPosition(colname);
        } catch (XATTableColumnNoExistException xate) {
            index = -1;
        }

        return (index > 0) ? new ColumnRef(xtab, index) : null;
    }

    /**
     * Value based matching of a given object with a vector of object.
     * @param index Vector
     * @param obj Object     
     * @return null if no match, the matched object otherwise.
     * @since   1.0                         
     */
    Object match(Vector index, Object obj) {

        if (obj == null)
            return null;

        // to keep the order, we use hashtable.
        for (int i = 0; i < index.size(); i++) {
            Object matchObj = index.elementAt(i);
            if (matchObj instanceof Element && obj instanceof Element) {
                String objStr = XATTableImp.elementToString((Element) obj);
                String matchStr = XATTableImp.elementToString((Element) matchObj);
                if (matchStr.equals(objStr)) {
                    return matchObj;
                }
            } else
                if ((matchObj instanceof Attr && obj instanceof Attr)
                    || (matchObj instanceof Text && obj instanceof Text)) {
                    if (matchObj.toString().equals(obj.toString())) {
                        return matchObj;
                    }

                } else {
                    if (matchObj.equals(obj)) {
                        return matchObj;
                    }
                }
        }
        return null;
    }

    /**
     * Checks if the left and right tuples match on their common columns captured by hashLeft/hashRight.
     * @param leftTuple is the left tuple 
     * @param rightTuple is the right tuple
     * @param leftRightIndex is the hash table rthat capture common columns between left and right tuples    
     * @return boolean
     * @since   1.0                              
     */
    boolean matchTuple(
        Vector leftTuple,
        Vector rightTuple,
        Hashtable leftRightIndex) {

        // check to see if the parameters are valid.
        if (leftTuple == null || rightTuple == null || leftRightIndex == null)
            return false;

        // based on the common mapping index leftRightIndex.
        Enumeration keys = leftRightIndex.keys();

        while (keys.hasMoreElements()) {
            // get the left value.
            String leftIndex = (String) keys.nextElement();
            Object leftValue = leftTuple.elementAt(Integer.parseInt(leftIndex) - 1);
            String rightIndex = (String) leftRightIndex.get(leftIndex);
            Object rightValue = rightTuple.elementAt(Integer.parseInt(rightIndex) - 1);
            if (!leftValue.toString().equals(rightValue.toString()))
                return false;
        }

        return true;
    }
    /**
     * Merges the two tuples and get rid of their common parts in the right tuple.
     * @param left java.util.Vector
     * @param right java.util.Vector
     * @param map java.util.Hashtable
     * @return java.util.Vector     
     * @since   1.0                                   
     */
    Vector mergeTuple(Vector left, Vector right, Hashtable map) {
        Vector merged = new Vector();
        merged.addAll(left);
        for (int i = 0; i < right.size(); i++) {
            // if it is not in the common parts, then append it.
            if (!map.contains("" + (i + 1)))
                merged.add(right.elementAt(i));
        }
        return merged;
    }

    /**
     * Creates collections for the values of nested column. It uses Hashtable to help the nesting.
     * The final output order decided by the first-appearence of un-nested column values.
     * it will nest on the id of each cell.
     * @param col String
     * @param table XATTable
     * @return XATTable    
     * @since   1.0                                       
    */
    protected XATTable nest(String col, XATTable table) {

        // result xat table.
        XATTable result = new XATTableImp();

        // hash table used to do make the collections.
        Hashtable hash = new Hashtable();

        // figure out the nested columns.
        Vector nestedcols = new Vector();
        nestedcols.add(col);

        String[] ncols = (String[]) nestedcols.toArray(new String[] {
        });

        // figure out the groupbyed columns.
        Vector colsV = (Vector) table.getColNames().clone();
        colsV.remove(col);
        String[] cols = (String[]) colsV.toArray(new String[] {
        });

        // iterate through the table
        // put empty XATValue into the hash table,
        // The hashtable is an array of real values of columns.

        Vector key = new Vector();

        for (int i = 0; i < table.getNumberOfTuples(); i++) {
            key = new Vector();
            if (cols.length > 0) {
                // deref the XAT Values from the table.
                for (int j = 0; j < cols.length; j++) {
                    key.add(
                        ((XATDataValue) table.getValue(table.getColumnPosition(cols[j]), i + 1))
                            .getId());
                }
            } else {
                // a dummy string to represent empty context.
                key.add("EMPTY_CONTEXT");
            }
            // now we have an array of XATValue[]
            // The Key will be the to string value of this array.
            String keyvalue = key.toString();
            if (hash.get(keyvalue) == null) {
                // if this is the first time to have this row,
                // make a new array of the non-gb columns.
                XATDataValue[] value = new XATDataValue[ncols.length];
                for (int ingb = 0; ingb < ncols.length; ingb++) {
                    value[ingb] = new XATDataValueImp();
                    value[ingb].add(table.getValue(table.getColumnPosition(ncols[ingb]), i + 1));
                }
                hash.put(keyvalue, value);
            } else {
                // then it has to be a XATDataValue.
                XATDataValue[] value = (XATDataValue[]) hash.get(keyvalue);
                // put the current tuple's XATDataValue into that value.
                for (int ingb = 0; ingb < ncols.length; ingb++) {
                    value[ingb].add(table.getValue(table.getColumnPosition(ncols[ingb]), i + 1));
                }
            }
        }

        result = table.cloneSchema();
        // check whether this tuple already added or not.
        Hashtable exist = new Hashtable();
        // the init output table's row cursor.
        int cursor = 1;

        // final sort out of the values.
        for (int i = 0; i < table.getNumberOfTuples(); i++) {
            key = new Vector();
            if (cols.length > 0) {
                // deref the XAT values from the table, and make the key again.
                for (int j = 0; j < cols.length; j++) {
                    key.add(
                        ((XATDataValue) table.getValue(table.getColumnPosition(cols[j]), i + 1))
                            .getId());
                }
            } else {
                // a dummy string to represent empty context.
                key.add("EMPTY_CONTEXT");
            }
            // now we have an array of XATValue[]
            // The Key will be the to string value of this array.
            String keyvalue = key.toString();

            if (exist.get(keyvalue) == null) {
                // that's a new tuple.
                exist.put(keyvalue, keyvalue);
                // copy the tuple from the input table to the output table.
                result.appendTuple(table.getTuple(i + 1));
                // get the new aggregated value.
                XATDataValue[] value = (XATDataValue[]) hash.get(keyvalue);
                for (int ingb = 0; ingb < ncols.length; ingb++) {
                    // then update the tuple with the new aggregated values.
                    result.updateValue(result.getColumnPosition(ncols[ingb]), cursor, value[ingb]);
                }
                // increment the cursor.
                cursor++;
            }
        }

        return result;
    }

    /**
     * Gets rid of duplicated columns in a table.
     * @param table edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATTable
     * @since   1.0                                        
     */
    void removeDuplicatedColumns(XATTable table) {
        // use Hashtable to find duplicates.
        Hashtable dup = new Hashtable();
        Vector names = table.getColNames();

        // scan through the schema.
        for (int i = 0; i < names.size(); i++) {
            String name = (String) names.elementAt(i);
            Object result = dup.get(name);
            if (result != null) {
                // check if the two columns are match.
                Vector columFirst = table.getColumn(table.getColumnPosition(name));
                Vector columSecond = table.getColumn(i + 1);
                // compare these two columns.
                if (!columFirst.toString().equals(columSecond.toString())) {
                    System.out.println(
                        "WARNING: ExecuteVisitor.removeDuplicatedColumns:: Dup Columns ("
                            + name
                            + ") found, delete later one, but two columns content doesn't match exactly! Check the tree!");
                }
                table.deleteColumn(i + 1);
                names.removeElementAt(i);
                i--;
            } else {
                // put this name in the hashtable.
                dup.put(names.elementAt(i), names.elementAt(i));
            }
        }
    }

    /**
     * Tuple by Tuple comparison. If two tuples match, the 2nd tuple is deleted.
     * @param inTable is the input XAT table     
     * @return XATTable with removed duplicate tuples.          
     * @since   1.0                                   
     */
    private XATTable removeDuplicates(XATTable inTable) {
        XATTable table = inTable;
        int tupleCount = table.getNumberOfTuples();
        int tupCountTemp = tupleCount;
        try {

            for (int i = 1; i <= tupleCount; i++) {
                for (int j = i + 1; j <= tupleCount; j++) {

                    //System.out.println(table.getTuple(i) + " " + table.getTuple(j));
                    if (table.getTuple(i).equals(table.getTuple(j))) {
                        table.deleteTuple(j);
                        tupleCount--;
                        j--;
                    }
                }
            }
        } catch (XATTableOutOfRangeException e) {
            e.printStackTrace();
        } catch (XATTableEmptyException e) {
            e.printStackTrace();
        }
        return table;
    }

    /**
     * The shared method for left and right outerjoin.
     * @param loj is the LeftOuterJoin operator     
     * @param xtvLeft is the left XATTable
     * @param xtbRight is the right XATTable
     * @return XATTable     
     * @since   1.0       
     */
    XATTable sharedOuterJoin(
        LeftOuterJoin loj,
        XATTable xtbLeft,
        XATTable xtbRight) {

        XATTable xtbOutput = new XATTableImp();
        int iLeftTuples = xtbLeft.getNumberOfTuples();
        int iRightTuples = xtbRight.getNumberOfTuples();

        int iLeftColumns = xtbLeft.getNumberOfColumns();
        int iRightColumns = xtbRight.getNumberOfColumns();

        // all the names in left vector.
        HashSet setLeftNames = new HashSet(xtbLeft.getColNames());
        // the mapping common parts from left vector's index to right vector's index.
        Hashtable hashCommonIndex = new Hashtable();

        // BLOCK
        // this block will create the output XATTABLE that will have enough columns
        // with the correct names so that both the Left and Right input can be placed in the Table
        // LEFT
        for (int i = 1; i <= iLeftColumns; i++) {
            try {
                xtbOutput.appendColumn(xtbLeft.getColumnName(i), new Vector());
            } catch (XATTableTupleNoMatchException e) {
                e.printStackTrace(System.err);
            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace(System.err);
            }
        }
        // RIGHT
        for (int i = 1; i <= iRightColumns; i++) {
            try {
                // check if the right column already exist on the left. If it exist, then
                // don't need to keep it in the output, otherwise, keep it.
                if (!setLeftNames.contains(xtbRight.getColumnName(i)))
                    xtbOutput.appendColumn(xtbRight.getColumnName(i), new Vector());
                else
                    // put the index mapping from left to right tables.
                    hashCommonIndex.put(
                        "" + xtbLeft.getColumnPosition(xtbRight.getColumnName(i)),
                        "" + i);
            } catch (XATTableTupleNoMatchException e) {
                e.printStackTrace(System.err);
            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace(System.err);
            }
        }
        // ENDBLOCK

        for (int i = 1; i <= iLeftTuples; i++) {
            boolean bFoundMatch = false;
            for (int j = 1; j <= iRightTuples; j++) {
                Vector vLeft = xtbLeft.getTuple(i);
                Vector vRight = xtbRight.getTuple(j);
                // if the condition evaluates to true
                if (matchTuple(vLeft, vRight, hashCommonIndex)) {
                    bFoundMatch = true;
                    try {
                        Vector vNewTuple = mergeTuple(vLeft, vRight, hashCommonIndex);
                        xtbOutput.appendTuple(vNewTuple);
                    } catch (XATTableEmptyException e) {
                        e.printStackTrace(System.err);
                    } catch (XATTableOutOfRangeException e) {
                        e.printStackTrace(System.err);
                    } catch (XATTableSchemaNoMatchException e) {
                        e.printStackTrace(System.err);
                    }
                }
            }
            // if the condition never evaluated to true then the left Tuple will be added
            // spaces for the right tuple will also be added but nulls will fill that space
            // now changed to using EMPTY COLLECTION instead of null.
            // By: Song Wang
            if (!bFoundMatch) {
                try {
                    Vector vNewTuple = new Vector(xtbLeft.getTuple(i));
                    //Here we also should make the columns of THIS loj(from For) null
                    //If there is Cartison Product existing.
                    //So we find the first CP from LOJ to leaf
                    //And make other columns empty collection
                    //By: Song Wang
                    XATNode lojNode = loj.getNode();
                    XATNode cpNode = null;
                    for (XATNode iNode = lojNode.getChild(0); iNode != null;) {
                        if (iNode.getOperator() instanceof CartesianProduct) {
                            cpNode = iNode;
                            break;
                        }
                        try {
                            iNode = iNode.getChild(0);
                        } catch (XATNodeDoesNotExistException e) {
                            iNode = null;
                        }
                    }
                    if (cpNode != null) { // find the Cartison Product on left branch of LOJ.
                        Vector beforeCPCol =
                            ((XATTable) cpNode.getChild(1).getOperator().getOutputDataSource())
                                .getColNames();
                        Vector afterCPCol = xtbLeft.getColNames();
                        //update the vNewTuple
                        for (int i2 = 0; i2 < vNewTuple.size(); i2++) {
                            if (!beforeCPCol.contains((String) afterCPCol.elementAt(i2))) {
                                //this collumn is added this time
                                vNewTuple.remove(i2);
                                vNewTuple.insertElementAt(new XATDataValueImp(), i2);
                            }
                        }
                    } else { //can not find the Cartison Product on left branch of LOJ.
                        //update the vNewTuple
                        for (int i2 = 0; i2 < vNewTuple.size(); i2++) {
                            vNewTuple.remove(i2);
                            vNewTuple.insertElementAt(new XATDataValueImp(), i2);
                        }
                    }
                    //end of modification
                    for (int j = 0; j < iRightColumns - hashCommonIndex.size(); j++)
                        vNewTuple.add(new XATDataValueImp());
                    vNewTuple.setSize(iLeftColumns + iRightColumns - hashCommonIndex.size());
                    xtbOutput.appendTuple(vNewTuple);
                } catch (XATTableEmptyException e) {
                    e.printStackTrace(System.err);
                } catch (XATTableOutOfRangeException e) {
                    e.printStackTrace(System.err);
                } catch (XATTableSchemaNoMatchException e) {
                    e.printStackTrace(System.err);
                }
            }
        }
        return xtbOutput;
    }

    /**
     * The shared method for left and right outerjoin.
     * @param xtvLeft is the left XATTable
     * @param xtbRight is the right XATTable
     * @return XATTable     
     * @since   1.0            
     */
    XATTable sharedOuterJoin(XATTable xtbLeft, XATTable xtbRight) {

        XATTable xtbOutput = new XATTableImp();
        int iLeftTuples = xtbLeft.getNumberOfTuples();
        int iRightTuples = xtbRight.getNumberOfTuples();

        int iLeftColumns = xtbLeft.getNumberOfColumns();
        int iRightColumns = xtbRight.getNumberOfColumns();

        // all the names in left vector.
        HashSet setLeftNames = new HashSet(xtbLeft.getColNames());
        // the mapping common parts from left vector's index to right vector's index.
        Hashtable hashCommonIndex = new Hashtable();

        // BLOCK
        // this block will create the output XATTABLE that will have enough columns
        // with the correct names so that both the Left and Right input can be placed in the Table
        // LEFT
        for (int i = 1; i <= iLeftColumns; i++) {
            try {
                xtbOutput.appendColumn(xtbLeft.getColumnName(i), new Vector());
            } catch (XATTableTupleNoMatchException e) {
                e.printStackTrace(System.err);
            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace(System.err);
            }
        }
        // RIGHT
        for (int i = 1; i <= iRightColumns; i++) {
            try {
                // check if the right column already exist on the left. If it exist, then
                // don't need to keep it in the output, otherwise, keep it.
                if (!setLeftNames.contains(xtbRight.getColumnName(i)))
                    xtbOutput.appendColumn(xtbRight.getColumnName(i), new Vector());
                else
                    // put the index mapping from left to right tables.
                    hashCommonIndex.put(
                        "" + xtbLeft.getColumnPosition(xtbRight.getColumnName(i)),
                        "" + i);
            } catch (XATTableTupleNoMatchException e) {
                e.printStackTrace(System.err);
            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace(System.err);
            }
        }
        // ENDBLOCK

        for (int i = 1; i <= iLeftTuples; i++) {
            boolean bFoundMatch = false;
            for (int j = 1; j <= iRightTuples; j++) {
                Vector vLeft = xtbLeft.getTuple(i);
                Vector vRight = xtbRight.getTuple(j);
                // if the condition evaluates to true
                if (matchTuple(vLeft, vRight, hashCommonIndex)) {
                    bFoundMatch = true;
                    try {
                        Vector vNewTuple = mergeTuple(vLeft, vRight, hashCommonIndex);
                        xtbOutput.appendTuple(vNewTuple);
                    } catch (XATTableEmptyException e) {
                        e.printStackTrace(System.err);
                    } catch (XATTableOutOfRangeException e) {
                        e.printStackTrace(System.err);
                    } catch (XATTableSchemaNoMatchException e) {
                        e.printStackTrace(System.err);
                    }
                }
            }
            // if the condition never evaluated to true then the left Tuple will be added
            // spaces for the right tuple will also be added but nulls will fill that space
            // now changed to using EMPTY COLLECTION instead of null.
            // By: Song Wang
            if (!bFoundMatch) {
                try {
                    Vector vNewTuple = new Vector(xtbLeft.getTuple(i));
                    for (int j = 0; j < iRightColumns - hashCommonIndex.size(); j++)
                        vNewTuple.add(new XATDataValueImp());
                    vNewTuple.setSize(iLeftColumns + iRightColumns - hashCommonIndex.size());
                    xtbOutput.appendTuple(vNewTuple);
                } catch (XATTableEmptyException e) {
                    e.printStackTrace(System.err);
                } catch (XATTableOutOfRangeException e) {
                    e.printStackTrace(System.err);
                } catch (XATTableSchemaNoMatchException e) {
                    e.printStackTrace(System.err);
                }
            }
        }
        return xtbOutput;
    }

    /**
     * Used to sort an input table based on certain columns.
     * @param cols The list of column names used to sort the table.
     * @param xtbInput The input table to be sorted.
     * @param ascend Which sort direction? true -- ascend, false -- descend.
     * @return The sorted XATTable.
     * @since   1.0                 
     */
    XATTable sort(String[] cols, XATTable xtbInput, boolean ascend)
        throws XATException {
        XATTable xtbOutput = xtbInput;
        // Let's do the bubble sort?
        // It's not as efficient as you think, but you know, very easy to implement.
        for (int i = 1; i <= xtbOutput.getNumberOfTuples(); i++) {
            for (int j = 1; j < i; j++) {
                int direction = compare(i, j, cols, xtbOutput);
                if (ascend ? (direction < 0) : (direction > 0)) { // if direction is wrong.
                    // swap it.
                    swap(i, j, xtbOutput);
                }
            }
        }
        return xtbOutput;
    }

    /**
     * Swaps two tuples in the XATTable tab.
     * @param iA the first tuple index.
     * @param iB the second tuple index.
     * @param tab The table where the tuples will be swapped.
     * @return Nothing, the tab is changed.
     * @since   1.0                 
     */
    void swap(int iA, int iB, XATTable tab) throws XATException {
        Vector tupleA = tab.getTuple(iA);
        Vector tupleB = tab.getTuple(iB);
        tab.deleteTuple(iA);
        if (iA == (tab.getNumberOfTuples() + 1))
            tab.appendTuple(tupleB);
        else
            tab.insertTuple(iA, tupleB);

        tab.deleteTuple(iB);
        if (iB == (tab.getNumberOfTuples() + 1))
            tab.appendTuple(tupleA);
        else
            tab.insertTuple(iB, tupleA);
    }

    /**
     * Execution for the Expose operator, part of the visitor pattern. 
     * Only keep the exposed columns in the output XAT table. All other columns are removed.
     * @param exp is the Expose opertor. 
     * @return null
     * @since   1.0     
    */
    public Object visit(Expose exp) throws ExecutionInvalidXATTreeException {
        XATTable xtbInput;
        try {
            xtbInput = (XATTable) exp.getPrimaryDataSource();
        } catch (XATNodeDoesNotExistException e) {
            throw new ExecutionInvalidXATTreeException();
        }

        for (int i = 1; i <= xtbInput.getNumberOfColumns(); i++) {
            String sColName = xtbInput.getColumnName(i);
            if (!sColName.equals(exp.getOutputColumnName())) {
                xtbInput.deleteColumn(i);
                i--;
            }
        }

        exp.setOutput((XATTable) xtbInput);
        return null;
    }

    /*
     * Execution for the FOR operator, part of the visitor pattern.     
     * For each tuple, we execute the sub query:
     *  - we create the temp source for the current tuple in the outer query.
     *  - execute the subtree.
     *  - get the result and keep it.
     *  - update the data in the temp source.
     *  - work for the next tuple.
     * @param forop is the FOR opertor. 
     * @return null
     * @since   1.0         
    */
    public Object visit(FOR forop) {
        // First we need to get the input table.

        XATTable xtbNewFor = new XATTableImp();
        XATTable xtbOrgFor;
        try {
            xtbOrgFor = (XATTable) forop.getPrimaryDataSource();

            // Get the subqueries.
            XATTree subquery = forop.getXtreFunctions();

            // clone the subquery.
            XATTree subqueryclone = (XATTree) subquery.clone();
            StatisticsGatheringVisitor.addTempTree(subqueryclone);
            XATNode[] leaves = subqueryclone.getLeaves();

            // append this source to the end of each leaf if the subquery has no other sources, otherwise make the cartesian product of the two sources.
            // Note: There suppose to be only one leaf.
            int iLengthleaves = leaves.length;

            XATNode sourceNode = new XATNodeImp();
            Source sourceTmp = new SourceImp(sourceNode);
            sourceTmp.setType(Source.TEMP);
            sourceNode.setOperator(sourceTmp);

            for (int j = 0; j < iLengthleaves; j++) {
                XATNode leaf = (XATNode) leaves[j];
                // check if the leaf is a source operator.
                if (!(leaf.getOperator() instanceof Source)) {
                    subqueryclone.addNode(sourceNode, leaf);
                    sourceNode.setParent(leaf);
                } else // it is source operator.
                    {
                    // add a cartesian product.
                    XATNode xtnodeCP = new XATNodeImp();
                    CartesianProduct cp = new CartesianProductImp(xtnodeCP);
                    xtnodeCP.setOperator(cp);
                    subqueryclone.addNode(xtnodeCP, leaf.getParent());
                    subqueryclone.deleteNode(leaf);
                    subqueryclone.addNode(sourceNode, xtnodeCP);
                    subqueryclone.addNode(leaf, xtnodeCP);
                }
            }
            ExecuteVisitor exec = new ExecuteVisitor();

            // for each tuple, we evaluate the subquery.
            if (xtbOrgFor.getNumberOfTuples() == 0) {
                //fixing for the case: select in outter tree of for.
                //inner tree should not be evaluated
                //here we visit inner tree is only for the schema.

                // create the temporary table for the subquery.
                XATTable xtbSource = xtbOrgFor.cloneSchema();
                xtbSource.setName(xtbOrgFor.getName());
                // make the data ready for the subquery.
                sourceTmp.setOutput(xtbSource);
                // execute the subquery.
                exec.visit(subqueryclone);
                XATTable xtbTmp =
                    (XATTable) subqueryclone.getRoot().getOperator().getOutputDataSource();
                // initialize the schema of the xtbNewGroupBy
                xtbNewFor = xtbTmp.cloneSchema();
            }

            for (int i = 1; i <= xtbOrgFor.getNumberOfTuples(); i++) {
                // create the temporary table for the subquery.
                XATTable xtbSource = xtbOrgFor.cloneSchema();
                xtbSource.appendTuple(xtbOrgFor.getTuple(i));
                xtbSource.setName(xtbOrgFor.getName());
                // make the data ready for the subquery.
                sourceTmp.setOutput(xtbSource);
                // execute the subquery.
                exec.visit(subqueryclone);
                XATTable xtbTmp =
                    (XATTable) subqueryclone.getRoot().getOperator().getOutputDataSource();
                if (i == 1) {
                    // initialize the schema of the xtbNewGroupBy
                    xtbNewFor = xtbTmp.cloneSchema();
                }
                // append the result to the output table.
                 ((XATTableImp) xtbNewFor).appendTable(xtbTmp);
            }

            //Deal with select case of deleting outer for variable binding context.
            // By: Song Wang
            if ((xtbNewFor.getNumberOfTuples() == 0)
                && (xtbOrgFor.getNumberOfTuples() > 0)) { //empty table for this variable.
                XATTree tempTree = new XATTreeImp();
                tempTree.setRoot(forop.getNode());
                XATNode[] forleaves = tempTree.getLeaves();
                for (int k = 0; k < forleaves.length; k++) {
                    XATNode forleaf = (XATNode) forleaves[k];
                    if ((forleaf.getOperator() instanceof Source)
                        && (((Source) forleaf.getOperator()).getType() == Source.TEMP)) {
                        Source forsourceTmp = (Source) forleaf.getOperator();
                        XATTable forTmpTable = (XATTable) forsourceTmp.getOutputDataSource();
                        Vector forsourceTmpTuple = forTmpTable.getTuple(1);
                        Vector extendedForSource = new Vector();
                        for (Iterator it = xtbNewFor.getColNames().iterator(); it.hasNext();) {
                            try {
                                int l = forTmpTable.getColumnPosition((String) it.next());
                                extendedForSource.add(forsourceTmpTuple.get(l - 1));
                            } catch (XATTableColumnNoExistException e) {
                                extendedForSource.add(new XATDataValueImp());
                            }
                        }
                        xtbNewFor.appendTuple(extendedForSource);
                        break;
                    }
                }
            }
        } catch (XATException e) {
            e.printStackTrace(System.err);
        }

        // Takes the new table and appends the columns after the functions are called on the Original table
        forop.setOutput(xtbNewFor);

        return null;
    }

    /**
     * Execution for the Function operator, part of the visitor pattern.         
     * Function F(param1..m)[s1..n]
     * Input: Multiple tables s1..n.
     * Output: Temporary table.
     * Logic: Execute some user defined function on the data sources.
     * Or, used to represent a recursive query.
     * Order Handling:
     * Schema and tuple orders depend on the implementation.
     * They can be reconfirmed by projection and orderby nodes.
     * @param func is the Function opertor. 
     * @return null
     * @since   1.0         
     */
    public Object visit(Function func) {
        func.execute();
        return null;
    }

    /*
     * Execution for the Merge operator, part of the visitor pattern.
     * Input: Tow Table s1 and s2.
     * Output: Table s.
     * Logic: Merges two tables vertically into one table by concatinating columns
     * Order Handling: Table s is ordered based on s1 and s2 order, Merge is considered as
     * "Join by order"  
     * Requirement: both s1 and s2 are ordered and should have the same number of typles.     
     * The Merge opertor will 
     * @param merIm is the Merge opertor. 
     * @return null
     * @since   1.0         
    */
    public Object visit(Merge merIm)
        throws XATNodeDoesNotExistException, XATTableTupleNoMatchException {

        // make an output table.
        merIm.setOutput(new XATTableImp());

        XATTable xtbOutput = (XATTable) merIm.getPrimaryDataSource();

        //for each source, merge
        for (int i = 1; i < Array.getLength(merIm.getDataSources()); i++) {

            int iTupleCount = xtbOutput.getNumberOfTuples();
            Vector outColNames = xtbOutput.getColNames();

            XATTable xtbInputPosDup = (XATTable) merIm.getDataSourceAt(i);
            //remove duplicates
            //XATTable xtbInput = removeDuplicates(xtbInputPosDup);
            XATTable xtbInput = xtbInputPosDup;
            int inputTupleCount = xtbInput.getNumberOfTuples();
            Vector inColNames = xtbInput.getColNames();

            //if the tuple counts are not even, the two tables cannot be merged.
            if (iTupleCount != inputTupleCount) {
                //To deal with select in outer tree of FOR(LOJ's left tree)
                //we need to check the cartison product below it.
                //to make up the XAT tables.
                //This making up is equals to do another LOJ with 1st child of CP as left

                //try to find the CP first
                XATNode mgNode = merIm.getNode();
                XATNode cpNode = null;
                for (XATNode iNode = mgNode.getChild(i); iNode != null;) {
                    if ((iNode.getOperator() instanceof CartesianProduct)
                        && (!(iNode.getOperator() instanceof LeftOuterJoin))) {
                        cpNode = iNode;
                        break;
                    }
                    try {
                        iNode = iNode.getChild(0);
                    } catch (XATNodeDoesNotExistException e) {
                        iNode = null;
                    }
                }
                if (cpNode != null) { // find the Cartison Product on left branch of LOJ.
                    //make LOJ
                    xtbInput =
                        sharedOuterJoin(
                            (XATTable) cpNode.getChild(1).getOperator().getPrimaryDataSource(),
                            xtbInput);
                } else { //can not find the Cartison Product on left branch of LOJ.
                    throw (new XATTableTupleNoMatchException());
                }
            }

            Vector totalColNames = new Vector();
            totalColNames.addAll(outColNames);
            totalColNames.addAll(inColNames);

            //create a new Table
            XATTable newXATMerge = new XATTableImp();
            newXATMerge.setName(xtbOutput.getName());
            try {

                //add the outer columns first
                for (int n = 0; n < outColNames.size(); n++) {
                    newXATMerge.appendColumn(
                        (String) totalColNames.elementAt(n),
                        xtbOutput.getColumn(n + 1));
                }

                //add the inner columns next
                for (int n = 0; n < inColNames.size(); n++) {
                    newXATMerge.appendColumn(
                    //make sure to add the right column name
                    (String) totalColNames.elementAt(n + outColNames.size()),
                        xtbInput.getColumn(n + 1));
                }

            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace();
            } catch (XATTableTupleNoMatchException e) {
                e.printStackTrace();
            }

            xtbOutput = newXATMerge;
        }

        removeDuplicatedColumns(xtbOutput);

        //set output to xtbOutput
        merIm.setOutput((XATTable) xtbOutput);
        return null;
    }

    /**
     * Execution for the NameColumn operator, part of the visitor pattern.         
     * Input: Table s.
     * Output: Table s.
     * Logic: Rename col1 in table s into col2.
     * Order Handling: Keep all the schema and tuple orders.
     * Requirement: Col1 in table s.
     * @param NameColumn is the NameColumn opertor. 
     * @return null
     * @since   1.0              
     */
    public Object visit(NameColumn nc) throws ExecutionInvalidXATTreeException {
        String sOrgColName = nc.getOriginalColumnName();
        String sNewColName = nc.getNewColumnName();
        XATTable xtbNameColumn = new XATTableImp();
        try {
            xtbNameColumn = (XATTable) nc.getPrimaryDataSource();
            int i = 0;
            i = xtbNameColumn.getColumnPosition(sOrgColName);
            xtbNameColumn.setColumnName(sNewColName, i);
        } catch (XATTableOutOfRangeException e) {
            e.printStackTrace(System.err);
        } catch (XATTableColumnNoExistException e) {
            // it's not a big deal. If you cannot find that column, then the
            // tree is wrong. So, just do nothing
            if (isDebug())
                System.err.println("Warning: Tree might generated wrong.");
        } catch (XATNodeDoesNotExistException e) {
            throw new ExecutionInvalidXATTreeException();
        } finally {
            nc.setOutput((XATTable) xtbNameColumn);
        }
        return null;
    }

    /*
     * Execution for the Source operator, part of the visitor pattern.
     * Input: Can be: an XML document, databse table, or any other input source. See XAT tech report for that.
     * Output: Table s with one column.
     * Logic: If the input is a relational table, the output XAT table will be will be the same.
     * If the input is an XML document the output XAT table will contain the XML document in one tuple.
     * Order Handling: Keep all the schema and tuple orders. If the input is a collection of documnt, 
     * the output XAT table will have one tuple for each documnet. 
     * Requirement:
     * @param s is the Source opertor. 
     * @return null
     * @since   1.0         
    */
    public Object visit(Source s) {
        XATTable xtbOutput = new XATTableImp();
        Document dDocument;
        String sDocument = "";
        Vector vColumn = new Vector();
        switch (s.getType()) {
            case Source.XML :
                try {
                    DOMParser parser = new DOMParser();
                    parser.setFeature(
                        "http://apache.org/xml/features/dom/defer-node-expansion",
                        false);
                    // otherwise parser.getCurrentNode() == null
                    parser.setFeature(
                        "http://apache.org/xml/features/continue-after-fatal-error",
                        true);
                    parser.setFeature("http://apache.org/xml/features/allow-java-encodings", true);
                    parser.parse(s.getName());
                    dDocument = parser.getDocument();
                    Element e = dDocument.getDocumentElement();
                    XATDataValueImp newVal = new XATDataValueImp(e);
                    vColumn.add(newVal);
                } catch (Exception e) {
                    e.printStackTrace();
                }
                break;
            case Source.TABLE :
                XATDataValueImp newVal = new XATDataValueImp(sDocument);
                vColumn.add(newVal);
                break;
            case Source.TEMP :
                // do nothing because the table is already set!
                return null;
            default :
                // fail 
                return null;
        }

        try {
            xtbOutput.appendColumn(s.getOutputColumnName(), vColumn);
        } catch (XATTableTupleNoMatchException e) {

        }
        s.setOutput((XATTable) xtbOutput);
        return null;
    }

    /*
     * Execution for the SQLStmt operator, part of the visitor pattern.
     * Input: No input, hence it can be a leaf node
     * Output: Table s.
     * Logic: Queries teh underlying relational database and cosntruct an XAT table from teh result.
     * The opertor will contain the SQl statement to be sent to the relational DB and any required DB connection  information.
     * Order Handling: Depends on teh SQL statement stored in this opertor, if there is an "OrderBy" clause the order of 
     * tuples in the output XAT table will depend on that, otherwise the tuples are considered unordered.
     * Requirement:.          
     * @param sqlstmt is the SQLStmt opertor. 
     * @return null
     * @since   1.0         
    */
    public void visit(SQLStmt sqlstmt) {

        XATTable output = new XATTableImp();

        // Establishes the connection with db, executes SQL and
        // stores results in the XATTable for the node
        String username = this.username, passwd = this.password;
        //String query;
        ResultSet rs = null;
        Statement stmt = null;
        Connection con = null;
        //Establish connection with the database
        try {
            try {
                Class.forName("oracle.jdbc.driver.OracleDriver");
            } catch (ClassNotFoundException cnfe) {
                System.out.println("fail to connect to Oracle");
                throw new RuntimeException("unable to load Oracle JDBC driver");
            }
            con = DriverManager.getConnection(this.connection, username, passwd);
        } catch (SQLException sqlex) {
            System.err.println("SQL Exception raised for SQL:" + sqlstmt.getStmt());
            sqlex.printStackTrace(System.err);
        }
        //Execute the query on the database
        try {
            stmt = con.createStatement();
            rs = stmt.executeQuery(sqlstmt.getStmt());
        } catch (SQLException sqlex) {
            System.err.println("could not execute query " + sqlstmt.getStmt());
            sqlex.printStackTrace(System.err);
        }
        // retreive metadadata information and
        // add column names to the data model
        int columnCount = 0;
        try {
            ResultSetMetaData rsmd = rs.getMetaData();
            columnCount = rsmd.getColumnCount();
            // create the output table schema.
            for (int icol = 1; icol <= columnCount; icol++) {
                output.appendColumn(rsmd.getColumnName(icol));
            }
        } catch (SQLException sqlex) {
            throw new RuntimeException("could not get metadata: " + sqlex.getMessage());
        }

        // fill the datamodel with result set
        try {
            while (rs.next()) {
                Vector tuple = new Vector(columnCount);
                for (int i = 0; i < columnCount; i++)
                    tuple.add(new XATDataValueImp(rs.getString(i + 1)));
                output.appendTuple(tuple);
            }
            stmt.close();
        } catch (SQLException sqlex) {
            throw new RuntimeException(
                "error reading results from " + sqlstmt.getStmt() + ": " + sqlex);
        }
        sqlstmt.setOutput(output);
    }

    /*
     * Execution for the CartesianProduct operator, part of the visitor pattern.
     * Input: Tow tables s1 and s2.
     * Output: Table s.
     * Logic: Same sematocs as in teh relational algebra.
     * Order Handling: Order of s will have a major order of left table s1 and a minor order of right table s2.
     * Requirement:.          
     * @param cp is the CartesianProduct opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException
     * @since   1.0         
    */
    public Object visit(CartesianProduct cp) throws XATNodeDoesNotExistException {
        XATTable xtbLeft = cp.getLeft();
        XATTable xtbRight = cp.getRight();
        XATTable xtbOutput = new XATTableImp();
        int iLeftTuples = xtbLeft.getNumberOfTuples();
        int iRightTuples = xtbRight.getNumberOfTuples();

        int iLeftColumns = xtbLeft.getNumberOfColumns();
        int iRightColumns = xtbRight.getNumberOfColumns();

        for (int i = 1; i <= iLeftColumns; i++) {
            try {
                xtbOutput.appendColumn(xtbLeft.getColumnName(i), new Vector());
            } catch (XATTableTupleNoMatchException e) {
                e.printStackTrace();
            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace();
            }
        }
        for (int i = 1; i <= iRightColumns; i++) {
            try {
                xtbOutput.appendColumn(xtbRight.getColumnName(i), new Vector());
            } catch (XATTableTupleNoMatchException e) {
                e.printStackTrace();
            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace();
            }
        }

        for (int i = 1; i <= iLeftTuples; i++) {
            for (int j = 1; j <= iRightTuples; j++) {
                int[] iPosArray = { i, j };
                try {
                    Vector vNewTuple = new Vector(xtbLeft.getTuple(i));
                    vNewTuple.addAll(xtbRight.getTuple(j));
                    xtbOutput.appendTuple(vNewTuple);
                } catch (XATTableEmptyException e) {
                    e.printStackTrace();
                } catch (XATTableOutOfRangeException e) {
                    e.printStackTrace();
                } catch (XATTableSchemaNoMatchException e) {
                    e.printStackTrace();
                }
            }
        }

        // remove the duplicated columns.
        // first try to make sure the two columns are same.
        // then, remove one from it.
        removeDuplicatedColumns((XATTable) xtbOutput);

        // set output to xtbOutput
        cp.setOutput((XATTable) xtbOutput);

        return null;
    }

    /**
     * Execution for the Difference operator, part of the visitor pattern.         
     * Difference diff(Table[])
     * Input: n number of tables.
     * Output: table r.
     * Logic: This operation will compare n number of tables and return
     * a result table r that retains tuples that do not match from table to table.
     * Requirement: The table schemas are identical, same number of columns and
     * the same name for each column.
     * @param diff is the Difference opertor. 
     * @return null
     * @since   1.0              
     */
    public Object visit(Difference diff) throws XATTableSchemaNoMatchException {
        XATTable xTabOutput = new XATTableImp();

        try {
            xTabOutput = (XATTable) diff.getPrimaryDataSource();
        } catch (XATNodeDoesNotExistException nm) {
            nm.printStackTrace();
        }

        XATTable xTabInputs[] = (XATTable[]) diff.getDataSources();
        Vector vTup1 = new Vector(); // Used for tuple comparisons
        Vector vTup2 = new Vector();

        int iColCount = xTabOutput.getNumberOfColumns();
        int iTupCount = xTabOutput.getNumberOfTuples();

        // First, check to see if the table schemas are identical
        for (int i = 1; i < xTabInputs.length; i++) {
            if (xTabInputs[i].getNumberOfColumns() != iColCount) {
                throw new XATTableSchemaNoMatchException();
            }
            try {
                for (int j = 1; j <= iColCount; j++) {
                    String sColName1 = xTabOutput.getColumnName(j);
                    String sColName2 = xTabInputs[i].getColumnName(j);
                    if (!sColName1.equals(sColName2)) {
                        System.out.println(sColName1 + " " + sColName2);
                        throw new XATTableSchemaNoMatchException();
                    }
                }
            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace();
            }

            //create a new Table
            XATTable newXATDifference = new XATTableImp();
            newXATDifference.setName(xTabOutput.getName());
            for (int n = 1; n <= iColCount; n++) {
                try {
                    newXATDifference.appendColumn((String) xTabOutput.getColumnName(n));
                } catch (XATTableTupleNoMatchException e) {
                    e.printStackTrace();
                } catch (XATTableOutOfRangeException e) {
                    e.printStackTrace();
                }
            }

            // Done the schema checking, now we can compare tuples.
            // For now, instead of remembering the positions of each
            // tuple for comparison we will put a set of null strings
            // in for the values of each cell which may be cleaned up later.
            try {
                for (int k = 1; k <= iTupCount; k++) {
                    vTup1 = xTabOutput.getTuple(k);
                    for (int j = 1; j <= iTupCount; j++) {
                        vTup2 = xTabInputs[i].getTuple(j);
                        if (vTup1.equals(vTup2))
                            break;
                        if (!vTup1.equals(vTup2) && j == iTupCount) {
                            // For now, set the tuple to a set of null strings to preserve
                            // the position of the tuples
                            newXATDifference.appendTuple(vTup1);
                        }
                    }
                }
            } catch (XATTableOutOfRangeException or) {
                or.printStackTrace();
            } catch (XATTableEmptyException emp) {
                emp.printStackTrace();
            } catch (XATTableSchemaNoMatchException nm) {
                nm.printStackTrace();
            }

            //set new table to final table
            XATTable newXATDifferenceNoDup = removeDuplicates(newXATDifference);
            xTabOutput = newXATDifferenceNoDup;
        }

        diff.setOutput(xTabOutput);
        return null;
    }

    /*
     * Execution for the Distinct operator, part of the visitor pattern.
     * Input: Table s.
     * Output: Table s.
     * Logic: Eliminates teh duplicate tuples from s. It will convert teh XAT table from bag semantics into set semantics.
     * Order Handling: Order of the output table will conform to ther order of input table.
     * Requirement:.               
     * @param d is the Distinct opertor. 
     * @return null
     * @since   1.0         
    */
    public Object visit(Distinct d) {
        XATTable table = new XATTableImp();
        try {
            table = (XATTable) d.getPrimaryDataSource();
        } catch (XATNodeDoesNotExistException e) {
            e.printStackTrace();
            return null;
        }
        int pos;
        Vector column;
        try {
            pos = table.getColumnPosition(d.getInputColumnName());
            column = table.getColumn(pos);
        } catch (XATTableColumnNoExistException e) {
            e.printStackTrace();
            return null;
        } catch (XATTableOutOfRangeException e) {
            e.printStackTrace();
            return null;
        }
        for (int i = 0; i < column.size(); i++) {
            try {
                XATDataValueImp obj = (XATDataValueImp) column.elementAt(i);
                if (obj.convertToCollection() != null) {
                    Vector v = obj.convertToCollection();

                    for (int j = 0; j < v.size(); j++) {
                        Object o = v.elementAt(j);
                        if (o != null) {
                            for (int k = j + 1; k < v.size(); k++) {
                                if (o.toString().equals(v.elementAt(k).toString())) {
                                    v.remove(k);
                                    k--;
                                }
                            }
                        }
                    }
                }
            } catch (ClassCastException e) {
            }
        }
        try {
            table.updateColumn(pos, column);
            d.setOutput(table);
        } catch (XATTableOutOfRangeException e) {
            e.printStackTrace();
        } catch (XATTableEmptyException e) {
            e.printStackTrace();
        } catch (XATTableTupleNoMatchException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * Execution for the GroupBy operator, part of the visitor pattern.         
     * Groupby GB(col1..n, F1..m(col))[s]
     * Input: table s.
     * Output: table s.
     * Logic: Same as SQL.
     * Order Handling: The schema order of the output table is col1..n followed by F1..m(col).
     * The tuple order of the output table is no longer kept.
     * Requirement: col1..n and all the col in the F1..m should be in table s.
     * @param gb is the GroupBy opertor. 
     * @return null
     * @since   1.0              
     */
    public Object visit(GroupBy gb) throws ExecutionInvalidXATTreeException {
        // First we need to get the input table.
        XATTable xtbNewGroupby = new XATTableImp();
        XATTable xtbOrgGroupby;
        try {
            xtbOrgGroupby = (XATTable) gb.getPrimaryDataSource();
            Vector groups = new Vector();
            //if the table is empty, the groupby should return a table with one tuple
            //one tuple filled with empty collections.
            if (xtbOrgGroupby.getNumberOfTuples() == 0) {
                XATTable group = xtbOrgGroupby.cloneSchema();
                groups.add(group);
            } else {
                // Now, we break it into groups.
                groups = breakDown(gb.getColumnNames(), xtbOrgGroupby);
            }
            // Get the subqueries.
            XATTree subquery = gb.getXATTree();

            // for each group, we evaluate the subquery.
            for (int i = 0; i < groups.size(); i++) {
                XATTable group = (XATTable) groups.elementAt(i);
                group.setName(xtbOrgGroupby.getName());
                // clone the subquery.
                XATTree subqueryclone = (XATTree) subquery.clone();
                StatisticsGatheringVisitor.addTempTree(subqueryclone);
                XATNode[] leaves = subqueryclone.getLeaves();
                // append this source to the end of each leaf.
                // Note: There suppose to be only one leaf
                XATNode sourceNode = new XATNodeImp();
                Source sourceTmp = new SourceImp(sourceNode);
                sourceTmp.setOutput(group);
                sourceTmp.setType(Source.TEMP);
                sourceNode.setOperator(sourceTmp);

                for (int j = 0; j < leaves.length; j++) {
                    XATNode leaf = (XATNode) leaves[j];
                    // if the leaf is a source node,
                    // then create a cartesian product,
                    // put both the source node below it.
                    if (leaf.getOperator() instanceof Source) {
                        XATNode cpNode = new XATNodeImp();
                        CartesianProduct cpOp = new CartesianProductImp(cpNode);
                        // insert the catesian there.
                        cpNode.addChild(sourceNode);
                        sourceNode.setParent(cpNode);
                        cpNode.addChild(leaf);
                        cpNode.setParent(leaf.getParent());
                        leaf.setParent(cpNode);
                        cpNode.getParent().deleteChild(leaf);
                        cpNode.getParent().addChild(cpNode);
                    } else { // if the leaf is not a source operator, then just appened this operator.
                        subqueryclone.addNode(sourceNode, leaf);
                        sourceNode.setParent(leaf);
                    }
                }
                ExecuteVisitor exec = new ExecuteVisitor();
                exec.visit(subqueryclone);
                XATTable xtbTmp =
                    (XATTable) subqueryclone.getRoot().getOperator().getOutputDataSource();
                if (xtbTmp != null) {
                    // if the result is not empty, then put it back to the groupby's result.
                    if (i == 0) { // if it's the first table,
                        // initialize the schema of the xtbNewGroupBy
                        xtbNewGroupby = xtbTmp.cloneSchema();
                    }
                    // append the result to the output table.
                    xtbNewGroupby.appendTable(xtbTmp);
                    if (isDebug() && isShowTable())
                        System.out.println("**" + xtbNewGroupby + "**");
                }
            }
        } catch (XATException e) {
            throw new ExecutionInvalidXATTreeException();
        }

        // Takes the new table and appends the columns after the functions are called on the Original table
        xtbNewGroupby.setName("aftergroupby");
        gb.setOutput(xtbNewGroupby);

        return null;
    }

    /**
     * Execution for the Intersection operator, part of the visitor pattern.         
     * Intersect Inter(Table[])
     * Input: n number of tables.
     * Output: table r.
     * Logic: This operation will compare n number of tables and return
     * a result table r that retains tuples that match with each table.
     * Order Handling: The ouput table order is the same as the left input table order     
     * Requirement: The table schemas are identical, same number of columns and the same name for each column.
     * @param inter is the Intersection opertor. 
     * @return null 
     * @throws XATTableSchemaNoMatchException     
     * @since   1.0              
     */
    public Object visit(Intersection inter) throws XATTableSchemaNoMatchException {
        XATTable xTabOutput = new XATTableImp();

        try {
            xTabOutput = (XATTable) inter.getPrimaryDataSource();
        } catch (XATNodeDoesNotExistException nm) {
            nm.printStackTrace();
        }

        XATTable xTabInputs[] = (XATTable[]) inter.getDataSources();
        Vector vTup1 = new Vector(); // Used for tuple comparisons
        Vector vTup2 = new Vector();

        int iColCount = xTabOutput.getNumberOfColumns();
        int iTupCount = xTabOutput.getNumberOfTuples();

        // First, check to see if the table schemas are identical
        for (int i = 1; i < xTabInputs.length; i++) {
            if (xTabInputs[i].getNumberOfColumns() != iColCount) {
                throw new XATTableSchemaNoMatchException();
            }
            try {
                for (int j = 1; j <= iColCount; j++) {
                    String sColName1 = xTabOutput.getColumnName(j);
                    String sColName2 = xTabInputs[i].getColumnName(j);
                    if (!sColName1.equals(sColName2)) {
                        System.out.println(sColName1 + " " + sColName2);
                        throw new XATTableSchemaNoMatchException();
                    }
                }
            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace();
            }

            //create a new Table
            XATTable newXATIntersect = new XATTableImp();
            newXATIntersect.setName(xTabOutput.getName());
            for (int n = 1; n <= iColCount; n++) {
                try {
                    newXATIntersect.appendColumn((String) xTabOutput.getColumnName(n));
                } catch (XATTableTupleNoMatchException e) {
                    e.printStackTrace();
                } catch (XATTableOutOfRangeException e) {
                    e.printStackTrace();
                }
            }

            // Done the schema checking, now we can compare tuples.
            // For now, instead of remembering the positions of each
            // tuple for comparison we will put a set of null strings
            // in for the values of each cell which may be cleaned up later.
            try {
                for (int k = 1; k <= iTupCount; k++) {
                    vTup1 = xTabOutput.getTuple(k);
                    for (int j = 1; j <= iTupCount; j++) {
                        vTup2 = xTabInputs[i].getTuple(j);
                        if (vTup1.equals(vTup2)) {
                            // For now, set the tuple to a set of null strings to preserve
                            // the position of the tuples
                            newXATIntersect.appendTuple(vTup1);
                        }
                    }
                }
            } catch (XATTableOutOfRangeException or) {
                or.printStackTrace();
            } catch (XATTableEmptyException emp) {
                emp.printStackTrace();
            } catch (XATTableSchemaNoMatchException nm) {
                nm.printStackTrace();
            }

            //set new table to final table
            //System.out.println(newXATUnion);
            XATTable newXATIntersectNoDup = removeDuplicates(newXATIntersect);
            xTabOutput = newXATIntersectNoDup;
        }

        inter.setOutput(xTabOutput);
        return null;
    }

    /**
     * Execution for the LeftOuterJoin operator, part of the visitor pattern.     
     * Left Outer Join LOJ(c)[l, r]
     * Input: table l, and table r.
     * Output: One table (with temporary table name)
     * Logic: Same as SQL.
     * Order Handling: The schema order of the output table is columns of table l followed by the columns of table r.
     * The tuple order of the output table is iteration of tuples in r over
     * the iteration of tuples in l, e.g., {<l1, r1>, <l1, r2>, <l2, null>, <l3, r1>, <l3, r3>}
     * Requirement: Condition c should be relates to both tables l and r.
     * @param loj is the LeftOuterJoin opertor. 
     * @return null
     * @throws ExecutionInvalidXATTreeException          
     * @since   1.0                  
     */
    public Object visit(LeftOuterJoin loj)
        throws ExecutionInvalidXATTreeException {

        XATTable xtbLeft = loj.getLeft();
        XATTable xtbRight = loj.getRight();

        XATTable xtbOutput = sharedOuterJoin(loj, xtbLeft, xtbRight);
        // set output to xtbOutput
        loj.setOutput((XATTable) xtbOutput);

        return null;
    }

    /*
     * Execution for the LeftSemiJoin operator, part of the visitor pattern.
     * Input: Tow table s1 and s2.
     * Output: Table s.
     * Logic: Same as in relational algebra
     * Order Handling: Same as in theta join.
     * Requirement:.                    
     * @param lsoj is the LeftSemiJoin opertor. 
     * @return null
     * @since   1.0         
    */
    public Object visit(LeftSemiJoin lsj) {
        XATTable xtbLeft = new XATTableImp();
        XATTable xtbRight = new XATTableImp();
        xtbLeft = (XATTable) lsj.getLeft().deepCloneDataSource();
        xtbRight = lsj.getRight();

        int iLeftTuples = xtbLeft.getNumberOfTuples();
        int iRightTuples = xtbRight.getNumberOfTuples();

        for (int i = 1; i <= iLeftTuples; i++) {
            int j;
            for (j = 1; j <= iRightTuples; j++) {
                int[] iPosArray = { i, j };
                // if the condition evaluates to true
                if (((Boolean) lsj.getExpression().eval(lsj, iPosArray)).booleanValue()) {
                    // here we do the work if the condition evaluates to true
                    // this case we need to do nothing.
                    break;
                }
            }
            // might be j> IrightTUples
            if (j >= iRightTuples) {
                // we hit the end of the loop.  i.e. there was no match.
                try {
                    xtbLeft.deleteTuple(i);
                } catch (XATTableOutOfRangeException e) {

                } catch (XATTableEmptyException e) {

                }
            }
        }
        // set output to xtbLeft
        lsj.setOutput((XATTable) xtbLeft);

        return null;

    }

    /**
     * Execution for the OrderBy operator, part of the visitor pattern.     
     * Orderby OB(col1..n)[s]
     * Input: table s.
     * Output: table s.
     * Logic: Same as SQL.
     * Order Handling: The schema order of the output table is same as table s.
     * The tuple order of the output table is as specified.
     * Requirement:
     * col1..n should be in table s.
     * @param ob is the OrderBy opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException     
     * @since   1.0              
     */
    public Object visit(OrderBy ob) throws XATNodeDoesNotExistException {
        XATTable sortedTab = new XATTableImp();
        XATTable xtbOrgOrderby = new XATTableImp();
        try {
            xtbOrgOrderby = (XATTable) ob.getPrimaryDataSource();
        } catch (XATNodeDoesNotExistException e) {
            throw new XATNodeDoesNotExistException();
        }

        String[] sColNames = ob.getColumnNames();
        int iNumCols = Array.getLength(sColNames);

        try {
            sortedTab = sort(sColNames, xtbOrgOrderby, true);
        } catch (XATException e) {
            // this fails
            return null;
        }

        // Takes the new table and appends the columns after the functions are called on the Original table
        ob.setOutput(sortedTab);
        return null;
    }

    /*
     * Execution for the OuterUnion operator, part of the visitor pattern.
     * Outer Unoin OU(S)[l..n]
     * Input: n number of tables.
     * Output: Table s 
     * Logic: Unlike the Union, the Outer Union does not require the input tables to have the same schema.
     * It is useful in publishing XML documents.
     * Order Handling:
     * Requirement: 
     * @param ou is the OuterUnion opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException     
     * @since   1.0         
    */
    public Object visit(OuterUnion ou) throws XATNodeDoesNotExistException {
        XATTable xtbOutputPosDup =
            (XATTable) ou.getPrimaryDataSource().deepCloneDataSource();
        //remove all duplicates
        XATTable xtbOutput = removeDuplicates(xtbOutputPosDup);

        for (int i = 1; i < Array.getLength(ou.getSources()); i++) {

            int iTupleCount = xtbOutput.getNumberOfTuples();
            Vector outColNames = xtbOutput.getColNames();

            XATTable xtbInputPosDup = ou.getSourceAt(i);
            //remove duplicates
            XATTable xtbInput = removeDuplicates(xtbInputPosDup);
            int inputTupleCount = xtbInput.getNumberOfTuples();
            Vector inColNames = xtbInput.getColNames();

            //get common column names
            Vector comColNames = xtbOutput.getCommonColumnNames(xtbInput);

            //get merged column names
            Vector newColNames = xtbOutput.mergeColumnNames(xtbInput);

            //get uncommon column names
            Vector unComColNames = xtbOutput.getUnCommonColumnNames(xtbInput);

            //create new Vector for all inner unmatched tuples
            Vector innerUnmatchedTupleVector = new Vector();

            //create a new Table
            XATTable newXATUnion = new XATTableImp();
            newXATUnion.setName(xtbOutput.getName());
            for (int n = 0; n < newColNames.size(); n++) {
                try {
                    newXATUnion.appendColumn((String) newColNames.elementAt(n));
                } catch (XATTableTupleNoMatchException e) {
                    e.printStackTrace();
                }
            }

            //iterate through the first table
            try {
                for (int c = 0; c < iTupleCount; c++) {
                    Vector newTuple = new Vector();
                    Vector comTuple = new Vector();

                    int tupleCurr = c + 1;

                    //if tuples are deleted from inTable, make sure to have correct current tuple count
                    int tupleInCurr = c + 1 - (iTupleCount - inputTupleCount);

                    //Get all common column cells
                    for (int b = 0; b < comColNames.size(); b++) {
                        //add a cell from the common column to the first new "tuple"

                        comTuple.add(
                            xtbOutput.getValue(
                                xtbOutput.getColumnPosition((String) comColNames.elementAt(b)),
                                tupleCurr));

                    }

                    //initialize newTuple
                    newTuple = (Vector) comTuple.clone();

                    boolean mismatchAdd = true;

                    //find possible matching tuple values in second table

                    for (int d = 0; d < inputTupleCount; d++) {
                        Vector vecTupleNew = new Vector();
                        //add a cell from the common column to a second new "tuple"
                        for (int z = 0; z < comColNames.size(); z++) {
                            vecTupleNew.add(
                                xtbInput.getValue(
                                    xtbInput.getColumnPosition((String) comColNames.elementAt(z)),
                                    d + 1));
                        }

                        //if the first tuple and the second tuple are equal
                        if (newTuple.equals(vecTupleNew)) {
                            //Get all extra cell values from outer table
                            //System.out.println(newTuple + " " + vecTupleNew);
                            for (int x = comColNames.size(); x < newColNames.size(); x++) {
                                int loc = outColNames.indexOf(newColNames.elementAt(x));
                                if (loc != -1) {
                                    newTuple.add(
                                        xtbOutput.getValue(
                                            xtbOutput.getColumnPosition((String) newColNames.elementAt(x)),
                                            tupleCurr));
                                }
                            }

                            //Get all extra cell values from inner table
                            for (int x = comColNames.size(); x < newColNames.size(); x++) {
                                int loc = inColNames.indexOf(newColNames.elementAt(x));
                                if (loc != -1) {
                                    newTuple.add(
                                        xtbInput.getValue(
                                            xtbInput.getColumnPosition((String) newColNames.elementAt(x)),
                                            tupleInCurr));
                                }
                            }

                            //append newly formed schema correct tuple to new table
                            newXATUnion.appendTuple(newTuple);

                            //fix contents of newTuple
                            newTuple = (Vector) comTuple.clone();

                            //delete the tuple from the inner table, since it was added to the new table
                            // and lower the tuple count
                            xtbInput.deleteTuple(tupleInCurr);
                            inputTupleCount--;
                            tupleInCurr--;
                            mismatchAdd = false;
                        } else {
                            //System.out.println(newTuple + " " + vecTupleNew);
                            //Get all extra cell values from outer table
                            for (int x = comColNames.size(); x < newColNames.size(); x++) {
                                int loc = outColNames.indexOf(newColNames.elementAt(x));
                                if (loc != -1) {
                                    newTuple.add(
                                        xtbOutput.getValue(
                                            xtbOutput.getColumnPosition((String) newColNames.elementAt(x)),
                                            tupleCurr));
                                }
                            }
                            //Get all extra cell values from inner table
                            for (int x = comColNames.size(); x < newColNames.size(); x++) {
                                int loc = inColNames.indexOf(newColNames.elementAt(x));
                                if (loc != -1) {
                                    newTuple.add(new Vector());
                                }
                            }

                            //in order to avoid duplicates, and wrong tuples, check if it really
                            // needs to be added to the table.  Only add once, at the end of the
                            // cartesian like compare process.
                            if (mismatchAdd && d == inputTupleCount - 1) {
                                //append newly formed schema correct tuple to new table
                                newXATUnion.appendTuple(newTuple);
                                mismatchAdd = false;
                            }

                            //fix contents of newTuple
                            newTuple = (Vector) comTuple.clone();
                        }
                    }
                }

            } catch (XATTableEmptyException e) {
                e.printStackTrace();
            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace();
            } catch (XATTableColumnNoExistException e) {
                e.printStackTrace();
            } catch (XATTableSchemaNoMatchException e) {
                e.printStackTrace();
            }
            try {
                for (int c = 0; c < inputTupleCount; c++) {
                    int tupleInCurr = c + 1;
                    Vector newTuple = new Vector();
                    //Get all common column cells
                    for (int b = 0; b < comColNames.size(); b++) {
                        //add a cell from the common column to the first new "tuple"
                        newTuple.add(
                            xtbInput.getValue(
                                xtbInput.getColumnPosition((String) comColNames.elementAt(b)),
                                tupleInCurr));
                    }
                    //Get all extra cell values from outer table
                    for (int x = comColNames.size(); x < newColNames.size(); x++) {
                        int loc = outColNames.indexOf(newColNames.elementAt(x));
                        if (loc != -1) {
                            newTuple.add(new Vector());
                        }
                    }
                    //Get all extra cell values from inner table
                    for (int x = comColNames.size(); x < newColNames.size(); x++) {
                        int loc = inColNames.indexOf(newColNames.elementAt(x));
                        if (loc != -1) {
                            newTuple.add(
                                xtbInput.getValue(
                                    xtbInput.getColumnPosition((String) newColNames.elementAt(x)),
                                    tupleInCurr));
                        }
                    }

                    //append newly formed schema correct tuple to new table
                    newXATUnion.appendTuple(newTuple);
                }

            } catch (XATTableColumnNoExistException e) {
                e.printStackTrace();
            } catch (XATTableSchemaNoMatchException e) {
                e.printStackTrace();
            }
            //set new table to final table
            //System.out.println(newXATUnion);
            XATTable newXATUnionNoDup = removeDuplicates(newXATUnion);
            xtbOutput = newXATUnionNoDup;
            //xtbOutput = newXATUnion;
        }
        //set output to xtbOutput
        ou.setOutput((XATTable) xtbOutput);
        return null;
    }

    /**
     * Execution for the Project operator, part of the visitor pattern.     
     * Project Pi(col1..n)[s]
     *
     * Input: table s
     * Output: table s
     * Logic: Same as SQL.
     * Order Handling: Keeps original tuple order, the schema order is reordered as the col1..n in the project operator.
     * Requirement: The col1..n should be in source s.
     * @param p is the Project opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException     
     * @since   1.0                  
     */
    public Object visit(Project p) throws XATNodeDoesNotExistException {
        XATTable xtbOutput = new XATTableImp();
        XATTable xtbInput = new XATTableImp();
        try {
            xtbInput = (XATTable) p.getPrimaryDataSource();
        } catch (XATNodeDoesNotExistException e) {
            throw new XATNodeDoesNotExistException();
        }
        String[] sColumnNames = p.getColumnNames();
        for (int i = 0; i < Array.getLength(sColumnNames); i++) {
            try {
                int iColumnPosition = xtbInput.getColumnPosition(sColumnNames[i]);
                xtbOutput.appendColumn(sColumnNames[i], xtbInput.getColumn(iColumnPosition));
            } catch (XATTableColumnNoExistException e) {

            } catch (XATTableOutOfRangeException e) {

            } catch (XATTableTupleNoMatchException e) {

            }
        }
        //set output to xtbOutput
        p.setOutput((XATTable) xtbOutput);
        return null;
    }

    /**
     * Execution for the RightOuterJoin operator, part of the visitor pattern.        
     * Uses same logic as leftOuterJoin. Just switch the Left and Right.
     * @param roj is the RightOuterJoin opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException     
     * @since   1.0
     * @see LeftOuterJoin
    */
    public Object visit(RightOuterJoin roj) throws XATNodeDoesNotExistException {
        XATTable xtbLeft = roj.getLeft();
        XATTable xtbRight = roj.getRight();
        // call the shared algorithm, with different order of the tables.
        XATTable xtbOutput = sharedOuterJoin(xtbRight, xtbLeft);
        // set output to xtbOutput
        roj.setOutput((XATTable) xtbOutput);
        return null;
    }

    /**
     * Execution for the RightSemiJoin operator, part of the visitor pattern.        
     * Uses same logic as leftSemiJoin. Just switch the Left and Right.
     * @param rsj is the RightSemiJoin opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException     
     * @since   1.0
     * @see LeftSemiJoin
    */
    public Object visit(RightSemiJoin rsj) throws XATNodeDoesNotExistException {
        XATTable xtbLeft = new XATTableImp();
        XATTable xtbRight = new XATTableImp();
        xtbLeft = (XATTable) rsj.getLeft().deepCloneDataSource();
        xtbRight = rsj.getRight();
        int iLeftTuples = xtbLeft.getNumberOfTuples();
        int iRightTuples = xtbRight.getNumberOfTuples();

        for (int i = 1; i <= iRightTuples; i++) {
            int j;
            for (j = 1; j <= iLeftTuples; j++) {
                int[] iPosArray = { j, i };
                // if the condition evaluates to true
                if (((Boolean) rsj.getExpression().eval(rsj, iPosArray)).booleanValue()) {
                    // here we do the work if the condition evaluates to true
                    // this case we need to do nothing
                    break;
                }
            }
            if (j > iLeftTuples) {
                /* we hit the end of the loop.  i.e. there was no match. */
                try {
                    xtbRight.deleteTuple(i);
                    i--;
                    iRightTuples--;
                } catch (XATTableOutOfRangeException e) {

                } catch (XATTableEmptyException e) {

                }
            }
        }
        // set output to xtbRight
        rsj.setOutput((XATTable) xtbRight);
        return null;
    }

    /**
     * Execution for the Select operator, part of the visitor pattern.         
     * Select Theta(c)[s]
     * Input: table s
     * Output: table s
     * Logic: Same as SQL.
     * Order Handling: Keep original tuple order, keep original schema order.
     * Requirement: Condition c should be only reference to the source s.
     * @param s is the Select opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException
     * @since   1.0              
     */
    public Object visit(Select s) throws XATNodeDoesNotExistException {

        // check that the condition relates to the xnaNode.getOperator().getOutput()
        XATTable xtbOutput = (XATTable) s.getPrimaryDataSource();
        int i = 1;
        while (i <= xtbOutput.getNumberOfTuples()) {
            int[] iPosArray = { i };
            // if(condition is not true for the tuple)
            XATDataValue evalResults = (XATDataValue) s.getExpression().eval(s, iPosArray);
            if (!(evalResults).convertToBoolean().booleanValue()) {
                try {
                    if (isDebug()) {
                        // get all the colum names used in this expression.
                        ColumnName[] cols = s.getExpression().getRelatedColumnNames();
                        StringBuffer buffer = new StringBuffer();
                        for (int iCols = 0; iCols < cols.length; iCols++) {
                            buffer.append(
                                cols[iCols]
                                    + ":"
                                    + xtbOutput.getValue(xtbOutput.getColumnPosition(cols[iCols].getColumnName()), i)
                                    + "|");
                        }
                        System.out.println("Non match: " + buffer.toString());
                    }
                    xtbOutput.deleteTuple(i);
                } catch (XATTableOutOfRangeException e) {

                } catch (XATTableEmptyException e) {

                }
            } else {
                i++;
            }

        }
        //set output to xtbOutput
        s.setOutput((XATTable) xtbOutput);
        return null;
    }

    /**
     * Execution for the ThetaJoin operator, part of the visitor pattern.         
     *
     * Input: table l, and table r.
     * Output: One table (with temporary table name)
     * Logic: Same as SQL.
     * Order Handling: The schema order of the output table is columns of table l followed by the columns of table r.
     * The tuple order of the output table is iteration of tuples in r over the iteration of tuples in l, e.g., {<l1, r1>, <l1, r2>, <l2, r1>, <l2, r2>}
     * Requirement: Condition c should be relates to both tables l and r.
     * @param tj is the ThetaJoin opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException
     * @since   1.0              
    */
    public Object visit(ThetaJoin tj) throws XATNodeDoesNotExistException {
        XATTable xtbLeft = tj.getLeft();
        XATTable xtbRight = tj.getRight();
        XATTable xtbOutput = new XATTableImp();
        int iLeftTuples = xtbLeft.getNumberOfTuples();
        int iRightTuples = xtbRight.getNumberOfTuples();

        int iLeftColumns = xtbLeft.getNumberOfColumns();
        int iRightColumns = xtbRight.getNumberOfColumns();

        for (int i = 1; i <= iLeftColumns; i++) {
            try {
                xtbOutput.appendColumn(xtbLeft.getColumnName(i), new Vector());
            } catch (XATTableTupleNoMatchException e) {
                e.printStackTrace();
            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace();
            }
        }
        for (int i = 1; i <= iRightColumns; i++) {
            try {
                xtbOutput.appendColumn(xtbRight.getColumnName(i), new Vector());
            } catch (XATTableTupleNoMatchException e) {
                e.printStackTrace();
            } catch (XATTableOutOfRangeException e) {
                e.printStackTrace();
            }
        }

        for (int i = 1; i <= iLeftTuples; i++) {
            for (int j = 1; j <= iRightTuples; j++) {
                int[] iPosArray = { i, j };
                // if the condition evaluates to true
                if (((Boolean) tj.getExpression().eval(tj, iPosArray)).booleanValue()) {
                    try {
                        Vector vNewTuple = new Vector(xtbLeft.getTuple(i));
                        vNewTuple.addAll(xtbRight.getTuple(j));
                        xtbOutput.appendTuple(vNewTuple);
                    } catch (XATTableEmptyException e) {
                        e.printStackTrace();
                    } catch (XATTableOutOfRangeException e) {
                        e.printStackTrace();
                    } catch (XATTableSchemaNoMatchException e) {
                        e.printStackTrace();
                    }
                }
            }
        }

        // set output to xtbOutput
        tj.setOutput((XATTable) xtbOutput);

        return null;
    }

    /**
     * Execution for the Union operator, part of the visitor pattern.     
     * Input: Multiple tables s1..n.
     * Output: One table (with temporary name).
     * Logic: Same as SQL.
     * Order Handling: The schema order of the output table is same as table s1.
     * The tuple order of the output table is in the order of table s1..n.
     * Requirement: All tables s1..n have same schema
     * @param u is the Union opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException, XATTableSchemaNoMatchException
     * @since   1.0              
     */
    public Object visit(Union u)
        throws XATNodeDoesNotExistException, XATTableSchemaNoMatchException {
        XATTable xtbOutput = new XATTableImp();
        try {
            xtbOutput = (XATTable) u.getPrimaryDataSource().deepCloneDataSource();
        } catch (XATNodeDoesNotExistException e) {
            throw new XATNodeDoesNotExistException();
        }

        int iColumnCount = xtbOutput.getNumberOfColumns();
        for (int i = 1; i < Array.getLength(u.getSources()); i++) {
            XATTable xtbInput = u.getSourceAt(i);
            if (xtbInput.getNumberOfColumns() != iColumnCount) {
                System.out.println("Incorrect tuple count");
                throw new XATTableSchemaNoMatchException();
            }
            for (int m = 1; m <= iColumnCount; m++) {
                try {
                    if (!xtbInput.getColumnName(m).equals(xtbOutput.getColumnName(m))) {
                        System.out.println("Incorrect column name match");
                        throw new XATTableSchemaNoMatchException();
                    }
                } catch (XATTableOutOfRangeException e) {
                    e.printStackTrace();
                }
            }

            int iTupleCount = xtbInput.getNumberOfTuples();
            for (int j = 1; j <= iTupleCount; j++) {
                try {
                    xtbOutput.appendTuple(xtbInput.getTuple(j));
                } catch (XATTableEmptyException e) {
                    e.printStackTrace();
                } catch (XATTableOutOfRangeException e) {
                    e.printStackTrace();
                } catch (XATTableSchemaNoMatchException e) {
                    e.printStackTrace();
                }
            }
        }

        //remove duplicates
        XATTable remDupTable = removeDuplicates(xtbOutput);
        //set output to xtbOutput
        u.setOutput((XATTable) xtbOutput);
        return null;
    }

    /**
     * Execution for the Aggregate operator, part of the visitor pattern.         
     * Aggregate Agg(F1..m(col))[s]
     * Input: table s.
     * Output: table s.
     * Logic: Merge all tuples in that table into one, and apply functions on
     * those columns. If there are no functions, then just merge all the content.
     * Order Handling: The schema order of the output table is F1..m(col).
     * There is only one tuple.
     * Also, within each cell, the duplicates should be removed from that collection
     * except the fucus collom 
     * Requirement: All the col in the F1..m should be in table s.
     * @param agg is the Aggregate opertor. 
     * @return null
     * @since   1.0              
     */
    public Object visit(Aggregate agg) {
        XATTree xtrAggfunctions = agg.getXATTree();
        XATTable xTabInput = new XATTableImp();
        try {
            xTabInput = (XATTable) agg.getPrimaryDataSource();
        } catch (XATNodeDoesNotExistException e) {
            agg.setOutput(new XATTableImp());
            e.printStackTrace();
            return null;
        }
        //When the table is empty, the aggregate should return a table will
        //one tuple filled with empty collections.
        // By: Song Wang
        if (xtrAggfunctions == null) {
            // Here we must merge all of the tuples into one tuple leaving the columns intact
            // In order to complete this, take the entire column as input and put the contents into a single cell
            Vector newTuple = new Vector();
            for (int i = 1; i <= xTabInput.getNumberOfColumns(); i++) {
                // Here we need to set one cell per column in the output table
                try {
                    // First merge the values into one XATDataValue.
                    XATDataValue value = new XATDataValueImp();
                    String sColName = xTabInput.getColumnName(i);
                    Vector vCol = xTabInput.getColumn(i);
                    for (int j = 0; j < vCol.size(); j++) {
                        value.add(vCol.elementAt(j));
                    }
                    // Second, remove the duplicated values in that XATDataValue except the last column.
                    // This will be changed to "except the focus column", which is the outputCollumnName of aggration.
                    // By: Song Wang          
                    //if (i != xTabInput.getNumberOfColumns()) { // except the last column
                    if (!sColName.equals(agg.getOutputColumnName())) {
                        // remove the duplicates in this Cell.
                        value.removeDuplicates();
                    }
                    // Third, create a new XATDataValue from the new Collection.
                    newTuple.add(value);
                } catch (XATTableOutOfRangeException e) {
                }
            }
            try {
                xTabInput.deleteAllTuples();
                xTabInput.appendTuple(newTuple);
            } catch (XATTableSchemaNoMatchException e) {
            }

        } else {
            System.err.println(
                "ERROR! Aggregate shouldn't have other aggregation functions.");
        }

        agg.setOutput(xTabInput);
        return null;
    }

    /**
     * Execution for the Composer operator, part of the visitor pattern.
     * Input: table s.
     * Output: an XML document.
     * Logic: This method results in a complete XML document by using the contents and 
     * structure of the data model to determine the structure of the XML document.
     * Order Handling: 
     * Requirement: It is a special purpose XML cosntruction opertor that will only be avaialbe after
     * SQL generation and optimization. 
     * @param comp is the Composer opertor. 
     * @return null
     * @since   1.0         
     */
    public void visit(Composer comp) {
        XATTable inputTable;
        try {
            inputTable = (XATTable) comp.getPrimaryDataSource();

            //determine the number of nested levels
            int levels = comp.getLevel();
            int numRows = inputTable.getNumberOfTuples();
            int numCols = inputTable.getNumberOfColumns();

            //prepare a hash table to keep the tag's id and type
            Hashtable hash = new Hashtable();
            StringBuffer resultDoc = new StringBuffer();
            Stack tagStack = new Stack();

            for (int i = 1; i <= numRows; i++) {
                for (int j = 1; j <= numCols; j++) {

                    //strings to check if the id changed
                    String previousId = new String("");
                    String currentId = new String("");

                    try {
                        currentId = ((XATDataValue) inputTable.getValue(j, i)).convertToString();
                        if (i > 1)
                            previousId = ((XATDataValue) inputTable.getValue(j, i - 1)).convertToString();
                        else
                            previousId = new String("");

                    } catch (Exception e) {
                        System.out.println("could not store id's for comparison\n" + e);
                    }

                    if (j <= levels) {
                        // this column contains a parent id.
                        // if there is nothing in the hash for that nesting level, 
                        // add it to the hash
                        if (hash.containsKey(new Integer(j))) {
                            if (!currentId.equals(previousId)) {
                                tagStack.push("</" + hash.get(new Integer(j)) + ">");
                                hash.remove(new Integer(j));
                            }
                        }
                        // if there is an entry in the hash, but the 
                        // id changed, close the tag and add the new tag type
                        // to the hash
                        if (!hash.containsKey(new Integer(j))) {
                            try {
                                if (((XATDataValue) inputTable.getValue(j, i)).convertToString().length()
                                    != 0) {
                                    hash.put(
                                        new Integer(j),
                                        ((XATDataValue) inputTable.getValue((levels + 1), i)).convertToString());
                                }

                            } catch (Exception e) {
                                System.out.println(e);
                            }

                        }
                    } else {
                        String colName = new String();

                        if (j == (levels + 1))
                            while (!tagStack.empty())
                                resultDoc.append(tagStack.pop());

                        try {
                            colName = inputTable.getColumnName(j);
                        } catch (XATTableOutOfRangeException e) {
                            System.out.println(e);
                        }

                        // if the column contains tagger name add it to the result
                        if (colName.equalsIgnoreCase("type"))
                            try {
                                resultDoc.append("<" + inputTable.getValue(j, i) + " ");
                            } catch (Exception e) {
                                System.out.println(e);
                            } else
                            // append the text of tagger 
                            //if (colName.equalsIgnoreCase("text")) {
                            if (colName.equalsIgnoreCase("value")) {
                                try {
                                    resultDoc.append(">" + inputTable.getValue(j, i));
                                } catch (Exception e) {
                                    System.out.println(e);
                                }

                            }
                        // attributes
                        else
                            try {
                                if (((XATDataValue) inputTable.getValue(j, i)).convertToString() != "") {
                                    resultDoc.append(inputTable.getColumnName(j) + "=");
                                    resultDoc.append("\"" + inputTable.getValue(j, i) + "\"");
                                }
                            } catch (Exception e) {
                                System.out.println(e);
                            }
                    }

                }

            }

            for (int i = levels; i >= 1; i--)
                if (hash.containsKey(new Integer(i)))
                    resultDoc.append("</" + hash.get(new Integer(i)) + ">");

            //print the result of the vector that contains XML document
            System.out.println("XML document: " + resultDoc.toString());
            Vector newCol = new Vector();
            newCol.add(resultDoc.toString());
            inputTable.appendColumn(comp.getOutputColumnName(), newCol);
            comp.setOutput(inputTable);
        } catch (Exception e) {
        }

    }

    /**
     * Execution for the NavCollection operator, part of the visitor pattern.
     * Input: table s.
     * Output: table s.
     * Logic: The NavCollection operator will only create the new collection
     * instead of unnesting the parent tuples. We adopt the algorithm from Navigate Unnesting. 
     * The difference is: we don't duplicate the parent tuples, and directly put the output column in it.
     * Order Handling: the tuple order on the output XAT table follows the order of the input XAT table.     
     * Requirement:     
     * @param n is the NavCollection opertor. 
     * @return null
     * @throws ExecutionInvalidXATTreeException
     * @since   1.0              
     */
    public Object visit(NavCollection n) throws ExecutionInvalidXATTreeException {
        try {
            // Keep the information in the navigate operator.
            String sBinding = n.getBinding();
            NavigationStep[] nsEntry = n.getEntryPoint();
            NavigationStep[] nsDestination = n.getDestination();

            //1. Check the entry point, it should be VarStep.
            if (!(nsEntry[0] instanceof VarStep))
                throw new ExecutionInvalidXATTreeException("Expecting Entry Point as a VarStep.");
            String sColumnName = nsEntry[0].getStepValue();

            //2. Go to the input table
            XATTable xtabInput;
            try {
                xtabInput = (XATTable) n.getPrimaryDataSource();
            } catch (XATNodeDoesNotExistException e) {
                throw new ExecutionInvalidXATTreeException("Missing Input Table.");
            }

            //3. Locate that column.
            //4. Get that column out.
            int iEntryCol = xtabInput.getColumnPosition(sColumnName);

            Vector inputColumn = xtabInput.getColumn(iEntryCol);

            //5. Create a new Vector as the output column.
            Vector outputColumn = new Vector();

            //6. The output column's name should be stored in property "binding" of the navigateimp.
            String sOutputColumnName = sBinding;

            //7. For each value in the input column generated in step 4.
            for (int i = 0; i < inputColumn.size(); i++) {
                XATDataValue value = (XATDataValue) inputColumn.elementAt(i);

                //8. Get the list of steps in the destination.
                //9. Make a private function called "Follow" with two parameters, the Node and the Step.
                //The Follow() will return a collection of the XML nodes after the step is followed.
                Vector collection = follow(value.convertToCollection(), nsDestination);

                //10. Remember the output into the output column.
                outputColumn.addElement(collection);
            }

            //13. Now after the whole input column has been processed.
            //14. We are going to populate the output column into the output XAT table.
            //15. Take a clone of the input XAT table as the output XAT table.

            //16. Add a new empty column to the output XAT table with its new name.
            // We need to update the XATTable to have one more function of appendColumn, which is only
            // take a column name. It will create a blank column with a specific name in the table.
            xtabInput.appendColumn(sOutputColumnName);
            iEntryCol = xtabInput.getColumnPosition(sOutputColumnName);

            //17. For each value in the output Column, we do
            int iCursor = 1; // cursor on the output table. count from 1.
            for (int i = 0; i < outputColumn.size(); i++) {
                // expected a collection here.
                Vector vCollection = (Vector) outputColumn.elementAt(i);

                //if the collection is empty, then we keep the empty collection.
                //directly put the collection into the output table.
                xtabInput.updateValue(iEntryCol, iCursor, new XATDataValueImp(vCollection));
                iCursor++;

            }
            //21. done. keep the output.
            n.setOutput(xtabInput);
        } catch (XATException e) {
            e.printStackTrace();
            throw new ExecutionInvalidXATTreeException(e.getMessage());
        }

        return null;
    }

    /**
     * Execution for the NavUnnest operator, part of the visitor pattern.
     * Input: table s.
     * Output: table s.
     * Logic: The NavUnnest operator will unnest the parent tuples.
     * A new column is appended to the output XAT table each parent 
     * tuple is duplicated in the output table for each unnested value 
     * from that tuple, the unnested value appers in the new column,
     * and if there is nothing to unnest from an input tuple an empty collection is placed in the new column 
     * Order Handling: the tuple order on the output XAT table follows the order of the input XAT table.     
     * Requirement:    
     * @param n is the NavUnnest opertor. 
     * @return null
     * @throws ExecutionInvalidXATTreeException
     * @since   1.0         
    */
    public Object visit(NavUnnest n) throws ExecutionInvalidXATTreeException {

        // make it an empty input table by default.
        XATTable xtabInput = new XATTableImp();
        XATTable xtabOutput = new XATTableImp();
        try {
            // Keep the information in the navigate operator.
            String sBinding = n.getBinding();
            NavigationStep[] nsEntry = n.getEntryPoint();
            NavigationStep[] nsDestination = n.getDestination();

            //1. Check the entry point, it should be VarStep.
            if (!(nsEntry[0] instanceof VarStep))
                throw new ExecutionInvalidXATTreeException("Expecting Entry Point as a VarStep.");
            String sColumnName = nsEntry[0].getStepValue();

            //2. Go to the input table
            try {
                xtabInput = (XATTable) n.getPrimaryDataSource();
            } catch (XATNodeDoesNotExistException e) {
                throw new ExecutionInvalidXATTreeException("Missing Input Table.");
            }

            //3. Locate that column.
            //4. Get that column out.
            int iEntryCol = xtabInput.getColumnPosition(sColumnName);

            Vector inputColumn = xtabInput.getColumn(iEntryCol);

            //5. Create a new Vector as the output column.
            Vector outputColumn = new Vector();

            //6. The output column's name should be stored in property "binding" of the navigateimp.
            String sOutputColumnName = sBinding;
            //7. For each value in the input column generated in step 4.
            for (int i = 0; i < inputColumn.size(); i++) {
                XATDataValue value = (XATDataValue) inputColumn.elementAt(i);

                //if this value is empty collection. this means we should DELETE this one in NavUnnest
                if ((nsDestination == null) && (value.convertToCollection().size() == 0)) {
                    xtabInput.deleteTuple(i + 1);
                    i--;
                    continue;
                }
                //8. Get the list of steps in the destination.
                //9. Make a private function called "Follow" with two parameters, the Node and the Step.
                //The Follow() will return a collection of the XML nodes after the step is followed.
                Vector collection = follow(value.convertToCollection(), nsDestination);

                //10. Remember the output into the output column.
                outputColumn.addElement(collection);
            }

            //13. Now after the whole input column has been processed.
            //14. We are going to populate the output column into the output XAT table.
            //15. Take a clone of the input XAT table as the output XAT table.
            //16. Add a new empty column to the output XAT table with its new name.
            // We need to update the XATTable to have one more function of appendColumn, which is only
            // take a column name. It will create a blank column with a specific name in the table.
            xtabInput.appendColumn(sOutputColumnName);
            iEntryCol = xtabInput.getColumnPosition(sOutputColumnName);

            //17. For each value in the output Column, we do
            //int iCursor = 1; // cursor on the output table. count from 1.

            //change from original wide-first search to deep-first pre order search
            //aim to fix the order bug of "//nagstep"
            //every tuple will append to the xtabOutput.
            //xtabInput,inputColumn will not changed.
            //items in outputColumn will all be null after fun call.
            xtabOutput = xtabInput.cloneSchema();
            for (int i = 0; i < outputColumn.size(); i++) {
                dfsPreOrder(xtabOutput, iEntryCol, xtabInput, inputColumn, outputColumn, i);
            }

            //21. done. keep the output.
            n.setOutput(xtabOutput);
        } catch (XATException e) {
            // tell us the error.
            e.printStackTrace(System.err);
            // keep the outputtable as the input table.
            n.setOutput(xtabOutput);
            // throws the exception.
            throw new ExecutionInvalidXATTreeException(e.getMessage());
        }

        return null;
    }

    /**
     * Execution for the Tagger operator, part of the visitor pattern.         
     * Tagger Tag(p)[s]
     *
     * Input: Table s.
     * Output: Table s.
     * Logic: One additional column is added with tagged information.
     * Pattern p is only one level.
     * Order Handling: The tagged column is added to the end.
     * The tuple order of the output table is same as table s.
     * Requirement: The columns used in pattern p should be in table s.
     * @param t is the Tagger opertor. 
     * @return null
     * @since   1.0              
     */
    public Object visit(Tagger t) {
        XATTable xtabInput = new XATTableImp();
        XATTable xtabOutput = new XATTableImp();
        try {
            xtabInput = (XATTable) t.getPrimaryDataSource();
            xtabOutput = xtabInput.cloneSchema();
            XATNode node = t.getNode();
            //Set s = node.clearSchema();
            String sName = t.getOutputColumnName();
            xtabOutput.appendColumn(sName);
            //t.setOutput(xtabOutput);
            //node.setSchema(s);
        } catch (XATException e) {
            e.printStackTrace();
        }

        // Converts the ListPattern to a list of static strings and
        // column references
        // Check if the pattern in tagger is of ListPattern type
        Vector origTmpl = new Vector();

        if ((t.getPattern() instanceof ListPattern)) {
            // System.out.println("Pattern of ListPattern type");
            origTmpl = ((ListPattern) t.getPattern()).getList();

        }

        if ((t.getPattern() instanceof DOMPattern)) {
            ListPattern lp =
                ((DOMPattern) t.getPattern()).toListPattern(
                    ((DOMPattern) t.getPattern()).getRoot());
            origTmpl = lp.getList();
        }

        Vector template = new Vector(origTmpl.size());
        for (int i = 0; i < origTmpl.size(); i++) {
            Object el = origTmpl.elementAt(i);
            if (el instanceof String) {
                template.add(el);
            } else
                if (el instanceof ColumnName) {
                    ColumnRef cr = lookupColumn(t.getNode(), ((ColumnName) el).getColumnName());
                    if (cr == null)
                        throw new RuntimeException("Cannot find column " + el.toString());
                    template.add(cr);
                } else
                    throw new RuntimeException("invalid list element " + el.toString());
        }

        // Go through the records of the tables and fill up the node output with result from tagger
        // copies data for output columns (except for the last output column, which is used to store 
        // the output of the tagger) in our dm from the input
        int resColumnNum = xtabOutput.getNumberOfColumns();
        int resTupleNum;
        try {
            resTupleNum =
                ((XATTable) t.getNode().getChild(0).getOperator().getOutputDataSource())
                    .getNumberOfTuples();
        } catch (XATNodeDoesNotExistException e) {
            throw new RuntimeException(e.toString());
        }
        ColumnRef inputColRef[] = new ColumnRef[resColumnNum - 1];

        for (int i = 1; i < resColumnNum; i++) {
            try {
                inputColRef[i - 1] = lookupColumn(t.getNode(), xtabOutput.getColumnName(i));

                if (inputColRef[i - 1] == null)
                    throw new RuntimeException(
                        "input dm does not have column: " + xtabOutput.getColumnName(i));

            } catch (XATTableOutOfRangeException e) { // this should really be a RuntimeException
                throw new RuntimeException(e.toString());
            }
        }

        Vector tuple = new Vector(resColumnNum);
        tuple.setSize(resColumnNum);

        for (int i = 0; i < resTupleNum; i++) {

            for (int j = 0; j < resColumnNum - 1; j++)
                tuple.set(j, inputColRef[j].getCell(i + 1));

            StringBuffer value = new StringBuffer();

            for (Enumeration e = template.elements(); e.hasMoreElements();) {
                Object o = e.nextElement();
                if (o instanceof String)
                    value.append((String) o);
                else
                    value.append(((ColumnRef) o).getCell(i + 1));
            }
            tuple.set(resColumnNum - 1, new XATDataValueImp(value.toString()));

            xtabOutput.appendTuple(tuple);
        }

        t.setOutput(xtabOutput);
        return null;
    }

    /**
     * Execution for the XMLDifference operator, part of the visitor pattern.
     * Input: Table s.
     * Output: Table s.
     * Logic: Takes the difference of two columns. The first col minus the second col.
     * Order Handling: 
     * Requirement: 
     * @param xdiff is the XMLDifference opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException, XATTableSchemaNoMatchException
     * @since   1.0              
     */
    public Object visit(XMLDifference xdiff)
        throws XATNodeDoesNotExistException, XATTableSchemaNoMatchException {
        XATTable xtbOutputPosDup =
            (XATTable) xdiff.getPrimaryDataSource().deepCloneDataSource();
        //remove all duplicates
        XATTable xtbOutput = removeDuplicates(xtbOutputPosDup);

        int iTupleCount = xtbOutput.getNumberOfTuples();
        Vector outColNames = xtbOutput.getColNames();
        int colCount = xtbOutput.getNumberOfColumns();

        //XMLDifference only works on two columns.  If there are more, throw an exception
        if (colCount != 2) {
            throw new XATTableSchemaNoMatchException();
        }

        String outColName = xdiff.getOutputColumnName();

        //create a new Table
        XATTable newXMLDifference = new XATTableImp();
        newXMLDifference.setName(xtbOutput.getName());
        for (int n = 0; n < outColNames.size(); n++) {
            try {
                newXMLDifference.appendColumn((String) outColNames.elementAt(n));
            } catch (XATTableTupleNoMatchException e) {
                e.printStackTrace();
            }
        }

        //add new column for XML Difference'ed data
        try {
            newXMLDifference.appendColumn(outColName);
            for (int i = 1; i <= iTupleCount; i++) {
                Vector newTuple = xtbOutput.getTuple(i);

                //Order sensitive, essentially Col1 - Col2
                // Whatever appears in Col1 but not Col2 will be the result
                // Get col1, set it as the newCell for adding
                Vector firstColVec = new Vector();
                Vector secondColVec = new Vector();
                Vector newCell = new Vector();
                Object firstColObj = null;
                Object secondColObj = null;

                if (newTuple.elementAt(0) instanceof Vector) {
                    firstColVec = (Vector) newTuple.elementAt(0);
                    //make each collection distinct
                    firstColVec = XATTableImp.collectionDistinct(firstColVec);
                    newCell.addAll(firstColVec);
                } else {
                    firstColObj = newTuple.elementAt(0);
                    newCell.addElement(firstColObj);
                }

                if (newTuple.elementAt(1) instanceof Vector) {
                    secondColVec = (Vector) newTuple.elementAt(1);
                    //make each collection distinct                
                    secondColVec = XATTableImp.collectionDistinct(secondColVec);
                } else {
                    secondColObj = newTuple.elementAt(1);
                }

                //for each column check for differences
                //if first col is a vector
                if (firstColObj == null) {
                    for (int j = 0; j < firstColVec.size(); j++) {
                        if (newCell.isEmpty()) {
                            break;
                        }
                        //if the second column is a vector
                        if (secondColObj == null) {
                            for (int m = 0; m < secondColVec.size(); m++) {
                                //if an item appears in firstCol, and secondCol
                                // remove it from the newly added cell

                                if (firstColVec.elementAt(j).equals(secondColVec.elementAt(m))) {
                                    newCell.removeElement(firstColVec.elementAt(j));
                                }
                                if (newCell.isEmpty()) {
                                    break;
                                }
                            }
                        } else {
                            //otherwise the second column is an object
                            if (firstColVec.elementAt(j).equals(secondColObj)) {
                                newCell.removeElement(firstColVec.elementAt(j));
                            }
                        }
                        if (newCell.isEmpty()) {
                            break;
                        }
                    }
                } else {
                    //otherwise the first column is an object
                    // if the second column is a vector
                    if (secondColObj == null) {
                        for (int m = 0; m < secondColVec.size(); m++) {
                            if (firstColObj.equals(secondColVec.elementAt(m))) {
                                newCell.removeElement(firstColObj);
                            }
                            if (newCell.isEmpty()) {
                                break;
                            }
                        }
                    } else {
                        //otherwise the second column is an object
                        if (firstColObj.equals(secondColObj)) {
                            newCell.removeElement(firstColObj);
                        }
                    }
                }

                newTuple.add(newCell);
                newXMLDifference.appendTuple(newTuple);

            }

        } catch (XATTableTupleNoMatchException e) {
            e.printStackTrace();
        } catch (XATTableEmptyException e) {
            e.printStackTrace();
        } catch (XATTableOutOfRangeException e) {
            e.printStackTrace();
        } catch (XATTableSchemaNoMatchException e) {
            e.printStackTrace();
        }

        xtbOutput = newXMLDifference;
        //set output to xtbOutput
        xdiff.setOutput((XATTable) xtbOutput);
        return null;

    }

    /**
     * Execution for the XMLIntersection operator, part of the visitor pattern.
     * Input: Table s.
     * Output: Table s.
     * Logic: Takes the intersection of two columns. The first col intersect the second col.
     * Order Handling: 
     * Requirement:      
     * @param xintersect is the XMLIntersection opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException, XATTableSchemaNoMatchException
     * @since   1.0              
     */
    public Object visit(XMLIntersection xintersect)
        throws XATNodeDoesNotExistException, XATTableSchemaNoMatchException {
        XATTable xtbOutputPosDup =
            (XATTable) xintersect.getPrimaryDataSource().deepCloneDataSource();
        //remove all duplicates
        XATTable xtbOutput = removeDuplicates(xtbOutputPosDup);

        int iTupleCount = xtbOutput.getNumberOfTuples();
        Vector outColNames = xtbOutput.getColNames();
        int colCount = xtbOutput.getNumberOfColumns();

        //interesection only works on two columns. If there are more, throw an exception
        if (colCount != 2) {
            throw new XATTableSchemaNoMatchException();
        }

        String outColName = xintersect.getOutputColumnName();

        //create a new Table
        XATTable newXMLIntersection = new XATTableImp();
        newXMLIntersection.setName(xtbOutput.getName());
        for (int n = 0; n < outColNames.size(); n++) {
            try {
                newXMLIntersection.appendColumn((String) outColNames.elementAt(n));
            } catch (XATTableTupleNoMatchException e) {
                e.printStackTrace();
            }
        }

        //add new column for XML Intersection'ed data
        try {
            newXMLIntersection.appendColumn(outColName);
            for (int i = 1; i <= iTupleCount; i++) {
                Vector newTuple = xtbOutput.getTuple(i);

                //Order sensitive, essentially Col1 - Col2
                // Whatever appears in Col1 but not Col2 will be the result
                // Get col1, set it as the newCell for adding
                Vector firstColVec = new Vector();
                Vector secondColVec = new Vector();
                Vector newCell = new Vector();
                Object firstColObj = null;
                Object secondColObj = null;

                if (newTuple.elementAt(0) instanceof Vector) {
                    firstColVec = (Vector) newTuple.elementAt(0);
                    //make each collection distinct
                    firstColVec = XATTableImp.collectionDistinct(firstColVec);
                } else {
                    firstColObj = newTuple.elementAt(0);
                }

                if (newTuple.elementAt(1) instanceof Vector) {
                    secondColVec = (Vector) newTuple.elementAt(1);
                    //make each collection distinct
                    secondColVec = XATTableImp.collectionDistinct(secondColVec);
                } else {
                    secondColObj = newTuple.elementAt(1);
                }

                //for each column check for differences
                //if first col is a vector
                if (firstColObj == null) {
                    for (int j = 0; j < firstColVec.size(); j++) {
                        //if the second column is a vector
                        if (secondColObj == null) {
                            for (int m = 0; m < secondColVec.size(); m++) {
                                //if an item appears in firstCol, and secondCol
                                // remove it from the newly added cell
                                if (firstColVec.elementAt(j).equals(secondColVec.elementAt(m))) {
                                    newCell.add(firstColVec.elementAt(j));
                                }
                            }
                        } else {
                            //otherwise the second column is an object
                            if (firstColVec.elementAt(j).equals(secondColObj)) {
                                newCell.add(firstColVec.elementAt(j));
                            }
                        }
                    }
                } else {
                    //otherwise the first column is an object
                    // if the second column is a vector
                    if (secondColObj == null) {
                        for (int m = 0; m < secondColVec.size(); m++) {
                            if (firstColObj.equals(secondColVec.elementAt(m))) {
                                newCell.add(firstColObj);
                            }
                        }
                    } else {
                        //otherwise the second column is an object
                        if (firstColObj.equals(secondColObj)) {
                            newCell.add(firstColObj);
                        }
                    }
                }

                newTuple.add(newCell);
                newXMLIntersection.appendTuple(newTuple);

            }

        } catch (XATTableTupleNoMatchException e) {
            e.printStackTrace();
        } catch (XATTableEmptyException e) {
            e.printStackTrace();
        } catch (XATTableOutOfRangeException e) {
            e.printStackTrace();
        } catch (XATTableSchemaNoMatchException e) {
            e.printStackTrace();
        }

        xtbOutput = newXMLIntersection;
        //set output to xtbOutput
        xintersect.setOutput((XATTable) xtbOutput);
        return null;

    }

    /**
     * Execution for the XMLUnion operator, part of the visitor pattern.
     * Input: Table s.
     * Output: Table s.
     * Logic: Merges XML tables into one table. Each table will have relevant columns
     * but the merged tables, will not. Hence alot of values will be null.
     * Order Handling: 
     * Requirement:           
     * @param xun is the XMLUnion opertor. 
     * @return null
     * @throws XATNodeDoesNotExistException
     * @since   1.0              
     */
    public Object visit(XMLUnion xun) throws XATNodeDoesNotExistException {

        XATTable xtbOutput = (XATTable) xun.getPrimaryDataSource();

        int iTupleCount = xtbOutput.getNumberOfTuples();

        String[] unionColNames = xun.getColumnNames();

        int colCount = xtbOutput.getNumberOfColumns();

        String outColName = xun.getOutputColumnName();

        //add new column for XML Unioned data
        try {
            xtbOutput.appendColumn(outColName);

            int outIndex = xtbOutput.getColumnPosition(outColName);

            for (int i = 1; i <= iTupleCount; i++) {
                XATDataValue newCell = new XATDataValueImp();

                for (int j = 0; j < unionColNames.length; j++) {

                    XATValue value =
                        (XATValue) xtbOutput.getValue(xtbOutput.getColumnPosition(unionColNames[j]), i);

                    newCell.add(value);
                }

                xtbOutput.updateValue(outIndex, i, newCell);

            }

        } catch (XATTableTupleNoMatchException e) {
            e.printStackTrace();
        } catch (XATTableEmptyException e) {
            e.printStackTrace();
        } catch (XATTableOutOfRangeException e) {
            e.printStackTrace();
        } catch (XATTableSchemaNoMatchException e) {
            e.printStackTrace();
        }

        //set output to xtbOutput
        xun.setOutput((XATTable) xtbOutput);
        return null;

    }

    /*
     * Execution for an XAT tree, part of the visitor pattern.     
     * @param tree is the XATTree. 
     * @return Object
     * @since   1.0         
    */
    public Object visit(XATTree tree) {
        return visit(tree.getRoot());
    }

    /*
     * Execution for an XAT Node, part of the visitor pattern.     
     * @param xnoObj is the XATNode. 
     * @return Object
     * @since   1.0         
    */
    public Object visit(XATNode xnoObj) {

        XATNode[] xnaChildren = xnoObj.getChildren();
        for (int i = 0; i < xnaChildren.length; i++) {
            visit(xnaChildren[i]);
        }
        if (isDebug())
            System.out.println(xnoObj.getOperator());

        // A vector of cloned output table.
        Vector cloneXATTables = new Vector();
        if (isKeepClone()) {
            // clone the input table for this operator.
            for (int i = 0; i < xnaChildren.length; i++) {
                Object datasource =
                    DeepCopyMaker.makeDeepCopy(xnaChildren[i].getOperator().getOutputDataSource());
                if (datasource != null)
                    cloneXATTables.add(datasource);
                else
                    cloneXATTables.add(new XATTableImp());
            }
        }
        visit(xnoObj.getOperator());

        if (isKeepClone()) {
            // restore the XATtable for its input table.
            for (int i = 0; i < xnaChildren.length; i++) {
                xnaChildren[i].getOperator().setOutput(
                    (XATDataSource) cloneXATTables.elementAt(i));
            }
        }

        if (isDebug() && isShowTable())
            System.out.println(xnoObj.getOperator().getOutputDataSource());
        return null;
    }

    /**
     * Used to implement the visitor pattern. 
     * Overwrite this method in the parent class.
     * If there is an inheretance between the visited objects, it will only match the highest class. 
     * Note: Different from it's super class, this method will abort if "AbortOnException" system property is set.
     * @param object Object 
     * @return Object
     * @since   1.0             
    */
    public Object visit(Object object) {
        if (object == null)
            return dispatch();
        Method m = getMethod(object.getClass());
        try {
            return m.invoke(this, new Object[] { object });
        } catch (InvocationTargetException e) {
            e.getTargetException().printStackTrace();
            if (isAbort()) {
                // if we decide to abort the execute if any exception
                // occured. We abort the whole process.
                System.out.println("System Abort!!!");
                System.exit(1);
            }
            return dispatch(object);
        } catch (IllegalAccessException e) {
            return dispatch(object);
        } catch (IllegalArgumentException e) {
            return dispatch(object);
        }
    }
}