package edu.wpi.cs.dsrg.xmldb.xat.testfiles;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Source;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.SourceImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function.Function;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function.FunctionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTreeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATTable;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATTableImp;

/**
 * This Class is used to test functions.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0
 */

public class TestFunctions {
    /**
     * TestFunctions constructor comment.
     */
    public TestFunctions() {
        super();
    }
    public static void main(String argvs[]) {
        test1();
    }
    /**
    * Test case 1: Test the Function() To see if that can dynamically find the proper function class.
    */
    public static void test1() {
	    // create an XATTree with two nodes.
	    XATTree testTree = new XATTreeImp();
	    
	    // create an source XATNode.
	    XATNode srcNode = new XATNodeImp();
	    
	    // create a test Table.
	    XATTable testTable = new XATTableImp();
	    testTable.setName("testXinz");
	    Vector column = new Vector();
	    column.addElement("100");
	    column.addElement("20");
	    try{
		    testTable.appendColumn("col1", column);
	    }catch(Exception e){
		    e.printStackTrace();
	    }

	    System.out.println("Test Table: "  + testTable);
	    
		// create a source operator.
		Source srcOp = new SourceImp(srcNode);
		srcNode.setOperator(srcOp);
	    // set it's output table.
		srcOp.setOutput(testTable);

	    // create second XATNode.
	    XATNode funNode = new XATNodeImp();

	    // make the funNode as the root.
	    testTree.setRoot(funNode);

	    // make testNode as child of funNode.
	    funNode.addChild(srcNode);

	    // fill the funNode;
        Function f = new FunctionImp(funNode);
        funNode.setOperator(f);
        f.setName("MIN");
        f.setParams(new String[] { "col1" });


        // try it!
        f.execute();

        System.out.println("The Output Table: " + f.getOutputDataSource());
    }
}
