package edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.exception.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.visitorpattern.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import java.lang.reflect.Array;
/**
 * Creates a CartesianProduct node.  Used during query decorrelation when there 
 * are multiple sources in a tree.  The CartesianProduct node combines the multiple 
 * sources at the bottom of the tree.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0  
 */
public class CartesianProductImp
    extends XATMultiSourceOperatorImp
    implements XATMultiSourceOperator, CartesianProduct {

    /**
     * Assign a node to this operator .
     * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
     * @since   1.0   
     */
    public CartesianProductImp(XATNode node) {
        super(node);
    }

    /** Returns the left XAT table  
    * @return the left XATTable.
    * @since   1.0      
    */
    public XATTable getLeft() {
        try {
            return this.xnodOwner.getChild(0).getOperator().getOutput();
        } catch (XATNodeDoesNotExistException e) {
            return null;
        }
    }

    /** Returns the right XAT table  
    * @return the right XATTable.
    * @since   1.0      
    */
    public XATTable getRight() {
        try {
            return xnodOwner.getChild(1).getOperator().getOutput();
        } catch (XATNodeDoesNotExistException e) {
            return null;
        }

    }
    /**
    * Returns a String that represents the value of this object.
    * @return a string representation of the receiver
    * @since   1.0          
    */
    public String toString() {
        return "Cartesian Product";
    }
}