/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

/*
 * Created on Jan 1, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
//adapted 6/08 by KWorks

package edu.wpi.cs.dsrg.STeM.Partition.IMPIndex;
import java.util.Vector;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DataBucket {
	protected int numTuples;
	protected Vector tupleList;
	
	public DataBucket() {
		numTuples = 0;
		tupleList = new Vector();
	}
	public Vector getTupleList() {
		return tupleList;
	}
	public XATTuple getTuple(int pos) {
		return (XATTuple)tupleList.get(pos);
	}
	public void insertTuple(XATTuple tuple) {
		tupleList.add(tuple);
		numTuples ++;
	}
	public void insertTupleByTime(XATTuple tuple) {
		if (numTuples == 0) {
			tupleList.add(tuple);
			numTuples ++;
		} else {
			long timestamp = tuple.getMinTimeStamp();
			for (int i=0; i<numTuples; i++) {
				XATTuple t = (XATTuple)tupleList.get(i);
				if (timestamp < t.getMinTimeStamp()) {
					tupleList.insertElementAt(tuple, i);
					numTuples ++;
					return;
				}
			}
			tupleList.add(tuple);
			numTuples ++;
		}
	}
	public void mergeBucket(DataBucket dBucket) {
		int numTuples_b = dBucket.size();
		if (numTuples_b == 0) {
			return;
		} else if (numTuples == 0) {
			Vector tupleList_b = dBucket.getTupleList();
			tupleList = tupleList_b;
			return;
		}
		Vector tupleList_b = dBucket.getTupleList();
		int counter_a = 0, counter_b = 0, cursor_a = 0;
		XATTuple t_a = (XATTuple)tupleList.get(0);
		XATTuple t_b = (XATTuple)tupleList_b.get(0);
		
		while(true) {
			long time_a = t_a.getMinTimeStamp();
			long time_b = t_b.getMinTimeStamp();
			if (time_a > time_b) {
				tupleList.add(cursor_a, t_b);
				cursor_a ++;
				counter_b ++;
				if (counter_b == numTuples_b) {
					return;
				} else {
					t_b = (XATTuple)tupleList_b.get(counter_b);
				}
			} else {
				counter_a ++;
				if (counter_a == numTuples) {
					for (; counter_b<numTuples_b; counter_b++) {
						tupleList.add(tupleList_b.get(counter_b));
					}
				}
				return;
			}
		}
	}
	public void removeTuple(int pos) {
		tupleList.remove(pos);
		numTuples --;
	}
	public int removeExpiredTuples(long windowStart) {
		int counter = 0;
		while (counter < numTuples) {
			long time = ((XATTuple)tupleList.get(0)).getMinTimeStamp();
			if (time < windowStart) {
				tupleList.remove(0);
				counter ++;
			} else {
				break;
			}
		}
		numTuples -= counter;
		return counter;
	}
	
	public void removeOldestTuple() {
		if(numTuples>0)
		{	
		  tupleList.remove(0);
		  numTuples --;
		}  
	}

	public int size() {
		return numTuples;
	}
}
