/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

/*
 * Created on Dec 30, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
//adapted 6/08 by KWorks

package edu.wpi.cs.dsrg.STeM.Partition.IMPIndex;
import java.util.ArrayList;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TempHashEntry {
	int[] searchKeys;
	ArrayList tupleList; 
	int numTuples;
	
	public TempHashEntry() {
		tupleList = new ArrayList();
		numTuples = 0;
	}

	public TempHashEntry(int[] sKeys) {
		int numKeys = sKeys.length;
		searchKeys = new int[numKeys];
		for (int i=0; i<numKeys; i++) {
			searchKeys[i] = sKeys[i];
		}
		tupleList = new ArrayList();
		numTuples = 0;
	}
	public int[] getSearchKeys() {
		return searchKeys;
	}
	public int getNumTuples() {
		return numTuples;
	}
	public ArrayList getTupleList() {
		return tupleList;
	}
	public void insertTuple(XATTuple tuple) {
		tupleList.add(tuple);
		numTuples ++;
	}
	public void clearTupleList() {
		tupleList.clear();
		numTuples = 0;
	}
	public boolean ifMatch(int[] sKeys) {
		int numKeys = sKeys.length;
		for (int i=0; i<numKeys; i++) {
			if (searchKeys[i] != sKeys[i])
				return false;
		}
		return true;
	}
}
