
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

/*
 * Created on Jan 2, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
//adapted 6/08 by KWorks

package edu.wpi.cs.dsrg.STeM.Partition.IMPIndex;

import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorStateImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public abstract class WindowGroupbyIndex extends OperatorStateImp {
	int numGroupAttrs;
	int[] groupAttrPosArray;
	long window;
	int totalNumTuples;
	int maxTotalNumTuples;

	public WindowGroupbyIndex() {
		totalNumTuples = 0;
	}
	public abstract void insertTuple(XATTuple tuple);
	public abstract void insertTupleByTime(XATTuple tuple);
	public abstract Vector probe(XATPunct query);
	//public abstract void removeExpiredTuples(long windowStart);
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState#copyStateContent(edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState)
	 */
	public void copyStateContent(OperatorState newstate) {
		// TODO Auto-generated method stub

	}
	public int[] getGroupAttrPosArray() {
		return groupAttrPosArray;
	}
	public void setGroupAttrPosArray(int[] gAttrPosArray) {
		numGroupAttrs = gAttrPosArray.length;
		groupAttrPosArray = new int[numGroupAttrs];
		for (int i=0; i<numGroupAttrs; i++) {
			groupAttrPosArray[i] = gAttrPosArray[i];
		}
	}
	public long getWindow() {
		return window;
	}
	public void setWindow(long w) {
		window = w;
	}
	public int getMaxNumTuples() {
		return maxTotalNumTuples;
	}
	public void setMaxNumTuples(int maxNTuples) {
		maxTotalNumTuples = maxNTuples;
	}
	public boolean exceedCapacity() {
		if (totalNumTuples > maxTotalNumTuples) {
			return true;
		} else {
			return false;
		}
	}
	public int getTotalNumTuples() {
		return totalNumTuples;
	}
}
