/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

/*
 * Created on Feb 17, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.STeM.Partition.IMPIndexHeuristic;

import java.util.Vector;

import edu.wpi.cs.dsrg.STeM.Partition.IMPIndexHeuristic.*;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ExhaustiveEnum extends QueryBasedPartitionHeuristic {
	public ExhaustiveEnum() {
		super();
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.pullbasedgroupbyheuristics.PartitionHeuristics#computeOptimalConfigs()
	 */
	
	public void computeOptimalConfig() 
	{
		//initialize optimalConfig 
		int[] bitsNoIndex = new int[numAttrs];
		for (int i=0; i<numAttrs; i++) 
		{
			bitsNoIndex[i] = 0;
		}
		optimalConfig = new IndexConfig(bitsNoIndex, computeNoIndexCost());
		
		
		numConsideredAttrs = numAttrs;
		
		buildIndexConfigs();
		
		for (int i=0; i<numAttrs; i++) 
		{
//			System.out.println("i ="+i);
			IndexConfig[] ics = configGroups[i][numBits].getConfigs();
			int numConfigs = ics.length;
//			System.out.println("numConfigs ="+numConfigs);
			
			for (int j=0; j<numConfigs; j++) 
			{
				IndexConfig ic = ics[j];
//				System.out.println("ic "+ic.toString());
				arrangeCost(ic);
			}
		}
		
		// for debugging purposes
		System.out.println("# Configs Checked: "+numConfigsChecked);
	}
	
	public void optimizedComputeOptimalConfig() {
		computeOccurrenceWeight();
		for (int i=0; i<numAttrs; i++) {
			if (occurrenceWeight[i]>0) {
				consideredAttrs[numConsideredAttrs] = i;
				numConsideredAttrs ++;
			}
		}
		//initialize optimalConfig 
		int[] bitsNoIndex = new int[numAttrs];
		for (int i=0; i<numAttrs; i++) {
			bitsNoIndex[i] = 0;
		}
		optimalConfig = new IndexConfig(bitsNoIndex, computeNoIndexCost());
		
		if (numConsideredAttrs == 0) {
			return;
		}
		//construct index configs
		OptimizedBuildIndexConfigs();
		for (int i=0; i<numConsideredAttrs; i++) 
		{
			IndexConfig[] ics = configGroups[i][numBits].getConfigs();
			int numConfigs = ics.length;
			for (int j=0; j<numConfigs; j++) 
			{
				IndexConfig ic = ics[j];
				int[] icBits = ic.getNumBits();
				boolean skip = false;
				

				for (int k=i; k<i; k++) 
				{
					if (icBits[consideredAttrs[k]]>numBitsLimits[consideredAttrs[k]]) 
					{
						skip = true;
						break;
					}
				}
				
				if (!skip) 
				{
					//System.out.println(ic);
					arrangeCost2(ic);
					//arrangeCost(ic);
				}
			}
			for (int j=0; j<=i; j++) {
				numBitsLimits[consideredAttrs[j]] = optimalConfig.getNumBits()[consideredAttrs[j]];				
			}
		}
		// for debugging purposes
		//System.out.println("# Configs Checked: "+numConfigsChecked);
	} 
	

	protected void buildIndexConfigs() 
	{
		configGroups = null;		
		configGroups = new IndexConfigGroup[numAttrs][numBits+1];
		
		for (int i=0; i<=numBits; i++) 
		{
			int[] bitsAssigned = new int[numAttrs];
			for (int k=0; k<numAttrs; k++) 
			{
				bitsAssigned[k] = 0;
			}
			bitsAssigned[0] = i;
			IndexConfig ic = new IndexConfig(bitsAssigned);
			IndexConfig[] ics = new IndexConfig[] {ic};
			IndexConfigGroup icg = new IndexConfigGroup(ics);
			configGroups[0][i] = icg;
		}
		
		for (int i=1; i<numAttrs; i++) 
		{
			for (int j=0; j<=numBits; j++) 
			{
				Vector newConfigs = new Vector();
				for (int k=0; k<j; k++) 
				{
					for (int p=0; p<i; p++) 
					{
						IndexConfig[] cfg = configGroups[p][k].getConfigs();
						int nConfigs = cfg.length;
						for (int l=0; l<nConfigs; l++) 
						{
							int[] numBitsArray = cfg[l].getNumBits();
							int[] newNumBitsArray = new int[numAttrs];
							for (int m=0; m<numAttrs; m++) {
								newNumBitsArray[m] = numBitsArray[m];
//								System.out.print(numBitsArray[m]+"-");
							}
//							System.out.println();
							
//							int[] newNumBitsArray = cfg[l].getNumBits().clone();
							newNumBitsArray[i] = j-k;
							IndexConfig newcfg = new IndexConfig(newNumBitsArray);
							
							
							//arrangeCost(newcfg);
							
							newConfigs.add(newcfg);
						}
					}
				}
				IndexConfigGroup newicg = new IndexConfigGroup((IndexConfig[])newConfigs.toArray(new IndexConfig[]{}));
				configGroups[i][j] = newicg;
			}
		}
		
	}
	
	protected void OptimizedBuildIndexConfigs() {
		configGroups = new IndexConfigGroup[numConsideredAttrs][numBits+1];
		for (int i=0; i<=numBits; i++) {
			int[] bitsAssigned = new int[numAttrs];
			for (int k=0; k<numAttrs; k++) {
				bitsAssigned[k] = 0;
			}
			bitsAssigned[consideredAttrs[0]] = i;
			IndexConfig ic = new IndexConfig(bitsAssigned);
			IndexConfig[] ics = new IndexConfig[] {ic};
			IndexConfigGroup icg = new IndexConfigGroup(ics);
			configGroups[0][i] = icg;
		}
		for (int i=1; i<numConsideredAttrs; i++) {
			for (int j=0; j<=numBits; j++) {
				Vector newConfigs = new Vector();
				for (int k=0; k<j; k++) {
					for (int p=0; p<i; p++) {
						IndexConfig[] cfg = configGroups[p][k].getConfigs();
						int nConfigs = cfg.length;
						for (int l=0; l<nConfigs; l++) {
							int[] numBitsArray = cfg[l].getNumBits();
							int[] newNumBitsArray = new int[numAttrs];
							for (int m=0; m<numAttrs; m++) {
								newNumBitsArray[m] = numBitsArray[m];
							}
							newNumBitsArray[consideredAttrs[i]] = j-k;
							IndexConfig newcfg = new IndexConfig(newNumBitsArray);
							newConfigs.add(newcfg);
						}
					}
				}
				IndexConfigGroup newicg = new IndexConfigGroup((IndexConfig[])newConfigs.toArray(new IndexConfig[]{}));
				configGroups[i][j] = newicg;
			}
		}
	}
	
	protected void OptimizedBuildIndexConfigsCost() 
	{
//		System.out.println("start building..");
		
		configGroups = new IndexConfigGroup[numConsideredAttrs][numBits+1];
		for (int i=0; i<=numBits; i++) 
		{
			int[] bitsAssigned = new int[numAttrs];
			for (int k=0; k<numAttrs; k++) 
			{
				bitsAssigned[k] = 0;
			}
			bitsAssigned[consideredAttrs[0]] = i;
			IndexConfig ic = new IndexConfig(bitsAssigned);
			IndexConfig[] ics = new IndexConfig[] {ic};
			IndexConfigGroup icg = new IndexConfigGroup(ics);
			configGroups[0][i] = icg;
		}
		
		for (int i=1; i<numConsideredAttrs; i++) 
		{
			for (int j=0; j<=numBits; j++) 
			{
				Vector newConfigs = new Vector();
				for (int k=0; k<j; k++) 
				{
					for (int p=0; p<i; p++) 
					{
						IndexConfig[] cfg = configGroups[p][k].getConfigs();
						int nConfigs = cfg.length;
						for (int l=0; l<nConfigs; l++) 
						{
//							int[] numBitsArray = cfg[l].getNumBits();
//							int[] newNumBitsArray = new int[numAttrs];
//							for (int m=0; m<numAttrs; m++) {
//								newNumBitsArray[m] = numBitsArray[m];
//							}
							
							int[] newNumBitsArray =cfg[l].getNumBits().clone();
							
							newNumBitsArray[consideredAttrs[i]] = j-k;
							IndexConfig newcfg = new IndexConfig(newNumBitsArray);
							newConfigs.add(newcfg);
							
							//check cost
							boolean skip = false;
							
							for (int q=0; q<i; q++) 
							{
								if (newcfg.getNumBits()[consideredAttrs[q]]>numBitsLimits[consideredAttrs[q]]) 
								{
									skip = true;
									break;
								}
							}
							if (!skip) 
							{							
								arrangeCost2(newcfg);
							}
							
						}
					}
					
				}
				IndexConfigGroup newicg = new IndexConfigGroup((IndexConfig[])newConfigs.toArray(new IndexConfig[]{}));
				configGroups[i][j] = newicg;
				
				newConfigs = null; 

			}
		}
//		System.out.println("done building..");
	}
	
	// The following methods are for debugging purposes, 
	// TO BE REVISED
	/**
	 * only used by printAllCosts, for debugging purposes.
	 * not including query-related hash cost.
	 * @param ic
	 * @return
	 */
	public float computeCost(IndexConfig ic) {
		int[] nBitsAssigned = ic.getNumBits();
		float cost = 0;
		
		for (int i=0; i<EvalQP.size(); i++) 
		{
			int accumulatedBits = 0;
			QueryPattern qp = queryPatterns[EvalQP.get(i)];
			
			int pid = qp.getPatternID();
			
			for (int j=0; j<numAttrs; j++) {
				int mask = (int)Math.pow(2, j);
				
				if ((pid & mask) == mask) {
					accumulatedBits += nBitsAssigned[j];
				}
			}
			
			cost += ((float)qp.weight)/Math.pow(2, accumulatedBits);
		}
		
		numConsideredAttrs = numAttrs;
		return cost;
	}
	
////////////////////////////////////////////
// KEW
	public float computeQueryCost(IndexConfig ic,int nPR, int nBR) {
		int[] nBitsAssigned = ic.getNumBits();
		//System.out.println("numBits="+nBitsAssigned.length);
//		System.out.println(" Length nBitsAssigned[]="+nBitsAssigned.length);
		
		float cost = 0;
		computeOccurrenceWeightOnly();
		
		float coefficient = 1;
		for (int i=0; i<numAttrs; i++) {
			if(occurrenceWeight[i] != 1)
				coefficient *= (1-occurrenceWeight[i]);
//			System.out.println("i="+i+" occurrenceWeight[i]="+occurrenceWeight[i]);
		}
		
		float probeFactor = 1;
		int nBitPos = 0;
		
		for (int k=0; k<numAttrs; k++) 
		{
			float p = occurrenceWeight[k];
			if ((occurrenceWeight[k] > 0) &&(nBitsAssigned[nBitPos]>0))
			{	
//				System.out.println("k="+k+" occurrenceWeight[k]="+occurrenceWeight[k]);
//				System.out.println("nBitPos="+nBitPos);
//				System.out.println(" nBitsAssigned[k]="+nBitsAssigned[k]);
				probeFactor *= (1 + (p/(1-p))/Math.pow(2, nBitsAssigned[k]));
//				System.out.println("k="+k+" nBitsAssigned[nBitPos]="+nBitsAssigned[nBitPos]);
				nBitPos++;
			}
		}
		
		
		//numQueries = # probe tups per window
		numQueries = nPR;
		//stateSize = # build tups per window
		stateSize = nBR;		
		//cost to compare0.000148;
		compareCost=(float)148;;
		
		if(coefficient>0.0)
			cost = numQueries * compareCost * coefficient * probeFactor * stateSize;
		else
			cost = numQueries * compareCost * probeFactor * stateSize;
			
		return cost;
	}
	
	public float computeEstUseQueryCost(IndexConfig ic,int nPR, int nBR, float estUse) {
		int[] nBitsAssigned = ic.getNumBits();
		//System.out.println("numBits="+nBitsAssigned.length);
		
		float cost = 0;
		computeOccurrenceWeightOnly();
		
		float coefficient = 1;
		for (int i=0; i<numAttrs; i++) 
		{
			coefficient *= (1-occurrenceWeight[i]);
//			System.out.println("i="+i+" occurrenceWeight[i]="+occurrenceWeight[i]);
		}
		
		float probeFactor = 1;
		int nBitPos = 0;
		for (int k=0; k<numAttrs; k++) 
		{
			float p = occurrenceWeight[k];
			if ((occurrenceWeight[k] != 0) &&(nBitsAssigned[k]>0))
			{	
//				System.out.println("k="+k+" occurrenceWeight[k]="+occurrenceWeight[k]);
//				System.out.println("nBitPos="+nBitPos);
//				System.out.println(" nBitsAssigned[k]="+nBitsAssigned[k]);
				probeFactor *= (1 + (p/(1-p))/Math.pow(2, nBitsAssigned[k]));
//				System.out.println("k="+k+" nBitsAssigned[nBitPos]="+nBitsAssigned[nBitPos]);
//				System.out.println(" probeFactor="+probeFactor);
				nBitPos++;
			}
		}
		
		
		//numQueries = # probe tups per window
		numQueries = nPR;
		//stateSize = # build tups per window
		stateSize = nBR;		
		//cost to compare
		compareCost = (float)148;
		
		cost = (estUse* numQueries) * compareCost * coefficient * probeFactor * stateSize;
		return cost;
	}
	
	/////////////////////////////	
	public float computetupleCost(int nBR) 
	{
		//cost to hash
		float hashCost = (float)39;
		
		float tupleCost = numTuples * hashCost * numAttrs;
		return tupleCost;
	}	

///////////////////////////////////////////////////////////////	
	public void printAllCosts()
	{
		//buildIndexConfigsOptimal();
		IndexConfig optimalConfig = null;
		float optimalCost = Float.MAX_VALUE;
		for (int i=0; i<numAttrs; i++) {
			for (int k=1; k<=numBits;k++) {
				IndexConfig[] ics = configGroups[i][k].getConfigs();
				int numConfigs = ics.length;
				for (int j=0; j<numConfigs; j++) {
					IndexConfig ic = ics[j];
					float cost = computeCost(ic);
					if (cost < optimalCost) {
						optimalCost = cost;
						optimalConfig = ic;
					}
					System.out.println(ic+"  "+cost);
				}
				System.out.println("--------------------");
			}
		}
		System.out.println("Optimal Config: " + optimalConfig);
		System.out.println("Optimal Cost: " + optimalCost);
	}
	
//	protected void generateConfigs() {
//		int[] currentBits = new int[numAttrs];
//		for (int i=0; i<numAttrs-1; i++) {
//			currentBits[i] = 0;
//		}
//		currentBits[numAttrs-1] = numBits;
//		int attrPos = numAttrs-1;
//		
//		int accumulatedBits = 0;
//		while (!(attrPos==0 && currentBits[0]==numBits)) {
//			while (currentBits[attrPos]<numBits) {
//				currentBits
//			}
//		}
//		
//		Stack bitStack = new Stack();
//		
//		int attrPos = 0;
//		while(true) {
//			while (accumulatedBits<numBits && attrPos<numAttrs) {
//				bitStack.push(new Integer(currentBits[attrPos]));
//				accumulatedBits += currentBits[attrPos];
//			}
//		}
//	}
	
}
