/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

/*
 * Created on Feb 14, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.STeM.Partition.IMPIndexHeuristic;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class IndexConfig {
	int[] numBits;
	float cost;
	
	public IndexConfig() {
		
	}
	
	public IndexConfig(int[] nBits) {
		int numAttrs = nBits.length;
		numBits = new int[numAttrs];
		for (int i=0; i<numAttrs; i++) {
			numBits[i] = nBits[i];
		}
		cost = 0; // cost initialized to 0
	}
	public IndexConfig(int[] nBits, float c) {
		int numAttrs = nBits.length;
		numBits = new int[numAttrs];
		for (int i=0; i<numAttrs; i++) {
			numBits[i] = nBits[i];
		}
		cost = c; // cost initialized to 0
	}

	public int[] getNumBits() {
		return numBits;
	}
	public float getCost() {
		return cost;
	}
	public void setNumBits(int[] nBits) {
		int numAttrs = nBits.length;
		numBits = new int[numAttrs];
		for (int i=0; i<numAttrs; i++) {
			numBits[i] = nBits[i];
		}
	}
	public void setCost(float c) {
		cost = c;
	}
	public String toString() {
		int numElements = numBits.length;
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for (int i=0; i<numElements-1; i++) {
			sb.append(numBits[i]+", ");
		}
		sb.append(numBits[numElements-1]+"]");
		return sb.toString();
	}
}
