/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

/*
 * Created on Feb 17, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.STeM.Partition.IMPIndexHeuristic;

import java.io.BufferedWriter;
import java.io.FileWriter;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class IndexSelectionAlgorithm {
	PartitionHeuristic heuristic;
	
	public IndexSelectionAlgorithm() {
	}
	
	public void init(String className, String configFile, float cCost, float hCost, 
			float nTuples, float nQueries, float window) {
		try {
			heuristic = (PartitionHeuristic)Class.forName("edu.wpi.cs.dsrg.xmldb.xat.common.operator.pullbasedgroupbyheuristics."+className).newInstance();
		} catch(Exception e) {
			e.printStackTrace();
		}
		heuristic.init(configFile, cCost, hCost, nTuples, nQueries, window);
	}
	
	public void run(){
//		float noIndexCost = heuristic.computeNoIndexCost();
//		System.out.println(noIndexCost);
		long startTime = System.currentTimeMillis();
		heuristic.computeNumConfigs();
		//heuristic.optimizedComputeOptimalConfig();
		//heuristic.computeOptimalConfig();
		long execTime = System.currentTimeMillis() - startTime;
		IndexConfig optCfg = heuristic.getOptimalConfig();
		
		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter("indexselectionstat", true));
			writer.write(optCfg+" "+optCfg.getCost()+" "+execTime+" "+heuristic.getNumConfigsChecked()+"\n");
			//writer.write(optCfg.getCost()+" "+execTime+" "+heuristic.getNumConfigsChecked()+"\n");
			writer.flush();
			writer.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
//		System.out.println("Optimal Config: " + optCfg);
//		System.out.println("Optimal Cost: " + optCfg.getCost());
//		System.out.println("Execution time: " + execTime);
	}
	
	public static void main(String[] args) {
		String heuristicClass = args[0];
		String configFile = args[1];
		float cCost = Float.parseFloat(args[2]);
		float hCost = Float.parseFloat(args[3]);
		float nTuples = Float.parseFloat(args[4]);
		float nQueries = Float.parseFloat(args[5]);
		float window = Float.parseFloat(args[6]);
		IndexSelectionAlgorithm algo = new IndexSelectionAlgorithm();
		algo.init(heuristicClass, configFile, cCost, hCost, nTuples, nQueries, window);
		algo.run();
	}
}
