/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

/*
 * Created on Feb 12, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.STeM.Partition.IMPIndexHeuristic;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ProbeCostComputation {
	int numItems = 0;
	int[] numerators;
	int[] denominators;
	
	public void setNumerators(int[] nums) {
		if (numItems == 0) {
			numItems = nums.length;
		}
		numerators = new int[numItems];
		for (int i=0; i<numItems; i++) {
			numerators[i] = nums[i];
		}
	}
	
	public void setDenominators(int[] denoms) {
		if (numItems == 0) {
			numItems = denoms.length;
		}
		denominators = new int[numItems];
		for (int i=0; i<numItems; i++) {
			denominators[i] = denoms[i];
		}
	}
	
	public float compute() {
		float sum = 0;
		for (int i=0; i<numItems; i++) {
			sum += ((float)numerators[i]/(float)denominators[i]);
		}
		return sum;
	}
	
	public static void main(String[] args) {
		int nArgs = args.length;
		int nItems = nArgs/2;
		int[] nums = new int[nItems];
		int[] denoms = new int[nItems];
		int cursor = 0;
		int index = 0;
		while (cursor < nItems) {
			nums[index] = Integer.parseInt(args[cursor]);
			index ++;
			cursor ++;
		}
		index = 0;
		while (cursor < nArgs) {
			denoms[index] = Integer.parseInt(args[cursor]);
			index ++;
			cursor ++;
		}
		
		ProbeCostComputation cost = new ProbeCostComputation();
		cost.setNumerators(nums);
		cost.setDenominators(denoms);
		//System.out.println(cost.compute());
	}
}
