/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

/*
 * Created on Feb 17, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.STeM.Partition.IMPIndexHeuristic;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class QCLeadingHeuristic extends QueryBasedPartitionHeuristic {
	boolean[] queryCovered;
	float[] queryCoverage;

	public QCLeadingHeuristic() {
		super();
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.pullbasedgroupbyheuristics.PartitionHeuristics#computeOptimalConfigs()
	 */
	public void computeOptimalConfig() {
		//initialize optimalConfig 
		int[] bitsNoIndex = new int[numAttrs];
		for (int i=0; i<numAttrs; i++) {
			bitsNoIndex[i] = 0;
		}
		float noIndexCost =  computeNoIndexCost();
		optimalConfig = new IndexConfig(bitsNoIndex, noIndexCost);
		
		queryCovered = new boolean[numQueryPatterns];
		for (int i=0; i<numQueryPatterns; i++) {
			queryCovered[i] = false;
		}
		computeOccurrenceWeight();
		queryCoverage = new float[numAttrs];
		for (int i=0; i<numAttrs; i++) {
			queryCoverage[i] = occurrenceWeight[i];
		}
		while (numNonConsideredAttrs > 0) {
			int attrID = nextAttrWithMaxQC();
			if (attrID == -1) {
				break;
			}
			updateQueryCoverage(attrID);
			buildIndexConfigs(attrID);
			IndexConfig[] indexConfigs = configGroups[numConsideredAttrs][numBits].getConfigs();
			int numIndexConfigs = indexConfigs.length;
			boolean betterConfigFound = false;
			for (int j=0; j<numIndexConfigs; j++) {
				IndexConfig ic = indexConfigs[j];
				if (arrangeCost(ic)) {
					betterConfigFound = true;
				}
			}
			if (!betterConfigFound) {
				break;
			}
			consideredAttrs[numConsideredAttrs] = attrID;
			numConsideredAttrs ++;
			updateNonConsideredAttrs(attrID);
		}
		//System.out.println("# Configs Checked: "+numConfigsChecked);
	}
	public void optimizedComputeOptimalConfig() {
		//initialize optimalConfig 
		int[] bitsNoIndex = new int[numAttrs];
		for (int i=0; i<numAttrs; i++) {
			bitsNoIndex[i] = 0;
		}
		float noIndexCost =  computeNoIndexCost();
		optimalConfig = new IndexConfig(bitsNoIndex, noIndexCost);
		
		queryCovered = new boolean[numQueryPatterns];
		for (int i=0; i<numQueryPatterns; i++) {
			queryCovered[i] = false;
		}
		computeOccurrenceWeight();
		queryCoverage = new float[numAttrs];
		for (int i=0; i<numAttrs; i++) {
			queryCoverage[i] = occurrenceWeight[i];
		}
		while (numNonConsideredAttrs > 0) {
			int attrID = nextAttrWithMaxQC();
			if (attrID == -1) {
				break;
			}
			updateQueryCoverage(attrID);
			buildIndexConfigs(attrID);
			IndexConfig[] indexConfigs = configGroups[numConsideredAttrs][numBits].getConfigs();
			int numIndexConfigs = indexConfigs.length;
			boolean betterConfigFound = false;
			for (int j=0; j<numIndexConfigs; j++) {
				IndexConfig ic = indexConfigs[j];
				int[] icBits = ic.getNumBits();
				boolean skip = false;
				for (int k=0; k<numConsideredAttrs; k++) {
					if (icBits[consideredAttrs[k]]>numBitsLimits[consideredAttrs[k]]) {
						skip = true;
						break;
					}
				}
				if (!skip) {
					if (arrangeCost(ic)) {
						betterConfigFound = true;
					}
				}
			}
			if (!betterConfigFound) {
				break;
			}
			consideredAttrs[numConsideredAttrs] = attrID;
			for (int j=0; j<=numConsideredAttrs; j++) {
				numBitsLimits[consideredAttrs[j]] = 
					optimalConfig.getNumBits()[consideredAttrs[j]];
			}
			numConsideredAttrs ++;
			updateNonConsideredAttrs(attrID);
		}
		//System.out.println("# Configs Checked: "+numConfigsChecked);
	}
	protected void updateQueryCoverage(int attrID) {
		int[] occurredPatterns = occurredPatternID[attrID];
		for (int i=0; i<numPatternOccurred[attrID]; i++) {
			int patternID = occurredPatterns[i];
			if (!queryCovered[patternID]) {
				queryCovered[patternID] = true;

				queryCoverage[attrID] -= queryPatterns[patternID].getWeight();;

//				int nAttrOccurred = numAttrOccurred[patternID];
//				for (int j=0; j<nAttrOccurred; j++) {
//					queryCoverage[occurredAttrID[patternID][j]] -= queryPatterns[patternID].getWeight();;
//				}
			}
		}
	}
	
	protected int nextAttrWithMaxQC() {
		int attrWithMaxQC = ((Integer)nonConsideredAttrs.get(0)).intValue();
		float maxQC = queryCoverage[attrWithMaxQC];
		for (int i=1; i<numNonConsideredAttrs; i++) {
			int nextAttrID = ((Integer)nonConsideredAttrs.get(i)).intValue();
			float nextQC = queryCoverage[nextAttrID];
			if (nextQC > maxQC) {
				attrWithMaxQC = nextAttrID;
				maxQC = nextQC;
			}
		}
		if (maxQC == 0) {
			return -1;
		} else {
			return attrWithMaxQC;
		}
	}

}
