/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.STeM.Partition;

import java.io.Serializable;
import java.util.ArrayList;

import edu.wpi.cs.dsrg.STeM.Partition.IMPIndex.PriorityHashTreeIndex;
import edu.wpi.cs.dsrg.eddyBatch.datastructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

public interface Partition
{
// this is the partition index item that is stored in the partition list
	
	//partition number
	public int getPartitionNumber();
	public void setPartitionNumber(int PN);
	
	//last tuple in partition
	public EddyQueue.Node getFirstTupleinPartition();
	public void setFirstTupleinPartition(EddyQueue.Node EQ);
	
	//Index associated with partition
	public ArrayList<Integer> getHashKeys();
	public void setHashKeys(ArrayList<Integer> Index);
	public void setIMPIndex(PriorityHashTreeIndex Index);
	public PriorityHashTreeIndex getIMPIndex();
	
	
}
