/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.STeM.Partition;

import java.io.Serializable;
import java.util.ArrayList;

import edu.wpi.cs.dsrg.STeM.Partition.IMPIndex.PriorityHashTreeIndex;
import edu.wpi.cs.dsrg.eddy.datastructure.EddyQueue.Node;
import edu.wpi.cs.dsrg.eddyBatch.datastructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

//Karen Works

//This structure stores the bits and performs 
// bit operations

public class PartitionImp implements Partition, Serializable
{
	//partition number
	private int PartitionNumber;
	
//	//last tuple stored
	private EddyQueue.Node FirstTupleinPartition;
	
	//HashKeyIndex
	private ArrayList<Integer> HashKeys;
	
	//IMP Index
	PriorityHashTreeIndex IMPIndex;

	
	/**
	 * constructor comment.
	 */
	int Size; // Number of bits
	
	public PartitionImp() 
	{
		super();
		
		//Init Vars
		PartitionNumber = 0;
		FirstTupleinPartition = null;
		HashKeys = null;
		IMPIndex = null;
	}

	/**
	 * constructor comment.
	 */

	public PartitionImp(int pn,EddyQueue.Node eq,ArrayList<Integer> Indexs) 
	{
		super();
		
		//init Vars
		PartitionNumber = pn;
		FirstTupleinPartition = eq;
		HashKeys = (ArrayList<Integer>)Indexs.clone();
		IMPIndex = null;
	}
	
	public PartitionImp(int pn,EddyQueue.Node eq,PriorityHashTreeIndex Index) 
	{
		super();
		
		//Init Vars
		PartitionNumber = pn;
		FirstTupleinPartition = eq;
		IMPIndex = Index;
	}

	
/**********************************************/
	
	/* Partition Number */
	/**
	 * returns PartitionNumber
	 */

	public int getPartitionNumber()
	{
		return PartitionNumber;
	}

	/**
	 * set PartitionNumber
	 */

	public void setPartitionNumber(int PN)
	{
		PartitionNumber = PN;
	}

	/* LastTupleinPartition */
	/**
	 * returns LastTupleinPartition
	 */
	
////////////////////////////////////////
	public EddyQueue.Node getFirstTupleinPartition()
	{
		return FirstTupleinPartition;
	}

	/**
	 * set LastTupleinPartition
	 */

	public void setFirstTupleinPartition(EddyQueue.Node EQ)
	{
		FirstTupleinPartition = EQ;
	}
	
///////////////////////////////////	
	/* HashKeyIndex */
	/**
	 * returns HashKeyIndex
	 */

	public ArrayList<Integer> getHashKeys()
	{
		return HashKeys;
	}

	/**
	 * set HashKeyIndex
	 */

	public void setHashKeys(ArrayList<Integer> Index)
	{
		HashKeys = Index;
	}
	

	/**
	 * set IMPIndex
	 */

	public void setIMPIndex(PriorityHashTreeIndex Index)
	{
		IMPIndex = Index;
	}
	
	/**
	 * get IMPIndex
	 */

	public PriorityHashTreeIndex getIMPIndex()
	{
		return IMPIndex;
	}
	
///////////////////////////////////
	public void setLastTupleinPartition(Node EQ) {
		// TODO Auto-generated method stub
		
	}

///////////////////////////////////
	public double getEstimatedUsage(int EPN, int CPN) {
		// TODO Auto-generated method stub
		
		int EU = (PartitionNumber-EPN+1)/(CPN-EPN+1);
		return EU;
	}
/**********************************************/
	
	
}

