/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.STeM;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATMultiQueueStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATMultiQueueWindowStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.execution.OperatorLookUp;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

import java.util.ArrayList;
import java.util.HashMap;
import edu.wpi.cs.dsrg.eddy.datastructure.*;
import edu.wpi.cs.dsrg.eddy.operator.EddyOperator;

import java.util.Iterator;

//Karen Works

//This is the STEM operator 

public interface STeMJoinProbeOperator extends XATMultiQueueWindowStreamOperator{
	public void SetIsEddyOp(boolean b);

	//Info about probe
	public int getProbeSTREAMId();
	public void SetProbeSTREAMId(int i);
	public ArrayList<Integer> getNumTupleIndex();
	public void SetNumTupleIndex(String val);

	//Info about stored stem data
	public int getDataSTREAMId();
	public void SetDataSTREAMId(int i);
	public ArrayList<Integer> getNumSTeMIndex();
	public void SetNumSTeMIndex(String val);
	public void SetSTeMDataIndexArrayPos(int i);
	public int getSTeMDataIndexArrayPos();

	// table for look up operators used by QMesh
	public void setOperatorLookUp(OperatorLookUp z);
	
	//operator id used for QMesh
	public void setQMeshOperatorID(int id);
	public int getQMeshOperatorID();

}
