/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.eddy.datastructure;

import java.util.BitSet;
import java.io.Serializable;
//Karen Works

//This structure stores the bits and performs 
// bit operations

public class BitStructure implements Serializable
{
	private BitSet Bits;
	/**
	 * constructor comment.
	 */
	int Size; // Number of bits
	
	public BitStructure() 
	{
		super();
		Bits = null;
	}

	/**
	 * constructor comment.
	 */
	public BitStructure(int sz) 
	{
		super();
		Bits = new BitSet(sz);
		Size = sz;
	}
	
	/**
	 * count number of completed bits.
	 */

	public int countNumCompletedBits() 
	{
		System.out.println("Bits.cardinality()="+Bits.cardinality());

		if (Bits != null) {
			return Bits.cardinality();
	   } else {
		//hello
		System.out.println("tuple is null");
		return 0;
	  }
	}

	/**
	 * returns bitset
	 */

	public BitSet getBits()
	{
		return Bits;
	}
	
	
	/**
	 * convert bits to string
	 */
	public String getSetBitsToString() {
		if (Bits != null) {
		   return Bits.toString();
	    } else {
		   //hello
		   System.out.println("tuple is null");
			return "";
	    }
	}

	/**
	 * Set a specific bit 
	 */
	public void set(int indx) {
		if (Bits != null) {

			Bits.set(indx,true);
			//System.out.println(Bits.toString());
			
	    } else {
		   //hello
		   System.out.println("tuple is null");
	    }
	}

	/**
	 * Clear out a specific bit 
	 */
	public void clear(int indx) {
		if (Bits != null) {
			Bits.clear(indx);		
	    } else {
		   System.out.println("tuple is null");
	    }
	}
	/**
	 * clear out all bits
	 */
	public void clear() {
	  if (Bits != null) {
		   for(int i = 0; i < Bits.length(); i++) {
			Bits.clear();
		   }
		
	  } else {
		System.out.println("tuple is null");
	  }
	}

	/**
	 * Test to see if single query is All Done
	 */
	public boolean AllDone() {
	  if (Bits != null) {
			System.out.println("Size"+Size);
		
		if (Bits.cardinality() == Size)
		{
			return true;	
		}
		else
		{
			return false;
		}
		
	}
     else {
    	 System.out.println("tuple is null");
    	 return false;
    }
  }
	
	/* returns the first not set */
	public int FirstNotCompleted() {
	  return Bits.nextClearBit(1);
	}

	/**
	 * returns the firstbit set to true
	 */
	public int FirstReady() {
	  return Bits.nextSetBit(0);
	}

	
	/**
	 * creates a copy from a bitset
	 */
	public void CreateCopyFrom(BitSet bs) 
	{
		Bits  = (BitSet)bs.clone();
	}

	/**
	 * returns the number of bits
	 */
	public int getSize()
	{
		return Bits.length();
	}
}

