/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.eddy.datastructure;


import java.io.Serializable;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;

import java.util.ArrayList;
import java.util.BitSet;
import java.util.Calendar;
import java.util.Date;
import java.util.Hashtable;

//Karen Works

//This structure stores the information associated with 
//an eddy tuple and eddy tuple operations.

public interface EddyTuple extends XATTuple
{
	public int NumDoneBitsComplete();
	public boolean isDone();
	public void SetDoneBit(int pos);
	public void ClearReadyBit(int pos);
	
	public int NextNotDoneOp();
	public int NextReadyOp();
	public int NextReadyOpTicket(ArrayList<Double> OperatorTickets);
	public int NextReadyOpCBR(Hashtable operatorStreamClassifierAttribute, int streamID);
	
	public Date GetCreationDate();
	public XATTuple getTuple(int pos);
	public void addTuple(int pos,XATTuple t);
	public int getNumTuplesInAnswer();
	public BitStructure getDoneBitSet();
	public BitStructure getReadyBitSet();
	public int getSize();
	public void setDoneBitSet(BitSet bs);
	public void setReadyBitSet(BitSet bs);
	public XATTuple[] getAnswer();
	public void setAnswer(XATTuple[] a);

	
}
