//--------------------------------------------------
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

// CBROperatorProfileEntry.java
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2008
//--------------------------------------------------

package edu.wpi.cs.dsrg.eddy.operator;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Hashtable;

public class CBROperatorProfileEntry 
{
	private boolean hasClassifierAttribute;
	private Hashtable hashClassifierAttributeDetailedSelectivities;
	private double overallSelectivity = 0.0; 
	private int classifierAttributeIndex = -1; //index of the classifying attribute in the schema of the stream
	
    public CBROperatorProfileEntry(boolean hasClassifierAttributeVal,
    							   int classifierAttributeIndexVal,
    							   Hashtable hashClassifierAttributeDetailedSelectivitiesVal,
    							   double overallSelectivityVal)
    {
    	hasClassifierAttribute = hasClassifierAttributeVal;
    	if (hasClassifierAttribute)
    	{
    		classifierAttributeIndex = classifierAttributeIndexVal;
    		hashClassifierAttributeDetailedSelectivities = hashClassifierAttributeDetailedSelectivitiesVal;
    	}
    	else
    	{
    		overallSelectivity = overallSelectivityVal;
    	}    	    	
    }

	public double getOverallSelectivity()
	{
		return overallSelectivity;		
	}
	
	public Hashtable getHashClassifierAttributeDetailedSelectivities()
	{
		return hashClassifierAttributeDetailedSelectivities;		
	}
	
	public boolean getHasClassifierAttribute()
	{
		return hasClassifierAttribute;		
	}
	
	public int getClassifierAttributeIndex()
	{
		return classifierAttributeIndex;		
	}	
}
