/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.eddyBatch.datastructure;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Random;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;

//Karen Works

//This structure stores the information associated with 
//an eddy tuple and eddy tuple operations.

public class EddyActiveProcTupleImp extends XATTupleImp implements EddyActiveProcTuple, Serializable
{
	//Count Active Proc Tups
	private HashMap <Integer,Integer> PartitionProcTupCount;
	
	//for testing only
	//public String strOps;
	
	public EddyActiveProcTupleImp() 
	{ //throws XATTimeStampException {
		super();
	}

	public EddyActiveProcTupleImp(HashMap <Integer,Integer> P) 
	{ //throws XATTimeStampException {
		super();
		PartitionProcTupCount = P;
	}
	////////////////////////////////////////////////////////
	// returns the PartitionProcTupCount
	public HashMap <Integer,Integer> GetPartitionProcTupCount(){
		return PartitionProcTupCount;
		
	}

	// sets the PartitionProcTupCount
	public void PartitionProcTupCount(HashMap <Integer,Integer> P){
		PartitionProcTupCount = P;		
	}

	
}

