/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.eddyBatch.operator;

import java.util.ArrayList;
import java.util.BitSet;
import java.util.HashMap;

import edu.wpi.cs.dsrg.STeM.STeMData;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATSingleQueueStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATMultiQueueStreamOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATSingleQueueStreamOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATMultiQueueWindowStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATMultiQueueWindowStreamOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
//Karen Works

//This is the eddy operator 

public interface EddyPartitionOperator extends XATMultiQueueWindowStreamOperator{
//public interface EddyOperator extends XATSingleQueueStreamOperator{
	void setNumStreams(int Ns);
	void setNumOps(int NOps);
	void setOpStringIds(int OpId, String val);
	void setRouter(String val);
	void InitializeVariables();
	
	/**
	 * @return
	 */
	ExpressionStr getExpression();
	/**
	 * @param expression
	 */
	
	void setExpression(ExpressionStr expression);
	ArrayList<BitSet> getPreFilledPerStream();

	// adapting indice?
	public void setAdaptingIndice(boolean val);
	public boolean getAdaptingIndice();
	
	//sets the maximum partition size
	public void setMaxPartitionSize(int val);
	public int getMaxPartitionSize();
	
	//sets the partition window size
	public void setMaxPartitionWindowSize(int val);
	public int getMaxPartitionWindowSize();
	
	//is partitioned?
	public void setIsPartitioned(boolean val);
	public boolean getIsPartitioned();

	//use IMPIndex? No - hash index
	public void setUseIMPIndex(boolean val);
	public boolean getUseIMPIndex();
	
	//sets the Number of Limited Indices
	public void setNumLimitedIndices(int val);
	public int getNumLimitedIndices();
	
	//migration strategy
	public void setNoMigration(boolean val);
	public void setSymmetricMigration(boolean val);	
	public void setPartitionMigration(boolean val);
	public boolean getNoMigration();
	public boolean getSymmetricMigration();	
	public boolean getPartitionMigration();

/////////////////////////////////////////////////////////
//	SRIA
	public void setSRIA(boolean val);
	public boolean getSRIA();
	
	public void setHH(boolean val);
	public boolean getHH();
	
	public void setHHErrorRate(double val);
	public double getHHErrorRate();
	
	public void setCostFactorSignificance(double val);
	public double getCostFactorSignificance();
	
	////////////////////////////////////////////
	//Combined stats ?
	public void setCombinedStats(boolean val);
	public boolean getCombinedStats();
	
	public void setNumCombinedStats(int val);
	public int getNumCombinedStats();

	public void setCombinedStatsFactor(double[] val);
	public double[] getCombinedStatsFactor();
	/*****************************************/
	//Index Selection trigger
//	public void setNoIndexSelectionTrigger(boolean val);
//	public boolean getNoIndexSelectionTrigger();
//
//	public void setCostIncrIndexSelectionTrigger(boolean val);
//	public boolean getCostIncrIndexSelectionTrigger();
//
//	public void setFreqIncrIndexSelectionTrigger(boolean val);
//	public boolean getFreqIncrIndexSelectionTrigger();
//
//	public void setCombinedIncrIndexSelectionTrigger(boolean val);
//	public boolean getCombinedIncrIndexSelectionTrigger();
		
	public void setDegreeCostIncr(double val);
	public double getDegreeCostIncr();

	public void setDegreeFreqIncr(double val);
	public double getDegreeFreqIncr();
	
}
