/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-1-24
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.dag;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;;
/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public interface XATCommandMsg extends XATTuple {

	public static final int OBJECT_TYPE_ID = 208; // 0xd0, i.e. "do"
	public static final int PASS_TOKEN = 1; //Expects target machine ID (String type) or the string "YOU" as arg
											//"YOU" will give the token to any machine that is listening.
	public static final int TERMINATE_STREAM = 2; //Expects target IP:Port (String) as arg
	public static final int SET_INPUT_SCHEMA = 3; //Expects schema string (hash-separated values)
	public static final int SET_MERGE_TYPE = 4; //Expects symbolic int representing merge type. See SpreadfireMergeOperator.java for details

	
	//public static final int NO = 0;
	//public static final int YES = 1;
	//public static final int IGNORE = 2;

	public int getCommandType(int pos);
	public XATDataValue getCommandArgs(int pos);
	public void setCommandType(int pos, int type);
	public void setCommandArgs(int pos, XATDataValue args);
	public void setCommand(int pos, int type, XATDataValue args);
	public int[] getCommandTypeArray() ;
	public XATDataValue[] getCommandArgsArray();
	public void setCommandTypeArray(int[] pTypeArray);
	public void setCommandArgsArray(XATDataValue[] pArgsArray);
	public long getInvalidTime();
	public void setInvalidTime(long iTime);
	//public int getMesgType();  -- I don't think I'll have need for these -BM
	//public void setMesgType(int mesgType);
	
	/**
	 * Sped-up identification functions for typing.
	 * Use instead of (<I>object</I> instanceof XATCommandMsg) due to running at tuple granularity.
	 */
	public int getObjTypeID();
}
