/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-4-6
 * based on XATPunctImp from Luping Ding
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.dag;

import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
//import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;

/**
 * @author bmombe1
 * based on code by lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class XATCommandMsgImp extends XATTupleImp implements XATCommandMsg {

	protected int[] cmdTypeArray = null;
	protected XATDataValue[] cmdArgsArray = null; 
	protected long invalidTime = Long.MAX_VALUE;
	protected int mesgType = XATPunct.NO;

	public XATCommandMsgImp() {
		super();
		this.objTypeID = 208;  // Hex code 0xd0, i.e. "do"
	}
	
	public XATCommandMsgImp(XATDataValue[] array) {
		super(array);
		this.objTypeID = 208;
	}
	
	public XATCommandMsgImp(int length) {
		super(length);
		this.objTypeID = 208;
	}
	
	public XATCommandMsgImp(List list) {
		super(list);
		this.objTypeID = 208;
	}

	public int getCommandType(int pos) {
		return cmdTypeArray[pos];
	}

	public XATDataValue getCommandArgs(int pos) {
		return cmdArgsArray[pos];
	}
	
	public void setCommandType(int pos, int type) {
		cmdTypeArray[pos] = type;
	}

	public void setCommandArgs(int pos, XATDataValue args) {
		cmdArgsArray[pos] = args;
	}
	
	public void setCommand(int pos, int type, XATDataValue args) {
		cmdTypeArray[pos] = type;
		cmdArgsArray[pos] = args;
	}

	public int[] getCommandTypeArray() {
		return cmdTypeArray;
	}

	public XATDataValue[] getCommandArgsArray() {
		return cmdArgsArray;
	}
	
	public long getInvalidTime() {
		return invalidTime;
	}
	public void setInvalidTime(long iTime) {
		invalidTime = iTime;
	}

	public void setCommandTypeArray(int[] pTypeArray) {
		cmdTypeArray = pTypeArray;
	}
	
	public void setCommandArgsArray(XATDataValue[] pArgsArray) {
		cmdArgsArray = pArgsArray;
	}
	
//	public int getMesgType() {
//		return mesgType;
//	}
//	
//	public void setMesgType(int mesgType) {
//		this.mesgType = mesgType;
//	}

}
