/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.dag;

import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;

/**
 * Insert the type's description here.
 * Creation date: (9/25/02 4:17:14 PM)
 * @author: Xin Zhang
 */
public interface XATDag extends XATTree {
/**
 * Adds a new root to the Dag.  This will be added to the right of the others
 * @param newRoot edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode
 */
void addRoot(DagNode newRoot);

void deleteRoot(DagNode node);
/**
 * Insert the method's description here.
 * Creation date: (1/31/03 4:48:34 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode
 * @param i int
 */
DagNode getNthRoot(int i);
/**
 * Returns true if node is a root node; false otherwise.
 * @return boolean
 */
public boolean isRoot(DagNode node);
/**
 * Insert the method's description here.
 * Creation date: (1/31/03 4:49:28 PM)
 * @param i int
 * @param newRoot edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode
 */
void setNthRoot(int i, DagNode newRoot);

public int getRootCount();
public String toString();
public void clearHasBeenVisitedMark();
}
