/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.dag;

/**
 * An XATTimeStampRangeException is thrown when an XATTimeStamp range is not availablel to timestamp, either
 * because the range is already in use
 * Creation date: (5/26/2003 12:50:45 PM)
 * @author: Tim Sutherland
 */
public class XATTimeStampRangeException extends XATTimeStampException {
/**
 * XATTimeStampRangeException constructor comment.
 */
public XATTimeStampRangeException() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (5/28/2003 2:21:13 PM)
 * @param i int
 */
public XATTimeStampRangeException(int i) {
	
	super("The column: " + i + " is not a valid range for this timestamp");
	}
/**
 * XATTimeStampRangeException constructor comment.
 * @param s java.lang.String
 */
public XATTimeStampRangeException(String s) {
	super(s);
}
}
