/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.dag;

import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;

public class XATTupleNegativeImp extends XATTupleImp implements XATTupleNegative {

	
	protected boolean  negativeFlag;
	protected boolean  added;
	
	public XATTupleNegativeImp(XATTuple t){
	
	    super(t.getArrayData());
		this.setMaxTimeStamp(t.getMaxTimeStamp());
		this.setMinTimeStamp(t.getMinTimeStamp());
		//this.setAdded(((XATTupleNegative)t).isAdded());
		//this.negativeFlag=false;	
	}
	public XATTupleNegativeImp() {
		super();
		this.negativeFlag = false;
		// TODO Auto-generated constructor stub
	}
	
	public XATTupleNegativeImp(XATDataValue[] array) {
		super(array);
		this.negativeFlag = false;
	}
	
	public XATTupleNegativeImp(int length) {
		super(length);
		this.negativeFlag = false;
	}
	
	public XATTupleNegativeImp(List list) {
		super(list);
		this.negativeFlag = false;
	}

	public boolean isNegativeFlag() {
		return negativeFlag;
	}

	public void setNegativeFlag(boolean negativeFlag) {
		this.negativeFlag = negativeFlag;
	}
	
	public String toString(){
	String test = super.toString();
	if (this.negativeFlag == true) 
		test=test+"negative"; 
	else test=test+"positive";
	return test;
	
	}
	public boolean isAdded() {
		return added;
	}
	public void setAdded(boolean added) {
		this.added = added;
	}
	public boolean equals(XATTuple tp, String ignoreField) {
		// TODO Auto-generated method stub
		return false;
	}
	
	
	

}
