package edu.wpi.cs.dsrg.xmldb.xat.common.expression;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import java.util.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;

/**
 * This class defines a binary expression.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0 
 */

public abstract class BinExpressionImp implements BinExpression {
/**
 * The default BinExpressionImp constructor.
 * @since 1.0
 */
public BinExpressionImp() {
	super();
}
/**
 * get column names related with expression.
 * @return ColumnName[] The array containing all the related column names.
 * @since 1.0
 */

public ColumnName[] getRelatedColumnNames() {
    Vector result = new Vector();
    ColumnName[] cols = this.getLeft().getRelatedColumnNames();
    for (int i = 0; i < cols.length; i++)
        result.add(cols[i]);

    cols = this.getRight().getRelatedColumnNames();
    for (int i = 0; i < cols.length; i++)
        result.add(cols[i]);

    return (ColumnName[]) (result.toArray(new ColumnName[] {
    }));
}
}
