/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Feb 21, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.migration.probablisticjoinoperator;

import java.util.Vector;

/**
 * @author Yali Zhu
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class JoinTreeNode {
	
	int totalVertexNum;
	int[] involvedVertexIndex;
	
	//double outputRate;
	
	JoinTreeNode parent = null;
	Vector children = null;
	
	public JoinTreeNode(int n) {
		this.totalVertexNum = n;
		this.involvedVertexIndex = new int[n];
		
		for(int i=0; i<n; i++) {
			involvedVertexIndex[i] = 0;
		}
	}
	public void setParent(JoinTreeNode parentnode) {
		this.parent = parentnode;
	}
	
	public void setChildren(Vector children) {
		this.children = children;
		
		for(int i=0; i<children.size(); i++) {
			int[] indexArray = ((JoinTreeNode)children.get(i)).getInvolvedVertexIndex();
			
			for(int j=0; j<indexArray.length; j++) {
				if(indexArray[j] == 1) 
					this.involvedVertexIndex[j] = 1;
			}
		}
	}
	
//	private void updateOutputRate() {
//		
//	}
	
	public void addChild(JoinTreeNode c) {
		
		this.children.add(c);
		int[] indexArray = c.getInvolvedVertexIndex();
		
		for(int j=0; j<indexArray.length; j++) {
			if(indexArray[j] == 1) 
				this.involvedVertexIndex[j] = 1;
		}
	}
	
	public void removeChild(JoinTreeNode c) {
		this.children.remove(c);
		
		int[] indexArray = c.getInvolvedVertexIndex();
		
		for(int j=0; j<indexArray.length; j++) {
			if(indexArray[j] == 1) 
				this.involvedVertexIndex[j] = 0;
		}
		
	}
	
	public void addInvolvedVertexIndex(int index) {
		this.involvedVertexIndex[index] = 1;
	}
	
	public int[] getInvolvedVertexIndex() {
		return this.involvedVertexIndex;
	}
}
