/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on May 13, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.migration.probablisticjoinoperator;

//import java.util.Vector;

import java.util.Random;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATSimpleQueueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
//import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNodeImp;

/**
 * @author Yali Zhu
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class OperatorTester {

	public static void main(String args[]) {
		System.setProperty("DATA_MODEL", "XATSimpleQueueImp");
		//TestPWMJoinOperator();
		TestChangingWBJoinOperator();
		
		Random rand = new Random();
		
		rand.setSeed(0);
		for(int i=0; i<10; i++) {
			System.out.println(rand.nextDouble());
		}
		
		System.out.println();
		rand.setSeed(1);
		for(int i=0; i<10; i++) {
			System.out.println(rand.nextDouble());
		}
	}
	
	public static void TestChangingWBJoinOperator() {
		DagNode node = new DagNodeImp();
		ChangingWBJoinOperatorImp operator = new ChangingWBJoinOperatorImp(node);
		
		operator.setSelectivity(0.55);
		operator.setTimeWindow(100000);

		try{
			operator.setProperty("STATE_TYPE", "edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.WFIFOState");
		}catch (Exception e) {
			e.printStackTrace();
		}

		//create and connect input queues and output queues.
		System.setProperty("DATA_MODEL", "XATSimpleQueueImp");
		XATQueue queueA = new XATSimpleQueueImp();
		XATQueue queueB = new XATSimpleQueueImp();
		//XATQueue queueC = new XATSimpleQueueImp();
		XATQueue queueOut = new XATSimpleQueueImp();
		
		operator.addInputQueue(queueA);
		operator.addInputQueue(queueB);
		//operator.addInputQueue(queueC);
		operator.addOutputQueue(queueOut);
		
		XATQueueSchema schema1 = new XATQueueSchema();
		XATQueueSchema schema2 = new XATQueueSchema();
		//XATQueueSchema schema3 = new XATQueueSchema();
		schema1.addColumn("A.a1");
		schema2.addColumn("B.b1");
		//schema3.addColumn("C.c1");
		queueA.setSchema(schema1);
		queueB.setSchema(schema2);
		//queueC.setSchema(schema3);
		operator.setHasInit(false);
		
		//put some tuples to input queues
		for(int i=0; i<10; i++) {
			XATTuple tuple = new XATTupleImp();
			tuple.addCell(new XATDataValueImp(new Double("1")));
			tuple.setUniTimeStamp(i*200);
			queueA.enqueue(tuple, null);
		}
		
		for(int i=0; i<5; i++) {
			XATTuple tuple = new XATTupleImp();
			tuple.addCell(new XATDataValueImp(new Double("2")));
			tuple.setUniTimeStamp(i*300);
			queueB.enqueue(tuple, null);
		}
		
		operator.setAsRootOperator(true);
		operator.run();
		operator.finalizeOperation();
		System.out.println("done.");
	}
	
	public static void TestPWMJoinOperator() {
		DagNode node = new DagNodeImp();
		ProbabilisticWMJoinOperator operator = new ProbabilisticWMJoinOperator(node);
		
		double[] rates = new double[3];
		rates[0] = 10;
		rates[1] = 20;
		rates[2] = 50;
		
		double[][] selectivities = new double[3][3];
		for(int i=0; i< 3; i++) {
			for(int j=0; j<3; j++)
				selectivities[i][j] = 1;
		}
		selectivities[0][1] = 0.05;
		selectivities[1][0] = 0.05;
		selectivities[1][2] = 0.3;
		selectivities[2][1] = 0.3;
	
		operator.setNumOfInputs(3);
		operator.setArrivalRates(rates);
		operator.setSelectivityMatrix(selectivities);
		operator.setTimeWindow(1000);
		operator.setRunningMode("mjoin");
		operator.setCartesianProductStatus(true);
		operator.setUpdateSelectivityStatus(true);
		try{
			operator.setProperty("STATE_TYPE", "edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.WFIFOState");
		}catch (Exception e) {
			e.printStackTrace();
		}
		operator.setupStates();
		operator.computeProbeSequence();

		//create and connect input queues and output queues.
		System.setProperty("DATA_MODEL", "XATSimpleQueueImp");
		XATQueue queueA = new XATSimpleQueueImp();
		XATQueue queueB = new XATSimpleQueueImp();
		XATQueue queueC = new XATSimpleQueueImp();
		//XATQueue queueOut = new XATSimpleQueueImp();
		
		operator.addInputQueue(queueA);
		operator.addInputQueue(queueB);
		operator.addInputQueue(queueC);
		//operator.addOutputQueue(queueOut);
		
		XATQueueSchema schema1 = new XATQueueSchema();
		XATQueueSchema schema2 = new XATQueueSchema();
		XATQueueSchema schema3 = new XATQueueSchema();
		schema1.addColumn("A.a1");
		schema2.addColumn("B.b1");
		schema3.addColumn("C.c1");
		queueA.setSchema(schema1);
		queueB.setSchema(schema2);
		queueC.setSchema(schema3);
		operator.setHasInit(false);
		
		//put some tuples to input queues
		for(int i=0; i<10; i++) {
			XATTuple tuple = new XATTupleImp();
			tuple.addCell(new XATDataValueImp(new Double("1")));
			tuple.setUniTimeStamp(i*200);
			queueA.enqueue(tuple, null);
		}
		
		for(int i=0; i<5; i++) {
			XATTuple tuple = new XATTupleImp();
			tuple.addCell(new XATDataValueImp(new Double("2")));
			tuple.setUniTimeStamp(i*300);
			queueB.enqueue(tuple, null);
		}
		
		for(int i=0; i<8; i++) {
			XATTuple tuple = new XATTupleImp();
			tuple.addCell(new XATDataValueImp(new Double("3")));
			tuple.setUniTimeStamp(i*200);
			queueC.enqueue(tuple, null);
		}
		
		operator.run();
	}
}
