/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Feb 21, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.migration.probablisticjoinoperator;

import java.util.Vector;

/**
 * @author Yali Zhu
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class RootedTreeNode {
	
	//int totalVertexNum;

	// a node that needs to be combined with its parent in the IB algorithm is marked as a tailNode, by doing this
	// we don't really need to combine them.
	boolean tailNode = false;
	
	// for simple node, the vlist contains a single vertex
	// for combined node, the vllist contains a lst of vertics, ordered by their appearance in the join ordering chain. 
	//Vector nodelist = new Vector();
	
	// for simple node d, rank(d) = rate(d) * selectivity(parent, d)
	// for simple node d, rank(d) = (t(d)-1)/c(d)
	// for combined node c, rank(c) is computed by multiple all rates of the node in the nodelist, 
	// and the selectivity between consecutive nodes in the node list.   
	int nodeIndex = 0;
	double cvalue;
	double tvalue;
	double rank;
	
	RootedTreeNode parent;
	Vector children = new Vector();
	
	public RootedTreeNode(int index) {
		this.nodeIndex = index;
		//this.involvedVertexIndex = new int[n];
		
//		for(int i=0; i<n; i++) {
//			involvedVertexIndex[i] = 0;
//		}
	}
	public void setParent(RootedTreeNode parentnode) {
		this.parent = parentnode;
	}
	
	public void setChildren(Vector children) {
		this.children = children;
	}
	
//	private void updateOutputRate() {
//		
//	}
	
	public void addChild(RootedTreeNode c) {
		
		this.children.add(c);
	}
	
	public void removeChild(RootedTreeNode c) {
		this.children.remove(c);
	}
	
	public void setAsTailNode() {
		this.tailNode = true;
	}
	
	public boolean isTailNode() {
		return this.tailNode;
	}
	
	public double getCValue() {
		return this.cvalue;
	}
	
	public void setCValue(double cvalue) {
		this.cvalue = cvalue;
	}
	
	public double getTValue() {
		return this.tvalue;
	}
	
	public void setTValue(double tvalue) {
		this.tvalue = tvalue;
	}
	
	public void setRank(double rank) {
		this.rank = rank;
	}
	
	public double getRank() {
		return this.rank;
	}
	
	public Vector getChildren() {
		return this.children;
	}
	
	public boolean hasChildren() {
		return (this.children.size() > 0);
	}
	
	public int getNodeIndex() {
		return this.nodeIndex;
	}
	
	public String toString() {
		String rs = new String();
		
		rs += "(NODE: ";
		rs += "index= " + this.nodeIndex + " rank= " + this.rank +")";
		
		return rs;
	}
}
