/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Feb 20, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.migration.probablisticjoinoperator;

import java.util.List;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * @author Yali Zhu
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SimpleQueue {

	Vector tuples;
	
	// this involvedStreamID vector is used to compute the selectivity between two inputs of a suboperator
	// for example, a super operator may have two sub join operators AjoinB(child) and BjoinC(parent).
	// for suboperator BjoinC, the input B actually contains already joined AB tuples, so the selectivity between
	// input B and C should really be selectivity(AC) * selectivity(BC).
	// so this involvedStreamID vector is used to compute the actual selectivity 
	// between two input streams to a suboperator.
	// streamID is an integer number, the same index number used by the selectivityMatrix[] in the SUPER operator.
	Vector involvedStreamID;
	
	public SimpleQueue() {
		
	}
	
	public void enqueue(XATTuple newtuple) {
		tuples.add(newtuple);
	}
	
	public XATTuple dequeueOne() {

		XATTuple tuple = (XATTuple)tuples.remove(0);
		return tuple;
	}
	public List dequeueN(int n) {
		List l = tuples.subList(0, n);
		l.clear();
		return l;
	}
	
	public List dequeueAll() {
		List l = tuples.subList(0, tuples.size());
		return l;
	}
}
