package edu.wpi.cs.dsrg.xmldb.xat.common.operator;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////


/**
 * Implementation for the Interface that represents a column Name
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0      
 */

public class ColumnNameImp implements ColumnName {
    String sColumnName;
    String sTableName;

    /**
     * Constructor
     * @param sColumnName is column name
     * @since   1.0       
     */
    public ColumnNameImp(String sColumnName) {
        this.sColumnName = sColumnName;
        this.sTableName = null;
    }
    /**
     * Constructor
     * @param sTableName is table name 
     * @param sColumnName is column name
     * @since   1.0       
     */
    public ColumnNameImp(String sTableName, String sColumnName) {
        this.sColumnName = sColumnName;
        this.sTableName = sTableName;
    }
    /**
     * returns the column name 
     * @return column name
     * @since   1.0       
     */

    public String getColumnName() {
        return sColumnName;
    }
    /**
     * returns the table name 
     * @return table name
     * @since   1.0       
     */
    public String getTableName() {
        return sTableName;
    }
    /**
     * sets the column name 
     * @param newName is column name
     * @since   1.0       
     */

    public void setColumnName(String newName) {
        String sColumnName = newName;
    }
    /**
     * sets the table name 
     * @param newName is table name
     * @since   1.0       
     */
    public void setTableName(String newName) {
        sTableName = newName;
    }
    /**
     * returns a string representation of column name 
     * @return java.lang.String
     * @since   1.0       
     */
    public String toString() {
        if (sTableName == null) {
            return sColumnName;
        } else {
            return sTableName + "." + sColumnName;
        }
    }
}
