package edu.wpi.cs.dsrg.xmldb.xat.common.operator;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataSource;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATTable;

/**
 * An Interface for XATMultiSourceOperator.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0      
 */
public interface XATMultiSourceOperator extends XATOperator {

    /**
    * Get a specific source of a certain number.
    * @return XATDataSource of that position.
    * @since   1.0     
    */
    public XATDataSource getDataSourceAt(int position);
    /**
    * Return a vector of XATDataSource objects got from its child nodes.
    * You can get these XATDataSource objects from children nodes.
    * @return Vector of XATDataSource.
    * @since   1.0         
    */
    public XATDataSource[] getDataSources();
    /**
    * Get a specific source of a certain number.
    * @return XATTable of that position.
    * @since   1.0         
    * @deprecated use XATMultiSourceOperator.getDataSourceAt(int position)   
    */
    public XATTable getSourceAt(int position);
    /**
    * Return am array of XATTable objects got from its child nodes.
    * You can get those XATTable objects from children nodes.
    * @return Vector of XATTable.
    * @since   1.0         
    * @deprecated use XATMultiSourceOperator.getDataSources()
    */
    public XATTable[] getSources();
}