package edu.wpi.cs.dsrg.xmldb.xat.common.operator;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////
import java.io.Serializable;
/**
 * Generic interface for all QueryObjects in the system.  Any object that
 * wants to have a reference to the statistics gatherer -or- be able to be
 * stored in the StatisticsGatherer needs to derive from this class. <p>
 *
 * This also provides a standard means for operators to define which statistics they support.
 * This is new b/c previously, the properties and statistics were lumped together.  <p>
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0        
 */
public interface XATQueryObject extends Serializable, XATProperties {

    /**
    * returns an enumeration of Statistics supported by
    * this query object
    * @return an Enumeration
    * @since   1.0           
    */
    public java.util.Enumeration getStatistics();
    /**
     * Checks if the given Statistic is valid for this QueryObject.
     * @param nameToCheck the name to check    
     * @return boolean true if the property is supported by this object, false otherwise.
     * @since   1.0            
     */
    public boolean isValidStatistic(String nameToCheck);
    
    public abstract LightWeightQueryObject getLightWeightQueryObject();
}