/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.clustersheddy;

//********************************************************************
//Coin.java       Author: Lewis/Loftus
//
//Represents a coin with two sides that can be flipped.
//********************************************************************

import java.util.Random;

public class Coin implements java.io.Serializable
{
	private final int HEADS = 0;
	private final int TAILS = 1;
	
	private int face;
	
	//-----------------------------------------------------------------
	//  Sets up the coin by flipping it initially.
	//-----------------------------------------------------------------
	public Coin ()
	{
	  flip();
	}
	
	//-----------------------------------------------------------------
	//  Flips the coin by randomly choosing a face value.
	//-----------------------------------------------------------------
	public void flip ()
	{
	  face = (int) (Math.random() * 2);
	}
	
	//-----------------------------------------------------------------
	//  Returns true if the current face of the coin is heads.
	//-----------------------------------------------------------------
	public boolean isHeads ()
	{
	  return (face == HEADS);
	}
	
	//-----------------------------------------------------------------
	//  Returns the current face of the coin as a string.
	//-----------------------------------------------------------------
	public String toString()
	{
	  String faceName;
	
	  if (face == HEADS)
	     faceName = "Heads";
	  else
	     faceName = "Tails";
	
	  return faceName;
	}
}
