/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.clustersheddy;

public class SimilarityImp 
{
	//destination threshold type
	//precise means that the destination has to be identical
	//approx means that it can be approximate (as long as it's within a range value)
	public static int THRESHOLD_DESTINATION_TYPE_PRECISE = 1;
	public static int THRESHOLD_DESTINATION_TYPE_APPROX = 2;
		
	public static int THRESHOLD_DISTANCE_X = 0;
	public static int THRESHOLD_DISTANCE_Y = 0;
	public static int THRESHOLD_SPEED = 0;
	public static int THRESHOLD_TIME = 0;
	public static boolean THRESHOLD_DESTINATION_ENABLED = false;
	public static int THRESHOLD_DESTINATION_TYPE = THRESHOLD_DESTINATION_TYPE_PRECISE;
	public static int THRESHOLD_DESTINATION_VALUE = 0;
	
	
	public static int translateDestThresholdType(String strThresholdDestinationType)
	{
		if (strThresholdDestinationType.toLowerCase().startsWith("precise"))
		{
			return THRESHOLD_DESTINATION_TYPE_PRECISE;
		}
		else if (strThresholdDestinationType.toLowerCase().startsWith("approx"))
		{
			return THRESHOLD_DESTINATION_TYPE_APPROX;
		}
		return THRESHOLD_DESTINATION_TYPE_PRECISE;			
	}


}
