/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.helpers.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.continuous.*;

/**
 * @author Rimma V. Nehme
 *
 */
public class Clipper implements java.io.Serializable
{	
	

	 static boolean checkLine(float p, float q, MyPoint pTemp)
	 {
	 	int flag=1;
	 	float r=(q/p);
	 	
	 	if (p<0)
	 	{
	 		if(r>pTemp.y)
	 		{
	 			flag=0;
	 		}
	 		else
	 		{
	 			if (r>pTemp.x)
	 			{
	 				pTemp.x=r;
	 			}
	 		}
	 	}
	 	else if (p>0)
	 	{
	 		if(r<pTemp.x)
	 		{
	 			flag=0;
	 		}
	 		else
	 		{
	 			if (r<pTemp.y)
	 			{
	 				pTemp.y=r;
	 			}
	 		}	 		
	 	}
	 	else
	 	{
	 		if (q<0)
	 			flag=0;
	 	}
	 	
	 	if (flag == 0)
	 	{
	 		return false;
	 	}
	 	else
	 	{
	 		return true;
	 	}
	 }
	 
	 
	 public static MotionContinuousState oldClipLine3D(int queryID, int objectID, PositionSpt2D winMinParam, PositionSpt2D winMaxParam, PositionSpt2D point1Param, PositionSpt2D point2Param)
	 {
		//OLD CODE
	 	PositionSpt2D winMin = new PositionSpt2D(winMinParam.x, winMinParam.y, winMinParam.t);
	 	PositionSpt2D winMax = new PositionSpt2D(winMaxParam.x, winMaxParam.y, winMaxParam.t);
	 	PositionSpt2D point1 = new PositionSpt2D(point1Param.x, point1Param.y, point1Param.t);
		PositionSpt2D point2 = new PositionSpt2D(point2Param.x, point2Param.y, point2Param.t);
	 			
		
	 	MyPoint pTemp = new MyPoint(0.0f,1.0f);
	 	float dx = point2.x - point1.x, dy, dt;

	 	if (ClipTest(-dx, point1.x - winMin.x, pTemp))
	 		if (ClipTest(dx, winMax.x - point1.x, pTemp))
	 		{
	 			dy = point2.y - point1.y;
	 	
	 			if (ClipTest(-dy, point1.y - winMin.y, pTemp))
	 				if (ClipTest(dy, winMax.y - point1.y, pTemp))
	 				{
	 					dt = point2.t - point1.t;
	 					
	 					if (ClipTest(-dt, point1.t - winMin.t, pTemp))
	 						if (ClipTest(dt, winMax.t - point1.t, pTemp))
	 						{					
	 							
	 							if (pTemp.y < 1.0)
	 							{
	 								point2.x = (long)(point1.x + pTemp.y * dx);
	 								point2.y = (long)(point1.y + pTemp.y * dy);
	 								point2.t = (point1.t + pTemp.y * dt);
	 							}
	 		
	 							if (pTemp.x > 0.0)
	 							{
	 								point1.x += pTemp.x * dx;
	 								point1.y += pTemp.x * dy;
	 								point1.t += pTemp.x * dt;
	 							}
	
	 							Helper.DebugWriteLine("Actual time of intersection = "+point1.t + " - "+point2.t);

	 							//round to 2 decimal points
	 							point1.t = point1.t * 100;
	 							point1.t = Math.round(point1.t);
	 							point1.t = point1.t / 100;
	 							
	 							//round to 2 decimal points
	 							point2.t = point2.t * 100;
	 							point2.t = Math.round(point2.t);
	 							point2.t = point2.t / 100;


	 							MotionContinuousState mc = new MotionContinuousState(objectID,
										 EntityType.Object,
										 Math.round(point1.x),
										 Math.round(point1.y),
										 point1.t,
										 Math.round(point2.x),
										 Math.round(point2.y),
										 point2.t,
										 FunctionType.Linear);

	 							//return the clipped linear segment
	 							return mc;
	 						}				
	 					}		
	 			}
	 			
	 	
	 		//otherwise
		 return null;
	 }
	 
	
	 //public void clipLine(Graphics g, MyPoint winMin, MyPoint winMax, MyPoint pointA, MyPoint pointB)
	    
	 public static MotionContinuousState clipLine3DCohenSutherLand(int queryID, int objectID, MyPointCS winMin, MyPointCS winMax, MyPointCS pointA, MyPointCS pointB)
	 {

	 	boolean done = false, draw = false;
	 	float m = 0;

	 	while (!done)
	 	{
	 	    pointA.encode(winMin, winMax);
	 	    pointB.encode(winMin, winMax);

	 	    if (UtilsCS.accept(pointA, pointB))
	 	    {
	 	    	done = true;
	 	    	draw = true;
	 	    }
	 	    else
	 	    {
	 	    	if (UtilsCS.reject(pointA, pointB))
	 	    		done = true;
	 	    	else
	 	    	{
	 	    		if (pointA.inside())
	 	    		{
	 	    			MyPointCS pointTemp = pointA;
	 	    			pointA = pointB;
	 	    			pointB = pointTemp;
	 	    		}

	 	    		if (pointA.x != pointB.x)
	 	    			m = (pointB.y - pointA.y) / (pointB.x - pointA.x);

	 	    		if (pointA.bits[0])
	 	    		{
	 	    			pointA.y += (winMin.x - pointA.x) * m;
	 	    			pointA.x = winMin.x;
	 	    		}
	 	    		else
	 	    		{
	 	    			if (pointA.bits[1])
	 	    			{
	 	    				pointA.y += (winMax.x - pointA.x) * m;
	 	    				pointA.x = winMax.x;
	 	    			}
	 	    			else
	 	    			{
	 	    				if (pointA.bits[2])
	 	    				{
	 	    					if (pointB.x != pointA.x)
	 	    						pointA.x += (winMax.y - pointA.y) / m;
	 	    					pointA.y = winMax.y;
	 	    				}
	 	    				else
	 	    				{
	 	    					if (pointA.bits[3])
	 	    					{
	 	    						if (pointB.x != pointA.x)
	 	    							pointA.x += (winMin.y - pointA.y) / m;
	 	    						pointA.y = winMin.y;
	 	    					}
	 	    				}
	 	    			}
	 	    		}
	 	    	}
	 	    }
	 	}
	     

	 //g.drawLine(Math.round(pointA.x), Math.round(pointA.y), Math.round(pointB.x), Math.round(pointB.y));
	 
		MotionContinuousState mc = new MotionContinuousState(objectID,
				 EntityType.Object,
				 Math.round(pointA.x),
				 Math.round(pointA.y),
				 pointA.t,
				 Math.round(pointB.x),
				 Math.round(pointB.y),
				 pointB.t,
				 FunctionType.Linear);

		return mc;
	 	
	 }
	 
	 public static MotionContinuousState clipLine3D(int queryID, int objectID, PositionSpt2D winMin, PositionSpt2D winMax, PositionSpt2D point1, PositionSpt2D point2)
	 {
	 	
	 	float delta_x = (point2.x - point1.x);
	 	float delta_y = (point2.y - point1.y);
	 	float delta_t = (point2.t - point1.t);
		
	 	long p1 = - (point2.x - point1.x);
	 	long p2 =   (point2.x - point1.x);
	 	long p3 = - (point2.y - point1.y);
	 	long p4 =   (point2.y - point1.y);
		float p5 = - (point2.t - point1.t);
		float p6 =   (point2.t - point1.t);
		
		long q1 = point1.x - winMin.x;
		long q2 = winMax.x - point1.x;
		long q3 = point1.y - winMin.y;
		long q4 = winMax.y - point1.y;
		float q5 = point1.t - winMin.t;
		float q6 = winMax.t - point1.t;
		
		
		float p1_f = - (point2.x - point1.x);
		float p2_f =   (point2.x - point1.x);
		float p3_f = - (point2.y - point1.y);
		float p4_f =   (point2.y - point1.y);
		float p5_f = - (point2.t - point1.t);
		float p6_f =   (point2.t - point1.t);
		
		float q1_f = point1.x - winMin.x;
		float q2_f = winMax.x - point1.x;
		float q3_f = point1.y - winMin.y;
		float q4_f = winMax.y - point1.y;
		float q5_f = point1.t - winMin.t;
		float q6_f = winMax.t - point1.t;
		
		
		float u1 = 0;
		float u2 = 1;
		
		float u1_f = 0;
		float u2_f = 1;
		

		if ((p1 == 0) && (q1 < 0))
		{
			return null;
		}
		if (p1 < 0) { u1 = Math.max(u1, q1/p1);  u1_f = Math.max(u1_f, q1_f/p1_f);}
		if (p1 > 0) { u2 = Math.min(u2, q1/p1);  u2_f = Math.min(u2_f, q1_f/p1_f);}
		if (u1 > u2){ return null; }
		
		if (p2 < 0) { u1 = Math.max(u1, q2/p2); u1_f = Math.max(u1_f, q2_f/p2_f);}
		if (p2 > 0) { u2 = Math.min(u2, q2/p2); u2_f = Math.min(u2_f, q2_f/p2_f);}
		if (u1 > u2){ return null; }
		
		if (p3 < 0) { u1 = Math.max(u1, q3/p3); u1_f = Math.max(u1_f, q3_f/p3_f); }
		if (p3 > 0) { u2 = Math.min(u2, q3/p3); u2_f = Math.min(u2_f, q3_f/p3_f);}
		if (u1 > u2){ return null; }

		if (p4 < 0) { u1 = Math.max(u1, q4/p4); u1_f = Math.max(u1_f, q4_f/p4_f); }
		if (p4 > 0) { u2 = Math.min(u2, q4/p4); u2_f = Math.min(u2_f, q4_f/p4_f);}
		if (u1 > u2){ return null; }
		
		if (p5 < 0) { u1 = Math.max(u1, q5/p5); u1_f = Math.max(u1_f, q5_f/p5_f);}
		if (p5 > 0) { u2 = Math.min(u2, q5/p5); u2_f = Math.min(u2_f, q5_f/p5_f);}
		if (u1 > u2){ return null; }

		if (p6 < 0) { u1 = Math.max(u1, q6/p6); u1_f = Math.max(u1_f, q6_f/p6_f);}
		if (p6 > 0) { u2 = Math.min(u2, q6/p6); u2_f = Math.min(u2_f, q6_f/p6_f);}
		if (u1 > u2){ return null; }
		
		
		//System.out.println("The intersected line is [" + (point1.x+u1*delta_x)+", " + (point1.y + u1*delta_y) +", " +(point1.t + u1*delta_t)+"] - [" + (point1.x+u2*delta_x)+", " + (point1.y + u2*delta_y) +", "+(point1.t + u2*delta_t)+ "]");

		long newX1 = Math.round(point1.x + u1_f*delta_x);
		long newY1 = Math.round(point1.y + u1_f*delta_y);
		float newT1 = (point1.t + u1_f*delta_t);
		long newX2 = Math.round(point1.x + u2_f*delta_x);
		long newY2 = Math.round(point1.y + u2_f*delta_y);
		float newT2 = (point1.t + u2_f*delta_t);
		

		//round to 2 decimal points
		newT1 = newT1 * 100;
		newT1 = Math.round(newT1);
		newT1 = newT1 / 100;
			
		//round to 2 decimal points
		newT2 = newT2 * 100;
		newT2 = Math.round(newT2);
		newT2 = newT2 / 100;
	
		/*
		//round to 4 decimal points
		newT1 = newT1 * 10000;
		newT1 = Math.round(newT1);
		newT1 = newT1 / 10000;
			
		//round to 4 decimal points
		newT2 = newT2 * 10000;
		newT2 = Math.round(newT2);
		newT2 = newT2 / 10000;
		*/
		MotionContinuousState mc = new MotionContinuousState(objectID,
				 EntityType.Object,
				 newX1,
				 newY1,
				 newT1,
				 newX2,
				 newY2,
				 newT2,
				 FunctionType.Linear);

		return mc;
		
		
	 
	 }
	
	
	 public static boolean ClipTest(float p, float q, MyPoint pTemp)
	 {
	 	float r;
	    boolean boolReturn = true;

	    if (p < 0.0)
	    {
	    	r = q/p;
		    
	    	if (r > pTemp.y)
	    		boolReturn = false;
	    	else
	    		if (r > pTemp.x)
	    			pTemp.x = r;
	    }
	    else
	    {
	    	if (p > 0.0)
	    	{
	    		r = q/p;
		
	    		if (r < pTemp.x)
	    			boolReturn = false;
	    		else
	    			if (r < pTemp.y)
	    				pTemp.y = r;
	    	}
	    	else
	    		if (q < 0.0)
	    			boolReturn = false;
	    }
	    return boolReturn;
	 }
}
