/*
 * Created on May 29, 2005
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion;

/**
 * @author Rimma V. Nehme
 */
public class MotionSCUBAStatisticsGatherer  extends MotionStatisticsGatherer
{
	public int numberOfClustersAtTheBeginningOfExecution;
	public int numberOfClustersBeingJoined;
	public int numberOfClustersAtTheEndOfExecution;
	
	public int numberOfNewClustersCreated;
	public int numberOfClustersDissolved;
	
	public int numberOfSingleMemberClusters;
	public int numberOfMultiMemberClusters;
		
	public int numberOfObjectsStayedInParentCluster;
	public int numberOfQueriesStayedInParentCluster;	
	public int numberOfObjectsLeftParentCluster;
	public int numberOfQueriesLeftParentCluster;
	
	public double timeClusterMaintenanceStart;
	public double timeClusterMaintenanceEnd;
	
	public double timeBeginOfflineClustering;
	public double timeEndOfflineClustering;
	
	public double timeBeginKMeansClustering;
	public double timeEndKMeansClustering;
	
	public double timeTotalDuplicateElimination;
	public double timeCleanJoinTimeWithoutDuplicateElimination;
	
	public int numberOfClustersOverlappingWithMoreThanOneGridCell;

	
	
	public String SCUBAStatisticsToString()
	{
		String rs=super.DiscreteStatisticsToString();
		super.ResetStatistics();
	
		rs += "Number of clusters being joined ["+numberOfClustersBeingJoined+"]\n";
		rs += "Number of new clusters created ["+numberOfNewClustersCreated+"]\n";
		rs += "Number of clusters dissolved ["+numberOfClustersDissolved+"]\n";
		
		rs += "Number of single-member clusters ["+numberOfSingleMemberClusters+"]\n";
		rs += "Number of multi-member clusters ["+numberOfMultiMemberClusters+"]\n";
		
		rs += "Number of objects stayed in parent cluster ["+numberOfObjectsStayedInParentCluster+"]\n";
		rs += "Number of queries stayed in parent cluster ["+numberOfQueriesStayedInParentCluster+"]\n";

		rs += "Number of objects left parent cluster ["+numberOfObjectsLeftParentCluster+"]\n";
		rs += "Number of queries left parent cluster ["+numberOfQueriesLeftParentCluster+"]\n";
	
		rs += "Total time for cluster maintenance ["+(timeClusterMaintenanceEnd - timeClusterMaintenanceStart)+"]\n";
		
		return rs;
	}
	
	
	public String ShortSCUBAStatisticsToString()
	{
		String rs=super.ShortDiscreteStatisticsToString() +"\t";
		super.ResetStatistics();
		
		rs += ""+numberOfClustersAtTheBeginningOfExecution+"\t";
		rs += ""+numberOfClustersBeingJoined+"\t";
		rs += ""+numberOfClustersAtTheEndOfExecution+"\t";
		
		rs += ""+numberOfNewClustersCreated+"\t";
		rs += ""+numberOfClustersDissolved+"\t";
		
		rs += ""+numberOfSingleMemberClusters+"\t";
		rs += ""+numberOfMultiMemberClusters+"\t";
		
		rs += ""+numberOfObjectsStayedInParentCluster+"\t";
		rs += ""+numberOfQueriesStayedInParentCluster+"\t";

		rs += ""+numberOfObjectsLeftParentCluster+"\t";
		rs += ""+numberOfQueriesLeftParentCluster+"\t";
		
		rs += ""+(timeClusterMaintenanceEnd - timeClusterMaintenanceStart)+"\t";
		rs += ""+timeTotalDuplicateElimination+"\t";
		rs += ""+(timeJoinEnd - timeJoinStart -  timeTotalDuplicateElimination)+"\t";
		
		rs += ""+numberOfClustersOverlappingWithMoreThanOneGridCell+"\t";
		
		rs += ""+(timeEndOfflineClustering - timeBeginOfflineClustering)+"\t";
		rs += ""+(timeEndKMeansClustering - timeBeginKMeansClustering)+"\t";
		return rs;
	}
	
	
	public String ShortSCUBAStatisticsHeaderToString()
	{
		String rs=super.ShortDiscreteStatisticsHeaderToString() + "\t";
		rs += "# Clusters at the Beginning of Interval Execution\t";
		rs += "# Clusters Being Joined\t";
		rs += "# Clusters at the End of Interval Execution\t";
		
		rs += "# Clusters Created\t";
		rs += "# Clusters Dissolved\t";
		
		rs += "# Single Member Clusters\t";
		rs += "# Multi Member Clusters\t";
		
		rs += "# Objects Stayed In Cluster\t";
		rs += "# Queries Stayed In Cluster\t";

		rs += "# Objects Left Cluster\t";
		rs += "# Queries Left Cluster\t";
		
		rs += "Total time for Cluster Maintenance\t";
		rs += "Total time for Duplicate Elimination (DE)\t";
		rs += "Total time for Clean Join (DE excluded)\t";
		
		rs += "# of clusters overlapping with more than one grid cell\t";
		
		rs += "Total time Offline Clustering\t";
		rs += "Total time KMeans Clustering\t";
		return rs;
	}


}
