/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion;

/**
 * @author Rimma V. Nehme
 *
 */
public class PositionSp2D implements java.io.Serializable
{
	protected long x;
	protected long y;

	public PositionSp2D() 
	{
		x = 0;	
		y = 0;	
	}
	
	public PositionSp2D(long newX, long newY) 
	{
		x = newX;	
		y = newY;			
	}
	
	public PositionSp2D(float newX, float newY) 
	{
		x = (long)newX;	
		y = (long)newY;			
	}
	
	public long  GetX()
	{
		return x;
	}
	
	public void  SetX(long newX)
	{
		x = newX;
	}
	
	public long  GetY()
	{
		return y;
	}
	
	public void  SetY(long newY)
	{
		y = newY;
	}	
	
	public String toString()
	{
		return "{"+ x +"," + y + "}";
	}
}
