/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion;

/**
 * @author Rimma V. Nehme
 *
 */
class UtilsCS
{
    public static boolean reject(MyPointCS pointA, MyPointCS pointB)
    {
    	return ((pointA.bits[0] && pointB.bits[0]) ||
    			(pointA.bits[1] && pointB.bits[1]) ||
				(pointA.bits[2] && pointB.bits[2]) ||
				(pointA.bits[3] && pointB.bits[3]) ||
				(pointA.bits[4] && pointB.bits[4]) ||
				(pointA.bits[5] && pointB.bits[5]));

    }

    public static boolean accept(MyPointCS pointA, MyPointCS pointB)
    {
    	return !(pointA.bits[0] || pointB.bits[0] ||
			 pointA.bits[1] || pointB.bits[1] ||
		     pointA.bits[2] || pointB.bits[2] ||
		     pointA.bits[3] || pointB.bits[3] || 
		     pointA.bits[4] || pointB.bits[4] ||
		     pointA.bits[5] || pointB.bits[5]);
    }
}