/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums;

/**
 * @author Rimma V. Nehme
 *
 */
public class UpdateType 
{
	public final static int NA = 0;
	public final static int Newpoint = 1;
	public final static int Point = 2;
	public final static int DissappearPoint = 3;
	public final static int CalculatedPoint = 4;

	public static int FromStringToEnum(String strValue)
	{
		int rc = UpdateType.NA;
		if(strValue.equalsIgnoreCase("newpoint"))
		{
			rc = UpdateType.Newpoint;
		}
		else if (strValue.equalsIgnoreCase("point"))
		{
			rc = UpdateType.Point;
		}
		else if (strValue.equalsIgnoreCase("disappearpoint"))
		{
			rc = UpdateType.DissappearPoint;
		}
		return rc;
	}
	
	public static int FromIntToEnum(int intValue)
	{
		int rc = UpdateType.NA;
		if(intValue == 1)
		{
			rc = UpdateType.Newpoint;
		}
		else if (intValue == 2)
		{
			rc = UpdateType.Point;
		}
		else if (intValue == 3)
		{
			rc = UpdateType.DissappearPoint;
		}
		else if (intValue == 4)
		{
			rc = UpdateType.CalculatedPoint;
		}	
		return rc;
	}
	
	public static String FromEnumToString(int intValue)
	{
		String rc = "UpdateType.NA";
		if(intValue == 1)
		{
			rc = "UpdateType.Newpoint";
		}
		else if (intValue == 2)
		{
			rc = "UpdateType.Point";
		}
		else if (intValue == 3)
		{
			rc = "UpdateType.DissappearPoint";
		}
		else if (intValue == 4)
		{
			rc = "UpdateType.CalculatedPoint";
		}
		return rc;
	}
}
