/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.grid;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.DimensionType;


/**
 * @author Rimma V. Nehme
 *
 */
public abstract class GenericGrid implements java.io.Serializable
{
	protected static long xDimensionSize    = 110000000;
	//protected static long xDimensionSizeMin = 105000000;
	protected static long yDimensionSize    = 50000000;
	//protected static long yDimensionSizeMin = 46000000;
	

	
	protected static int xDimensionCellCount = 150;
	protected static int yDimensionCellCount = 150;
	
	protected static double xDimensionScalingFactor = 0.0001;
	protected static double yDimensionScalingFactor = 0.0001;
	
	public static int GetCellIndex(long position, int dimension)
	{
		int cellIndex = -1;
		if (dimension == DimensionType.x)
		{
			cellIndex = (int)((position )/ GenericGrid.GetXDimensionCellSize());
		}
		else if (dimension == DimensionType.y)
		{
			cellIndex = (int)((position ) / GenericGrid.GetYDimensionCellSize());
		}
		else if (dimension == DimensionType.t)
		{
			cellIndex = 0;
		}
		return cellIndex;		
	}
	
	public void Cleanup()
	{
		
	}
	
	
	public static long GetXDimensionSize()
	{
		return xDimensionSize;
	}
	public static long GetXDimensionCellSize()
	{
		return (xDimensionSize)/xDimensionCellCount;
	}
	
	public static long GetYDimensionCellSize()
	{
		return (yDimensionSize)/yDimensionCellCount;
	}
	
	public static long GetYDimensionSize()
	{
		return yDimensionSize;
	}
	
	public static int GetXDimensionCellCount()
	{
		return xDimensionCellCount;
	}
	
	public static int GetYDimensionCellCount()
	{
		return yDimensionCellCount;
	}
	
	public static double GetXDimensionScalingFactor()
	{
		return xDimensionScalingFactor;
	}
	
	public static double GetYDimensionScalingFactor()
	{
		return yDimensionScalingFactor;
	}
}
