/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.grid;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

/**
 * @author Rimma V. Nehme
 *
 */
public class GenericSpatialGridCell 
{
	protected GridCellIndex2D cellIndex;
	
	protected int xMin;
	protected int yMin;
	
	protected int xMax;
	protected int yMax;
	

	public GenericSpatialGridCell() 
	{
		cellIndex = new GridCellIndex2D();
		xMin = 0;
		yMin = 0;
		xMax = 0;
		yMax = 0;
	}
	
	public GenericSpatialGridCell(int newXIndex, int newYIndex,
								  int newXMin, int newYMin,
								  int newXMax, int newYMax) 
	{
		cellIndex = new GridCellIndex2D(newXIndex, newYIndex);
		xMin = newXMin;
		yMin = newYMin;
		xMax = newXMax;
		yMax = newYMax;
	}
	
	public int GetXMin()
	{
		return xMin;
	}
	
	public int GetYMin()
	{
		return yMin;
	}
	
	public int GetXMax()
	{
		return xMax;
	}
	
	public int GetYMax()
	{
		return yMax;
	}
	
	public GridCellIndex2D GetCellIndex()
	{
		return cellIndex;
	}
}
