/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.grid;
import java.util.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.discrete.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.range.*;
/**
 * @author Rimma V. Nehme
 *
 */
public class GenericSpatioTemporalDiscreteGridCell extends GenericSpatioTemporalGridCell
{
	ArrayList movingObjects; //MovingObjectState[]
	ArrayList movingQueries; //MovingQueryState[]

	public GenericSpatioTemporalDiscreteGridCell(int newXIndex, int newYIndex, int newTIndex,
			   long newXMin, long newYMin, long newTMin,
			   long newXMax, long newYMax, long newTMax)
	{
		super(newXIndex, newYIndex, newTIndex, newXMin, newYMin, newTMin, newXMax, newYMax, newTMax);
		movingObjects = new ArrayList();
		movingQueries = new ArrayList();	
	}

	public ArrayList GetQueryUpdatesInTheCellByQueryIDAndGridIndex(int queryID)
	{
		ArrayList tmpQueryEntries = new ArrayList();
		tmpQueryEntries.clear();

		for (int i=0; i< this.movingObjects.size();i++)
		{
			MovingRangeQueryState mQueryEntry = ((MovingRangeQueryState)(this.movingQueries.get(i)));
			if (mQueryEntry.GetID() == queryID)
			{
				//get all location updates for that particular object in that particular grid cell
				tmpQueryEntries.add(mQueryEntry);
			}
		}
		return tmpQueryEntries;		
	}

	public ArrayList GetObjectUpdatesInTheCellByObjectIDAndGridIndex(int objectID)
	{
		ArrayList tmpObjectEntries = new ArrayList();
		tmpObjectEntries.clear();

		for (int i=0; i< this.movingObjects.size();i++)
		{
			MovingObjectState mObjectEntry = ((MovingObjectState)(this.movingObjects.get(i)));
			if (mObjectEntry.GetID() == objectID)
			{
				//get all location updates for that particular object in that particular grid cell
				tmpObjectEntries.add(mObjectEntry);
			}
		}
		return tmpObjectEntries;		
	}

	/*dp:
	public void AddMovingObjectEntry(MovingObjectState newMovingObjectEntry)
	{
		movingObjects.add(newMovingObjectEntry);
	}
	*/
	
	public void AddMovingObjectEntry(GridEntry movingObjectGridEntry)
	{
		movingObjects.add(movingObjectGridEntry);
	}
	
	/*dp:
	public void AddMovingQueryEntry(MovingQueryState newMovingQueryEntry)
	{
		movingQueries.add(newMovingQueryEntry);
	}
	*/
	

	public void AddMovingQueryEntry(GridEntry movingQueryGridEntry)
	{
		movingQueries.add(movingQueryGridEntry);
	}

	public ArrayList GetMovingObjects()
	{
		return this.movingObjects;
	}

	public ArrayList GetMovingQueries()
	{
		return this.movingQueries;
	}
}
