/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.grid;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.*;

/**
 * @author Rimma V. Nehme
 *
 */
public abstract class GenericSpatioTemporalGrid extends GenericGrid
{
	protected static int tDimensionSize = 1;
	protected static int tDimensionCellCount = 1;
	
	
	public static String toStaticString()
	{
		return "GenericSpatioTemporalGrid:\n"+
			   "xDimensionSize: "+xDimensionSize+"\n"+
			   "xDimensionCellCount: "+xDimensionCellCount+"\n"+
			   "yDimensionSize: "+yDimensionSize+"\n"+
			   "yDimensionCellCount: "+yDimensionCellCount+"\n"+
			   "tDimensionSize: "+tDimensionSize+"\n"+
			   "tDimensionCellCount: "+tDimensionCellCount+"\n";
	}
	
	public void Cleanup()
	{
		
	}
	
	
	public static int GetTDimensionSize()
	{
		return tDimensionSize;
	}
	
	public static int GetTDimensionCellCount()
	{
		return tDimensionCellCount;
	}
	
	public static boolean IsIndexWithinGridBoundary(int xIndex, int yIndex, int tIndex)
	{			
		if ((xIndex >= GenericSpatioTemporalGrid.xDimensionCellCount) ||
			(yIndex >= GenericSpatioTemporalGrid.yDimensionCellCount) ||
			(tIndex >= GenericSpatioTemporalGrid.tDimensionCellCount))
		{			
			return false;
		}
		else
		{
			return true;
		}
	}
	
	public static PositionSpt2D GetCellWindowMin(GridCellIndex3D index)
	{
		long xPos = (long)(index.GetXIndex() * GenericSpatioTemporalGrid.GetXDimensionCellSize());
		long yPos = (long)(index.GetYIndex() * GenericSpatioTemporalGrid.GetYDimensionCellSize());
		long tPos = 0;
		return new PositionSpt2D(xPos, yPos, tPos);
	}
	
	public static PositionSpt2D GetCellWindowMax(GridCellIndex3D index)
	{
		long xPos = (long)((index.GetXIndex() + 1) * GenericSpatioTemporalGrid.GetXDimensionCellSize());
		long yPos = (long)((index.GetYIndex() + 1) * GenericSpatioTemporalGrid.GetYDimensionCellSize());
		long tPos = 0;
		return new PositionSpt2D(xPos, yPos, tPos);
	}
}
