/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.grid;

/**
 * @author Rimma V. Nehme
 *
 */
public class GenericSpatioTemporalGridCell implements java.io.Serializable
{
	protected GridCellIndex3D cellIndex;
	protected long xMin;
	protected long yMin;
	protected long tMin;
	
	protected long xMax;
	protected long yMax;
	protected long tMax;

	public GenericSpatioTemporalGridCell() 
	{
		cellIndex = new GridCellIndex3D();
		xMin = 0;
		yMin = 0;
		tMin = 0;
		xMax = 0;
		yMax = 0;
		tMax = 0;
	}
	
	public GenericSpatioTemporalGridCell(int newXIndex, int newYIndex, int newTIndex,
			long newXMin, long newYMin, long newTMin,
			long newXMax, long newYMax, long newTMax) 
	{
		cellIndex = new GridCellIndex3D(newXIndex, newYIndex, newTIndex);
		xMin = newXMin;
		yMin = newYMin;
		tMin = newTMin;
		xMax = newXMax;
		yMax = newYMax;
		tMax = newTMax;
	}
	
	public long GetXMin()
	{
		return xMin;
	}
	
	public long GetYMin()
	{
		return yMin;
	}
	
	public long GetTMin()
	{
		return tMin;
	}
	
	public long GetXMax()
	{
		return xMax;
	}
	
	public long GetYMax()
	{
		return yMax;
	}
	
	public long GetTMax()
	{
		return tMax;
	}
	
	public GridCellIndex3D GetCellIndex()
	{
		return cellIndex;
	}
}
