/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.grid;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.EntityType;

/**
 * @author Rimma V. Nehme
 *
 */
public class GridCellIndex3D implements java.io.Serializable
{
	protected int x;
	protected int y;
	protected int t;

	public GridCellIndex3D() 
	{
		x = 0;
		y = 0;
		t = 0;
	}
	
	public String toString()
	{
		return "GridCellIndex3D():\n"+
					"x: "+ this.GetXIndex()+"\n"+
					"y: "+this.GetYIndex()+"\n"+
					"t: "+this.GetTIndex()+"\n";
	}
	
	
	public GridCellIndex3D(int newX, int newY, int newT) 
	{
		x = newX;
		y = newY;
		t = newT;		
	}
	
	public int GetXIndex()
	{
		return x;
	}
	
	public int GetYIndex()
	{
		return y;
	}
	
	public int GetTIndex()
	{
		return t;
	}
}
