/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Apr 15, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.hash;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.EntityType;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.helpers.Helper;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.discrete.MovingObjectState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.discrete.MovingQueryState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorStateImp;

/**
 * @author rnehme
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DoubleKeyHash extends OperatorStateImp
{
	public HashMap InternalHash;
	
	public DoubleKeyHash()
	{
		InternalHash = new HashMap();
	}
	
	public int getNumberOfFirstKeyEntries()
	{
		return InternalHash.keySet().size();
	}
	
	public Object get(int keyOne, int keyTwo)
	{
		Object returnObject = null;
		if (InternalHash.containsKey(new Integer(keyOne)))
		{
			HashMap secondInternalHash = (HashMap)InternalHash.get(new Integer(keyOne));
			
			if (secondInternalHash.containsKey(new Integer(keyTwo)))
			{
				return secondInternalHash.get(new Integer(keyTwo));				
			}		
		}
		return returnObject;
	}
	
	public Object getByFirstKey(int keyOne)
	{
		Object returnObject = null;
		if (InternalHash.containsKey(new Integer(keyOne)))
		{
			return InternalHash.get(new Integer(keyOne));					
		}
		return returnObject;
	}
	
	
	public int getNumberOfBothKeyEntries()
	{
		int totalCount = 0;
		Iterator i = InternalHash.entrySet().iterator();
		while(i.hasNext())
		{			
			Map.Entry  entry =  (Map.Entry)i.next();			
			HashMap secondKeyInternalHash =(HashMap)entry.getValue();
			
			Iterator i2 = secondKeyInternalHash.entrySet().iterator();
			while(i2.hasNext())
			{
				totalCount++;
			}			
	   }		
		return totalCount;
	}
	
	public void add(int keyOne, int keyTwo, Object newObject)
	{
		if (!InternalHash.containsKey(new Integer(keyOne)))
		{
			InternalHash.put(new Integer(keyOne), new HashMap());
			HashMap secondHash = (HashMap)InternalHash.get(new Integer(keyOne));
			secondHash.put(new Integer(keyTwo), newObject);
		}
		else if (InternalHash.get(new Integer(keyOne)) == null)
		{
			InternalHash.put(new Integer(keyOne), new HashMap());
			HashMap secondHash = (HashMap)InternalHash.get(new Integer(keyOne));
			secondHash.put(new Integer(keyTwo), newObject);
		}
		else
		{
			HashMap secondHash = (HashMap)InternalHash.get(new Integer(keyOne));
			secondHash.put(new Integer(keyTwo), newObject);
		}		
	}
	
	public void remove(int keyOne, int keyTwo)
	{
		if (!InternalHash.containsKey(new Integer(keyOne)) || (InternalHash.get(new Integer(keyOne)) == null))
		{
			//do nothing
		}
		else
		{
			HashMap secondInternalHash = (HashMap)InternalHash.get(new Integer(keyOne));
			
			if (!secondInternalHash.containsKey(new Integer(keyTwo)) || (secondInternalHash.get(new Integer(keyTwo)) == null))
			{
				//again do nothing
			}
			else
			{
				Object objectToRemove = secondInternalHash.get(new Integer(keyTwo));
				secondInternalHash.remove(objectToRemove);
			}
		}		
	}
	
	
	public void removeByFirstKey(int keyOne)
	{
		if (!InternalHash.containsKey(new Integer(keyOne)) || (InternalHash.get(new Integer(keyOne)) == null))
		{
			//do nothing
		}
		else
		{
			HashMap secondInternalHash = (HashMap)InternalHash.get(new Integer(keyOne));
			InternalHash.remove(secondInternalHash);						
		}	
	}
	
	
	public void forEachFirstKeyRemoveAll()
	{
		Iterator i = InternalHash.entrySet().iterator();
		while(i.hasNext())
		{			
			Map.Entry  entry =  (Map.Entry)i.next();			
			HashMap secondKeyInternalHash =(HashMap)entry.getValue();
		
			secondKeyInternalHash.clear();
		}
	}
	
	public Object getLargestFirstKey()
	{		
		Set keySet = InternalHash.keySet();		
		return keySet.toArray()[keySet.size() - 1];
	}
	
	
	public void forEachFirstKeyRemoveAllButLastTwoForSecondKey()
	{
		Iterator i = InternalHash.entrySet().iterator();
		while(i.hasNext())
		{			
			Map.Entry  entry =  (Map.Entry)i.next();			
			HashMap secondKeyInternalHash =(HashMap)entry.getValue();
		
			TreeMap treeSecondKeyInternalHash = new TreeMap(secondKeyInternalHash);
			int secondKeyCount = treeSecondKeyInternalHash.size();
			int currentCount = 0;
			Set keySet = treeSecondKeyInternalHash.keySet();
			Object []keySetArray = keySet.toArray();
			keySet = null;			
			
			for (int p=0; p < secondKeyCount - 2; p++)
			{
				secondKeyInternalHash.remove(keySetArray[p]);				
			}
		}
	}
	
	
	public String toString()
	{
		String rc = "";
		Iterator i = InternalHash.entrySet().iterator();
		while(i.hasNext())
		{			
			Map.Entry  entry =  (Map.Entry)i.next();			
			HashMap secondKeyInternalHash =(HashMap)entry.getValue();
			
			rc += "key = " + entry.getKey().toString()+":\n";
		
			TreeMap treeSecondKeyInternalHash = new TreeMap(secondKeyInternalHash);
			Iterator i2 = treeSecondKeyInternalHash.entrySet().iterator();
			while(i2.hasNext())
			{	
				Map.Entry  entry2 =  (Map.Entry)i2.next();			
				XATTuple val2 =(XATTuple)entry2.getValue();	
				rc += "value = " + val2+"\n";
			}
				
		}
		return rc;
	}
	
	public void copyStateContent(OperatorState newstate) 
	{
		// TODO Auto-generated method stub
		
	}

	public void clearState() {
		// TODO Auto-generated method stub
		
	}
}
