/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.helpers;

/**
 * @author Rimma V. Nehme
 *
 */
public class MemoryTestBench implements java.io.Serializable
{
	  public long calculateMemoryUsage(ObjectFactory factory) 
	  {
	    Object handle = factory.makeObject();
	    long mem0 = Runtime.getRuntime().totalMemory() -
	      Runtime.getRuntime().freeMemory();
	    long mem1 = Runtime.getRuntime().totalMemory() -
	      Runtime.getRuntime().freeMemory();
	    
	    handle = null;
	    System.gc(); System.gc(); System.gc(); System.gc();
	    System.gc(); System.gc(); System.gc(); System.gc();
	    System.gc(); System.gc(); System.gc(); System.gc();
	    System.gc(); System.gc(); System.gc(); System.gc();
	    mem0 = Runtime.getRuntime().totalMemory() -
	      Runtime.getRuntime().freeMemory();
	    handle = factory.makeObject();
	    System.gc(); System.gc(); System.gc(); System.gc();
	    System.gc(); System.gc(); System.gc(); System.gc();
	    System.gc(); System.gc(); System.gc(); System.gc();
	    System.gc(); System.gc(); System.gc(); System.gc();
	    mem1 = Runtime.getRuntime().totalMemory() -
	      Runtime.getRuntime().freeMemory();
	    return mem1 - mem0;
	  }
	  public void showMemoryUsage(ObjectFactory factory) 
	  {
	  	
	    // Get current size of heap in bytes
	    long heapSize = Runtime.getRuntime().totalMemory();
	    
	    // Get maximum size of heap in bytes. The heap cannot grow beyond this size.
	    // Any attempt will result in an OutOfMemoryException.
	    long heapMaxSize = Runtime.getRuntime().maxMemory();
	    
	    // Get amount of free memory within the heap in bytes. This size will increase
	    // after garbage collection and decrease as new objects are created.
	    long heapFreeSize = Runtime.getRuntime().freeMemory();
	    
	    //Helper.DebugWriteLine("Heap Size: "+ heapSize +" bytes");
	    //Helper.DebugWriteLine("Heap Max Size: "+ heapMaxSize+" bytes");
	    //Helper.DebugWriteLine("Heap Free Size: "+ heapFreeSize+" bytes");
	  	
	    System.out.println("Heap Size: "+ heapSize +" bytes");
	    System.out.println("Heap Max Size: "+ heapMaxSize+" bytes");
	    System.out.println("Heap Free Size: "+ heapFreeSize+" bytes");
	  	
	    
	    long mem = calculateMemoryUsage(factory);
	    /*Helper.DebugWriteLine*/System.out.println("MEMORY CHECK: produced " +
	      factory.makeObject().getClass().getName() +
	      " which took " + mem + " bytes");	    
	    
	  }
	}
