/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.operators.clusteroperator;

import java.io.BufferedWriter;
import java.io.FileWriter;

/*
 * 
 * @author Robert Contois
 *
 * This class was used for the evaluations during the project. It wrote the results out to a file.
 */
public class ExpEval
{
	long startTime;				//start time of the experiment
	long endTime;				//end time of the experiment
	String fileName = "C:\\results.txt";	//where to output the results
	
	/*
	 * constructor for the experimental results
	 */
	ExpEval()
    {	
    }

	/*
	 * calculate the start time for the experiment and store it in the class
	 */
	public void startTime()
	{
		startTime = System.currentTimeMillis();		
	}

	/*
	 * calculate the end time for the experiment and store it in the class
	 */
	public void endTime()
	{
		endTime = System.currentTimeMillis();		
	}
	
	/*
	 * calculate the difference between the start and end times
	 * 
	 * @return 	the total execution time
	 */
	public long difference()
	{
		return (endTime - startTime);
	}
	
	/*
	 * log the results to the file specified in the class
	 * 
	 * @param textToWrite		The text that is to be written to the results file
	 * 
	 */
	public void logResults(String textToWrite)
	{
		try
		{
			BufferedWriter out = new BufferedWriter(new FileWriter(fileName, true));
			out.write(textToWrite + "\n");
			out.close();
		}
		catch(Exception e)
		{
			
		}
	}
}




