/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.operators.clusteroperator;
/*
 * 
 * @author Robert Contois
 * 
 * This class represents a point on an XY coordinate system
 */
public class Points
{
    private double x, y;
    
    /*
     * Constructor to set the points x and y value
     * 
     * @param temp_x	the x coord of the point
     * @param temp_y	the y coord of the point
     */
    Points(double temp_x, double temp_y)
    {
	x = temp_x;
	y = temp_y;
    }

    /*
     * default constructor for a point
     */
    Points()
    {

    }

    /*
     * get the x value of the point
     * 
     * @return the x value of the point
     */
    public double getX()
    {
	return x;
    }

    /*
     * get the y value of the point
     * 
     * @return the y value of the point
     */
    public double getY()
    {
	return y;
    }

    /*
     * set the x value of the point
     * 
     * @param temp_x	the value representing the x coord of the point
     */
    public void setX(double temp_x)
    {
	x = temp_x;
    }

    /*
     * set the y value of the point
     * 
     * @param temp_y	the value representing the y coord of the point
     */
    public void setY(double temp_y)
    {
	y = temp_y;
    }
    
    /*
     * print out the coord of the point, for testing
     */
    public void printCoord()
    {
	System.out.println(x + "," + y);
    }

}




