/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on May 16, 2005
 *
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.operators.scuba;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * @author Rimma V. Nehme
 */
public class MotionSCUBAClusterStorage  implements java.io.Serializable
{
	public HashMap storage;
	
	public MotionSCUBAClusterStorage()
	{
		storage = new HashMap();
	}
	
	public MotionSCUBACluster getClusterByCID(Integer clusterID)
	{
		return (MotionSCUBACluster)storage.get(clusterID);
	}
	
	public void addNewCluster(MotionSCUBACluster newCluster)
	{
		storage.put(new Integer(newCluster.cid), newCluster);
	}
	
	
	public String toString()
	{
		int trueAggregateCounter = 0;
		String rc = "\n*** CLUSTER STORAGE ***:\n";
		rc += "TOTAL ["+storage.keySet().size() +"] clusters\n";
		
		/*
		Iterator i = storage.entrySet().iterator();
		while(i.hasNext())
		{			
			Map.Entry  entry =  (Map.Entry)i.next();			
			MotionSCUBACluster cluster =(MotionSCUBACluster)entry.getValue();
			
			rc += "key = " + entry.getKey().toString()+":\n";					
			rc += "value = " + cluster.toString()+"\n";	
			if ((cluster.objects.size() > 1) || (cluster.queries.size() > 1))
			{
				trueAggregateCounter++;
			}
		}
		
		rc += "# OF MULTI-MEMBER CLUSTERS ["+trueAggregateCounter +"]\n";
		*/
		
		return rc;		
	}

}
