/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on May 14, 2005
 *
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.operators.scuba;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.PositionSpt2D;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.ClassType;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.EntityType;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.UpdateType;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.discrete.MovingObjectState;

/**
 * @author Rimma V. Nehme
 *
 */
public class MotionSCUBAMovingObjectState extends MovingObjectState
{
	public int speed;
	public long nextNodeX;
	public long nextNodeY;
	
	
	public MotionSCUBAMovingObjectState(int newID,
			 int newEntityType,							
			 long newX,
			 long newY, 
			 long newT,
			 int newUpdateType,
			 int newObjectClass,
			 long newNextNodeX,
			 long newNextNodeY,
			 int newSpeed) 
	{
		super(newID, newEntityType, newX, newY, newT, newUpdateType, newObjectClass);
		this.nextNodeX = newNextNodeX;
		this.nextNodeY = newNextNodeY;
		this.speed = newSpeed;
	}
	
	public long GetNextNodeX()
	{
		return nextNodeX;
	}

	public long GetNextNodeY()
	{
		return nextNodeY;
	}

	public String toString()
	{
		return super.toString()+ 
					"speed: "+ this.speed+"\n"+
					"nextNodeX: "+this.nextNodeX+"\n"+
					"nextNodeY: "+this.nextNodeY+"\n";
	}
}
