/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.results;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.QueryType;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.helpers.ObjectFactory;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.discrete.*;

/**
 * @author Rimma V. Nehme
 *
 */
public class MotionDiscreteResult extends MotionGenericResult implements ObjectFactory
{
	protected MotionDiscreteState value;
	
	public MotionDiscreteResult(int newQueryID,  int newObjectID, int newQueryType, MotionDiscreteState newDiscreteResult) 
	{
		super(newQueryID, newObjectID, newQueryType);
		this.value = newDiscreteResult;
	}
	
	public MotionDiscreteState GetResultValue()
	{
		return value;
	}
	
	public String toString()
	{
		return "MotionDiscreteResult():\n"+
				this.value.toString()+"\n";
	}


	public Object makeObject() 
	{		
		return new MotionDiscreteResult(0,0,QueryType.Range, new MotionDiscreteState());
	}

}
