/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.results.collections;
import java.util.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.grid.GenericSpatioTemporalGrid;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.results.*;
/**
 * @author Rimma V. Nehme
 *
 */
public class MotionContinuousResultsCollection 
{
	ArrayList continuousResults; //MotionContinuousResult[]
	
	
	private String statisticsToString()
	{
		String outputString="*** Results Collection Statistics ***";
		
		for (int i=0; i < continuousResults.size(); i++)
		{
			MotionContinuousResult tmp = (MotionContinuousResult)continuousResults.get(i);
			outputString += tmp.toString()+"\n";
		}
		
		
		return outputString;
	}
	
	public String toString()
	{
		String outputString = "MotionContinuousResultsCollection():\n";
		for (int i=0; i<this.continuousResults.size();i++)
		{
			MotionContinuousResult mcr = (MotionContinuousResult)continuousResults.get(i);
			outputString += mcr.toString();
		}
		return outputString;
	}
	
	public ArrayList GetContinuousResults()
	{
		return continuousResults;
	}
	
	public MotionContinuousResultsCollection() 
	{
		continuousResults = new ArrayList();
	}
	
	public void Add(MotionContinuousResult newResult)
	{
		continuousResults.add(newResult);
	}
	
	public void Clear()
	{
		continuousResults.clear();
	}
}
