/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.continuous;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.PositionSpt2D;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.*;
/**
 * @author Rimma V. Nehme
 *
 */
public class MovingQueryContinuousState extends MotionContinuousState
{
	protected int queryClass; //enum: ClassType
	protected int queryType; //enum: QueryType
	protected int queryBoundary; 
	
	public MovingQueryContinuousState(int newID, 
									  int newEntityType, 
									  long newXStart, 
									  long newYStart, 
									  float newTStart,
									  long newXEnd, 
									  long newYEnd, 
									  float newTEnd,	
									  int newContinuityType,
									  int newQueryClass,
									  int newQueryType,
									  int newQueryBoundary)
	{
		
		
		super(newID, newEntityType, newXStart, newYStart, newTStart, newXEnd, newYEnd, newTEnd, newContinuityType);
		this.queryClass = newQueryClass;
		this.queryType = newQueryType;
		this.queryBoundary = newQueryBoundary;
	}
	
	public int GetQueryBoundary()
	{
		return this.queryBoundary;
	}
	
	public String toString()
	{
		return "MovingQueryContinuousState():\n"+
					"ID: "+ this.id+"\n"+
					"Entity Type: "+EntityType.FromEnumToString(this.entityType)+"\n"+
					"Start Position: "+this.startPosition.toString()+"\n"+
					"End Position: "+this.endPosition.toString()+"\n"+
					"Query Class: "+ClassType.FromEnumToString(this.queryClass)+"\n"+	
					"Query Type: "+ClassType.FromEnumToString(this.queryType)+"\n"+
					"Continuity Type: "+FunctionType.FromEnumToString(this.continuityType)+"\n";
	}

}
