/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.discrete;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.ClassType;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.EntityType;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.UpdateType;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.helpers.Helper;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.MotionGenericState;

/**
 * @author Rimma V. Nehme
 *
 */
public class MotionDiscreteState extends MotionGenericState 
{
	protected PositionSpt2D position;
	
	public MotionDiscreteState() 
	{
		super(0,EntityType.NA);
		this.position = new PositionSpt2D();
	}
	
	public MotionDiscreteState(int newID,
							   int newEntityType,
							   long newX,
							   long newY, 
							   float newT) 
	{
		super(newID, newEntityType);
		this.position = new PositionSpt2D(newX, newY, newT);
	}
	
	public String toString()
	{
		return "MotionDiscreteState():\n"+
					"ID: "+ this.id+"\n"+
					"Entity Type: "+EntityType.FromEnumToString(this.entityType)+"\n"+
					"Position: "+this.position.toString()+"\n";
	}
	
	public PositionSpt2D GetPosition()
	{
		return position;
	}
	
	
	public void SetPosition(PositionSpt2D newPosition)
	{
		this.position = newPosition;
	}
}
