/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.range;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.FunctionType;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.QueryType;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.continuous.MovingQueryContinuousState;
/**
 * @author Rimma V. Nehme
 *
 */
public class MovingRangeQueryContinuousState extends MovingQueryContinuousState
{
	protected int queryBoundary;
	

	public MovingRangeQueryContinuousState (int newID,
			  int newEntityType,							
			  long newXStart,
			  long newYStart, 
			  long newTStart,
			  long newXEnd,
			  long newYEnd, 
			  long newTEnd,	
			  int newContinuityType,
			  int newQueryClass,
			  int newQueryBoundary) 
	{
		super(newID, newEntityType, newXStart, newYStart, newTStart, newXEnd, newYEnd, newTEnd, newContinuityType, newQueryClass, QueryType.Range, newQueryBoundary);
		this.queryBoundary = newQueryBoundary;
	}

	public int  GetQueryBoundary()
	{
		return queryBoundary;
	}

	public void  SetQueryBoundary(int newQueryBoundary)
	{
		queryBoundary = newQueryBoundary;
	}	
}
