/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
//
//  Motion Data Processing 1.0 
//
//  Copyright 2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Rimma V. Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  me: <rimma3@WPI.EDU>.
//
/////////////////// WORCESTER POLYTECHNIC INSTITUTE ///////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.range;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.enums.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.motion.states.discrete.MovingQueryState;

/**
 * @author Rimma V. Nehme
 *
 */
public class MovingRangeQueryState extends MovingQueryState
{
	protected int queryBoundary;

	public MovingRangeQueryState (int newID,
			 					  int newEntityType,							
								  long newX,
								  long newY, 
								  long newT,
								  int newUpdateType,
								  int newQueryClass,
								  int newQueryBoundary) 
	{
		super(newID, newEntityType, newX, newY, newT, newUpdateType, newQueryClass, QueryType.Range, newQueryBoundary);		
	}
	
	public int  GetQueryBoundary()
	{
		return queryBoundary;
	}
	
	public void  SetQueryBoundary(int newQueryBoundary)
	{
		queryBoundary = newQueryBoundary;
	}
	
	public String toString()
	{
		return  super.toString()+"\n"+
				"Query Boundary: "+ this.queryBoundary+"\n";
	}
}