/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Oct 14, 2004
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.partitionstreamoperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;

/**
 * @author Bin Liu
 * A simple Mod function that takes the tuple and return the id based on the number of
 * paritions to be made.
 */
public class ModPartitionFunction extends PartitionFunction{
	int total_partition = -1; // total number of parttitions to be made
	
	public ModPartitionFunction(Integer tp){
		total_partition = tp.intValue();
	}
	/**
	 * For a Mod function, we know for sure that the value of the tuple on the specified 
	 * column is a int, for others, we simple resturn 0
	 */
	public int partitionTuple(XATTuple tuple, int column){
		int partition_id = -1;
		XATDataValue tuple_val = tuple.getCell(column);
		String str_val = tuple_val.convertToString();
		int int_val = 0;
		try{
			int_val = Integer.parseInt(str_val);
		} catch (NumberFormatException ne){
			// do nothing
		}
		//simply return the mod 
		return (int_val%total_partition);
	} //end of partitionTuple
	
} //end of class ModPartitionFunction
