/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Oct 14, 2004
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.partitionstreamoperator;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.partitionstreamoperator.PartitionFunction;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.GroupbyHashEntry;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;

/**
 * @author Mingzhu Wei
 * A simple partition function that takes the tuple and return the id based on the value of partition column
 * paritions to be made.
 */
public class ValuePartitionFunction extends PartitionFunction{
	int total_partition = -1; // total number of parttitions to be made
	int numPartition = -1;
	public ValuePartitionFunction(Integer tp){
		total_partition = tp.intValue();
		int numPartition = 0;
	}
	// the hashtable to map the event type to which output stream (position of output Queue)
	
	Hashtable typeTable = new Hashtable();
	/**
	 * Based on the value of the tuple on the specified 
	 * column, if the typeTable has this string, return the position of this string, else build a new outputQueue and  is a int, for others, we simple resturn 0
	 */
	public int partitionTuple(XATTuple tuple, int column){
		XATDataValue tuple_val = tuple.getCell(column);
		String str_val = tuple_val.convertToString();
		Enumeration en = typeTable.keys();
		while(en.hasMoreElements()) {
			Object key = en.nextElement();
			if (((String)key).equals(str_val))
				return ((Integer)typeTable.get(key)).intValue();
			else
			{
				
				numPartition++;
				typeTable.put(str_val, (Integer)numPartition);
				return numPartition;
			}
			
		}
		return -1;//end of partitionTuple
	}

}//end of class ModPartitionFunction
