/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Nov 21, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestreamoperator;

/**
 * 
 *  FileInputDemo * Demonstrates the FileInputStream * and DataInputStream 
 * 
 * @author mukherab
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
 import java.io.*;
 
 
class PipeFileExperiments {
  protected String ffname;
  protected FileInputStream file;
  protected StreamTokenizer st;
  protected long valuesFromFile[][][];
  protected long valuesFromFileAggr[][]; // contains the aggregate values displayed in aggregate_output.txt
  protected String s;
  protected String str;
  protected int fileNumber=0;
  protected int fileCount=0;
  protected int rowCount=0;
  
  PipeFileExperiments(){
  	
  }

  
PipeFileExperiments(String filename, int fileno)
throws FileNotFoundException {
try {
	fileNumber = fileno;
	fileCount++;
	ffname = filename;
  file = new FileInputStream(filename);
  st = new StreamTokenizer(file);
  st.ordinaryChar('.');
  st.ordinaryChar('-');
  } catch(FileNotFoundException e) {
  			System.out.println(
  			"Could not open " + filename);
  			throw e;
  }
}

public void cleanup() {
try {
  file.close();
} catch(IOException e) {
  System.out.println(
    "file.close() unsuccessful");
}
}

public String processTokensToString() {
try {
	s = new String();
	int i=0,j=0;
	
	long firstColRow = 0; 
  if (st.nextToken() != StreamTokenizer.TT_EOF && st.ttype==StreamTokenizer.TT_NUMBER){
  
    firstColRow=(long)st.nval;
    valuesFromFile[fileNumber][i][j]= 0;
    s= s+ Long.toString(valuesFromFile[fileNumber][i][j]);
    j++; 
    rowCount ++;
  }
  while(st.nextToken() !=
    StreamTokenizer.TT_EOF) {  
    switch(st.ttype) {
      case StreamTokenizer.TT_EOL:
        i++;
      	rowCount++;
      	s = s+"\n";
        break;
      case StreamTokenizer.TT_NUMBER:
      	if(j==0){
          	valuesFromFile[fileNumber][i][j]= (long)st.nval-firstColRow;
        	j++;
        }
       else if(j==1){ 
        	valuesFromFile[fileNumber][i][j]= (long)st.nval-(valuesFromFile[fileNumber][i][j-1]+firstColRow);
        	j++;
        }
       else{ 
        valuesFromFile[fileNumber][i][j]=(long)st.nval;
       	j=0;
       }
      	s = s + Long.toString(valuesFromFile[fileNumber][i][j]);
        break;
      case StreamTokenizer.TT_WORD:
        s = s + st.sval; // Already a String
        break;
       default: // single character in ttype
        s = s+ String.valueOf((char)st.ttype);
    }
  }
  return s;
} catch(IOException e) {
  System.out.println("st.nextToken() unsuccessful");
  return null;
  }
} 

public void fileInput(String argFile) throws IOException {
	
try{
	FileInputStream fis = new FileInputStream(argFile);
	//	 Convert our input stream to a 
	// DataInputStream 
	DataInputStream in = new DataInputStream(fis); 
	// Continue to read lines while 
	// there are still some left to read 
	while (in.available() !=0) { 
		// Print file line to screen 
		System.out.println (in.readLine()); 
		} 
		in.close(); 
		} catch (Exception e) { 
			System.err.println("File input error"); 
		} 
		 
	}
	

public void fileOutput(String sToFile)throws IOException {
	FileOutputStream out; // declare a file output object 
	PrintStream p; // declare a print stream object 
	try { 
		// Create a new file output stream 
		// connected to "myfile.txt" \
		out = new FileOutputStream(this.ffname+"_out.txt");
		 // Connect print stream to the output stream 
		p = new PrintStream( out );
		p.println (sToFile);
		p.close(); 
	 }catch (Exception e) { 
		System.err.println ("Error writing to file"); 
	} 
}

/**
 * This method calculates the aggregate values using the valuesFromFile 3-D array.
 *
 */
private long [][] aggregateFile(){
	try {
		 			 
		for(int r=0;r<rowCount;r++){
			valuesFromFileAggr[r][0]= valuesFromFile[0][r][0];
			valuesFromFileAggr[r][2]= valuesFromFile[fileCount-1][r][2];
		
		}
		for (int r=0;r<rowCount;r++){
			long summationRow2 = 0;
			for(int f=0;f<fileCount;f++){
				 summationRow2+= valuesFromFile[f][r][2];
			}
			valuesFromFileAggr[r][2]=summationRow2;
		}
		return valuesFromFileAggr;
	}catch (Exception e) { 
			System.err.println ("Error aggregating File");
			return null;
	}
}

/**
 * This method converts the long 2-D array into a single string.
 *
 */

public String convertLongToString(long tmpValues[][])
{ 
	try{
		
	str=new String();
	
	for(int r=0;r<rowCount;r++){
		for(int c=0; c<3;c++){
			str = str + Long.toString(tmpValues[r][c]);
			if(c<2)
			str= str + "\t";
		}
		str = str + "\n";
    }
	return str;
	} catch (Exception e) { 
		System.err.println ("Error converting long to string");
		return null;
	}
}		


/**
 * This method outputs the string generated in the above convertLongToString() 
 * method into a text file 
 *
 */


public void fileOutputAggr(String sToFile) throws IOException {
	FileOutputStream out; // declare a file output object 
	PrintStream p; // declare a print stream object 
	try { 
		// Create a new file output stream 
		// connected to "myfile.txt" \
		out = new FileOutputStream("Aggregate_Output.txt");
		 // Connect print stream to the output stream 
		p = new PrintStream( out );
		p.println (sToFile);
		p.close(); 
	 }catch (Exception e) { 
		System.err.println ("Error writing to file"); 
	} 

}

		
public static void Main(String args[]) throws IOException { 
    PipeFileExperiments pf;
	for (int i=0;i<args.length;i++)
		{ try {
			//send the file names that are the commandline parameter
			pf = new PipeFileExperiments(args[i],i);
			
			pf.fileOutput(pf.processTokensToString());
			pf.cleanup();
			
	 	    } catch(Exception e) {
	 	    	e.printStackTrace();
		    }
		}
	}
}
