/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Nov 23, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestreamoperator;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.io.StreamTokenizer;

/**
 * @author mukherab
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PipeFileExperimentsAggregate extends PipeFileExperiments {
	
	private long aggrTable[][];// contains the Aggregate values
	
	private long cummulativeAggrTable[][]; // contains the Cummulative aggregate values displayed in Cummulativeaggregate_output.txt
	/**
	 * @param filename
	 * @param fileno
	 * @throws FileNotFoundException
	 */
	
	//overloaded constructors 
	//this constructor overloads the PipeFileExperiments constructor and also sends fileName and fileNo
	PipeFileExperimentsAggregate(String fileName, int fileNo) throws FileNotFoundException {
		super(fileName, fileNo);
		// TODO Auto-generated constructor stub
	}
	
	PipeFileExperimentsAggregate(String fileName)throws FileNotFoundException{
		super();
		try{
		file = new FileInputStream(fileName);
		  st = new StreamTokenizer(file);
		  st.ordinaryChar('.');
		  st.ordinaryChar('-');
		  } catch(FileNotFoundException e) {
		  			System.out.println(
		  			"Could not open " + fileName);
		  			throw e;
		  }
	}
	
	public  long [][]processTokensToAggrTable() {
		try {
			 int i=0,j=0;
		  while(st.nextToken() !=
		    StreamTokenizer.TT_EOF) {  
		    switch(st.ttype) {
		      case StreamTokenizer.TT_EOL:
		        i++;
		        break;
		      case StreamTokenizer.TT_NUMBER:
		      	aggrTable[i][j]= (long)st.nval;
		      	if(j<2){		          	
		          	j++;
		      	}
		      	else{
		      		j=0;
		      	}
		      	
		      
		        break;
		      case StreamTokenizer.TT_WORD:
		      
		        break;
		       default: // single character in ttype		      
		    }
		  }
		  return aggrTable;
		} catch(IOException e) {
		  System.out.println("st.nextToken() unsuccessful");
		  return null;
		  }
		} 
	
	/**
	 * This method calculates the cummulative aggregate values 
	 * using the valuesFromFileAggr 2-D array which is calculated in the aggregateFile() method
	 *
	 */
	public long[][] cummulativeAggregate(long AggrTable[][]){
		try{
			for(int r=0;r<rowCount;r++){
		
			for(int c=0;c<3;c++){
				if (r==0){
					cummulativeAggrTable[r][c]= aggrTable[r][c]; // first row is copied as it is.
				}
				if (c==0){
					cummulativeAggrTable[r][c]= aggrTable[r][c]; // first column for each row is copied as it is.
					}
				else{
					cummulativeAggrTable[r][c]=aggrTable[r][c]+AggrTable[r-1][c]; // 2nd and 3rd columns are cummulative.
				}
						
			 }
		}
			return cummulativeAggrTable;
		} catch (Exception e){
			System.err.println ("Error computing cummulative Aggregate");
			return null;
		}
	}
	
		
	/**
	 * This method overloads a similar method in super class  and outputs the string generated 
	 * in the above convertLongToString() method into a text file. cummulativeAggr.txt 
	 *
	 */
	
	public void fileOutputAggr(String sToFile) throws IOException {
		FileOutputStream out; // declare a file output object 
		PrintStream p; // declare a print stream object 
		try { 
			// Create a new file output stream 
			// connected to "myfile.txt" \
			out = new FileOutputStream("cummulativeAggr_Output.txt");
			 // Connect print stream to the output stream 
			p = new PrintStream( out );
			p.println (sToFile);
			p.close(); 
		 }catch (Exception e) { 
			System.err.println ("Error writing to file"); 
		} 

	}

	
	
	public static void main(String[] args) {
		try {
		PipeFileExperimentsAggregate pfAggr = new PipeFileExperimentsAggregate(args[0]);
		pfAggr.fileOutputAggr(pfAggr.convertLongToString(pfAggr.processTokensToAggrTable()));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
