/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Nov 27, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestreamoperator;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * @author songwang
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PipeFileExperiments_new {
	/**
	 * arraylist of input files
	 */
	ArrayList inputs;
	/**
	 * final output for file 1
	 */
	PrintWriter pw;
	
	/**
	 * final output for file 2
	 */
	PrintWriter pw1;
	/**
	 * two dimension array to temporily store data
	 */
	long[][] valueFromFile;
	
	
	long rowCount = 0;
	
	public PipeFileExperiments_new () {
		inputs = new ArrayList();
		
		try {
			pw = new PrintWriter(new BufferedWriter(new FileWriter("c:/exp_out.txt")));
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return;
		}
	}
	public static void main(String[] args) throws IOException {
		
		if (args.length == 0) {
			System.out.println("please give input file path");
			return;
		}
		/**
		 * initialize
		 */
		PipeFileExperiments_new pe = new PipeFileExperiments_new();
		pe.valueFromFile = new long[1000][args.length*3+3];
		for (int i = 0; i < args.length; i++) {
			BufferedReader br = new BufferedReader(new FileReader(args[i]));
			pe.inputs.add(i, br);
			
		}
		pe.genOutput();
		pe.print();
		pe.close();
			
	}
	/**
	 * @throws IOException
	 * 
	 */
	private void close() throws IOException {
		for (int i = 0; i < inputs.size(); i++) {
			((BufferedReader)inputs.get(i)).close();
		}
		pw.close();
		
		
	}
	/**
	 * read inputs, calulates the final result
	 * @throws IOException
	 * 
	 */
	private void genOutput() throws IOException {
		String buf = null;
		String[] tmp = null;
		
		long initTime = 0;
		boolean firstLineFirstFile = true;
		int rowNum = 0, colNum = 0;
		BufferedReader br = null;
		long startTime, deltaTime, tuples = 0;
		long[] sumDeltaTime = new long[1000];
		for (int i = 0; i < inputs.size(); i++) {
			br = (BufferedReader)inputs.get(i);
			rowCount = 0;
			while (br.ready()) {
				rowCount++;
				buf = br.readLine();
				buf = buf.trim();
				tmp = buf.split("\t");
				
				if (firstLineFirstFile) {
					initTime = Long.valueOf(tmp[0]).longValue();
					firstLineFirstFile = false;
				}
				startTime = Long.valueOf(tmp[0]).longValue() - initTime;
				deltaTime = Long.valueOf(tmp[1]).longValue() - Long.valueOf(tmp[0]).longValue();
				tuples = Long.valueOf(tmp[2]).longValue();
				
				valueFromFile[rowNum][colNum] = startTime;
				valueFromFile[rowNum][colNum+1] = deltaTime;
				valueFromFile[rowNum][colNum+2] = tuples;
				
				//sum delta time as reading files
				sumDeltaTime[i] += deltaTime;
				rowNum++;
			}//finish one file
			
			//reset pointer
			rowNum = 0;
			colNum +=3;
		} //finish all input files
		
		for (int i = 0; i < rowCount; i++ ) {
			valueFromFile[i][colNum] = valueFromFile[i][0];
			valueFromFile[i][colNum+1] = sumDeltaTime[i];
			valueFromFile[i][colNum+2] = valueFromFile[i][colNum-1];
			
			
		}
	}
	
	private void print() {
		long aggrDeltaTime = 0, aggrTuples = 0;
		for (int i = 0; i < rowCount; i++) {
			
			for (int j = 0; j < inputs.size()*3+3; j++) {
				pw.print(valueFromFile[i][j] + "\t");
				
			}
			pw.println();
			
		}
		
//		for (int i = 0; i < rowCount; i++) {
//			
//			aggrDeltaTime += valueFromFile[i][inputs.size()*3+1];
//			aggrTuples += valueFromFile[i][inputs.size()*3+2];
//			pw1.print(valueFromFile[i][inputs.size()*3] + "\t" + aggrDeltaTime + "\t" + aggrTuples);
//			
//			pw1.println();
//		}
	}

}
