/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestreamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestate.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATMultiQueueWindowStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.*;

/**
 * The PipeWBinaryJoinOperator stands for
 * pipelined-slidingwindow-binary-join-operator. It will include two
 * implementations: PipeWBinaryJoinOperatorHeadImp and
 * PipeWBinaryJoinOperatorBodyImp. PipeWBinaryJoinOperatorHeadImp is a join
 * operator for the head of the pipeline. PipeWBinaryJoinOperatorBodyImp is a
 * join operator for the body and tail of the pipeline Creation date:
 * (10/05/2005 2:26:41 PM)
 * 
 * @author: Song Wang and Abhishek Mukherji
 */
public interface PipeWBinaryJoinOperator extends
		XATMultiQueueWindowStreamOperator {
	public void initState(String statetype);

	public OperatorState getLeftState();

	public int getLeftStateSize();

	public int getRightStateSize();

	/**
	 * Insert the method's description here. Creation date: (5/28/2003 12:11:23
	 * PM)
	 * 
	 * @return int
	 */
	//public int getLPos();
	/**
	 * Insert the method's description here. Creation date: (4/3/2003 5:00:50
	 * AM)
	 * 
	 * @return queryplanelements.WFIFOState
	 */
	public OperatorState getRightState();

	/**
	 * Insert the method's description here. Creation date: (1/21/2003 10:57:01
	 * AM)
	 */
	boolean run();

	/**
	 * @return
	 */
	ExpressionStr getExpression();

	/**
	 * @param expression
	 */
	void setExpression(ExpressionStr expression);

}