/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Oct 22, 2004
 * @author song wang
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestreamoperator;

import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestate.PipeWFIFOState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.WOperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATMultiQueueWindowStreamOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

public class PipeWMJoinOperatorBasicImp	extends XATMultiQueueWindowStreamOperatorImp implements PipeWMJoinOperator {
	//added only for statistic collection for exp. can be safely removed
	StringBuffer state_string=new StringBuffer();
	StringBuffer output_string=new StringBuffer();
	String stateType= new String();
	
	long secondCounter=0;
	
	//join orderings for each input stream. for now we do not care about it
	int[][] ProbeSequence;
	//how many input stream this mjoin operates on.
	int numOfInputs = 0;  
	
	//matrix for join orderings. encoding stream A,B,C... as 0,1,2,... then 
	//for join ordering A-B-C, you will have joinOrderings[0][0]=1, i.e. "B" and joinOrderings[0][1]=2, i.e. "C"
	int[][] joinOrderings;
	
	//oID is the operator ID, used to mark the intermediate result generated by this operator.
	//private int oID = 0;
	
	// predicateMatrix[i][j] stores the predicates (expressionStr) that needs to be evaluated between input i and j.
	// only half (including diagonal line) of the matrix is filled. The filled half has i<=j (i at left, j at right).
	// during join processing, if i>j, i needs to be treated as the right side and j the left side.
	// this gurantee 1) the right predicate evaluation, and 2) the right order of columns no matter what the join order is.
	// this matrix is generated during parsing of a mjoin operator, by queryplangenerator.ClassVariableVisitor.
	public ExpressionStr[][] predicateMatrix; 
	
	// for ring build-up, 
	int window=0;//total window size
	int seg =0;//number of segment, must >3
	
	public PipeWMJoinOperatorBasicImp(PipeWMJoinOperatorBasicImp oldop, XATNode newnode) {
		super(oldop, newnode);
		this.predicateMatrix = oldop.predicateMatrix;
		this.windowSize = oldop.windowSize;
	}
	
	public PipeWMJoinOperatorBasicImp(XATNode init) {
		super(init);
	}
	
	public PipeWMJoinOperatorBasicImp(XATNode init, int n) {
		super(init);
		this.numOfInputs = n;
	}
	
	public int getNumOfInputs() {
		return numOfInputs;
	}
	
	public void setNumOfInputs(int n) {
		this.numOfInputs = n;
	}
	public int getOperatorID() {
		return this.operatorID;
	}
	
	public void setOperatorID(int n) {
		this.operatorID = n;
	}
	
	public void setWindow(int win){
		this.window =win;
	}
	
	public void setSeg(int seg){
		this.seg = seg;
	}
	public int getWindow(){
		return this.window;
	}
	
	public int getSeg(){
		return this.seg;
	}
	public String getStateType(){
		return this.stateType;
	}
	public void setStateType(String statetype){
		this.stateType=statetype;
	}

	public void initState(String statetype) {
		setStateType(statetype);
		//NOTE: this.numOfInputs should be this.getInputQueueCount()-1
		//the extra input queue is used for intermediate result.
		try{	
			//Constructor con = Class.forName(statetype).getConstructor();
			states = new WOperatorState[this.numOfInputs];
			for (int i=0;i<this.numOfInputs;i++){
				states[i] = (WOperatorState)Class.forName(statetype).newInstance();
				states[i].setOperator(this);
				if (this.startPointArray[i] > 0)
					((PipeWFIFOState) states[i])
							.setStartWindow(this.startPointArray[i]);
				if (this.windowSizeArray[i] > 0) {
					((PipeWFIFOState) states[i])
							.setTimeWindow(this.windowSizeArray[i]);
					((PipeWFIFOState) states[i])
					.setEndWindow(this.startPointArray[i]
							+ this.windowSizeArray[i]);
				}
				((PipeWFIFOState) states[i]).init(i);
			}
		}catch(Exception e) {
			e.printStackTrace();	
		}
		
	}
	
	/*
	 * Assign new ID to each state inside this operator, starting from the given startID.
	 * return the next available ID. For example, if startID is 2, and there are 2 states inside this operator,
	 * then these two states are assigned new IDs as 2 and 3, and 4 is then returned as the next available stateID.
	 */
	public int setStateID(int startID) {
		if (states == null) {
			return startID;
		}
	
		for(int i=0; i<states.length; i++) {
			states[i].setStateID(startID);
			startID++;
		}
		return startID;
	}

	public ExpressionStr getExpression(int i, int j) {
		return this.predicateMatrix[i][j];
	}

	public OperatorState getState(int i) {
		return this.states[i];
	}

	public int getStateSize(int i) {
		return this.states[i].getStateSize();
	}
	public int getStateSize() {
		int ret=0;
		for (int i=0;i<this.numOfInputs;i++) ret+=states[i].getStateSize();
		return ret;
	}

	/*
	 * overwritten init function to deal with the multiple queues in the input
	 * queue. For tuple propagation queue
	 */
	public void init(int outputQueueId) {
		XATQueueSchema outSchema = this.getOutputQueue(outputQueueId).getSchema();
		if (outSchema == null || outSchema.getLength() == 0) {
			String schemaName = new String();
			outSchema = new XATQueueSchema();
			XATQueueSchema inSchema = this.getInputQueue(outputQueueId).getSchema();
			schemaName = inSchema.getName();
				
			Iterator j = inSchema.getColNames().iterator();
			while(j.hasNext()){
				outSchema.addColumn((String) j.next());
			}
			outSchema.setName(schemaName);
			this.getOutputQueue(outputQueueId).setSchema(outSchema);
		}
	}
	/*
	 * overwritten init function to deal with the multiple schema in the input
	 * queue. For the join output queue
	 */
	public void initResult(int outputQueueId) {
		XATQueueSchema outSchema = this.getOutputQueue(outputQueueId).getSchema();
		if (outSchema == null || outSchema.getLength() == 0) {
			String schemaName = new String();
			outSchema = new XATQueueSchema();
			//Here we expect multiple inputQueues existing
			Iterator it =this.getInputQueues(); 
			while (it.hasNext()) {
				XATQueueSchema inSchema = ((XATQueue)it.next()).getSchema();
				if (inSchema!=null){
					schemaName += "#" + inSchema.getName();
					
					Iterator j = inSchema.getColNames().iterator();
					while(j.hasNext()){
						outSchema.addColumn((String) j.next());
					}
				}
			}

			outSchema.setName(schemaName);
			//by default, the last outputqueue is used to output final join result
			this.getOutputQueue(outputQueueId).setSchema(outSchema);
		}
		computeOutputPositionsResult(outputQueueId);

		this.numOutputColsPerStream = new int[outputPositions.length];
		this.numOutputColumns = 0;
		for (int i=0; i<outputPositions.length-1; i++) {
			int numCols = outputPositions[i].length;
			numOutputColsPerStream[i] = numCols;
			numOutputColumns += numCols;
		}
		this.setHasInit(true);
	}

	/**
	 * Overwritten function to deal with the multiple schema in the input queue
	 * compute the attribute mapping between input queuea(s) schema and output
	 * queue schema
	 */
	public void computeOutputPositionsResult(int outputQueueId) {
		DagNode node = (DagNode)getNode(); 
		Vector outColNames = getOutputQueue(outputQueueId).getSchema().getColNames();
		int outputColPos = 0;

		Iterator inputs = getInputQueues();
		//store all the input columns
		int j=0;
		while(inputs.hasNext()) {
			XATQueueSchema inSchema = ((XATQueue)inputs.next()).getSchema();
			if (inSchema==null) continue;
			Vector outputPosVec = new Vector();
			Vector inputColNames = inSchema.getColNames(); 
			for (Iterator i1 = outColNames.iterator(); i1.hasNext();){
				Object outputCol = i1.next();
				for (int k = 0; k<inputColNames.size(); k++){
					Object inputCol = inputColNames.get(k);
					if (outputCol.equals(inputCol)){
						outputPosVec.add(new Integer(k));
						break;
					}
				}
			}
			//convert vector to int[]
			int[] outputPosArray = new int[outputPosVec.size()];
			for (int count = 0; count < outputPosVec.size(); count++){
				outputPosArray[count] = ((Integer)outputPosVec.get(count)).intValue();
			}
			this.setOutputPositions(j, outputPosArray);
			j++;
		}
	}
	

	public void setExpression(int i, int j, ExpressionStr expression) {
		predicateMatrix = new ExpressionStr[this.numOfInputs][this.numOfInputs];
		if (i>j) {//swap i,j to make sure i<=j
			int temp=i;
			i=j;
			j=temp;
		}
		this.predicateMatrix[i][j]=expression;
	}
	public void setJoinOrderings(int[][] join){
		this.joinOrderings=join;
	}
	public int[][] getJoinOrderings(){
		return this.joinOrderings;
	}
	public boolean run(){
		XATTuple[] tuples = new XATTuple[this.getInputQueueCount()];
		
		// Here we expect that the input queue have multiple schemas
		for (int i=0;i<this.getInputQueueCount()-1;i++){
			if (this.getInputQueue(i).getSchema()==null) {
				return false;
			}
		}

		//outputqueue for stream tuple propagation 
		//Note: we do not care about schema of intermediate result queue
		for (int i=0;i<this.getOutputQueueCount()-2;i++ )
			if (this.getOutputQueue(i).getSchema() == null) {
				init(i);
			}

		//Outputqueue for pipelined-join
		//We assume here that the plan generator will use the LAST outputqueue
		// for the output of the pipelined window join
		if (this.getOutputQueue(this.getOutputQueueCount()-1)!=null && this.getOutputQueue(this.getOutputQueueCount()-1).getSchema()==null) {
			this.initResult(this.getOutputQueueCount()-1);
		}

		/** figure out how many tuples to dequeue from input queues */
		Iterator it= this.getInputQueues();
		int size =0;
		while (it.hasNext()) {
			XATQueue inputQueue = (XATQueue)it.next();
			size += inputQueue.getQueueSize(this);
		}
		int dequeueHowmany = Integer.parseInt(this
				.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));

		//System.out.println(this + "tuple to dequeue " + dequeueHowmany);

		int total = (dequeueHowmany > size) ? size
				: dequeueHowmany;

		int totalOutput =0;

		
		//begin exp stat collect
		long timeNow =System.currentTimeMillis()/1000;
		if (timeNow!=this.secondCounter) {
			//System.out.println(this.getOperatorID()+":"+this.getStateSize());
			//state_string.append(System.currentTimeMillis()+"\t"+this.getStateSize()+"\n");
			state_string.append(this.getStateSize()+"\n");
			this.secondCounter=timeNow;
		}
		
		XATTuple tempTuple = null;
		XATQueue tempQueue = null;
		for (int y=0;y<this.getInputQueueCount();y++){
			tempTuple = null;
			tempQueue = null;
			tempQueue = this.getInputQueue(y);
			if (tempQueue.getQueueSize()>0) {
					tempTuple = tempQueue.peek(this);

			}
			tuples[y]=tempTuple;
		}

		for (int x = 0; x < total;) {
			
			int z = findTupleWithMinTimestamp(tuples);
			
			if (z==-1) break;//total tuples have been processed. should not reach this.
			
			XATTuple tuple = this.getInputQueue(z).dequeue(this);
			x++;
			if (z<this.getInputQueueCount()-1) {//is stream tuple
				if (tuple.isProbe()){//male tuple
					totalOutput += this.processMaleTuple(tuple,z);
				} else {//female tuple
					this.processFemaleTuple(tuple,z);
				}
			} else {//is intermediate result tuple
				this.processIntermediateResult(tuple,z);
			}

			//fill the buffer, kind of merge-sorting of all the tuples in the input queues.
			tempTuple = null;
			tempQueue = null;
			tempQueue = this.getInputQueue(z);
			if (tempQueue.getQueueSize()>0) {
					tempTuple = tempQueue.peek(this);
			}
			tuples[z]=tempTuple;
			
		}
		//stats_string.append(System.currentTimeMillis()+"\t"+ totalOutput + "\n");	

//		try {
//			inputQueue.setProperty("DEQUEUED_TUPLE_COUNT", "" + total);
//			setNumberOfPossibleOutputs();
//		} catch (Exception e) {
//			System.out.println(e);
//		}
			
		return true;
	}

	void processFemaleTuple(XATTuple tuple,int i) {
		//insert into state
		((PipeWFIFOState) states[i]).insertTuple(tuple);
	}

	/**
	 * The following functions are basically for pipelined multiway join operators. 
	 * each intermediate result tuple contains the state number to be joined [0 to n-1]
	 * initialized as -1.
	 * The boolean ending means if it is an end tuple.
	 * The opID means the operator ID that generate this intermediate result
	 * For the original input stream tuples, all these three variables are meaningless.
	 * 
	 * NOTE: the streamID above is used to identify the stream that triggers the intermediate result.
	 * For example, if one a tuple from stream A is processed, then all the intermediate result has streamID = 0
	 * if the join order is A->C->B->E->D, then the (A,C) pair will have streamID=0, stateToJoin=1,
	 * (A,C,B) pair will have streamID=0, stateToJoin=4.
	 * If there is another join order of B->C->A->D->E, then the (B,C,A) pair will have streamID=1, stateToJoin=3
	 * Of cause the (A,C,B) and (B,C,A) tuple have the same schema and can't be distinguished by the tuple itself.
	 * 
	 * Actually, we can assume that the same prefix intermediate result will have the same further join ordering
	 * That is, the (A,C,B) and (B,C,A) tuples do not need to distinguish at all. The further join ordering
	 * must be the same for them. so right now, the streamID is used for the matrix entry only.
	 * 
	 * Added by Song Wang
	 * @return
	 */

	int processMaleTuple(XATTuple tuple,int from) {
		int outputCount= 0;
		XATTuple[] joinedtuples = null;
		//step 1: cross purge of all the states
	    //propagate purged tuple to corresponding output queues
		for (int i = 0; i< this.numOfInputs; i++){
			List purgedTuples = ((PipeWFIFOState) states[i])
			.purgeByTuplePipeCross(tuple);
			this.getOutputQueue(i).enqueue(purgedTuples,this);
		}
//		for (int i = 0; i < purgedTuples.size(); i++) {
//			((XATTuple) purgedTuples.get(i)).setStreamID(1);//0 for left, 1 for
//			// right
//		}
		//if (this.getOutputQueue(1)!=null) 
		
		//step 2: attach to outputqueue
//		if (this.getOutputQueue(1)!=null) {
//			XATTuple probeTuple = (XATTupleImp) (((XATTupleImp) tuple).clone());
//			probeTuple.setProbe(true);
//			probeTuple.setStreamID(0);
			this.getOutputQueue(from).enqueue(tuple,this);
//		}
			

		//step 3: probe the state
		int toBeProbe = this.joinOrderings[from][0];//the join probing state
		joinedtuples = ((PipeWFIFOState) states[toBeProbe]).probe(tuple,
				this.getExpression(0, 0));
		
		//mark the intermediate result
		for (int i = 0; i < joinedtuples.length; i++) {
			joinedtuples[i].setStreamID(from);
			joinedtuples[i].setOpID(this.getOperatorID());
			joinedtuples[i].setStateToJoin(this.joinOrderings[from][1]);
		}
			
		//by default, the last queue is join output queue
		//by default, the queue next to the last queue is the intermediate result queue
		//for (int i=0;i<this.getOutputQueueCount()-2;i++ ){
		this.getOutputQueue(this.getOutputQueueCount()-2).enqueue(joinedtuples, this);
		outputCount+=joinedtuples.length;
		//}
		return outputCount;
	}

	int processIntermediateResult(XATTuple tuple,int z){
		
		int outputCount= 0;
		XATTuple[] joinedtuples = new XATTuple[]{};
		boolean finalResult =false;
		
		//step 1: propagation if tuple.opID != operatorID
		if (tuple.getOpID()!=this.getOperatorID()) this.getOutputQueue(this.getOutputQueueCount()-2).enqueue(tuple,this);
		
		if (tuple.isDummy()) {
			return 0;
		}

		//step 2: probe the state
		int toBeProbe = tuple.getStateToJoin();//the join probing state
		joinedtuples = ((PipeWFIFOState) states[toBeProbe]).probe(tuple,
				this.getExpression(0, 0));
	
		//mark the intermediate result
		for (int i = 0; i < joinedtuples.length; i++) {
			joinedtuples[i].setStreamID(tuple.getStreamID());
			joinedtuples[i].setOpID(this.getOperatorID());
			int j=0;
			for (j=0;j<this.numOfInputs-2;j++) { 
				if (this.joinOrderings[tuple.getStreamID()][j]==tuple.getStateToJoin())
					break;
			}
			if (j==this.numOfInputs-2){//final join output achieved
				finalResult = true;
			} else {
			joinedtuples[i].setStateToJoin(this.joinOrderings[tuple.getStreamID()][j+1]);
			}
		}
		if (finalResult){
			this.getOutputQueue(this.getOutputQueueCount()-1).enqueue(joinedtuples, this);
			outputStat(joinedtuples);
		} else {
			this.getOutputQueue(this.getOutputQueueCount()-2).enqueue(joinedtuples, this);
		}
		outputCount+=joinedtuples.length;
		
		return outputCount;
		
	}
	void outputStat(XATTuple[] joinedTuples){
		//if (joinedTuples.length<=0) return;
		for (int i=0;i<joinedTuples.length;i++) {
			long nowTime = System.currentTimeMillis();
			this.output_string.append(nowTime-joinedTuples[i].getTimeEnter()+"\n");
			//System.out.println(nowTime-joinedTuples[i].getMaxTimeStamp());
		}
	}
	int findTupleWithMinTimestamp(XATTuple[] tuples){
		int ret = -1;
		XATTuple tempTuple = null;
		for (int i=0;i<tuples.length;i++){
			if (tuples[i]==null) continue;
			if (tempTuple==null ||tuples[i].getMaxTimeStamp()<=tempTuple.getMaxTimeStamp()){
				ret =i;
				tempTuple = tuples[i];
			}
		}
		return ret;
	}
	public void setDefaultProperties() {

		super.setDefaultProperties();
		addProperty("TIME_WINDOW", "0");
		addProperty("START_WINDOW", "0");
		addProperty("END_WINDOW", "0");
		// type of state
		addProperty("STATE_TYPE", "PIPEWFIFOSTATE");
	}

	public void printStatsToFile() {
		try {
			String fileName = new String(this.getOperatorID() +".state."+"txt");
			FileWriter out = new FileWriter(fileName, true);
			out.write(this.state_string.toString());
			out.close();

			String fileName2 = new String(this.getOperatorID() +".output."+"txt");
			FileWriter out2 = new FileWriter(fileName2, true);
			out2.write(this.output_string.toString());
			out2.close();
			
		} catch (IOException e) {
			System.out.println(e.toString());
		}
}
	/**
	 * Insert the method's description here. Creation date: (2/14/2003 9:33:59
	 * AM)
	 * 
	 * @return java.lang.String
	 */
	public String toString() {
		String rs = new String();

		String sName = this.getClass().getName();
		//find the last dot.
		int index = 0;
		for (index = sName.length() - 1; index >= 0; index--)
			if (sName.charAt(index) == '.')
				break;
		rs = sName.substring(index + 1) + " ";
		rs = rs + this.getOperatorID();
		String id = this.getProperty("OBJECT_ID");
		if (id == "-1") {
			rs = rs + " " + this.hashCode();
		} else {
			rs = rs + id + " " + this.hashCode();
		}

		if (this.isActive())
			rs += " ACTIVE ";
		else
			rs += " INACTIVE ";
		return rs;
	}
	public boolean finalizeOperation() {
		this.printStatsToFile();
		
		System.out.println("\n\nStatistic Collection Done\n");
		return true;
	}

	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean cleanAllAccumulatedTuples() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean hasUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean matchStates(XATStreamOperator op) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean recomputeUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	public String toToolTipString() {
		// TODO Auto-generated method stub
		return null;
	}
}