/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestreamoperator;

import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestate.PipeWFIFOState;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

public class PipeWMJoinOperatorInterleavedTailImp extends PipeWMJoinOperatorInterleavedImp {

	public PipeWMJoinOperatorInterleavedTailImp(PipeWMJoinOperatorInterleavedImp oldop,
			XATNode newnode) {
		super(oldop, newnode);
		// TODO Auto-generated constructor stub
	}

	public PipeWMJoinOperatorInterleavedTailImp(XATNode init) {
		super(init);
		// TODO Auto-generated constructor stub
	}

	public PipeWMJoinOperatorInterleavedTailImp(XATNode init, int n) {
		super(init, n);
		// TODO Auto-generated constructor stub
	}
	int processMaleTuple(XATTuple tuple,int from) {
		int outputCount= 0;
		XATTuple[] joinedtuples = null;
		//step 1: cross purge of all the states
	    //propagate purged tuple to corresponding output queues
		for (int i = 0; i< this.numOfInputs; i++){
			List purgedTuples = ((PipeWFIFOState) states[i])
			.delayedPurgeByTuplePipeCross(tuple);//.purgeByTuplePipeCross(tuple);
			//this.getOutputQueue(i).enqueue(purgedTuples,this);
		}
//		for (int i = 0; i < purgedTuples.size(); i++) {
//			((XATTuple) purgedTuples.get(i)).setStreamID(1);//0 for left, 1 for
//			// right
//		}
		//if (this.getOutputQueue(1)!=null) 
		
		//step 2: attach to outputqueue
//		if (this.getOutputQueue(1)!=null) {
//			XATTuple probeTuple = (XATTupleImp) (((XATTupleImp) tuple).clone());
//			probeTuple.setProbe(true);
//			probeTuple.setStreamID(0);
			//this.getOutputQueue(from).enqueue(tuple,this);
//		}
			

		//step 3: probe the state
		int toBeProbe = this.joinOrderings[from][0];//the join probing state
		joinedtuples = ((PipeWFIFOState) states[toBeProbe]).probe(tuple,
				this.getExpression(0, 0));
		
		//mark the intermediate result
		for (int i = 0; i < joinedtuples.length; i++) {
			joinedtuples[i].setStreamID(from);
			joinedtuples[i].setOpID(this.getOperatorID());
			joinedtuples[i].setStateToJoin(this.joinOrderings[from][1]);
		}
			
		//by default, the last queue is join output queue
		//by default, the queue next to the last queue is the intermediate result queue
		//for (int i=0;i<this.getOutputQueueCount()-2;i++ ){
		this.getOutputQueue(this.getOutputQueueCount()-2).enqueue(joinedtuples, this);
		outputCount+=joinedtuples.length;
		//}
		return outputCount;
	}
	int processIntermediateResult(XATTuple tuple,int z){
		
		int outputCount= 0;
		XATTuple[] joinedtuples = new XATTuple[]{};
		boolean finalResult =false;
		
		//finish the real purge since we now are using delayed state purge.
		//then do the real purge, propagate this purge tuple and no need to probe
		if (tuple.isRealPurge()){
			for (int i = 0; i< this.numOfInputs; i++){
				List purgedTuples = ((PipeWFIFOState) states[i])
				.purgeByTuplePipeCross(tuple);
			}
			//this.getOutputQueue(this.getOutputQueueCount()-2).enqueue(tuple,this);
			//System.out.println("tail: real purge");
			//return 0;
		} else
		//step 1: propagation if tuple.opID != operatorID
		if (tuple.getOpID()!=this.getOperatorID()) this.getOutputQueue(this.getOutputQueueCount()-2).enqueue(tuple,this);
		
		if (tuple.isDummy()) {
			return 0;
		}

		//step 2: probe the state
		int toBeProbe = tuple.getStateToJoin();//the join probing state
		joinedtuples = ((PipeWFIFOState) states[toBeProbe]).probe(tuple,
				this.getExpression(0, 0));
	
		//mark the intermediate result
		for (int i = 0; i < joinedtuples.length; i++) {
			joinedtuples[i].setStreamID(tuple.getStreamID());
			joinedtuples[i].setOpID(this.getOperatorID());
			int j=0;
			for (j=0;j<this.numOfInputs-2;j++) { 
				if (this.joinOrderings[tuple.getStreamID()][j]==tuple.getStateToJoin())
					break;
			}
			if (j==this.numOfInputs-2){//final join output achieved
				finalResult = true;
			} else {
			joinedtuples[i].setStateToJoin(this.joinOrderings[tuple.getStreamID()][j+1]);
			}
		}
		if (finalResult){
			this.getOutputQueue(this.getOutputQueueCount()-1).enqueue(joinedtuples, this);
			outputStat(joinedtuples);

		} else {
			this.getOutputQueue(this.getOutputQueueCount()-2).enqueue(joinedtuples, this);
		}
		outputCount+=joinedtuples.length;
		
		return outputCount;
		
	}

}