/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-3-11
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;

import java.util.HashMap;
import java.util.Vector;
import java.util.Iterator;
import java.io.Serializable;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public abstract class GroupbyIndexImp implements GroupbyIndex, Serializable {
	protected int INIT_CAPACITY = 500;
	protected float LOAD_FACTOR = (float)0.8;
	
	protected HashMap hashtable;
	protected Object[] ancesterKeys; //for migration purpose
	protected Object[] searchKeys;

	public GroupbyIndexImp() {
		hashtable = new HashMap(INIT_CAPACITY, LOAD_FACTOR);
	}

	public void put(Object key, Object value) {
		hashtable.put(key, value);
	}
	public Iterator iterator() {
		return hashtable.values().iterator();
	}
	public Object[] getAncesterKeys() {
		return ancesterKeys;
	}
	public void setAncesterKeys(Object[] aKeys) {
		ancesterKeys = aKeys;
	}
	public Object[] getSearchKeys() {
		return searchKeys;
	}
	public void setSearchKeys(Object[] sKeys) {
		searchKeys = sKeys;
	}

	//match all input keys
	public boolean equalKeys(Object[] inputKeys) {
		int numInputKeys = inputKeys.length;
		if (searchKeys.length != numInputKeys) {
			return false;
		} else {
			for (int i=0; i<numInputKeys; i++) {
				if (!searchKeys[i].equals(inputKeys[i])) {
					return false;
				}
			}
			return true;
		}
	}
	
	public boolean equalKeys(XATDataValue[] punctContent, 
			int[] punctType, int[] keysPos) {
		int numKeysToCompare = keysPos.length;
		if (searchKeys.length != numKeysToCompare) {
			return false;
		} else {
			for (int i=0; i<numKeysToCompare; i++) {
				int index = keysPos[i];
				if (punctType[index] == XATPunct.SINGLE_VALUE 
						&& !searchKeys[i].equals(punctContent[index].getValue())) {
					return false;
				}
			}
			return true;
		}
	}
	
	public abstract Object hash(Object[] keys);
	
	public abstract Object getEntry(Object[] keys, Object[] gbKeys, String nextIndexType,
			boolean leafLevel);
	
	public abstract Vector probe(XATTuple tuple, Object[] gbKeys, 
			boolean leafLevel, int[] indexAttrPosArray, Object[] ancKeys,
			String nextIndexType, boolean nextLeafLevelFlag, 
			long invalidTime); 
	
	public abstract Vector generateGroups(XATDataValue[] punctContent, int[] punctType, 
			int[] groupAttrPosArray, boolean leafLevel, int[] indexAttrPosArray,
			long invalidTime);
}
