/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-3-11
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import java.util.Vector;
import java.util.Iterator;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class GroupbySingleValueHashIndexImp extends GroupbyIndexImp {
	
	public GroupbySingleValueHashIndexImp() {
		super();
	}
	public Object hash(Object[] keys) {
		return keys[0];
	}
	public Object getEntry(Object[] keys, Object[] gbKeys, 
			String nextIndexType, boolean leafLevel) {
		Object obj = hashtable.get(keys[0]);
		if (obj == null) {
			if (leafLevel) {
				HashBucket bucket = new HashBucket(gbKeys);
				hashtable.put(keys[0], bucket);
				return bucket;
			} else {
				GroupbyIndex index = null;
				try {
					index = (GroupbyIndex)Class.forName(nextIndexType).newInstance();
				} catch (Exception e) {
					e.printStackTrace();
				}
				index.setSearchKeys(keys);
				hashtable.put(keys[0], index);
				return index;
			}
		} else {
			return obj;
		}
	}

	public Vector probe(XATTuple tuple, Object[] gbKeys, boolean leafLevel, 
			int[] indexAttrPosArray, Object[] ancKeys, String nextIndexType, 
			boolean nextLeafLevelFlag, long invalidTime) {
		Vector result = new Vector();
		Object key_0 = tuple.getCell(indexAttrPosArray[0]).getValue();
		Object obj = hashtable.get(key_0);
		if (obj == null) {
			if (leafLevel) {
				HashBucket bucket = new HashBucket(gbKeys);
				bucket.add(tuple);
				hashtable.put(key_0, bucket);
			} else {
				GroupbyIndex index = null;
				try {
					index = (GroupbyIndex)Class.forName(nextIndexType).newInstance();
				} catch (Exception e) {
					e.printStackTrace();
				}
				index.setAncesterKeys(ancKeys);
				Object[] sKeys = new Object[]{key_0};
				index.setSearchKeys(sKeys);
				hashtable.put(key_0, index);
				result.add(index);
			}
		} else {
			if (leafLevel) { //obj is a vector of XATTuple
				HashBucket bucket = (HashBucket)obj;
				int numTuplesInBucket = bucket.size();
				for (int i=0; i<numTuplesInBucket; i++) {
					if (((XATTuple)bucket.get(0)).getMinTimeStamp()<invalidTime) {
						bucket.remove(0);
					} else {
						break;
					}
				}
				bucket.add(tuple);
			} else {
				result.add(obj);
			}
		}
		return result;
	}

	public Vector generateGroups(XATDataValue[] punctContent, int[] punctType, 
			int[] groupAttrPosArray, boolean leafLevel, int[] indexAttrPosArray,
			long invalidTime) {
		Vector result = new Vector();
		int punctValueType = punctType[indexAttrPosArray[0]];
		if (punctValueType == XATPunct.ALL_VALUE) {
			Iterator it = hashtable.values().iterator();
			if (leafLevel) {
				while (it.hasNext()) {
					HashBucket bucket = (HashBucket) it.next(); //bucket of GroupbyHashEntry
					int numEntries = bucket.size();
					int i=0;
					for (; i<numEntries; i++) {
						XATTuple entry = (XATTuple)bucket.get(0);
						if (entry.getMinTimeStamp()<invalidTime) {
							bucket.remove(0);
						} else {
							break;
						}
					}
					numEntries = bucket.size();
					i=0;
					for (; i<numEntries; i++) {
						XATTuple entry = (XATTuple)bucket.get(i);
						if (entry.equalKeys(punctContent, punctType, groupAttrPosArray)) {
							result.add(entry);
						}
					}
				}
			} else {
				while (it.hasNext()) {
					result.add(it.next());
				}
			}
		} else if (punctValueType == XATPunct.SINGLE_VALUE) {
			Object key = punctContent[indexAttrPosArray[0]].getValue();
			Object obj = hashtable.get(key);
			if (obj != null) {
				if (leafLevel) {
					HashBucket bucket = (HashBucket)obj;
					int numEntries = bucket.size();
					int i=0;
					for (; i<numEntries; i++) {
						XATTuple entry = (XATTuple)bucket.get(0);
						if (entry.getMinTimeStamp()<invalidTime) {
							bucket.remove(0);
						} else {
							break;
						}
					}
					numEntries = bucket.size();
					i=0;
					for (; i<numEntries; i++) {
						XATTuple entry = (XATTuple)bucket.get(i);
						if (entry.equalKeys(punctContent, punctType, groupAttrPosArray)) {
							result.add(entry);
						}
					}
				} else {
					result.add(obj);
				}
			}
		}
		return result;
	}
}
