/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Sep 1, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import java.util.Vector;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class HashBucket {
	protected Object[] keys; //groupby keys
	protected Vector objList;
	
	public HashBucket() {
		objList = new Vector();
	}
	public HashBucket(Object[] ks) {
		keys = ks;
		objList = new Vector();
	}
	public Object[] getKeys() {
		return keys;
	}
	public void setKeys(Object[] ks) {
		keys = ks;
	}
	public Vector getObjList() {
		return objList;
	}
	public Object get(int pos) {
		return objList.get(pos);
	}
	public void add(Object obj) {
		objList.add(obj);
	}
	public void addTupleByTime(XATTuple tuple) {
		int numTuples = objList.size();
		if (numTuples == 0) {
			objList.add(tuple);
		} else {
			long timestamp = tuple.getMinTimeStamp();
			for (int i=0; i<numTuples; i++) {
				XATTuple t = (XATTuple)objList.get(i);
				if (timestamp < t.getMinTimeStamp()) {
					objList.insertElementAt(tuple, i);
					return;
				}
			}
			objList.add(tuple);
		}
	}
	public void remove(int pos) {
		objList.remove(pos);
	}
	public int size() {
		return objList.size();
	}
}
