/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Aug 12, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorStateImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import java.util.ArrayList;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class PunctGroupbyStateImp extends OperatorStateImp
	implements PunctAwareState {
	
	protected int INIT_CAPACITY = 500;
	protected float LOAD_FACTOR = (float)0.8;

	protected int numIndexAttrs;
	protected int[] indexAttrPosArray;
	protected int[] indexAttrTypeArray;
	protected int numAggFunctions;
	protected StreamFunction[] aggFunctions;
	protected int basicWindowSize = Integer.MAX_VALUE;
	
	public PunctGroupbyStateImp() {
		super();
	}
	
	public abstract void init();

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareHashState#probe(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple, int)
	 */
	public abstract XATTuple[] probe(XATTuple tuple);

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareState#probe(java.lang.Object)
	 */
	public XATTuple[] probe(Object key) {
		return null;
	}

	/**
	 * @param punct
	 * @return
	 */
	public abstract ArrayList generateGroups(XATPunct punct);

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareHashState#purgeByPunct(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple, int)
	 */
	public int purge(Object key) {
		return 0;
	}

	public int purge(XATPunct tuple) {
		return 0;
	}
	
	public void copyStateContent(OperatorState newstate) {
	}
	
	public Object[] invalidate(long earliestProcessTupleTime){
		return null;
	}
	
	public Object[] invalidateSingleGroup(Object key, long earliestProcessTupleTime) {
		return null;
	}
	public Object getAllStateTuples() {
		return null;
	}
	public void setIndexAttrPosArray(int[] iAttrPosArray) {
		this.numIndexAttrs = iAttrPosArray.length;
		this.indexAttrPosArray = iAttrPosArray;
	}
	public void setIndexAttrTypeArray(int[] iAttrTypeArray) {
		this.indexAttrTypeArray = iAttrTypeArray;
	}
	
	public int getNumIndexAttrs() {
		return numIndexAttrs;
	}
	public void setNumIndexAttrs(int nIndexAttrs) {
		this.numIndexAttrs = nIndexAttrs;
	}
	public int getBasicWindowSize() {
		return basicWindowSize;
	}
	public void setBasicWindowSize(int bWindowSize) {
		this.basicWindowSize = bWindowSize;
	}
	public StreamFunction getAggFunction(int pos) {
		return aggFunctions[pos];
	}
	public StreamFunction[] getAggFunctions() {
		return aggFunctions;
	}
	public void setAggFunction(int pos, StreamFunction function) {
		aggFunctions[pos] = function;
	}
	public void setAggFunctions(StreamFunction[] functions) {
		aggFunctions = functions;
		numAggFunctions = functions.length;
	}
	public int getNumAggFunctions() {
		return numAggFunctions;
	}
	public void setNumAggFunctions(int numAggFuncs) {
		this.numAggFunctions = numAggFuncs;
	}
}
