/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-3-13
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import java.util.HashMap;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 * 
 * Combined-key hash state
 */
public class PunctHashFlatGroupbyStateImp extends PunctGroupbyStateImp {
	
	protected HashMap hashtable;
	protected static int HASH_FACTOR = 128;
	
	public PunctHashFlatGroupbyStateImp() {
	}
	
	public void init() {
		hashtable = new HashMap(INIT_CAPACITY, LOAD_FACTOR);
	}
	
	private int hash(Object keys[]) {
		int hashValue = 0;
		for (int i=0; i<numIndexAttrs; i++) {
			int hashKey = ((Number)keys[i]).intValue();
			hashValue += hashKey * (2^i) * HASH_FACTOR; 
		}
		return hashValue;
	}

	public XATTuple[] probe(XATTuple tuple) {
		XATDataValue[] tupleContent = tuple.getArrayData();
		Object[] keyArray = new Object[numIndexAttrs];
		
		for (int i=0; i<numIndexAttrs; i++) {
			keyArray[i] = tupleContent[indexAttrPosArray[i]].getValue();
		}
		Integer hashKey = new Integer(hash(keyArray));
		Object obj = hashtable.get(hashKey);
		if (obj == null) {
			ArrayList entryList = new ArrayList();
			GroupbyHashEntry newEntry = new GroupbyHashEntry(keyArray);
			newEntry.insertTuple(tuple);
			entryList.add(newEntry);
			hashtable.put(hashKey, entryList);
		} else {
			ArrayList entryList = (ArrayList)obj;
			int numEntries = entryList.size();
			if (numEntries == 0) {
				GroupbyHashEntry newEntry = new GroupbyHashEntry(keyArray);
				newEntry.insertTuple(tuple);
				entryList.add(newEntry);
			} else {
				Iterator it = entryList.iterator();
				boolean foundGroup = false;
				while(it.hasNext()) {
					GroupbyHashEntry nextEntry = (GroupbyHashEntry)it.next();
					if (nextEntry.equalKeys(keyArray)) {
						nextEntry.insertTuple(tuple);
						foundGroup = true;
						break;
					}
				}
				if (!foundGroup) {
					GroupbyHashEntry newEntry = new GroupbyHashEntry(keyArray);
					newEntry.insertTuple(tuple);
					entryList.add(newEntry);
				}
			}
		}
		return null;
	}
	
	public ArrayList generateGroups(XATPunct punct) {
		XATDataValue[] punctContent = punct.getArrayData();
		int[] punctType = punct.getPunctTypeArray();
		Object[] keys = new Object[numIndexAttrs];
		ArrayList singleValueAttrPos = new ArrayList();
		
		for (int i=0; i<numIndexAttrs; i++) {
			int index = indexAttrPosArray[i];
			if (punctType[index] == XATPunct.SINGLE_VALUE) {
				singleValueAttrPos.add(new Integer(i));
				keys[i] = punctContent[index].getValue();
			} else {
				keys[i] = null;
			}
		}
		
		int numSingleValueAttrs = singleValueAttrPos.size();
		ArrayList result = new ArrayList();
		if (numSingleValueAttrs == numIndexAttrs) {
			Integer hashKey = new Integer(hash(keys));
			ArrayList entryList = (ArrayList)hashtable.get(hashKey);
			int numEntries = entryList.size();
			for (int i=0; i<numEntries; i++) {
				GroupbyHashEntry nextEntry = (GroupbyHashEntry)entryList.get(i);
				if (nextEntry.equalKeys(keys)) {
					result.add(nextEntry);
					entryList.remove(i);
					break;
				}
			}
		} else {
			int[] indexToCompare = new int[numSingleValueAttrs];
			for (int i=0; i<numSingleValueAttrs; i++) {
				indexToCompare[i] = ((Integer)singleValueAttrPos.get(i)).intValue();
			}
			Iterator entryListIterator = hashtable.values().iterator();
			while (entryListIterator.hasNext()) {
				ArrayList nextEntryList = (ArrayList)entryListIterator.next();
				int numEntries = nextEntryList.size();
				int cursor = 0;
				while (cursor<numEntries) {
					GroupbyHashEntry nextEntry = (GroupbyHashEntry)nextEntryList.get(cursor);
					if (nextEntry.equalKeys(keys, indexToCompare)) {
						result.add(nextEntry);
						nextEntryList.remove(cursor);
						numEntries --;
					} else {
						cursor ++;
					}
				}
			}
		}
		return result;
	}

	public void clearState() {
		// TODO Auto-generated method stub
		
	}
}
