/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Aug 12, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorStateImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Enumeration;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PunctHashGroupbyStateImp extends OperatorStateImp
	implements PunctAwareState {
	
	static int INTERVAL = 100000; //used by hash function
	protected int[] indexAttrPosArray;
	protected Hashtable hashtable = new Hashtable();
	protected int basicWindowSize = Integer.MAX_VALUE;
	protected StreamFunction[] aggFunctions;
	protected int numAggFunctions;
	
	public PunctHashGroupbyStateImp() {
		super();
	}
	
	/*
	public PunctHashGroupbyStateImp(PunctHashGroupbyStateImp oldstate, 
			XATStreamOperator newop) {
		super(oldstate, newop);
		this.isMatched = false;
	}*/

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareHashState#probe(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple, int)
	 */
	public XATTuple[] probe(XATTuple tuple) {
		Object hashValue = hash(tuple);
		Object obj = hashtable.get(hashValue);
		if (obj == null) {
			ArrayList bucketList = new ArrayList();
			bucketList.add(tuple);
			hashtable.put(hashValue, bucketList);
		} else {
			((ArrayList)obj).add(tuple);
		}
		//update state size
		//this.increStateSize();
		return null;
	}

	private Object hash(XATTuple tuple) {
		int value_0 = ((Integer)tuple.getCell(indexAttrPosArray[0]).getValue()).intValue();
		int value_1 = ((Integer)tuple.getCell(indexAttrPosArray[1]).getValue()).intValue();
		Integer hashValue = new Integer(value_1*INTERVAL+value_0);
		return hashValue;
	}
	
	public XATTuple[] probe(Object key) {
		return null;
	}


	public ArrayList generateGroups(Object groupVal, int attrPos) {
		ArrayList result = new ArrayList();
		int groupValue = ((Integer)groupVal).intValue();
		Enumeration en = hashtable.keys();
		while (en.hasMoreElements()) {
			Object hashKey = en.nextElement();
			int keyValue = ((Integer)hashKey).intValue();
			int restoreValue;
			if (attrPos == indexAttrPosArray[0]) {
				restoreValue = keyValue%INTERVAL;
			} else {
				restoreValue = keyValue/INTERVAL;
			}
			if (restoreValue == groupValue) {
				Object matchTupleList = hashtable.get(hashKey);
				if (matchTupleList!=null) {
					result.add(matchTupleList);
				}
				//purge
				hashtable.remove(hashKey);
			}
		}
		return result;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareHashState#purgeByPunct(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple, int)
	 */
	public int purge(Object key) {
		//update state size
		int numTuplesPurged = 0;
		Object bucket = hashtable.get(key);
		if (bucket != null) {
			numTuplesPurged = ((ArrayList)bucket).size();
			//this.decreStateSize(numTuplesPurged);
		}
		hashtable.remove(key);
		return numTuplesPurged;
	}

	public int purge(XATPunct tuple) {
		return 0;
	}
	public void copyStateContent(OperatorState newstate) {
	}
	public Object[] invalidate(long earliestProcessTupleTime){
		Enumeration en = hashtable.keys();
		while(en.hasMoreElements()) {
			Object key = en.nextElement();
			ArrayList tupleList = (ArrayList)hashtable.get(key);
			while (tupleList.size()>0) {
				long time = ((XATTuple)tupleList.get(0)).getNthTimeStamp(indexAttrPosArray[0]);
				if (time<earliestProcessTupleTime) {
					tupleList.remove(0);
				} else {
					break;
				}
			}
			if (tupleList.size()==0) {
				hashtable.remove(key);
			}
		}
		return null;
	}
	
	public Object[] invalidateSingleGroup(Object key, long earliestProcessTupleTime) {
		Object entry = hashtable.get(key);
		if (entry != null) {
			ArrayList tupleList = (ArrayList)entry;
			while (tupleList.size()>0) {
				long time = ((XATTuple)tupleList.get(0)).getNthTimeStamp(indexAttrPosArray[0]);
				if (time<earliestProcessTupleTime) {
					tupleList.remove(0);
				} else {
					break;
				}
			}
			if (tupleList.size()==0) {
				hashtable.remove(key);
			}
		}
		return null;
	}
	public Object getAllStateTuples() {
		return hashtable;
	}
	public void setIndexAttrPosArray(int[] indexAttrPosArray) {
		int numAttrs = indexAttrPosArray.length;
		this.indexAttrPosArray = new int[numAttrs];
		for (int i=0; i<numAttrs; i++) {
			this.indexAttrPosArray[i] = indexAttrPosArray[i];
		}
	}
	public int getBasicWindowSize() {
		return basicWindowSize;
	}
	public void setBasicWindowSize(int bWindowSize) {
		this.basicWindowSize = bWindowSize;
	}
	public StreamFunction getAggFunction(int pos) {
		return aggFunctions[pos];
	}
	public StreamFunction[] getAggFunctions() {
		return aggFunctions;
	}
	public void setAggFunction(int pos, StreamFunction function) {
		aggFunctions[pos] = function;
	}
	public void setAggFunctions(StreamFunction[] functions) {
		aggFunctions = functions;
		numAggFunctions = functions.length;
	}
	public int getNumAggFunctions() {
		return numAggFunctions;
	}
	public void setNumAggFunctions(int numAggFuncs) {
		this.numAggFunctions = numAggFuncs;
	}

	public void clearState() {
		// TODO Auto-generated method stub
		
	}
}
