/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-2-2
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.HashMap;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PunctHashHierarchyGroupbyStateImp extends PunctGroupbyStateImp {
	protected HashMap hashtable; //top-level hash table
	//for reusing hashtables
	protected ArrayList hashtableRecycle; //hashtable recycle bin
	protected int numHashtables; //# hashtables in recycle bin
	
	public PunctHashHierarchyGroupbyStateImp() {
	}

	public void init() {
		hashtable = new HashMap(INIT_CAPACITY, LOAD_FACTOR);
		hashtableRecycle = new ArrayList();
		numHashtables = 0;
	}

	private void recycleHashtable(HashMap htable, int indexLevel) {
		hashtableRecycle.add(htable);
		numHashtables ++;
		if (indexLevel < numIndexAttrs - 1) {
			ArrayList oldEntries = new ArrayList();
			oldEntries.add(htable);
			for (int i=indexLevel; i<numIndexAttrs-1; i++) { //recursively recycle hash table
				ArrayList newEntries = new ArrayList();
				Iterator it = oldEntries.iterator();
				while (it.hasNext()) {
					HashMap hMap = (HashMap)it.next();
					hashtableRecycle.add(hMap);
					numHashtables ++;
					newEntries.add(hMap.values().iterator());
				}
				oldEntries = newEntries;
			}
			int numEntries = oldEntries.size();
			for (int i=0; i<numEntries; i++) {
				Iterator it = (Iterator)oldEntries.get(i);
				while(it.hasNext()) {
					hashtableRecycle.add(it.next());
					numHashtables ++;
				}
			}
		}
	}
	
	private HashMap createHashtable() {
		if (numHashtables > 0) {
			numHashtables --;
			HashMap nextHashMap = (HashMap)hashtableRecycle.get(numHashtables);
			hashtableRecycle.remove(numHashtables);
			nextHashMap.clear();
			return nextHashMap;
		} else {
			return new HashMap(INIT_CAPACITY, LOAD_FACTOR);
		}
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareHashState#probe(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple, int)
	 */
	public XATTuple[] probe(XATTuple tuple) {
		XATDataValue[] tupleContent = tuple.getArrayData();
		Object[] keyArray = new Object[numIndexAttrs];
		HashMap currentTable = hashtable;
		Object hashEntryObj = null;
		int cursor = 0;
		while (cursor<numIndexAttrs) {
			Object key = tupleContent[indexAttrPosArray[cursor]].getValue();
			keyArray[cursor] = key;
			cursor ++;
			hashEntryObj = currentTable.get(key);
			if (hashEntryObj == null) { 
				if (cursor == numIndexAttrs) {
					GroupbyHashEntry leafHashEntry = new GroupbyHashEntry(keyArray);
					leafHashEntry.insertTuple(tuple);
					currentTable.put(key, leafHashEntry);
				} else {
					while (cursor < numIndexAttrs) {
						HashMap newTable = this.createHashtable();
						currentTable.put(key, newTable);
						currentTable = newTable;
						key = tupleContent[indexAttrPosArray[cursor]].getValue();;
						keyArray[cursor] = key;
						cursor ++;
					}
					GroupbyHashEntry leafHashEntry = new GroupbyHashEntry(keyArray);
					leafHashEntry.insertTuple(tuple);
					currentTable.put(key, leafHashEntry);
					break;
				}
			} else {
				if (cursor == numIndexAttrs) {
					GroupbyHashEntry leafHashEntry = (GroupbyHashEntry)hashEntryObj;
					leafHashEntry.insertTuple(tuple);
				} else {
					currentTable = (HashMap)hashEntryObj;
				}
			}
		}
		return null;
	}

	public ArrayList generateGroups(XATPunct punct) {
		ArrayList tempResult = new ArrayList();
		tempResult.add(hashtable);
		ArrayList newTempResult = new ArrayList();
		XATDataValue[] punctContent = punct.getArrayData();
		int[] punctType = punct.getPunctTypeArray();
		boolean[] deleteFlags = new boolean[numIndexAttrs];
		int cursor = numIndexAttrs-1;
		while (cursor>0) {
			deleteFlags[cursor] = true;
			cursor --;
			if (punctType[indexAttrPosArray[cursor]] != XATPunct.ALL_VALUE) {
				deleteFlags[cursor] = true;
				break;
			}
		}
		cursor --;
		while (cursor>=0) {
			deleteFlags[cursor] = false;
			cursor --;
		}
		
		boolean foundGroups = true;
		for (int i=0; i<numIndexAttrs; i++) {
			if (tempResult.size()==0) {
				foundGroups = false;
				break;
			}
			Iterator it = tempResult.iterator();
			int index = indexAttrPosArray[i];
			if (punctType[index]==XATPunct.SINGLE_VALUE) {
				Object key = punctContent[index].getValue();
				while (it.hasNext()) {
					Object nextEntryObj = it.next();
					if (nextEntryObj instanceof HashMap) {
						HashMap nextTable = (HashMap)nextEntryObj;
						Object newEntryObj = nextTable.get(key);
						if (newEntryObj != null) {
							newTempResult.add(newEntryObj);
							if (deleteFlags[i]) {
								//if (i<numIndexAttrs-2) {
									//this.recycleHashtable((HashMap)nextEntryObj, i+1);
								//}
								nextTable.remove(key);
							}
						}
					} else if (nextEntryObj instanceof Collection) {
						HashMap[] hMapCollection = (HashMap[])((Collection)nextEntryObj).toArray(new HashMap[]{});
						int numMapsInCollection = hMapCollection.length;
						for (int k=0; k<numMapsInCollection; k++) {
							HashMap nextTable = hMapCollection[k];
							Object newEntryObj = nextTable.get(key);
							if (newEntryObj != null) {
								newTempResult.add(newEntryObj);
								if (deleteFlags[i]) {
									if (i<numIndexAttrs-2) {
										this.recycleHashtable((HashMap)nextEntryObj, i+1);
									}
									nextTable.remove(key);
								}
							} //end if
						} //end while
					} //end else if
				} //end while
			} else if (punctType[index]==XATPunct.ALL_VALUE) {
				while (it.hasNext()) {
					Object nextEntryObj = it.next();
					if (nextEntryObj instanceof HashMap) {
						newTempResult.add(((HashMap)nextEntryObj).values());
					} else if (nextEntryObj instanceof Collection) {
						HashMap[] hMapCollection = (HashMap[])((Collection)nextEntryObj).toArray(new HashMap[]{});
						int numMapsInCollection = hMapCollection.length;
						for (int k=0; k<numMapsInCollection; k++) {
							newTempResult.add(hMapCollection[k].values());
						} //end if
					} //end else if
				} //end while
			} //end else if
			tempResult = newTempResult;
			newTempResult = new ArrayList();
		}
		ArrayList result = new ArrayList();
		if (foundGroups) {
			Iterator it = tempResult.iterator();
			while (it.hasNext()){
				Object nextResult = it.next();
				if (nextResult instanceof Collection) {
					result.addAll((Collection)nextResult);
				} else {
					result.add(nextResult);
				}
			}
		}
		return result;
	}

	public void clearState() {
		// TODO Auto-generated method stub
		
	}
}
