/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-1-20
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Enumeration;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PunctHashPartitionWinStateImp extends PunctHashGroupbyStateImp {
	
	int window_size = 1;
	ArrayList tuples = new ArrayList();
	
	public PunctHashPartitionWinStateImp() {
		super();
	}
	
	public void insertTuple(XATTuple tuple) {
		tuples.add(tuple);
	}
	
	public void processTuples() {
		int numTuples = tuples.size();
		Hashtable tempHash = new Hashtable();
		for (int i=0; i<numTuples; i++) {
			XATTuple tuple = (XATTuple)tuples.get(i);
			Object groupVal = tuple.getCell(indexAttrPosArray[0]).getValue();
			Object obj = tempHash.get(groupVal);
			if (obj == null) {
				ArrayList bucketList = new ArrayList();
				bucketList.add(tuple);
				tempHash.put(groupVal, bucketList);
			} else {
				((ArrayList)obj).add(tuple);
			}
			//update state size
			this.increStateSize();
		}
		Enumeration en = tempHash.keys();
		while(en.hasMoreElements()) {
			Object key = en.nextElement();
			ArrayList tupleList = (ArrayList)tempHash.get(key);
			int numTuplesInList = tupleList.size();
			if (numTuplesInList >= window_size) {
				for (int i=0; i< (numTuplesInList - window_size); i++) {
					tupleList.remove(0);
				}
				hashtable.put(key, tupleList);
			} else {
				Object oldEntry = hashtable.get(key);
				if (oldEntry == null) {
					hashtable.put(key, tupleList);
				} else {
					ArrayList oldTupleList = (ArrayList)oldEntry;
					int numTuplesToRemove = oldTupleList.size() + numTuplesInList - window_size;
					for (int i=0; i< numTuplesToRemove; i++) {
						oldTupleList.remove(0);
					}
					oldTupleList.addAll(tupleList);
				}
			}
		}
		tuples.clear();
	}

	public int getWindowSize() {
		return window_size;
	}
	
	public void setWindowSize(int wSize) {
		this.window_size = wSize;
	}
}
