/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-2-2
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PunctHashSingleAttributeGroupbyStateImp extends
		PunctGroupbyStateImp {
	
	protected Hashtable hashtable;
	protected Hashtable ignoreValues;

	public PunctHashSingleAttributeGroupbyStateImp() {
		super();
		hashtable = new Hashtable();
		ignoreValues = new Hashtable();
	}
	public void init() {
		
	}
	public XATTuple[] probe(XATTuple tuple) {
		Object groupVal = tuple.getCell(indexAttrPosArray[0]).getValue();
		if (ignoreValues.containsKey(groupVal)) {
			return null;
		}
		Object obj = hashtable.get(groupVal);
		if (obj == null) {
			GroupbyHashEntry hashEntry = new GroupbyHashEntry(new Object[] {groupVal});
			double[] currentValueArray = new double[numAggFunctions];
			for (int i=0; i<numAggFunctions; i++) {
				currentValueArray[i] = aggFunctions[i].getInitialValue();
			}
			hashEntry.setCurrentValueArray(currentValueArray);
			hashEntry.insertTuple(tuple);
//			 print out the insert tuple
			//System.out.println("insert into state: " + tuple.toString());
			//hashEntry.setTimestamp(tuple.getTimeStamp());
			hashEntry.setMaxTimestamp(tuple.getMaxTimeStamp());
			hashEntry.setMinTimestamp(tuple.getMinTimeStamp());
			if (hashEntry.getNumTuples() == basicWindowSize) {
				XATTuple[] tuples = (XATTuple[])hashEntry.getTupleList().toArray(new XATTuple[]{});
				for (int i=0; i<numAggFunctions; i++) {
					StreamFunction func = aggFunctions[i];
					func.increment(tuples);
					hashEntry.setithCurrentValue(i, func.getCurrentValue());
				}
				hashEntry.clearTupleList();
			}
			hashtable.put(groupVal, hashEntry);
		} else {
			GroupbyHashEntry hashEntry = (GroupbyHashEntry)obj;
			hashEntry.insertTuple(tuple);
			// print out the insert tuple
			//System.out.println("insert into state: " + tuple.toString());
			if (hashEntry.getNumTuples() == basicWindowSize) {
				XATTuple[] tuples = (XATTuple[])hashEntry.getTupleList().toArray(new XATTuple[]{});
				double[] currentValueArray = hashEntry.getCurrentValueArray();
				for (int i=0; i<numAggFunctions; i++) {
					StreamFunction func = aggFunctions[i];
					func.setCurrentValue(currentValueArray[i]);
					func.increment(tuples);
					hashEntry.setithCurrentValue(i, func.getCurrentValue());
				}
				hashEntry.clearTupleList();
			}
		}
		//update state size
		//this.increStateSize();
		return null;
	}

	public GroupbyHashEntry getSingleGroupEntry(Object groupVal) {
		Object entry = hashtable.get(groupVal);
		if (entry == null) {
			return null;
		}
		return (GroupbyHashEntry)entry;
	}

	public void addIgnoreValue(Object ignValue) {
		ignoreValues.put(ignValue, null);
	}
	
	public void removeIgnoreValue(Object ignValue) {
		ignoreValues.remove(ignValue);
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareHashState#purgeByPunct(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple, int)
	 */
	public int purge(Object groupVal) {
		//update state size
		//int numTuplesPurged = 0;
		//Object bucket = hashtable.get(groupVal);
		//if (bucket != null) {
		//	numTuplesPurged = ((ArrayList)bucket).size();
		//	this.decreStateSize(numTuplesPurged);
		//}
		hashtable.remove(groupVal);
		//return numTuplesPurged;
		return 0;
	}

	public Object[] invalidateEvent(int timePos, long earliestProcessTupleTime){
		Enumeration en = hashtable.keys();
		while(en.hasMoreElements()) {
			Object key = en.nextElement();
			ArrayList tupleList = ((GroupbyHashEntry)hashtable.get(key)).getTupleList();
			while (tupleList.size()>0) {
				//long time = ((XATTuple)tupleList.get(0)).getNthTimeStamp(indexAttrPosArray[0]);
				// get the content of the first tuple
				//XATDataValue[] values = ((XATTuple)tupleList.get(0)).getArrayData();
				//long time = (long)values[timePos];
				XATTuple firstTupleInGroup = (XATTuple)tupleList.get(0);
				XATDataValue[] firstTupleContent = firstTupleInGroup.getArrayData();
				long time = firstTupleContent[timePos].convertToLong();
				
					
				if (time<=earliestProcessTupleTime) {
					//System.out.println("Purge tuple: " + firstTupleInGroup.toString());
					tupleList.remove(0);
				} else {
					break;
				}
			}
			if (tupleList.size()==0) {
				hashtable.remove(key);
			}
		}
		return null;
	}
	
	//mingzhu, add invalidate event
	// compare timestampe attribute with input parameter
	public Object[] invalidate(long earliestProcessTupleTime){
		Enumeration en = hashtable.keys();
		while(en.hasMoreElements()) {
			Object key = en.nextElement();
			ArrayList tupleList = ((GroupbyHashEntry)hashtable.get(key)).getTupleList();
			while (tupleList.size()>0) {
				long time = ((XATTuple)tupleList.get(0)).getNthTimeStamp(indexAttrPosArray[0]);
				//System.out.println("Nth timestamp Pos: "+ indexAttrPosArray[0]);
				if (time<earliestProcessTupleTime) {
					tupleList.remove(0);
				} else {
					break;
				}
			}
			if (tupleList.size()==0) {
				hashtable.remove(key);
			}
		}
		return null;
	}
	
	public Object[] invalidateSingleGroup(Object punctVal, 
			long earliestProcessTupleTime) {
		Object entry = hashtable.get(punctVal);
		if (entry != null) {
			ArrayList tupleList = ((GroupbyHashEntry)entry).getTupleList();
			while (tupleList.size()>0) {
				long time = ((XATTuple)tupleList.get(0)).getNthTimeStamp(indexAttrPosArray[0]);
				if (time<earliestProcessTupleTime) {
					tupleList.remove(0);
				} else {
					break;
				}
			}
			if (tupleList.size()==0) {
				hashtable.remove(punctVal);
			}
		}
		return null;
	}

	public ArrayList generateGroups(XATPunct punct) {
		return null;
	}
	
	//added by Mingzhu
	
	/* 
	 * This one return the hashtable in the state
	 */
	public Object getAllStateTuples() {
		return hashtable;
	}
	public void clearState() {
		// TODO Auto-generated method stub
		
	}

}
