/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Aug 11, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorStateImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import java.util.Hashtable;
import java.util.ArrayList;
import java.util.Enumeration;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PunctHashSingleEquiJoinStateImp
	extends OperatorStateImp
	implements PunctHashSingleEquiJoinState {

	protected int[] indexAttrPosArray;
	protected Hashtable hashtable = new Hashtable();
	protected Hashtable punctuationStore;
	protected ArrayList unpurgedPunctList;
	
	/**
	 * constructor
	 */
	public PunctHashSingleEquiJoinStateImp() {
		super();
		punctuationStore = new Hashtable();
		unpurgedPunctList = new ArrayList();
	}

	public PunctHashSingleEquiJoinStateImp(PunctHashSingleEquiJoinStateImp oldstate, XATStreamOperator newop) {
		super(oldstate, newop);
		this.isMatched = false;
		punctuationStore = new Hashtable();
		unpurgedPunctList = new ArrayList();
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareHashState#probe(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple, int)
	 */
	public XATTuple[] probe(XATTuple tuple) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareHashState#probe(java.lang.Object, int)
	 */
	public XATTuple[] probe(Object value) {
		// TODO Auto-generated method stub
		Object bucket = hashtable.get(value);
		if (bucket == null) {
			return null;
		}
		ArrayList bucketList = (ArrayList) bucket;
		if (bucketList.size() == 0) {
			return null;
		}
		return (XATTuple[])bucketList.toArray(new XATTuple[]{});
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareHashState#purgeByPunct(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple, int)
	 */
	public int purge(XATPunct punct) {
		// TODO Auto-generated method stub
		return 0;
	}
	public int purgeByUnpurgedPuncts(ArrayList punctList) {
		int numTuplesPurged = 0;
		for (int i=0; i<punctList.size(); i++) {
			numTuplesPurged += purge(punctList.get(i));
		}
		return numTuplesPurged;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareHashState#purgeByPunct(java.lang.Object, int)
	 */
	public int purge(Object punctValue) {
		//update state size
		int numTuplesPurged = 0;
		Object bucket = hashtable.get(punctValue);
		if (bucket != null) {
			numTuplesPurged = ((ArrayList)bucket).size();
			//this.decreStateSize(numTuplesPurged);
		}
		hashtable.remove(punctValue);
		return numTuplesPurged;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingeEquiJoinState#insert(java.lang.Object, edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple)
	 */
	public void insertTuple(Object value, XATTuple tuple) {
		Object bucket = hashtable.get(value);
		if (bucket == null) {
			ArrayList bucketList = new ArrayList();
			bucketList.add(tuple);
			hashtable.put(value, bucketList);
		} else {
			ArrayList bucketList = (ArrayList)bucket;
			bucketList.add(tuple);
		}
		//update state size
		//this.increStateSize();
	}

	public void insertTuples(Object value, ArrayList tuples) {
		//update state size
		//this.increStateSize(tuples.size());

		Object bucket = hashtable.get(value);
		if (bucket == null) {
			hashtable.put(value, tuples);
		} else {
			ArrayList bucketList = (ArrayList)bucket;
			bucketList.addAll(tuples);
			hashtable.put(value, bucketList);
		}
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingeEquiJoinState#insertPunct(java.lang.Object, edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple)
	 */
	public void insertPunct(Object punctValue, XATPunct punct) {
		punctuationStore.put(punctValue, punct);
		unpurgedPunctList.add(punctValue);
	}
		
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingeEquiJoinState#deletePunct(java.lang.Object)
	 */
	public void deletePunct(Object punctValue) {
		punctuationStore.remove(punctValue);
	}


	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingleEquiJoinState#checkDropCondition(java.lang.Object, boolean)
	 */
	public boolean checkDropCondition(Object value, boolean hasJoined) {
		if (punctuationStore.get(value) != null) {
			return true;
		} else {
			return false;
		}
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingleEquiJoinState#getPunctuationStore()
	 */
	public Hashtable getPunctuationStore() {
		return punctuationStore;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingleEquiJoinState#propagate()
	 */
	public XATTuple[] propagate() {
		ArrayList propagatePuncts = new ArrayList();
		Enumeration en = punctuationStore.keys();
		while(en.hasMoreElements()) {
			Object key = en.nextElement();
			Object bucket = hashtable.get(key);
			if (bucket == null) {
				propagatePuncts.add(punctuationStore.get(key));
				punctuationStore.remove(key);
			}
		}
		
		if (propagatePuncts.size()>0) {
			return (XATTuple[])propagatePuncts.toArray(new XATTuple[]{});
		} else {
			return null;
		}
	}
	public Hashtable getPunctuationstore() {
		return this.punctuationStore;
	}
	public ArrayList getUnpurgedPunctList() {
		return this.unpurgedPunctList;
	}
	public void setPunctuationStore(Hashtable punctStore) {
		this.punctuationStore = punctStore;
	}
	public void setUnpurgedPunctList(ArrayList unpurgedPunctList) {
		this.unpurgedPunctList = unpurgedPunctList;
	}
	
	public void clearUnpurgedPunctList() {
		unpurgedPunctList.clear();
	}
	/** for migration. */
	public void copyStateContent(OperatorState newstate) {
		this.hashtable = (Hashtable)((PunctHashSingleEquiJoinState)newstate).getAllStateTuples();
		this.punctuationStore = ((PunctHashSingleEquiJoinState)newstate).getPunctuationstore();
		Enumeration en = punctuationStore.keys();
		while(en.hasMoreElements()) {
			this.unpurgedPunctList.add(punctuationStore.get(en.nextElement()));
		}
	}

	public Object[] invalidate(long latestProcessTupleTime){
		return null;
	}
	public Object[] purgeSingleGroupByWindow(Object punctVal, long earliestProcessTupleTime) {
		return null;
	}
	public Object getAllStateTuples() {
		return hashtable;
	}
	public void setIndexAttrPosArray(int[] indexAttrPosArray) {
		int numAttrs = indexAttrPosArray.length;
		this.indexAttrPosArray = new int[numAttrs];
		for (int i=0; i<numAttrs; i++) {
			this.indexAttrPosArray[i] = indexAttrPosArray[i];
		}
	}

	public void clearState() {
		// TODO Auto-generated method stub
		
	}
}
