/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Aug 11, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;

import java.util.ArrayList;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PunctHashSingleEquiKeyJoinStateImp
	extends PunctHashSingleEquiJoinStateImp {
	
	public PunctHashSingleEquiKeyJoinStateImp() {
		super();
	}

	public PunctHashSingleEquiKeyJoinStateImp(PunctHashSingleEquiKeyJoinStateImp oldstate, XATStreamOperator newop) {
		super(oldstate, newop);
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctAwareHashState#probe(java.lang.Object, int)
	 */
	public XATTuple[] probe(Object value, int indexAttrPos) {
		Object matchTuple = hashtable.get(value);
		if (matchTuple == null) {
			return null;
		}
		ArrayList bucketList = (ArrayList)matchTuple;
		if (bucketList.size() == 0) {
			return null;
		}
		return (XATTuple[])bucketList.toArray(new XATTuple[]{});
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingeEquiJoinState#insert(java.lang.Object, edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple)
	 */
	public void insertTuple(Object value, XATTuple tuple) {
		//this.increStateSize();
		ArrayList tupleList = new ArrayList();
		tupleList.add(tuple);
		hashtable.put(value, tupleList);
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingleEquiJoinState#checkDropCondition(java.lang.Object, boolean)
	 */
	public boolean checkDropCondition(Object value, boolean hasJoined) {
		if (hasJoined) {
			return true;
		} else {
			return false;
		}
	}
}
