/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-2-26
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import java.util.HashMap;
import java.util.ArrayList;
import java.util.Iterator;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PunctHashSymmetricGroupbyStateImp extends PunctGroupbyStateImp {
	protected HashMap[] hashtableArray;
	
	public PunctHashSymmetricGroupbyStateImp() {
	}
	
	//init() must be executed before the state is used
	public void init() {
		hashtableArray = new HashMap[this.numIndexAttrs];
		for (int i=0; i<numIndexAttrs; i++) {
			hashtableArray[i] = new HashMap(INIT_CAPACITY, LOAD_FACTOR);
		}
	}
	
	public XATTuple[] probe(XATTuple tuple) {
		Object[] searchKeys = new Object[numIndexAttrs];
		for (int i=0; i<numIndexAttrs; i++) {
			searchKeys[i] = tuple.getCell(this.indexAttrPosArray[i]).getValue();
		}
		
		Object obj = hashtableArray[0].get(searchKeys[0]);
		if (obj == null) {
			GroupbyHashEntry newEntry = new GroupbyHashEntry(searchKeys);
			newEntry.insertTuple(tuple);
			ArrayList entryList = new ArrayList();
			entryList.add(newEntry);
			hashtableArray[0].put(searchKeys[0], entryList);
			for (int i=1; i<numIndexAttrs; i++) {
				Object hashObj = hashtableArray[i].get(searchKeys[i]);
				if (hashObj == null) {
					ArrayList newEntryList = new ArrayList();
					newEntryList.add(newEntry);
					hashtableArray[i].put(searchKeys[i], newEntryList);
				} else {
					((ArrayList)hashObj).add(newEntry);
				}
			}
		} else {
			boolean found = false;
			GroupbyHashEntry[] hashEntries = (GroupbyHashEntry[])((ArrayList)obj).toArray(new GroupbyHashEntry[]{});
			int numEntries = hashEntries.length;
			for (int i=0; i<numEntries; i++) {
				GroupbyHashEntry entry = hashEntries[i];
				if (entry.equalKeys(searchKeys)) {
					entry.insertTuple(tuple);
					found = true;
					break;
				}
			}
			if (!found) {
				GroupbyHashEntry newEntry = new GroupbyHashEntry(searchKeys);
				newEntry.insertTuple(tuple);
				((ArrayList)obj).add(newEntry);
				for (int i=1; i<numIndexAttrs; i++) {
					Object hashObj = hashtableArray[i].get(searchKeys[i]);
					if (hashObj == null) {
						ArrayList newEntryList = new ArrayList();
						newEntryList.add(newEntry);
						hashtableArray[i].put(searchKeys[i], newEntryList);
					} else {
						((ArrayList)hashObj).add(newEntry);
					}
				}
			}
		}
		return null;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashGroupbyStateImp#generateGroups(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct)
	 */
	public ArrayList generateGroups(XATPunct punct) {
		XATDataValue[] punctContent = punct.getArrayData();
		int[] punctType = punct.getPunctTypeArray();
		Object[] searchKeys = new Object[numIndexAttrs];
		ArrayList singleKeyPosList = new ArrayList();
		
		for (int i=0; i<numIndexAttrs; i++) {
			int index = indexAttrPosArray[i];
			if (punctType[index] == XATPunct.SINGLE_VALUE) {
				searchKeys[i] = punctContent[index].getValue();
				singleKeyPosList.add(new Integer(i));
			} else {
				searchKeys[i] = null;
			}
		}
		int numSingleKeys = singleKeyPosList.size();
		int[] singleKeyPosArray = new int[numSingleKeys];
		for (int i=0; i<numSingleKeys; i++) {
			singleKeyPosArray[i] = ((Integer)singleKeyPosList.get(i)).intValue();
		}

		ArrayList result = new ArrayList();
		if (numSingleKeys == 1) {
			int singleKeyPos = singleKeyPosArray[0];
			Object key = searchKeys[singleKeyPos];
			Object obj = hashtableArray[singleKeyPos].get(key);
			if (obj == null) {
				return result;
			} else {
				GroupbyHashEntry[] entryArray = (GroupbyHashEntry[])((ArrayList)obj).toArray(new GroupbyHashEntry[]{});
				int numEntries = entryArray.length;
				for (int i=0; i<numEntries; i++) {
					GroupbyHashEntry entry = entryArray[i];
					if (!entry.ifDrop()) {
						entry.setDropFlag(true);
						result.add(entry);
					}
				}
				hashtableArray[singleKeyPos].remove(key);
				return result;
			}
		} else {
			int firstKeyPos = singleKeyPosArray[0];
			Object key = searchKeys[firstKeyPos];
			Object obj = hashtableArray[firstKeyPos].get(key);
			if (obj == null) {
				return result;
			} else {
				ArrayList entryArray = (ArrayList)obj;
				int numEntries = entryArray.size();
				int cursor = 0;
				while (cursor<numEntries) {
					GroupbyHashEntry entry = (GroupbyHashEntry)entryArray.get(cursor);
					if (entry.ifDrop()) {
						entryArray.remove(cursor);
						numEntries --;
					} else if (entry.equalKeys(searchKeys, singleKeyPosArray)) {
						entry.setDropFlag(true);
						result.add(entry);
						entryArray.remove(cursor);
						numEntries --;
					} else {
						cursor ++;
					}
				}
				return result;
			}
		}
	}
	
	//cleanup deleted groups in specified hashtables
	//public void cleanupDeletedGroups(int[] hashtablePos) {
	public void cleanupDeletedGroups() {
		for (int i=0; i<numIndexAttrs; i++) {
			HashMap htable = hashtableArray[i];
			Iterator it = htable.values().iterator();
			while (it.hasNext()) {
				ArrayList entryList = (ArrayList)it.next();
				if (entryList.size()==0) {
					continue;
				}
				GroupbyHashEntry firstEntry = (GroupbyHashEntry)entryList.get(0);
				Object key = firstEntry.getSearchKeys()[indexAttrPosArray[i]];
				int cursor = 1;
				if (firstEntry.ifDrop()) {
					entryList.remove(0);
					cursor = 0;
				}
				while (cursor<entryList.size()) {
					if (((GroupbyHashEntry)entryList.get(cursor)).ifDrop()) {
						entryList.remove(cursor);
					} else {
						cursor ++;
					}
				}
				if (entryList.size()==0) {
					htable.remove(key);
				}
			}
		}
	}

	public void clearState() {
		// TODO Auto-generated method stub
		
	}
}
