/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-2-15
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SimpleGroupbyHashEntry {
	protected Object[] searchKeys; //key
	protected int numTuples; //number of new tuples
	protected double[] currentValueArray;
	
	public SimpleGroupbyHashEntry() {
		numTuples = 0;
	}

	public SimpleGroupbyHashEntry(Object[] sKeys) {
		searchKeys = sKeys;
		numTuples = 0;
	}

	public Object[] getSearchKeys() {
		return searchKeys;
	}
	public void setSearchKeys(Object[] sKeys) {
		searchKeys = sKeys;
	}
	public int getNumTuples() {
		return numTuples;
	}
	public void increNumTuples() {
		numTuples ++;
	}
	public double[] getCurrentValueArray() {
		return currentValueArray;
	}
	public double getithCurrentValue(int pos) {
		return currentValueArray[pos];
	}
	public void setCurrentValueArray(double[] currentValArray) {
		currentValueArray = currentValArray;
	}
	public void setithCurrentValue(int pos, double cValue) {
		currentValueArray[pos] = cValue;
	}

	//match all input keys
	public boolean equalKeys(Object[] inputKeys) {
		int numInputKeys = inputKeys.length;
		if (searchKeys.length != numInputKeys) {
			return false;
		} else {
			for (int i=0; i<numInputKeys; i++) {
				if (!searchKeys[i].equals(inputKeys[i])) {
					return false;
				}
			}
			return true;
		}
	}
	//match input keys indicated by keysPos array
	public boolean equalKeys(Object[] inputKeys, int[] keysPos) {
		int numKeysToCompare = keysPos.length;
		if (searchKeys.length != numKeysToCompare) {
			return false;
		} else {
			for (int i=0; i<numKeysToCompare; i++) {
				int index = keysPos[i];
				if (!searchKeys[i].equals(inputKeys[index])) {
					return false;
				}
			}
			return true;
		}
	}

	public boolean equalKeys(Object inputKey, int keyPos) {
		if (searchKeys[keyPos].equals(inputKey)) {
			return true;
		} else {
			return false;
		}
	}

	public boolean equalKeys(XATDataValue[] punctContent, int[] punctType, int[] keysPos) {
		int numKeysToCompare = keysPos.length;
		for (int i=0; i<numKeysToCompare; i++) {
			int index = keysPos[i];
			if (punctType[index] == XATPunct.SINGLE_VALUE && !searchKeys[index].equals(punctContent[index].getValue())) {
				return false;
			}
		}
		return true;
	}
}
