/*
 /////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
* Created on Mar 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import java.util.Hashtable;

/**
 * @author mshah
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SingleHashIndexImp extends SingleIndexImp implements SingleIndex {
	Hashtable iNodeHash;
	/**
	 * constructor
	 * @param numStreams
	 */
	public SingleHashIndexImp() {
		super();
		iNodeHash = new Hashtable();
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.Index#addIndexNode(java.lang.Object, edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.INode)
	 */
	public void addIndexNode(Object key, SingleINode node) {
		iNodeHash.put(key, node);
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.Index#addTNode(java.lang.Object, edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.TNode)
	 */
	public void addTNode(Object key, TNode node) {
		SingleINode iNode = (SingleINode)iNodeHash.get(key);
		if (iNode == null) {
			iNode = new SingleINodeImp(key, node);
			iNodeHash.put(key, iNode);
		} else {
			iNode.addTNode(node);
		}
	}

	public void addTNode(Object key, TNode node, int punctFlag) {
		SingleINode iNode = (SingleINode)iNodeHash.get(key);
		if (iNode == null) {
			iNode = new SingleINodeImp(key, node);
			iNode.setPunctFlag(punctFlag);
			iNodeHash.put(key, iNode);
		} else {
			iNode.addTNode(node);
			iNode.setPunctFlag(punctFlag);
		}
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.index#removeIndexNode()
	 */
	public void removeIndexNode(Object key) {
		iNodeHash.remove(key);
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.index#getIndexNode()
	 */
	public SingleINode getIndexNode(Object key) {
		return (SingleINode)iNodeHash.get(key);
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.Index#clear()
	 */
	public void clear() {
		iNodeHash.clear();
	}
}
