/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Aug 13, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SingleINodeImp implements SingleINode {

	public static int JOINANDDROPTUPLE = 1;
	public static int JOINANDINSERTTUPLE = 0;
	public static int DROPTUPLE = -1;
	
	Object key;
	TNode head;
	TNode tail;
	
	int punctFlag = JOINANDINSERTTUPLE; 

	public SingleINodeImp(Object key) {
		this.key = key;
	}
	
	/**
	 * @param key
	 * @param tnode
	 */
	public SingleINodeImp(Object key, TNode tnode) {
		this.key = key;
		this.head = tnode;
		this.tail = tnode;
	}
	
	public Object getKey() {
		return key;
	}
	
	public void setKey(Object key) {
		this.key = key;
	}
	/**
	 * @return
	 */
	public TNode getHead() {
		return this.head;
	}
	/**
	 * @param head
	 */
	public void setHead(TNode head) {
		this.head = head;
	}
	/**
	 * @return
	 */
	public TNode getTail() {
		return this.tail;
	}
	/**
	 * @param tail
	 */
	public void setTail(TNode tail) {
		this.tail = tail;
	}

	public int getPunctFlag() {
		return this.punctFlag;
	}
	
	public void setPunctFlag(int pFlag) {
		this.punctFlag = pFlag;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.INode#addTNode(edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.TNode)
	 */
	public void addTNode(TNode tnode) {
		if (tail == null) {
			head = tnode;
			tail = tnode;
		} else {
			tail.setNextSameValueTNode(tnode);
			tail = tnode;
		}
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.INode#clearTNodes()
	 */
	public int clearTNodes() {
		int numTuplesDeleted = 0;
		TNode headTNode = head;
		while (headTNode != null) {
			if (headTNode.getTuple()!=null) {
				numTuplesDeleted ++;
				headTNode.setTuple(null);
			}
			headTNode = headTNode.getNextSameValueTNode();
		}
		head = null;
		tail = null;
		return numTuplesDeleted;
	}

}
