/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Aug 13, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import java.util.ArrayList;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public interface SinglePWSingleEquiJoinState extends OperatorState{

	/**
	 * @return
	 */
	ArrayList getPurgedPunctList();
	
	/**
	 * @return
	 */
	ArrayList getUnpurgedPunctList();
	
	/**
	 * 
	 */
	void mergePunctListsAsPurged();
	/**
	 * @return
	 */
	TNode getStartWindow();

	/**
	 * @return
	 */
	TNode getEndWindow();

	/**
	 * @return
	 */
	INodeIndex getIndex();
	/**
	 * @return
	 */
	int getJoinAttrPos();
	/**
	 * @param start
	 */
	void setStartWindow(TNode start);

	/**
	 * @param end
	 */
	void setEndWindow(TNode end);

	/**
	 * @param index
	 */
	void setIndex(INodeIndex index);
	/**
	 * @param joinAttrPos
	 */
	void setJoinAttrPos(int joinAttrPos);

	/**
	 * @param key
	 * @param tuple
	 */
	void addTupleToIndex(Object key, XATTuple tuple);

	/**
	 * @param tuple
	 * @return
	 */
	ResultPackage probe(Object value);

	/**
	 * @param punctValue
	 * @return
	 */
	int purgeByPunct(Object punctValue);
	
	/**
	 * @param value
	 */
	boolean processPunct(XATTuple punct);

	/**
	 * @param latestProcessTupleTime
	 * @return
	 */
	Object[] purgeByWindow(long latestProcessTupleTime);
	
	/**
	 * 
	 */
	void clearState();
	
	/**
	 * @param value
	 */
	void markAsPropagated(Object value);
	
}
