/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Aug 13, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorStateImp;
import java.util.ArrayList;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SinglePWSingleEquiJoinStateImp 
extends OperatorStateImp implements SinglePWSingleEquiJoinState {

	protected int JOINANDDROPTUPLE = 1;
	protected int JOINANDINSERTTUPLE = 0;
	protected int DROPTUPLE = -1;
	
	protected int PROPAGATEPUNCT = 1;
	protected int DROPPUNCT = -1;
	protected int DONOTHING = 0;
	
	protected INodeIndex index;
	protected TNode startWindow;
	protected TNode endWindow;
	
	protected int joinAttrPos;
	
	protected ArrayList purgedPunctList = new ArrayList();
	protected ArrayList unpurgedPunctList = new ArrayList();
	
	protected TNodeRecycleBin tnodeRecycle = new TNodeRecycleBinImp();
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SinglePWSingleEquiJoinState#getPurgedPunctList()
	 */
	public ArrayList getPurgedPunctList() {
		return purgedPunctList;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SinglePWSingleEquiJoinState#getUnpurgedPunctList()
	 */
	public ArrayList getUnpurgedPunctList() {
		return unpurgedPunctList;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SinglePWSingleEquiJoinState#mergePunctListsAsPurged()
	 */
	public void mergePunctListsAsPurged() {
		purgedPunctList.addAll(unpurgedPunctList);
		unpurgedPunctList.clear();
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.SinglePWState#getStartWindow()
	 */
	public TNode getStartWindow() {
		// TODO Auto-generated method stub
		return this.startWindow;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.SinglePWState#getEndWindow()
	 */
	public TNode getEndWindow() {
		// TODO Auto-generated method stub
		return this.endWindow;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SinglePWSingleEquiJoinState#getIndex()
	 */
	public INodeIndex getIndex() {
		return index;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SinglePWSingleEquiJoinState#getJoinAttrPos()
	 */
	public int getJoinAttrPos() {
		return joinAttrPos;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.SinglePWState#setStartWindow(edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.TNode)
	 */
	public void setStartWindow(TNode start) {
		// TODO Auto-generated method stub
		this.startWindow = start;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.SinglePWState#setEndWindow(edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.TNode)
	 */
	public void setEndWindow(TNode end) {
		// TODO Auto-generated method stub
		this.endWindow = end;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SinglePWSingleEquiJoinState#setIndex(edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SingleIndex)
	 */
	public void setIndex(INodeIndex index) {
		this.index = index;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SinglePWSingleEquiJoinState#setJoinAttrPos(int)
	 */
	public void setJoinAttrPos(int joinAttrPos) {
		this.joinAttrPos = joinAttrPos;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.SinglePWState#addTupleToIndex(java.lang.Object, edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple)
	 */
	public void addTupleToIndex(Object key, XATTuple tuple) {
		TNode tnode = tnodeRecycle.createTNode(tuple, joinAttrPos);
		if (this.endWindow == null) {
			this.endWindow = tnode;
			this.startWindow = tnode;
		} else {
			this.endWindow.setNextTNodeInTimeList(tnode);
			this.endWindow = tnode;
		}
		this.index.addTNode(key, tnode);
		//update state size
		//this.increStateSize();
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SinglePWSingleEquiJoinState#purgeByPunct(java.lang.Object)
	 */
	public int purgeByPunct(Object punctValue) {
		INode iNode = index.getIndexNode(punctValue);
		if (iNode == null) {
			return this.DONOTHING;
		}
		if (iNode.getPunctFlag() == this.DROPTUPLE) {
			index.removeIndexNode(punctValue);
			return this.DROPPUNCT;
		}

		iNode.clearTNodes(this.tnodeRecycle);
		
		//int numTuplesDeleted = iNode.clearTNodes();
		//update state size
		//this.decreStateSize(numTuplesDeleted);

		if (iNode.getPunctFlag() == this.JOINANDDROPTUPLE) {
			index.removeIndexNode(punctValue);
			return this.PROPAGATEPUNCT;
		} 
		return DONOTHING;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SinglePWSingleEquiJoinState#processPunct(java.lang.Object)
	 */
	public boolean processPunct(XATTuple punct) {
		Object value = punct.getCell(joinAttrPos).getValue();
		
		INode iNode = index.getIndexNode(value);
		if (iNode == null) {
			return true;
		}
		
		if (iNode.getPunctFlag() == this.DROPTUPLE) {
			index.removeIndexNode(value);
			return false;
		}

		iNode.setPunctFlag(this.JOINANDDROPTUPLE);
		
		unpurgedPunctList.add(punct);
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SinglePWSingleEquiJoinState#markAsPropagated(java.lang.Object)
	 */
	public void markAsPropagated(Object value) {
		INode iNode = index.getIndexNode(value);
		if (iNode == null) {
			iNode = new INodeImp(value);
			iNode.setPunctFlag(this.DROPTUPLE);
			index.addIndexNode(value, iNode);
		} else {
			iNode.clearTNodes(this.tnodeRecycle);
			iNode.setPunctFlag(this.DROPTUPLE);
		}
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.SinglePWStateImp#probe(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple)
	 */
	public ResultPackage probe(Object value) {
		INode iNode = (INode)this.index.getIndexNode(value);
			
		//insert new tuple into index
		if (iNode == null) {//no I-Node for this join value yet
			//iNode = new SingleINodeImp(value);
			//index.addIndexNode(value, iNode);
			return null;
		}
		
		ResultPackage rPackage = new ResultPackageImp();
		if (iNode.getPunctFlag() == this.DROPTUPLE) {
			rPackage.setDropFlag(this.DROPTUPLE);
			return rPackage;
		} else if (iNode.getPunctFlag() == this.JOINANDDROPTUPLE) {
			rPackage.setDropFlag(this.JOINANDDROPTUPLE);
		}
		
		ArrayList resultTupleList = new ArrayList();
		TNode node = iNode.getHead();
		while (node != null && node.getTuple()==null) {
			node = node.getNextSameValueTNode();
		}
		iNode.setHead(node);
		if (node == null) {
			iNode.setTail(null);
			return null;
		}
		while(node != null) {
			resultTupleList.add(node.getTuple());
			node = node.getNextSameValueTNode();
		}
		if (resultTupleList.size() != 0) {
			rPackage.setResultTuples((XATTuple[]) resultTupleList.toArray(new XATTuple[] {}));
		}
		return rPackage;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.PWStateImp#purgeByWindow(long)
	 */
	public Object[] purgeByWindow(long earliestProcessTupleTime) {
		TNode node = this.startWindow;
		//skip all invalid tuples at the head of time list
		while (node != null && node.getTuple() == null) {
			this.tnodeRecycle.insertTNode(node);
			node = node.getNextTNodeInTimeList();
		}
		if (node == null) {//no more valid tuples in this time list
			this.setStartWindow(null);
			this.setEndWindow(null);
			return null;
		}
		boolean foundNewWinStart = false;
		int numTuplesInvalidated = 0;
		while (node != null) {
			XATTuple tuple = node.getTuple();
			if (tuple == null) {
				node = node.getNextTNodeInTimeList();
				continue;
			}
				
			long joinAttrTS = 0;
			try {
				joinAttrTS = tuple.getNthTimeStamp(joinAttrPos);
			} catch(Exception e) {
				e.printStackTrace();
			}
			
			if (joinAttrTS >= earliestProcessTupleTime) {
				//find the first time-valid tuple
				startWindow = node;
				foundNewWinStart = true;
				break;
			} else {//tuple expires
				node.setTuple(null);
				numTuplesInvalidated ++;
				node = node.getNextTNodeInTimeList();
			}
		}
		//this.decreStateSize(numTuplesInvalidated);
		
		if (!foundNewWinStart) {
			this.setStartWindow(null);
			this.setEndWindow(null);
		}
		
		ArrayList propagatedJoinValues = new ArrayList();
		int cursor = 0;
		while(cursor<this.purgedPunctList.size()) {
			XATTuple punct = (XATTuple)this.purgedPunctList.get(cursor);
			if (punct.getNthTimeStamp(joinAttrPos) < earliestProcessTupleTime) {
				Object value = punct.getCell(joinAttrPos).getValue();
				propagatedJoinValues.add(value);
				purgedPunctList.remove(cursor);
				INode iNode = this.index.getIndexNode(value);
				if (iNode == null) {
					iNode = new INodeImp(value);
					iNode.setPunctFlag(this.DROPTUPLE);
					index.addIndexNode(value, iNode);
				} else {
					iNode.setPunctFlag(this.DROPTUPLE);
				}
			} else {
				break;
			}
		}
		if (propagatedJoinValues.size()>0) {
			return propagatedJoinValues.toArray();
		} else {
			return null;
		}
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.SinglePWSingleEquiJoinState#clearState()
	 */
	public void clearState() {
		this.startWindow = null;
		this.endWindow = null;
		index.clear();
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState#copyStateContent(edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState)
	 */
	public void copyStateContent(OperatorState newstate) {
	}
	
}
