/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Aug 18, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import java.util.ArrayList;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SinglePWSingleEquiKeyJoinStateImp extends
		SinglePWSingleEquiJoinStateImp {

	public void addTupleToIndex(Object key, XATTuple tuple) {
		TNode tnode = new TNodeImp(tuple);
		if (this.endWindow == null) {
			this.endWindow = tnode;
			this.startWindow = tnode;
		} else {
			this.endWindow.setNextTNodeInTimeList(tnode);
			this.endWindow = tnode;
		}
		this.index.addTNode(key, tnode, this.JOINANDDROPTUPLE);
		//update state size
		//this.increStateSize();
	}

	public Object[] purgeByWindow(long earliestProcessTupleTime) {
		ArrayList propagatedJoinValues = new ArrayList();
		
		TNode node = this.startWindow;
		//skip all invalid tuples at the head of time list
		while (node != null && node.getTuple() == null) {
			this.tnodeRecycle.insertTNode(node);
			node = node.getNextTNodeInTimeList();
		}
		if (node == null) {//no more valid tuples in this time list
			this.setStartWindow(null);
			this.setEndWindow(null);
			return null;
		}
		boolean foundNewWinStart = false;
		while (node != null) {
			XATTuple tuple = node.getTuple();
			if (tuple == null) {
				node = node.getNextTNodeInTimeList();
				continue;
			}
				
			long joinAttrTS = 0;
			try {
				joinAttrTS = tuple.getNthTimeStamp(joinAttrPos);
			} catch(Exception e) {
				e.printStackTrace();
			}
				
			if (joinAttrTS >= earliestProcessTupleTime) {
				//find the first time-valid tuple
				startWindow = node;
				foundNewWinStart = true;
				break;
			} else {//tuple expires
				INode iNode = this.index.getIndexNode(tuple.getCell(joinAttrPos).getValue());
				iNode.setHead(null);
				iNode.setTail(null);
				iNode.setPunctFlag(this.DROPTUPLE);
				propagatedJoinValues.add(iNode.getKey());
				node = node.getNextTNodeInTimeList();
				//update state size
				//this.decreStateSize();
			}
		}
		if (!foundNewWinStart) {
			this.setStartWindow(null);
			this.setEndWindow(null);
		}
		if (propagatedJoinValues.size()>0) {
			return propagatedJoinValues.toArray();
		} else {
			return null;
		}
	}

	public ResultPackage probe(Object value) {
		INode iNode = (INode)this.index.getIndexNode(value);
			
		//insert new tuple into index
		if (iNode == null) {//no I-Node for this join value yet
			//iNode = new SingleINodeImp(value);
			//index.addIndexNode(value, iNode);
			return null;
		}
		
		ResultPackage rPackage = new ResultPackageImp();
		if (iNode.getPunctFlag() == this.DROPTUPLE) {
			rPackage.setDropFlag(this.DROPTUPLE);
			return rPackage;
		}
		
		rPackage.setDropFlag(this.JOINANDDROPTUPLE);
		
		ArrayList resultTupleList = new ArrayList();
		TNode node = iNode.getHead();
		while (node != null && node.getTuple()==null) {
			this.tnodeRecycle.insertTNode(node);
			node = node.getNextSameValueTNode();
		}
		iNode.setHead(node);
		if (node == null) {
			iNode.setTail(null);
			return null;
		}
		while(node != null) {
			resultTupleList.add(node.getTuple());
			node = node.getNextSameValueTNode();
		}
		if (resultTupleList.size() != 0) {
			rPackage.setResultTuples((XATTuple[]) resultTupleList.toArray(new XATTuple[] {}));
		}
		return rPackage;
	}

}
