/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2004-9-26
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate;

import java.util.ArrayList;
import java.io.Serializable;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TNodeRecycleBinImp implements TNodeRecycleBin, Serializable {

	ArrayList tnodeList;
	int numTNodes;
	
	public TNodeRecycleBinImp() {
		tnodeList = new ArrayList();
		numTNodes = 0;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.mpwjoin.state.TNodeRecycleBin#hasMoreTNode()
	 */
	public boolean hasMoreTNode() {
		return numTNodes>0;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.mpwjoin.state.TNodeRecycleBin#getNextTNode()
	 */
	public TNode getNextTNode() {
		if (numTNodes == 0) {
			return null;
		} else {
			TNode nextTNode = (TNode)tnodeList.get(0);
			tnodeList.remove(0);
			numTNodes --;
			return nextTNode;
		}
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.operator.mpwjoin.state.TNodeRecycleBin#insertTNode(edu.wpi.cs.dsrg.xmldb.xat.component.operator.mpwjoin.state.TNode)
	 */
	public void insertTNode(TNode node) {
		tnodeList.add(node);
		numTNodes ++;
	}

	public TNode createTNode(XATTuple tuple, int joinAttrPos) {
		TNode node = null;
		if (numTNodes>0) {
			node = (TNode)tnodeList.get(0);
			node.setTuple(tuple);
			//reset pointers
			node.setNextSameValueTNode(null);
			node.setNextTNodeInTimeList(null);
			tnodeList.remove(0);
			numTNodes --;
		} else {
			node = new TNodeImp(tuple);
		}
		return node;
	}
}
