/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Aug 11, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATMultiQueueStreamOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingleEquiJoinState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueException;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunctImp;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Enumeration;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class BinaryPunctuationStreamSingleEquiJoinOperatorImp
	extends XATMultiQueueStreamOperatorImp
	implements BinaryPunctuationStreamSingleEquiJoinOperator {

	int LEFT = 0;
	int RIGHT = 1;
	
	protected boolean propagateFlag;
	protected int memoryLimit;
	
	PunctHashSingleEquiJoinState leftState;
	PunctHashSingleEquiJoinState rightState;

	int leftJoinAttrPos;
	int rightJoinAttrPos;
	
	int purgeThreshold = 1;
	int propagateThreshold = 1;

	int numLeftPunctsSinceLastPurge = 0;
	int numRightPunctsSinceLastPurge = 0;
	int numLeftPunctsSinceLastPropagate = 0;
	int numRightPunctsSinceLastPropagate = 0;
		
	public BinaryPunctuationStreamSingleEquiJoinOperatorImp(BinaryPunctuationStreamSingleEquiJoinOperatorImp oldop, XATNode newnode) {
		super(oldop, newnode);
		this.leftJoinAttrPos = oldop.getLeftJoinAttrPos();
		this.rightJoinAttrPos = oldop.getRightJoinAttrPos();
		this.purgeThreshold = oldop.getPurgeThreshold();
		this.propagateThreshold = oldop.getPropagateThreshold();
		this.leftState = (PunctHashSingleEquiJoinState) this.states[0];
		this.rightState = (PunctHashSingleEquiJoinState) this.states[1];
	}
	public BinaryPunctuationStreamSingleEquiJoinOperatorImp(XATNode init) {
		super(init);
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamSingleEquiJoinOperator#getLeftState()
	 */
	public PunctHashSingleEquiJoinState getLeftState() {
		// TODO Auto-generated method stub
		return leftState;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamSingleEquiJoinOperator#getRightState()
	 */
	public PunctHashSingleEquiJoinState getRightState() {
		// TODO Auto-generated method stub
		return rightState;
	}

	private void setLeftState(PunctHashSingleEquiJoinState lState) {
		// TODO Auto-generated method stub
		this.leftState = lState;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamSingleEquiJoinOperator#setRightState(edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingleEquiJoinState)
	 */
	private void setRightState(PunctHashSingleEquiJoinState rState) {
		// TODO Auto-generated method stub
		this.rightState = rState;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamSingleEquiJoinOperator#getLeftJoinAttrPos()
	 */
	public int getLeftJoinAttrPos() {
		// TODO Auto-generated method stub
		return leftJoinAttrPos;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamSingleEquiJoinOperator#getRightJoinAttrPos()
	 */
	public int getRightJoinAttrPos() {
		// TODO Auto-generated method stub
		return rightJoinAttrPos;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamSingleEquiJoinOperator#setLeftJoinAttrPos(int)
	 */
	public void setLeftJoinAttrPos(int lJoinAttrPos) {
		this.leftJoinAttrPos = lJoinAttrPos;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamSingleEquiJoinOperator#setRightJoinAttrPos(int)
	 */
	public void setRightJoinAttrPos(int rJoinAttrPos) {
		this.rightJoinAttrPos = rJoinAttrPos;
	}
	
	private void propagateJoinValue(Object value) {
		XATDataValue[] newPunctContent = new XATDataValueImp[numOutputColumns];
		int[] punctTypeArray = new int[numOutputColumns];
		int j = 0, k=0;
		for (; j<numOutputColsPerStream[0]; j++) {
			if (j==leftJoinAttrPos) {
				newPunctContent[j] = new XATDataValueImp(value);
				punctTypeArray[j] = XATPunct.SINGLE_VALUE;
			} else {
				newPunctContent[j] = new XATDataValueImp();
				punctTypeArray[j] = XATPunct.ALL_VALUE;
			}
		}
		for (; k<numOutputColsPerStream[1]; k++) {
			if (k==rightJoinAttrPos) {
				newPunctContent[k+j] = new XATDataValueImp(value);
				punctTypeArray[k+j] = XATPunct.SINGLE_VALUE;
			} else {
				newPunctContent[k+j] = new XATDataValueImp();
				punctTypeArray[k+j] = XATPunct.ALL_VALUE;
			}
			
		}
		XATPunct propPunct = new XATPunctImp(newPunctContent);
		propPunct.setPunctTypeArray(punctTypeArray);
		this.getOutputQueue().enqueue(propPunct, this);
	}

	
	public boolean run() {
		if(!hasInit()) {
			init();
			if (!hasInit()) {
				return false;
			}
		}
		int howMany = Integer.parseInt(this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
		return execOperator(howMany);
	}
	
	private boolean execOperator(int howMany) {
		XATTuple newObj = null;
		int indication = LEFT;
		int tupleCount = 0;
		
		while (true) {
			if (tupleCount == howMany) {
				/*
				if (this.getStateSize() > this.memoryLimit) {
					int numTuplesPurgedFromLeft = this.leftState.purgeByUnpurgedPuncts(
							rightState.getUnpurgedPunctList());
					int numTuplesPurgedFromRight = this.rightState.purgeByUnpurgedPuncts(
							leftState.getUnpurgedPunctList());
					int numTuplesPurgeTotal = numTuplesPurgedFromLeft + numTuplesPurgedFromRight;
					leftState.clearUnpurgedPunctList();
					rightState.clearUnpurgedPunctList();
					numLeftPunctsSinceLastPurge = 0;
					numRightPunctsSinceLastPurge = 0;
				}*/
				return true;
			}
			try {
				//pick the next tuple to process
				if (this.getLeftInputQueue().getQueueSize(this) == 0) {
					newObj = this.getRightInputQueue().dequeue(this);
					indication = RIGHT;
				} else if (this.getRightInputQueue().getQueueSize(this) == 0) {
					newObj = this.getLeftInputQueue().dequeue(this);
					indication = LEFT;
				} else {
					long leftTimeStamp = 0;
					long rightTimeStamp = 0;
			
					leftTimeStamp =
						this.getLeftInputQueue().peek(this).getMinTimeStamp();
					rightTimeStamp = 
						this.getRightInputQueue().peek(this).getMinTimeStamp();
							
					if(leftTimeStamp <= rightTimeStamp) {
						newObj = this.getLeftInputQueue().dequeue(this);
						indication = LEFT;
					} else {
						newObj = this.getRightInputQueue().dequeue(this);
						indication = RIGHT;
					}					
				}
			} catch(XATQueueException e1) {
				return true;
			}
			
			if (indication == LEFT) {
				if (newObj.isPunct()) { //receive a new punctuation
					Object punctVal = newObj.getCell(leftJoinAttrPos).getValue();
					if (punctVal == null) {
						continue;
					}
					this.leftState.insertPunct(punctVal, (XATPunct)newObj);
					numLeftPunctsSinceLastPurge ++;
					numLeftPunctsSinceLastPropagate ++;
					if (numLeftPunctsSinceLastPurge == this.purgeThreshold) {
						int numTuplesPurged = this.rightState.purgeByUnpurgedPuncts(
								leftState.getUnpurgedPunctList());
						leftState.clearUnpurgedPunctList();
						numLeftPunctsSinceLastPurge = 0;
					}
					
					if (numLeftPunctsSinceLastPropagate == this.propagateThreshold) {
						
						XATTuple[] outputPuncts = leftState.propagate();
						if (outputPuncts != null && this.propagateFlag) {
							for(int i=0; i<outputPuncts.length; i++) {
								Object propVal = outputPuncts[i].getCell(leftJoinAttrPos).getValue();
								this.propagateJoinValue(propVal);				
							} 
						}
						numLeftPunctsSinceLastPropagate = 0;
					}
				} else {
					tupleCount ++;
					Object value = newObj.getCell(leftJoinAttrPos).getValue();
					boolean hasJoined = false;
					XATTuple[] result = rightState.probe(value);
					if (result != null) {
						hasJoined = true;
						ArrayList resultTupleArray = new ArrayList();
						for (int i=0; i<result.length; i++) {
							resultTupleArray.add(this.generateResultTuple(new XATTuple[]{newObj, result[i]}));
						}
						this.getOutputQueue().enqueue((XATTuple[]) resultTupleArray.toArray(
								new XATTuple[] {}), this);
					}
					if (!rightState.checkDropCondition(value, hasJoined)) {
						leftState.insertTuple(value, newObj);
					}
				}
			} else {
				if (newObj.isPunct()) { //receive a new punctuation
					Object punctVal = newObj.getCell(rightJoinAttrPos).getValue();
					if (punctVal == null) {
						continue;
					}
					this.rightState.insertPunct(punctVal, (XATPunct)newObj);
					numRightPunctsSinceLastPurge ++;
					numRightPunctsSinceLastPropagate ++;
					if (numRightPunctsSinceLastPurge == this.purgeThreshold) {
						int numTuplesPurged = this.leftState.purgeByUnpurgedPuncts(
								rightState.getUnpurgedPunctList());
						rightState.clearUnpurgedPunctList();
						numRightPunctsSinceLastPurge = 0;
					}
					
					if (numRightPunctsSinceLastPropagate == this.propagateThreshold) {
						XATTuple[] outputPuncts = rightState.propagate();
						
						if (outputPuncts != null && this.propagateFlag) {
							for(int i=0; i<outputPuncts.length; i++) {
								Object propVal = outputPuncts[i].getCell(rightJoinAttrPos).getValue();
								this.propagateJoinValue(propVal);				
							} 
						}
						numRightPunctsSinceLastPropagate = 0;
					}
				} else {
					tupleCount ++;
					Object value = newObj.getCell(rightJoinAttrPos).getValue();
					boolean hasJoined = false;
					XATTuple[] result = leftState.probe(value);
					if (result != null) {
						hasJoined = true;
						ArrayList resultTupleArray = new ArrayList();
						for (int i=0; i<result.length; i++) {
							resultTupleArray.add(this.generateResultTuple(new XATTuple[]{ result[i], newObj}));
						}
						this.getOutputQueue().enqueue((XATTuple[]) resultTupleArray.toArray(
								new XATTuple[] {}), this);
					}
					if (!leftState.checkDropCondition(value, hasJoined)) {
						rightState.insertTuple(value, newObj);
					}
				}
			}
		}
	}	

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.BinaryPunctuationStreamSingleEquiJoinOperator#getPurgeThreshold()
	 */
	public int getPurgeThreshold() {
		return purgeThreshold;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.BinaryPunctuationStreamSingleEquiJoinOperator#setPurgeThreshold(int)
	 */
	public void setPurgeThreshold(int pThreshold) {
		this.purgeThreshold = pThreshold;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamSingleEquiJoinOperator#getPropagateThreshold()
	 */
	public int getPropagateThreshold() {
		return propagateThreshold;
	}
		
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamSingleEquiJoinOperator#setPropagateThreshold(int)
	 */
	public void setPropagateThreshold(int propThreshold) {
		this.propagateThreshold = propThreshold;
	}
	

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		// TODO Auto-generated method stub
		return "PJoin";
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setState(edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState[])
	 */
	public void setState(OperatorState[] state) {
		this.states = new OperatorState[state.length];
		for(int i = 0; i < this.states.length;i++){
			this.states[i] = state[i];
		}
		this.leftState = (PunctHashSingleEquiJoinState) state[0];
		this.rightState = (PunctHashSingleEquiJoinState) state[1];
	}
	
	/** Begin methods for migration. */
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#hasUnmatchedState()
	 */
	public boolean hasUnmatchedState() {
		if (states == null) {
			return false;
		}

		for (int i = 0; i < states.length; i++) {
			if (!states[i].isMatched())
				return true;
		}
		return false;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAccumulatedTuples(long)
	 */
	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		if ((this.getLeftInputQueue().getSchema() == null) || (this.getRightInputQueue().getSchema() == null)){
				return false;
		}
		if(this.getOutputQueue().getSchema() == null){
			init();
		}
		
		/** figure out how many tuples to dequeue from left and right queue */
		XATQueue lQueue = this.getLeftInputQueue();
		XATQueue rQueue = this.getRightInputQueue();
		int size1 = lQueue.getQueueSize(this);
		int size2 = rQueue.getQueueSize(this);
		int lHowmany=size1; 
		int rHowmany=size2;

		if(lQueue.isOldBoxInput()) {
			XATTuple[] tuples = lQueue.peek(size1, this);
			for (int i = 0; i < size1; i++) {
				if (((XATTuple) tuples[i]).getMaxTimeStamp() >= maxtimestamp) {
					lHowmany = i;
					break;
				}
			}
		}
		
		if(rQueue.isOldBoxInput()) {
			XATTuple[] tuples = rQueue.peek(size2, this);
			for (int i = 0; i < size2; i++) {
				if (((XATTuple) tuples[i]).getMaxTimeStamp() >= maxtimestamp) {
					rHowmany = i;
					break;
				}
			}
		}

		if((lHowmany + rHowmany) == 0) 
			return false;
			
		execOperator(lHowmany+rHowmany);

		/* run successfully */
		return true;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAllAccumulatedTuples()
	 */
	public boolean cleanAllAccumulatedTuples() {
		if ((this.getLeftInputQueue().getSchema() == null) || (this.getRightInputQueue().getSchema() == null)){
				return false;
		}
		if(this.getOutputQueue().getSchema() == null){
			init();
		}
		
		/** figure out how many tuples to dequeue from left and right queue */
		XATQueue lQueue = this.getLeftInputQueue();
		XATQueue rQueue = this.getRightInputQueue();
		int lHowmany = lQueue.getQueueSize(this);
		int rHowmany = rQueue.getQueueSize(this);

		/** nothing to clean */
		if(lHowmany == 0 && rHowmany == 0) {
			return false;
		}

		execOperator(lHowmany+rHowmany);

		/* run successfully */
		return true;	
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setStateID(int)
	 */
	public int setStateID(int startID) {
		if (states == null) {
			return startID;
		}
	
		for(int i=0; i<states.length; i++) {
			states[i].setStateID(startID);
			startID++;
		}
		return startID;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#recomputeUnmatchedState()
	 */
	public boolean recomputeUnmatchedState() {
		boolean returnvalue = true;
		
		try {
			
			/* if left state is unmatched */
			if (states[0].isMatched() == false) {
				
				if(this.getNode().getOpChildrenSize() < 1) 
					throw new Exception("operator with unmatched state must have at least one child!");
				
				XATStreamOperator childop = this.getNode().getOpChild(0).getStreamOperator();
				
				if(!childop.getOutputQueue().equals(this.getNthInputQueue(0)) || !(childop instanceof BinaryPunctuationStreamSingleEquiJoinOperator)) {
					throw new Exception("Error recomputing unmatched state!");
				} 
				
				PunctHashSingleEquiJoinState lstate = (PunctHashSingleEquiJoinState)childop.getState()[0];
				Hashtable lpunctstore = lstate.getPunctuationstore();
				PunctHashSingleEquiJoinState rstate = (PunctHashSingleEquiJoinState)childop.getState()[1];
				Hashtable rpunctstore = rstate.getPunctuationstore();
				
				if(lstate.isMatched() && rstate.isMatched()) {
				
					Hashtable lstatetuples = (Hashtable)lstate.getAllStateTuples();
					Enumeration en = lstatetuples.keys();
					while (en.hasMoreElements()) {
						Object key = en.nextElement();
						XATTuple[] result = rstate.probe(key);
						if (result == null) {
							continue;
						}
						ArrayList resultTupleArray = new ArrayList();
						ArrayList tupleList = (ArrayList) lstatetuples.get(key);
						for (int m=0; m<tupleList.size(); m++) {
							XATTuple newObj = (XATTuple)tupleList.get(m);
							for (int i=0; i<result.length; i++) {
								resultTupleArray.add(XATTupleImp.combineTuples(newObj, result[i]));
							}
						}
						((PunctHashSingleEquiJoinState)states[0]).insertTuples(key, resultTupleArray);
					}
					Hashtable newPunctStore = new Hashtable();
					ArrayList newUnpurgedPunctList = new ArrayList();
					en = lpunctstore.keys();
					while(en.hasMoreElements()) {
						Object key = en.nextElement();
						Object rPunctObj = rpunctstore.get(key);
						if (rPunctObj != null) {
							XATTuple lPunct = (XATTuple)lpunctstore.get(key);
							XATTuple rPunct = (XATTuple)rPunctObj;
							XATTuple newPunct = XATTupleImp.combineTuples(lPunct, rPunct);
							newPunctStore.put(key, newPunct);
							newUnpurgedPunctList.add(newPunct);
						}
					}
					states[0].setMatched(true);
					((PunctHashSingleEquiJoinState)states[0]).setPunctuationStore(newPunctStore);
					((PunctHashSingleEquiJoinState)states[0]).setUnpurgedPunctList(newUnpurgedPunctList);
				} else {
					returnvalue = false;
				} 			
			}
			
			/* if right state is unmatched */
			if (states[1].isMatched() == false) {

				if(this.getNode().getOpChildrenSize() < 1) 
					throw new Exception("operator with unmatched state must have at least one child!");
				
				XATStreamOperator childop = this.getNode().getOpChild(0).getStreamOperator();

				if(childop.getOutputQueue() != this.getNthInputQueue(1)) {
					
					childop = this.getNode().getOpChild(1).getStreamOperator();
					if(childop.getOutputQueue() != this.getRightInputQueue())
						throw new Exception("Error recomputing unmatched state!");
				}	
				
				if(!(childop instanceof BinaryPunctuationStreamSingleEquiJoinOperator)) {
					throw new Exception("Error recomputing unmatched state!");
				} 
				
				PunctHashSingleEquiJoinState lstate = (PunctHashSingleEquiJoinState)childop.getState()[0];
				Hashtable lpunctstore = lstate.getPunctuationstore();
				PunctHashSingleEquiJoinState rstate = (PunctHashSingleEquiJoinState)childop.getState()[1];
				Hashtable rpunctstore = rstate.getPunctuationstore();
				
				if(lstate.isMatched() && rstate.isMatched()) {
					Hashtable lstatetuples = (Hashtable)lstate.getAllStateTuples();
					Enumeration en = lstatetuples.keys();
					while (en.hasMoreElements()) {
						Object key = en.nextElement();
						XATTuple[] result = rstate.probe(key);
						if (result == null) {
							continue;
						}
						ArrayList resultTupleArray = new ArrayList();
						ArrayList tupleList = (ArrayList) lstatetuples.get(key);
						for (int m=0; m<tupleList.size(); m++) {
							XATTuple newObj = (XATTuple)tupleList.get(m);
							for (int i=0; i<result.length; i++) {
								resultTupleArray.add(XATTupleImp.combineTuples(newObj, result[i]));
							}
						}
						((PunctHashSingleEquiJoinState)states[1]).insertTuples(key, resultTupleArray);
					}
					
					Hashtable newPunctStore = new Hashtable();
					ArrayList newUnpurgedPunctList = new ArrayList();
					en = lpunctstore.keys();
					while(en.hasMoreElements()) {
						Object key = en.nextElement();
						Object rPunctObj = rpunctstore.get(key);
						if (rPunctObj != null) {
							XATTuple lPunct = (XATTuple)lpunctstore.get(key);
							XATTuple rPunct = (XATTuple)rPunctObj;
							XATTuple newPunct = XATTupleImp.combineTuples(lPunct, rPunct);
							newPunctStore.put(key, newPunct);
							newUnpurgedPunctList.add(newPunct);
						}
					}
					states[1].setMatched(true);
					((PunctHashSingleEquiJoinState)states[1]).setPunctuationStore(newPunctStore);
					((PunctHashSingleEquiJoinState)states[1]).setUnpurgedPunctList(newUnpurgedPunctList);
				} else {
					returnvalue = false;
				} 			
			}	
		} catch (Exception e) {
			System.out.println("Something wrong when recomputing unmatched states. ");
			e.printStackTrace();
			return false;
		}
		return returnvalue;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#matchStates(edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator)
	 */
	public boolean matchStates(XATStreamOperator newboxoperator) {
		if (!(newboxoperator instanceof BinaryPunctuationStreamSingleEquiJoinOperatorImp)) {
			return false;
		}
	  	int thisSize = this.states.length;
	  	int thatSize = newboxoperator.getState().length;
	  	OperatorState[] thatstates = newboxoperator.getState();
	  	boolean hasmatchedstate = false;
	  	
	  	for(int i=0; i<thisSize; i++) {
	  		for(int j=0; j<thatSize; j++) {
	  			// found a matched state
	  			if(states[i].getStateID() == thatstates[j].getStateID()) {
	  				thatstates[j].setMatched(true);
	  				thatstates[j].copyStateContent(states[i]);
	  				hasmatchedstate = true;
	  			}
	  		}
	  	}
	  	
	  	return hasmatchedstate;
	}
	/** End methods for migration. */
	public boolean finalizeOperation(){
		return true;
	}
	public boolean getPropagateFlag() {
		return propagateFlag;
	}

	public void setPropagateFlag(boolean pFlag) {
		propagateFlag = pFlag;
	}
	
	public int getMemoryLimit() {
		return memoryLimit;
	}
	public void setMemoryLimit(int memLimit) {
		memoryLimit = memLimit;
	}
	
}
