/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-2-14
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator;

import java.util.Vector;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.StringTokenizer;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class FileConverter {
	String punctIndicator = "##";

	public static void main(String[] args) {
		int numArgs = args.length;
		String[] input_file_names = new String[numArgs-1];
		for (int i=0; i<numArgs-1; i++) {
			input_file_names[i] = args[i];
		}
		String output_file_name = args[numArgs-1];
		
		FileConverter dfMerger = new FileConverter();
		dfMerger.mergeFiles(input_file_names, output_file_name);
	}
	
	public void statFileConvert(String inFile, String operatorName) {
		String outputFile = inFile+"-convert.csv";
		String inputFile = inFile+".csv";
		int opNameLength = operatorName.length();
		
		Vector tuple_gen_time_vector = new Vector();
		try {
			BufferedReader reader = new BufferedReader(new FileReader(inputFile));
			String new_line = null;
			while((new_line = reader.readLine())!=null) {
				new_line = new_line.trim();
				if (new_line.length() < opNameLength) {
					continue;
				}
				if (!new_line.substring(0, opNameLength).equals(operatorName)) {
					continue;
				}
				StringTokenizer st = new StringTokenizer(new_line, ",");
				st.nextToken();
				tuple_gen_time_vector.add(new Long(st.nextToken().trim()));
			}
			reader.close();
			BufferedWriter writer = new BufferedWriter(new FileWriter(outputFile));
			for (int i=0; i<tuple_gen_time_vector.size(); i++) {
				long gen_time = ((Long) tuple_gen_time_vector.get(i)).longValue();
				writer.write(gen_time+"\n");
			}
			writer.flush();
			writer.close();
			System.out.println("Done file conversion.");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void streamFileConvert(String inFile, int colPos, String colDivider, int interval) {
		String outputFile = inFile+"-convert.dat";
		String inputFile = inFile+".dat";
		
		BufferedReader reader = null;
		BufferedWriter writer = null;
		try {
			reader = new BufferedReader(new FileReader(inputFile));
			writer = new BufferedWriter(new FileWriter(outputFile));
			
			String new_line_read = null;
			int cursor = 1;
			while((new_line_read = reader.readLine())!=null) {
				new_line_read = new_line_read.trim();
				if (new_line_read.length() == 0) {
					continue;
				}
				StringTokenizer st = new StringTokenizer(new_line_read, colDivider);
				String new_line_write = new String();
				for (int i=0; i<colPos; i++) {
					new_line_write += st.nextToken();
					new_line_write += colDivider;
				}
				
				String tobeconvertstr = st.nextToken();
				if (tobeconvertstr.trim().equals("*")) {
					new_line_write += tobeconvertstr;
				} else {				
					long timestamp = Long.parseLong(tobeconvertstr)+cursor*interval;
					new_line_write += timestamp;
				}
				cursor ++;

				while(st.hasMoreTokens()) {
					new_line_write += colDivider;
					new_line_write += st.nextToken();
				}
				writer.write(new_line_write+"\n");
				writer.flush();
			}
			reader.close();
			writer.close();
			System.out.println("Done file conversion.");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void mergeFiles(String[] inputFileNames, String outputFileName) {
		int numInputFiles = inputFileNames.length;
		BufferedReader[] readers = new BufferedReader[numInputFiles];
		BufferedWriter writer = null;
		try {
			for (int i=0; i<numInputFiles; i++) {
				readers[i] = new BufferedReader(new FileReader(inputFileNames[i]));
			}
			writer = new BufferedWriter(new FileWriter(outputFileName));
		} catch(Exception e) {
			e.printStackTrace();
		}
		String[] cachedLines = new String[numInputFiles];
		boolean stop = false;
		try {
			while(!stop) {
				for (int i=0; i<numInputFiles; i++) {
					String newLine = null;
					if ((newLine = readers[i].readLine()) == null) {
						stop = true;
						break;
					}
					if (newLine.startsWith(punctIndicator)) {
						StringBuffer sb = new StringBuffer();
						sb.append(punctIndicator);
						
						for (int j=0; j<i; j++) {
							sb.append("*, ");
						}
						sb.append(newLine.substring(2, newLine.length()));
						for (int j=i+1; j<numInputFiles; j++) {
							sb.append(", *");
						}
						writer.write(sb.toString()+"\n");
						if ((newLine = readers[i].readLine()) == null) {
							stop = true;
							break;
						}
						cachedLines[i] = newLine;
					} else {
						cachedLines[i] = newLine;
					}
				}//end for
				if (stop) {
					break;
				}
				StringBuffer newOutputLine = new StringBuffer();
				for (int i=0; i<numInputFiles-1; i++) {
					newOutputLine.append(cachedLines[i]+", ");
				}
				newOutputLine.append(cachedLines[numInputFiles-1]);
				writer.write(newOutputLine.toString()+"\n");
			}//end while
			writer.flush();
			writer.close();
			for (int i=0; i<numInputFiles; i++) {
				readers[i].close();
			}
			System.out.println("Done.");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	public void appendNewColumns(String inFileName, String outFileName) {
		try {
			BufferedReader bReader = new BufferedReader(new FileReader(inFileName));
			BufferedWriter bWriter = new BufferedWriter(new FileWriter(outFileName));
			while (true) {
				String newLine = null;
				if ((newLine = bReader.readLine()) == null) {
					break;
				}
				if (newLine.startsWith(punctIndicator)) {
					bWriter.write(newLine+", *"+"\n");
				} else {
					bWriter.write(newLine+", 1"+"\n");
				}
				bWriter.flush();
			}
			bReader.close();
			bWriter.close();
			System.out.println("Done.");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
}
