/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on May 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.GroupbyHashEntry;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingleAttributeGroupbyStateImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamGroupbyOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PunctuationSingleAttributeGroupbyOperatorImp
	extends StreamGroupbyOperatorImp 
	implements PunctuationStreamOperator {
	
	protected boolean propagateFlag;
	protected int memoryLimit;
	
	protected PunctHashSingleAttributeGroupbyStateImp state;
	
	/*
	public PunctuationStreamGroupbyOperatorImp(PunctuationStreamGroupbyOperatorImp oldop, 
			XATNode newnode) {
		super(oldop, newnode);
		state = (PunctHashGroupbyStateImp)this.states[0];
	}*/

	/**
	 * constructor
	 * @param init
	 */
	public PunctuationSingleAttributeGroupbyOperatorImp(XATNode init) {
		super(init);
	}
	
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#run()
	 */
	public boolean run() throws Exception {
		if (!hasInit()) {
			init();
			if (!hasInit()) {
				return false;
			}
		}

		XATQueue inputQueue = this.getInputQueue();
		int howMany = Integer.parseInt(this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
		//int howMany = 600;
		int tupleCount = 0;
		
		
		while (true) {
			if (tupleCount == howMany) {
				return true;
			}
			try {
				XATTuple tuple = inputQueue.dequeue(this);
								
				if (tuple.isPunct()) {
					//int type = ((XATPunct)tuple).getPunctType(groupAttrPosArray[0]);
					//if (type == XATPunct.SINGLE_VALUE) {
						Object punctValue = tuple.getCell(groupAttrPosArray[0]).getValue();
						GroupbyHashEntry result = state.getSingleGroupEntry(punctValue);
						if (result != null) {
							XATTuple resultTuple = generateResultForSingleGroup(result);
							this.getOutputQueue().enqueue(resultTuple, this);
							state.purge(punctValue);
						}
						if (((XATPunct)tuple).getMesgType()==XATPunct.IGNORE) {
							state.addIgnoreValue(punctValue);
						} else {
							state.removeIgnoreValue(punctValue);
						}
					//} else if (type == XATPunct.SET_VALUE) {
						//ArrayList punctList = (ArrayList) tuple.getCell(groupAttrPosArray[0]);
						//for (int i=0; i<punctList.size(); i++) {
							//XATTuple[] result = ((PunctHashGroupbyStateImp)state).generateSingleGroup(punctList.get(i));
							//if (result != null) {
								//int numTuplesInGroup = result.length; // for demo purpose
								//generateResultForSingleGroup(result);
								//((PunctHashGroupbyStateImp)state).purgeByPunct(punctList.get(i), groupAttrPosArray[0]);
							//}
						//}
					//} else {
						//continue;
					//}
					if (propagateFlag) {
						this.getOutputQueue().enqueue(generateResultPunct((XATPunct)tuple), this);
					}
				} else {
					tupleCount ++;
					state.probe(tuple);			
				}
			} catch(Exception e) {
				break;
			}
		}
		return true;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		return "Punct-Groupby";
	}

	public void setState(OperatorState[] state) {
		this.states = new OperatorState[state.length];
		for(int i = 0; i < this.states.length; i++){
			this.states[i] = state[i];
		}
		this.state = (PunctHashSingleAttributeGroupbyStateImp)state[0];
	}

	public boolean getPropagateFlag() {
		return propagateFlag;
	}

	public void setPropagateFlag(boolean pFlag) {
		propagateFlag = pFlag;
	}
	
	public int getMemoryLimit() {
		return memoryLimit;
	}
	public void setMemoryLimit(int memLimit) {
		memoryLimit = memLimit;
	}
	protected XATTuple generateResultForSingleGroup(GroupbyHashEntry entry) {
		int numFunctions = aggFunctions.length;
		XATDataValue[] resultValue = new XATDataValue[numOutputColumns];
		long[] resultTime = new long[numOutputColumns];
		//long[] firstTupleTime = entry.getTimestamp();
		long minTime = entry.getMinTimestamp();
		long maxTime = entry.getMaxTimestamp();

		resultValue[0] = new XATDataValueImp(entry.getSearchKeys()[0]);
		//resultTime[0] = firstTupleTime[outputPositions[0][0]];
		for (int i=0; i<numFunctions; i++) {
			StreamFunction func = aggFunctions[i];
			func.setCurrentValue(entry.getithCurrentValue(0));
			func.increment((XATTuple[])entry.getTupleList().toArray(new XATTuple[]{}));
			resultValue[i+1] = new XATDataValueImp(new Double(func.getCurrentValue()));
			resultTime[i+1] = minTime;
		}
		XATTuple resultTuple = new XATTupleImp(resultValue);
		resultTuple.setTimeStamp(resultTime);
		resultTuple.setMinTimeStamp(minTime);
		resultTuple.setMaxTimeStamp(maxTime);
		return resultTuple;
	}

}
