/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Aug 18, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator;

import java.util.Vector;
import java.util.Iterator;
import java.util.HashMap;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueException;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamGroupbyOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.GroupbyHashEntry;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHybridIndexGroupbyStateImp;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PunctuationStreamGroupbyHybridIndexOperatorImp extends
		StreamGroupbyOperatorImp implements PunctuationStreamOperator {
	//TEMP
	int numOutput = 0;
	
	protected static int HASH_FACTOR = 128; //used by hash function
	protected long window;
	//state used before migration
	protected PunctHybridIndexGroupbyStateImp state;
	//state used after migration
	protected PunctHybridIndexGroupbyStateImp newstate;
	
	//the following two fields are used for parallel migration
	//flag indicating whether migration is on-going
	protected boolean inMigration = false;
	protected long migrationStartTime;
	
	//intermediate data structure for generating results
	protected HashMap resultGenTable;
	
	int tupleCount = 0;
	
	/**
	 * @param init
	 */
	public PunctuationStreamGroupbyHybridIndexOperatorImp(XATNode init) {
		super(init);
		resultGenTable = new HashMap(200, (float)0.85);
	}
	
	/**
	 * @param win
	 */
	public void setWindow(long win) {
		window = win;
	}
	
	/**
	 * for result generation
	 * @param keys
	 * @return
	 */
	private int hash(Object[] keys) {
		int hashValue = 0;
		int numKeys = keys.length;
		for (int i=0; i<numKeys; i++) {
			int hashKey = ((Number)keys[i]).intValue();
			hashValue += hashKey * (2^i) * HASH_FACTOR; 
		}
		return hashValue;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#run()
	 */
	public boolean run() throws Exception {
		if (!hasInit()) {
			init();
			if (!hasInit()) {
				return false;
			}
		}

		XATQueue inputQueue = this.getInputQueue();
		//int howMany = Integer.parseInt(this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
		int howMany = 400;
		
		while (true) {
			if (tupleCount == howMany) {
				tupleCount = 0;
				return true;
			}
			try {
				XATTuple tuple = inputQueue.dequeue(this);
								
				if (tuple.isPunct()) { //punctuation (or query)
					Vector result = new Vector();
					if (inMigration) {
						result = state.generateGroups((XATPunct)tuple);
						result.addAll(newstate.generateGroups((XATPunct)tuple));
					} else {
						result = state.generateGroups((XATPunct)tuple);
					}
					Iterator it = result.iterator();
					while (it.hasNext()) {
						XATTuple nextTuple = (XATTuple)it.next();
						Object[] keys = new Object[numGroupAttrs];
						for (int i=0; i<numGroupAttrs; i++) {
							keys[i] = nextTuple.getCell(groupAttrPosArray[i]).getValue();
						}
						
						Integer hashKey = new Integer(hash(keys));
						Object obj = resultGenTable.get(hashKey);
						if (obj == null) { 
							GroupbyHashEntry hashEntry = new GroupbyHashEntry(keys);
							hashEntry.insertTuple(nextTuple);
							Vector bucket = new Vector();
							bucket.add(hashEntry);
							resultGenTable.put(hashKey, bucket);
						} else {
							Vector v_entry = (Vector) obj;
							int numEntries = v_entry.size();
							boolean foundMatchEntry = false;
							
							for (int i=0; i<numEntries; i++) {
								GroupbyHashEntry hashEntry = (GroupbyHashEntry) v_entry.get(i);
								if (nextTuple.equalKeys(hashEntry.getSearchKeys(), groupAttrPosArray)) {
									hashEntry.insertTuple(nextTuple);
									foundMatchEntry = true;
									break;
								}
							}
							if (!foundMatchEntry) {
								GroupbyHashEntry hashEntry = new GroupbyHashEntry(keys);
								hashEntry.insertTuple(nextTuple);
								v_entry.add(hashEntry);
							}
						}
					}
					it = resultGenTable.values().iterator();
					while (it.hasNext()) {
						Vector nextBucket = (Vector)it.next();
						Iterator itBucket = nextBucket.iterator();
						while (itBucket.hasNext()) {
							GroupbyHashEntry nextEntry = (GroupbyHashEntry)itBucket.next();
							XATTuple resultTuple = generateResultForSingleGroup(nextEntry);
							numOutput ++;
							//this.getOutputQueue().enqueue(resultTuple, this);
							// for debug purpose
							//System.out.println(resultTuple);
						}
					}
					resultGenTable.clear();
				} else { //regular tuple
					tupleCount ++;
					if (inMigration) {
						newstate.probe(tuple);
						long minTS = tuple.getMinTimeStamp();
						//check whether migration finishes
						if (minTS - window > migrationStartTime) {
							inMigration = false;
							states[0] = newstate;
							state = newstate;
							newstate = null;
						}
					} else {
						state.probe(tuple);
					}
				}
			} catch(XATQueueException e) {
				return false;
			} catch(Exception e2) {
				return false;
			}
		}
	}

	/**
	 * applicable to all cases
	 */
	public void stateMoveByTuple() {
		Vector oldStateBuckets = state.collectIndexObjects(
				state.getNumLevels());
		newstate.insertTuples(oldStateBuckets);
		states[0] = newstate;
		state = newstate;
		newstate = null;
	}

	/**
	 * only applicable to full single_val_index
	 */
	public void stateMoveByBucket() {
		Vector oldStateBuckets = state.collectIndexObjects(
				state.getNumLevels());
		newstate.insertBuckets(oldStateBuckets);
		states[0] = newstate;
		state = newstate;
		newstate = null;
	}
	
	/**
	 * @param indexLevel
	 */
	public void stateMoveByIndex(int indexLevel) {
		Vector oldStateIndexes = state.collectIndexObjects(indexLevel);
		newstate.insertIndexes(oldStateIndexes);
		states[0] = newstate;
		state = newstate;
		newstate = null;
	}
	
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamOperator#getPropagateFlag()
	 */
	public boolean getPropagateFlag() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamOperator#setPropagateFlag(boolean)
	 */
	public void setPropagateFlag(boolean pFlag) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamOperator#getMemoryLimit()
	 */
	public int getMemoryLimit() {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamOperator#setMemoryLimit(int)
	 */
	public void setMemoryLimit(int memLimit) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setState(edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState[])
	 */
	public void setState(OperatorState[] opstate) {
		this.states = new OperatorState[opstate.length];
		for(int i = 0; i < this.states.length; i++){
			this.states[i] = opstate[i];
		}
		this.state = (PunctHybridIndexGroupbyStateImp)opstate[0];
		this.state.init();
	}
	
	//for migration purpose
	
	/**
	 * @param state
	 */
	public void setNewState(OperatorState nstate) {
		newstate = (PunctHybridIndexGroupbyStateImp)nstate;
		newstate.init();
	}
	
	/**
	 * @param mStartTime
	 */
	public void setMigrationStartTime(long mStartTime) {
		migrationStartTime = mStartTime;
	}

	/**
	 * @param mFlag
	 */
	public void setMigrationFlag(boolean mFlag) {
		inMigration = mFlag;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		return "Punct-Groupby-Hybrid-Index";
	}

	/**
	 * @param gbEntry
	 * @return
	 */
	protected XATTuple generateResultForSingleGroup(GroupbyHashEntry gbEntry) {
		XATTuple[] group = (XATTuple[]) gbEntry.getTupleList().toArray(new XATTuple[] {});
		XATTuple firstTupleInGroup = group[0];
		long minTime = firstTupleInGroup.getMinTimeStamp();
		long maxTime = firstTupleInGroup.getMaxTimeStamp();

		XATDataValue[] resultValue = new XATDataValue[numOutputColumns];

		int i=0;
		Object[] gbAttrValue = gbEntry.getSearchKeys();
		for (; i<numGroupAttrs; i++) {
			resultValue[i] = new XATDataValueImp(gbAttrValue[i]);
		}
		for (int j=0; j<numAggFunctions; j++) {
			resultValue[j+i] = aggFunctions[j].evaluate(group);
		}
		XATTuple resultTuple = new XATTupleImp(resultValue);
		resultTuple.setMinTimeStamp(minTime);
		resultTuple.setMaxTimeStamp(maxTime);
		return resultTuple;
	}
	
	//TEMP
	public int getNumOutput() {
		return numOutput;
	}
	public void resetNumOutput() {
		numOutput = 0;
	}
}
