/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on May 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueException;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctGroupbyStateImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.GroupbyHashEntry;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamGroupbyOperatorImp;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PunctuationStreamGroupbyOperatorImp
	extends StreamGroupbyOperatorImp 
	implements PunctuationStreamOperator {
	
	protected boolean propagateFlag;
	protected int memoryLimit;
	
	protected PunctGroupbyStateImp state;
	int maxPunctCount = 10;
	
	/**
	 * constructor
	 * @param init
	 */
	public PunctuationStreamGroupbyOperatorImp(XATNode init) {
		super(init);
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#run()
	 */
	public boolean run() throws Exception {
		if (!hasInit()) {
			init();
			if (!hasInit()) {
				return false;
			}
		}

		XATQueue inputQueue = this.getInputQueue();
		int howMany = Integer.parseInt(this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
		//int howMany = 100;
		int tupleCount = 0;
		int punctCount = 0;
		
		while (true) {
			if (tupleCount == howMany) {
				/*
				if (state instanceof PunctHashSymmetricGroupbyStateImp) {
					((PunctHashSymmetricGroupbyStateImp) state).cleanupDeletedGroups();
				}*/
				return true;
			}
			try {
				XATTuple tuple = inputQueue.dequeue(this);
								
				if (tuple.isPunct()) {
					ArrayList result = state.generateGroups((XATPunct)tuple);
					Iterator it = result.iterator();
					while (it.hasNext()) {
						GroupbyHashEntry hashEntry = (GroupbyHashEntry)it.next();
						ArrayList SingleGroup = hashEntry.getTupleList();
						if (SingleGroup.size() != 0) {
							//XATTuple resultTuple = generateResultForSingleGroup((XATTuple[])SingleGroup.toArray(new XATTuple[]{}));
							XATTuple resultTuple = new XATTupleImp(numOutputColumns);
							this.getOutputQueue().enqueue(resultTuple, this);
							//for debug purpose
							//System.out.println(resultTuple);
						}
					}
					if (propagateFlag) {
						this.getOutputQueue().enqueue(generateResultPunct((XATPunct)tuple), this);
					}
					/*
					punctCount ++;
					if ((punctCount == maxPunctCount) && (state instanceof PunctHashSymmetricGroupbyStateImp)) {
						int[] hashtablePosArray = new int[numGroupAttrs];
						for (int i=0; i<numGroupAttrs; i++) {
							hashtablePosArray[i] = i;
						}
						((PunctHashSymmetricGroupbyStateImp)state).cleanupDeletedGroups(hashtablePosArray);
					}*/
				} else {
					tupleCount ++;
					state.probe(tuple);			
				}
			} catch(XATQueueException e) {
				break;
			} catch(Exception e2) {
				e2.printStackTrace();
			}
		}
		return true;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		return "Punct-Groupby";
	}

	public void setState(OperatorState[] state) {
		this.states = new OperatorState[state.length];
		for(int i = 0; i < this.states.length; i++){
			this.states[i] = state[i];
		}
		this.state = (PunctGroupbyStateImp)state[0];
		this.state.init();
	}

	public boolean getPropagateFlag() {
		return propagateFlag;
	}

	public void setPropagateFlag(boolean pFlag) {
		propagateFlag = pFlag;
	}
	
	public int getMemoryLimit() {
		return memoryLimit;
	}
	public void setMemoryLimit(int memLimit) {
		memoryLimit = memLimit;
	}
}
