/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-1-19
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 * count-based window
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator;

import java.util.ArrayList;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.PunctHashSingleAttributePartitionWinStateImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamGroupbyOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PunctuationStreamPartitionWindowOperatorImp 
		extends StreamGroupbyOperatorImp
		implements PunctuationStreamPartitionWindowOperator {

	protected boolean propagateFlag;
	protected int memoryLimit;
	
	protected PunctHashSingleAttributePartitionWinStateImp state;
	int window_size = 1;

	/**
	 * @param oldop
	 * @param newnode
	 */
	/*
	public PunctuationStreamPartitionWindowOperatorImp(
			PunctuationStreamPartitionWindowOperatorImp oldop, XATNode newnode) {
		super(oldop, newnode);
		window_size = oldop.getWindowSize();
		state = (PunctHashPartitionWinStateImp)this.states[0];
	}*/

	public PunctuationStreamPartitionWindowOperatorImp(XATNode init) {
		super(init);
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamPartitionWindowOperator#getWindowSize()
	 */
	public int getWindowSize() {
		// TODO Auto-generated method stub
		return window_size;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamPartitionWindowOperator#setWindowSize(long)
	 */
	public void setWindowSize(int wSize) {
		this.window_size = wSize;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#run()
	 */
	public boolean run() throws Exception {

		if (!hasInit()) {
			init();
			if (!hasInit()) {
				return false;
			}
		}

		XATQueue inputQueue = this.getInputQueue();
		int howMany = Integer.parseInt(this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
		//int howMany = 600;
		
		ArrayList tupleList = new ArrayList();
		int tupleCount = 0;
		
		while (true) {
			if (tupleCount == howMany) {
				return true;
			}
			try {
				XATTuple tuple = inputQueue.dequeue(this);
								
				if (tuple.isPunct()) {
					//int type = ((XATPunct)tuple).getPunctType(groupAttrPosArray[0]);
					//if (type == XATPunct.SINGLE_VALUE) {
						//state.processTuples();
						Object punctValue = tuple.getCell(groupAttrPosArray[0]).getValue();
						XATTuple[] result = state.generateSingleGroup(punctValue);
						if (result != null) {
							XATTuple resultTuple = generateResultForSingleGroup(result);
							this.getOutputQueue().enqueue(resultTuple, this);
							state.purge(punctValue);
						}
					//} else if (type == XATPunct.SET_VALUE) {
						//ArrayList punctList = (ArrayList) tuple.getCell(groupAttrPosArray[0]);
						//for (int i=0; i<punctList.size(); i++) {
							//XATTuple[] result = state.generateSingleGroup(punctList.get(i));
							//if (result != null) {
								//int numTuplesInGroup = result.length; // for demo purpose
								//generateResultForSingleGroup(result);
								//state.purgeByPunct(punctList.get(i));
							//}
						//}
					//} else if (type == XATPunct.RANGE_VALUE) {
						//continue;
					//} else if (type == XATPunct.ALL_VALUE || type == XATPunct.NULL_VALUE) {
						//continue;
					//}
					if (propagateFlag) {
						this.getOutputQueue().enqueue(this.generateResultPunct((XATPunct)tuple), this);
					}
				} else {
					tupleCount ++;
					state.probe(tuple);
					//state.insertTuple(tuple);			
				}
			} catch(Exception e) {
				break;
			}
		}
		return true;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamPartitionWindowOperator#getGroupAttrPos(int)
	 */
	public int getGroupAttrPos(int pos) {
		return this.groupAttrPosArray[pos];
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamPartitionWindowOperator#getGroupAttrPosArray()
	 */
	public int[] getGroupAttrPosArray() {
		return this.groupAttrPosArray;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamPartitionWindowOperator#setGroupAttrPos(int, int)
	 */
	public void setGroupAttrPos(int pos, int gAttrPos) {
		this.groupAttrPosArray[pos] = gAttrPos;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PunctuationStreamPartitionWindowOperator#setGroupAttrPosArray(int[])
	 */
	public void setGroupAttrPosArray(int[] gAttrPosArray) {
		this.groupAttrPosArray = gAttrPosArray;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		return "PartitionWindow";
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setState(edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState[])
	 */
	public void setState(OperatorState[] state) {
		this.states = new OperatorState[state.length];
		for(int i = 0; i < this.states.length; i++){
			this.states[i] = state[i];
		}
		this.state = (PunctHashSingleAttributePartitionWinStateImp)state[0];
	}
	
	public boolean getPropagateFlag() {
		return propagateFlag;
	}

	public void setPropagateFlag(boolean pFlag) {
		propagateFlag = pFlag;
	}
	
	public int getMemoryLimit() {
		return memoryLimit;
	}
	public void setMemoryLimit(int memLimit) {
		memoryLimit = memLimit;
	}

}
