package edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

/**
 * An interface for the Source opertor.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0      
 */

public interface Source extends SpecialOperator {
    public static final int XML = 0;
    public static final int TABLE = 1;
    public static final int TEXT = 2;
    public static final int TEMP = 3;

    /**
     * get the current name of this source.
     * @return the current name.
     * @since   1.0          
     */
    String getName();

    /** Return the type of this source. It could be either XML or TABLE. 
     * @return int.
     * @since   1.0          
    */
    int getType();
    /**
     * Set the new name of this source.
     * @param The new name.
     * @return original name.
     * @since   1.0          
     */
    String setName(String newName);
    /**
     * Set the type of this source.
     * @param newType the new type of this source, could be either Source.XML or Source.TABLE.
     * @return original type.
     * @since   1.0          
     */
    int setType(int newType);
}