/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-4-25
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.spreadfire;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATMultiQueueWindowStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATMultiQueueWindowStreamOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.*;

import java.util.*;
//import java.lang.reflect.Constructor;
//import streamgenerator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.Machine;
import edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;

/**
 * @author Mingzhu Wei
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ReplicationAwareBinaryWindowEquiJoinImp 
	extends WBinaryJoinOperatorImp implements
		ReplicationAwareBinaryWindowEquiJoin, ReplicatedStreamOperator {

	//above header instead of "extends XATMultiQueueWindowStreamOperatorImp" to take advantage of ClassBuilder functionality
	/**
	 * @param oldop
	 * @param newnode
	 */
	/*
	public ReplicationAwareBinaryWindowEquiJoinImp(
			ReplicationAwareBinaryWindowEquiJoinImp oldop, XATNode newnode) {
		super(oldop, newnode);
		// TODO Auto-generated constructor stub
	}
	*/

	/**
	 * @param oldop
	 * @param newnode
	 */
	/*
	public ReplicationAwareBinaryWindowEquiJoinImp(
			ReplicationAwareBinaryWindowEquiJoinImp oldop, XATNode newnode) {
		super(oldop, newnode);
		// TODO Auto-generated constructor stub
	}
	*/

	/** if this is oldBoxRoot, allOldOperators will be set to the right array. Otherwise, this is null */
	private XATStreamOperator[] allOldOperators = null;
	private ExpressionStr expression;
	ArrayList keptTuples = new ArrayList();

	boolean leftStateToken = false;
	boolean rightStateToken = false;
	
	boolean leftStreamTerminated = false;
	boolean rightStreamTerminated = false;
	
	boolean firstrun = true;
	String MachineName;
	
	public String getMachineName (Machine curMachine){
		
		this.MachineName = curMachine.getMachineName();
		return this.MachineName;
		
	}
	

	/** The numOfChildren and numOfChildrenDone are here to decide if an operator inside an old box has done
	 *  during migration stage, meaning all the old tuple in states are purged. 
	 *  numOfChildren starts as the real num of children of this operator. Since we have only binary join now, this is
	 *  always set to be 2.
	 *  numOfChildrenDone always starts as 0, and increased by its child operator if that operator is done.
	 *
	 *  When numOfChildrenDone == numOfChildren, and the two states of this operator has no tuple gets processed after
	 *  migration starts, this operator is also done and will increase its parent's numOfChildrenDone.
	 */
	
	public ReplicationAwareBinaryWindowEquiJoinImp(XATNode node) {
		super(node);
	}	
	public ReplicationAwareBinaryWindowEquiJoinImp
	(ReplicationAwareBinaryWindowEquiJoinImp oldop, XATNode newnode) {
		super(oldop, newnode);
		this.expression = oldop.expression;
		//states = new WOperatorState[2];
		//this.inToOutColPos = oldop.inToOutColPos;
		this.windowSize = oldop.windowSize;

		

	}
	

	public ReplicationAwareBinaryWindowEquiJoinImp(XATNode node, Machine curMachine) {
		super(node);

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/17/2003 4:48:47 PM)
	 */
	
	public void initState(String statetype) {

		try{	
			//Constructor con = Class.forName(statetype).getConstructor();
			states = new WOperatorState[2];
			states[0] = (WOperatorState)Class.forName(statetype).newInstance();
			states[1] = (WOperatorState)Class.forName(statetype).newInstance();
			states[0].setOperator(this);
			states[1].setOperator(this);
			if(this.windowSize > 0) {
				((WOperatorState)states[0]).setTimeWindow(this.windowSize);
				((WOperatorState)states[1]).setTimeWindow(this.windowSize);
			}
		}catch(Exception e) {
			e.printStackTrace();	
		}
		
	}
	/**
	 * Clear all tuples inside this operator and all tuples insides its states
	 */

	/**
	 * This method is used at the end of Parallel Migration when old box is done.
	 * If this operator is a leaf operator of new box, the kept tuples
	 * for purpose of preserve partial order will now be pushed out and
	 * enqueued to output queue all at once.
	 * Creation date: (6/26/2003 4:31:05 AM)
	 */
	public void enqueueKeptTuples() {

		XATTuple[] tuples = (XATTuple[]) keptTuples.toArray(new XATTuple[] {
		});
		this.getOutputQueue().enqueue(tuples, this);
		System.out.println(
			"push out " + tuples.length + " tuples from newbox root operator");

		keptTuples.clear();
		this.isNewBoxRoot = false;
		return;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/5/2003 6:59:19 PM)
	 */
	
	private void execOperator(int lHowmany, int rHowmany) {


		
		XATQueue oQueue = this.getOutputQueue();
		XATQueue linputQueue = this.getLeftInputQueue();
		XATQueue rinputQueue = this.getRightInputQueue();
		XATTuple[] tuples;
		XATTuple[] joinedtuples;
		
		 //join tuples from left queue to right state 
		if(lHowmany != 0) {
			tuples = linputQueue.dequeue(lHowmany, this);
			XATTuple[] tuplesNoCmdMsgLeft = DelCmdMsg(tuples);

			if((states[1].getStateSize() != 0) && (tuplesNoCmdMsgLeft.length > 0)) {
				long starttime = System.currentTimeMillis();
                joinedtuples = ((WOperatorState)states[1]).probe(tuplesNoCmdMsgLeft, this.expression, 1);
                long endtime = System.currentTimeMillis();
                System.out.println("Op " + getOperatorID() + ": left side probe took " + (endtime - starttime) + "ms for " + lHowmany + " new tuples");
				if(joinedtuples.length > 0)
					oQueue.enqueue(joinedtuples, this);
			}
			if (this.leftStateToken == true) {
				((WOperatorState)states[0]).insertTuple(tuples);
			}
			

		}

		
		//join tuples from right queue to left state 
		if(rHowmany != 0) {
			tuples = rinputQueue.dequeue(rHowmany, this);
			XATTuple[] tuplesNoCmdMsgRight = DelCmdMsg(tuples);

			if ((states[0].getStateSize() != 0) &&  (tuplesNoCmdMsgRight.length > 0)) {
			    long starttime = System.currentTimeMillis();
                joinedtuples = ((WOperatorState)states[0]).probe(tuplesNoCmdMsgRight, this.expression, 0);
                long endtime = System.currentTimeMillis();
                System.out.println("Op " + getOperatorID() + ": right side probe took " + (endtime - starttime) + "ms for " + rHowmany +" new tuples");
			

				if (joinedtuples.length > 0)
					oQueue.enqueue(joinedtuples, this);
			}
			if (this.rightStateToken == true){
				((WOperatorState)states[1]).insertTuple(tuples);
			}
		}
	}
	
	private void execOperatorToken(int lHowmany, int rHowmany) {

		XATQueue oQueue = this.getOutputQueue();
		XATQueue linputQueue = this.getLeftInputQueue();
		XATQueue rinputQueue = this.getRightInputQueue();
		XATTuple[] tuples;
		XATTuple[] joinedtuples;
		
		/* join tuples from left queue to right state */
		if(lHowmany == 1) {
			tuples = linputQueue.dequeue(lHowmany, this);
			if ((tuples.length >=1 )&& (!JudgeTupleToken(tuples[0])))
			{	
				if((states[1].getStateSize() != 0) ) {
					joinedtuples = ((WOperatorState)states[1]).probe(tuples, this.expression, 1);
					oQueue.enqueue(joinedtuples, this);
				}
			}
			else
				oQueue.enqueue(tuples, this);
			
			if (this.leftStateToken == true) {
				((WOperatorState)states[0]).insertTuple(tuples);
			}
		}

		
		/*join tuples from right queue to left state */
		
		
		if(rHowmany == 1) {
			tuples = rinputQueue.dequeue(rHowmany, this);
			if ((tuples.length >=1 )&& (!JudgeTupleToken(tuples[0])))
				{	
					if(states[0].getStateSize() != 0) {
					joinedtuples = ((WOperatorState)states[0]).probe(tuples, this.expression, 0);
					oQueue.enqueue(joinedtuples, this);
				}
				if (this.rightStateToken == true){
					((WOperatorState)states[1]).insertTuple(tuples);
				}
			}
			else
				oQueue.enqueue(tuples, this);
		
			if (this.leftStateToken == true) {
				((WOperatorState)states[0]).insertTuple(tuples);
			}
		}
	}	
	
	public boolean JudgeTupleToken(XATTuple tuple)
	{
		if (tuple.getObjTypeID()==208)
			return true;
		else return false;
	}
	
		/**
	 * Insert the method's description here.
	 * Creation date: (6/3/2003 2:07:16 AM)
	 * @return boolean
	 */
	public boolean getAllOldPurgedFlag() {
		return 
		(((WOperatorState)states[0]).checkAllOldTuplePurged() && ((WOperatorState)states[1]).checkAllOldTuplePurged());
	}
	
	/**
	 * @return
	 */
	public ExpressionStr getExpression() {
		return expression;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/3/2003 5:00:07 AM)
	 * @return queryplanelements.WFIFOState
	 */
	public OperatorState getLeftState() {
		return states[0];
	}
	
	public int getLeftStateSize() {
		return states[0].getStateSize();
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/28/2003 12:11:23 PM)
	 * @return int
	 */

		
	/**
	 * Insert the method's description here.
	 * Creation date: (4/3/2003 5:00:50 AM)
	 * @return queryplanelements.WFIFOState
	 */
	public OperatorState getRightState() {
		return states[1];
	}
	
	public int getRightStateSize() {
		return states[1].getStateSize();
	}

	public int getStateSize() {
		return (states[0].getStateSize() + states[1].getStateSize());
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (3/15/2003 10:23:33 PM)
	 * @return int
	 */

	/**
	 * This reinit method is only used during the stage of optimization.
	 * This method assumes that all operator properties, including the predicates, window size, state schema 
	 * and input queue schema has been initialized at the execution init stage.
	 * After optimization, the state and output queue schema might be changed so this method just reset them 
	 * to the corrent schema according to the input queue schema.
	 */
	
	/**
	 * Insert the method's description here.
	 * return: -1 nothing in queue, no run
	 *			0 exception
	 *			1 run successfully
	 * 
	 * Creation date: (1/21/2003 10:57:01 AM)
	 */
	public boolean run() {

		// TODO This needs to be changed, since we'll now need to be more flexible.
		if(firstrun) {
		    
			firstrun = false;
		}
		
		if ((this.getLeftInputQueue().getSchema() == null) 
		        || (this.getRightInputQueue().getSchema() == null)){
		    return false;
		}
		if(this.getOutputQueue().getSchema() == null){
			init();
            
            ((WOperatorState)this.getLeftState()).setSchema(this.getLeftInputQueue().getSchema());
            ((WOperatorState)this.getRightState()).setSchema(this.getRightInputQueue().getSchema());
        }
		
		/** figure out how many tuples to dequeue from left and right queue */
		XATQueue lQueue = this.getLeftInputQueue();
		XATQueue rQueue = this.getRightInputQueue();
		int size1 = 1;
		int size2 = 1;

		// Thinking out loud section follows:
		// We want to cap the amount of time/processing used by the operator
		// to finish execution because the operator taking too long prevents
		// the SPREADFIRE manager from doing its job.
		//  So there are some other ways to do this:
		// 1) a hard cap on a fixed number of tuples per execution, like 200
		// 2) a floating cap to adapt to the input queue size like k*log(x)
		// 3) a cap on time spent processing, like interrupt after 10 seconds for
		//    each of left and right.
		//TODO: write code that implements the comment above.
		
		// Let's keep this one simple for now.  We'll set a hard cap of 200 tuples
		//  to process from each of the left and right.
		int numberoftuplesleft = Math.min(
		        				Integer.parseInt(
		        				    this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"
		        				    )
		        				), 
		        				Math.max(40000 / (this.getRightStateSize() + 1), 200));
        int numberoftuplesright = Math.min(
                Integer.parseInt(
                    this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"
                    )
                ), 
                Math.max(40000 / (this.getLeftStateSize() + 1), 200));
		
		// Judge whether the left tuples has the token
		
		XATTuple[] tuplesLeft = lQueue.peek(numberoftuplesleft, this);
		int lasti = 0;
		for(int i = 0; i < tuplesLeft.length; i++)
		{
			if (tuplesLeft[i].getObjTypeID() == 208)
			{
				//If we find an XATCommandMsg, we want to process all the tuples
				// before it first, then the message, then the tuples after it.
				//This code should be backportable to the WJoin operator.
				execOperator(i - lasti, 0);
				parseCommandMessage((XATCommandMsg)lQueue.dequeue(this), 0);
				// if another message happens, we want to start dequeuing from the next tuple
				lasti = i + 1;
			}
		}
			
//			 Judge whether the right tuples has the token
		XATTuple[] tuplesRight = rQueue.peek(numberoftuplesright, this);
		int lastiRight = 0;
		for(int i = 0; i < tuplesRight.length; i++)
		{
			if (tuplesRight[i].getObjTypeID() == 208)
			{
				//If we find an XATCommandMsg, we want to process all the tuples
				// before it first, then the message, then the tuples after it.
				//This code should be backportable to the WJoin operator.
				execOperator(0, i - lastiRight);
				parseCommandMessage((XATCommandMsg)rQueue.dequeue(this), 1);
				// if another message happens, we want to start dequeuing from the next tuple
				lastiRight = i + 1;
			}
		}

		execOperator(tuplesLeft.length - lasti, tuplesRight.length - lastiRight);
		/* if this is root operator of old box, check to see if both states have all old tuples purged */

		
		/* solely used by migration 1 */


		/* run successfully */
		return true;
	}

	public XATTuple[] DelCmdMsg(XATTuple[] tuples){
		
		int length= tuples.length;
		XATTuple[] tuplesNoToken = new XATTuple[length];
		int j = 0;
		for (int i=0; i<tuples.length; i++) {
			//Judge whether the current tuple is a Commandtype:
			if (tuples[i].getObjTypeID()!= 208)
			{
				tuplesNoToken[j] = tuples[i];
				j++;
			}
		}
		return tuplesNoToken;
	}
	/**
	 * Insert the method's description here.
	 *
	 * This method is currently NOT IN USE.
	 *
	 * Creation date: (5/25/2003 4:08:55 AM)
	 * @return int
	 */
	public int runForMigration1() {

		/** figure out how many tuples to dequeue from left and right queue */
		XATQueue lQueue = this.getLeftInputQueue();
		XATQueue rQueue = this.getRightInputQueue();

		int lHowmany = (lQueue.isOldBoxInput()) ? 0 : lQueue.getQueueSize(this);
		int rHowmany = (rQueue.isOldBoxInput()) ? 0 : rQueue.getQueueSize(this);

		if (debugFlag) {
			System.out.println(
				"dequeue " + lHowmany + "tuples from left queue");
			System.out.println(
				"dequeue " + rHowmany + "tuples from right queue");
		}

		try{
			lQueue.setProperty("DEQUEUED_TUPLE_COUNT", "" + lHowmany);
			rQueue.setProperty("DEQUEUED_TUPLE_COUNT", "" + rHowmany);
		} catch(Exception e) {
			System.out.println(e);
		}

		if ((lHowmany + rHowmany) == 0)
			/* nothing to run */
			return -1;
			
		execOperator(lHowmany, rHowmany);

		/* run successfully */
		return 1;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/25/2003 4:08:55 AM)
	 * @return int
	 */
	public int runForMigration2(long latestTimeStamp) {

		XATQueue lQueue = this.getLeftInputQueue();
		XATQueue rQueue = this.getRightInputQueue();

		int lsize = 0, rsize = 0;
		int lHowmany = 0;
		int rHowmany = 0;

		/** figure out howmany tuple to dequeue from left queue */
		if ((lsize = lQueue.getQueueSize(this)) != 0) {
			lHowmany = lsize;

			//if stream Queue, dequeue based on latestTimeStamp
			List ownerList = lQueue.getQueueOwner();
			int ownersize = ownerList.size();
			int ownerindex = 0;
			while (ownerindex < ownersize) {
				//if (lQueue.getQueueOwner() instanceof XATStream) {
				if (ownerList.get(ownerindex) instanceof XATStream) {
					XATTuple[] tuples = lQueue.peek(lsize, this);
					for (int i = 0; i < lsize; i++) {

						if (((XATTuple) tuples[i]).getMinTimeStamp() >= latestTimeStamp) {
							lHowmany = i;
							break;
						}
					}
				}
				break;
			}
			ownersize++;
		}
		
		/* figure out howmany tuple to dequeue from right queue */
		if ((rsize = rQueue.getQueueSize(this)) != 0) {
			rHowmany = rsize;

			if (rQueue.getQueueOwner() instanceof XATStream) {
				XATTuple[] tuples = rQueue.peek(rsize, this);
				for (int i = 0; i < rsize; i++) {

					if (tuples[i].getMinTimeStamp() >= latestTimeStamp) {
						rHowmany = i;
						break;
					}
				}
			}
		}
	
		try{
			lQueue.setProperty("DEQUEUED_TUPLE_COUNT", "" + lHowmany);
			rQueue.setProperty("DEQUEUED_TUPLE_COUNT", "" + rHowmany);
		} catch(Exception e) {
			System.out.println(e);
		}

		if ((lHowmany + rHowmany) == 0)
			/* nothing to run */
			return -1;

		if (debugFlag) {
			System.out.println(
				"dequeue " + lHowmany + "tuples from left queue");
			System.out.println(
				"dequeue " + rHowmany + "tuples from right queue");
		}

		execOperator(lHowmany, rHowmany);

		/* run successfully */
		return 1;
	}
	public void setDefaultProperties() {

		super.setDefaultProperties();
		addProperty("TIME_WINDOW","0");
		// type of state
		addProperty("STATE_TYPE", "WFIFOSTATE");
	}
	/**
	 * @param expression
	 */
	public void setExpression(ExpressionStr expr){
		this.expression = expr;
	}

	public void setNumberOfPossibleOutputs() {
		/** figure out how many tuples to dequeue from left and right queue */
		XATQueue lQueue = this.getLeftInputQueue();
		XATQueue rQueue = this.getRightInputQueue();

		int lHowmany = Integer.parseInt(lQueue.getProperty("DEQUEUED_TUPLE_COUNT"));
		int rHowmany = Integer.parseInt(rQueue.getProperty("DEQUEUED_TUPLE_COUNT"));

		int lStateSize = states[0].getStateSize();
		int rStateSize = states[1].getStateSize();
		
		int possibleOutputs = lHowmany * rStateSize + rHowmany * lStateSize + lHowmany * rHowmany;
		
		try{
			this.setProperty("NUMBER_OF_POSSIBLE_OUTPUTS", ""+possibleOutputs);
		} catch(Exception e) {
			System.out.println(e);
		}
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (6/3/2003 1:40:53 AM)
	 * @param operators edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator[]
	 */
	public void setOldBoxOperators(XATStreamOperator[] operators) {

		allOldOperators = operators;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (3/15/2003 10:24:23 PM)
	 * @param newWindow int
	 */
	public void setWindowSize(long newWindow) {

		//join operator has the same timeWindow with both its states
		this.windowSize = newWindow;
		if(states != null) {
			((WOperatorState)states[0]).setTimeWindow(newWindow);
			((WOperatorState)states[1]).setTimeWindow(newWindow);
		}
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/14/2003 9:33:59 AM)
	 * @return java.lang.String
	 */
	public String toString() {
		String rs = new String();

		String sName = this.getClass().getName();
		//find the last dot.
		int index = 0;
		for(index = sName.length()-1; index >=0; index--)
			if(sName.charAt(index) == '.')
				break;
		rs = sName.substring(index + 1) + " ";
		String id = this.getProperty("OBJECT_ID");
		if(id == "-1"){
			rs = rs + " " + this.hashCode(); 
		} else{
			rs = rs + id + " " +this.hashCode();
		}
	
		if(this.isActive()) rs += " ACTIVE ";
		else rs+= " INACTIVE ";
		return rs;
	}
	
	public String toToolTipString() {
		String rs = new String();

		String sName = this.getClass().getName();
		//find the last dot.
		int index = 0;
		for(index = sName.length()-1; index >=0; index--)
			if(sName.charAt(index) == '.')
				break;
		rs = sName.substring(index + 1) + " ";
		String id = this.getProperty("OBJECT_ID");
		if(id == "-1"){
			rs = rs + hashCode(); 
		} else{
			rs = rs + id;
		}	
		if(this.isActive()) rs += " ACTIVE ";
		else rs+= " INACTIVE ";

		/** now add the join predicate and window size info */
		rs += "\n";
		rs += "predicate: " + expression +"\n";
		rs += "window size = "+windowSize+"\n";

		return rs;
	}
	
	/* 
	 * process all accumulated tuples in input queues that have their maxtimestamp 
	 * smaller than the given maxtimestamp 
	 */
	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		if ((this.getLeftInputQueue().getSchema() == null) || (this.getRightInputQueue().getSchema() == null)){
				return false;
		}
		if(this.getOutputQueue().getSchema() == null){
			init();
		}
		
		/** figure out how many tuples to dequeue from left and right queue */
		XATQueue lQueue = this.getLeftInputQueue();
		XATQueue rQueue = this.getRightInputQueue();
		int size1 = lQueue.getQueueSize(this);
		int size2 = rQueue.getQueueSize(this);
		int lHowmany=size1; 
		int rHowmany=size2;

		if(lQueue.isOldBoxInput()) {
			XATTuple[] tuples = lQueue.peek(size1, this);
			for (int i = 0; i < size1; i++) {
				if (((XATTuple) tuples[i]).getMaxTimeStamp() >= maxtimestamp) {
					lHowmany = i;
					break;
				}
			}
		}
		
		if(rQueue.isOldBoxInput()) {
			XATTuple[] tuples = rQueue.peek(size2, this);
			for (int i = 0; i < size2; i++) {
				if (((XATTuple) tuples[i]).getMaxTimeStamp() >= maxtimestamp) {
					rHowmany = i;
					break;
				}
			}
		}

		if((lHowmany + rHowmany) == 0) 
			return false;
			
		if (debugFlag) {
			System.out.println("dequeue " + lHowmany + "tuples from left queue");
			System.out.println("dequeue " + rHowmany + "tuples from right queue");
		}
			
		execOperator(lHowmany, rHowmany);

		/* run successfully */
		return true;
	
	}
	
	/*
	 * process all accumulated tuples in this operators' input queues.
	 */
	public boolean cleanAllAccumulatedTuples() {
		if ((this.getLeftInputQueue().getSchema() == null) || (this.getRightInputQueue().getSchema() == null)){
				return false;
		}
		if(this.getOutputQueue().getSchema() == null){
			init();
		}
		
		/** figure out how many tuples to dequeue from left and right queue */
		XATQueue lQueue = this.getLeftInputQueue();
		XATQueue rQueue = this.getRightInputQueue();
		int lHowmany = lQueue.getQueueSize(this);
		int rHowmany = rQueue.getQueueSize(this);

		/** nothing to clean */
		if(lHowmany == 0 && rHowmany == 0) {
			return false;
		}

		if (debugFlag) {
			System.out.println("dequeue " + lHowmany + "tuples from left queue");
			System.out.println("dequeue " + rHowmany + "tuples from right queue");
		}
			
		execOperator(lHowmany, rHowmany);

		/* run successfully */
		return true;	
	}
	
	/*
	 * recompute the unmatched states inside this operator.
	 * Usually the unmatched states are computed based on the matched states inside one of the 
	 * children operator of this operator.
	 * 
	 * return: 
	 * TRUE -- if the states (inside child operator) that the recomputation of the unmatched states are based on are 
	 *      all matched, and the recomputation is successful.
	 * FALSE -- if any of the states (inside child operator) that are used to recompute the unmatched states
	 *          is unmatched, or the recomputation is unsucessful.  
	 */
	public boolean recomputeUnmatchedState() {
		boolean returnvalue = true;
		
		try {
			
		/* if left state is unmatched */
		if (states[0].isMatched() == false) {
			
			if(this.getNode().getOpChildrenSize() < 1) 
				throw new Exception("operator with unmatched state must have at least one child!");
			
			XATStreamOperator childop = this.getNode().getOpChild(0).getStreamOperator();
			
			if(!childop.getOutputQueue().equals(this.getNthInputQueue(0)) || !(childop instanceof WBinaryJoinOperator)) {
				throw new Exception("Error recomputing unmatched state!");
			} 
			
			WOperatorState lstate = (WOperatorState)childop.getState()[0];
			WOperatorState rstate = (WOperatorState)childop.getState()[1];
			
			if(lstate.isMatched() && rstate.isMatched()) {
			
				XATTuple[] rstatetuples = rstate.getAllStateTuples();
				XATTuple[] joinedtuples;
			
				joinedtuples = lstate.probe(rstatetuples, this.expression, 0);
				((WOperatorState)states[0]).insertTuple(joinedtuples);
				states[0].setMatched(true);
			} else {
				returnvalue = false;
			} 			
		}
		
		/* if right state is unmatched */
		if (states[1].isMatched() == false) {
			
			if(this.getNode().getOpChildrenSize() < 1) 
				throw new Exception("operator with unmatched state must have at least one child!");
			
			XATStreamOperator childop = this.getNode().getOpChild(0).getStreamOperator();
			
			if(childop.getOutputQueue() != this.getNthInputQueue(1)) {
				
				childop = this.getNode().getOpChild(1).getStreamOperator();
				if(childop.getOutputQueue() != this.getRightInputQueue())
					throw new Exception("Error recomputing unmatched state!");
			}	
			
			if(!(childop instanceof WBinaryJoinOperator)) {
				throw new Exception("Error recomputing unmatched state!");
			} 
			
			WOperatorState lstate = (WOperatorState)childop.getState()[0];
			WOperatorState rstate = (WOperatorState)childop.getState()[1];
			
			if(lstate.isMatched() && rstate.isMatched()) {
			XATTuple[] rstatetuples = rstate.getAllStateTuples();
			XATTuple[] joinedtuples;
			
			joinedtuples = lstate.probe(rstatetuples, this.expression, 0);
			((WOperatorState)states[1]).insertTuple(joinedtuples);
			states[1].setMatched(true);
			} else {
				returnvalue = false;
			}
			
		}	
	} catch (Exception e) {
			System.out.println("Something wrong when recomputing unmatched states. ");
			e.printStackTrace();
			return false;
	}
	return returnvalue;
	
	}

	/*
	 * check if this operator has any unmatched states.
	 * return: TRUE if this operator has unmatched states, FALSE otherwise.
	 */
	public boolean hasUnmatchedState() {
		if (states == null) {
			return false;
		}

		for (int i = 0; i < states.length; i++) {
			if (!states[i].isMatched())
				return true;
		}
		return false;
	}

	
	/*
	 * Assign new ID to each state inside this operator, starting from the given startID.
	 * 
	 * return the next available ID. For example, if startID is 2, and there are 2 states inside this operator,
	 * then these two states are assigned new IDs as 2 and 3, and 4 is then returned as the next available stateID.
	 */
	  public int setStateID(int startID) {
		if (states == null) {
			return startID;
		}
	
		for(int i=0; i<states.length; i++) {
			states[i].setStateID(startID);
			startID++;
		}
		return startID;
	  }
	  

	  public boolean matchStates(XATStreamOperator newboxoperator) {
	  	int thisSize = this.states.length;
	  	int thatSize = newboxoperator.getState().length;
	  	OperatorState[] thatstates = newboxoperator.getState();
	  	boolean hasmatchedstate = false;
	  	
	  	for(int i=0; i<thisSize; i++) {
	  		for(int j=0; j<thatSize; j++) {
	  			// found a matched state
	  			if(states[i].getStateID() == thatstates[j].getStateID()) {
	  				thatstates[j].setMatched(true);
	  				thatstates[j].copyStateContent(states[i]);
	  				hasmatchedstate = true;
	  			}
	  		}
	  	}
	  	
	  	return hasmatchedstate;
	  }
	public boolean finalizeOperation(){
			return true;
	}
	
	public boolean hasTokenForState(int statenum) throws ArrayIndexOutOfBoundsException
	{
	    if (statenum == 0) return this.leftStateToken;
	    if (statenum == 1) return this.rightStateToken;
			
	    //If neither, it's not what we asked for.
	    throw new ArrayIndexOutOfBoundsException(statenum);
	}
		
	public void parseCommandMessage(XATCommandMsg mesg, int statenum)
	{
        System.out.println("Operator " + this.getOperatorID() + " parsing the command message " + mesg.getCommandType(0) + ":" + mesg.getCommandArgs(0));
	    if ( mesg.getCommandType(0)==XATCommandMsg.PASS_TOKEN)
	    {
	        XATDataValue argsValue = mesg.getCommandArgsArray()[0];
	        String  tokenMachineName = argsValue.convertToString();
	        String curMachineName = System.getProperty("NAME");
	        if (statenum == 0)
	        {
	            if (tokenMachineName.equals( curMachineName)
	                    || tokenMachineName.equals("YOU"))
	                this.leftStateToken = true;
	            else 
	                this.leftStateToken = false;
	        }
	        else if (statenum == 1)
	        {
	            if (tokenMachineName.equals( curMachineName)
	                    || tokenMachineName.equals("YOU"))
	                this.rightStateToken = true;
				else 
				    this.rightStateToken = false;
	        }
	    }
	    else if (mesg.getCommandType(0) == XATCommandMsg.TERMINATE_STREAM)
	    {
	        //input stream is being terminated locally for some machine.
	        if (mesg.getCommandArgs(0).equals(
	                System.getProperty("HOST_ADDRESS") + ":" + System.getProperty("PORT")))
	        {
	            if (statenum == 0)
	            {
	                //tare the state size for this operator.
	                this.states[0].decreStateSize(this.states[0].getStateSize());
	                //clear the input queue
	                ((XATQueue)this.inputQueue.get(0)).dequeue(this);
	                //Notify the supposedly waiting deactivation thread
	                leftStreamTerminated = true;
	                notifyAll();
	            }
	            if (statenum == 1)
	            {
	                //tare the state size for this operator.
	                this.states[1].decreStateSize(this.states[1].getStateSize());
	                //clear the input queue
	                ((XATQueue)this.inputQueue.get(1)).dequeue(this);
	                //Notify the supposedly waiting deactivation thread
	                rightStreamTerminated = true;
	                notifyAll();
	            }
	        }
	    }
	    else if (mesg.getCommandType(0) == XATCommandMsg.SET_INPUT_SCHEMA)
	    {
            ArrayList args = (ArrayList) mesg.getCommandArgs(0).getValue();
	        if (statenum == 0)
	        {
	            //tare the state size for this operator.
	            XATQueueSchema in_schema = new XATQueueSchema();
	            in_schema.setName((String)args.get(1));
                in_schema.setColNames((Vector)args.get(0));
	            this.getInputQueue(0).setSchema(in_schema);
	        }
	        if (statenum == 1)
	        {
	            //tare the state size for this operator.
	            XATQueueSchema in_schema = new XATQueueSchema();
                in_schema.setName((String)args.get(1));
                in_schema.setColNames((Vector)args.get(0));
	            this.getInputQueue(1).setSchema(in_schema);
	        }
	    }
	}
		
	public synchronized void setActive(boolean active)
	{
	    if (!active)
	    {
	        while (!this.leftStreamTerminated || !this.rightStreamTerminated)
	        {
	            try
	            {
	                wait();			
	            } catch (InterruptedException e) {}
	        }
	        this.active = false;
	    }
	    else
	    {
	        this.leftStreamTerminated = false;
	        this.rightStreamTerminated = false;
	        this.active = true;
	    }    
	}
			
}
