/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on May 11, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.state;

import java.util.ArrayList;

//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
//import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public interface OperatorState {
	/**
	 * 
	 */
	void decreStateSize();
	/**
	 * @param decrement
	 */
	void decreStateSize(int decrement);
	
	/**
	 * @return
	 */
	XATStreamOperator getOperator();

	public int getStateID ();
	/**
	 * Returns the size (in number of tuples) of the state of the operator.
	 * 
	 * @return -The size of the state of the operator.
	 */
	int getStateSize();
	/**
	 * 
	 */
	void increStateSize();
	/**
	 * @param increment
	 */
	void increStateSize(int increment);
	
//	public OperatorStateImp makeNewCopy();
	/**
	 * @param op
	 */
	void setOperator(XATStreamOperator op);
	
	public String getStateSchemaName();
	
	public void setStateSchemaName(String name);
	public void setStateID (int id);
	public void setDebugFlag (boolean flag);
	
	public void setStateSize(int size);
	
	//public XATTuple[] getAllStateTuples();
	public boolean getDebugFlag();
	
	public boolean isMatched();
	
	public void setMatched(boolean matched);
	
	public void clearState();
	public void copyStateContent(OperatorState newstate);
	
	public void addJoiningSubStates(int substateID);
	
	public ArrayList getJoiningSubStates();

//	public XATTuple getStateTuple(int position); 
	
//	public void probe(XATTuple tuple);
//	public void probe(XATTuple tuple, ExpressionStr expression);
//	public void probe(XATTuple[] tuples);
//	public void probe(XATTuple[] tuples, ExpressionStr expression);
	
}
