/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.state;

import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import java.util.ArrayList;

//import streamgenerator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import java.io.Serializable;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;
/**
 * Insert the type's description here.
 * Creation date: (2/17/2003 5:34:51 PM)
 * @author: Yali Zhu
 */
public class WFIFOState extends WOperatorState implements Serializable {
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState#getStateSize()
	 */
	public int getStateSize() {
		return statetuples.size();
	}
	
	private ArrayList statetuples = new ArrayList();
	
/**
 * FIFOState constructor comment.
 */
public WFIFOState() {
    super();
    
//    if (stateQ == null) {
//		if(System.getProperty("DATA_MODEL").endsWith("XATMemoryQueueImp")) {
//			stateQ = new XATMemoryQueueImp(this);
//		}
//		else if (System.getProperty("DATA_MODEL").endsWith("XATPersistentQueueImp")) {
//			stateQ = new XATPersistentQueueImp(this);
//		}
//		else {
//			System.out.println("!!! Error: Unknow type of DATA_MODEL !!!");
//			System.exit(-1);
//		}
//    }
    //stateQ = new XATQueueImp(this);
    //stateQ.register(this);
}

public WFIFOState(XATStreamOperator op) {
	super();
//	if (stateQ == null) {
//		if(System.getProperty("DATA_MODEL").endsWith("XATMemoryQueueImp")) {
//			stateQ = new XATMemoryQueueImp(this);
//			stateQ.register(op);
//		}
//		else if (System.getProperty("DATA_MODEL").endsWith("XATPersistentQueueImp")) {
//			stateQ = new XATPersistentQueueImp(this);
//			stateQ.register(op);
//		}
//		else {
//			System.out.println("!!! Error: Unknow type of DATA_MODEL !!!");
//			System.exit(-1);
//		}
//	}
	this.setOperator(op);
}

public WFIFOState(WFIFOState oldstate, XATStreamOperator newop) {
	super(oldstate, newop);
	
//	if (stateQ == null) {
//		if(System.getProperty("DATA_MODEL").endsWith("XATMemoryQueueImp")) {
//			stateQ = new XATMemoryQueueImp(this);
//			stateQ.register(newop);
//		}
//		else if (System.getProperty("DATA_MODEL").endsWith("XATPersistentQueueImp")) {
//			stateQ = new XATPersistentQueueImp(this);
//			stateQ.register(newop);
//		}
//		else {
//			System.out.println("!!! Error: Unknow type of DATA_MODEL !!!");
//			System.exit(-1);
//		}
//	}
	this.setOperator(newop);
	this.stateSchema = oldstate.stateSchema;
	//this.stateQ.setSchema(oldstate.stateQ.getSchema());
}
/**
 * copy current state
 * new state should be empty.
 */
//public OperatorStateImp makeNewCopy(XATStreamOperator op) {
//	WFIFOState newstate = new WFIFOState();
//	newstate.isMatched = false;
//	newstate.stateSchema = this.stateSchema;
//	newstate.setSchema(this.stateQ.getSchema());
//	newstate.debugFlag = this.debugFlag;
//	newstate.totalNumTuples = 0;
//	newstate.stateID = this.stateID;
//	newstate.operator = op;
//
//	return newstate;
//}

//public void setSchema(XATQueueSchema schema) {
//	this.stateQ.setSchema(schema);
//}

public void clearState() {
	statetuples.clear();
}

/**
 * Insert the method's description here.
 * Creation date: (4/10/2003 9:19:49 AM)
 * @return boolean
 */
public boolean checkAllOldTuplePurged() {

    if (totalNumTuples == 0) {
        allOldPurged = true;
        return true;
    }

    //return isOlder(tuple.getTimeStamps(), lastTimeStampBeforeMigration);
    for (int i = 0; i<totalNumTuples; i++) {
        if (!((XATTuple)statetuples.get(i)).isNew())
            return false;
    }
    allOldPurged = true;
    return true;
}

/**
 * Insert the method's description here.
 * Creation date: (6/1/2003 7:36:13 AM)
 * @return long
 */
public long[] getEarlistTimeStamp() {
	
    if (totalNumTuples > 0)
        return ((XATTuple)statetuples.get(0)).getTimeStamp();
    else 
 		return null;
}
/**
 * Insert the method's description here.
 *
 * Get tuple with earliest timestamp
 *
 * Creation date: (6/1/2003 7:36:13 AM)
 * @return long
 */
public XATTuple getEarlistTuple() {
	// return the first tuple in stateQ
    if (totalNumTuples > 0)
        return (XATTuple)statetuples.get(0);

    else
        return null;
}
/**
 * Insert the method's description here.
 * Creation date: (6/1/2003 7:36:35 AM)
 * @return long
 */
public long[] getLatestTimeStamp()
{
	if (totalNumTuples > 0) {
		return ((XATTuple)statetuples.get(totalNumTuples - 1)).getTimeStamp();
	}
	else 
 		return null;
}
/**
 * Insert the method's description here.
 *
 * Get tuple with latest timestamp
 *
 * Creation date: (6/1/2003 7:36:35 AM)
 * @return long
 */
public XATTuple getLatestTuple()
{
	if (totalNumTuples > 0) {
		return (XATTuple)statetuples.get(totalNumTuples-1);
	}
	else 
		return null;
}
/**
 * Insert the method's description here.
 * Creation date: (2/25/2003 11:29:29 AM)
 * @return queryplanelements.FIFOQueue
 */
//public XATQueue getStateQueue() {
//	return stateQ;
//}

public XATTuple[] getAllStateTuples(){
	int size = statetuples.size();
	XATTuple[] tuples = new XATTuple[size];
	
	for(int i=0; i<size; i++) {
		tuples[i] = (XATTuple)statetuples.get(i);
	}
	return tuples;
}

public XATTuple getStateTuple(int position) {
	return (XATTuple)statetuples.get(position);
}

public ArrayList getStateTuples() {
	return statetuples;
}

/**
 * Insert the method's description here.
 * Creation date: (6/23/2003 5:38:12 AM)
 * @return int
 */
//public int getStateTupleCounts() {
//	return stateQ.getQueueSize();
//}
/**
 * Insert the method's description here.
 * Creation date: (2/25/2003 11:26:24 AM)
 */

public void insertTuple(XATTuple newTuple) {
	// each state is the owner of the stateQ, and
	// each operator that contains the state is registered as a customer of the stateQ.
	//stateQ.enqueue(newTuple, this);
	statetuples.add(newTuple);
	totalNumTuples++;
}

public void insertTuple(XATTuple[] newTuples){
	// each state is the owner of the stateQ, and
	// each operator that contains the state is registered as a customer of the stateQ.
	//stateQ.enqueue(newTuples, this);
	for(int i=0; i<newTuples.length; i++) {
		statetuples.add(newTuples[i]);
	}
	totalNumTuples = totalNumTuples + newTuples.length;
}

public void insertTuple(ArrayList newTuples){
	for(int i=0; i<newTuples.size(); i++) {
		statetuples.add(newTuples.get(i));
	}
	totalNumTuples = totalNumTuples + newTuples.size();
}

//public boolean isRegistered(Object caller){
//	return stateQ.isRegistered(caller);
//}
/**
 * Insert the method's description here.
 * Creation date: (2/25/2003 11:27:47 AM)
 * @param newTuple streamgenerator.XATStreamTuple
 */
	public void purgeByTuple(XATTuple newTuple) {

		if (newTuple == null) {
			return;
		}

		int count = 0;

		/**
		 * purge a tuple if its out of window bound, stop when meet the first
		 * tuple in the state that cannot be purged
		 */
		for (int i = 0; i < statetuples.size(); i++) {
			if (timeStampExpired(newTuple, (XATTuple) statetuples.get(i))) {
				//statetuples.remove(i);
				//System.out.println("purge a tuple from state");
				count++;
				//i--;
				//totalNumTuples--;
			} else {
				if(count > 0) {
					//System.out.println("i = " + i + " count = " + count);
					statetuples.subList(i-count, i).clear();
					count = 0;
					i = i-count;
				}
			}
		}
		//if (count > 0) {
			//System.out.println("state size before purge = " + statetuples.size());
			//statetuples.subList(0, count).clear();
			//System.out.println("number of tuples purged = " + count);
			//System.out.println("state size after purge = " + statetuples.size());
		//}
		return;
	}

	public void aggressivePurgeByTuple(XATTuple newTuple) {
		if (newTuple == null) {
			return;
		}

		int count = 0;

		/**
		 * purge a tuple if its out of window bound, go through the state and purge ALL tuples
		 * that are outside the window frame from newTuple, and skip the ones that are inside the window frame from
		 * the newTuple.
		 */
		for (int i = 0; i < statetuples.size(); i++) {
			if (timeStampExpired(newTuple, (XATTuple) statetuples.get(i))) {
				//statetuples.remove(i);
				//System.out.println("purge a tuple from state");
				count++;
				//i--;
				//totalNumTuples--;
			} else
				break;
		}
		if (count > 0) {
			System.out.println("state size before purge = " + statetuples.size());
			statetuples.subList(0, count).clear();
			System.out.println("number of tuples purged = " + count);
			System.out.println("state size after purge = " + statetuples.size());
		}
		return;
	}
	

/**
 * Insert the method's description here.
 * Creation date: (3/20/2003 11:08:58 PM)
 */
//public void register(Object caller) {
//    stateQ.register(caller);
//}
/**
 * Insert the method's description here.
 * Creation date: (5/28/2003 6:01:33 AM)
 * @param queue edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue
 */
//	public void setStateQueue(XATQueue queue) {
//    	stateQ = queue;
//	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.WOperatorState#getSchema()
	 */
//	public XATQueueSchema getSchema() {
//		return stateSchema;
//	}

	public String toString() {
		return "state "+ stateID + " schema: " + stateSchema;
	}

//	public void probe(XATTuple tuple) {	
//	}
	
	public XATTuple[] probe(XATTuple[] tuples, ExpressionStr expression, int statepos) {
		
		int [][] outPositions = operator.getOutputPositions();
		if (operator.getOutputPositions().length < 2) System.err.println("Cannot probe: operator reports less than 2 queues. Input queue count is " + operator.getInputQueueCount() + " .. first queue is " + operator.getInputQueue(0).getQueueName());
		int outputsize = operator.getOutputPositions(0).length + operator.getOutputPositions(1).length;
		
		ArrayList joinedtuples = new ArrayList();
		
		List tuplepair = new Vector();
		
        long purgetotal = 0;
        long comparetotal = 0;
		for(int x=0; x<tuples.length; x++) {
			XATTuple tuple = tuples[x];
			//System.out.println("use tuple " + tuple.toString() + "\t to probe");
			
			for(int i=0; i<statetuples.size(); i++) {

				/* if outside window constraints, purge the state tuple*/
                long startpurgetime = System.currentTimeMillis();
				XATTuple nextstatetuple = (XATTuple)statetuples.get(i);
				if(this.timeStampExpired(tuple, nextstatetuple)) {
					statetuples.remove(i);
					i--;
					totalNumTuples--;
                    purgetotal += System.currentTimeMillis() - startpurgetime;
                    continue;
				}
                purgetotal += System.currentTimeMillis() - startpurgetime;
						
				/* join the two tuples if predicate is satisfied. */
				tuplepair.clear();
				
				if (statepos == 0) {
					tuplepair.add(nextstatetuple);
					tuplepair.add(tuple);

				} else {
					tuplepair.add(tuple);
					tuplepair.add(nextstatetuple);
				}
				
//				System.out.println("tuple pair: " + tuplepair.get(0) + " and " + tuplepair.get(1));
				long comparestart = System.currentTimeMillis();
                boolean matchmade = ((Boolean)expression.eval(tuplepair, operator)).booleanValue();
				comparetotal += System.currentTimeMillis() - comparestart;
                if (matchmade) {
					List newvalues = new Vector();
					long[] newtimes = new long[outputsize];
					//newts.combine(lTuple.getTimeStamp(), rTuple.getTimeStamp());
					int timeindex=0;
					for(int j=0; j<2; j++) {
						for(int k=0; k<operator.getOutputPositions(j).length; k++) {
							newvalues.add(((XATTuple)tuplepair.get(j)).getCell(outPositions[j][k]));
							newtimes[timeindex] = ((XATTuple)tuplepair.get(j)).getNthTimeStamp(outPositions[j][k]);
							timeindex++;
						}
					}
					XATTuple joinedtuple = new XATTupleImp(newvalues);
					joinedtuple.setTimeStamp(newtimes);
					long m1 = tuple.getMinTimeStamp();
					long m2 = nextstatetuple.getMinTimeStamp();
					joinedtuple.setMinTimeStamp((m1<m2)?m1:m2);
					m1 = tuple.getMaxTimeStamp();
					m2 = nextstatetuple.getMaxTimeStamp();
					joinedtuple.setMaxTimeStamp((m1>m2)?m1:m2);
					System.out.println(" Joined tuple: " + joinedtuple.toString());
					joinedtuples.add(joinedtuple);
					if(tuple.isNew() && nextstatetuple.isNew()) {
						joinedtuple.setToNew(true);
					} else {
						joinedtuple.setToNew(false);
					}
				}
			}
		}
       // System.out.println("state probe: " + purgetotal + "ms purge, " + comparetotal + "ms eval");
		//((Client[])al.toArray(new Client[0]));
		return (XATTuple[])joinedtuples.toArray(new XATTuple[]{});
	}
	
	
	// added by Mingzhu Wei @ June, 2007
	// Use the column of timestamp to probe
public XATTuple[] probeUsingTS(XATTuple[] tuples, ExpressionStr expression, int statepos) {
		
		int [][] outPositions = operator.getOutputPositions();
		if (operator.getOutputPositions().length < 2) System.err.println("Cannot probe: operator reports less than 2 queues. Input queue count is " + operator.getInputQueueCount() + " .. first queue is " + operator.getInputQueue(0).getQueueName());
		int outputsize = operator.getOutputPositions(0).length + operator.getOutputPositions(1).length;
		
		ArrayList joinedtuples = new ArrayList();
		
		List tuplepair = new Vector();
		
        long purgetotal = 0;
        long comparetotal = 0;
		for(int x=0; x<tuples.length; x++) {
			XATTuple tuple = tuples[x];
			//System.out.println("use tuple " + tuple.toString() + "\t to probe");
			
			for(int i=0; i<statetuples.size(); i++) {

				/* if outside window constraints, purge the state tuple*/
                long startpurgetime = System.currentTimeMillis();
				XATTuple nextstatetuple = (XATTuple)statetuples.get(i);
				if(this.purgeByTimeStamp(tuple, nextstatetuple)) {
					statetuples.remove(i);
					i--;
					totalNumTuples--;
                    purgetotal += System.currentTimeMillis() - startpurgetime;
                    continue;
				}
                purgetotal += System.currentTimeMillis() - startpurgetime;
						
				/* join the two tuples if predicate is satisfied. */
				tuplepair.clear();
				
				if (statepos == 0) {
					tuplepair.add(nextstatetuple);
					tuplepair.add(tuple);

				} else {
					tuplepair.add(tuple);
					tuplepair.add(nextstatetuple);
				}
				
//				System.out.println("tuple pair: " + tuplepair.get(0) + " and " + tuplepair.get(1));
				long comparestart = System.currentTimeMillis();
                boolean matchmade = ((Boolean)expression.eval(tuplepair, operator)).booleanValue();
				comparetotal += System.currentTimeMillis() - comparestart;
                if (matchmade) {
					List newvalues = new Vector();
					long[] newtimes = new long[outputsize];
					//newts.combine(lTuple.getTimeStamp(), rTuple.getTimeStamp());
					int timeindex=0;
					for(int j=0; j<2; j++) {
						
						System.out.println("WFIFO State: Output Positions" + operator.getOutputPositions(j).length);
						for(int k=0; k<operator.getOutputPositions(j).length; k++) {
							newvalues.add(((XATTuple)tuplepair.get(j)).getCell(outPositions[j][k]));
							newtimes[timeindex] = ((XATTuple)tuplepair.get(j)).getNthTimeStamp(outPositions[j][k]);
							timeindex++;
						}
					}
					XATTuple joinedtuple = new XATTupleImp(newvalues);
					joinedtuple.setTimeStamp(newtimes);
					long m1 = tuple.getMinTimeStamp();
					long m2 = nextstatetuple.getMinTimeStamp();
					joinedtuple.setMinTimeStamp((m1<m2)?m1:m2);
					m1 = tuple.getMaxTimeStamp();
					m2 = nextstatetuple.getMaxTimeStamp();
					joinedtuple.setMaxTimeStamp((m1>m2)?m1:m2);
					//System.out.println("In WFIFOState Joined Tuple: " + joinedtuple.toString());
					joinedtuples.add(joinedtuple);
					if(tuple.isNew() && nextstatetuple.isNew()) {
						joinedtuple.setToNew(true);
					} else {
						joinedtuple.setToNew(false);
					}
				}
			}
		}
        System.out.println("state probe: " + purgetotal + "ms purge, " + comparetotal + "ms eval");
		//((Client[])al.toArray(new Client[0]));
		return (XATTuple[])joinedtuples.toArray(new XATTuple[]{});
	}
	
//added by Mingzhu Wei @ June, 2007
// Use the column of timestamp to probe, compare both the timestamp and event ID
public XATTuple[] probeUsingTSID(XATTuple[] tuples, ExpressionStr[] expressions, int statepos) {
	
	int [][] outPositions = operator.getOutputPositions();
	if (operator.getOutputPositions().length < 2) System.err.println("Cannot probe: operator reports less than 2 queues. Input queue count is " + operator.getInputQueueCount() + " .. first queue is " + operator.getInputQueue(0).getQueueName());
	int outputsize = operator.getOutputPositions(0).length + operator.getOutputPositions(1).length;
	
	ArrayList joinedtuples = new ArrayList();
	
	List tuplepair = new Vector();
	
    long purgetotal = 0;
    long comparetotal = 0;
	for(int x=0; x<tuples.length; x++) {
		XATTuple tuple = tuples[x];
		System.out.println("\n\n use tuple " + tuple.toString() + "\t to probe");
		
		for(int i=0; i<statetuples.size(); i++) {

			/* if outside window constraints, purge the state tuple*/
            long startpurgetime = System.currentTimeMillis();
			XATTuple nextstatetuple = (XATTuple)statetuples.get(i);
			if(this.purgeByTimeStamp(tuple, nextstatetuple)) {
				statetuples.remove(i);
				i--;
				totalNumTuples--;
                purgetotal += System.currentTimeMillis() - startpurgetime;
                continue;
			}
            purgetotal += System.currentTimeMillis() - startpurgetime;
					
			/* join the two tuples if predicate is satisfied. */
			tuplepair.clear();
			
			System.out.println("\ntuple pair");
			if (statepos == 0) {
				
				// first insert the left tuple
				tuplepair.add(nextstatetuple);
				System.out.println("first tuple " + nextstatetuple.toString());
				// then insert the right tuple
				tuplepair.add(tuple);
				System.out.println("second tuple " + tuple.toString());

			} else {
				tuplepair.add(tuple);
				tuplepair.add(nextstatetuple);
			}
			
//			System.out.println("tuple pair: " + tuplepair.get(0) + " and " + tuplepair.get(1));
			long comparestart = System.currentTimeMillis();
			// compare two expressions one by one, compare both timestamp and event ID
			
			boolean matchmade = true;
			boolean matchi;
			for (int kk =0; kk < expressions.length; kk++)
			{
				matchi = ((Boolean)expressions[kk].eval(tuplepair, operator)).booleanValue();
				matchmade = matchmade&& matchi;
			}
			
			System.out.println("Evaluation result " + matchmade);
			/*boolean match1 = ((Boolean)expressions[0].eval(tuplepair, operator)).booleanValue();
			boolean match2 = ((Boolean)expressions[1].eval(tuplepair, operator)).booleanValue();
			boolean matchmade = match1&& match2;*/
            //boolean matchmade = ((Boolean)expressions[0].eval(tuplepair, operator)).booleanValue();
			comparetotal += System.currentTimeMillis() - comparestart;
            if (matchmade) {
				List newvalues = new Vector();
				long[] newtimes = new long[outputsize];
				//newts.combine(lTuple.getTimeStamp(), rTuple.getTimeStamp());
				int timeindex=0;
				for(int j=0; j<2; j++) {
					
					//System.out.println("WFIFO State: Output Positions" + operator.getOutputPositions(j).length);
					for(int k=0; k<operator.getOutputPositions(j).length; k++) {
						newvalues.add(((XATTuple)tuplepair.get(j)).getCell(outPositions[j][k]));
						//newtimes[timeindex] = ((XATTuple)tuplepair.get(j)).getNthTimeStamp(outPositions[j][k]);
						timeindex++;
					}
				}
				XATTuple joinedtuple = new XATTupleImp(newvalues);
				joinedtuple.setTimeStamp(newtimes);
				long m1 = tuple.getMinTimeStamp();
				long m2 = nextstatetuple.getMinTimeStamp();
				joinedtuple.setMinTimeStamp((m1<m2)?m1:m2);
				m1 = tuple.getMaxTimeStamp();
				m2 = nextstatetuple.getMaxTimeStamp();
				joinedtuple.setMaxTimeStamp((m1>m2)?m1:m2);
				System.out.println("In WFIFOState Joined Tuple: " + joinedtuple.toString());
				joinedtuples.add(joinedtuple);
				if(tuple.isNew() && nextstatetuple.isNew()) {
					joinedtuple.setToNew(true);
				} else {
					joinedtuple.setToNew(false);
				}
			}
		}
	}
	
	
	
    //System.out.println("state probe: " + purgetotal + "ms purge, " + comparetotal + "ms eval");
	//((Client[])al.toArray(new Client[0]));
	return (XATTuple[])joinedtuples.toArray(new XATTuple[]{});
}
	

//added by Mingzhu Wei @ June, 2007
//Use the the right most queue to probe the left queue, compare both timestamp and event ID
public Vector probeLeftQueueUsingTSID(XATTuple tuple, ExpressionStr[] expressions, int statepos) {
	
	int [][] outPositions = operator.getOutputPositions();
	if (operator.getOutputPositions().length < 2) System.err.println("Cannot probe: operator reports less than 2 queues. Input queue count is " + operator.getInputQueueCount() + " .. first queue is " + operator.getInputQueue(0).getQueueName());
	int outputsize = operator.getOutputPositions(0).length + operator.getOutputPositions(1).length;

	ArrayList joinedtuples = new ArrayList();

	Vector tuplepair = new Vector();
	Vector middleTuples = new Vector();
	long purgetotal = 0;
	long comparetotal = 0;
	//System.out.println("use tuple " + tuple.toString() + "\t to probe");

	for(int i=0; i<statetuples.size(); i++) {

		/* if outside window constraints, purge the state tuple*/
		long startpurgetime = System.currentTimeMillis();
		XATTuple nextstatetuple = (XATTuple)statetuples.get(i);
		if(this.purgeByTimeStamp(tuple, nextstatetuple)) {
			statetuples.remove(i);
			i--;
			totalNumTuples--;
			purgetotal += System.currentTimeMillis() - startpurgetime;
			continue;
		}
		purgetotal += System.currentTimeMillis() - startpurgetime;

		/* join the two tuples if predicate is satisfied. */
		tuplepair.clear();

		if (statepos == 0) {

			// first insert the left tuple
			tuplepair.add(nextstatetuple);
			// then insert the right tuple
			tuplepair.add(tuple);

		} else {
			tuplepair.add(tuple);
			tuplepair.add(nextstatetuple);
		}

//		System.out.println("tuple pair: " + tuplepair.get(0) + " and " + tuplepair.get(1));
		long comparestart = System.currentTimeMillis();
		// compare two expressions one by one, compare both timestamp and event ID

		boolean matchmade = true;
		for (int kk =0; kk < expressions.length; kk++)
		{
			boolean matchi = ((Boolean)expressions[kk].eval(tuplepair, operator)).booleanValue();
			matchmade = matchmade&& matchi;
		}

		if (matchmade) { 
			if (middleTuples.size()>0){
				System.out.println("Before insertion middleTupple:");
				for (int j =0; j<middleTuples.size(); j++)

				{
					System.out.println("confirm pairs");
					Vector x = (Vector)middleTuples.get(j);
					System.out.println(((XATTuple)x.get(0)).toString() + ((XATTuple)x.get(1)).toString());

				}
			}
			System.out.println("Before tuplepair\n \n");
			System.out.println(((XATTuple)tuplepair.get(0)).toString() + ((XATTuple)tuplepair.get(1)).toString());
			middleTuples.add(tuplepair.clone());
			//System.out.println("Pair Pari\n \n");
			//System.out.println(((XATTuple)tuplepair.get(0)).toString() + ((XATTuple)tuplepair.get(1)).toString());
			System.out.println("After insertion middle Pari\n \n");
			if (middleTuples.size()>0){
				for (int j =0; j<middleTuples.size(); j++)

				{
					System.out.println("confirm pairs");
					Vector x = (Vector)middleTuples.get(j);
					System.out.println(((XATTuple)x.get(0)).toString() + ((XATTuple)x.get(1)).toString());

				}
			}

		}
		comparetotal += System.currentTimeMillis() - comparestart;
	}
	
	
	if (middleTuples.size()>0){
		System.out.println("\n final confirm pairs");
	for (int i =0; i<middleTuples.size(); i++)

	{
		
		Vector x = (Vector)middleTuples.get(i);
		System.out.println(((XATTuple)x.get(0)).toString() + ((XATTuple)x.get(1)).toString());

	}
	}
	return middleTuples;
	
}


/*
 * use result from the left most queue and right most queue to probe the middle queue
 * Each elememnt in tuplePairList is a tuplePair, which stores the result of left most queue and right most queue
 * Use each tuplePair in tuplePairList to probe the middle queue
 */ 


public XATTuple[] probeMiddleQueueUsingTSID(Vector tuplePairList, ExpressionStr[] expressions, int statepos) {
	int [][] outPositions = operator.getOutputPositions();
	if (operator.getOutputPositions().length < 2) System.err.println("Cannot probe: operator reports less than 2 queues. Input queue count is " + operator.getInputQueueCount() + " .. first queue is " + operator.getInputQueue(0).getQueueName());
	int outputsize = operator.getOutputPositions(0).length + operator.getOutputPositions(1).length +operator.getOutputPositions(2).length;
	
	ArrayList joinedtuples = new ArrayList();
	// first get each tuplePair,
	 long purgetotal = 0;
	    long comparetotal = 0;
	Iterator it = tuplePairList.iterator();
		while (it.hasNext())
	{
		// get the current tuplePair
		Vector pair = (Vector)it.next();
		XATTuple[] tuplePair = new XATTuple[pair.size()];
		int rightPos = pair.size()-1;
		for (int j=0; j< pair.size(); j++)
				tuplePair[j]= (XATTuple)pair.get(j);
		
		Vector leftPair = new Vector();
		Vector rightPair = new Vector();
		Vector newTuplePair = new Vector();
		
		// first removed the out-of-date tuple from state
		
		for(int i=0; i<statetuples.size(); i++) {

			/* if outside window constraints, purge the state tuple*/
			long startpurgetime = System.currentTimeMillis();
			XATTuple nextstatetuple = (XATTuple)statetuples.get(i);
			if(this.purgeByTimeStamp(tuplePair[rightPos], nextstatetuple)) {
				statetuples.remove(i);
				i--;
				totalNumTuples--;
				purgetotal += System.currentTimeMillis() - startpurgetime;
				continue;
			}
			purgetotal += System.currentTimeMillis() - startpurgetime;

			/* join the two tuples if predicate is satisfied. */
			leftPair.clear();
			rightPair.clear();
			
			//compose the first pair
			leftPair.add(tuplePair[0]);
			leftPair.add(nextstatetuple);
			
			// compose the seconde pair
			rightPair.add(nextstatetuple);
			rightPair.add(tuplePair[1]);
			
//			System.out.println("left tuple pair: " + tuplepair.get(0) + " and " + tuplepair.get(1));
			long comparestart = System.currentTimeMillis();
			// compare two expressions one by one, compare both timestamp and event ID
			
			boolean matchmade = true;
			for (int kk =0; kk < expressions.length; kk++)
			{
				boolean left = ((Boolean)expressions[kk].eval(leftPair, operator)).booleanValue();
				//System.out.println("first pair evaluation result " + left);
				boolean right = ((Boolean)expressions[kk].eval(rightPair, operator)).booleanValue();
				//System.out.println("right pair evaluation result " + right);
				matchmade = matchmade&& left && right;
				
			}
			/*boolean match1 = ((Boolean)expressions[0].eval(tuplepair, operator)).booleanValue();
			boolean match2 = ((Boolean)expressions[1].eval(tuplepair, operator)).booleanValue();
			boolean matchmade = match1&& match2;*/
         //boolean matchmade = ((Boolean)expressions[0].eval(tuplepair, operator)).booleanValue();
			comparetotal += System.currentTimeMillis() - comparestart;
         if (matchmade) {
        	    newTuplePair.add(tuplePair[0]);
        	 	newTuplePair.add(nextstatetuple);
        	 	newTuplePair.add(tuplePair[1]);
        	 	//make a new tuple pair which is compose of three tuples
        	 	List newvalues = new Vector();
				long[] newtimes = new long[outputsize];
				//newts.combine(lTuple.getTimeStamp(), rTuple.getTimeStamp());
				int timeindex=0;
				for(int j=0; j<3; j++) {
					
					//System.out.println("WFIFO State: Output Positions" + operator.getOutputPositions(j).length);
					for(int k=0; k<operator.getOutputPositions(j).length; k++) {
						//newvalues.add(((XATTuple)tuplepair.get(j)).getCell(outPositions[j][k]));
						newvalues.add(((XATTuple)newTuplePair.get(j)).getCell(outPositions[j][k]));
						//newtimes[timeindex] = ((XATTuple)tuplepair.get(j)).getNthTimeStamp(outPositions[j][k]);
						timeindex++;
					}
				}
				System.out.println("out new tuple Pair: " + newTuplePair);
				XATTuple joinedtuple = new XATTupleImp(newvalues);
				joinedtuple.setTimeStamp(newtimes);
				long m1 = tuplePair[1].getMinTimeStamp();
				long m2 = nextstatetuple.getMinTimeStamp();
				joinedtuple.setMinTimeStamp((m1<m2)?m1:m2);
				m1 = tuplePair[1].getMaxTimeStamp();
				m2 = nextstatetuple.getMaxTimeStamp();
				joinedtuple.setMaxTimeStamp((m1>m2)?m1:m2);
				System.out.println("\n generate Joined Tuple: " + joinedtuple.toString());
				joinedtuples.add(joinedtuple);
				if(tuplePair[1].isNew() && nextstatetuple.isNew()) {
					joinedtuple.setToNew(true);
				} else {
					joinedtuple.setToNew(false);
				}
			}
		}

	}
		
		return (XATTuple[])joinedtuples.toArray(new XATTuple[]{});

}

	


public void copyStateContent(OperatorState newstate) {
		this.statetuples = ((WFIFOState)newstate).statetuples;
	}

	//public boolean isRegistered(Object caller){
	//	return stateQ.isRegistered(caller);
	//}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/25/2003 11:27:47 AM)
	 * @param newTuple streamgenerator.XATStreamTuple
	 */
		public void purgeByTuple(XATTuple newTuple, long overall_min) {
	
			if (newTuple == null) {
				return;
			}
	
			int count = 0;
	
			/**
			 * purge a tuple if its out of window bound, stop when meet the first
			 * tuple in the state that cannot be purged
			 */
			for (int i = 0; i < statetuples.size(); i++) {
				if (timeStampExpired(newTuple, (XATTuple) statetuples.get(i), overall_min)) {
					//statetuples.remove(i);
					//System.out.println("purge a tuple from state");
					count++;
					//i--;
					//totalNumTuples--;
				} else {
					if(count > 0) {
						//System.out.println("i = " + i + " count = " + count);
						statetuples.subList(i-count, i).clear();
						count = 0;
						i = i-count;
					}
				}
			}
			//if (count > 0) {
				//System.out.println("state size before purge = " + statetuples.size());
				//statetuples.subList(0, count).clear();
				//System.out.println("number of tuples purged = " + count);
				//System.out.println("state size after purge = " + statetuples.size());
			//}
			return;
		}

//	public void probe(XATTuple[] tuples) {	
//	}
	
	//public void probe(XATTuple[] tuples, ExpressionStr expression, int statepos) {
	//}
}
