/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on May 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class StreamAggregateOperatorImp
	extends XATSingleQueueStreamOperatorImp
	implements StreamAggregateOperator {

	protected StreamFunction[] aggFunctions;
	protected int numAggFunctions;
	protected int batchThreshold;
	
	public StreamAggregateOperatorImp(XATNode init) {
		super(init);
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#run()
	 */
	public boolean run() throws Exception {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.WStreamAggregateOperator#getAggFunction(int)
	 */
	public StreamFunction getAggFunction(int pos) {
		return aggFunctions[pos];
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.WStreamAggregateOperator#getAggFunctions()
	 */
	public StreamFunction[] getAggFunctions() {
		return aggFunctions;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.WStreamAggregateOperator#setAggFunction(edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.StreamFunction)
	 */
	public void setAggFunction(int pos, StreamFunction function) {
		aggFunctions[pos] = function;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.WStreamAggregateOperator#setAggFunctions(edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.StreamFunction[])
	 */
	public void setAggFunctions(StreamFunction[] functions) {
		aggFunctions = functions;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		// TODO Auto-generated method stub
		return "Aggregate";
	}
	
	/**
	 * The method cleanAccumulatedTuples() is similar to the method run(),
	 * except the way of figuring out how many tuples to dequeue from input queues.
	 * Inside method run() the numbers are computed based on the property
	 * "NUMBER_OF_TUPLES_TO_DEQUEUE" set by the system scheduler,
	 * while in cleanAccumulatedTuples, all tuples in input queues that have their max timesamp
	 * smaller than the given maxtimestamp should be dequened.
	 */
	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		return true;
	}


	/*
	 * process all accumulated tuples in this operators' input queues.
	 */
	public boolean cleanAllAccumulatedTuples() {
		return true;
	}
	
	/*
	 * check if this operator has any unmatched states.
	 * return: TRUE if this operator has unmatched states, FALSE otherwise.
	 */
	public boolean hasUnmatchedState() {
		return false;
	}



	public boolean matchStates(XATStreamOperator op) {
		return false;
	}


	public boolean recomputeUnmatchedState() {
		return true;
	}

	public int setStateID(int nextid) {
		return nextid;
	}

	public boolean finalizeOperation(){
		return true;
	}

	public int getBatchThreshold() {
		return batchThreshold;
	}
	
	public void setBatchThreshold(int bThreshold) {
		this.batchThreshold = bThreshold;
	}

	public void init() {
		numAggFunctions = aggFunctions.length;
		XATQueueSchema inSchema = this.getInputQueue().getSchema();
		if (inSchema == null || inSchema.getLength()==0) {
			return;
		}
		XATQueueSchema outSchema = this.getOutputQueue().getSchema();
		if (outSchema == null || outSchema.getLength()==0) {
			outSchema = new XATQueueSchema();
			outSchema.setName(inSchema.getName());
			String[] colNames = (String[])inSchema.getColNames().toArray(new String[] {});
			for (int i=0; i<numAggFunctions; i++) {
				StreamFunction func = aggFunctions[i];
				func.setAttrName(colNames[func.getAttrPos()]);
				outSchema.addColumn(func.getFuncName()+"_"+func.getAttrName());
			}

			this.getOutputQueue().setSchema(outSchema);
		}
		numOutputColumns = numAggFunctions;
		setHasInit(true);
	}

}
