/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on May 6, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import java.io.Serializable;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class StreamFunctionImp implements StreamFunction, Serializable {
	double initialValue;
	double currentValue; //current value of the aggregating function, for incremental evaluation
	String funcName; //name of the aggregating function
	String attrName; //name of the aggregating attribute
	int attrPos; //position of the aggregating attribute
	/**
	 * constructor
	 */
	public StreamFunctionImp() {
		
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#getAttrName()
	 */
	public String getAttrName() {
		return attrName;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#setAttrName(java.lang.String)
	 */
	public void setAttrName(String attrName) {
		this.attrName = attrName;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#getAttrPos()
	 */
	public int getAttrPos() {
		return attrPos;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#setAttrPos(int)
	 */
	public void setAttrPos(int aPos) {
		attrPos = aPos;
	}
	public abstract double evaluateDouble(XATTuple[] tuples);
	public abstract double evaluateDouble(XATTuple[] tuples, double currentVal, int currentNumTuples);
	public abstract double evaluateDouble(XATTuple[] tuples, int startIndex, int endIndex);
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#evaluate(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple[])
	 */
	public abstract XATDataValue evaluate(XATTuple[] tuples);
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#evaluate(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple[], double, int)
	 */
	public abstract XATDataValue evaluate(XATTuple[] tuples, double currentVal, int currentNumTuples);
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#evaluate(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple[], int, int)
	 */
	public abstract XATDataValue evaluate(XATTuple[] tuples, int startIndex, int endIndex);
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#increment(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple[])
	 */
	public abstract void increment(XATTuple[] tuples);
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#decrement(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple[])
	 */
	public abstract void decrement(XATTuple[] tuples);
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#getCurrentValue()
	 */
	public double getCurrentValue() {
		return currentValue;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#setCurrentValue(java.lang.Object)
	 */
	public void setCurrentValue(double newValue) {
		currentValue = newValue;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#getFuncName()
	 */
	public String getFuncName() {
		return funcName;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#setFuncName(java.lang.String)
	 */
	public void setFuncName(String funcName) {
		this.funcName = funcName;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#getInitialValue()
	 */
	public double getInitialValue() {
		return initialValue;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#setInitialValue(double)
	 */
	public void setInitialValue(double initValue) {
		this.initialValue = initValue;
	}
}
