/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2005-1-23
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;

/**
 * @author lisading
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class StreamFunctionMax extends StreamFunctionImp {

	public StreamFunctionMax() {
		super();
		this.currentValue = Double.MIN_VALUE;
		this.initialValue = Double.MIN_VALUE;
		this.funcName = "MAX";
	}
	public double evaluateDouble(XATTuple[] tuples) {
		double result = Double.MIN_VALUE;
		int length = tuples.length;
		
		//go through the tuples and sum all the result
		for (int i=0; i<length; i++) {
			Object objValue = tuples[i].getCell(attrPos).getValue();
			double value = 0.0;
			if (objValue instanceof Integer) {
				value = ((Integer)objValue).doubleValue();
			} else if (objValue instanceof Long) {
				value = ((Long)objValue).doubleValue();
			} else if (objValue instanceof Double) {
				value = ((Double)objValue).doubleValue();
			}
			result = (result>value?result:value);
		}
		return result;
	}
	public double evaluateDouble(XATTuple[] tuples, double currentVal, int currentNumTuples) {
		double result = currentVal;
		int length = tuples.length;
		
		//go through the tuples and sum all the result
		for (int i=0; i<length; i++) {
			Object objValue = tuples[i].getCell(attrPos).getValue();
			double value = 0.0;
			if (objValue instanceof Integer) {
				value = ((Integer)objValue).doubleValue();
			} else if (objValue instanceof Long) {
				value = ((Long)objValue).doubleValue();
			} else if (objValue instanceof Double) {
				value = ((Double)objValue).doubleValue();
			}
			result = (result>value?result:value);
		}
		return result;
	}	
	public double evaluateDouble(XATTuple[] tuples, int startIndex, int endIndex) {
		double result = Double.MIN_VALUE;
		int length = tuples.length;
		
		//go through the tuples and sum all the result
		for (int i=startIndex; i<=endIndex; i++) {
			Object objValue = tuples[i].getCell(attrPos).getValue();
			double value = 0.0;
			if (objValue instanceof Integer) {
				value = ((Integer)objValue).doubleValue();
			} else if (objValue instanceof Long) {
				value = ((Long)objValue).doubleValue();
			} else if (objValue instanceof Double) {
				value = ((Double)objValue).doubleValue();
			}
			result = (result>value?result:value);
		}
		return result;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#evaluate(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple[])
	 */
	public XATDataValue evaluate(XATTuple[] tuples) {
		double result = Double.MIN_VALUE;
		int length = tuples.length;
		
		//go through the tuples and sum all the result
		for (int i=0; i<length; i++) {
			Object objValue = tuples[i].getCell(attrPos).getValue();
			double value = 0.0;
			if (objValue instanceof Integer) {
				value = ((Integer)objValue).doubleValue();
			} else if (objValue instanceof Long) {
				value = ((Long)objValue).doubleValue();
			} else if (objValue instanceof Double) {
				value = ((Double)objValue).doubleValue();
			}
			result = (result>value?result:value);
		}
		
		XATDataValue newValue = new XATDataValueImp(new Double(result));
		return newValue;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#evaluate(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple[], double, int)
	 */
	public XATDataValue evaluate(XATTuple[] tuples, double currentVal, int currentNumTuples) {
		double result = currentVal;
		int length = tuples.length;
		
		//go through the tuples and sum all the result
		for (int i=0; i<length; i++) {
			Object objValue = tuples[i].getCell(attrPos).getValue();
			double value = 0.0;
			if (objValue instanceof Integer) {
				value = ((Integer)objValue).doubleValue();
			} else if (objValue instanceof Long) {
				value = ((Long)objValue).doubleValue();
			} else if (objValue instanceof Double) {
				value = ((Double)objValue).doubleValue();
			}
			result = (result>value?result:value);
		}
		
		XATDataValue newValue = new XATDataValueImp(new Double(result));
		return newValue;
	}	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#evaluate(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple[], int, int)
	 */
	public XATDataValue evaluate(XATTuple[] tuples, int startIndex, int endIndex) {
		double result = Double.MIN_VALUE;
		int length = tuples.length;
		
		//go through the tuples and sum all the result
		for (int i=startIndex; i<=endIndex; i++) {
			Object objValue = tuples[i].getCell(attrPos).getValue();
			double value = 0.0;
			if (objValue instanceof Integer) {
				value = ((Integer)objValue).doubleValue();
			} else if (objValue instanceof Long) {
				value = ((Long)objValue).doubleValue();
			} else if (objValue instanceof Double) {
				value = ((Double)objValue).doubleValue();
			}
			result = (result>value?result:value);
		}
		
		XATDataValue newValue = new XATDataValueImp(new Double(result));
		return newValue;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#increment(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple[])
	 */
	public void increment(XATTuple[] tuples) {
		int length = tuples.length;
		
		//go through the tuples and sum all the result
		for (int i=0; i<length; i++) {
			double value = ((Double)tuples[i].getCell(attrPos).getValue()).doubleValue();
			currentValue = (currentValue>value?currentValue:value);
		}
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction#decrement(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple[])
	 */
	public void decrement(XATTuple[] tuples) {
		
	}

}
