/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on 2004-11-19
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator;

import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStrImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

/**
 * @author Administrator
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class StreamProjectFunctionOperatorImp extends StreamProjectOperatorImp
		implements StreamProjectFunctionOperator {

	ExpressionStr[] expression;
	
	/*
	public StreamProjectFunctionOperatorImp(StreamProjectFunctionOperatorImp oldop, XATNode newnode) {
		super(oldop, newnode);
		String[] rAttrNames = oldop.getRetainAttrNames();
		retainAttrNames = new String[rAttrNames.length];
		for (int i=0; i<rAttrNames.length; i++) {
			retainAttrNames[i] = rAttrNames[i];
		}
		ExpressionStr[] expr = oldop.getExpression();
		expression = new ExpressionStrImp[expr.length];
		for (int i=0; i<expr.length; i++) {
			expression[i] = expr[i];
		}
	}*/
	
	/**
	 * constructor
	 * @param init
	 */
	public StreamProjectFunctionOperatorImp(XATNode init) {
		super(init);
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamProjectFunctionOperator#getExpression()
	 */
	public ExpressionStr[] getExpression() {
		// TODO Auto-generated method stub
		return expression;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamProjectFunctionOperator#setExpression(edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr)
	 */
	public void setExpression(ExpressionStr[] expr) {
		// TODO Auto-generated method stub
		expression = new ExpressionStrImp[expr.length];
		for (int i=0; i<expr.length; i++) {
			expression[i] = expr[i];
		}
	}
	
	public boolean run() throws Exception {
		if (!hasInit()) {
			this.init();
			if (!hasInit()) {
				return false;
			}
		}
		//fill in your implementation here
		int howMany = Integer.parseInt(this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));

		try {
			XATTuple[] tuples = this.getInputQueue().dequeue(howMany, this);
			/** figure out how many tuples to keep*/
			
			for (int i=0; i<tuples.length; i++) {
				//tupleList.clear();
				Vector tupleList = new Vector();
				tupleList.add(tuples[i]);
				Object out = expression[0].eval(tupleList, this);
				XATDataValue[] resultContent = new XATDataValue[1];
				resultContent[0] = new XATDataValueImp(out);
				XATTuple result = new XATTupleImp(resultContent);
				this.getOutputQueue().enqueue(result, this);
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
		return true;
	}

	public void init() {
		XATQueueSchema inSchema = this.getInputQueue().getSchema(),
			outSchema = this.getOutputQueue().getSchema();
		if (inSchema == null || inSchema.getLength()==0) {
			return;
		}
		
		if (outSchema == null || outSchema.getLength()==0) {
			outSchema = new XATQueueSchema();
			outSchema.setName(this.getInputQueue().getSchema().getName());
			for (int i=0; i<retainAttrNames.length; i++) {
				outSchema.addColumn(retainAttrNames[i]);
			}
			for (int i=0; i<expression.length; i++) {
				outSchema.addColumn(expression[i].getName());
			}
			this.getOutputQueue().setSchema(outSchema);
		}
		// compute output positions
		Vector outColNames = this.getOutputQueue().getSchema().getColNames();
		int[] outputPos = new int[outColNames.size()];
		Vector inColNames = this.getInputQueue(0).getSchema().getColNames(); 
		int numExpressions = expression.length;
		
		for (int i=0; i<(outColNames.size()-numExpressions); i++){
			Object outputCol = outColNames.get(i);
			outputPos[i] = inColNames.indexOf(outputCol);
		}
		this.setOutputPositions(0, outputPos);
		this.setHasInit(true);
	}

}
