/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.*;
/**
 * Insert the type's description here.
 * Creation date: (3/21/2003 2:26:41 PM)
 * @author: Yali Zhu
 */
public interface WBinaryJoinOperator extends XATMultiQueueWindowStreamOperator{
	/**
	 * This reinit method is only used during the stage of optimization.
	 * This method assumes that all operator properties, including the predicates, window size, state schema 
	 * and input queue schema has been initialized at the execution init stage.
	 * After optimization, the state and output queue schema might be changed so this method just reset them 
	 * to the corrent schema according to the input queue schema.
	 */
	//public void reinit();
	public void initState(String statetype);
/**
 * This method is used at the end of Parallel Migration when old box is done.
 * If this operator is a leaf operator of new box, the kept tuples
 * for purpose of preserve partial order will now be pushed out and
 * enqueued to output queue all at once.
 * Creation date: (6/26/2003 4:31:05 AM)
 */
public void enqueueKeptTuples();
/**
 * Insert the method's description here.
 * Creation date: (4/5/2003 6:59:19 PM)
 */
//public boolean evalJoinPredicate(
//    XATTuple t1,
//    int t1Pos,
//    XATTuple t2,
//    int t2Pos);
/**
 * Insert the method's description here.
 * Creation date: (6/3/2003 2:07:16 AM)
 * @return boolean
 */
public boolean getAllOldPurgedFlag() ;
/**
 * Insert the method's description here.
 * Creation date: (4/3/2003 5:00:07 AM)
 * @return queryplanelements.WFIFOState
 */
public OperatorState getLeftState();
public int getLeftStateSize();
public int getRightStateSize();
/**
 * Insert the method's description here.
 * Creation date: (5/28/2003 12:11:23 PM)
 * @return int
 */
//public int getLPos();
/**
 * Insert the method's description here.
 * Creation date: (4/3/2003 5:00:50 AM)
 * @return queryplanelements.WFIFOState
 */
public OperatorState getRightState();
/**
 * Insert the method's description here.
 * Creation date: (1/21/2003 10:57:01 AM)
 */
boolean run();
/**
 * Insert the method's description here.
 * Creation date: (5/25/2003 4:08:55 AM)
 * @return int
 */
public int runForMigration1();
/**
 * Insert the method's description here.
 * Creation date: (5/25/2003 4:08:55 AM)
 * @return int
 */
public int runForMigration2(long latestTimeStamp);
/**
 * Insert the method's description here.
 * Creation date: (6/3/2003 1:40:53 AM)
 * @param operators edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator[]
 */
public void setOldBoxOperators(XATStreamOperator[] operators) ;
/**
 * @return
 */
ExpressionStr getExpression();

/**
 * @param expression
 */
void setExpression(ExpressionStr expression);


}
