/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Oct 22, 2004
 * @author Yali Zhu
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.WOperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

public class WMJoinOperatorImp 	extends XATMultiQueueWindowStreamOperatorImp implements WMJoinOperator {
	
	int[][] ProbeSequence;
	//how many input stream this mjoin operates on. for binary join, this is known to be 2.
	int numOfInputs = 0;  
	
	// predicateMatrix[i][j] stores the predicates (expressionStr) that needs to be evaluated between input i and j.
	// only half (including diagonal line) of the matrix is filled. The filled half has i<=j (i at left, j at right).
	// during join processing, if i>j, i needs to be treated as the right side and j the left side.
	// this gurantee 1) the right predicate evaluation, and 2) the right order of columns no matter what the join order is.
	// this matrix is generated during parsing of a mjoin operator, by queryplangenerator.ClassVariableVisitor.
	private ExpressionStr[][] predicateMatrix; 
	
	
	public WMJoinOperatorImp(WMJoinOperatorImp oldop, XATNode newnode) {
		super(oldop, newnode);
		this.predicateMatrix = oldop.predicateMatrix;
		this.windowSize = oldop.windowSize;
	}
	
	public WMJoinOperatorImp(XATNode init) {
		super(init);
	}
	
	public WMJoinOperatorImp(XATNode init, int n) {
		super(init);
		this.numOfInputs = n;
	}
	
	public int getNumOfInputs() {
		return numOfInputs;
	}
	
	public void setNumOfInputs(int n) {
		this.numOfInputs = n;
	}
	
	public void initState(String statetype) {

		try{	
			//Constructor con = Class.forName(statetype).getConstructor();
			states = new WOperatorState[2];
			states[0] = (WOperatorState)Class.forName(statetype).newInstance();
			states[1] = (WOperatorState)Class.forName(statetype).newInstance();
			states[0].setOperator(this);
			states[1].setOperator(this);
			if(this.windowSize > 0) {
				((WOperatorState)states[0]).setTimeWindow(this.windowSize);
				((WOperatorState)states[1]).setTimeWindow(this.windowSize);
			}
		}catch(Exception e) {
			e.printStackTrace();	
		}
		
	}
	
	/*
	 * Assign new ID to each state inside this operator, starting from the given startID.
	 * return the next available ID. For example, if startID is 2, and there are 2 states inside this operator,
	 * then these two states are assigned new IDs as 2 and 3, and 4 is then returned as the next available stateID.
	 */
	public int setStateID(int startID) {
		if (states == null) {
			return startID;
		}
	
		for(int i=0; i<states.length; i++) {
			states[i].setStateID(startID);
			startID++;
		}
		return startID;
	}
	
	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		return true;
	}
	public boolean cleanAllAccumulatedTuples() {
		return false;
	}
	
	public boolean run() {
		return false;
	}
	public boolean matchStates(XATStreamOperator op) {
		return false;
	}
	/*
	 * check if this operator has any unmatched states.
	 * return: TRUE if this operator has unmatched states, FALSE otherwise.
	 */
	public boolean hasUnmatchedState() {
		return false;
	}

	public boolean recomputeUnmatchedState() {
		return true;
	}
	
	public String toToolTipString() {
		String s = new String();
		
		return s;
	}
	public boolean finalizeOperation(){
		return true;
	}

}
