/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueException;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleNegative;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.XATNodeDoesNotExistException;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.LightWeightQueryObject;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.WFIFOStateDeltaRecompute;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.WOperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataSource;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATTable;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyInt;

public class WindowBinaryDeltaRecomputeJoinOperatorImp extends
XATMultiQueueWindowStreamOperatorImp implements WindowBinaryDeltaRecomputeJoinOperator {

	//added only for statistic collection for exp. can be safely removed
	protected StringBuffer stats_string;
	String stateType=null;
	private ExpressionStr expression;
	
	private TuplesList outputQueueCache = null;//recompute complete result

	//private TuplesList outputQueueCacheRecom = null;
	private TuplesList outputQueueCacheDelta= null; // delta result
	private boolean OutputModeFlag=false; //true means complete result, false means delta.
	private boolean InputModeFlag=false;  // true means complete result, false means delta.

	private long start = 0;
	
	public WindowBinaryDeltaRecomputeJoinOperatorImp(XATNode newnode) {
		super(newnode);
		// TODO Auto-generated constructor stub
	}

	public String getStateType(){
		return this.stateType;
	}
	
	private int processLeftTuple(XATTuple tuple) {
		XATTuple[] joinedtuples = null;
		XATTuple[] prevJoinedtuples = null;
		//to track the output tuples previously joined and now purged by negative tuple 
		XATTuple[] prevJoinedNegtuples = null;

		int ret=0;
		if (this.outputQueueCache == null)
			this.outputQueueCache = new TuplesList(this.getOutputQueue().getSchema(), "timestamp");

		if (this.outputQueueCacheDelta == null)
			this.outputQueueCacheDelta = new TuplesList(this.getOutputQueue().getSchema(), "timestamp");

		//step 0: processing the negative tuple from the input queue
		if(!isInputModeFlag()){

			if(tuple instanceof XATTupleNegative)
			{
				if(((XATTupleNegative)tuple).isNegativeFlag()){
				//outputQueueCacheDelta.addToEnd(tuple);
					tuple.setToNew(true);
				List purgedByNegativeTuple = ((WFIFOStateDeltaRecompute) states[0]).purgeByNegativeTupleSelf((XATTupleNegative)tuple);

				ListIterator purgedByNegTuplesList = purgedByNegativeTuple.listIterator();

				//the output tuples corresponding to the purged tuples need to be removed.

				while (purgedByNegTuplesList.hasNext())
				{
					XATTuple t = (XATTuple) purgedByNegTuplesList.next();
					prevJoinedNegtuples = ((WFIFOStateDeltaRecompute) states[1]).probe(t,
							this.getExpression(), 0);
					for(int i =0;i<prevJoinedNegtuples.length;i++)
					{
						if(this.outputQueueCache.hasTuple(prevJoinedNegtuples[i]))
						{
							outputQueueCache.remove(prevJoinedNegtuples[i]);
							/*XATTupleNegativeImp tn = new XATTupleNegativeImp(prevJoinedNegtuples[i]);
							tn.setNegativeFlag(true);
							outputQueueCacheDelta.addToEnd(tn, true);*/
							System.out.println("\n  invalidating due to negative tuple " +prevJoinedNegtuples[i]);
						}
					}
				 }
					return 0;
				}
				 	
/*				if output requires delta, we need to put the negative tuple into the state
				if(!this.isOutputModeFlag())
				{
					((WFIFOStateDeltaRecompute) states[0]).insertTuple(tuple);
				}
				//return 0;*/
			    
			}
		}


		//step 1: cross purge
		List purgedTuples = ((WFIFOStateDeltaRecompute) states[1]).purgeByTuplePipeCross(tuple);

		ListIterator purgedTuplesList = purgedTuples.listIterator();

		//the output tuples corresponding to the purged tuples need to be removed.

		while (purgedTuplesList.hasNext())
		{
			XATTuple t = (XATTuple) purgedTuplesList.next();
			prevJoinedtuples = ((WFIFOStateDeltaRecompute) states[0]).probe(t,this.getExpression(), 0);
			for(int i =0;i<prevJoinedtuples.length;i++)
			{
				if(this.outputQueueCache.hasTuple(prevJoinedtuples[i]))
				{
					outputQueueCache.remove(prevJoinedtuples[i]);
					/*XATTupleNegativeImp tn = new XATTupleNegativeImp(prevJoinedtuples[i]);
					tn.setNegativeFlag(true);
					outputQueueCacheDelta.addToEnd(tn, true);*/
					System.out.println("\n expiring " +prevJoinedtuples[i]);
				}
			}
		}
		//step 2: probe the state
		joinedtuples = ((WFIFOStateDeltaRecompute) states[1]).probe(tuple,
				this.getExpression(), 1);
		//for (int i=0;i<this.getOutputQueueCount();i++ ){
		this.getOutputQueue().enqueue(joinedtuples, this);

		for(int i =0;i<joinedtuples.length;i++)
		{
			this.outputQueueCache.addToEnd(joinedtuples[i],true);
			/*XATTupleNegativeImp tn = new XATTupleNegativeImp(joinedtuples[i]);
			tn.setNegativeFlag(false);
			outputQueueCacheDelta.addToEnd(tn, true);*/
			this.outputQueueCacheDelta.addToEnd(joinedtuples[i],true);
		}

		
//		output at every increment (HOP)
		if(tuple.getMinTimeStamp()>this.start+this.windowSize)
		{
			TuplesList toEnqueue ;//= new TuplesList(this.getOutputQueue().getSchema(), "timestamp");

			if (isOutputModeFlag()){
				toEnqueue = outputQueueCache;	
			}
			else
			{
				toEnqueue = outputQueueCacheDelta;
			}
			XATTuple tDummy = new XATTupleImp();
			KeyInt data=new KeyInt(-1);  
		       tDummy.addCell( data);
			
		       this.getOutputQueue().enqueue(tDummy,this);

			ListIterator cacheIt = toEnqueue.listIterator();
			while (cacheIt.hasNext())
			{
				XATTuple t = (XATTuple) cacheIt.next();
				this.getOutputQueue().enqueue(t, this);
			}		
			outputQueueCache.clear();
			outputQueueCacheDelta.clear();
		}

		ret+=joinedtuples.length;
		//}
		//step 3: attach to outputqueue
		//step 4: insert into state
		((WFIFOStateDeltaRecompute) states[0]).insertTuple(tuple);
		return ret;

	}

	private int processRightTuple(XATTuple tuple) {
		XATTuple[] joinedtuples = null;
		XATTuple[] prevJoinedtuples = null;
		//to track the output tuples previously joined and now purged by negative tuple 
		XATTuple[] prevJoinedNegtuples = null;

		int ret=0;


		if (this.outputQueueCache == null)
			this.outputQueueCache = new TuplesList(this.getOutputQueue().getSchema(), "timestamp");

		if (this.outputQueueCacheDelta == null)
			this.outputQueueCacheDelta = new TuplesList(this.getOutputQueue().getSchema(), "timestamp");

		//step 0: processing the negative tuple from the input queue
		if(!isInputModeFlag()){
			if(tuple instanceof XATTupleNegative)
			{
				if(((XATTupleNegative)tuple).isNegativeFlag()){
				//outputQueueCacheDelta.addToEnd(tuple);
				tuple.setToNew(true);
				List purgedByNegativeTuple = ((WFIFOStateDeltaRecompute) states[1]).purgeByNegativeTupleSelf((XATTupleNegative)tuple);

				ListIterator purgedByNegTuplesList = purgedByNegativeTuple.listIterator();

				//the output tuples corresponding to the purged tuples need to be removed.

				while (purgedByNegTuplesList.hasNext())
				{
					XATTuple t = (XATTuple) purgedByNegTuplesList.next();
					prevJoinedNegtuples = ((WFIFOStateDeltaRecompute) states[0]).probe(t,
							this.getExpression(), 0);
					for(int i =0;i<prevJoinedNegtuples.length;i++)
					{
						if(this.outputQueueCache.hasTuple(prevJoinedNegtuples[i]))
						{
							outputQueueCache.remove(prevJoinedNegtuples[i]);
				/*			XATTupleNegativeImp tn = new XATTupleNegativeImp(prevJoinedNegtuples[i]);
							tn.setNegativeFlag(true);
							outputQueueCacheDelta.addToEnd(tn, true);*/
							System.out.println("\n invalidating due to negative tuple" +prevJoinedNegtuples[i]);
						}
					}
				}
				return 0;
				}
			/*	//if output requires delta, we need to put the negative tuple into the state 
				if(!this.isOutputModeFlag())
				{
					((WFIFOStateDeltaRecompute) states[0]).insertTuple(tuple);
				}
				return 0;*/
			}
		}


		//step 1: cross purge
		List purgedTuples = ((WFIFOStateDeltaRecompute) states[0])
		.purgeByTuplePipeCross(tuple);


		ListIterator purgedTuplesList = purgedTuples.listIterator();
		//the output tuples corresponding to the purged tuples need to be removed.

		while (purgedTuplesList.hasNext())
		{
			XATTuple t = (XATTuple) purgedTuplesList.next();
			prevJoinedtuples = ((WFIFOStateDeltaRecompute) states[1]).probe(t,
					this.getExpression(), 0);
			for(int i =0;i<prevJoinedtuples.length;i++)
			{
				if(this.outputQueueCache.hasTuple(prevJoinedtuples[i]))
				{	
					outputQueueCache.remove(prevJoinedtuples[i]);
					/*XATTupleNegativeImp tn = new XATTupleNegativeImp(prevJoinedtuples[i]);
					tn.setNegativeFlag(true);
					outputQueueCacheDelta.addToEnd(tn, true);*/
					System.out.println("\n expiring " +prevJoinedtuples[i]);
				}
			}
		}

		//step 2: probe the state
		joinedtuples = ((WFIFOStateDeltaRecompute) states[0]).probe(tuple,
				this.getExpression(), 0);

		//if(this.outputQueueCacheDelta == null)
		//this.outputQueueCacheDelta = new TupleList();//this.getOutputQueue().getSchema(),"timestamp");
		for(int i =0;i<joinedtuples.length;i++)
		{
			this.outputQueueCache.addToEnd(joinedtuples[i],true);
			/*XATTupleNegativeImp tn = new XATTupleNegativeImp(joinedtuples[i]);
			tn.setNegativeFlag(true);
			outputQueueCacheDelta.addToEnd(tn, true);*/
			this.outputQueueCacheDelta.addToEnd(joinedtuples[i],true);

		}
//		output at every increment (HOP)
		if(tuple.getMinTimeStamp()>this.start+this.windowSize)
		{
			TuplesList toEnqueue ;//= new TuplesList(this.getOutputQueue().getSchema(), "timestamp");

			if (isOutputModeFlag()){
				toEnqueue = outputQueueCache;	
			}
			else
			{
				toEnqueue = outputQueueCacheDelta;
			}

			XATTuple tDummy = new XATTupleImp();
			KeyInt data=new KeyInt(-1);  
		       tDummy.addCell( data);
			
		       this.getOutputQueue().enqueue(tDummy,this);
		       
			ListIterator cacheIt = toEnqueue.listIterator();
			while (cacheIt.hasNext())
			{
				XATTuple t = (XATTuple) cacheIt.next();
				this.getOutputQueue().enqueue(t, this);
			}	
			outputQueueCache.clear();
			outputQueueCacheDelta.clear();
		}
		
		ret+=joinedtuples.length;
		//}
		//step 3: attach to outputqueue
		//step 4: insert into state
		((WFIFOStateDeltaRecompute) states[1]).insertTuple(tuple);
		return ret;
	}

	/**
	 * Insert the method's description here. return: -1 nothing in queue, no run
	 * 0 exception 1 run successfully
	 * 
	 * Creation date: (1/21/2003 10:57:01 AM)
	 */
	public boolean run() {

		
		XATTuple leftTuple = null;
		XATTuple[] leftTuples = null;
		XATTuple rightTuple = null;
		XATTuple[] rightTuples = null;
		long timestart = System.nanoTime();
		try {
			if ((this.getLeftInputQueue().getSchema() == null)
					|| (this.getRightInputQueue().getSchema() == null)) {
				return false;
			}

			/*//outputqueue for join output
		//could be multiple outputs. but the schema is the same.
		for (int i=0;i<this.getOutputQueueCount();i++ )
			if (this.getOutputQueue(i).getSchema() == null) {
				init(i);
			}*/


			if(this.getOutputQueue().getSchema() == null)
				init();
//			return false;



			/* Load the current time_window and increment lengths */
			this.increment = 1000;
			this.windowSize = 4000;

			//hopping through increment
			//left state
		//	List purgedByHopTuple = ((WFIFOStateDeltaRecompute) states[0]).purgeByTimeStampSelf(this.start+this.increment);

			
			
		
//			Hopping through right state
			//List purgedByHopTupleR = ((WFIFOStateDeltaRecompute) states[1]).purgeByTimeStampSelf(this.start+this.increment);

		
		/** figure out how many tuples to dequeue from left and right queue */
			XATQueue lQueue = this.getLeftInputQueue();
			XATQueue rQueue = this.getRightInputQueue();
			int size1 = lQueue.getQueueSize(this);
			int size2 = rQueue.getQueueSize(this);
			int lHowmany = 0, rHowmany = 0;

			int dequeueHowmany = Integer.parseInt(this
					.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));

			//System.out.println(this + "tuple to dequeue " + dequeueHowmany);

			int totalOutput =0;

			//left queue is empty. we only deal with tuples from right queue
			//here we assume the tuple from left and right will arrive in order
			if (size1 <= 0 && size2 > 0) {
				lHowmany = 0;
				rHowmany = (dequeueHowmany > size2) ? size2 : dequeueHowmany;
				try {
					lQueue.setProperty("DEQUEUED_TUPLE_COUNT", "" + lHowmany);
					rQueue.setProperty("DEQUEUED_TUPLE_COUNT", "" + rHowmany);
					setNumberOfPossibleOutputs();
				} catch (Exception e) {
					System.out.println(e);
				}

				//begin exp stat collect
				stats_string.append(System.currentTimeMillis()+"\t"); 

				rightTuples = rQueue.dequeue(rHowmany, this);
				for (int x = 0; x < rightTuples.length; x++) {
					totalOutput+=this.processRightTuple(rightTuples[x]);
				}
				stats_string.append(System.currentTimeMillis()+"\t"+ totalOutput + "\n");	

				return true;
			}

			//right queue is empty. we only deal with tuples from left queue
			//here we assume the tuple from left and right will arrive in order
			if (size2 <= 0 && size1 > 0) {
				rHowmany = 0;
				lHowmany = (dequeueHowmany > size1) ? size1 : dequeueHowmany;
				try {
					lQueue.setProperty("DEQUEUED_TUPLE_COUNT", "" + lHowmany);
					rQueue.setProperty("DEQUEUED_TUPLE_COUNT", "" + rHowmany);
					setNumberOfPossibleOutputs();
				} catch (Exception e) {
					System.out.println(e);
				}
				//begin exp stat collect
				stats_string.append(System.currentTimeMillis()+"\t"); 

				leftTuples = lQueue.dequeue(lHowmany, this);
				for (int x = 0; x < leftTuples.length; x++) {
					totalOutput+=this.processLeftTuple(leftTuples[x]);
				}
				stats_string.append(System.currentTimeMillis()+"\t"+ totalOutput + "\n");	

				return true;
			}

			//Both queues are not empty.
			//here we assume the tuple from left and right will arrive in order
			if (size2 > 0 && size1 > 0) {
				lHowmany = 0;
				rHowmany = 0;
				int total = (dequeueHowmany > (size1 + size2)) ? (size1 + size2)
						: dequeueHowmany;

				//begin exp stat collect
				stats_string.append(System.currentTimeMillis()+"\t"); 

				for (int x = 0; x < total; x++) {
					if (lHowmany < size1 && leftTuple == null) {
						leftTuple = lQueue.dequeue(this);
						lHowmany++;
					}
					if (rHowmany < size2 && rightTuple == null) {
						rightTuple = rQueue.dequeue(this);
						rHowmany++;
					}
					if (rightTuple!=null&&leftTuple == null
							|| rightTuple!=null&&leftTuple.getMaxTimeStamp()
							- rightTuple.getMaxTimeStamp() >= 0) {
						totalOutput+=this.processRightTuple(rightTuple);
						rightTuple = null;
					} else if (leftTuple!=null&&rightTuple == null
							|| leftTuple!=null&&rightTuple.getMaxTimeStamp()
							- leftTuple.getMaxTimeStamp() > 0) {
						totalOutput+=this.processLeftTuple(leftTuple);

						leftTuple = null;
					}
				}
			}

			/* Change start to reflect the new beginning of the queue windows */ 
			start += this.increment;
			stats_string.append(System.currentTimeMillis()+"\t"+ totalOutput + "\n");	

			try{
				lQueue.setProperty("DEQUEUED_TUPLE_COUNT", "" + lHowmany);
				rQueue.setProperty("DEQUEUED_TUPLE_COUNT", "" + rHowmany);
				setNumberOfPossibleOutputs();
			} catch (Exception e) {
				System.out.println(e);


			}
		}catch(Exception e1) {
			e1.printStackTrace();
		}   
		//System.out.print("RunTime");
	    File file = new File ("runtimeJOperatorWithConvertion0.1k10.txt");
		FileWriter file_writer;
		try {
			file_writer = new FileWriter (file,true);
			file_writer.append(System.nanoTime()-timestart +"    \n");
			
			 file_writer.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
			
		return true;

	}

	public void printStatsToFile() {
		try {
			String fileName = new String("RegularJoinDelta_" + System.currentTimeMillis()+".txt");
			FileWriter out = new FileWriter(fileName, true);
			out.write(this.stats_string.toString());
			out.close();

		} catch (IOException e) {
			System.out.println(e.toString());
		}
	}

	public boolean isInputModeFlag() {
		return InputModeFlag;
	}

	public void setInputModeFlag(boolean inputModeFlag) {
		InputModeFlag = inputModeFlag;
	}

	public boolean isOutputModeFlag() {
		return OutputModeFlag;
	}

	public void setOutputModeFlag(boolean outputModeFlag) {
		OutputModeFlag = outputModeFlag;
	}

	
	/**
	 * 
	 */
	//private static final long serialVersionUID = 1L;

	public long getIncrement(int pos) {
		// TODO Auto-generated method stub
		return this.increment;
	}

	public long[] getIncrementArray() {
		// TODO Auto-generated method stub
		return null;
	}

	public long getStartPoint(int pos) {
		// TODO Auto-generated method stub
		return 0;
	}

	public long[] getStartPointArray() {
		// TODO Auto-generated method stub
		return null;
	}

	public long getWindowSize(int pos) {
		// TODO Auto-generated method stub
		return 0;
	}

	public OperatorState getLeftState() {
		return states[0];
	}

	public int getLeftStateSize() {
		return states[0].getStateSize();
	}

	public OperatorState getRightState() {
		return states[1];
	}

	public int getRightStateSize() {
		return states[1].getStateSize();
	}
	/**
	 * This function is used to initialize the two input states of the sliding
	 * window join It will be called by the plan generator in the
	 * visit(WindowBinaryDeltaRecomputeJoinOperator, XATNode). Creation date:
	 * (10/05/2005 4:48:47 PM)
	 */
	public void initState(String statetype) {
		this.stateType = statetype;
		try {
			//Constructor con = Class.forName(statetype).getConstructor();
			states = new WOperatorState[2];
			states[0] = (WOperatorState) Class.forName(statetype).newInstance();
			states[1] = (WOperatorState) Class.forName(statetype).newInstance();
			states[0].setOperator(this);
			states[1].setOperator(this);
			if (this.startPointArray[0] > 0)
				((WFIFOStateDeltaRecompute) states[0])
						.setStartWindow(this.startPointArray[0]);
			if (this.startPointArray[1] > 0)
				((WFIFOStateDeltaRecompute) states[1])
						.setStartWindow(this.startPointArray[1]);

			if (this.windowSizeArray[0] > 0) {
				((WFIFOStateDeltaRecompute) states[0])
						.setTimeWindow(this.windowSizeArray[0]);
				
			}
			if (this.windowSizeArray[1] > 0) {
				((WFIFOStateDeltaRecompute) states[1])
						.setTimeWindow(this.windowSizeArray[1]);
				
			}
			((WFIFOStateDeltaRecompute) states[0]).init(0);
			((WFIFOStateDeltaRecompute) states[1]).init(1);
			
			this.stats_string = new StringBuffer();
			//stats_string.append("StartTime\tEndTime\tOutputTuples\n");

		
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	public long[] getWindowSizeArray() {
		// TODO Auto-generated method stub
		return null;
	}

	public void setIncrement(long increment, int pos) {
		// TODO Auto-generated method stub
		
	}

	public void setIncrementArray(long[] incrementArray) {
		// TODO Auto-generated method stub
		
	}

	public void setStartPoint(long sPoint, int pos) {
		// TODO Auto-generated method stub
		
	}

	public void setStartPointArray(long[] sPointArray) {
		// TODO Auto-generated method stub
		
	}

	public void setWindowSize(long wSize, int pos) {
		// TODO Auto-generated method stub
		
	}

	public void setWindowSizeArray(long[] wSizeArray) {
		// TODO Auto-generated method stub
		
	}

	public void addInputQueue(XATQueue queue) {
		// TODO Auto-generated method stub
		
	}

	public void addOutputQueue(XATQueue queue) {
		// TODO Auto-generated method stub
		
	}

	public XATQueue getLeftInputQueue() {
		// TODO Auto-generated method stub
		return null;
	}

	public XATQueue getLeftOutputQueue() {
		// TODO Auto-generated method stub
		return null;
	}

	public XATQueue getNthInputQueue(int N) throws ArrayIndexOutOfBoundsException {
		// TODO Auto-generated method stub
		return null;
	}

	public XATQueue getNthOutputQueue(int N) throws ArrayIndexOutOfBoundsException {
		// TODO Auto-generated method stub
		return null;
	}

	public XATQueue getRightInputQueue() {
		// TODO Auto-generated method stub
		return null;
	}

	public XATQueue getRightOutputQueue() {
		// TODO Auto-generated method stub
		return null;
	}

	public void setLeftInputQueue(XATQueue newQueue) {
		// TODO Auto-generated method stub
		
	}

	public void setLeftOutputQueue(XATQueue newQueue) {
		// TODO Auto-generated method stub
		
	}

	public void setNthInputQueue(XATQueue newQueue, int N) {
		// TODO Auto-generated method stub
		
	}

	public void setNthOuputQueue(XATQueue newQueue, int N) {
		// TODO Auto-generated method stub
		
	}

	public void setRightInputQueue(XATQueue newQueue) {
		// TODO Auto-generated method stub
		
	}

	public void setRightOutputQueue(XATQueue newQueue) {
		// TODO Auto-generated method stub
		
	}

	public ExpressionStr getExpression() {
		return this.expression;
	} 
	
	public XATDataSource getDataSourceAt(int position) {
		// TODO Auto-generated method stub
		return null;
	}

	public XATDataSource[] getDataSources() {
		// TODO Auto-generated method stub
		return null;
	}

	public XATTable getSourceAt(int position) {
		// TODO Auto-generated method stub
		return null;
	}

	public XATTable[] getSources() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean finalizeOperation() {
		// TODO Auto-generated method stub
		return false;
	}

	public XATNode getNode() {
		// TODO Auto-generated method stub
		return null;
	}

	public XATTable getOutput() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getOutputColumnName() {
		// TODO Auto-generated method stub
		return null;
	}

	public XATDataSource getOutputDataSource() {
		// TODO Auto-generated method stub
		return null;
	}

	public Iterator getOutputDataSources() {
		// TODO Auto-generated method stub
		return null;
	}

	public XATDataSource getPrimaryDataSource() throws XATNodeDoesNotExistException {
		// TODO Auto-generated method stub
		return null;
	}

	public XATTable getPrimarySource() throws XATNodeDoesNotExistException {
		// TODO Auto-generated method stub
		return null;
	}

	public void setNode(XATNode newNode) {
		// TODO Auto-generated method stub
		
	}

	public void setOutput(XATDataSource newoutput) {
		// TODO Auto-generated method stub
		
	}

	public void setOutputColumnName(String OutputColumnName) {
		// TODO Auto-generated method stub
		
	}

	public LightWeightQueryObject getLightWeightQueryObject() {
		// TODO Auto-generated method stub
		return null;
	}

	public Enumeration getStatistics() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isValidStatistic(String nameToCheck) {
		// TODO Auto-generated method stub
		return false;
	}

	public Enumeration getProperties() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getProperty(String name) {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isValidPropertyName(String nameToCheck) {
		// TODO Auto-generated method stub
		return false;
	}

	public void setProperty(String name, String value) throws Exception {
		// TODO Auto-generated method stub
		
	}

	public void addInputQueue(XATQueue newInputQueue, int position) throws XATQueueException {
		// TODO Auto-generated method stub
		
	}

	public void addOutputQueue(int position) throws XATQueueException {
		// TODO Auto-generated method stub
		
	}

	public void addOutputQueueIdFromChildren(int opid, int id) {
		// TODO Auto-generated method stub
		
	}

	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean cleanAllAccumulatedTuples() {
		// TODO Auto-generated method stub
		return false;
	}

	public void clearAllTuples() {
		// TODO Auto-generated method stub
		
	}

	public void clearOutputQueueIdsFromChildren() {
		// TODO Auto-generated method stub
		
	}

	public void clearStatus() {
		// TODO Auto-generated method stub
		
	}

	public boolean equals(XATStreamOperator op) {
		// TODO Auto-generated method stub
		return false;
	}

	public String getCurrentStatus() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean getDebug() {
		// TODO Auto-generated method stub
		return false;
	}

	public XATQueue getInputQueue() {
		// TODO Auto-generated method stub
		return null;
	}

	public XATQueue getInputQueue(int queueNum) {
		// TODO Auto-generated method stub
		return null;
	}

	public XATQueue getInputQueue(String queueName) {
		// TODO Auto-generated method stub
		return null;
	}

	public int getInputQueueCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int getInputQueuePosition(XATQueue queue) {
		// TODO Auto-generated method stub
		return 0;
	}

	public Iterator getInputQueues() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean getIsSubPlanOperator() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean getIsSynced() {
		// TODO Auto-generated method stub
		return false;
	}

	public OperatorState getNthState(int n) {
		// TODO Auto-generated method stub
		return null;
	}

	public int getNumberOfOutputQueue() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int getObjectID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int getOperatorID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int[][] getOutputPositions() {
		// TODO Auto-generated method stub
		return null;
	}

	public int[] getOutputPositions(int i) {
		// TODO Auto-generated method stub
		return null;
	}

	public XATQueue getOutputQueue() {
		// TODO Auto-generated method stub
		return null;
	}

	public XATQueue getOutputQueue(int position) {
		// TODO Auto-generated method stub
		return null;
	}

	public int getOutputQueueCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	public ArrayList getOutputQueueIdFromChild(int opid) {
		// TODO Auto-generated method stub
		return null;
	}

	public Hashtable getOutputQueueIdFromChildren() {
		// TODO Auto-generated method stub
		return null;
	}

	public Iterator getOutputQueues() {
		// TODO Auto-generated method stub
		return null;
	}

	public OperatorState[] getState() {
		// TODO Auto-generated method stub
		return null;
	}

	public int getStateSize() {
		// TODO Auto-generated method stub
		return 0;
	}

	public boolean hasInit() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean hasState() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean hasUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	public void init() {
		// TODO Auto-generated method stub
		
	}

	public boolean isActive() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isBoxOperator() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isChanged() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isNewlyActivated() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isNewlyDeactivated() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isOldBoxLeaf() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isRunning() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean matchStates(XATStreamOperator op) {
		// TODO Auto-generated method stub
		return false;
	}

	public void processSyncTuple() {
		// TODO Auto-generated method stub
		
	}

	public boolean recomputeUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	public void removeInputQueue(int position) {
		// TODO Auto-generated method stub
		
	}

	public void removeInputQueue(XATQueue queue) {
		// TODO Auto-generated method stub
		
	}

	public void removeOutputQueue(XATQueue queue) {
		// TODO Auto-generated method stub
		
	}

	public void removeOutputQueue(int position) {
		// TODO Auto-generated method stub
		
	}

	public void replaceInputQueue(XATQueue existingQueue, XATQueue newQueue) {
		// TODO Auto-generated method stub
		
	}

	
	public void setActive(boolean active) {
		// TODO Auto-generated method stub
		
	}

	public void setAsNewBoxRoot() {
		// TODO Auto-generated method stub
		
	}

	public void setAsOldBoxLeaf() {
		// TODO Auto-generated method stub
		
	}

	public void setAsOldBoxRoot() {
		// TODO Auto-generated method stub
		
	}

	public void setAsOldOperator() {
		// TODO Auto-generated method stub
		
	}

	public void setBoxOperator(boolean isboxop) {
		// TODO Auto-generated method stub
		
	}

	public void setChanged(boolean ischanged) {
		// TODO Auto-generated method stub
		
	}

	public void setDebug(boolean debug) {
		// TODO Auto-generated method stub
		
	}

	public void setHasInit(boolean hasInit) {
		// TODO Auto-generated method stub
		
	}

	public void setInputQueue(XATQueue newInputQueue) throws XATQueueException {
		// TODO Auto-generated method stub
		
	}

	public void setIsSubPlanOperator(boolean s) {
		// TODO Auto-generated method stub
		
	}

	public void setIsSubPlanRootOperator(boolean s) {
		// TODO Auto-generated method stub
		
	}

	public void setIsSynced(boolean s) {
		// TODO Auto-generated method stub
		
	}

	public void setNewlyActivated(boolean is) {
		// TODO Auto-generated method stub
		
	}

	public void setNewlyDeactivated(boolean is) {
		// TODO Auto-generated method stub
		
	}

	public void setNthState(OperatorState state, int n) {
		// TODO Auto-generated method stub
		
	}

	public void setNumberOfOutputQueue(int value) {
		// TODO Auto-generated method stub
		
	}

	public void setNumberOfPossibleOutputs() {
		// TODO Auto-generated method stub
		
	}

	public void setOperatorID(int id) {
		// TODO Auto-generated method stub
		
	}

	public void setOutputPositions(int i, int[] ithOutputPositions) {
		// TODO Auto-generated method stub
		
	}

	public void setOutputPositions(int[][] newOutputPositions) {
		// TODO Auto-generated method stub
		
	}

	public void setOutputQueue(XATQueue newOutputQueue) throws XATQueueException {
		// TODO Auto-generated method stub
		
	}

	public void setRunning(boolean running) {
		// TODO Auto-generated method stub
		
	}

	public void setState(OperatorState[] state) {
		// TODO Auto-generated method stub
		
	}

	public int setStateID(int startID) {
		// TODO Auto-generated method stub
		return 0;
	}

	public String toShortString() {
		// TODO Auto-generated method stub
		return null;
	}

	public String toToolTipString() {
		// TODO Auto-generated method stub
		return null;
	}

	public long getIncrement() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int getInvalidateThreshold() {
		// TODO Auto-generated method stub
		return 0;
	}

	public long getStartPoint() {
		// TODO Auto-generated method stub
		return 0;
	}

	public long getWindowSize() {
		// TODO Auto-generated method stub
		return 0;
	}

	public void setIncrement(long increment) {
		// TODO Auto-generated method stub
		
	}

	public void setInvalidateThreshold(int iThreshold) {
		// TODO Auto-generated method stub
		
	}

	public void setStartPoint(long sPoint) {
		// TODO Auto-generated method stub
		
	}

	public void setWindowSize(long wSize) {
		// TODO Auto-generated method stub
		
	}

	public void setExpression(ExpressionStr expression) {
		this.expression = expression;
	}

	public void enqueueKeptTuples() {
		// TODO Auto-generated method stub
		
	}

	public boolean getAllOldPurgedFlag() {
		// TODO Auto-generated method stub
		return false;
	}

	public int runForMigration1() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int runForMigration2(long latestTimeStamp) {
		// TODO Auto-generated method stub
		return 0;
	}

	public void setOldBoxOperators(XATStreamOperator[] operators) {
		// TODO Auto-generated method stub
		
	}

}
