/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on May 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATMultiQueueStreamOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class XATMultiQueueWindowStreamOperatorImp
	extends XATMultiQueueStreamOperatorImp
	implements XATMultiQueueWindowStreamOperator {

	//for global window
	public long startPoint;
	public long windowSize;
	public long increment;
	
	//for individual windows
	//at most support 6-way join
	public long startPointArray[]= new long[6];
	public long windowSizeArray[]= new long[6];
	public long incrementArray[]= new long[6];
	
	int invalidateThreshold;
	
	public XATMultiQueueWindowStreamOperatorImp(XATNode init) {
		super(init);
	}
	
	/**
	 * copy constructor
	 * copy everything except queues and tuples.
	 * 
	 * @param oldop
	 * @param newnode
	 */
	public XATMultiQueueWindowStreamOperatorImp(XATMultiQueueWindowStreamOperatorImp oldop, XATNode newnode) {
		super(oldop, newnode);
		this.startPoint = 0;
		this.windowSize = oldop.windowSize;
		this.increment = oldop.increment;
		this.windowSizeArray = oldop.windowSizeArray;
		this.incrementArray = oldop.incrementArray; 
	}
	
	public XATMultiQueueWindowStreamOperatorImp(XATMultiQueueWindowStreamOperator oldop, XATNode newnode) {
		this((XATMultiQueueWindowStreamOperatorImp)oldop, newnode);
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#run()
	 */
	public abstract boolean run() throws Exception;

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getStartPoint()
	 */
	public long getStartPoint() {
		return startPoint;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getWindowSize()
	 */
	public long getWindowSize() {
		return windowSize;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getIncrement()
	 */
	public long getIncrement() {
		return increment;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getStartPoint(int)
	 */
	public long getStartPoint(int pos) {
		return startPointArray[pos];
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getWindowSize(int)
	 */
	public long getWindowSize(int pos) {
		return windowSizeArray[pos];
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getIncrement(int)
	 */
	public long getIncrement(int pos) {
		return incrementArray[pos];
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getStartPointArray()
	 */
	public long[] getStartPointArray() {
		return startPointArray;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getWindowSizeArray()
	 */
	public long[] getWindowSizeArray() {
		return windowSizeArray;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getIncrementArray()
	 */
	public long[] getIncrementArray() {
		return incrementArray;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getInvalidateThreshold()
	 */
	public int getInvalidateThreshold() {
		return invalidateThreshold;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setStartPoint(long)
	 */
	public void setStartPoint(long sPoint) {
		startPoint = sPoint;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setWindowSize(long)
	 */
	public void setWindowSize(long wSize) {
		windowSize = wSize;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setIncrement(long)
	 */
	public void setIncrement(long increment) {
		this.increment = increment;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setStartPoint(long, int)
	 */
	public void setStartPoint(long sPoint, int pos) {
		startPointArray[pos] = sPoint;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setWindowSize(long, int)
	 */
	public void setWindowSize(long wSize, int pos) {
		windowSizeArray[pos] = wSize;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setIncrement(long, int)
	 */
	public void setIncrement(long increment, int pos) {
		incrementArray[pos] = increment;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setStartPointArray(long[])
	 */
	public void setStartPointArray(long[] sPointArray) {
		startPointArray = sPointArray;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setWindowSizeArray(long[])
	 */
	public void setWindowSizeArray(long[] wSizeArray) {
		windowSizeArray = wSizeArray;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setIncrementArray(long[])
	 */
	public void setIncrementArray(long[] incrementArray) {
		this.incrementArray = incrementArray;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setInvalidateThreshold(int)
	 */
	public void setInvalidateThreshold(int iThreshold) {
		this.invalidateThreshold = iThreshold;
	}

}
