/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on May 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATSingleQueueStreamOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class XATSingleQueueWindowStreamOperatorImp
	extends XATSingleQueueStreamOperatorImp
	implements XATSingleQueueWindowStreamOperator {

	protected long startPoint;
	protected long windowSize;
	protected long increment;
	
	protected int invalidateThreshold;
	
	public XATSingleQueueWindowStreamOperatorImp(XATNode init) {
		super(init);
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#run()
	 */
	public abstract boolean run() throws Exception;

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getStartPoint()
	 */
	public long getStartPoint() {
		return startPoint;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getWindowSize()
	 */
	public long getWindowSize() {
		return windowSize;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#getIncrement()
	 */
	public long getIncrement() {
		return increment;
	}

	public int getInvalidateThreshold() {
		return invalidateThreshold;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setStartPoint(long)
	 */
	public void setStartPoint(long sPoint) {
		startPoint = sPoint;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setWindowSize(long)
	 */
	public void setWindowSize(long wSize) {
		windowSize = wSize;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATWindowStreamOperator#setIncrement(long)
	 */
	public void setIncrement(long increment) {
		this.increment = increment;
	}

	public void setInvalidateThreshold(int iThreshold) {
		this.invalidateThreshold = iThreshold;
	}
}
