/**--------------------------------------------------
* Attribute.java
* Author: Rimma V. Nehme, rnehme@purdue.edu, 2007
*/
package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh;

import java.util.ArrayList;
import java.util.Arrays;


@SuppressWarnings("serial")
public class Attribute implements java.io.Serializable
{
	//-----------------------------------------------------------------------------
	
	@SuppressWarnings("rawtypes")
	ArrayList mValues;
	String mName;
	Object mLabel;

	//-----------------------------------------------------------------------------
	
    @SuppressWarnings({ "unchecked", "rawtypes" })
	public Attribute(String name, boolean[] values)
    {
        mName = name;
        mValues = new ArrayList(Arrays.asList(values));
        //mValues.Sort();
    }

    //-----------------------------------------------------------------------------
    
    @SuppressWarnings({ "unchecked", "rawtypes" })
	public Attribute(String name, String[] values)
	{
		mName = name;
		Arrays.sort(values);
		mValues = new ArrayList(Arrays.asList(values));
		//mValues.Sort();
	}

	//-----------------------------------------------------------------------------
	
    @SuppressWarnings({ "unchecked", "rawtypes" })
    public Attribute(String name, int[] values)
    {
        mName = name;
        Arrays.sort(values);
        mValues = new ArrayList(Arrays.asList(values));
        //mValues.Sort();
    }
    
    //-----------------------------------------------------------------------------

	public Attribute(Object Label)
	{
		mLabel = Label;
		mName = "";
		mValues = null;
	}

	//-----------------------------------------------------------------------------
	
	public String getAttributeName()
	{
		return mName;		
	}

	//-----------------------------------------------------------------------------
	
    public String[] getValues()
	{		
    	if (mValues != null)
			return (String[])mValues.toArray();
		else
			return null;	
	}
    
    //-----------------------------------------------------------------------------

	public boolean isValidValue(String value)
	{
		return indexValue(value) >= 0;
	}

	//-----------------------------------------------------------------------------
	
    public int indexValue(String value)
	{    	
		if (mValues != null)
		{
			Object[] arrValues = mValues.toArray();
			return Arrays.binarySearch(arrValues, value);
		}
		else
			return -1;
	}
    
    //-----------------------------------------------------------------------------

	public String toString()
	{
		if (!mName.equals(""))
		{
			return mName;
		}
		else
		{
			return mLabel.toString();
		}
	}
	
	//-----------------------------------------------------------------------------
	
}