package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;

/**
 * @author Rimma V. Nehme
 * 
 */
public class Helper {
	// ----------------------------------------------------------------------------
	public static String LOG_FILE = "C:\\QueryMesh\\QueryMeshLog.txt";
	static String fileName = "C:\\QueryMesh\\QueryMeshDebug.txt";
	static String statsFileName = "C:\\QueryMesh\\QueryMeshStatistics.txt";

	// ----------------------------------------------------------------------------

	public static void WriteToFile(String fileToWriteTo, String textToWrite) {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(
					fileToWriteTo, true));
			out.write(textToWrite);
			out.newLine();
			out.close();
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
	}

	// ----------------------------------------------------------------------------

	public static void DebugWrite(String textToWrite) {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(fileName,
					true));
			out.write(textToWrite);
			out.close();
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
	}

	// ----------------------------------------------------------------------------

	public static void DebugWriteLine(String textToWrite) {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(fileName,
					true));
			out.write(textToWrite + "\n");
			out.close();
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
	}

	// ----------------------------------------------------------------------------

	public static void StatsWriteLine(String textToWrite) {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(
					statsFileName, true));
			out.write(textToWrite + "\n");
			out.close();
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
	}

	// ----------------------------------------------------------------------------

	public static void StatsWriteLineToFile(String filePath, String textToWrite) {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(filePath,
					true));
			out.write(textToWrite + "\n");
			out.close();
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
	}

	// ----------------------------------------------------------------------------

	public static String GetCurrentTimeString() {
		Calendar calendar = new GregorianCalendar();
		String am_pm;

		int hour = calendar.get(Calendar.HOUR);
		int minute = calendar.get(Calendar.MINUTE);
		int second = calendar.get(Calendar.SECOND);
		int millisecond = calendar.get(Calendar.MILLISECOND);

		if (calendar.get(Calendar.AM_PM) == 0) {
			am_pm = "AM";
		} else {
			am_pm = "PM";
		}

		return "" + hour + ":" + minute + ":" + second + ":" + millisecond
				+ " " + am_pm;
	}

	// ----------------------------------------------------------------------------
}
