//--------------------------------------------------
// HistTest.java
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2007
//--------------------------------------------------
package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh;

@SuppressWarnings("serial")
public class HistTest implements java.io.Serializable {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		java.util.Random r = new java.util.Random();
		// Them method nextGaussian in the class Random produces
		// values centered at 0.0 and with a standard deviation
		// of 1.0.

		// Create an instance of our basic histogram class.
		// Make it wide enough enough to include most of the
		// gaussian values.
		BasicHist bh = new BasicHist(10, -2.0, 2.0); // int numBins, double lo, double hi

		// Fill the histogram
		for (int i = 0; i < 100; i++) {
			double val = r.nextGaussian();
			bh.add(val);
		}

		// Print out the frequency values in each bin.
		for (int i = 0; i < 10; i++) {
			System.out.println("Bin " + i + " = " + bh.getValue(i));
		}

		// Negative bin values gives the underflows
		System.out.println("Underflows = " + bh.getValue(-1));

		// Bin values above the range give the overflows.
		System.out.println("Overflows = " + bh.getValue(10));
	}
}
