//--------------------------------------------------
// StringBasicHist.java
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2007
//--------------------------------------------------

package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh;

import java.util.Hashtable;

/**
 * A simple histogram class to count the frequency of values of a parameter of
 * interest.
 **/
@SuppressWarnings("serial")
public class StringBasicHist implements java.io.Serializable {
	Hashtable<String, Integer> bins;

	public StringBasicHist() {
		bins = new Hashtable<String, Integer>();
	}

	public void add(String key) {
		if (!bins.containsKey(key)) {
			bins.put(key, 1);
		} else {
			int counter = Integer.parseInt(bins.get(key).toString());
			counter++;
			bins.put(key, counter);
		}
	}

	public String getBinByValue(String key) {
		return key;
	}

	/** Clear the histogram bins. **/
	public void clear() {
		bins.clear();
	}

	/** Provide access to the bin values. **/
	public int getValue(String key) {
		return Integer.parseInt(bins.get(key).toString());
	}
}