package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.execution;

// Karen Works
// This is a dummy operator that does nothing but displays the results

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.XATMultiQueueWindowStreamOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;

import java.io.BufferedWriter;
import java.io.FileWriter;

@SuppressWarnings("serial")
public class DoNothingOperatorImp extends XATMultiQueueWindowStreamOperatorImp
		implements DoNothingOperator {

	private ExpressionStr expression;

	public int windowSize;
	String outFile = "C:\\QueryMesh\\execution_stats\\QM_RESULTS.txt";

	public DoNothingOperatorImp(XATNode init) {
		super(init);
	}

	public static void WriteToFile(String fileLocation, String stringToWrite,
			boolean doNewLine) {
		try {
			// Create file
			FileWriter fstream = new FileWriter(fileLocation, true);
			BufferedWriter out = new BufferedWriter(fstream);
			out.write(stringToWrite);
			if (doNewLine) {
				out.newLine();
			}
			// Close the output stream
			out.close();
		} catch (Exception e) {
			// Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
	}

	public boolean run() throws Exception {
		for (int i = 0; i < this.getOutputQueueCount(); i++) {
			if (this.getOutputQueue(i).getSchema() == null) {
				init(i);
			}
		}

		int howMany = Integer.parseInt(this
				.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));

		/** get the tuples */
		XATTuple[] tuples = this.getInputQueue().dequeue(howMany, this);

		WriteToFile(outFile, "Number of results: ", false);
		WriteToFile(outFile, String.valueOf(tuples.length), true);

		int numRTokensRemoved = 0;

		for (int i = 0; i < tuples.length; i++) {
			// do not enqueue r-tokens
			if (tuples[i].getClass().toString().endsWith("RoutingTokenImp")) {
				numRTokensRemoved++;
			} else {
				this.getOutputQueue().enqueue(tuples[i], this);
			}
			// //for testing purposes only
			// System.out.println("Output...");
			// QMeshTuple qmt = (QMeshTuple)tuples[i];
			// for (int j = 0 ; j < qmt.getNumTuplesInAnswer(); j++) {
			// if (qmt.getTuple(j)!= null) {
			// // for testing purposes only
			// System.out.print(qmt.getTuple(j));
			// this.getOutputQueue().enqueue(qmt.getTuple(j), this);
			// WriteToFile(outFile, qmt.getTuple(j).toString(), false);
			// }
			// }
			// WriteToFile(outFile, "", true);
		}
		System.gc();
		return true;
	}

	public void setWindowSize(String[] size) {
		windowSize = Integer.parseInt(size[0]);

	}

	// overload supper method
	public void init(int i) {
		XATQueueSchema inSchema = this.getInputQueue().getSchema();
		if (inSchema == null || inSchema.getLength() == 0) {
			return;
		}
		XATQueueSchema outSchema = this.getOutputQueue(i).getSchema();
		if (outSchema == null || outSchema.getLength() == 0) {
			this.getOutputQueue(i).setSchema(inSchema);
		}

		computeOutputPositions();// no need to overload since all the output
									// queue are the same
		numOutputColumns = outputPositions[0].length;
		setHasInit(true);
	}

	public String toToolTipString() {
		return "DoNothing (QueryMesh)";
	}

	public ExpressionStr getExpression() {
		return expression;
	}

	public void setExpression(ExpressionStr expression) {
		this.expression = expression;
	}

	/**
	 * The method cleanAccumulatedTuples() is similar to the method run(),
	 * except the way of figuring out how many tuples to dequeue from input
	 * queues. Inside method run() the numbers are computed based on the
	 * property "NUMBER_OF_TUPLES_TO_DEQUEUE" set by the system scheduler, while
	 * in cleanAccumulatedTuples, all tuples in input queues that have their max
	 * timesamp smaller than the given maxtimestamp should be dequened.
	 */
	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		return true;
	}

	/*
	 * process all accumulated tuples in this operators' input queues.
	 */
	public boolean cleanAllAccumulatedTuples() {
		return true;
	}

	/*
	 * check if this operator has any unmatched states. return: TRUE if this
	 * operator has unmatched states, FALSE otherwise.
	 */
	public boolean hasUnmatchedState() {
		return false;
	}

	public boolean matchStates(XATStreamOperator op) {
		return false;
	}

	public boolean recomputeUnmatchedState() {
		return true;
	}

	public int setStateID(int nextid) {
		return nextid;
	}

	public boolean finalizeOperation() {
		return true;
	}
}
