package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.execution;

import java.io.Serializable;
import java.util.Calendar;
import java.util.Date;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;

//Karen Works
//This structure stores the information associated with 
//an eddy tuple and eddy tuple operations.

@SuppressWarnings("serial")
public class QMeshTupleImp extends XATTupleImp implements QMeshTuple, Serializable
{
	// intermediate tuple that will be the answer
	private XATTuple[] answer = null;
	
	// number of tuples in answer
	private int NumTuplesInAnswer;
	
	// creation date
	private Date Creation;
	
	
	public QMeshTupleImp(XATTuple t,int NumStreams,int TuplePos) 
	{ 
		//throws XATTimeStampException {
		super();
		
		if (t != null) 
		{
			// set up answer
			answer = new XATTuple[NumStreams];
			answer[TuplePos] = t;         
			
			// set time
			this.setMaxTimeStamp(t.getMaxTimeStamp());
			this.setMinTimeStamp(t.getMinTimeStamp());
			
			NumTuplesInAnswer = NumStreams;			
			
			//set creation time
			Creation = Calendar.getInstance().getTime();
		} 
		else 
		{
			System.out.println("tuple is null");
		}
	}

	public QMeshTupleImp(int NumStreams) 
	{ 
		super();
		answer = new XATTuple[NumStreams];

		NumTuplesInAnswer = NumStreams;
		
		//set creation time
		Creation = Calendar.getInstance().getTime();			
	}
		
	// returns the creation date
	public Date GetCreationDate()
	{
		return Creation;
	}
	
	// adds a tuple to position pos
	public void addTuple(int pos, XATTuple t)
	{
		answer[pos] = t;         	
	}
	
	// returns a tuple from position pos
	public XATTuple getTuple(int pos)
	{
		return answer[pos];         	
	}
	
	// returns the number of tuples in the answer
	public int getNumTuplesInAnswer()
	{
		return NumTuplesInAnswer;         	
	}	

	// copies the answer
	public XATTuple[] getAnswer()
	{
		return answer.clone();
	}

	// sets the answer
	public void setAnswer(XATTuple[] a)
	{
		answer = a;
	}
	
	public String toString()
	{
		String str = "\nQueryMesh Tuple\n";
		str += "Answer tuple: \n";
		
		for (int p = 0; p < answer.length; p++)
		{
			XATTuple embeddedTuple = (XATTuple)answer[p];
			str += p +") "+ embeddedTuple.toString() +"\n";
		}
		str += "NumTuplesInAnswer[" + NumTuplesInAnswer + "]\n";
		str += "Creation = " + Creation;
		return str;
	}
}
