package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.execution;

import java.util.ArrayList;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

public class RangeNode {

	/*************************************************/
	public class RangeValues {
		double start;
		double end;
		node n;

		public RangeValues(int s, int e, node nd) {
			start = s * 1.0;
			end = e * 1.0;
			n = nd;
		}

		public RangeValues(double s, double e, node nd) {
			start = s;
			end = e;
			n = nd;
		}
	}

	/*************************************************/

	int attributeId; // attribute id
	ArrayList<RangeValues> nodes;

	public RangeNode(int atrbId, double s, double e, node nd) {
		attributeId = atrbId;
		nodes = new ArrayList<RangeValues>();
		RangeValues r = new RangeValues(s, e, nd);

		nodes.add(r);
	}

	public RangeNode(int atrbId, int s, int e, node nd) {
		attributeId = atrbId;
		nodes = new ArrayList<RangeValues>();
		RangeValues r = new RangeValues(s, e, nd);

		nodes.add(r);
	}

	/*************************************************/
	public void AddRangeValue(double s, double e, node nd) {
		RangeValues r = new RangeValues(s, e, nd);
		nodes.add(r);
	}

	public void AddRangeValue(int s, int e, node nd) {
		RangeValues r = new RangeValues(s * 1.0, e * 1.0, nd);
		nodes.add(r);
	}

	/*************************************************/

	public node FindMatch(XATTuple ProbeTuple) {
		double val = ProbeTuple.getCell(attributeId).convertToDouble();
		int nodeNumber = binarySearch(val);
		if (nodeNumber != -1) {
			return nodes.get(nodeNumber).n;
		} 
		else
			return null;
	}

	public int binarySearch(double val) {
		int low = 0;
		int high = nodes.size() - 1;
		int mid;

		while (low <= high) {
			mid = (low + high) / 2;

			if (nodes.get(mid).end < val)
				low = mid + 1;
			else if (nodes.get(mid).start > val)
				high = mid - 1;
			else if ((nodes.get(mid).end >= val)
					&& (nodes.get(mid).start <= val))
				return mid;
		}

		return -1;
		// NOT_FOUND = -1
	}

	// /////////////////////////////////////////////
	public int getAttributeId() // attribute id
	{
		return attributeId;
	}
}
