package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.execution;

import java.util.ArrayList;
import java.io.Serializable;

@SuppressWarnings("serial")
public class RusterNode implements Serializable
{
	String strOpList = "";
	
	//operator stack = list of operators to send the ruster to
	ArrayList<Integer> os;
	
	//array id of ruster used
	int RusterId;
	
	boolean bIsDefault = false;
	// 0 = default path
	
	@SuppressWarnings("unchecked")
	public RusterNode(ArrayList<Integer> o, int RustId, boolean b)
	{
		os = (ArrayList<Integer>) o.clone();
		RusterId = RustId;
		bIsDefault = b;
	}

	@SuppressWarnings("unchecked")
	public RusterNode(ArrayList<Integer> o, int RustId)
	{
		if (o == null)
		{
			System.out.println("This should never happen");
		}
		os = (ArrayList<Integer>)o.clone();
		RusterId = RustId;
	}

	public boolean IsDefault()
	{
		return bIsDefault;
	}
	
	public String GetRusterId()
	{
		return Integer.toString(RusterId);
	}
	
	public String GetOpList()
	{
		//return cached op list
		if (!strOpList.equalsIgnoreCase(""))
		{
			return strOpList;
		}
		else
		{
			//populate op list
			String str = "";
			for(int i = 0; i < os.size();i++)
			{
				str += os.get(i) + ",";
			}
			str = str.substring(0, str.length() - 1);
			strOpList = str;
			return strOpList;
		}
	}
	
	public String toString()
	{
		String str = "\n\n";
		str += "Ruster id[" + RusterId + "]\n";
		str += "IsDefault[" + bIsDefault + "]\n";
		str += "route = " + os;
		return str;
	}
}
