/*
 * ConstraintsConjunction.java
 *
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.optimization.JSetL;


import java.util.*;

/**
 * The <code>ConstraintsConjunction</code> class implements an abstraction of a generical 
 * conjunction of constraint.
 * 
 * @author  Elio Panegai
 * @version 1.3.0
 */
public class ConstraintsConjunction extends Vector implements java.io.Serializable {
    

    /**
     * Adds the constraint at the end of the store.
     *
     * @param s a constraint.
     */
    public void add(Constraint s) {
	//store.add(s);
        super.add(s);
	return;
    }


    /**
     * Adds the constraint in the desired position of the store.
     *
     * @param i position in the store.
     * @param s a constraint.
     */    
    public void add(int i, Constraint s) {
	//store.add(i,s);
        super.add(i,s);
	return;
    }
    
  /*   public int indexOf(Constraint s) {
	//return store.indexOf(s);
         return super.indexOf(s);
    }
  */
    
    /**
     * Returns the number of components in the vector used for storeing the constraints.
     * @return the number of components in the store vector.
     * @param Y List varible that have to be replaced.
     * @param Ynew List varible that replace all istances of the parameter first variable.
     */
   /* public int size() {
	//return store.size();
        return super.size();
    }


    public Object get(int x) {
	//return store.get(x);
        return super.get(x);
    }


    public void removeAllElements() {
	//store.removeAllElements();
        super.removeAllElements();
	return;
    }*/
    
    
       /* Restituisce un nuovo vincolo ottenuto da quello su cui  invocato 
       sostituendo ogni variabile della lista Y con la variabile che si 
       trova nella stessa posizione nella lista Ynew. */
    /**
     * Returns a new constraint conjunction equal to the invocator instance but with  
     * all the items in the list y replaced by the respective items of list ynew.     
     * @param y List of items to be replaced
     * @param ynew The replacing items list.
     * @return A new constraint conjunction with the specified variable replacement.
     */    
    protected ConstraintsConjunction sostAll(Lst y, Lst ynew) {
	ConstraintsConjunction s = this.cloneConstraintsConjunction();
	for(int i = 0; i < y.size(); i++) {
	    s = s.sost((Lvar)y.get(i),(Lvar)ynew.get(i));
	}
	return s;
    }
    
    
    /**
     * Returns a new constraint conjunction equal to the invocator instance but with the paramenter 
     * varables replaced. Variable y is replaced with x.
     * @param y Variable to be replaced
     * @param x Replacing variable.
     * @return A new constraint conjunction with the specified variable replacement.
     */
    protected ConstraintsConjunction sost(Lvar y, Lvar x) {
	ConstraintsConjunction n = new ConstraintsConjunction();
	for(int i = 0; i < this.size(); i++) {
	    Constraint s = new Constraint(((Constraint)this.get(i)).sost(y,x));
	    n.add(s);
	}
	return n;
    }

    /**
     * Returns a new constraint conjunction equal to the invocator constraint but with the paramenter 
     * lists replaced. List y is replaced with list x.
     * @param L1 List to be replaced
     * @param L2 Replacing list.
     * @return A new constraint conjunction with the specified list replacement.
     */    
    protected ConstraintsConjunction sost(Lst L1, Lst L2) {
	ConstraintsConjunction n = new ConstraintsConjunction();
	for(int i = 0; i < this.size(); i++) {
	    Constraint s = new Constraint(((Constraint)this.get(i)).sost(L1,L2));
	    n.add(s);
	}
	return n;
    }


    /**
     * Adds the constraint to the current constraint conjunction.
     *
     * @param s a constraint.
     * @return ConstraintsConjunction the object combined with the parameter 
     *         constraint. 
     */       
    public ConstraintsConjunction and(Constraint s) { 
	super.add(s);
	return this;
    }


    /**
     * Creates and returns a bit a bit copy of this constraint conjunction.
     * @return a bit a bit clone of this instance.
     */    
    protected ConstraintsConjunction cloneConstraintsConjunction() {
	ConstraintsConjunction vnew = new ConstraintsConjunction();
	for(int i = 0; i < this.size(); i++) {
	    vnew.add(((Constraint)this.get(i)).cloneConstraint());
	}
	return vnew;
    }
    
}