package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.optimization.JSetL;

import java.util.*;


/**
 * The <code>LvarExpr</code> class definies the arithmetical constraints.
 *
 * @author  Elio Panegai
 * @author  Elisabetta Poleo
 * @version 1.3.0
 */
public class LvarExpr {


    /* Vars member */
    protected ConstraintsConjunction vet;
    protected Lvar l;

    
    /* Constructor */
    public LvarExpr(Constraint S, Lvar L) {
	ConstraintsConjunction v = new ConstraintsConjunction();
	v.add(S);
	vet = v;
	l = L;
    }


    /* Methods member */
    public ConstraintsConjunction eq(boolean i) {
	vet.add(l.eq(i));
	return vet;
    }


    public ConstraintsConjunction eq(byte i) {
	vet.add(l.eq(i));
	return vet;
    }


    public ConstraintsConjunction eq(short i) {
	vet.add(l.eq(i));
	return vet;
    }

 
    public ConstraintsConjunction eq(int i) {
	vet.add(l.eq(i));
	return vet;
    }


    public ConstraintsConjunction eq(long i) {
	vet.add(l.eq(i)); 
	return vet;
    }


    public ConstraintsConjunction eq(float i) {
	vet.add(l.eq(i));
	return vet;
    }

    public ConstraintsConjunction eq(double i) {
	vet.add(l.eq(i));
	return vet;
    }


    public ConstraintsConjunction eq(char i) {
	vet.add(l.eq(i));
	return vet;
    }
    
    
    public ConstraintsConjunction eq(LvarExpr arit) {
        vet.add(l.eq(arit.l));
	return vet;
    }


    public ConstraintsConjunction eq(Object i) {
	vet.add(l.eq(i));
	return vet;
    }
   

    public ConstraintsConjunction neq(boolean i) {
	vet.add(l.neq(i));
	return vet;
    }


    public ConstraintsConjunction neq(byte i) {
	vet.add(l.neq(i));
	return vet;
    }


    public ConstraintsConjunction neq(short i) {
	vet.add(l.neq(i));
	return vet;
    }


    public ConstraintsConjunction neq(int i) {
	vet.add(l.neq(i));
	return vet;
    }


    public ConstraintsConjunction neq(long i) {
	vet.add(l.neq(i));
	return vet;
    }


    public ConstraintsConjunction neq(float i) {
	vet.add(l.neq(i));
	return vet;
    }


    public ConstraintsConjunction neq(double i) {
	vet.add(l.neq(i));
	return vet;
    }


    public ConstraintsConjunction neq(char i) {
	vet.add(l.neq(i));
	return vet;
    }

    
    public ConstraintsConjunction neq(LvarExpr arit) {
	vet.add(l.neq(arit.l));
	return vet;
    }


    //protected ConstraintsConjunction neq(Object i) {
    public ConstraintsConjunction neq(Object i) {   
	vet.add(l.neq(i));
	return vet;
    }


    public ConstraintsConjunction in(Set i) {
	vet.add(l.in(i));
	return vet;
    }


    public ConstraintsConjunction in(Lvar i) {
	vet.add(l.in(i));
	return vet;
    }


    public ConstraintsConjunction nin(Set i) {
	vet.add(l.nin(i));
	return vet;
    }


    public ConstraintsConjunction nin(Lvar i) {
	vet.add(l.nin(i));
	return vet;
    }


    // protected ConstraintsConjunction ge(int i) {
    public ConstraintsConjunction ge(int i) {    
	vet.add(l.ge(i));
	return vet;
    }


    // protected ConstraintsConjunction ge(Lvar i) {
    public ConstraintsConjunction ge(Lvar i) {
	vet.add(l.ge(i));
	return vet;
    }


    public ConstraintsConjunction ge(LvarExpr arit) {
	vet.add(l.ge(arit.l));
	return vet;
    }


    // protected ConstraintsConjunction gt(int i) {
    public ConstraintsConjunction gt(int i) {
	vet.add(l.gt(i));
	return vet;
    }


    //protected ConstraintsConjunction gt(Lvar i) {
    public ConstraintsConjunction gt(Lvar i) {
	vet.add(l.gt(i));
	return vet;
    }


    public ConstraintsConjunction gt(LvarExpr arit) {
	vet.add(l.gt(arit.l));
	return vet;
    }


    // protected ConstraintsConjunction le(int i) {
    public ConstraintsConjunction le(int i) {
	vet.add(l.le(i));
	return vet;
    }


    //protected ConstraintsConjunction le(Lvar i) {
    public ConstraintsConjunction le(Lvar i) {
	vet.add(l.le(i));
	return vet;
    }


    public ConstraintsConjunction le(LvarExpr arit) {
	vet.add(l.le(arit.l));
	return vet;
    }


    // protected ConstraintsConjunction lt(int i) {
    public ConstraintsConjunction lt(int i) {
	vet.add(l.lt(i));
	return vet;
    }


    // protected ConstraintsConjunction lt(Lvar i) {
    public ConstraintsConjunction lt(Lvar i) {
	vet.add(l.lt(i));
	return vet;
    }


    public ConstraintsConjunction lt(LvarExpr arit) {
	vet.add(l.lt(arit.l));
	return vet;
    }


    public LvarExpr sum(int i) {
	Lvar L = new Lvar();
	Constraint s = new Constraint(Enviroment.sumCode, L, this.l, i); 
	vet.add(s);
	l = L;
	return this;
    }


    public LvarExpr sum(Object i) {
	Lvar L = new Lvar();
	Constraint s = new Constraint(Enviroment.sumCode, L, this.l, i); 
	vet.add(s);
	l = L;
	return this;
    }


    public LvarExpr sub(int i) {
	Lvar L = new Lvar();
	Constraint s = new Constraint(Enviroment.subCode, L, this.l, i); 
	vet.add(s);
	l = L;
	return this;
    }


    public LvarExpr sub(Object i) {
	Lvar L = new Lvar();
	Constraint s = new Constraint(Enviroment.subCode, L, this.l, i); 
	vet.add(s);
	l = L;
	return this;
    }


    public LvarExpr mul(int i) {
	Lvar L = new Lvar();
	Constraint s = new Constraint(Enviroment.mulCode, L, this.l, i); 
	vet.add(s);
	l = L;
	return this;
    }


    public LvarExpr mul(Object i) {
	Lvar L = new Lvar();
	Constraint s = new Constraint(Enviroment.mulCode, L, this.l, i); 
	vet.add(s);
	l = L;
	return this;
    }


    public LvarExpr div(int i) {
	Lvar L = new Lvar();
	Constraint s = new Constraint(Enviroment.divCode, L, this.l, i); 
	vet.add(s);
	l = L;
	return this;
    }


    public LvarExpr div(Object i) {
	Lvar L = new Lvar();
	Constraint s = new Constraint(Enviroment.divCode, L, this.l, i); 
	vet.add(s);
	l = L;
	return this;
    }


    public LvarExpr mod(int i) {
	Lvar L = new Lvar();
	Constraint s = new Constraint(Enviroment.modCode, L, this.l, i); 
	vet.add(s);
	l = L;
	return this;
    }


    public LvarExpr mod(Object i) {
	Lvar L = new Lvar();
	Constraint s = new Constraint(Enviroment.modCode, L, this.l, i); 
	vet.add(s);
	l = L;
	return this;
    }

}
