
package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.optimization.JSetL;

/**
 * The <code>NewConstraints</code> class allow the user to define new 
 * constraints. User-defined constraints are dealt with as the built-in 
 * constraints: they can be added to the constraint store using the method
 * <CODE>add</CODE> and solved using the <CODE>SolverClass</CODE> methods for 
 * constraint solving.
 *
 * @author Elio Panegai
 * @version 1.3.0
 */
public abstract class NewConstraintsClass {  

    
    /**
     *  Reference to the solver.
    */    
    public SolverClass Solver;    
        
    
    /* Costructors */    
    public NewConstraintsClass() {
    }
    
    
    public NewConstraintsClass(SolverClass s) {
	Solver = s;
        Solver.setNewConstraints(this);
    }


    /* Abstract Methods */    
    public abstract void user_code(Constraint s) throws Failure, NotDefinedConstraint;    

}

