package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.optimization.JSetL;

import java.util.*;

/**
 * The <code>StoreState</code> class is used to getting a store copy.
 *
 * @author  Elio Panegai
 * @author  Elisabetta Poleo
 * @version 1.3.0
 */
class StoreState {


    /**
     * A clone of the store.
     */
    ConstraintStore statoStore; 
    
    /**
     * The position in the store of the constraint actually used.
     */
    int posizione;              


    /**
     * Reference to the solver.
     */
    SolverClass Solver; 


    /* Costructors */
    /**
     * Constructs a new empty StoreState object.
     * @param s Reference to the solver.
     */
    StoreState(SolverClass s) {
	this(null, 0, s);  
    }


    /**
     * Constructs a new StoreState object.
     * @param sc Reference to the solver.
     * @param s Reference to a constraint store.
     * @param i Index of a constraint in the constraint store.
     */
    StoreState(ConstraintStore s, int i, SolverClass sc) {
	this.statoStore = s;
	this.posizione  = i;
	this.Solver     = sc;
    }


    /* Member Methods */
    /**
     * Clone (bit a bit) the current StoreState.
     *
     * @return a clone of the object.
     */
    protected StoreState cloneStoreState() {
	StoreState s = new StoreState(null, 0, null);
        
	s.posizione  = this.posizione;
	s.Solver     = this.Solver;
	s.statoStore = new ConstraintStore(Solver.store.cloneStore());
	return s;
    }

}
