//--------------------------------------------------
// OptimizerOp.java
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2007
//--------------------------------------------------

package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.optimization;

import java.util.ArrayList;

public class OptimizerOp implements java.io.Serializable
{
	//----------------------------------------------------------------------------------------------------
	
	private String id;
	private String operatorType;
	private ArrayList<OptimizerOpInput> inputs;
	private double operatorSelectivity;
	
	//----------------------------------------------------------------------------------------------------
	
	public OptimizerOp(String idVal,
    				   String operatorTypeVal,     								   
    				   ArrayList inputsVal,
    				   double operatorSelectivityVal)
	{
		id = idVal;
		operatorType = operatorTypeVal;
		inputs = inputsVal;
		operatorSelectivity = operatorSelectivityVal;
	}
	
	//----------------------------------------------------------------------------------------------------
	
	public ArrayList getInputs()
	{
		return inputs;		
	}
	
	//----------------------------------------------------------------------------------------------------
	
	public double getOpSelectivity()
	{
		return operatorSelectivity;
	}
	
	//----------------------------------------------------------------------------------------------------
	  
	public String toString() 
	{	
		StringBuilder result = new StringBuilder();	 
		String NEW_LINE = System.getProperty("line.separator");
 
		result.append(NEW_LINE + "OptimizerOp:"+ NEW_LINE);
		result.append("id: " + id + NEW_LINE);	       
		result.append("operatorType: " + operatorType + NEW_LINE);
		for (int i = 0; i < inputs.size(); i++)
		{
			result.append("inputs: " + inputs.get(i).name + NEW_LINE);
		}
		result.append("operatorSelectivity: " + operatorSelectivity + NEW_LINE);
		return result.toString();    	    
	}
	    	  
	//----------------------------------------------------------------------------------------------------
	
}
