//--------------------------------------------------
// OperatorAndSelectivityComparer.java
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2008
//--------------------------------------------------

package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.selftuning;

import java.util.Comparator;

import edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.translation.ChildOperatorSignature;

public class OperatorAndSelectivityComparer implements Comparator 
{
	//-----------------------------------------------------------------------------
	
	public int compare(Object oas1, Object oas2)
	{
		try
		{
			double opSel1 = ((OperatorAndSelectivity)oas1).GetOperatorSelectivity();
			double opSel2 = ((OperatorAndSelectivity)oas2).GetOperatorSelectivity();
			
			if ((oas1 == null) || (oas2 == null))
			{
				return -1;
			}
			else
			{
				return Double.toString(opSel1).compareTo(Double.toString(opSel2));
			}
		 }
		catch (Exception e)
		{
			return 0;
		}
	}
	
	//-----------------------------------------------------------------------------
	
}
