//--------------------------------------------------
// RouteSignatureStorage.java
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2008
//--------------------------------------------------

package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.selftuning;

import java.util.Comparator;

import edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.execution.RusterNode;


public class RouteSignatureStorage 
{
	//-----------------------------------------------------------------------------
	
	String streamId = "";
	public String routeId = "";
	String routeSignature = "";
	boolean isDefaultRoute = false;
	
	//-----------------------------------------------------------------------------
	
	public RouteSignatureStorage(RusterNode rn, String streamIdVal)
	{
		streamId = streamIdVal;
		routeId = rn.GetRusterId();		
		routeSignature = rn.GetOpList();
		isDefaultRoute = rn.IsDefault();
		
		if (rn.IsDefault())//if this route is default, set the route id to 0, because that's the id that the online classifier assumes for default route
		{
			routeId = "0";
		}
	}
	
	//-----------------------------------------------------------------------------
	
	public boolean IsDefault()
	{
		return isDefaultRoute;
	}

	//-----------------------------------------------------------------------------
	
	public String GetStreamId()
	{
		return streamId;
	}
	
	//-----------------------------------------------------------------------------
	
	public String GetRouteId()
	{
		return routeId;
	}
	
	//-----------------------------------------------------------------------------
	
	public String GetRouteSignature()
	{
		return routeSignature;
	}
	
	//-----------------------------------------------------------------------------
	
}
