//--------------------------------------------------
// StqmPunctImp.cs
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2008
//--------------------------------------------------
package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.selftuning;

import java.util.ArrayList;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunct;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPunctImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.execution.RoutingTokenImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.security.AccessControlModel;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;

/**
 * @author Rimma V. Nehme
 *
 */
public class StqmPunctImp extends XATPunctImp implements StqmPunct 
{	
	//-----------------------------------------------------------------------------
	
	String content;
	
	//-----------------------------------------------------------------------------
	
	public StqmPunctImp() 
	{
		super();		
		this.objTypeID = 4; //security punctuations have object type id = 4
	}
	
	//-----------------------------------------------------------------------------
	
	public StqmPunctImp(XATDataValue[] array) 
	{
		super(array);
		this.objTypeID = 4; //security punctuations have object type id = 4
	}
	
	//-----------------------------------------------------------------------------
	
	public StqmPunctImp(int length) 
	{
		super(length);
		this.objTypeID = 4; //security punctuations have object type id = 4
	}
	
	//-----------------------------------------------------------------------------
	
	public StqmPunctImp(List list) 
	{
		super(list);
		this.objTypeID = 4; //security punctuations have object type id = 4
	}
	
	//-----------------------------------------------------------------------------

	public String toString() 
	{
		StringBuffer sb = new StringBuffer();
		sb.append("\nStqm punctuation: ");
		
		for (int i = 0; i < this.getLength(); i++) 
		{
			Object cellValue = this.getCell(i).getValue();
			if (cellValue != null) 
			{
				sb.append(cellValue.toString());
			} 
			else 
			{
				sb.append(" ");
			}
			if (i < this.getLength() - 1)
				sb.append("  |  ");
		}			
		
		sb.append("  |  " + this.minTimeStamp + "  |  " + this.maxTimeStamp);
		return sb.toString();
	}

	//-----------------------------------------------------------------------------
	
	public StqmPunct CreateClone() 
	{
		StqmPunctImp stqmPunctClone = new StqmPunctImp(this.getArrayData());
		return stqmPunctClone;
	}
	
	//-----------------------------------------------------------------------------
	
}
