//--------------------------------------------------
// SensorModel.java
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2008
//--------------------------------------------------

package edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.uncertainty.Particles;

import java.util.ArrayList;
import java.util.List;

public class SensorModel 
{
	//-----------------------------------------------------------------------------
	
	private Table<String, String, Double> table;
	private List<String> states;

	//-----------------------------------------------------------------------------
	
	public SensorModel(List<String> states, 
					   List<String> perceptions) 
	{
		this.states = states;
		table = new Table<String, String, Double>(states, perceptions);
	}

	//-----------------------------------------------------------------------------
	
	public void setSensingProbability(String state, 
									  String perception,
									  double probability) 
	{
		table.set(state, perception, probability);
	}
	
	//-----------------------------------------------------------------------------

	public Double get(String state, String perception) 
	{
		return table.get(state, perception);
	}

	//-----------------------------------------------------------------------------
	
	public Matrix asMatrix(String perception) 
	{
		List<Double> values = new ArrayList<Double>();
		// for (String state : aBelief.states()) {
		for (String state : states) 
		{
			values.add(get(state, perception));
		}
		Matrix OMatrix = Matrix.createDiagonalMatrix(values);
		return OMatrix;
	}

	//-----------------------------------------------------------------------------
	
}
