/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression;

import java.util.List;
//import java.util.Vector;
//import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinANDExpression;
//import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpression;
//import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinExpression;
//import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinORExpression;
//import edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
/**  
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class BinANDExpressionStrImp extends ExpressionStrImp implements BinANDExpressionStr
{

  ExpressionStr eLeft,eRight;
 
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 6:17:10 PM)
 * @param str edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression
 */
//public BinANDExpressionStrImp(Expression expr) {
//
//	ExpressionStrImp expressionStrImp = new ExpressionStrImp();
//	
//	eLeft = expressionStrImp.createExpressionStr(((BinExpression)expr).getLeft());
//
//	eRight = expressionStrImp.createExpressionStr(((BinExpression)expr).getRight());
//
//	 untrueExpression = (BinANDExpressionStrImp)this.clone();
//	
//	}

	public BinANDExpressionStrImp() {
		super();
	}
	
  	public BinANDExpressionStrImp(ExpressionStr left, ExpressionStr right)
  	{
		eLeft = left;
		eRight = right;
		//untrueExpression = (BinANDExpressionStrImp)this.clone();
  	}
 /**
	* It will evaluate itself and return the value as an object.
	* Remember, it could be like: Integer, Float, Double, String, Boolean.
	*/
//public java.lang.Object eval(edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator xopOper, int[] iPositions) {
//	return null;
//}
//if not return true, show what expression is not true 
public Object eval(List tuples, XATStreamOperator op) {
	try {
		//Boolean leftEval = (Boolean) eLeft.eval(tuples, op);
		//Boolean rightEval = (Boolean) eRight.eval(tuples, op);
		//return new Boolean((leftEval.booleanValue()) && (rightEval.booleanValue()));
        return new Boolean((Boolean)eLeft.eval(tuples, op) && (Boolean)eRight.eval(tuples, op));
	} catch (ClassCastException e) {
		e.printStackTrace();
		/* um, fail? */
		return null;
	}
}


	public ExpressionStr getLeft()
	{
	  return eLeft;
	}
	public ExpressionStr getRight()
	{
	  return eRight;
	}
/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 4:25:52 PM)
 * @return java.util.Vector
 */
//public java.util.Vector getTerminalColumnExprs() {
//	Vector results = new Vector();
//
//	results.addAll(eLeft.getTerminalColumnExprs());
//	results.addAll(eRight.getTerminalColumnExprs());
//	
//	return results;
//}
/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 4:25:52 PM)
 * @return java.util.Vector
 */
//public java.util.Vector getTerminalColumnNames() {
//	if (terminalColumnNames == null) {
//		terminalColumnNames = new Vector();
//
//		terminalColumnNames.addAll(eLeft.getTerminalColumnNames());
//		terminalColumnNames.addAll(eRight.getTerminalColumnNames());
//	}
//
//	return terminalColumnNames;
//}
	public void setLeft(ExpressionStr left)
	{
	  eLeft = left;
	}
	public void setRight(ExpressionStr right)
	{
	  eRight = right;
	}

	public String toString()
	{
	return "(" + eLeft.toString() + " AND " + eRight.toString() + ")";
	}
	
	/**
	 * reset column positions in expression according to the given position mapping.
	 * this method is usually called by optimizer when switching two operators and as a result we
	 * have to reset the column IDs of involving operators' expressions.
	 * 
	 * This method is usually called right before the method "getRelatedSubExpression" in this class.
	 * @param pos
	 * @return
	 */
	public boolean resetColumnPosition(int[][] positionmap) {
  		return false;
	}
    
	/**
	* get the sub-expressions that contains ONLY the given
	* queue position and column positions.
	* the returned expression could be as large as this expression itself, or as small as null.
	* 
	* This method is usually called by the optimizer right after the method "resetColumnPosition" in this class.
	*/
	public ExpressionStr getRelatedSubExpression(int queuepos, int[] columnpos) {
  		return null;
	}
	
	public boolean containColumnPositions(int queuePos, int[] columnPos) {
	  return (eLeft.containColumnPositions(queuePos, columnPos) || eRight.containColumnPositions(queuePos, columnPos));
	 }
}
