/*
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
 * Created on Aug 3, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression;

/**
 * @author Yali Zhu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TerminalConstantImp extends ExpressionStrImp implements TerminalConstant{

	public int iType;
	Object value;
	
	/**
	 * 
	 */
	public TerminalConstantImp() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public TerminalConstantImp(String sValue) {
		iType = STRING;
		value = sValue;
	}
	
	public TerminalConstantImp(double dValue) {
		iType = DOUBLE;
		value = new Double(dValue);
	}

	public TerminalConstantImp(Double dValue) {
		iType = DOUBLE;
		value = dValue;
	}
	
	public TerminalConstantImp(long lValue) {
		iType = LONG;
		value = new Long(lValue);
	}

	public TerminalConstantImp(Long lValue) {
		iType = LONG;
		value = lValue;
	}
	
	public TerminalConstantImp(int iValue) {
		iType = INTEGER;
		value = new Integer(iValue);
	}

	public TerminalConstantImp(Integer iValue) {
		iType = INTEGER;
		value = iValue;
	}

	public TerminalConstantImp(boolean bValue) {
		iType = BOOL;
		value = new Boolean(bValue);
	}
	
	public TerminalConstantImp(Boolean bValue) {
		iType = BOOL;
		value = bValue;  
	}	
	
	public int getType() {
		return iType;
	}

	public Object getValue() {
		return value;
	}
	
	public void setType(int type) {
		iType = type;
	}
	
	public void setValue(String sValue) {
		iType = STRING;
		value = sValue;
	}
	
	public void setValue(double dValue) {
		iType = DOUBLE;
		value = new Double(dValue);
	}
	
	public void setValue(long lValue) {
		iType = LONG;
		value = new Long(lValue);
	}
	
	public void setValue(int iValue) {
		iType = INTEGER;
		value = new Integer(iValue);
	}	

	public void setValue(boolean bValue) {
		iType = BOOL;
		value = new Boolean(bValue);
	}

	public String toString() {
		switch (iType) {
			case STRING :
				return "\"" + value + "\"";
			case DOUBLE :
			case LONG:
			case INTEGER :
			case BOOL:
				return value.toString();
			default :
				return "Terminal(" + Integer.toString(iType) + ")";
		}
	}

	/**
	   * It will evaluate itself and return the value as an object.
	   * Remember, it could be like: Integer, Float, Double, String, Boolean.
	   */
   public Object eval(java.util.List tuples, edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator op) {
	   return value;		
   }
   /**
	* getRelatedColumnNames method comment.
	*/
   public edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnName[] getRelatedColumnNames() {
	   return null;
   }
   /**
	* find the terminal columns' names, a vector of strings
	* Creation date: (2/17/2003 4:38:04 PM)  
	* @return java.util.Vector
	*/
   public java.util.Vector getTerminalColumnExprs() {
	   return null;
   }
	
   /**
	* find the terminal columns' names, a vector of strings
	* Creation date: (2/17/2003 4:38:04 PM)  
	* @return java.util.Vector
	*/
   public java.util.Vector getTerminalColumnNames() {
	   return null;
   }
   
   /**
	* reset column positions in expression according to the given position mapping.
	* this method is usually called by optimizer when switching two operators and as a result we
	* have to reset the column IDs of involving operators' expressions.
	* 
	* This method is usually called right before the method "getRelatedSubExpression" in this class.
	* @param pos
	* @return
	*/
   public boolean resetColumnPosition(int[][] positionmap) {
   		return false;
   }
    
   /**
   * get the sub-expressions that contains ONLY the given
   * queue position and column positions.
   * the returned expression could be as large as this expression itself, or as small as null.
   * 
   * This method is usually called by the optimizer right after the method "resetColumnPosition" in this class.
   */
   public ExpressionStr getRelatedSubExpression(int queuepos, int[] columnpos) {
  		return null;
   }
   
   public boolean containColumnPositions(int queuePos, int[] columnPos) {
   	return false;
   }



}
