/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.xmldb.xat.common.security.fence;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List; 

class Robin implements java.io.Serializable
{	
	//------------------------------------------------------------------------------------
	
	private int i; 	
	
	//------------------------------------------------------------------------------------
	
	public Robin(int i) 
	{		
		this.i = i;	
	} 	
	
	//------------------------------------------------------------------------------------
	
	public int call() 
	{		
		return i;	
	}
	
	//------------------------------------------------------------------------------------
	
}

//------------------------------------------------------------------------------------

public class RoundRobin implements Serializable
{
	//------------------------------------------------------------------------------------
	
	private Iterator it;	
	private List list; 	
	
	//------------------------------------------------------------------------------------
	
	public RoundRobin(List list) 
	{		
		this.list = list;		
		it = list.iterator();	
	}		
	
	//------------------------------------------------------------------------------------
	
	public int next() 
	{		
		// if we get to the end, start again		
		if (!it.hasNext()) 
		{			
			it = list.iterator();		
		}		
		Robin robin = (Robin) it.next();				
		return robin.call();			
	}		
	
	//------------------------------------------------------------------------------------
	
}
