/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnName;
/**
* It's going to represent the leaf expressions, e.g.,
* A String, Double, or a ColumnName.
* Hits: You can keep an Object property, that maybe objects of
* String, Double or ColumnName.
*/
public interface TerminalExpressionStr extends ExpressionStr {
    final static int STRING = 0;
    final static int DOUBLE = 1;
    final static int NAME = 2;
    final static int BOOL = 3;
    /**
    * Return the type of this terminalExpression.
    * It could be a String, or a Double, or a ColumnName.
    */
    int getType();
    /**
     * get the value of this expresssion.
     * 
     * @return java.lang.Object
     */
    Object getValue();
    /**
    * Set the type of this terminal expression.
    */
    void setType(int type);
    public void setValue(double value);
    public void setValue(ColumnName value); 
    public void setValue(String value);
    public void setValue(boolean value);
}
