/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.xmldb.xat.component.application;

import java.net.*;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.Vector;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.io.*;

//import edu.wpi.cs.dsrg.xmldb.xat.component.application.fireengine.finalGUI.DrawRoom;
//import edu.wpi.cs.dsrg.xmldb.xat.component.application.fireengine.finalGUI.FireMenuBar;
//import edu.wpi.cs.dsrg.xmldb.xat.component.application.fireengine.finalGUI.Points;
//import edu.wpi.cs.dsrg.xmldb.xat.component.application.fireengine.finalGUI.ProcessCluster;
//import edu.wpi.cs.dsrg.xmldb.xat.component.application.fireengine.finalGUI.StateInfo;
//import edu.wpi.cs.dsrg.xmldb.xat.component.application.fireengine.fire.ReadingType;
//import edu.wpi.cs.dsrg.xmldb.xat.component.application.fireengine.fire.SensorPosition;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;

import javax.swing.*;


import org.jdesktop.jdic.browser.WebBrowser;
import org.jdesktop.jdic.browser.WebBrowserEvent;
import org.jdesktop.jdic.browser.WebBrowserListener;

public class SimpleClusterApplication {

	private static String USAGE = "Usage: SimpleClusterApplication port [-o sfc]\n s- screen \n f- file";
	
	/**
	 * This is the application that will receive the answer of a query
	 * from a root operator. It can display the query result on the screen
	 * and/or put the result to a file.
	 */
	public SimpleClusterApplication() {
		super();
	}

	public static void main(String[] args) {
		
		JFrame frame = new JFrame("Cluster Application ICDE 2007 Demo - Istanbul");
		//frame.getContentPane().add(new JCanvas());
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		frame.setSize(400, 500);
		
		frame.setDefaultLookAndFeelDecorated(true);      
//		DrawRoom room = new DrawRoom();
		
//		room.setPreferredSize(new Dimension(400, 500));
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JPanel map=new JPanel();
		frame.add(map);
//		frame.add(room);
		
		map.setPreferredSize(new Dimension(0, 0));
		map.setVisible(false);
		SpringLayout layout = new SpringLayout();
		frame.setLayout(layout);
//		layout.putConstraint(SpringLayout.NORTH, room, 0, SpringLayout.NORTH, frame.getContentPane());
//		layout.putConstraint(SpringLayout.WEST, room, 0, SpringLayout.WEST, frame.getContentPane());
		
		//set up the menubar
		//System.out.println(this.getComponentCount());
		
//		FireMenuBar mb = new FireMenuBar(frame);
//		mb.setRoom(room);
//		frame.setJMenuBar(mb.createMenuBar());
		//frame.setOpaque(true);
		frame.setVisible(true);
		frame.getContentPane().add(new JCanvas());
		frame.setLocation(0, 350);
		//JPanel panel = new JPanel();
		//panel.setLayout(new BorderLayout());
		//panel.add(webBrowser, BorderLayout.CENTER);
		
		//frame.setPreferredSize(new Dimension(800, 800));
		//frame.getContentPane().add(panel, BorderLayout.CENTER);
		//frame.pack();
		//frame.setVisible(true);

		int port = -1;
		boolean toFile = false;
		boolean toScreen = false;
		boolean count = true;
		
		try {
			
			port = Integer.parseInt(args[0]);
			
			if (port <= 0 || port > 20000) {
				System.out.println(
				"Error: Please specifiy a port between 1 and 20000");
				return;
			}
			
			ServerSocket socket = new ServerSocket(port);
			
			int i = 1;
			while(true) {
				
				Socket inc = socket.accept();
				System.out.println("Now Receiving Cluster Query Results to Display");
				
//				Thread t = new ClusterDisplayHandler(inc,frame,room);
//				t.setName("ClusterDisplayHandler" + i);
//				t.setDaemon(true);
//				
//				t.start();
				i++;
				
				//if(webBrowser.isInitialized())
				//{
				//	webBrowser.executeScript("javascript:var a = document.getElementsByName(\"Cortona\").item(0).Engine.Nodes(\"TCA\").Fields('setTCTemperature')= \"1,2200\"");
				//}
			}
		} catch (IOException ioe) {
			System.out.println(
					"Could not start the Query Receiver: " + ioe.getMessage());
		}
	}
}

class ClusterDisplayHandler extends Thread {
	private Socket incoming;
	private WebBrowser webBrowser;

	private String identifier;
	private String queryName;
	private boolean toScreen;
	private boolean toFile;
	private JFrame frame;
	private JTextArea text;
	private JScrollPane pane;
	private JPanel panel;
	private boolean count;
	private int tupleCount;
//	private DrawRoom dr;
//	public ClusterDisplayHandler(Socket i, JFrame _frame, DrawRoom _dr) {
//		this.incoming = i;
//		this.frame = _frame;
//		
//		this.dr = _dr;
//	}
	
	public int getInstrumentID(String _name)
	{
		String id = new String("-1");
		if(_name.trim().indexOf("DAN") ==0){
			id =_name.replaceFirst("DAN","");
		}else if(_name.trim().indexOf("DAE") ==0)
		{
			id =_name.replaceFirst("DAE","");
		}else if(_name.trim().indexOf("DAS") ==0)
		{
			id =_name.replaceFirst("DAS","");
		}else if(_name.trim().indexOf("SC") ==0)
		{
			id =_name.replaceFirst("SC","");
		}else if(_name.trim().indexOf("DFN") ==0)
		{
			id =_name.replaceFirst("DFN", "");
		}else if(_name.trim().indexOf("DFF") ==0)
		{
			id = _name.replaceFirst("DFF","");
		}
		
		return Integer.parseInt(id);
	}

	public String getInstrumentName(String _name)
	{
		String mappedName = new String(" ");
		if(_name.trim().indexOf("DAN") ==0){
			//mappedName ="TCSLA2";
			mappedName ="S2";
		}else if(_name.trim().indexOf("DAE") ==0)
		{
			//mappedName ="TCA";
			mappedName ="S1";
		}else if(_name.trim().indexOf("DAS") ==0)
		{
			//mappedName ="TCSRA";
			mappedName ="S3";
		}else if(_name.trim().indexOf("SC") ==0)
		{
			//mappedName ="TCB";
			mappedName ="S4";
		}else if(_name.trim().indexOf("DFN") ==0)
		{
			mappedName ="S5";
			//mappedName ="TCC";
			
		}else if(_name.trim().indexOf("DFF") ==0)
		{
			mappedName ="S6";
			//mappedName = "TCD";
		}
		
		return mappedName;
	}

	public boolean isInVector(Vector _list, String _string)
	{
		boolean found = false;
		if(_list !=null)
		{
			for(int i =0; i<_list.size();i++)
			{
				if(_list.get(i).toString().compareTo(_string)==0)
				{
					found = true;
				}
			}
		}
		return found;
	}
	
	public String getSensorString(ArrayList _list)
	{
		String result = new String();
		if(_list !=null)
		{
			for(int i =0; i<_list.size();i++)
			{
				result+= _list.get(i).toString()+" ";
			}
		}
		return result;
	}
	
	public Vector getSensors(String _sensor)
	{
		Vector result = new Vector();
		String nextToken;
		 StringTokenizer st = new StringTokenizer(_sensor,",");
	     while (st.hasMoreTokens()) {
	    	 nextToken = this.getInstrumentName(st.nextToken());
	    	 if(!this.isInVector(result, nextToken))
	    		 result.add(nextToken);
	     }
	     return result;
	}
	
	public void run() {
		frame.repaint();
		
		tupleCount =0;
		// 	Listen to incoming packets and place them into the Packet Pool.
		String instrumentName;
		int instrumentID;
		float reading;
//		ProcessCluster pc = new ProcessCluster(this.dr, this.frame);
//		pc.setAttribute("circular");
        long startTime = System.currentTimeMillis();
		try {
			boolean enable = true;
			boolean haveSchema = false;
			XATTuple t;
			ObjectInputStream in =
				new ObjectInputStream(incoming.getInputStream());
			
			while(true)
			{
				//Receive the new Packets	
				try {
					Object o = in.readObject();
	
					NetworkPacket np = (NetworkPacket) o;
					Packet p = null;
					
					String clusterID = new String();
					String sensors = new String();
					Vector sensorList = new Vector();
					String level = new String();
					String line = new String();
//					StateInfo newSI;
					Vector positionNew;
					
					for (int j = 0; j < np.size(); j++) {
						
						sensorList = new Vector();
						positionNew = new Vector();
						p = np.getPacket(j);
						
						if(p.getControlMessage().equals("schema") && !haveSchema){
							System.out.println("Received The Schema: " + p.getObject().toString());
							haveSchema = true;
						}
						else if(p.getControlMessage().equals("schema")){
							//do nothing
						}
						else if (p.getControlMessage().compareTo("newquery") == 0) {
							identifier = p.getIdentifier();
							queryName = (String) p.getObject();
						}
						//Take the tuple and show the result
						else {
							
							t = (XATTuple) p.getObject();
							System.out.println(t.toString());
							
							tupleCount++;
							//line = new String();
							// First Cell is Cluster ID
							clusterID = t.getCell(0).toString();
							//line += clusterID+" ";
							// Second is the sensorList
							sensors = t.getCell(1).getValue().toString();
							sensorList = this.getSensors(sensors);
							
							if(sensorList.size() >0)
							{
								level = t.getCell(2).toString();
								
								if(level.trim().compareTo("")!=0)
								{
//									newSI = new StateInfo();
//									newSI.setClusterName("C"+j);
//									newSI.setSensorList(sensorList);
//									newSI.setLevel(level);
//									newSI.setPosition(positionNew);
//									
//									pc.states.add(newSI);
//									for (int i = 0; i < sensorList.size(); i++){
//										Points pt = new Points(0, 0);
//										String id = ((String)sensorList.get(i)).substring(1);
//										SensorPosition sp = new SensorPosition();
//										Vector temp = sp.position(id);
//										double x = Double.parseDouble(((ReadingType)temp.get(2)).getValue());
//										double y = Double.parseDouble(((ReadingType)temp.get(3)).getValue());
//										pt.setX(x);
//										pt.setY(y);
//										positionNew.add(pt);
									}
									
									//line += this.getSensorString(sensorList)+" ";
								// Level
								}
								//line += level;
								//System.out.println(line);
								//pc.setCluster(line);								
							}
					}
					if(tupleCount >0)
					{
//						pc.run();
					}
				} catch (EOFException e) {
					System.out.println("Error");
					e.printStackTrace();
					in = new ObjectInputStream(incoming.getInputStream());
				} 
			}
		}catch(StreamCorruptedException sce){
			sce.printStackTrace();
		}catch (SocketException se) {
		    System.out.println("Time: " + (System.currentTimeMillis() - startTime) + "received a total of: " +tupleCount+" tuples.");
			System.out.println(
				"Connection Failed: Cannot get stream data from "
					+ incoming.getInetAddress()
					+ ":"
					+ incoming.getPort());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}

class JCanvas extends JComponent {
	public JCanvas() {
	    setDoubleBuffered(true);
	    setOpaque(true);
	}
}
