/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.adprotocol;

import java.io.Serializable;
import java.util.ArrayList;
//import java.util.Hashtable;

/**
 * @author Bin Liu
 * Protocol Step 5: the send machine, wrap the real partitions states along with
 * partitions IDs, and send them to the receiver machine
 */
public class ReceivePartitionsInTree implements Serializable, Protocol {
	ArrayList partitionIDs;
	
	//Hashtable stores (key partition) pair. The key is the partition schema, which is the same as the schema of the input queue
	//this partition is corresponding to. Before sending out this protocol from sender, a partition group is devided
	//to partitions, and each partition is corresponding to one operator input queue. 
	//This is for ease of partition migration during load balancing, in case local migration is applied either on the sender
	//or on the receiver machine. 
	ArrayList partitions; 
	
	//ArrayList partitions;
	//String operatorID;
	
	public ReceivePartitionsInTree (ArrayList ids, ArrayList parts) {
		partitionIDs = ids;
		partitions = parts;
		//operatorID = "" + opID;
	}
	
	public ArrayList getPartitionsIDs(){
		return partitionIDs;
	}
	public ArrayList getPartitions(){
		return partitions;
	}
	
//	public String getOperatorID(){
//		return operatorID;
//	}
}
