/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATPropertiesImp;
import java.util.*;
import java.io.*;
/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Oct 27, 2003
 * 
 * Insert comments here.
 */
public class Stream extends XATPropertiesImp implements Serializable{


	private Server server;
	/**
	 * 
	 */
	public Stream() {
		super();
		setDefaultProperties();
		server = new Server();
	}

	protected void setDefaultProperties(){
		super.setDefaultProperties();
		addProperty("name","none");
		addProperty("server","none");
	}
	
	public void setName(String name){
		try{
			this.setProperty("name", name);
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void setServer(Server server){
		this.server = server;
	}
	
	public String getName(){
		return this.getProperty("name");
	}
	
	public Server getServer(){
		return this.server;
	}
	
	public String toString(){
			String ret = new String();
		
			ret+= "Stream: " + this.getName() + "\n";
			ret+= "\t Properties: \t\t\t\t";
			Enumeration e = this.getProperties();
			while(e.hasMoreElements()){
				String name = (String) e.nextElement();
				String prop = this.getProperty(name);
				ret+= name + "=" + prop + ", ";
			}
			ret+="\n";
			ret+= "\t" +server.toString();
			return ret;
		
		}
}
