/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.migrationcontroller;

//import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.QueryPlan;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.manager.DistributionManager;

/**
 * @author Yali Zhu
 * 
 * This is a distributed version of the migration controller.
 * It controls the migration of a query plan in a distributed environment.
 * In particular, it confirms to migration protocols and hand-shakes among DM and machines
 * to guarantee a correct migration process.
 */
public class DistributedMigrationController {
	
	DistributionManager distManager;
	
	
	public DistributedMigrationController(DistributionManager dm) {
		distManager = dm;
		//optimizer = new DistributedOptimizer();
	}

	public void MigratePlan(SubPlan subplan) {

		
		// redistribute the new subplan, update distribution table and keep the delta change. 
		
		/** step 1: synchronize execution among machines;
	        wait until received sync back from root operator */
		
		/** step 2: send new subplan to all machines	
		            wait until all plans been changed locally on each machine */
		
		/** step 3: moving states */
		
		/** step 4: recompute states */
		
		/** step 5: reconnet operators and queues across machines, recompute operator and state semantics */
		
		// update distribution table
		
		/** step 6: send message to each machine to resume execution */
		// each machine should update scheduler, statstable and lightweightstats table.
		
	}
}
