/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.migrationcontroller;

import java.util.ArrayList;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;

/**
 * @author Yali Zhu
 * 
 * Insert comments here.
 */
public class MigrationKeeper {
	
	// for subplan migration
	ArrayList leafOperators = new ArrayList();
	ArrayList activeLeafOperators = new ArrayList();
	ArrayList oldSubplanOperators = new ArrayList();
	XATStreamOperator oldSubplanRootOperator = null;
	ArrayList oldstates = new ArrayList();
	SubPlan subplan = new SubPlan();
	ArrayList statesToFill = new ArrayList();
	
	public MigrationKeeper() {
		
	}

	public void setLeafOperators(ArrayList leafops) {
		this.leafOperators = leafops;
	}
	
	public ArrayList getLeafOperators() {
		return this.leafOperators;
	}
	
	public void setActiveLeafOperators(ArrayList activeleafops) {
		this.activeLeafOperators = activeleafops;
	}
	
	public ArrayList getActiveLeafOperators() {
		return this.activeLeafOperators;
	}
	
	public void setOldSubplanOperators(ArrayList oldops) {
		this.oldSubplanOperators = oldops;
	}
	
	public ArrayList getOldSubplanOperators() {
		return this.oldSubplanOperators;
	}
	
	public void setOldSubplanRootOperator(XATStreamOperator oldrootop) {
		this.oldSubplanRootOperator = oldrootop;
	}
	
	public XATStreamOperator getOldSubplanRootOperator() {
		return this.oldSubplanRootOperator;
	}
	
	public void setOldStates(ArrayList oldstates) {
		this.oldstates = oldstates;
	}
	
	public ArrayList getOldStates() {
		return this.oldstates;
	}
	
	public void setSubPlan(SubPlan subplan) {
		this.subplan = subplan;
	}
	
	public SubPlan getSubPlan() {
		return this.subplan;
	}
	
	public void setStatesToFill(ArrayList statesTofill) {
		this.statesToFill = statesTofill;
	}
	
	public ArrayList getStatesToFill() {
		return this.statesToFill;
	}
}
