/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.migrationcontroller;

import java.util.ArrayList;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.Machine;

/**
 * @author Yali Zhu
 * creation time: Apr 23, 2006 5:03:15 PM
 */

public class NodePairToSwitch {
    XATNode parentNode;
    XATNode childNode;
    Machine parentNodeOldMachine;
    Machine childNodeOldMachine;
    ArrayList ids;
    boolean isLeftChild;
    
    public NodePairToSwitch(XATNode high, XATNode low, Machine parentmachine, Machine childmachine) {
        parentNode = high;
        childNode = low;
        parentNodeOldMachine = parentmachine;
        childNodeOldMachine = childmachine;
        ids = new ArrayList(2);
        ids.add(new Integer(parentNode.getStreamOperator().getObjectID()));
        ids.add(new Integer(parentNode.getStreamOperator().getObjectID()));
    }
    
    public void setIsLeftChild(boolean lc) {
        this.isLeftChild = lc;
    }
    
    public boolean getIsLeftChild() {
        return this.isLeftChild;
    }
    
    public XATNode getParentNode() {
        return this.parentNode;
    }
    
    public XATNode getChildNode() {
        return this.childNode;
    }
    
    public Machine getParentOldMachine() {
        return this.parentNodeOldMachine;
    }
    
    public Machine getChildOldMachine() {
        return this.childNodeOldMachine;
    }
    
    public int getParentOperatorID() {
        if (ids == null) {
            ids = new ArrayList(2);
            ids.add(new Integer(parentNode.getStreamOperator().getObjectID()));
            ids.add(new Integer(parentNode.getStreamOperator().getObjectID()));
        }
        return ((Integer)ids.get(0)).intValue();      
    }
    
    public int getChildOperatorID() {
        if (ids == null) {
            ids = new ArrayList(2);
            ids.add(new Integer(parentNode.getStreamOperator().getObjectID()));
            ids.add(new Integer(parentNode.getStreamOperator().getObjectID()));
        }
        return ((Integer)ids.get(1)).intValue();      
    }
    
    
    public ArrayList getOperatorIDs() {
        if (ids == null) {
            ids = new ArrayList(2);
            ids.add(new Integer(parentNode.getStreamOperator().getObjectID()));
            ids.add(new Integer(parentNode.getStreamOperator().getObjectID()));
        }
        return ids;       
    }
}
