/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet;
import java.io.Serializable;
/**
 * @author 
 * This class encapsulates the stream name and the 
 * tuple the stream name is used as the identifier
 */
public class Packet implements Serializable{
	/**Stores the reference to the control message*/
	private String controlMessage = null;

	/**Stores the reference to the stream name*/	
	private String identifier = null;
	/**Stores the reference to the tuple*/
	private Object o = null;
	public Packet(String controlMessage)
	{
		if(controlMessage == null)
		 throw new IllegalArgumentException();
		 
		this.controlMessage = controlMessage;
	}
	
	/**
	 * Constructs a new Packet
	 */
	public Packet(String identifier,Object o)
	{		
		if(identifier == null || o == null)
		 	throw new IllegalArgumentException();
		this.identifier = identifier;
		this.o = o;
	}
	
	public Packet(String identifier,Object o,String message)
	{
		if( identifier == null)
			throw new IllegalArgumentException("PACKET: The identifier is null.");
		if(o == null) {
			System.out.println("Identifier:" + identifier + "Mesage:" + message);
			throw new IllegalArgumentException("PACKET: The object is null.");
		}
		if(message == null)
			throw new IllegalArgumentException("PACKET: The message is null.");
			
			this.identifier = identifier;
			this.o = o;
			this.controlMessage = message;
	}
	
	public Packet(String name,String message)
	{
		this.identifier = name;
		this.controlMessage = message;
	}
	/**
	 * Gets the control message.
	 * 
	 * @return The control message
	 */
	public String getControlMessage() {
		return controlMessage;
	}
	
	/**
	 * Gets the packet identifier.
	 * 
	 * @return The packet identifeir
	 */
	public String getIdentifier()
	{
		return(this.identifier);
	}

	public void setIdentifier(String id){
		this.identifier = id;
	}
	/**
	 * 
	 * Gets the object from the packet.
	 * 
	 * @return
	 */
	public Object getObject()
	{
		return(o);
	}
	
	/**
	 * Returns the Packet as a string.
	 */
	public String toString(){
		String ret = new String();
		ret += this.getIdentifier() + " ";
		ret += this.getObject().toString() + " ";
		ret += this.getControlMessage() + "\n";
		return ret;
	}

}
