/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.pattern;

import java.util.ArrayList;

import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.Machine;
//import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.migrationcontroller.SubPlan;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Feb 17, 2004
 * 
 * Insert comments here.
 */
public interface ConnectionManager {

/**
 * Connects the Query Plans to the machines based on the distribution table.
 * 
 * @return true if successful.
 * 
 */
public boolean connect();

public boolean connectPartitions();

public void propagatePartitionMaps(Machine[] ms);
/**
 * 
 * @param newTable -The new  distribution table that we will use
 * @return
 */
public boolean reconnect(DistributionTable newTable);

/**
 * Used for distributed migration
 * Added by Yali Zhu @Aug. 24, 2005.
 * @param subplan
 * @return
 */
public boolean connectSubPlan(ArrayList subplanoperators);

}
