/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
/*
 * Created on Sep 26, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.pattern;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.Machine;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.QueryPlan;

/**
 * @author jbantova
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class RoundRobinInStepOfTwoDistribution extends DesignPattern {
	public RoundRobinInStepOfTwoDistribution(Machine[] m, QueryPlan[] qp){
		super(m,qp); 
	}
   
	public DistributionTable distribute(){
		System.out.println("Distribution Query Plan");
		 DistributionTable table=new DistributionTable();
		 try{
		 	int machineNum=0;
		 	int machineSize=machines.length;
		 	if(machineSize==1){
		 		for(int i=0; i<this.queryPlans.length;i++){
		 			XATNode[] nodes=queryPlans[i].getQueryPlan().convertToArray();
		 			for(int j=0;j<nodes.length;j++){
		 				table.add(nodes[j],this.machines[0]);
		 			}
		 		}
		 	}
		 	
		 	for(int i=0;i<this.queryPlans.length;i++ ){
		 		XATNode[] nodes=queryPlans[i].getQueryPlan().convertToArray();
		 		for(int j=0;j<nodes.length;j++){
		 			table.add(nodes[j],this.machines[machineNum]);
		 			if(j%2==1){
		 				machineNum++;
		 			}
		 			if(machineNum>=machineSize){
		 				machineNum=0;
		 			}
		 		}
		 	}
		 		 	
		 }catch (Exception e){
		 	e.printStackTrace();
		 }
		  System.out.println("Here is what I have:");
		  System.out.println(table);
		  return table;
		}
}
