/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.spreadfire.protocol;

import java.io.Serializable;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.spreadfire.ReplicatedStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.adprotocol.Protocol;

/**
 * @author bmombe1
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DeactivateEmptyStateOperator implements ReplicationStyleProtocol, Serializable {

	int _operator;
	String _machine;
	
	public DeactivateEmptyStateOperator(ReplicatedStreamOperator op, String machineName)
	{
		//assume first state is the one to be moved.
		this._operator = op.getOperatorID();
		this._machine = machineName;
	}

	public DeactivateEmptyStateOperator(int opID, String machineName)
	{
		//assume first state is the one to be moved.
		this._operator = opID;
		this._machine = machineName;
	}
	
	public int getOperatorID()
	{
		return this._operator;
	}
	
	public String getMachineName()
	{
		return this._machine;
	}
	
	public void setOperator(XATStreamOperator op)
	{
		this._operator = op.getOperatorID();
		return;
	}

	public void setOperator(int opID)
	{
		this._operator = opID;
		return;
	}
	
	public void setMachineName(String machineName)
	{
		this._machine = machineName;
	}
}
