/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.spreadfire.protocol;


import java.io.Serializable;
//import java.util.ArrayList;

public class PassStorageToken implements ReplicationStyleProtocol, Serializable {
	
	private String _operatorID;
	private int _stateNumber;
	private String _machineID;

	/** Optional constructor for when the operator specified by ID has only one
	 * element
	 * @param operatorID
	 * @param machineID
	 */ 
	public PassStorageToken(int operatorID, String machineID) {
		_operatorID = "" + operatorID;
		_stateNumber = 0;
		_machineID = machineID;
	}
	
	/** Primary constructor
	 * 
	 * @param operatorID
	 * @param stateNumber
	 * @param machineID
	 */
	public PassStorageToken(int operatorID, int stateNumber, String machineID) {
		_operatorID = "" + operatorID;
		_stateNumber = stateNumber;
		_machineID = machineID;
	}
	
	public String getOperatorID() {
		return _operatorID;
	}
	
	public int getStateNumber() {
		return _stateNumber;
	}
	
	public String getTargetMachineID() {
		return _machineID;
	}
	
}