/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.executioncontroller;

import java.util.ArrayList;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObjectImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.ConnectionListener;
//import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.manager.DistributionManager;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet.TupleDistributor;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet.TupleFeeder;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet.TupleReceiver;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet.TupleSender;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.statisticsgatherer.StatisticsPrinter;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Mar 22, 2004
 * 
 * Basic Execution Controller. This class actually doesnt do anything but encapsulate the
 * specific execution controllers that we use.
 * 
 */
public abstract class ExecutionController extends XATQueryObjectImp implements Runnable {

	/**
	 * Returns the current scheduling algorithm in use.
	 * @return
	 */
	public abstract edu.wpi.cs.dsrg.xmldb.xat.component.scheduler.XATScheduler getCurrentScheduler();
	
	
	public abstract StatisticsPrinter getPrinter();
	public abstract void setLightweightStats(ArrayList stats);
	public abstract TupleReceiver getTupleReceiver();
	public abstract ConnectionListener getConnectionListener();
	public abstract TupleFeeder getTupleFeeder();
	public abstract TupleDistributor getTupleDistributor();
	public abstract TupleSender getTupleSender();
	public abstract CAPE_GUI getGUI();
	public abstract edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree[] getTree();
	public abstract void run();
	public abstract String toString();
	
	
}
