/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.gui.listeners;

//import java.awt.CardLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
//import java.util.ArrayList;
//import java.util.Calendar;

//import javax.swing.JButton;
//import javax.swing.JLabel;
//import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
//import javax.swing.JTextField;
//import javax.swing.JViewport;
//import java.awt.Color;

import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;
//import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTreeImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.CAPE_GUI;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;

/** 
 * 
 */
public class UpdateCurrentInfoListener implements ActionListener{
	
	/** The CAPE_GUI */
	private CAPE_GUI gui;
	/** the tab/panel that this listener is for **/
	private JPanel panel;
	/** this is for the purposes of the example **/
	private int counter = 0;
	
	private	boolean[] previousstate;
	
	/** Constructor associates the given gui and panel with this listener. */
	public UpdateCurrentInfoListener(CAPE_GUI gui, JPanel panel){
		this.gui = gui;
		this.panel = panel;
	}
		
	public void actionPerformed(ActionEvent evt){
		
		if (panel.getName() == "Operators") {
			/*--------- insert content updates here --------------------*/
			/* Example: */
			counter++;
			
			/* added by Luping. */
			JScrollPane opStatusPane = (JScrollPane)panel.getComponent(0);
			JTextArea opStatusText = (JTextArea)opStatusPane.getViewport().getView();
			XATTree currentTree = gui.getXATTree(0);
			String opActivity = currentTree.getOperatorActivity();
			if (opActivity.length()>0) {
				//textArea.setText("<html>"+opActivity+"</html>");
				opStatusText.append(opActivity);
			}
			currentTree.clearOperatorActivity();
			
			/* commented by Luping. */
			//JLabel label = (JLabel)panel.getComponent(0);
			//JButton button = (JButton)panel.getComponent(1);
			//JList list = (JList)panel.getComponent(2);
			//label.setText("Label " + counter); // change the string in the label
			//button.setText("Button " + counter); // change the button's text value
			//list.setSelectedIndex(counter%5); // change the selected option
			
			/*--------- do not change anything below this line ---------*/
			for (int i = 0; i < panel.getComponentCount(); i++) {
				panel.getComponent(i).repaint();
			}			
			panel.repaint();
		}
		/* commented by Bin for VLDB05-Demo
		else if (panel.getName() == "Scheduler Adaptation") {
			JLabel schedCounter = (JLabel)panel.getComponent(0);
			JList schedList = (JList)panel.getComponent(1);
			
			XATTree currentTree = gui.getXATTree(0);
			
			ArrayList schedulerList = currentTree.getAvailableSchedulerCategories();
			String[] schedulers = new String[schedulerList.size()];
		
			for(int x=0; x<schedulerList.size(); x++) {
				schedulers[x] = (String)schedulerList.get(x);
			}	
			
			schedList.setListData(schedulers);
			//JList sched = new JList(schedulers);
			schedList.setVisibleRowCount(schedulers.length);
			schedList.setSelectedValue(currentTree.getCurrentScheduler(), true);
			schedList.setFocusable(true);
			schedList.setForeground(Color.GRAY);
			schedCounter.setText("Counter: " + Integer.toString(currentTree.getSchedulerChangedCounter()));
			//schedCounter.setForeground(Color.BLUE);
			
			for (int i = 0; i < panel.getComponentCount(); i++) {
				panel.getComponent(i).repaint();
			}			
			panel.repaint();
			
		} */
		 else if (panel.getName() == "Plan Migration") {
			/*--------- insert content updates here --------------------*/
			//JLabel schedLabel = (JLabel)panel.getComponent(2);
//			JLabel migCounter = (JLabel)panel.getComponent(0);
			JScrollPane optStatusPane = (JScrollPane)panel.getComponent(0);
			JTextArea migText = (JTextArea)optStatusPane.getViewport().getView();

			XATTree currentTree = gui.getXATTree(0);
//			migCounter.setText("Counter: " + Integer.toString(currentTree.getOptimizedCounter()));
			//migCounter.setForeground(Color.BLUE);
			String treeMigration = currentTree.getMigrationActivity();
			
			if (treeMigration.length()>0) {
				//migText.append("Migration Activity\n\n");
				migText.append(treeMigration);
			}
			currentTree.clearMigrationActivity();
			
			//schedList.setSelectedIndex(0); // the selected options, such as current scheduler
			
			//JList sched = (JList)panel.getComponent(2);
//			if(currentTree.isSchedulerChanged()) {
//				schedLabel.setBackground(Color.red);
//				
//				currentTree.setSchedulerChanged(false);
//			} else {
//				schedLabel.setBackground(Color.black);
//			}
//			
//			
//			
//			if(currentTree.isOptimized()) {
//				migLabel.setBackground(Color.red);
//				currentTree.setOptimized(false);
//			} else {
//				migLabel.setBackground(Color.black);
//			}
			
			/*--------- do not change anything below this line ---------*/
			for (int i = 0; i < panel.getComponentCount(); i++) {
				panel.getComponent(i).repaint();
			}
			panel.repaint();
		} else if (panel.getName() == "Distribution") {
			/*--------- insert content updates here --------------------*/
			int treecount = gui.getXATTreeCount();
			XATNode [] allnodes = {}; 
			int k;
			for (k = 0; k < treecount; k++)
			{
				int j, L;
				XATTree tree = gui.getXATTree(k);
				//redimension allnodes
				XATNode[] tempnodes = allnodes;
				allnodes = new XATNode[tempnodes.length + tree.convertToArray().length];
				for (L=0; L < tempnodes.length; L++)
				{
					allnodes[L] = tempnodes[L];
				}
				XATNode[] newnodes = tree.convertToArray();
				for (j=0; j<newnodes.length; j++, L++)
				{
					allnodes[L] = newnodes[j];
				}
			}
			
			boolean[] currentstate = new boolean[allnodes.length];
			
			for (k=0; k < allnodes.length; k++)
			{
				currentstate[Integer.parseInt(((XATStreamOperator)allnodes[k].getOperator()).getProperty("OBJECT_ID")) - 1] = ((XATStreamOperator)allnodes[k].getOperator()).isActive();
			}
			
			if (previousstate != null)
			{
				boolean deep_equal = true;
				for (k = 0; k < currentstate.length; k++)
				{
					if(currentstate[k] != previousstate[k])
					{
						deep_equal = false;
					}
				}
				
				if(!deep_equal)
				{
					/*
					JLabel thejlabel = null;
					JScrollPane thescrollpane = null;
					for(int j = 0; j < panel.getComponentCount(); j++)
					{
						if (panel.getComponent(j) instanceof JScrollPane)
							thescrollpane = (JScrollPane)panel.getComponent(j);
					}
					if (thescrollpane == null)
					{
						System.err.println ("Cant find the JScrollPane where you're pointing.  I'll crash now.");
					}

					for(int j = 0; j < thescrollpane.getViewport().getComponentCount(); j++)
					{
						if (thescrollpane.getViewport().getComponent(0) instanceof JLabel)
							thejlabel = (JLabel)thescrollpane.getViewport().getComponent(j);
					}
					if (thejlabel == null)
					{
						System.err.println ("Cant find the JLabel where you're pointing.  I'll crash now.");
					}
				
					Calendar currenttime = Calendar.getInstance();
					thejlabel.setText(thejlabel.getText() + "At time " + currenttime.get(Calendar.HOUR) 
							+ ":" + (currenttime.get(Calendar.MINUTE) < 10 ? "0" : "") 
							+ currenttime.get(Calendar.MINUTE) 
							+ ":" + (currenttime.get(Calendar.SECOND) < 10 ? "0" : "")
							+ currenttime.get(Calendar.SECOND) + "\n<UL>\n");
					*/
					
					JScrollPane distStatusPane = (JScrollPane)panel.getComponent(0);
					JTextArea distText = (JTextArea)distStatusPane.getViewport().getView();

					for(k = 0; k < currentstate.length; k++)
					{
						if(currentstate[k] != previousstate[k])
						{
							if (currentstate[k]) 
								//thejlabel.setText(thejlabel.getText() + "<LI>Operator " + (k + 1) + " activated</LI>\n");
								distText.append("Operator " + (k + 1) + " activated\n");
							else
								//thejlabel.setText(thejlabel.getText() + "<LI>Operator " + (k + 1) + " deactivated</LI>\n");
								distText.append("Operator " + (k + 1) + " deactivated\n");
						}
					}
					//thejlabel.setText(thejlabel.getText() + "</UL><BR><BR>\n");
					distText.append("\n");
				
					previousstate = (boolean[])currentstate.clone();
				}
			} else {
/*				boolean allinactive = true;
				for(k = 0; k < currentstate.length; k++ )
				{
					if (currentstate[k] == true)
					{
						allinactive = false;
					}
				}
				if (!allinactive) */
				previousstate = (boolean[])currentstate.clone();
			} 

			/*--------- do not change anything below this line ---------*/
			for (int i = 0; i < panel.getComponentCount(); i++) {
				panel.getComponent(i).repaint();
			}
			panel.repaint();
		} 		
		else if (panel.getName() == "Query Result") {
			counter++;
			
			JScrollPane resultDisplayPane = (JScrollPane)panel.getComponent(0);
			JTextArea resultDisplayText = (JTextArea)resultDisplayPane.getViewport().getView();
			XATQueue finalQueue = ((XATStreamOperator)gui.getXATTree(0).getRoot().getOperator()).getOutputQueue();
			String currentResult = finalQueue.getCurrentResult();
			if (currentResult.length()>0) {
				//textArea.setText("<html>"+opActivity+"</html>");
				resultDisplayText.append(currentResult);
			}
			finalQueue.clearCurrentResult();
			
			for (int i = 0; i < panel.getComponentCount(); i++) {
				panel.getComponent(i).repaint();
			}			
			panel.repaint();
		}

	}
}