/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.gui.listeners;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JScrollPane;

import edu.wpi.cs.dsrg.xmldb.xat.component.gui.CAPE_GUI;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.utils.CAPETab;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.utils.JTabbedPaneCAPE;

/** The listener that updates all of the open statistic table(s) every
 * <code>UPDATE_STATISTICS_MILLISECONDS</code>. */
public class UpdateStatisticTableListener implements ActionListener{
	
	/** The <code>CAPE_GUI</code>. */
	private CAPE_GUI _gui;
	
	/** Constructor associates the given <code>gui</code> with this listener. */
	public UpdateStatisticTableListener(CAPE_GUI gui){
		_gui = gui;
	}
	
	/** Handles the action event. */
	public void actionPerformed(ActionEvent evt){
		try{
			JTabbedPaneCAPE tp = _gui.getGraphManager().getStatsTabbedPane();
			
			//for each tab (or statistic table)
			for(int i=1; i<tp.getTabCount(); i++){
				JScrollPane tablePane = _gui.getTableMaker().makeTable(((CAPETab)tp.getIconAt(i)).getXATQueryObject());
				tp.setComponentAt(i, tablePane);
			}
		}catch(Exception e){System.err.println("UpdateStatisticTableListener: Error handing action event.");}
	}
}