/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
//--------------------------------------------------
// CommonSettings.java
//  
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2009
//--------------------------------------------------

package edu.wpi.cs.dsrg.xmldb.xat.component.gui.security;

import java.awt.Color;

public interface CommonSettings
{	
	//-----------------------------------------------------------------------------
	
	public int MAX_COLOR					=	8;
	public int TOP_PANEL_START_POS			=	10;
	
	//-----------------------------------------------------------------------------
	
	public int DEFAULT_ICON_WIDTH			=	30;
	public int DEFAULT_ICON_HEIGHT			=	30;

	//-----------------------------------------------------------------------------
	
	public int DEFAULT_STREAM_ICON_WIDTH	=	50;
	public int DEFAULT_STREAM_ICON_HEIGHT   =	30;
	
	//-----------------------------------------------------------------------------
	
	public int TAPPANEL_WIDTH				= 	225;
	public int TAPPANEL_HEIGHT				= 	350;
	public int TAPPANEL_CANVAS_WIDTH		= 	180;
	public int TAPPANEL_CANVAS_HEIGHT		= 	480;
	public int TAP_COUNT					=	3;
	
	//-----------------------------------------------------------------------------
	
	public int IMAGE_CANVAS_START_POSITION	=	10;
	
	public String ICON_NAME					=	"PHOTO";
	public int DEFAULT_IMAGE_CANVAS_SPACE	=	35;
	public int DEFAULT_LIST_CANVAS_POSITION	=	0;
	public int DEFAULT_LIST_CANVAS_INCREMENT=	20;
	public int DEFAULT_LIST_CANVAS_HEIGHT	=	15;
	
	//-----------------------------------------------------------------------------
	
	public int SCROLL_BAR_SIZE				= 	15;
	public int STREAM_CANVAS					=	0;
	public int CP_QUERY_CANVAS					=	1;
	public int USER_CANVAS_NORMAL_ICON		= 	11;
	public int USER_CANVAS_IGNORE_ICON		= 	10;
	
	//-----------------------------------------------------------------------------
	
	public int ROOM_CANVAS_ICON				= 	13;
	public int DEFAULT_MESSAGE_CANVAS_POSITION =	25;
	public int DEFAULT_SCROLLING_HEIGHT		=	20;
	
	//-----------------------------------------------------------------------------
	
	public int MESSAGE_TYPE_DEFAULT				= 	0;
	public int MESSAGE_TYPE_JOIN				= 	1;
	public int MESSAGE_TYPE_LEAVE				= 	2;
	public int MESSAGE_TYPE_ADMIN				= 	3;
	
	//-----------------------------------------------------------------------------
	public int MESSAGE_STREAM_SPECIFIED	 	    = 	10;
	public int MESSAGE_SP_POLICY_SPECIFIED	    = 	11;
	
	//-----------------------------------------------------------------------------
	
	public int QUIT_TYPE_DEFAULT				=	0;
	public int QUIT_TYPE_KICK					=	1;
	public int QUIT_TYPE_NULL					=	2;
	
	//-----------------------------------------------------------------------------
	
	public int EMOTION_CANVAS_WIDTH				=	400;
	public int EMOTION_CANVAS_HEIGHT			=	270;
	
	//-----------------------------------------------------------------------------
	
	public int MAX_PRIVATE_WINDOW				=	40;
	public String PRODUCT_NAME					= "StreamShield 1.0";
	public String COMPANY_NAME					= "Purdue University and Worcester Polytechnic Institute";
	
	//-----------------------------------------------------------------------------
	
	public String STREAMSHIELD_USER_NAME        = "STREAMSHIELD_USER";
	public String COMMAND_PREFIX        		= "COMMAND_";
	
	//-----------------------------------------------------------------------------
	
	/*********Emoti-Sp Names*************/
	int MAX_EMOTI_SPS = 21;
	String [] EMOTI_SP_NAMES = new String[MAX_EMOTI_SPS];
	
	//-----------------------------------------------------------------------------

}