/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.xmldb.xat.component.gui.security;

import java.awt.Container;
import java.awt.Cursor;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.LayoutManager;
import java.awt.Panel;
import java.awt.Label;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Window;
import java.awt.TextField;
import java.awt.TextArea;
import java.awt.Frame;
import java.awt.Button;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Font;
import java.awt.CardLayout;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.MediaTracker;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.net.Socket;
import java.util.StringTokenizer;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.Serializable;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.DataOutputStream;
import java.net.URL;
import java.net.Socket;
import java.awt.Toolkit;
import java.awt.MenuBar;
import java.awt.Menu;
import java.awt.MenuItem;
import java.awt.MenuShortcut;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import edu.wpi.cs.dsrg.xmldb.xat.component.gui.CAPE_GUI;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JPanel;

//-----------------------------------------------------------------------------

public class DeviceStreamShieldMainForm extends JPanel implements ActionListener
{	
	
	//-----------------------------------------------------------------------------
	private int SECURITY_PREFERENCE_UNRESTRICTED = 0;
	private int SECURITY_PREFERENCE_FAMILY_ONLY = 1;
	private int SECURITY_PREFERENCE_HIDE_ME = 2;
	
	private int ACTIVE_SECURITY_PREFERENCE = -1; //0 = Unrestricted, 1 = FamilyOnly, 2 = HideMe
	
	private Image img;
	
	JTextField instructions;
	JTextArea instructionsSecurityPunctuationSyntax;
	
    JButton btnUnrestricted;
    JButton btnFamilyOnly;
    JButton btnHideMe;
	
    JButton btnSubmit;
    JButton btnHelp;

    String NEWLINE = System.getProperty("line.separator");	 
    
    String spInsertSyntax = "INSERT SP [sp name] " + NEWLINE + 
	"INTO STREAM [stream name|stream id ] " + NEWLINE + 
	"LET " + NEWLINE +
    "  [sp name.]DDP = <ddp expr> AND " + NEWLINE + 
    "  [sp name.]SRP = <srp expr> AND " + NEWLINE +
    "  [[sp name.]SIGN = { + | - },] AND " + NEWLINE +
    "  [[sp name.]IMMUTABLE = {true|false}]";
    

    String spInsertSyntaxUnrestricted = "INSERT SP UnrestrictedSp " + NEWLINE + 
	"INTO STREAM LocationStream " + NEWLINE + 
	"LET " + NEWLINE +
    "  UnrestrictedSp.DDP = '*' AND " + NEWLINE + 
    "  UnrestrictedSp.SRP = '*' AND " + NEWLINE +
    "  UnrestrictedSp.SIGN = '+' AND " + NEWLINE +
    "  UnrestrictedSp.IMMUTABLE = false;";
    
    
    String spInsertSyntaxFamily = "INSERT SP RestrictToFamilySp " + NEWLINE + 
	"INTO STREAM LocationStream " + NEWLINE + 
	"LET " + NEWLINE +
    "  RestrictToFamilySp.DDP = '*' AND " + NEWLINE + 
    "  RestrictToFamilySp.SRP = " + NEWLINE + 
    "                'Family Member' AND " + NEWLINE +
    "  RestrictToFamilySp.SIGN = '+' AND " + NEWLINE +
    "  RestrictToFamilySp.IMMUTABLE = true;";
    
    String spInsertSyntaxHideMe = "INSERT SP HideMeSp " + NEWLINE + 
	"INTO STREAM LocationStream " + NEWLINE + 
	"LET " + NEWLINE +
    "  HideMeSp.DDP = '*' AND " + NEWLINE + 
    "  HideMeSp.SRP = '*' AND " + NEWLINE +
    "  HideMeSp.SIGN = '-' AND " + NEWLINE +
    "  HideMeSp.IMMUTABLE = true;";
    
    //-----------------------------------------------------------------------------
    
    public DeviceStreamShieldMainForm()
    {
    	this(new ImageIcon("C:\\Users\\Rimma\\workspace\\Raindrop\\edu\\wpi\\cs\\dsrg\\xmldb\\xat\\component\\gui\\security\\SmartPhoneBackground.png").getImage());
    }
    
    //-----------------------------------------------------------------------------
    
	public DeviceStreamShieldMainForm(String img) 
	{	
		this(new ImageIcon(img).getImage());
	}
	  
	//-----------------------------------------------------------------------------

	public DeviceStreamShieldMainForm(Image img) 
	{	
		JPanel jplPanel = new JPanel();
		jplPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 10, 30));
				
		this.img = img;
		Dimension size = new Dimension(img.getWidth(null), img.getHeight(null));
		setPreferredSize(size);
		setMinimumSize(size);
		setMaximumSize(size);
		setSize(size);
		
		this.setLayout(null);		

		instructions = new JTextField("      WHAT IS YOUR SECURITY PREFERENCE?");
	    instructions.setFont(new Font("SansSerif", Font.BOLD, 15));
	    instructions.setForeground(Color.white);
	    instructions.setSize(358,30);
	    instructions.setLocation(52,83);
	    instructions.setBackground(Color.black);
	    instructions.setEditable(false);	       
	    	    	    	    
	    instructionsSecurityPunctuationSyntax = new JTextArea("");
	    instructionsSecurityPunctuationSyntax.setFont(new Font("Courier New", Font.BOLD, 15));
	    instructionsSecurityPunctuationSyntax.setSize(345,285);
	    instructionsSecurityPunctuationSyntax.setLocation(60,173); //52, 163
	    instructionsSecurityPunctuationSyntax.setBackground(Color.white);
	    instructionsSecurityPunctuationSyntax.setEditable(true);
	    instructionsSecurityPunctuationSyntax.setLineWrap (true);
	    
	   	//security punctuation buttons	    
	    btnUnrestricted = new JButton("Unrestricted");
	    btnUnrestricted.setFont(new Font("SansSerif", Font.BOLD, 12));
	    btnUnrestricted.setSize(119,50);
	    btnUnrestricted.setLocation(52,113);
	    btnUnrestricted.setBackground(Color.green);	  
	    btnUnrestricted.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
	    
	    btnFamilyOnly = new JButton("Family Only");
	    btnFamilyOnly.setFont(new Font("SansSerif", Font.BOLD, 12));
	    btnFamilyOnly.setSize(119,50);
	    btnFamilyOnly.setLocation(170,113);
	    btnFamilyOnly.setBackground(Color.orange);
	    btnFamilyOnly.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
	    
	    btnHideMe = new JButton("Hide Me");
	    btnHideMe.setFont(new Font("SansSerif", Font.BOLD, 12));
	    btnHideMe.setSize(119,50);
	    btnHideMe.setLocation(289,113);
	    btnHideMe.setBackground(Color.red);
	    btnHideMe.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
	    
	    btnSubmit = new JButton("SUBMIT");
	    btnSubmit.setFont(new Font("SansSerif", Font.BOLD, 12));
	    btnSubmit.setSize(84,75);
	    btnSubmit.setLocation(189,576);
	    btnSubmit.setBackground(Color.lightGray);
	    btnSubmit.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
	    	    
	    btnHelp = new JButton("?");
	    btnHelp.setFont(new Font("SansSerif", Font.BOLD, 9));
	    btnHelp.setSize(40,40);
	    btnHelp.setLocation(380,618);
	    btnHelp.setBackground(Color.lightGray);
	    btnHelp.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
	    
	    btnUnrestricted.addActionListener(this);
	    btnFamilyOnly.addActionListener(this);
	    btnHideMe.addActionListener(this);
	    btnSubmit.addActionListener(this);
	    btnHelp.addActionListener(this);
	    
		this.add(instructionsSecurityPunctuationSyntax);
		this.add(btnUnrestricted);
		this.add(btnFamilyOnly);
		this.add(btnHideMe);
		this.add(btnSubmit);
		this.add(btnHelp);
		
		this.add(instructions);

	}

	//-----------------------------------------------------------------------------
	
	public void actionPerformed(ActionEvent event)
	{
		String actioncommand = event.getActionCommand();
		
		if (actioncommand.compareTo("Exit") == 0)
		{
			System.exit(0);
		}		
		else if(event.getSource() == btnUnrestricted)
		{
		    String Reply = spInsertSyntaxUnrestricted;
		    instructionsSecurityPunctuationSyntax.setText (Reply);		    
			ACTIVE_SECURITY_PREFERENCE = SECURITY_PREFERENCE_UNRESTRICTED;
		}
		else if(event.getSource() == btnFamilyOnly)
		{
		    String Reply = spInsertSyntaxFamily;
		    instructionsSecurityPunctuationSyntax.setText (Reply);
		    ACTIVE_SECURITY_PREFERENCE = SECURITY_PREFERENCE_FAMILY_ONLY;
		}
		else if(event.getSource() == btnHideMe)
		{
		    String Reply = spInsertSyntaxHideMe;
		    instructionsSecurityPunctuationSyntax.setText (Reply);
		    ACTIVE_SECURITY_PREFERENCE = SECURITY_PREFERENCE_HIDE_ME;
		}
		else if (event.getSource() == btnHelp)
		{
			String Reply = this.spInsertSyntax;
			instructionsSecurityPunctuationSyntax.setText (Reply);
		}
		else if (event.getSource() == btnSubmit)
		{
			String spContent = "";
			String confirmationMessage = "";
			
			if (ACTIVE_SECURITY_PREFERENCE == SECURITY_PREFERENCE_HIDE_ME)
			{
				confirmationMessage = "Please confirm your security preference - 'HIDING'.";
				spContent = "%%*|*|*|*|*|*|*|*|*|*|%%dsp%%frbac:{R1}%%+%%D%%|" + (spCounter++);
			}
			else if (ACTIVE_SECURITY_PREFERENCE == SECURITY_PREFERENCE_UNRESTRICTED)
			{
				confirmationMessage = "Please confirm your security preference - 'UNRESTRICTED'.";
				spContent = "%%*|*|*|*|*|*|*|*|*|*|%%dsp%%frbac:{R2}%%+%%D%%|" + (spCounter++);
			}
			else if (ACTIVE_SECURITY_PREFERENCE == SECURITY_PREFERENCE_FAMILY_ONLY)
			{
				confirmationMessage = "Please confirm your security preference - 'FAMILY ONLY'.";
				spContent = "%%*|*|*|*|*|*|*|*|*|*|%%dsp%%frbac:{R3}%%+%%D%%|" + (spCounter++);
			}
			JOptionPane.showConfirmDialog(null, confirmationMessage);		
			
			//write to file
			AppendToFile(spContent);
			
			instructionsSecurityPunctuationSyntax.setText ("");
			ACTIVE_SECURITY_PREFERENCE = -1;
		}
	}
	
	static int spCounter = 1000;
	
	private void AppendToFile(String content)
	{
		String NEWLINE = System.getProperty("line.separator");
		String fileToAppendTo = "C:\\Users\\Rimma\\workspace\\Raindrop\\resources\\security\\DEMO\\Stream0.txt";
		try
		{
	        BufferedWriter out = new BufferedWriter(new FileWriter(fileToAppendTo, true));
	        out.write(content + NEWLINE);
	        out.close();
	    } 
		catch (IOException e) 
		{
	    }
	}
	
	//-----------------------------------------------------------------------------

	public void paintComponent(Graphics g) 
	{ 
		g.drawImage(img, 0, 0, null);	 
	}

	//-----------------------------------------------------------------------------
	
	public static void main(String[] args) 
	{	
		DeviceStreamShieldMainForm panel = 
		new DeviceStreamShieldMainForm(new ImageIcon("C:\\Users\\Rimma\\workspace\\Raindrop\\edu\\wpi\\cs\\dsrg\\xmldb\\xat\\component\\gui\\security\\SmartPhoneBackground.png").getImage());
	
		JFrame frame = new JFrame();
		frame.getContentPane().add(panel);
		frame.pack();
		frame.setVisible(true);	  
		frame.setTitle("STREAMSHIELD DEVICE");
	}
	
	//-----------------------------------------------------------------------------
	
}

