/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
//--------------------------------------------------
// MessageBox.java
//  
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2009
//--------------------------------------------------

package edu.wpi.cs.dsrg.xmldb.xat.component.gui.security;

import java.awt.Dialog;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Panel;
import java.awt.Button;
import java.awt.Label;
import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JFrame;

public class MessageBox extends Dialog implements ActionListener,CommonSettings 
{  
	
	//-----------------------------------------------------------------------------
	 
	/***********Global Variable Declarations **************/
	JFrame parent;
	Button CmdOk, CmdCancel;
	MainCommandCanvas messagecanvas;
	ScrollView MessageScrollView;
	   
	//-----------------------------------------------------------------------------
	
	MessageBox(JFrame Parent, boolean okcan)
	{
		
		//-----------------------------------------------------------------------------
		
		super(Parent, "Information", false);
		parent = Parent;
		setBackground(Color.yellow);
		setLayout(new BorderLayout());	 
		//setFont(chatclient.getFont());  
		/*
	   	messagecanvas = new MessageCanvas(parent);
	   	MessageScrollView = new ScrollView(messagecanvas,true,true,200,100,0);
	   	messagecanvas.scrollview = MessageScrollView;
	   	messagecanvas.setBackground(chatclient.ColorMap[0]);	
		 */   	
	   
		add("Center",MessageScrollView);	   	   
		addOKCancelPanel(okcan);
		createFrame();	  
		pack();
	   
		setVisible(true);
		setSize(200,160);
		setResizable(false);
	}
	
	//-----------------------------------------------------------------------------
	
	protected void AddMessage(String message)
	{	
		messagecanvas.AddMessageToMessageObject(message, MESSAGE_TYPE_JOIN);		
	}
	
	//-----------------------------------------------------------------------------
	
   	private void addOKCancelPanel(boolean okcan) 
  	{
   		Panel panel = new Panel();
   		panel.setLayout(new FlowLayout());
   		createOKButton(panel);
   	  
   		if (okcan == true)      	
   			createCancelButton(panel);
   	  
   		add("South",panel);
   	}
   	
   	//-----------------------------------------------------------------------------

   	private void createOKButton(Panel panel) 
   	{
   		//CmdOk = new CustomButton(parent,"OK");   	
   		//panel.add(CmdOk);
   		//CmdOk.addActionListener(this); 
   	}

   	//-----------------------------------------------------------------------------
   	
   	private void createCancelButton(Panel panel) 
   	{   	
   		//CmdCancel = new CustomButton(parent,"Cancel");
   		//panel.add(CmdCancel);
   		//CmdCancel.addActionListener(this);
   	}

   	//-----------------------------------------------------------------------------
   	
   	private void createFrame() 
   	{
   		Dimension dimension = getToolkit().getScreenSize();
   		setLocation(dimension.width/3,dimension.height/3);
   	}

   	//-----------------------------------------------------------------------------
   	
   	public void actionPerformed(ActionEvent ae)
   	{
   		if(ae.getSource() == CmdOk) 
   		{     
   			dispose();
   		}
   		else if(ae.getSource() == CmdCancel) 
   		{
   			dispose();
   		}
   	}
   
   	//-----------------------------------------------------------------------------
   	
 }
