/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
//--------------------------------------------------
// EmotionCanvas.java
//  
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2009
//--------------------------------------------------

package edu.wpi.cs.dsrg.xmldb.xat.component.gui.security;

import java.awt.Dimension;
import java.awt.Canvas;
import java.util.ArrayList;
import java.awt.Graphics;
import java.awt.Event;
import java.awt.Image;
import java.awt.Color;
import java.awt.Font;
import java.awt.Cursor;


public class OLD_EmotionCanvas extends Canvas implements CommonSettings
{
	
	//-----------------------------------------------------------------------------
	
	/***********Global Variable Declarations****************/
	Dimension offDimension,dimension;
    Image offImage;
    Graphics offGraphics;  	
    ServerStreamShieldMainForm streamShieldMainForm;    
    ArrayList IconArray;
    int G_ILoop,XOffset,YOffset;
    MessageObject messageobject;
    ScrollView scrollview;
    String SelectedImage;
    
	//-----------------------------------------------------------------------------
	
	/**********Constructor Of Image Canvas *************/
	OLD_EmotionCanvas(ServerStreamShieldMainForm Parent)
	{
		streamShieldMainForm = Parent;	
		dimension = size();
		IconArray = new ArrayList();
		setBackground(streamShieldMainForm.ColorMap[0]);	
		setFont(streamShieldMainForm.TextFont);								
	}
	
	//-----------------------------------------------------------------------------
	
	protected void AddIconsToMessageObject()
	{
		int StartX = IMAGE_CANVAS_START_POSITION;					
		int StartY = IMAGE_CANVAS_START_POSITION;
		
		for(G_ILoop = 1; G_ILoop <= streamShieldMainForm.emotiSpIconCount; G_ILoop++)
		{
			messageobject = new MessageObject();
			messageobject.Message = (G_ILoop - 1)+"";
			messageobject.StartX  = StartX;
			messageobject.StartY  = StartY;
			//messageobject.IsImage = true;
			
			messageobject.IsEmotiSpImage = true;
			messageobject.Width   = DEFAULT_ICON_WIDTH;
			messageobject.Height  = DEFAULT_ICON_HEIGHT;
			
			IconArray.add(messageobject);	
			
			if(G_ILoop % 6 == 0)
			{
				StartX	= IMAGE_CANVAS_START_POSITION;
				StartY	+= DEFAULT_ICON_HEIGHT + DEFAULT_IMAGE_CANVAS_SPACE;
			}
			else
			{
				StartX 	+=	DEFAULT_ICON_WIDTH + DEFAULT_IMAGE_CANVAS_SPACE;	
			}
		}
		
		scrollview.setValues(dimension.width, StartY);
		scrollview.setScrollPos(1,1);
		scrollview.setScrollSteps(2,1,DEFAULT_SCROLLING_HEIGHT);
		repaint();		
	}
	
	//-----------------------------------------------------------------------------
	
	private void PaintFrame(Graphics graphics)
	{
		int m_iconListSize = IconArray.size();		
		for(G_ILoop = 0; G_ILoop < m_iconListSize; G_ILoop++)
		{			
			messageobject = (MessageObject) IconArray.get(G_ILoop);			
			if((messageobject.StartY + messageobject.Height) >= YOffset)
			{				
				PaintImagesIntoCanvas(graphics, messageobject, G_ILoop);	
			}
		}
	}
	
	//-----------------------------------------------------------------------------
	
	private void PaintImagesIntoCanvas(Graphics graphics, MessageObject messageObject,int imageIndex)
	{
		int m_StartY = messageObject.StartY - YOffset;
		
		if(messageobject.Message.equals(SelectedImage))
		{
			graphics.draw3DRect(messageObject.StartX - 2,
								m_StartY - 2,
								DEFAULT_ICON_WIDTH + 2,
								DEFAULT_ICON_HEIGHT + 2, 
								true);			
		}
			
		graphics.drawImage(streamShieldMainForm.emotiSpIconArray[Integer.parseInt(messageObject.Message)],messageObject.StartX,m_StartY,DEFAULT_ICON_WIDTH,DEFAULT_ICON_HEIGHT,this);		
		graphics.setColor(Color.black);
		graphics.drawString(EMOTI_SP_NAMES[imageIndex] /*+ messageObject.Message*/,messageObject.StartX-1, m_StartY+DEFAULT_ICON_HEIGHT + 10);
	}
	
	//-----------------------------------------------------------------------------
	
	public boolean handleEvent(Event event)
    {
        if(event.id == 1001 && event.arg == scrollview)
        {
            if(event.modifiers == 1)
                XOffset = event.key;
            else
                YOffset = event.key;                                    
            repaint();
            return true;
        } 
        else
        {
            return super.handleEvent(event);
        }			
    }
    
	//-----------------------------------------------------------------------------
	
    public boolean mouseEnter(Event event, int i, int j)
	{
		setCursor(new Cursor(Cursor.HAND_CURSOR));
		return true;
	}
    
    //-----------------------------------------------------------------------------

	public boolean 	mouseExit(Event event, int i, int j)
	{
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR)); 
		return true;
	}

	//-----------------------------------------------------------------------------
	
    public boolean mouseMove(Event event, int i, int j)
	{
		int CurrentY = j + YOffset;
		int m_iconListSize = IconArray.size();
		for(G_ILoop = 0; G_ILoop <  m_iconListSize; G_ILoop++)
		{
			messageobject = (MessageObject) IconArray.get(G_ILoop);
			if((CurrentY <= messageobject.StartY + messageobject.Height) && 
			   (i <= messageobject.StartX+messageobject.Width))
			{
				SelectedImage = messageobject.Message;
				repaint();
				break;
			}
			SelectedImage = null;
		}					
		return true;
	}
    
   //-----------------------------------------------------------------------------
	
	public boolean mouseDown(Event event, int i , int j)
	{
		int CurrentY = j + YOffset;
		int m_iconListSize = IconArray.size();
		
		for(G_ILoop = 0; G_ILoop <  m_iconListSize; G_ILoop++)
		{
			messageobject = (MessageObject) IconArray.get(G_ILoop);
			if((CurrentY <= messageobject.StartY+messageobject.Height) && 
			   (i <= messageobject.StartX+messageobject.Width))
			{
				//privatechat.AddImageToTextField(messageobject.Message);
				break;
			}			
		}			
		return true;				
	}
	
	//-----------------------------------------------------------------------------
	
	public void paint(Graphics graphics)
	{			
		/*************Double Buffering**************/		
		dimension = size();

		/*********** Create the offscreen graphics context**************/
		if ((offGraphics == null) || 
		    (dimension.width != offDimension.width) || 
		    (dimension.height != offDimension.height)) 
		{
	    	offDimension = dimension;
	    	offImage = createImage(dimension.width, dimension.height);
	    	offGraphics = offImage.getGraphics();	    		    		    		    	
		}

		/********* Erase the previous image*********/
		offGraphics.setColor(Color.white);
		offGraphics.fillRect(0, 0, dimension.width, dimension.height);	

		/*************** Paint the frame into the image*****************/
		PaintFrame(offGraphics);

		/****************** Paint the image onto the screen*************/
		graphics.drawImage(offImage, 0, 0, null);
	}
	
	//-----------------------------------------------------------------------------
	
	public void update(Graphics graphics)	
	{
		paint(graphics);	
	}
	
	//-----------------------------------------------------------------------------
	
}