/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
//--------------------------------------------------
// StreamShieldMainForm.java
//  
// Author: Rimma V. Nehme, rnehme@purdue.edu, 2009
//--------------------------------------------------

package edu.wpi.cs.dsrg.xmldb.xat.component.gui.security;

import java.awt.Panel;
import java.awt.Label;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Window;
import java.awt.TextField;
import java.awt.TextArea;
import java.awt.Frame;
import java.awt.Button;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Font;
import java.awt.CardLayout;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.MediaTracker;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.net.Socket;
import java.util.StringTokenizer;
import java.io.Serializable;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.DataOutputStream;
import java.net.URL;
import java.net.Socket;
import java.awt.Toolkit;
import java.awt.MenuBar;
import java.awt.Menu;
import java.awt.MenuItem;
import java.awt.MenuShortcut;

import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import edu.wpi.cs.dsrg.xmldb.xat.component.gui.CAPE_GUI;

//-----------------------------------------------------------------------------

public class ServerStreamShieldMainForm extends JPanel 
								  implements Serializable,
								  		     Runnable,
								  		     KeyListener,
								  		     ActionListener,
								  		     CommonSettings 
{

	//-----------------------------------------------------------------------------
	
	public static int COMMAND_COUNTER = 1;
	
	//-----------------------------------------------------------------------------
	
	public enum INSTRUCTION_STEP_ENUM 
	{ 
		STEP_1, 
		STEP_2, 
		STEP_3
	}

	INSTRUCTION_STEP_ENUM currentStep = INSTRUCTION_STEP_ENUM.STEP_1;
	
    //-----------------------------------------------------------------------------
	
	/**************Global Variable Declarations*****************/
	
	String ServerName,
	       AppletStatus,
	       ChatLogo,
	       BannerName,
	       ProxyHost,
	       ServerData,
	       RoomList,
	       SplitString;
	
	Image ImgLogo,ImgBanner;
	
	int ServerPort, 
		ProxyPort, 
		emotiSpIconCount, 
		streamsIconCount, 
		NumUsers, 
		G_ILoop, 
		NumStreams, 		
		NumCPQueries;
	
	boolean StartFlag,IsProxy;	
	Socket socket;
	
	DataInputStream datainputstream;
	DataOutputStream dataoutputstream;
	
	Color[] ColorMap;
	Dimension dimension;
	MediaTracker trackerEmotiSp, trackerStreams;
	
	Label InformationLabel;
	Label InstructionDetailsLabel;
	Label InstructionLabel;
	
	StringBuffer stringbuffer;
	Image[] emotiSpIconArray, streamsIconArray;
	
	MainCommandCanvas MainCommandCanvas;
	ScrollView MessageScrollView;
	
	Thread thread;
	StringTokenizer Tokenizer;
	
	TapPanel tappanel;
	JTextArea BottomCommandTextWindow;
	Button CmdExecute, 
		   CmdClear, 
		   CmdExit;
	
	Font TextFont;
	
	//protected PrivateChat[] privatewindow;
	protected int PrivateWindowCount;
	//InformationDialog dialog;
	Toolkit toolkit;
	MenuItem loginitem;
	MenuItem disconnectitem;
	MenuItem seperatoritem;
	MenuItem quititem, aboutitem;
	
	//-----------------------------------------------------------------------------
	
	public ServerStreamShieldMainForm(Stream [] streams) 
	{		
		NumStreams = streams.length; //update number of streams
				
		toolkit = Toolkit.getDefaultToolkit();	
		
		if(toolkit.getScreenSize().getWidth() > 778)
		{
			setSize(900, 600);
		}
		else
		{
			/*
			setSize((int)toolkit.getScreenSize().getWidth(),
					(int)toolkit.getScreenSize().getHeight() - 20);	
			*/
			setSize(200, 200);	
		}
			
		//setResizable(false);
		dimension = getSize();	
		setLayout(new BorderLayout());	

		//setTitle(PRODUCT_NAME);				
				
		/*****Loading menubar ***********/
		MenuBar menubar = new MenuBar();
		
		Menu loginmenu = new Menu("Login");		
		loginitem = new MenuItem("Login");
		loginitem.addActionListener(this);
		
		disconnectitem = new MenuItem("Disconnect");
		disconnectitem.addActionListener(this);
		
		seperatoritem = new MenuItem("-");
		
		quititem = new MenuItem("Quit");
		quititem.addActionListener(this);
		loginmenu.add(loginitem);
		loginmenu.add(disconnectitem);
		loginmenu.add(seperatoritem);
		loginmenu.add(quititem);
		
		Menu aboutmenu = new Menu("Help ");
		aboutitem = new MenuItem("About " + PRODUCT_NAME);
		aboutitem.addActionListener(this);
		aboutmenu.add(aboutitem);
		
		menubar.add(loginmenu);
		menubar.add(aboutmenu);
		//setMenuBar(menubar);
				
		//-----------------------------------------------------------------------------
		/**********Getting all the Parameteres***********/
		/*
		UserName 	= "";			
		UserRoom	= "";
		*/
		emotiSpIconCount 	= 21;
		streamsIconCount 	= 6;
		ChatLogo	= "images/security/logo.gif";
		BannerName 	= "images/security/defaultbanner.gif";
		RoomList 	= "";
		/*
		IsProxy = false;
		*/
		
		/*********Assigning Global Emoti-Sps*************/
		EMOTI_SP_NAMES[0] = "DEFAULT";
		EMOTI_SP_NAMES[1] = "DIZZY";
		EMOTI_SP_NAMES[2] = "UPSET";
		EMOTI_SP_NAMES[3] = "FUMING";
		EMOTI_SP_NAMES[4] = "HOT";
		EMOTI_SP_NAMES[5] = "BUSY";
		EMOTI_SP_NAMES[6] = "RUSHING";
		EMOTI_SP_NAMES[7] = "W/ PARENTS";
		EMOTI_SP_NAMES[8] = "OUT";
		EMOTI_SP_NAMES[9] = "HAPPY";
		EMOTI_SP_NAMES[10] = "INTERESTED";
		EMOTI_SP_NAMES[11] = "BUSY";
		EMOTI_SP_NAMES[12] = "BUSY";
		EMOTI_SP_NAMES[13] = "BUSY";
		EMOTI_SP_NAMES[14] = "BUSY";
		EMOTI_SP_NAMES[15] = "BUSY";
		EMOTI_SP_NAMES[16] = "BUSY";
		EMOTI_SP_NAMES[17] = "BUSY";
		EMOTI_SP_NAMES[18] = "BUSY";
		EMOTI_SP_NAMES[19] = "LOST";
		EMOTI_SP_NAMES[20] = "CONFUSED";
				
		
		/*********Assigning Global Colors*************/
		ColorMap 	= new Color[MAX_COLOR];
		
		/*******Backgorund*********/
		ColorMap[0] =  new Color(224,236,254); 
		
		/*******Information Panel Background*********/
		ColorMap[1] =  new Color(255,153,0);
		
		/*******Button Foreground*********/
		ColorMap[2] =  Color.black; 
		
		/*******Button Background**************/
		ColorMap[3] =  new Color(224,236,254); 
		
		/*******sstab button****************/
		ColorMap[4] =  new Color(238,232,170);
		
		/*******message canvas*********/
		ColorMap[5] =  Color.black;
		
		/*******Top Panel Background*********/
		ColorMap[6] =  Color.yellow;
		
		/*******Label Text Colors*********/
		ColorMap[7] =  Color.black;
		
		//-----------------------------------------------------------------------------
		/**********Loading Images*********/		
		trackerEmotiSp = new MediaTracker(this);
		trackerStreams = new MediaTracker(this);
		int ImageCount = 0;
		int StreamsImageCount = 0;
		
		ImgLogo 	= toolkit.getImage(ChatLogo);
		trackerEmotiSp.addImage(ImgLogo, ImageCount);
		ImageCount++;
		
		ImgBanner 	= toolkit.getImage(BannerName);		
		trackerEmotiSp.addImage(ImgBanner, ImageCount);
		ImageCount++;
				
		//-----------------------------------------------------------------------------
		/**********Loading EmotiSp Icons....***********/
		emotiSpIconArray = new Image[emotiSpIconCount];
		
		for(G_ILoop = 0; G_ILoop < emotiSpIconCount; G_ILoop++)
		{
			String fileName = "C:\\Users\\Rimma\\workspace\\Raindrop\\edu\\wpi\\cs\\dsrg\\xmldb\\xat\\component\\gui\\images\\security\\icons\\";
			emotiSpIconArray[G_ILoop] = toolkit.getImage(fileName +"photo"+G_ILoop+".gif");
			trackerEmotiSp.addImage(emotiSpIconArray[G_ILoop], ImageCount);
			ImageCount++;
		}
		
		/**********Loading Stream Icons....***********/
		streamsIconArray = new Image[streamsIconCount];
		
		for(G_ILoop = 0; G_ILoop < streamsIconCount; G_ILoop++)
		{
			String fileName = "C:\\Users\\Rimma\\workspace\\Raindrop\\edu\\wpi\\cs\\dsrg\\xmldb\\xat\\component\\gui\\images\\security\\stream_icons\\";
			streamsIconArray[G_ILoop] = toolkit.getImage(fileName + "stream_" + G_ILoop + ".gif");
			trackerStreams.addImage(streamsIconArray[G_ILoop], StreamsImageCount);
			StreamsImageCount++;
		}
		
		//-----------------------------------------------------------------------------
		
		/*********Initialize Private Window **********/
		//privatewindow = new PrivateChat[MAX_PRIVATE_WINDOW];
		//PrivateWindowCount = 0;
						
		try
		{		
			trackerEmotiSp.waitForAll();
			trackerStreams.waitForAll();
		}
		catch (InterruptedException e)
		{
			
		}
				
		/**********Initializing all the Components*********/
		InitializeStreamShieldFormComponents();			
	}		
	
	//-----------------------------------------------------------------------------
	
	private void SendMessageToServer(String Message)
	{				
		MainCommandCanvas.AddMessageToMessageObject(Message, MESSAGE_TYPE_DEFAULT);														
	}
	
	//-----------------------------------------------------------------------------
	
	/*******Initialize all the Applet Components********/
	private void InitializeStreamShieldFormComponents()
	{
		/*******Common Settings***********/
		setBackground(ColorMap[0]);	
		Font font = new Font("Dialog", Font.BOLD, 11);
		TextFont = new Font("Dialog", 0, 11);	
		setFont(font);	
		
		/***********Top Panel Coding*************/
		Panel TopPanel = new Panel(new BorderLayout());
		TopPanel.setBackground(ColorMap[6]);
		Panel LogoPanel = new ImagePanel(this, ImgLogo);		
		TopPanel.add("East", LogoPanel);		
		Panel BannerPanel = new ImagePanel(this, ImgBanner);
		TopPanel.add("West", BannerPanel);		
		add("North", TopPanel);	
		
		/*************Information Label Panel Coding*************/
		Panel CenterPanel = new Panel(new BorderLayout());
		Panel InformationPanel = new Panel(new BorderLayout());	
		Panel InstructionPanel = new Panel(new BorderLayout());	
		
		InformationPanel.setBackground(ColorMap[1]);	
		//InstructionPanel.setBackground(ColorMap[2]);
		
		//---------------------------------
		// INFORMATION LABEL (IN THE MIDDLE)
		//---------------------------------
		InformationLabel = new Label();		
		InformationLabel.setAlignment(1);
		UpdateInformationLabel();  

		//---------------------------------
		// INSTRUCTION LABEL (TO THE LEFT)
		//---------------------------------
		InstructionLabel = new Label();		
		InstructionLabel.setAlignment(Label.LEFT);
		InstructionLabel.setText("INSTRUCTIONS: ");
		Font fontInstructions = new Font("Dialog", Font.BOLD, 30);
		InstructionLabel.setFont(fontInstructions);
		
		InstructionDetailsLabel = new Label();		
		InstructionDetailsLabel.setAlignment(Label.LEFT);
		UpdateInstructionLabel(); 
		
		//----------------------------------
		
		InformationLabel.setForeground(ColorMap[5]); 
		
		InstructionPanel.add(InstructionLabel, BorderLayout.LINE_START);
		InstructionPanel.add(InstructionDetailsLabel);
		InformationPanel.add("Center", InformationLabel);
				
		CenterPanel.add("North", InformationPanel);
		TopPanel.add("Center", InstructionPanel);
		//---------------------------------------------------
		// MESSAGE CANVAS
		//---------------------------------------------------
		/*********Message Canvas and SSTAB Coding********/
		Panel MessagePanel = new Panel(new BorderLayout());
		MainCommandCanvas = new MainCommandCanvas(this);				
		MessageScrollView = new ScrollView(MainCommandCanvas, 
										   true, 
										   true, 
										   TAPPANEL_CANVAS_WIDTH, 
										   TAPPANEL_CANVAS_HEIGHT, 
										   SCROLL_BAR_SIZE);
		
		MainCommandCanvas.scrollview = MessageScrollView;	
		MessagePanel.add("Center", MessageScrollView);
		
		
		//---------------------------------------------------
		// TAP PANEL
		//---------------------------------------------------
		tappanel = new TapPanel(this, NumStreams);
						
	    MessagePanel.add("East", tappanel);  	    
	    CenterPanel.add("Center", MessagePanel);
	    
	    /*********Input Panel Coding Starts..*********/
	    Panel InputPanel = new Panel(new BorderLayout());
	    Panel TextBoxPanel = new Panel(new BorderLayout());
	    Label LblGeneral = new Label("Command Prompt: ");	 
	    
	    BottomCommandTextWindow = new JTextArea(7, 10);
	    BottomCommandTextWindow.setEditable(false);
	    
	    BottomCommandTextWindow.addKeyListener(this);
	    BottomCommandTextWindow.setFont(TextFont);
	    //BottomCommandTextWindow.setSize(BottomCommandTextWindow.getSize().width, 200);
	    	    
	    //add the text area into a scroll pane
	    JScrollPane scroll = new JScrollPane(BottomCommandTextWindow);
	    //give the scroll pane a reasonable size
	    scroll.setPreferredSize(new Dimension(150,100));
	    //just to demonstrate, we'll turn on line wrapping
	    BottomCommandTextWindow.setLineWrap(true);
	    //now we'll tell it to wrap whole words only (don't break on characters)
	    BottomCommandTextWindow.setWrapStyleWord(true);

	    //--------------------------------
	    // COMMIT COMMAND
	    //--------------------------------
	    CmdExecute = new CustomButton(this, "Submit Command");
	    CmdExecute.addActionListener(this);
	    
	    TextBoxPanel.add("West", LblGeneral);
	    TextBoxPanel.add("Center", BottomCommandTextWindow);
	    TextBoxPanel.add("East", CmdExecute);	    
	    
	    InputPanel.add("Center", TextBoxPanel);
	    
	    //----------------------------------------------
	    // BUTTONS
	    //----------------------------------------------
	    Panel InputButtonPanel = new Panel(new BorderLayout());
	    
	    //----------------------------------------------
	    // EXIT BUTTON
	    //----------------------------------------------
	    CmdExit = new CustomButton(this, "    Exit    ");
	    CmdExit.addActionListener(this);
	    InputButtonPanel.add("Center", CmdExit);
	  	
	    CmdClear = new CustomButton(this, "    Clear   ");
	    CmdClear.addActionListener(this);
	    CmdClear.setSize(100, 100);
	    InputButtonPanel.add("West", CmdClear);
	    
	    InputPanel.add("East", InputButtonPanel);
	  	
	  	Panel EmptyPanel = new Panel();
	  	EmptyPanel.setBackground(Color.yellow);
	  	InputPanel.add("South", EmptyPanel);	  	
	  	//InputPanel.setBackground(Color.green);

	  	CenterPanel.add("South", InputPanel);

		add("Center", CenterPanel);	
	}	

	
	//-----------------------------------------------------------------------------
	
	/*********Button Events *****/
	public void actionPerformed(ActionEvent evt)
	{
		//------------------------------------
		// COMMIT COMMAND
		//------------------------------------
		if(evt.getSource().equals(CmdExecute))
		{
			if (!(BottomCommandTextWindow.getText().trim().equals("")))
			{
				if (BottomCommandTextWindow.getText().contains("STREAM_"))
				{
					SendMessage(MESSAGE_STREAM_SPECIFIED);
				}
				else if (BottomCommandTextWindow.getText().contains("EMOTI_SP_"))
				{
					SendMessage(MESSAGE_SP_POLICY_SPECIFIED);
				}
				else if (BottomCommandTextWindow.getText().contains("CP_QUERY_"))
				{
					SendMessage(MESSAGE_SP_POLICY_SPECIFIED);
				}
				else
				{
					SendMessage(MESSAGE_TYPE_DEFAULT);
				}
			}
		}	
		
		//------------------------------------
		// EXIT COMMAND
		//------------------------------------
		if ((evt.getSource().equals(CmdExit)) || (evt.getSource().equals(quititem)))
		{
			DisconnectChat();
			System.exit(0);
		}	
		
		//------------------------------------
		// CLEAR COMMAND
		//------------------------------------
		if (evt.getSource().equals(CmdClear))
		{
			BottomCommandTextWindow.setText("");
			BottomCommandTextWindow.requestFocus();
		}	
		
	
		/*if(evt.getSource().equals(aboutitem))
		{			
			MessageBox messagebox = new MessageBox(this,false);					
			messagebox.AddMessage("~~13 " + PRODUCT_NAME);
			messagebox.AddMessage("Developed By...");
			messagebox.AddMessage(COMPANY_NAME);			
		}				
		*/
	}
	
	//-----------------------------------------------------------------------------
	
	/********* Key Listener Event *************/
	public void keyPressed(KeyEvent evt)
	{
		if((evt.getKeyCode() == 10) && 
		   (!(BottomCommandTextWindow.getText().trim().equals(""))))		
		{
			SendMessage(MESSAGE_TYPE_DEFAULT);
		}
	}
	
	//-----------------------------------------------------------------------------
	
	public void keyTyped(KeyEvent e)
	{
		
	}
	
	//-----------------------------------------------------------------------------
	
	public void keyReleased(KeyEvent e)
	{
		
	}

	//-----------------------------------------------------------------------------
	
	/******** Function To Send MESS Rfc to Server *************/
	private void SendMessage(int MESSAGE_TYPE)
	{
		/********Sending a Message *********/
		//SendMessageToServer("COMMAND: "+UserRoom+"~" + CommonSettings.STREAMSHIELD_USER_NAME + ": "+TxtMessage.getText());
		MainCommandCanvas.AddMessageToMessageObject(CommonSettings.COMMAND_PREFIX + 
				                                    COMMAND_COUNTER++ + 
				                                    ": " + 
				                                    BottomCommandTextWindow.getText(), 
				                                    MESSAGE_TYPE);			
		BottomCommandTextWindow.setText("");
		BottomCommandTextWindow.requestFocus();	
		
		UpdateInstructionsBasedOnLastCommand(MESSAGE_TYPE);
		UpdateInstructionLabel();
	}

	//-----------------------------------------------------------------------------
	
	private void UpdateInstructionsBasedOnLastCommand(int MESSAGE_TYPE)
	{
		if (currentStep == INSTRUCTION_STEP_ENUM.STEP_1)
		{
			if (MESSAGE_TYPE == CommonSettings.MESSAGE_STREAM_SPECIFIED)
			{
				currentStep = INSTRUCTION_STEP_ENUM.STEP_2;
			}
		}
		else if (currentStep == INSTRUCTION_STEP_ENUM.STEP_2)
		{
			if (MESSAGE_TYPE == CommonSettings.MESSAGE_SP_POLICY_SPECIFIED)
			{
				currentStep = INSTRUCTION_STEP_ENUM.STEP_3;
			}
		}
		else if (currentStep == INSTRUCTION_STEP_ENUM.STEP_3)
		{
			if (MESSAGE_TYPE == CommonSettings.MESSAGE_STREAM_SPECIFIED)
			{
				currentStep = INSTRUCTION_STEP_ENUM.STEP_2;
			}
		}
	}
	
	//-----------------------------------------------------------------------------
	
	/*********Function To Update the Information Label*****/
	private void UpdateInformationLabel()
	{
		stringbuffer = new StringBuffer();
		stringbuffer.append("# of Streams: ");
		stringbuffer.append(NumStreams);
		stringbuffer.append("       ");
		stringbuffer.append("# of CP-Queries: ");
		stringbuffer.append(NumCPQueries);
		stringbuffer.append("       ");
		stringbuffer.append("# of Users: ");
		stringbuffer.append(NumUsers);
		stringbuffer.append("       ");	
		
		InformationLabel.setText(stringbuffer.toString());		
	}
	
	//-----------------------------------------------------------------------------
	
	private void UpdateInstructionLabel()
	{
		stringbuffer = new StringBuffer();
		
		if (currentStep == INSTRUCTION_STEP_ENUM.STEP_1)
		{
			stringbuffer.append("Step 1. Select a stream");
		}
		else if (currentStep == INSTRUCTION_STEP_ENUM.STEP_2)
		{
			stringbuffer.append("Step 2. Create a security policy");
		}		
		else if (currentStep == INSTRUCTION_STEP_ENUM.STEP_3)
		{
			stringbuffer.append("Step 3. Commit the selection");
		}
				
		InstructionDetailsLabel.setText(stringbuffer.toString());			
		Font f = InstructionDetailsLabel.getFont();
		InstructionDetailsLabel.setFont(new Font("Serif", Font.PLAIN, 30)); 
		InstructionDetailsLabel.setSize(400, InstructionDetailsLabel.getHeight());
	}
	
	//-----------------------------------------------------------------------------
	
	/********Implements the Thread ****************/
	public void run()
	{
		while(thread != null)
		{
			try 
			{					
				ServerData = datainputstream.readLine();
					
				//----------------------------------
				//           USER INFO
				//----------------------------------
				/********* LIST UserName;UserName; RFC Coding***********/

				if(ServerData.startsWith("LIST"))
				{					
					Tokenizer = new StringTokenizer(ServerData.substring(5),";");						
										
					/********Update the Information Label *********/
					NumUsers = Tokenizer.countTokens();							
						
					UpdateInformationLabel();
					UpdateInstructionLabel();
						
					/**********Add User Item into User Canvas *********/						
					tappanel.UserCanvas.ClearAll();
					while(Tokenizer.hasMoreTokens())
					{							
						tappanel.UserCanvas.AddListItemToMessageObject(Tokenizer.nextToken());							
					}	
						
					MainCommandCanvas.ClearAll();										
					MainCommandCanvas.AddMessageToMessageObject("Welcome To The StreamShield!", MESSAGE_TYPE_JOIN);							
				}

				//----------------------------------
				//           USER INFO
				//----------------------------------

				if( ServerData.startsWith("ROOM"))
				{
					/********** Loading Room List in to Room Canvas **************/
					Tokenizer = new StringTokenizer(ServerData.substring(5),";");
						
					String UserRoom = Tokenizer.nextToken();
						
					UpdateInformationLabel();
					UpdateInstructionLabel();
						
					tappanel.CPQueryCanvas.ClearAll();
					tappanel.CPQueryCanvas.AddListItemToMessageObject(UserRoom);
						
					while(Tokenizer.hasMoreTokens())
					{							
						tappanel.CPQueryCanvas.AddListItemToMessageObject(Tokenizer.nextToken());							
					}
				}
					
				/********** ADD RFC *********/
				if(ServerData.startsWith("ADD"))
				{
					/********Update the Information Label *********/
					NumUsers++;
					UpdateInformationLabel();
					UpdateInstructionLabel();
						
					/**********Add User Item into User Canvas *********/
					SplitString = ServerData.substring(5);
					EnablePrivateWindow(SplitString);
					tappanel.UserCanvas.AddListItemToMessageObject(SplitString);							
					MainCommandCanvas.AddMessageToMessageObject(SplitString + " joins chat...",MESSAGE_TYPE_JOIN);						
				}									 
					
				/******** REMOVE User RFC Coding **********/
				if (ServerData.startsWith("REMO"))
				{						
					SplitString = ServerData.substring(5);	
						
					tappanel.UserCanvas.RemoveListItem(SplitString);
					RemoveUserFromPrivateChat(SplitString);
					MainCommandCanvas.AddMessageToMessageObject(SplitString+" has been logged Out from Chat!",MESSAGE_TYPE_LEAVE );
						
					/*****Update the Information Label ********/
					NumUsers--;
					UpdateInformationLabel();		
					UpdateInstructionLabel();
				}
					
				/******** MESS RFC Coding Starts **********/
				if( ServerData.startsWith("MESSAGE"))
				{
					MainCommandCanvas.AddMessageToMessageObject(ServerData.substring(5),MESSAGE_TYPE_DEFAULT);							
					
				}
									
				/***** INKI RFC (Information about kicked off User *********/
				if( ServerData.startsWith("INKI"))				
				{				
					SplitString = ServerData.substring(5);							
					tappanel.UserCanvas.RemoveListItem(SplitString);
					RemoveUserFromPrivateChat(SplitString);
					MainCommandCanvas.AddMessageToMessageObject(SplitString + " has been kicked Out from Chat by the Administrator!", MESSAGE_TYPE_ADMIN );
						
					/*****Update the Information Label ********/
					NumUsers--;
					UpdateInformationLabel();
					UpdateInstructionLabel();
				}
					
				/***** Change Room RFC **********/
				if( ServerData.startsWith("CHRO"))
				{
					String UserRoom = ServerData.substring(5);	
				}
					
				/********** Join Room RFC *************/
				if( ServerData.startsWith("JORO"))
				{
					SplitString = ServerData.substring(5);
					tappanel.UserCanvas.AddListItemToMessageObject(SplitString);
				
					/*****Update the Information Label ********/
					NumUsers++;
					UpdateInformationLabel();	
					UpdateInstructionLabel();
						
					MainCommandCanvas.AddMessageToMessageObject(SplitString + " joins chat...",MESSAGE_TYPE_JOIN);
					
				}
					
				/***********Leave Room RFC **********/
				if( ServerData.startsWith("LERO"))
				{
					SplitString = ServerData.substring(5,ServerData.indexOf("~"));
					tappanel.UserCanvas.RemoveListItem(SplitString);
					MainCommandCanvas.AddMessageToMessageObject(SplitString+" has leaves Room and join into " + ServerData.substring(ServerData.indexOf("~")+1)+" Room",MESSAGE_TYPE_ADMIN);													
						
					/*****Update the Information Label ********/
					NumUsers--;
					UpdateInformationLabel();	
					UpdateInstructionLabel();
				}
					
				/********** Room Count RFC ********/					
				if( ServerData.startsWith("ROCO"))
				{
					SplitString = ServerData.substring(5,ServerData.indexOf("~"));
					tappanel.TxtNewCpQuery.setText("Total Users in " + SplitString+" : "+ServerData.substring(ServerData.indexOf("~")+1));
				}
					
					
					/*
					//******* Private Message RFC *********
					if( ServerData.startsWith("PRIV"))
					{												
						SplitString = ServerData.substring(5,ServerData.indexOf(":"));
						//**** Chk whether ignored user *********
						if(!(tappanel.UserCanvas.IsIgnoredUser(SplitString)))	
						{
							boolean PrivateFlag = false;
							for(G_ILoop = 0; G_ILoop < PrivateWindowCount;G_ILoop++)
							{								
								if(privatewindow[G_ILoop].UserName.equals(SplitString))
								{
									privatewindow[G_ILoop].AddMessageToMessageCanvas(ServerData.substring(5));
									privatewindow[G_ILoop].show();
									privatewindow[G_ILoop].requestFocus();
									PrivateFlag = true;
									break;										
								}
							}	
							
							if(!(PrivateFlag))
							{	
								if(PrivateWindowCount >= MAX_PRIVATE_WINDOW)
								{
									MainCommandCanvas.AddMessageToMessageObject("You are Exceeding private window limit! So you may lose some message from your friends!",MESSAGE_TYPE_ADMIN);	
								}
								else
								{														
									privatewindow[PrivateWindowCount++] = new PrivateChat(this,SplitString);
									privatewindow[PrivateWindowCount-1].AddMessageToMessageCanvas(ServerData.substring(5));
									privatewindow[PrivateWindowCount-1].show();
									privatewindow[PrivateWindowCount-1].requestFocus();																
								}
							}
							
								
						}	
										
					}
					
				*/
			}
			catch(Exception _Exc) 
			{ 
				MainCommandCanvas.AddMessageToMessageObject(_Exc.getMessage(), MESSAGE_TYPE_ADMIN);				
			}	
		}	
	}
	
	//-----------------------------------------------------------------------------
	
	/***** Enable the Private Chat when the End User logged out****/
	private void EnablePrivateWindow(String ToUserName)
	{
		/*
		for(G_ILoop = 0; G_ILoop < PrivateWindowCount; G_ILoop++)
		{
			if(privatewindow[G_ILoop].UserName.equals(ToUserName))
			{
				privatewindow[G_ILoop].messagecanvas.AddMessageToMessageObject(ToUserName + " is Currently Online!",MESSAGE_TYPE_ADMIN);	
				privatewindow[G_ILoop].EnableAll();			
				return;	
			}
		}
		*/	
	}
	
	//-----------------------------------------------------------------------------
	
	/***** Disable the Private Chat when the End User logged out****/
	private void RemoveUserFromPrivateChat(String ToUserName)
	{
		/*
		for(G_ILoop = 0; G_ILoop < PrivateWindowCount; G_ILoop++)
		{
			if(privatewindow[G_ILoop].UserName.equals(ToUserName))
			{
				privatewindow[G_ILoop].messagecanvas.AddMessageToMessageObject(ToUserName + " is Currently Offline!",MESSAGE_TYPE_ADMIN);	
				privatewindow[G_ILoop].DisableAll();			
				return;	
			}
		}
		*/	
	}	
	
	//-----------------------------------------------------------------------------
	
	/******* Function To Remove Private Window ***************/
	protected void RemovePrivateWindow(String ToUserName)
	{	
		/*
		int m_UserIndex = 0;
		for(G_ILoop = 0; G_ILoop < PrivateWindowCount; G_ILoop++)
		{
			m_UserIndex++;
			if(privatewindow[G_ILoop].UserName.equals(ToUserName)) break;
		}						
		for(int m_iLoop = m_UserIndex;m_iLoop < PrivateWindowCount; m_iLoop++)
		{
			privatewindow[m_iLoop] = privatewindow[m_iLoop+1];	
		}
		
		PrivateWindowCount--;
		*/		
	}	
	
	//-----------------------------------------------------------------------------
	
	/******** Function to Set the Image Name into Text Field ************/
	protected void AddImageToTextField(String ImageName)
   	{
   		if(BottomCommandTextWindow.getText() == null || BottomCommandTextWindow.getText().equals(""))
   		{
   			BottomCommandTextWindow.setText("~~" + ImageName + " ");
   		}
		else
		{
			BottomCommandTextWindow.setText(BottomCommandTextWindow.getText()+" "+"~~"+ImageName+" ");
		}
   	}
			
	//-----------------------------------------------------------------------------
	
	/***** Function To Disable All Components ********/
	private void DisableAll()
	{		
		BottomCommandTextWindow.setEnabled(false);
		CmdExecute.setEnabled(false);
		tappanel.enable(false);			
		disconnectitem.setEnabled(false);
		loginitem.setEnabled(true);
		
		NumStreams = 0;
		NumCPQueries = 0;
		NumUsers = 0;
	}
	
	//-----------------------------------------------------------------------------
	
	/***** Function To Enable All Components ********/
	private void EnableAll()
	{
		BottomCommandTextWindow.setEnabled(true);
		CmdExecute.setEnabled(true);
		tappanel.enable(true);	
		disconnectitem.setEnabled(true);
		loginitem.setEnabled(false);
	}
	
	//-----------------------------------------------------------------------------
	
	/*******Diconnect Chat ********/
	private void DisconnectChat()
	{
		MainCommandCanvas.AddMessageToMessageObject("CONNECTION TO THE SERVER CLOSED", MESSAGE_TYPE_ADMIN);						
	}	
	
	//-----------------------------------------------------------------------------
	
	public static void main(String args[]) 
	{		
		int numStreams = 5;
		Stream [] streams = new Stream [numStreams];
		for (int i = 0; i < numStreams; i++)
		{
			streams[i] = new Stream("Stream_" + i);
		}
		
		ServerStreamShieldMainForm mainFrame = new ServerStreamShieldMainForm(streams);				
	}
	
	//-----------------------------------------------------------------------------
	
}
