/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.gui.utils;

import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
 * Filters out all files that do not have the extension ".csv".
 * 
 * Creation Date: (Jul 20, 2004 11:12:00 AM)
 * @author Natasha Bogdanova
 */
public class CSVFileFilter extends FileFilter {

	/**
	 * Default constructor.
	 */
	public CSVFileFilter() {
		super();
	}

	/**
	 * Returns true of the given file's name ends with ".csv".
	 * 
	 * Creation Date: (Jul 20, 2004 11:12:58 AM)
	 * @author Natasha Bogdanova
	 * @param inFile File
	 * @return boolean
	 */
	public boolean accept(File inFile) {
		if (inFile.isDirectory())
			return true;
		else
			return inFile.getName().toLowerCase().endsWith(".csv");
	}

	/**
	 * Returns the description of this filter.
	 * 
	 * Creation Date: (Jul 20, 2004 11:14:47 AM)
	 * @author Natasha Bogdanova
	 * @return String
	 */
	public String getDescription() {
		return "CSV Files";
	}

}
