/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues;

import java.io.Serializable;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;


/**
 * Insert the type's description here.
 * Creation date: (1/29/2003 2:00:01 PM)
 * @author: Asima Silva
 */
public class KeyString extends XATDataValueImp implements KeyInterface, Serializable {
	protected java.lang.String key;
/**
 * KeyString constructor comment.
 */
public KeyString() {
	super();
}
	/**
	 * Compares this object with the specified object for order.  Returns a
	 * negative integer, zero, or a positive integer as this object is less
	 * than, equal to, or greater than the specified object.<p>
	 *
	 * The implementor must ensure <tt>sgn(x.compareTo(y)) ==
	 * -sgn(y.compareTo(x))</tt> for all <tt>x</tt> and <tt>y</tt>.  (This
	 * implies that <tt>x.compareTo(y)</tt> must throw an exception iff
	 * <tt>y.compareTo(x)</tt> throws an exception.)<p>
	 *
	 * The implementor must also ensure that the relation is transitive:
	 * <tt>(x.compareTo(y)&gt;0 &amp;&amp; y.compareTo(z)&gt;0)</tt> implies
	 * <tt>x.compareTo(z)&gt;0</tt>.<p>
	 *
	 * Finally, the implementer must ensure that <tt>x.compareTo(y)==0</tt>
	 * implies that <tt>sgn(x.compareTo(z)) == sgn(y.compareTo(z))</tt>, for
	 * all <tt>z</tt>.<p>
	 *
	 * It is strongly recommended, but <i>not</i> strictly required that
	 * <tt>(x.compareTo(y)==0) == (x.equals(y))</tt>.  Generally speaking, any
	 * class that implements the <tt>Comparable</tt> interface and violates
	 * this condition should clearly indicate this fact.  The recommended
	 * language is "Note: this class has a natural ordering that is
	 * inconsistent with equals."
	 * 
	 * @param   o the Object to be compared.
	 * @return  a negative integer, zero, or a positive integer as this object
	 *		is less than, equal to, or greater than the specified object.
	 * 
	 * @throws ClassCastException if the specified object's type prevents it
	 *         from being compared to this Object.
	 */
public int compareTo(Object o) {
	String thisString = new String(this.getKey());
	KeyString newKeyStr = (KeyString) o;
	String newKeyString = newKeyStr.getKey();
	int ret = thisString.compareTo(newKeyString);
	return ret;
}
/**
 * Insert the method's description here.
 * Creation date: (1/29/2003 2:00:20 PM)
 * @return java.lang.String
 */
public java.lang.String getKey() {
	return key;
}
/**
 * Insert the method's description here.
 * Creation date: (1/29/2003 2:00:01 PM)
 * @return java.lang.Comparable
 */
public Comparable getType() {
	return null;
}
/**
 * Insert the method's description here.
 * Creation date: (1/29/2003 2:00:20 PM)
 * @param newKey java.lang.String
 */
public void setKey(java.lang.String newKey) {
	key = newKey;
}

/**
 * Insert the method's description here.
 * Creation date: (2/11/2003 12:48:12 PM)
 * @param nstring java.lang.String
 */
public KeyString(String nstring) {
	this.setKey(nstring);
	}

/**
 * Insert the method's description here.
 * Creation date: (2/11/2003 3:16:45 PM)
 * @return java.lang.String
 */
public String toString() {
	return this.getKey();
}

/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 11:32:11 PM)
 * @param k juggler.exploitationstructures.KeyInterface
 */
public void addKey(KeyInterface k) {
	return;
	}

/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 11:17:30 PM)
 * @param k int
 */
public void divideKey(KeyInterface k) {
	return;
	}

/**
 * Insert the method's description here.
 * Creation date: (2/18/2003 12:29:05 AM)
 * @return boolean
 * @param k org.omg.CORBA.Object
 */
public boolean equals(Object k) {

    KeyString kI = (KeyString) k;
    if (this.getKey() == kI.getKey())
        return true;
    else
        return false;
}

/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 11:36:51 PM)
 * @param k juggler.exploitationstructures.KeyInterface
 */
public void subKey(KeyInterface k) {
	return;
	}

/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 11:41:31 AM)
 * @return java.lang.Object
 */
public Object getValue(){
	return (new String(key));
}

}
