/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.optimizer.mjoinoptimizer;

import edu.wpi.cs.dsrg.xmldb.xat.common.migration.probablisticjoinoperator.WMJoinOperator;


/**
 * @author Yali Zhu
 *
 */
public class BinaryJoinEntry {
	public int lindex;
	public int rindex;
	public int joinID = -1;
	
	public int parentID = -1;
	public int lchildID = -1;
	public int rchildID = -1;
	
	public double[] inputRates;
	public double[][] selectivities;
	public int[][] joinOrderings;
	
	//indicate if this operator has been connected to the btree.
	public boolean connected = false;
	public WMJoinOperator operator;
	
	
	public BinaryJoinEntry(int joinid, int lindex, int rindex, WMJoinOperator operator) {
		this.joinID = joinid;
		this.lindex = lindex;
		this.rindex = rindex;
		this.operator = operator;
		
		connected = false;
	}

	public void setConnected() {
		this.connected = true;
	}
	
	public boolean isConnected() {
		return this.connected;
	}
	
	public boolean containIndex(int i) {
		return ((lindex == i) || (rindex == i));
	}

	//	public int getv1() {
	//		return v1;
	//	}
	//	
	//	public int getv2() {
	//		return v2;
	//	}
	//	
	//	public double getrate1() {
	//		return rate1;
	//	}
	//	
	//	public double getrate2() {
	//		return rate2;
	//	}
	//	
	//	public double getselectivity() {
	//		return selectivity;
	//	}
	//	
	//	public double getWeight() {
	//		return this.weight;
	//	}
		
		
		public String toString() {
			String rs = new String();
			
			rs += "(JoinEntry: ";
			rs += "ID=" + joinID + " l=" + lchildID + " r=" + rchildID + " p=" + parentID +")";
			
			return rs;
		}
}
