/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

/*
 * Created on Feb 21, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.optimizer.mjoinoptimizer;

import java.io.Serializable;

/**
 * @author Yali Zhu
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Edge implements Serializable {
	protected int v1;
	protected int v2;
	protected double rate1;
	protected double rate2;
	
	protected double selectivity;
	
	// weight = rate1 * rate2 * selectivity
	protected double weight;
	
	//how many stream does each node of the edge contain.
	//it starts with 1 since each node represents one input stream.
	//when edge is being merged, this number is increased.
	protected int streamsize1 = 1;
	protected int streamsize2 = 1;
	
	// used by IK algorithm
	protected double rootedWeight = 0;

	public Edge(int v1, int v2, double rate1, double rate2, double s) {
		this.v1 = v1;
		this.v2 = v2;
		this.rate1 = rate1;
		this.rate2 = rate2;
		this.selectivity = s;
		
		this.weight = rate1 * rate2 * s;
	}
	
	public int getv1() {
		return v1;
	}
	
	public int getv2() {
		return v2;
	}
	
	public double getWeight() {
		return this.weight;
	}
	
	public void setRootedWeight(double w) {
		this.rootedWeight = w;
	}
	
	public double getRootedWeight() {
		return this.rootedWeight;
	}
	
	public void updateWeight() {
		this.weight = rate1 * rate2 * selectivity;
	}
	
	public String toString() {
		String rs = new String();
		
		rs += "(EDGE: ";
		rs += v1 + " " + v2 + " s=" + selectivity + " w=" + weight+")";
		
		return rs;
	}
}
