/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.optimizer.mjoinoptimizer;

//import java.util.ArrayList;
import java.util.Hashtable;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDagImp;

/**
 * @author Yali Zhu
 * 
 * Insert comments here.
 */
public class Tester {
	
	public static void main(String args[]) {
		Hashtable table = new Hashtable();
		table.put(""+1, new Integer(100));
		table.put(""+2, new Integer(20));
		
		System.out.println(table.get(""+1));
		System.out.println(table.get(""+2));
		
		char c = 'C';
		c++;
		char x = c;
		int i = 'A' - c + 1;
		System.out.println(i);
		
		XATDag dag = new XATDagImp();
		
		ExhaustiveSearchOptimizer optimizer = new ExhaustiveSearchOptimizer(dag);
		
		String pstring = "A";
		System.out.println("pstring is " + pstring);
		char largestletter = optimizer.getLargestLetter(pstring);
		System.out.println("largest letter is " + largestletter);
		char nextinputletter = (char)((int)largestletter + 1);
		System.out.println("next letter is " + nextinputletter);

		for(int k=0; k<pstring.length(); k++) {
			String newpstring = null;
			
			//create a new join
			if(pstring.charAt(k) == '(') {	
				newpstring = optimizer.createPStringWithNewJoin(pstring, nextinputletter, k);
			} 
			//create a new join with a input stream
			else if(Character.isLetter(pstring.charAt(k))) {
				newpstring = optimizer.createPStringWithNewLeafJoin(pstring, nextinputletter, k);
			}
			//merge the input with an existing join to form a large mjoin
			else if(pstring.charAt(k) == ')') {
				newpstring = optimizer.createPStringWithOneLargerJoin(pstring, nextinputletter, k);
			}		
			
			if(newpstring != null) {
				System.out.println(newpstring);
				System.out.println(optimizer.getRootInputPString(newpstring));
				
			}
			
		}
	}

}
