/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.optimizer.rewritingrules;
/*
 * Created on Apr 19, 2004
 * 
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

//import java.util.List;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamSelectOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
//import edu.wpi.cs.cs4432.project3.heuristics.Optimizer;
//import edu.wpi.cs.dsrg.xmldb.xat.component.optimizer.heuristics.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.predicate.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;
//import edu.wpi.cs.dsrg.xmldb.xat.component.statisticsgatherer.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.migrationcontroller.XATBox;
//import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.BinANDExpressionStrImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.BinANDExpressionStr;

/**
 * @author Yali Zhu
 * @author Jason Runcie  - code from cs4432 class project3
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MergeOperatorRules {

	public MergeOperatorRules() {
		super();
	}
	
	public static boolean Merge(XATStreamOperator upperop, XATStreamOperator lowerop, XATBox newbox) {
		if((upperop instanceof StreamSelectOperator) && (lowerop instanceof StreamSelectOperator)) {
			return Merge((StreamSelectOperator)upperop, (StreamSelectOperator)lowerop, newbox);
		}
		
		return false;
	}

	public static boolean Merge(StreamSelectOperator upperSelect, StreamSelectOperator lowerSelect, XATBox newbox) {
		// CS4432 your code goes here.
		//System.out.println("merging " + upperSelect + " and " + lowerSelect);

		// Get the predicates from the lower select operator
		//List preds = lowerSelect.getPredicates();
		
		/* if the input queues of upperSelect and lowerSelect has the same schema (value same)
		 * we don't need to take care of the extra conversion of the expressions.
		 */
		if (upperSelect.getInputQueue().getSchema().getColNames()
			== lowerSelect.getOutputQueue().getSchema().getColNames()) {
				
			BinANDExpressionStr newexpr = new BinANDExpressionStrImp(upperSelect.getExpression(),lowerSelect.getExpression());
			upperSelect.setExpression(newexpr);
		}
		else {
			// @TODO otherwise, the schema has been minimized, do something about the expression.
		}

		// Rearrange the queues to bypass the lower select.
		upperSelect.setInputQueue(lowerSelect.getInputQueue());
		lowerSelect.getInputQueue().unregister(lowerSelect);
		
		// Deactivate the operator in an attempt to stop the statistics generator from giving errors.
		//lowerSelect.getLightWeightQueryObject().setActive(false);
		//lowerSelect.setActive(false);

		// Delete the lower select from the tree.
		newbox.deleteNode(lowerSelect.getNode());

		// Print the tree after the two Selects are merged.
		//Optimizer.addToOutputString("\n\nTree After Merge Operators: " + upperSelect + " and " + lowerSelect + "\n");
		//Optimizer.addToOutputString("Timestamp: " + System.currentTimeMillis()+"\n");
		//Optimizer.addToOutputString("---------------------------------------------------------------------------------------------------\n");
		//Optimizer.addToOutputString(Optimizer.getTree().toString());
		return true;
	}
}
