/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.generators;

import java.util.Enumeration;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.Math.Functions;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.interfaces.JoinGraph;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.interfaces.Vertex;

/**
 * Generates selectivity for all a given join graph
 * @author Venkatesh Raghavan
 * @version 1.0, July 2007
 */
public class JoinGraphGenerator {
	
	
	public static JoinGraph generate(JoinGraph _graph)
	{
		if(_graph!=null)
		{
			Enumeration enums = _graph.getVertices();
			Vector<Vertex> vertices = new Vector<Vertex>();
			while(enums.hasMoreElements())
			{
				vertices.add((Vertex) enums.nextElement());
			}
			
			int vertexCount = vertices.size();
			
			if(vertexCount>0)
			{
				for(int i=0; i<vertexCount;i++)
				{
					for(int j=i+1; j<vertexCount;j++)
					{
						try
						{
							_graph.addEdge(vertices.elementAt(i),vertices.elementAt(j), Utils.generateRandomSelectivity());
						}catch(Exception e)
						{
							e.printStackTrace();
						}
					}
				}
				
			}
			
		}
		//System.out.println("Hello");
		return _graph;
	}
	
	
	
}
