/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.classes;

import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.classes.exceptions.JoinGraphException;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.interfaces.Vertex;

public class WeightedJoinGraphImpl extends JoinGraphImpl{
	public WeightedJoinGraphImpl()
	{
		super();
	}
	
	public void addEdge(Vertex _start, Vertex _end) throws JoinGraphException
	{	
		// Starting and Ending Vertices are the same then throw an excpetion
		if(_start.getLabel().compareTo(_end.getLabel()) ==0)
		{
			JoinGraphException e = new JoinGraphException(" Start Vertex and End Vertex have same label");
			throw e;
		}else
		{
			WeightedEdgeImpl newEdge = new WeightedEdgeImpl(_start, _end);
			edges.put(_start.getLabel()+":"+_end.getLabel(), newEdge); 
		}
	}
	
	public void addEdge(Vertex _start, Vertex _end, double _value) throws JoinGraphException
	{
		// Starting and Ending Vertices are the same then throw an excpetion
		if(_start.getLabel().compareTo(_end.getLabel()) ==0)
		{
			JoinGraphException e = new JoinGraphException(" Start Vertex and End Vertex have same label");
			throw e;
		}else
		{
			WeightedEdgeImpl newEdge = new WeightedEdgeImpl(_start, _end, _value);			
			edges.put(_start.getLabel()+":"+_end.getLabel(), newEdge); 
		}
	}
}
