/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.costmodel.examples;

import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.classes.JoinGraphImpl;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.source.streams.Stream;

public class JoinGraphs {
	public static JoinGraphImpl abc1()
	{
		Stream a = new Stream("A");
		a.setInputRate(50.0);
		
		Stream b = new Stream("B");
		b.setInputRate(20.0);

		Stream c = new Stream("C");
		c.setInputRate(100.0);
		
		JoinGraphImpl graph = new JoinGraphImpl();
		
		graph.addVertex(a);
		graph.addVertex(b);
		graph.addVertex(c);
	
		try
		{
			graph.addEdge(a,b,0.1);
			graph.addEdge(b,c,0.3);
			return graph;
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		return null;
	}
	
	public static JoinGraphImpl abcd1()
	{
		Stream a = new Stream("A");
		a.setInputRate(20.0);
		
		Stream b = new Stream("B");
		b.setInputRate(20.0);

		Stream c = new Stream("C");
		c.setInputRate(20.0);
		
		Stream d = new Stream("D");
		d.setInputRate(20.0);
		
		JoinGraphImpl graph = new JoinGraphImpl();
		
		graph.addVertex(a);
		graph.addVertex(b);
		graph.addVertex(c);
		graph.addVertex(d);
		
		try
		{
			graph.addEdge(a,b,0.02);
			graph.addEdge(b,c,0.2);
			graph.addEdge(c,d,0.05);
			
			return graph;
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		return null;
	}
	
	public static JoinGraphImpl abcd()
	{
		Stream a = new Stream("A");
		a.setInputRate(10.0);
		
		Stream b = new Stream("B");
		b.setInputRate(30.0);
		
		Stream c = new Stream("C");
		c.setInputRate(50.0);
		
		Stream d = new Stream("D");
		d.setInputRate(20.0);
		
		JoinGraphImpl graph = new JoinGraphImpl();
		
		
		try{
			graph.addVertex(a);
			graph.addVertex(b);
			graph.addVertex(c);
			graph.addVertex(d);
			
			graph.addEdge(a,b,0.1);
			graph.addEdge(b,c,0.08);
			
			graph.addEdge(c,d,0.1);
			
			return graph;
		}catch(Exception exp)
		{
			exp.printStackTrace();
		}
		
		return null;
		
	}
	
	public static JoinGraphImpl abcde1()
	{
		Stream a = new Stream("A");
		a.setInputRate(10.0);
		
		Stream b = new Stream("B");
		b.setInputRate(30.0);
		
		Stream c = new Stream("C");
		c.setInputRate(50.0);
		
		Stream d = new Stream("D");
		d.setInputRate(20.0);
		
		Stream e = new Stream("E");
		e.setInputRate(100.0);
		
		Stream f = new Stream("F");
		f.setInputRate(100.0);
		
		JoinGraphImpl graph = new JoinGraphImpl();
		
		
		try{
			graph.addVertex(a);
			graph.addVertex(b);
			graph.addVertex(c);
			graph.addVertex(d);
			
			graph.addVertex(e);
			graph.addVertex(f);
			
			graph.addEdge(a,b,0.1);
			graph.addEdge(a,c,0.08);
			
			graph.addEdge(c,d,0.1);
			
			graph.addEdge(d,e,0.1);
			graph.addEdge(d,f,0.25);
				
			return graph;
		}catch(Exception exp)
		{
			exp.printStackTrace();
		}
		
		return null;
		
	}
}
