/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.costmodel.examples;

import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.classes.JoinGraphImpl;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.costmodel.BinaryJoin.SymmetricNLJWithNoTouchCost;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.classes.BinaryJoinNodeImpl;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.classes.QueryPlan;

public class QueryPlans {

	public static QueryPlan Q1()
	{
		JoinGraphImpl graph = JoinGraphs.abcde1();

		// A Join B
		BinaryJoinNodeImpl ab = new BinaryJoinNodeImpl();
		ab.addLeftChild(graph.getVertex("A"));
		ab.addRightChild(graph.getVertex("B"));

		QueryPlan abPlan = new QueryPlan(ab);

		//  (A Join B) Join C
		
		BinaryJoinNodeImpl abc = new BinaryJoinNodeImpl();
		abc.addLeftChild(abPlan);
		abc.addRightChild(graph.getVertex("C"));

		QueryPlan abcPlan = new QueryPlan(abc);

		// D Join E
		BinaryJoinNodeImpl de = new BinaryJoinNodeImpl();
		de.addLeftChild(graph.getVertex("D"));
		de.addRightChild(graph.getVertex("E"));

		QueryPlan dePlan = new QueryPlan(de);

		// (D Join E) Join F 
		
		BinaryJoinNodeImpl def = new BinaryJoinNodeImpl();
		def.addLeftChild(dePlan);
		def.addRightChild(graph.getVertex("F"));

		QueryPlan defPlan = new QueryPlan(def);

		// ((A Join B) Join C ) JOIN ((D Join E) Join F )

		BinaryJoinNodeImpl abcdef = new BinaryJoinNodeImpl();
		abcdef.addLeftChild(abcPlan);
		abcdef.addRightChild(defPlan);

		QueryPlan abcdefPlan = new QueryPlan(abcdef);
	
		return abcdefPlan;
	}

	public static QueryPlan Q2()
	{
		JoinGraphImpl graph = JoinGraphs.abc1();

		BinaryJoinNodeImpl ab = new BinaryJoinNodeImpl();
		ab.addLeftChild(graph.getVertex("A"));
		ab.addRightChild(graph.getVertex("B"));

		QueryPlan abPlan = new QueryPlan(ab);

		BinaryJoinNodeImpl abc = new BinaryJoinNodeImpl();
		abc.addLeftChild(abPlan);
		abc.addRightChild(graph.getVertex("C"));

		QueryPlan abcPlan = new QueryPlan(abc);

		return abcPlan;

	}
	public static QueryPlan Q3()
	{
		JoinGraphImpl graph = JoinGraphs.abcd();

		BinaryJoinNodeImpl ab = new BinaryJoinNodeImpl();
		ab.addLeftChild(graph.getVertex("A"));
		ab.addRightChild(graph.getVertex("B"));

		QueryPlan abPlan = new QueryPlan(ab);

		BinaryJoinNodeImpl abc = new BinaryJoinNodeImpl();
		abc.addLeftChild(abPlan);
		abc.addRightChild(graph.getVertex("C"));

		QueryPlan abcPlan = new QueryPlan(abc);

		BinaryJoinNodeImpl abcd = new BinaryJoinNodeImpl();
		abcd.addLeftChild(abcPlan);
		abcd.addRightChild(graph.getVertex("D"));

		QueryPlan abcdPlan = new QueryPlan(abcd);

		return abcdPlan;
	}
}
