/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.costmodel.examples;

import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.classes.JoinGraphImpl;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.classes.BinaryJoinNodeImpl;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.classes.QueryPlan;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.source.streams.Stream;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.costmodel.CostEstimator;
public class example1 {

	public static void main(String args[])
	{
		Stream a = new Stream("A");
		a.setInputRate(50.0);
		
		Stream b = new Stream("B");
		b.setInputRate(20.0);

		Stream c = new Stream("C");
		c.setInputRate(100.0);
		
		JoinGraphImpl graph = new JoinGraphImpl();
		
		graph.addVertex(a);
		graph.addVertex(b);
		graph.addVertex(b);
	
		try
		{
			graph.addEdge(a,b,0.1);
			graph.addEdge(b,c,0.3);

			QueryPlan aPlan = new QueryPlan(a);
			QueryPlan bPlan = new QueryPlan(b);
			QueryPlan cPlan = new QueryPlan(c);
			
			BinaryJoinNodeImpl ab = new BinaryJoinNodeImpl();
			ab.addLeftChild(aPlan);
			ab.addRightChild(bPlan);
			
			QueryPlan abPlan = new QueryPlan(ab);
			
			BinaryJoinNodeImpl abc = new BinaryJoinNodeImpl();
			abc.addLeftChild(abPlan);
			abc.addRightChild(cPlan);
			
			QueryPlan abcPlan = new QueryPlan(abc);
			
			CostEstimator cost = new CostEstimator();
			
			cost.generateCost(abcPlan, graph);
			
			//System.out.println("CPU Cost "+abcPlan.getCPUCost());
			System.out.println("Cost "+ abcPlan.getCost());
			
		}catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
