/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.interfaces;

import java.util.Enumeration;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.classes.exceptions.JoinGraphException;

public interface JoinGraph {
	public Enumeration getVertices();
	public Enumeration getEdges();
	public void addVertex(Vertex _node);
	public void addEdge(Vertex _start, Vertex _end, double _value) throws JoinGraphException;
	public boolean hasEdge(Vertex _start, Vertex _end);
	public Edge getEdge(Vertex _start, Vertex _end)  throws JoinGraphException;
	public int getVerticesCount();
	public void print();
	public Vector<Edge> getEdges(Vertex _node);
	public Vector<Vertex> getNeighbors(Vertex _node);
	public void removeAllEdges();
	public void removeAllVertex();
	public Vertex getVertex(String _label);
	public Vector removeVertex(Vertex vertex);
	public void removeEdge(Edge edge);
}
