/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.classes;

import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.interfaces.RankedRootedTreeNode;

public class CombinedRankedNodeImpl extends RankedRootedTreeNodeImpl{
	
	private RankedRootedTreeNode head;
	private RankedRootedTreeNode tail;
	
	public CombinedRankedNodeImpl(RankedRootedTreeNode _head, RankedRootedTreeNode _tail)
	{
		super(null);
		this.head = _head;
		this.tail = _tail;
		this.setCValue(_head.getCValue() + (_head.getTValue() * _tail.getCValue()));
		this.setTValue(_head.getTValue() * _tail.getTValue());
		if(this.getCValue() ==0)
		{
			this.setRank(0);
		}else this.setRank((this.getTValue()-1)/this.getCValue());
		//System.out.println(this.getLabel()+"#"+this.getRank());
	}
	
	public RankedRootedTreeNode getHead()
	{
		return this.head;
	}
	
	public RankedRootedTreeNode getTail()
	{
		return this.tail;
	}
	
	public void printPretty()
	{
		if(this.getVertex() !=null)
		{
			System.out.print("["+this.getVertex().getLabel()+"]"+this.getRank()+"");
		}
		if(this.chidrenCount() >0)
		{
			System.out.print("(");
			for(int i=0; i< this.chidrenCount();i++)
			{
				((RankedRootedTreeNodeImpl)this.getChild(i)).printPretty();
			}
			System.out.print(")");
		}
	}
	
	public void print()
	{
		if((this.head!= null) && (this.tail !=null))
		{
			System.out.println("Label: "+this.getHead().getLabel()+this.getTail().getLabel()+" Rank: "+this.getRank());
		}else System.out.println(" NO LABEL ");
	}
	
}
