/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.classes;

import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.interfaces.Vertex;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.interfaces.RankedRootedTreeNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.interfaces.RootedTreeNode;

public class RankedRootedTreeNodeImpl extends RootedTreeNodeImpl implements RankedRootedTreeNode{

	private double rank = 0.0;
	private double tValue = 0.0;
	private double cValue = 0.0;

	public RankedRootedTreeNodeImpl(Vertex _source)
	{
		super(_source);
	}
	
	public double getRank()
	{
		return this.rank;
	}
	public void setRank(double _rank)
	{
		this.rank = _rank;
	}
	
	public double getCValue()
	{
		return this.cValue;
	}
	
	public void setCValue(double _cValue)
	{
		this.cValue = _cValue;
	}
	public double getTValue()
	{
		return this.tValue;
	}
	
	public void setTValue(double _tValue)
	{
		this.tValue = _tValue;
	}
	
	public void print()
	{
		if(this.getVertex() !=null)
		{
			System.out.println("Label: "+this.getVertex().getLabel()+" Rank: "+this.rank);
		}else System.out.println(" NO LABEL ");
	}
	
	public void printPretty()
	{
		if(this.getVertex() !=null)
		{
			System.out.print("["+this.getVertex().getLabel()+"]"+this.rank+"");
		}
		if(this.chidrenCount() >0)
		{
			System.out.print("(");
			for(int i=0; i< this.chidrenCount();i++)
			{
				((RankedRootedTreeNodeImpl)this.getChild(i)).printPretty();
			}
			System.out.print(")");
		}
	}
}
