/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.source.classes;

import java.io.Serializable;

import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.interfaces.SourceVertex;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.interfaces.SourceNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.source.interfaces.Source;

public class SourceImpl implements Source, Serializable{
	private String label;
    private double windowSize = 1.0;
	public SourceImpl(String _label)
	{
		this.label = _label;
	}
	
	public String getLabel()
	{
		return this.label;
	}
	
	public void setLabel(String _label)
	{
		this.label=_label;
	}
	public int chidrenCount()
	{
		return 0;
	}
	
	public Object getChild(int _index)
	{
		return null;
	}
	

	public double getWindowSize()
	{
		return this.windowSize;
	}
	public void setWindowSize(double _windowSize)
	{
		this.windowSize = _windowSize;
	}
	
	public void addChild(Object _child)
	{
		// TODO: Exception.
	}
	
	public void addChild(int _index, Object _child)
	{
		//TODO: Exception.
	}
	
	private double cardinality = 0.0;
	
	public void setCardinality(double _value)
	{
		this.cardinality = _value;
	}
	public double getCardinality()
	{
		return this.cardinality;
	}
	
	public void print()
	{
		System.out.print(this.label);
	}
	
	public void printPretty()
	{
		System.out.print(this.label);
	}
	
	
	public Object clone()
	{
		SourceImpl clone = new SourceImpl(this.label);
		clone.setCardinality(this.cardinality);
		return clone;
	}
	public void setValue(double _value)
	{
		this.setCardinality(_value);
	}
	
	public double getValue()
	{
		return this.getCardinality();
	}
	public void removeAllChildren()
	{
		//TODO:
	}
	public String toString()
	{
		return this.label;
	}

	public String toXmlString() 
	{
		return this.label;
	}
}
