/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer;

import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.classes.JoinGraphImpl;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.costmodel.CostEstimator;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.classes.BinaryJoinNodeImpl;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.graph.tree.classes.QueryPlan;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryoptimizer.source.streams.Stream;

public class stub {

	public static void main(String args[])
	{
		Stream r0 = new Stream("0");
		r0.setInputRate(6.0);
		
		Stream r1 = new Stream("1");
		r1.setInputRate(87.0);
		
		Stream r2 = new Stream("2");
		r2.setInputRate(65.0);
		
		Stream r3 = new Stream("3");
		r3.setInputRate(42.0);
		
		Stream r4 = new Stream("4");
		r4.setInputRate(83.0);
		
		JoinGraphImpl graph = new JoinGraphImpl();
		
		graph.addVertex(r0);
		graph.addVertex(r1);
		graph.addVertex(r2);
		graph.addVertex(r3);
		graph.addVertex(r4);
	
		BinaryJoinNodeImpl joinNode2 = new BinaryJoinNodeImpl();
		
		joinNode2.addChild(r0);
		joinNode2.addChild(r1);
		
		
		BinaryJoinNodeImpl joinNode3 = new BinaryJoinNodeImpl();
		
		joinNode3.addChild(r2);
		joinNode3.addChild(r3);
		
		BinaryJoinNodeImpl joinNode = new BinaryJoinNodeImpl();
		joinNode.addChild(joinNode3);
		joinNode.addChild(joinNode2);
		
		CostEstimator costEstimator = new CostEstimator();
		QueryPlan tempPlan = new QueryPlan(joinNode);
		
		try
		{
			graph.addEdge(r0,r1,0.65);
			graph.addEdge(r0,r2,0.53);
			graph.addEdge(r0,r3,0.43);
			graph.addEdge(r0,r4,0.18);
			
			graph.addEdge(r1,r2,0.56);
			graph.addEdge(r1,r3,0.01);
			graph.addEdge(r1,r4,0.37);
		
			graph.addEdge(r2,r3,0.45);
			graph.addEdge(r2,r4,0.14);
			
			graph.addEdge(r3,r4,0.97);
			
			graph.print();
			
			System.out.println(costEstimator.generateCost(tempPlan,graph));
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		
		/*
		System.out.println("Hello");
		Enumeration sourceEnum = tempPlan.getSources().elements();
		while(sourceEnum.hasMoreElements())
		{
			((Source) sourceEnum.nextElement()).print();
		}
		*/
	}
}
