/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queryplangenerator;

//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.event.Negation;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.event.SSC;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.event.SSC_OOO;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.firestream.streamoperator.MultipleInputQueueClusterOperatorImp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.firestream.streamoperator.WSInMOuStreamMovingAverageOperatorImpl;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.firestream.streamoperator.WSingleStreamMovingAverageOperatorImpl;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.firestream.streamoperator.WStreamSimpleMovingAverageOperatorImp;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Vector;
import java.util.Iterator;
import java.util.StringTokenizer;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.clustersheddy.ClusterSheddyJoinOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.clustersheddy.SingleClusterSheddyJoinState;
import edu.wpi.cs.dsrg.xmldb.xat.common.migration.probablisticjoinoperator.ChangingWBJoinOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.migration.probablisticjoinoperator.ProbabilisticWMJoinOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.migration.probablisticjoinoperator.WMJoinOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.migration.realjoinoperator.WTransitiveHashJoinOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.partitionstreamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestate.ProbabilisticPipeWFIFOState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestreamoperator.PipeStreamSelectOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestreamoperator.PipeWBinaryJoinOperator;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestreamoperator.RegularWBinaryJoinOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.pipestreamoperator.StreamWindowSplitOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.BasicHist;
import edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.DecisionTreeHeader;
import edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.HistogramBuilderOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.SampleStatsCollectorOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.StringBasicHist;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ComplexOperator.ChangingWBJoinOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.security.BinaryPWSingleEquiSCJoinOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.security.SinglePWSingleEquiSCJoinState;
import edu.wpi.cs.dsrg.xmldb.xat.common.security.StreamSecurityShieldOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.security.StreamSecurityShieldOperatorACMSettings;

//SECURITY (symmetric model)
import edu.wpi.cs.dsrg.xmldb.xat.common.security.fence.*;

//TAGGING
//import edu.wpi.cs.dsrg.xmldb.xat.common.tagging.TaggerOperatorImp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ComplexOperator.ProbabilisticWMJoinOperator;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ComplexOperator.WMJoinOperator;
import edu.wpi.cs.dsrg.STeM.STeMJoinProbeOperatorImp;
import edu.wpi.cs.dsrg.eddy.operator.EddyOperatorImp;
import edu.wpi.cs.dsrg.eddy.operator.EddyStreamSelectOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.execution.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.querymesh.selftuning.TrainingTupleCollectorOperatorImp;
import edu.wpi.cs.dsrg.Mjoin.*;
import edu.wpi.cs.dsrg.STeM.Partition.STeMPartitionJoinProbeOperatorImp;
import edu.wpi.cs.dsrg.STeM.Partition.STeMMultiStreamPartitionJoinProbeOperatorImp;
import edu.wpi.cs.dsrg.eddyBatch.operator.EddyPartitionOperatorImp;
import edu.wpi.cs.dsrg.eddyBatch.operator.DoNothingOperatorImp;

;
/**
 * This class contains visit methods that will help the
 * FromXMLFileQueryPlanGenerator to parse class variables. Every operator type
 * that has a class variable should have a visit here that will parse the XML.
 * This allows each operator to have its own encoding b/c making the encoding
 * generic is too hard and verbose.
 * 
 * @author: Brad Pielech
 */
public class ClassVariableVisitor extends
		edu.wpi.cs.dsrg.xmldb.xat.common.visitorpattern.TwoParamVisitor
		implements Serializable {

	private String expressionpackage = new String(
			"edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression");

	/** To visit a null object. */
	public Object dispatch() {
		return null;
	}

	/** To visit any object. */
	public Object dispatch(Object obj) {
		return null;
	}

	/** To visit two any objects. */
	public java.lang.Object dispatch(java.lang.Object obj1,
			java.lang.Object obj2) {
		return null;
	}

	/**
	 * Parses the expression that is encoded in the XML and returns an
	 * Expression object. Only simple expressions are supported currently- no
	 * Arithmetic expressions are parsed, only terminal, comparison, and, or
	 * expressions are supported. The root of the expression tree is returned.
	 * 
	 * @return Expression
	 * @param node
	 *            org.w3c.dom.Node
	 */
	private Hashtable parseExpression(Node node) throws Exception {

		/*
		 * // old format 1 <expression> <exptype id="1" type =
		 * "edu.wpi.cs.dsrg.xmldb.xat.common.expression.TerminalExpressionImp"
		 * value="$col1" valtype ="columnName" leftid = "" rightid = ""/>
		 * <exptype id="2" type =
		 * "edu.wpi.cs.dsrg.xmldb.xat.common.expression.TerminalExpressionImp"
		 * value="$col3" valtype ="columnName" leftid = "" rightid = ""/>
		 * <exptype id="3" type =
		 * "edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpressionImp"
		 * value="" valtype="4" leftid = "1" rightid = "2"/> </expression> //
		 * old format 2 <expression> <exptype id="1" type =
		 * "TerminalExpressionImp" qPosition="0" cPosition="0" value="" valtype
		 * ="column" leftid = "" rightid = ""/> <exptype id="2" type =
		 * "TerminalExpressionImp" qPosition="1" cPosition="0" value="" valtype
		 * ="column" leftid = "" rightid = ""/> <exptype id="3" type =
		 * "BinCOMPExpressionImp" qPosition="" cPosition="" value=""
		 * valtype="EQ" leftid = "1" rightid = "2"/> </expression> // new format
		 * <variable name="expression_id" value="3"> <expressions> <expr id="1"
		 * type = "TerminalExpressionImp" qPosition="0" cPosition="0" value=""
		 * valtype ="column" leftid = "" rightid = ""/> <expr id="2" type =
		 * "TerminalExpressionImp" qPosition="1" cPosition="0" value="" valtype
		 * ="column" leftid = "" rightid = ""/> <expr id="3" type =
		 * "BinCOMPExpressionImp" qPosition="" cPosition="" value=""
		 * valtype="EQ" leftid = "1" rightid = "2"/> </expressions>
		 */
		Hashtable expTable = new Hashtable();
		NodeList steps = node.getChildNodes();
		ExpressionStr root = null;
		boolean twoterminalseen = false;
		/** iterate through the variables */
		for (int i = 0; i < steps.getLength(); i++) {
			Node next = steps.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String id = ((Node) attrs.getNamedItem("id")).getNodeValue()
						.trim();
				String leftid = ((Node) attrs.getNamedItem("lid"))
						.getNodeValue().trim();
				String rightid = ((Node) attrs.getNamedItem("rid"))
						.getNodeValue().trim();
				String valType = ((Node) attrs.getNamedItem("valtype"))
						.getNodeValue().trim();
				String queuePosition = ((Node) attrs.getNamedItem("qPosition"))
						.getNodeValue().trim();
				String colPosition = ((Node) attrs.getNamedItem("cPosition"))
						.getNodeValue().trim();
				String value = ((Node) attrs.getNamedItem("value"))
						.getNodeValue().trim();
				/**
				 * create expression, if it is terminal exp then set the type
				 * the type's value then store in hashtable then if it is a bin
				 * exp, connect left and right by looking in hashtable
				 */
				String type = ((Node) attrs.getNamedItem("type"))
						.getNodeValue().trim();
				Object o1 = Class.forName(expressionpackage + "." + type)
						.newInstance();
				expTable.put(id, o1);
				// if we have a terminal expression, then store it in hashtable
				// and set up value

				if (o1 instanceof TerminalExpressionStr) {
					TerminalExpressionStr e1 = (TerminalExpressionStr) o1;

					if (valType.equalsIgnoreCase("column")) {
						// e1.setValue(new
						// edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnNameImp(value));
						e1.setIColumnPosition(Integer.parseInt(colPosition));
						e1.setIQueuePosition(Integer.parseInt(queuePosition));
					}
				} else if (o1 instanceof TerminalConstant) {
					TerminalConstant e1 = (TerminalConstant) o1;

					if (valType.equalsIgnoreCase("string")) {
						e1.setValue(value);
						e1.setType(6);
					}
					if (valType.equalsIgnoreCase("double")) {
						e1.setValue(Double.parseDouble(value));
						e1.setType(7);
					}
					if (valType.equalsIgnoreCase("long")) {
						e1.setValue(Long.parseLong(value));
						e1.setType(8);
					}
					if (valType.equalsIgnoreCase("integer")) {
						e1.setValue(Integer.parseInt(value));
						e1.setType(9);
					}
					if (valType.equalsIgnoreCase("boolean")) {
						e1.setValue(Boolean.getBoolean(value));
						e1.setType(10);
					}
				} else if (o1 instanceof BinBoolExpressionStr) {
					BinBoolExpressionStr bb = (BinBoolExpressionStr) o1;
					ExpressionStr left = (ExpressionStr) expTable.get(leftid);
					bb.setLeft(left);
					ExpressionStr right = (ExpressionStr) expTable.get(rightid);
					bb.setRight(right);
					if (o1 instanceof BinCOMPExpressionStr) {
						BinCOMPExpressionStr bc = (BinCOMPExpressionStr) o1;

						if (valType.equalsIgnoreCase("LT")
								|| valType.equals("<")) {
							bc.setType(0);
						} else if (valType.equalsIgnoreCase("GT")
								|| valType.equals(">")) {
							bc.setType(1);
						} else if (valType.equalsIgnoreCase("LEQ")
								|| valType.equals("<=")) {
							bc.setType(2);
						} else if (valType.equalsIgnoreCase("GEQ")
								|| valType.equals(">=")) {
							bc.setType(3);
						} else if (valType.equalsIgnoreCase("EQ")
								|| valType.equals("==") || valType.equals("=")) {
							bc.setType(4);
						} else if (valType.equalsIgnoreCase("NEQ")
								|| valType.equals("!=") || valType.equals("<>")) {
							bc.setType(5);
						} else
							throw new Exception("predicate type not supported!");
						// bc.setType(Integer.parseInt(valType));
					}
				} else if (o1 instanceof BinArithExpressionStr) {
					BinArithExpressionStr ba = (BinArithExpressionStr) o1;
					ExpressionStr left = (ExpressionStr) expTable.get(leftid);
					ba.setLeft(left);
					ExpressionStr right = (ExpressionStr) expTable.get(rightid);
					ba.setRight(right);
					ba.setType(valType.charAt(0));
				}
			}
		}
		return expTable;
	}

	public Object visit(ProbabilisticWindowJoinOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				Node idN = attrs.getNamedItem("size");
				String id = idN.getNodeValue();

				op.setTimeWindow(Long.parseLong(id));
			}
		}
		return null;
	}

	// added Bin @ Oct, 2004, for parsing Symmetric Mway Hash Join Operator
	public Object visit(SymmMwayHashJoinOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		// String expr_id = null;
		Vector exprIDs = new Vector();

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						// only for debug.
						expressionTable = parseExpression(next);
						// op.addJoinExpression(expression);
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						String expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						exprIDs.addElement(expr_id);
					}
				}
				/* pass other class vairables if necessary */
				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equalsIgnoreCase("time_window")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setWindowSize(value);
					continue;
				}
				if (name.equalsIgnoreCase("invalidate_interval")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setInvalidateInterval(value);
					continue;
				}
				// statistics_gathering
				if (name.equalsIgnoreCase("statistics_gathering")) {
					String val = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (val.equalsIgnoreCase("on"))
						op.turnonStatisticsCollecter();
					continue;
				}
			} // end if ELELMENT_NODE
		}
		for (int j = 0; j < exprIDs.size(); j++) {
			String expr_id = (String) exprIDs.elementAt(j);
			op.addJoinExpression((ExpressionStr) expressionTable.get(expr_id));
		}
		return null;
	}

	// Added by Song Wang @ Oct, 2005, for parsing PipeWBinaryJoinOperator.
	// This should be called for the 3 implementations as:
	// PipeWBinaryJoinOperatorHeadImp
	// PipeWBinaryJoinOperatorBodyImp
	// PipeWBinaryJoinOperatorTailImp

	public Object visit(PipeWBinaryJoinOperator op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		// String expr_id = null;
		Vector exprIDs = new Vector();
		String statetype = null;
		double selectivity = 0.0;
		int inputCounterStart = 0;
		int inputCounterWindowSize = 0;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						// only for debug.
						expressionTable = parseExpression(next);
						// op.addJoinExpression(expression);
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						String expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						exprIDs.addElement(expr_id);
					}
				}
				/* pass other class vairables if necessary */
				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equalsIgnoreCase("start_window")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setStartPoint(value, inputCounterStart);
					inputCounterStart++;
					continue;
				}
				if (name.equalsIgnoreCase("end_window")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setWindowSize(
							value - op.getStartPoint(inputCounterWindowSize),
							inputCounterWindowSize);
					inputCounterWindowSize++;
					continue;
				}
				if (name.equalsIgnoreCase("state_type")) {
					statetype = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					// op.initState(statetype);
					continue;
				}
				if (name.equalsIgnoreCase("selectivity")) {
					selectivity = Double.parseDouble(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					// op.initState(statetype);
				}
			} // end if ELELMENT_NODE
		}
		String expr_id = (String) exprIDs.elementAt(0);
		op.setExpression((ExpressionStr) expressionTable.get(expr_id));
		if (statetype != null)
			op.initState(statetype);
		if (selectivity != 0.0) {// only used for ProbabilisticPipeWFIFOState
			((ProbabilisticPipeWFIFOState) op.getLeftState())
					.setSelectivity(selectivity);
			((ProbabilisticPipeWFIFOState) op.getRightState())
					.setSelectivity(selectivity);
		}
		return null;
	}

	// Added by Song Wang @ Oct, 2005, for parsing StreamWindowSplitOperatorImp.
	public Object visit(StreamWindowSplitOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		// String expr_id = null;
		Vector exprIDs = new Vector();
		int inputCounterWindowSize = 0;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						// only for debug.
						expressionTable = parseExpression(next);
						// op.addJoinExpression(expression);
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						String expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						exprIDs.addElement(expr_id);
					}
				}
				/* pass other class vairables if necessary */
				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equalsIgnoreCase("windowSize")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.insertQuery(inputCounterWindowSize, value);
					inputCounterWindowSize++;
					continue;
				}
			} // end if ELELMENT_NODE
		}
		return null;
	}

	public Object visit(PipeStreamSelectOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
				}

				/* pass other class vairables if necessary */
				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equalsIgnoreCase("queueID")) {
					int value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setQueueID(value);
				}

			}
		}

		op.setExpression((ExpressionStr) expressionTable.get(expr_id));
		return null;
	}

	public Object visit(StreamSelectOperator op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
				}
			}
		}

		op.setExpression((ExpressionStr) expressionTable.get(expr_id));
		return null;
	}

	public Object visit(WBinaryJoinOperator op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
				}

				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equalsIgnoreCase("time_window")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setWindowSize(value);
					continue;
				}
				if (name.equalsIgnoreCase("state_type")) {
					String statetype = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.initState(statetype);
				}
			}
		}
		op.setExpression((ExpressionStr) expressionTable.get(expr_id));
		return null;
	}

	private double[][] parseSelectivity(Node node, int n) {

		double[][] selectivities = new double[n][n];

		NodeList steps = node.getChildNodes();

		// initialize selectivity matrix
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++)
				selectivities[i][j] = 1;
		}

		/** iterate through the variables */
		for (int i = 0; i < steps.getLength(); i++) {
			Node next = steps.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				int lindex = Integer
						.parseInt(((Node) attrs.getNamedItem("lid"))
								.getNodeValue().trim());
				int rindex = Integer
						.parseInt(((Node) attrs.getNamedItem("rid"))
								.getNodeValue().trim());
				double value = Double.parseDouble(((Node) attrs
						.getNamedItem("value")).getNodeValue().trim());
				selectivities[lindex][rindex] = value;
				selectivities[rindex][lindex] = value;
			}
		}
		return selectivities;
	}

	private double[] parseArrivalRates(Node node, int n) throws Exception {

		double[] rates = new double[n];
		int count = 0;

		NodeList steps = node.getChildNodes();

		// initialize selectivity matrix
		for (int i = 0; i < n; i++)
			rates[i] = 0;

		/** iterate through the variables */
		for (int i = 0; i < steps.getLength(); i++) {
			Node next = steps.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				int index = Integer.parseInt(((Node) attrs.getNamedItem("id"))
						.getNodeValue().trim());
				// the parsed value is tuple arrival interval, in the unit of
				// milleseconds (ms).
				double value = Double.parseDouble(((Node) attrs
						.getNamedItem("value")).getNodeValue().trim());

				// this computes the tuple arrival rate in tuples/sec
				rates[index] = 1000 / value;
				count++;
			}
		}

		if (count < n) {
			throw (new Exception(
					"ERROR!! not all streams intervals are set in the query plan config file."));
		}
		return rates;
	}

	public Object visit(ProbabilisticWMJoinOperator op, Node node) {
		NodeList classList = node.getChildNodes();
		int numinputs = 0;
		boolean ifSetNumInputs = false;
		double[][] selectivities = null;
		double[] arrivalRates = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {

				if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equalsIgnoreCase("numinput")) {
						numinputs = Integer.parseInt(((Node) attrs
								.getNamedItem("value")).getNodeValue());
						op.setNumOfInputs(numinputs);
						ifSetNumInputs = true;
						continue;
					}

					if (name.equalsIgnoreCase("running_mode")) {
						String mode = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						op.setRunningMode(mode);
						continue;
					}

					if (name.equalsIgnoreCase("usecartesianproduct")) {
						String value = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						if (value.equalsIgnoreCase("yes"))
							op.setCartesianProductStatus(true);
						else
							op.setCartesianProductStatus(false);
						continue;
					}

					if (name.equalsIgnoreCase("updateselectivity")) {
						String value = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						if (value.equalsIgnoreCase("yes"))
							op.setUpdateSelectivityStatus(true);
						else
							op.setUpdateSelectivityStatus(false);
						continue;
					}

					if (name.equalsIgnoreCase("time_window")) {
						long window = Long.parseLong(((Node) attrs
								.getNamedItem("value")).getNodeValue());
						op.setTimeWindow(window);
						continue;
					}

					if (name.equalsIgnoreCase("state_type")) {
						String value = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						try {
							op.setProperty("STATE_TYPE", value);
						} catch (Exception e) {
							e.printStackTrace();
						}
						continue;
					}

				}
				/* pass selectivity into a selectivity matrix */
				else if (next.getNodeName().equalsIgnoreCase("selectivities")) {
					if (ifSetNumInputs) {
						selectivities = parseSelectivity(next, numinputs);
						op.setSelectivityMatrix(selectivities);
					} else {
						System.out
								.println("The class variable number of inputs needs to be configured as the first class variable in the query plan config file.");
						System.out
								.println("ERROR!! Wrong query plan config file.");
						break;
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase(
						"arrivalintervals")) {
					if (ifSetNumInputs) {
						try {
							arrivalRates = parseArrivalRates(next, numinputs);
							op.setArrivalRates(arrivalRates);
						} catch (Exception e) {
							e.printStackTrace();
						}
					} else {
						System.out
								.println("The class variable number of inputs needs to be configured as the first class variable in the query plan config file.");
						System.out
								.println("ERROR!! Wrong query plan config file.");
						break;
					}
					continue;
				}
			}
		}

		// op.init();
		op.setupStates();
		op.computeProbeSequence();

		return null;
	}

	/*
	 * delta to complete and delta to delta Join Operator
	 */
	public Object visit(WindowBinaryJoinOperatorD2CExperiments op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		// String expr_id = null;
		Vector exprIDs = new Vector();
		String statetype = null;
		double selectivity = 0.0;
		int inputCounterStart = 0;
		int inputCounterWindowSize = 0;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						System.out.println("+++parsing Expressions+++");
						// only for debug.
						expressionTable = parseExpression(next);
						// op.addJoinExpression(expression);
					} catch (Exception e) {
						System.out.println("+++parsing Expressions+++");
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						String expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						exprIDs.addElement(expr_id);
					}
				}
				/* pass other class vairables if necessary */
				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equalsIgnoreCase("start_window")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setStartPoint(value, inputCounterStart);
					inputCounterStart++;
					continue;
				}
				if (name.equalsIgnoreCase("end_window")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setWindowSize(
							value - op.getStartPoint(inputCounterWindowSize),
							inputCounterWindowSize);
					inputCounterWindowSize++;
					continue;
				}
				if (name.equalsIgnoreCase("state_type")) {
					statetype = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					System.out.println("STATE TYPE: " + statetype);
					// op.initState(statetype);
					continue;
				}
				if (name.equalsIgnoreCase("selectivity")) {
					selectivity = Double.parseDouble(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					// op.initState(statetype);
				}
			} // end if ELEMENT_NODE
		}
		String expr_id = (String) exprIDs.elementAt(0);
		op.setExpression((ExpressionStr) expressionTable.get(expr_id));
		if (statetype != null)
			op.initState(statetype);
		if (selectivity != 0.0) {// only used for ProbabilisticPipeWFIFOState
			((ProbabilisticPipeWFIFOState) op.getLeftState())
					.setSelectivity(selectivity);
			((ProbabilisticPipeWFIFOState) op.getRightState())
					.setSelectivity(selectivity);
		}
		return null;
	}

	public Object visit(XATSingleQueueWindowStreamOperator operator, Node node) {
		long increment = 0;
		long time_window = 0;
		Vector col_pos = new Vector();

		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("increment")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					operator.setIncrement(value);
				} else if (name.equals("time_window")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					operator.setWindowSize(value);
				} else if (name.equals("column_pos")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					col_pos.add(new Integer(value));
				}
			}
		}

		if (operator instanceof WStreamGroupbyOperatorImp) {
			((WStreamGroupbyOperatorImp) operator).setGroupAttrPos(0,
					((Integer) col_pos.elementAt(0)).intValue());
		}
		return null;
	}

	public Object visit(PunctuationStreamPartitionWindowOperator operator,
			Node node) {
		Vector colPosList = new Vector();
		Vector funcList = new Vector();
		Vector funcPosList = new Vector();
		StreamFunction func = null;
		int winSize = 1;
		boolean debug = false, propagate = false;

		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("group_pos")) {
					colPosList.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.equals("function")) {
					String funcClass = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					try {
						func = (StreamFunction) Class.forName(funcClass)
								.newInstance();
					} catch (Exception e) {
						e.printStackTrace();
					}
					funcList.add(func);
				} else if (name.equals("function_pos")) {
					funcPosList.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.equals("window_size")) {
					winSize = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("debug")) {
					String str_debug = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_debug.equals("true")) {
						debug = true;
					}
				} else if (name.equals("propagate")) {
					String str_debug = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_debug.equals("true")) {
						propagate = true;
					}
				}
			}
		}

		int[] col_pos_int = new int[colPosList.size()];
		for (int i = 0; i < colPosList.size(); i++) {
			col_pos_int[i] = Integer.parseInt((String) colPosList.get(i));
		}

		int[] func_pos_int = new int[funcPosList.size()];
		for (int i = 0; i < funcPosList.size(); i++) {
			func_pos_int[i] = Integer.parseInt((String) funcPosList.get(i));
		}

		for (int i = 0; i < funcList.size(); i++) {
			((StreamFunction) funcList.get(i)).setAttrPos(func_pos_int[i]);
		}

		operator.setGroupAttrPosArray(col_pos_int);
		operator.setAggFunctions((StreamFunction[]) funcList
				.toArray(new StreamFunction[] {}));
		operator.setWindowSize(winSize);
		operator.setDebug(debug);
		operator.setPropagateFlag(propagate);

		PunctHashSingleAttributePartitionWinStateImp state = new PunctHashSingleAttributePartitionWinStateImp();
		state.setWindowSize(winSize);
		state.setIndexAttrPosArray(col_pos_int);

		operator.setState(new PunctAwareState[] { state });

		return null;
	}

	public Object visit(MultiQueuePunctGenOperator operator, Node node) {
		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("base_stream_pos")) {
					int baseStreamPos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					operator.setBaseStreamPos(baseStreamPos);
				} else if (name.equals("gen_stream_pos")) {
					int genStreamPos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					operator.setGenStreamPos(genStreamPos);
				} else if (name.equals("base_punct_attr_pos")) {
					int basePunctAttrPos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					operator.setBasePunctAttr(basePunctAttrPos);
				} else if (name.equals("get_punct_attr_pos")) {
					int genPunctAttrPos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					operator.setGenPunctAttr(genPunctAttrPos);
				} else if (name.equals("window_size")) {
					int winSize = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					operator.setWindow(winSize);
				} else if (name.equals("mesg_type")) {
					int mesgType = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					operator.setMesgType(mesgType);
				}
			}
		}
		return null;
	}

	public Object visit(PunctuationSingleAttributeGroupbyOperatorImp operator,
			Node node) {
		Vector colPosList = new Vector();
		Vector funcList = new Vector();
		Vector funcPosList = new Vector();
		StreamFunction func = null;
		int basic_window_size = Integer.MAX_VALUE;
		boolean debug = false, propagate = false;

		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("group_pos")) {
					colPosList.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.equals("function")) {
					String funcClass = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					try {
						func = (StreamFunction) Class.forName(funcClass)
								.newInstance();
					} catch (Exception e) {
						e.printStackTrace();
					}
					funcList.add(func);
				} else if (name.equals("function_pos")) {
					funcPosList.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.equals("debug")) {
					String str_debug = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_debug.equals("true")) {
						debug = true;
					}
				} else if (name.equals("basic_window_size")) {
					basic_window_size = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("propagate")) {
					String str_debug = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_debug.equals("true")) {
						propagate = true;
					}
				}
			}
		}

		int[] col_pos_int = new int[colPosList.size()];
		for (int i = 0; i < colPosList.size(); i++) {
			col_pos_int[i] = Integer.parseInt((String) colPosList.get(i));
		}

		int[] func_pos_int = new int[funcPosList.size()];
		for (int i = 0; i < funcPosList.size(); i++) {
			func_pos_int[i] = Integer.parseInt((String) funcPosList.get(i));
		}

		for (int i = 0; i < funcList.size(); i++) {
			((StreamFunction) funcList.get(i)).setAttrPos(func_pos_int[i]);
		}

		operator.setGroupAttrPosArray(col_pos_int);
		operator.setAggFunctions((StreamFunction[]) funcList
				.toArray(new StreamFunction[] {}));
		operator.setDebug(debug);
		operator.setPropagateFlag(propagate);

		PunctHashSingleAttributeGroupbyStateImp state = new PunctHashSingleAttributeGroupbyStateImp();
		state.setIndexAttrPosArray(col_pos_int);
		state.setBasicWindowSize(basic_window_size);
		operator.setState(new PunctAwareState[] { state });

		return null;
	}

	public Object visit(PunctuationStreamGroupbyOperatorImp operator, Node node) {
		Vector v_group_attr_pos = new Vector();
		Vector v_agg_func_class = new Vector();
		Vector v_agg_attr_pos = new Vector();
		String state_class = null;

		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.compareToIgnoreCase("group_attr_pos") == 0) {
					v_group_attr_pos.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.compareToIgnoreCase("agg_function") == 0) {
					v_agg_func_class.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.compareToIgnoreCase("agg_attr_pos") == 0) {
					v_agg_attr_pos.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.compareToIgnoreCase("state_class") == 0) {
					state_class = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
				}
			}
		}

		int numGroupAttrs = v_group_attr_pos.size();
		int[] groupAttrPosArray = new int[numGroupAttrs];
		for (int i = 0; i < numGroupAttrs; i++) {
			groupAttrPosArray[i] = Integer.parseInt((String) v_group_attr_pos
					.get(i));
		}

		int numAggFunctions = v_agg_func_class.size();
		StreamFunction[] aggFunctions = new StreamFunction[numAggFunctions];
		for (int i = 0; i < numAggFunctions; i++) {
			try {
				aggFunctions[i] = (StreamFunction) Class.forName(
						(String) v_agg_func_class.get(i)).newInstance();
			} catch (Exception e) {
				e.printStackTrace();
			}
			int aggAttrPos = Integer.parseInt((String) v_agg_attr_pos.get(i));
			aggFunctions[i].setAttrPos(aggAttrPos);
		}

		PunctGroupbyStateImp state = null;
		try {
			state = (PunctGroupbyStateImp) Class.forName(state_class)
					.newInstance();
		} catch (Exception e) {
			e.printStackTrace();
		}
		state.setIndexAttrPosArray(groupAttrPosArray);
		state.setAggFunctions(aggFunctions);

		operator.setGroupAttrPosArray(groupAttrPosArray);
		operator.setAggFunctions(aggFunctions);
		operator.setState(new PunctAwareState[] { state });

		return null;
	}

	public Object visit(
			PunctuationStreamGroupbyHybridIndexOperatorImp operator, Node node) {
		Vector v_group_attr_pos = new Vector();
		Vector v_index_type = new Vector();
		Vector v_index_attr_pos = new Vector();
		Vector v_agg_func_class = new Vector();
		Vector v_agg_attr_pos = new Vector();
		long window = 10000;

		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.compareToIgnoreCase("group_attr_pos") == 0) {
					v_group_attr_pos.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.compareToIgnoreCase("index_type") == 0) {
					v_index_type.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.compareToIgnoreCase("index_attr_pos") == 0) {
					v_index_attr_pos.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.compareToIgnoreCase("agg_function") == 0) {
					v_agg_func_class.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.compareToIgnoreCase("agg_attr_pos") == 0) {
					v_agg_attr_pos.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.compareToIgnoreCase("window") == 0) {
					window = Long
							.parseLong(((Node) attrs.getNamedItem("value"))
									.getNodeValue());
				}
			}
		}

		int numGroupAttrs = v_group_attr_pos.size();
		int[] groupAttrPosArray = new int[numGroupAttrs];
		for (int i = 0; i < numGroupAttrs; i++) {
			groupAttrPosArray[i] = Integer.parseInt((String) v_group_attr_pos
					.get(i));
		}

		String[] indexTypeArray = (String[]) v_index_type
				.toArray(new String[] {});

		int totalNumLevels = v_index_attr_pos.size();
		int[][] indexAttrPosArray = new int[totalNumLevels][];
		for (int i = 0; i < totalNumLevels; i++) {
			StringTokenizer st = new StringTokenizer(
					(String) v_index_attr_pos.get(i), ",");
			Vector v_pos = new Vector();
			while (st.hasMoreTokens()) {
				v_pos.add(st.nextToken());
			}
			int numTokens = v_pos.size();
			int[] indexAttrPos = new int[numTokens];
			for (int j = 0; j < numTokens; j++) {
				indexAttrPos[j] = Integer.parseInt((String) v_pos.get(j));
			}
			indexAttrPosArray[i] = indexAttrPos;
		}

		int numAggFunctions = v_agg_func_class.size();
		StreamFunction[] aggFunctions = new StreamFunction[numAggFunctions];
		for (int i = 0; i < numAggFunctions; i++) {
			try {
				aggFunctions[i] = (StreamFunction) Class.forName(
						(String) v_agg_func_class.get(i)).newInstance();
			} catch (Exception e) {
				e.printStackTrace();
			}
			int aggAttrPos = Integer.parseInt((String) v_agg_attr_pos.get(i));
			aggFunctions[i].setAttrPos(aggAttrPos);
		}

		PunctHybridIndexGroupbyStateImp state = new PunctHybridIndexGroupbyStateImp();
		state.setGroupAttrPosArray(groupAttrPosArray);
		state.setIndexTypeArray(indexTypeArray);
		state.setIndexAttrPosArray(indexAttrPosArray);
		state.setWindow(window);
		state.init();

		operator.setGroupAttrPosArray(groupAttrPosArray);
		operator.setAggFunctions(aggFunctions);
		operator.setState(new PunctAwareState[] { state });
		operator.setWindow(window);

		return null;
	}

	public Object visit(WPunctuationStreamGroupbyOperatorImp operator, Node node) {
		Vector colPosList = new Vector();
		Vector funcList = new Vector();
		Vector funcPosList = new Vector();
		StreamFunction func = null;
		long windowSize = Long.MAX_VALUE, increment = 1;
		int basic_window_size = Integer.MAX_VALUE;
		boolean debug = false, propagate = false;

		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("group_pos")) {
					colPosList.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.equals("function")) {
					String funcClass = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					try {
						func = (StreamFunction) Class.forName(funcClass)
								.newInstance();
					} catch (Exception e) {
						e.printStackTrace();
					}
					funcList.add(func);
				} else if (name.equals("function_pos")) {
					funcPosList.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.equals("window_size")) {
					windowSize = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("increment")) {
					increment = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("basic_window_size")) {
					basic_window_size = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("debug")) {
					String str_debug = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_debug.equals("true")) {
						debug = true;
					}
				} else if (name.equals("propagate")) {
					String str_debug = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_debug.equals("true")) {
						propagate = true;
					}
				}
			}
		}

		int[] col_pos_int = new int[colPosList.size()];
		for (int i = 0; i < colPosList.size(); i++) {
			col_pos_int[i] = Integer.parseInt((String) colPosList.get(i));
		}

		int[] func_pos_int = new int[funcPosList.size()];
		for (int i = 0; i < funcPosList.size(); i++) {
			func_pos_int[i] = Integer.parseInt((String) funcPosList.get(i));
		}

		for (int i = 0; i < funcList.size(); i++) {
			((StreamFunction) funcList.get(i)).setAttrPos(func_pos_int[i]);
		}

		operator.setGroupAttrPosArray(col_pos_int);
		operator.setAggFunctions((StreamFunction[]) funcList
				.toArray(new StreamFunction[] {}));
		operator.setWindowSize(windowSize);
		operator.setIncrement(increment);
		operator.setDebug(debug);
		operator.setPropagateFlag(propagate);

		PunctHashSingleAttributeGroupbyStateImp state = new PunctHashSingleAttributeGroupbyStateImp();
		state.setIndexAttrPosArray(col_pos_int);
		state.setBasicWindowSize(basic_window_size);
		operator.setState(new PunctAwareState[] { state });

		return null;
	}

	public Object visit(PunctuationStreamDistinctOperator operator, Node node) {
		int index_attr_pos = 0;
		boolean debug = false;
		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("index_attr_pos")) {
					index_attr_pos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("debug")) {
					String str_debug = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_debug.equals("true")) {
						debug = true;
					} else {
						debug = false;
					}
					// debug = Boolean.getBoolean(((Node)
					// attrs.getNamedItem("value")).getNodeValue());
				}
			}
		}
		operator.setIndexAttrPos(index_attr_pos);
		PunctHashDistinctStateImp state = new PunctHashDistinctStateImp();
		state.setIndexAttrPosArray(new int[] { index_attr_pos });
		operator.setState(new PunctAwareState[] { state });
		operator.setDebug(debug);
		return null;
	}

	public Object visit(BinaryPunctuationStreamSingleEquiJoinOperator operator,
			Node node) {
		String left_state_class = null, right_state_class = null;
		int left_join_attr_pos = 0, right_join_attr_pos = 0;
		int purge_threshold = 1, propagate_threshold = 1, memory_limit = Integer.MAX_VALUE;
		boolean debug = false, propagate = false;
		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("left_join_pos")) {
					left_join_attr_pos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("right_join_pos")) {
					right_join_attr_pos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("left_state")) {
					left_state_class = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
				} else if (name.equals("right_state")) {
					right_state_class = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
				} else if (name.equals("propagate_threshold")) {
					propagate_threshold = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("purge_threshold")) {
					purge_threshold = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("debug")) {
					String str_debug = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_debug.equals("true")) {
						debug = true;
					}
					// debug = Boolean.getBoolean(((Node)
					// attrs.getNamedItem("value")).getNodeValue());
				} else if (name.equals("memory_limit")) {
					String str_mem_limit = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (!str_mem_limit.equals("-1")) {
						memory_limit = Integer.parseInt(str_mem_limit);
					}
				} else if (name.equals("propagate")) {
					String str_propagate = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_propagate.equals("true")) {
						propagate = true;
					}
				}
			}
		}
		operator.setLeftJoinAttrPos(left_join_attr_pos);
		operator.setRightJoinAttrPos(right_join_attr_pos);
		operator.setPropagateThreshold(propagate_threshold);
		operator.setPurgeThreshold(purge_threshold);
		operator.setMemoryLimit(memory_limit);
		operator.setDebug(debug);
		operator.setPropagateFlag(propagate);

		try {
			PunctHashSingleEquiJoinState leftState = (PunctHashSingleEquiJoinState) Class
					.forName(left_state_class).newInstance();
			PunctHashSingleEquiJoinState rightState = (PunctHashSingleEquiJoinState) Class
					.forName(right_state_class).newInstance();
			// Constructor[] construct =
			// Class.forName(left_state_class).getConstructors();
			// PunctHashSingleEquiJoinState leftState =
			// (PunctHashSingleEquiJoinState)construct[0].newInstance(new
			// Object[]{});
			// construct = Class.forName(right_state_class).getConstructors();
			// PunctHashSingleEquiJoinState rightState =
			// (PunctHashSingleEquiJoinState)construct[0].newInstance(new
			// Object[]{});
			operator.setState(new PunctHashSingleEquiJoinState[] { leftState,
					rightState });
		} catch (Exception e) {
			e.printStackTrace();
		}

		return null;
	}

	// Security-Compliant Join Operator (SCJoin)
	public Object visit(BinaryPWSingleEquiSCJoinOperator operator, Node node) {
		String left_state_class = null, right_state_class = null;
		int left_join_attr_pos = 0, right_join_attr_pos = 0;
		int invalidate_threshold = 1, purge_threshold = 1, memory_limit = Integer.MAX_VALUE;
		long left_window_size = Long.MAX_VALUE, right_window_size = Long.MAX_VALUE;
		boolean debug = false, propagate = false;

		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("left_join_pos")) {
					left_join_attr_pos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("right_join_pos")) {
					right_join_attr_pos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("left_window_size")) {
					String str_left_window_size = ((Node) attrs
							.getNamedItem("value")).getNodeValue();
					if (!str_left_window_size.equals("-1")) {
						left_window_size = Long.parseLong(str_left_window_size);
					}
				} else if (name.equals("right_window_size")) {
					String str_right_window_size = ((Node) attrs
							.getNamedItem("value")).getNodeValue();
					if (!str_right_window_size.equals("-1")) {
						right_window_size = Long
								.parseLong(str_right_window_size);
					}
				} else if (name.equals("left_state")) {
					left_state_class = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
				} else if (name.equals("right_state")) {
					right_state_class = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
				} else if (name.equals("invalidate_threshold")) {
					invalidate_threshold = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("purge_threshold")) {
					purge_threshold = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("debug")) {
					String str_debug = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_debug.equals("true")) {
						debug = true;
					}
				} else if (name.equals("memory_limit")) {
					String str_mem_limit = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (!str_mem_limit.equals("-1")) {
						memory_limit = Integer.parseInt(str_mem_limit);
					}
				} else if (name.equals("propagate")) {
					String str_propagate = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_propagate.equals("true")) {
						propagate = true;
					}
				}
			}
		}
		operator.setLeftJoinAttrPos(left_join_attr_pos);
		operator.setRightJoinAttrPos(right_join_attr_pos);
		operator.setWindowSizeArray(new long[] { left_window_size,
				right_window_size });
		operator.setInvalidateThreshold(invalidate_threshold);
		// operator.setPurgeThreshold(purge_threshold);
		operator.setDebug(debug);
		operator.setPropagateFlag(propagate);

		try {
			SinglePWSingleEquiSCJoinState leftState = (SinglePWSingleEquiSCJoinState) Class
					.forName(left_state_class).newInstance();
			// Constructor[] construct =
			// Class.forName(left_state_class).getConstructors();
			// SinglePWSingleEquiJoinState leftState =
			// (SinglePWSingleEquiJoinState)construct[0].newInstance(new
			// Object[]{});
			INodeIndex leftIndex = new HashIndexImp();
			leftState.setIndex(leftIndex);
			leftState.setJoinAttrPos(left_join_attr_pos);

			SinglePWSingleEquiSCJoinState rightState = (SinglePWSingleEquiSCJoinState) Class
					.forName(right_state_class).newInstance();
			// construct = Class.forName(right_state_class).getConstructors();
			// SinglePWSingleEquiJoinState rightState =
			// (SinglePWSingleEquiJoinState)construct[0].newInstance(new
			// Object[]{});
			INodeIndex rightIndex = new HashIndexImp();
			rightState.setIndex(rightIndex);
			rightState.setJoinAttrPos(right_join_attr_pos);
			operator.setState(new SinglePWSingleEquiSCJoinState[] { leftState,
					rightState });
		} catch (Exception e) {
			System.out.print(e.getStackTrace());
		}

		return null;
	}

	// Parses Security Settings (Associated Operators) for SS operator settings
	private Hashtable parseSecuritySettingsAssociatedOperators(Node node)
			throws Exception {

		/*
		 * //format <!-- associated processing operators --> <ap_operators>
		 * <ap_operator id="2"/> </ap_operators>
		 */
		Hashtable apoTable = new Hashtable();
		NodeList steps = node.getChildNodes();

		/** iterate through the variables */
		for (int i = 0; i < steps.getLength(); i++) {
			Node next = steps.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String id = ((Node) attrs.getNamedItem("id")).getNodeValue()
						.trim();

				apoTable.put("op" + i, id);
			}
		}
		return apoTable;
	}

	// Parses Security Settings (Associated Access Control Models for the
	// Security Shield (SS) Operator)
	private Hashtable parseSecuritySettingsAssociatedACM(Node node)
			throws Exception {
		/*
		 * //format <access_control_models> <!-- associated processing roles -->
		 * <access_control_model name="RBAC"> <acm_element type="role"
		 * value="R1"/> <acm_element type="role" value="R2"/>
		 * </access_control_model>
		 * 
		 * <!-- associated processing purposes --> <access_control_model
		 * name="PBAC"> <acm_element type="purpose" value="P1"/> <acm_element
		 * type="purpose" value="P2"/> </access_control_model>
		 * </access_control_models>
		 */
		Hashtable acmTable = new Hashtable();
		NodeList steps = node.getChildNodes();
		String acmName = "";
		Vector acmElements = new Vector();

		/** iterate through the variables */
		for (int i = 0; i < steps.getLength(); i++) {
			Node next = steps.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				if (next.getNodeName() == "access_control_model") {
					NamedNodeMap attrs = next.getAttributes();
					acmName = ((Node) attrs.getNamedItem("name"))
							.getNodeValue().trim();
					acmElements = new Vector();

					NodeList internalElements = next.getChildNodes();
					for (int j = 0; j < internalElements.getLength(); j++) {
						Node internalNext = internalElements.item(j);
						if (internalNext.getNodeType() == Node.ELEMENT_NODE) {
							if (internalNext.getNodeName() == "acm_element") {
								NamedNodeMap internalAttrs = internalNext
										.getAttributes();
								String type = ((Node) internalAttrs
										.getNamedItem("type")).getNodeValue()
										.trim();
								String value = ((Node) internalAttrs
										.getNamedItem("value")).getNodeValue()
										.trim();

								acmElements
										.add(new StreamSecurityShieldOperatorACMSettings(
												acmName, type, value));
							}
						}
					}// end for

					// add an access control model and all of its elements into
					// the hash table
					acmTable.put(new String(acmName.toString()), acmElements);
				}
			}
		}
		return acmTable;
	}

	// Security Shield Operator (SS Operator)
	public Object visit(StreamSecurityShieldOperator op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable apOperatorsTable = new Hashtable();
		Hashtable acmSettingsTable = new Hashtable();
		String expr_id = null;

		Hashtable associatedProcessingOperators = new Hashtable();
		Hashtable accessControlModelsTable = new Hashtable();
		String propagateFurtherFlag = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass security expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("sec_settings")) {
					try {
						NodeList secSettingsList = next.getChildNodes();

						for (int j = 0; j < secSettingsList.getLength(); j++) {
							Node nextSecSettingNode = secSettingsList.item(j);

							if (nextSecSettingNode.getNodeType() == Node.ELEMENT_NODE) {
								if (nextSecSettingNode.getNodeName()
										.equalsIgnoreCase("ap_operators")) {
									// parse associated processing operators
									apOperatorsTable = parseSecuritySettingsAssociatedOperators(nextSecSettingNode);
								}
								if (nextSecSettingNode.getNodeName()
										.equalsIgnoreCase(
												"access_control_models")) {
									// parse associated access control models
									accessControlModelsTable = parseSecuritySettingsAssociatedACM(nextSecSettingNode);
								} else if (nextSecSettingNode.getNodeName()
										.equalsIgnoreCase("propagate_sp")) {
									NamedNodeMap attrs = nextSecSettingNode
											.getAttributes();
									propagateFurtherFlag = ((Node) attrs
											.getNamedItem("value"))
											.getNodeValue();

								}

							}// end if
						}// end for
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				}
			}
		}

		// set associated processing operators
		op.setAssociatedProcessingOperators(apOperatorsTable);

		// set associated access control models
		op.setAssociatedAccessControlModels(accessControlModelsTable);

		// set propagate security punctuations further flag
		op.setPropagateSPFurtherFlag(propagateFurtherFlag);
		return null;
	}

	public Object visit(BinaryPWSingleEquiJoinOperator operator, Node node) {
		String left_state_class = null, right_state_class = null;
		int left_join_attr_pos = 0, right_join_attr_pos = 0;
		int invalidate_threshold = 1, purge_threshold = 1, memory_limit = Integer.MAX_VALUE;
		long left_window_size = Long.MAX_VALUE, right_window_size = Long.MAX_VALUE;
		boolean debug = false, propagate = false;

		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("left_join_pos")) {
					left_join_attr_pos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("right_join_pos")) {
					right_join_attr_pos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("left_window_size")) {
					String str_left_window_size = ((Node) attrs
							.getNamedItem("value")).getNodeValue();
					if (!str_left_window_size.equals("-1")) {
						left_window_size = Long.parseLong(str_left_window_size);
					}
				} else if (name.equals("right_window_size")) {
					String str_right_window_size = ((Node) attrs
							.getNamedItem("value")).getNodeValue();
					if (!str_right_window_size.equals("-1")) {
						right_window_size = Long
								.parseLong(str_right_window_size);
					}
				} else if (name.equals("left_state")) {
					left_state_class = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
				} else if (name.equals("right_state")) {
					right_state_class = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
				} else if (name.equals("invalidate_threshold")) {
					invalidate_threshold = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("purge_threshold")) {
					purge_threshold = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("debug")) {
					String str_debug = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_debug.equals("true")) {
						debug = true;
					}
				} else if (name.equals("memory_limit")) {
					String str_mem_limit = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (!str_mem_limit.equals("-1")) {
						memory_limit = Integer.parseInt(str_mem_limit);
					}
				} else if (name.equals("propagate")) {
					String str_propagate = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_propagate.equals("true")) {
						propagate = true;
					}
				}
			}
		}
		operator.setLeftJoinAttrPos(left_join_attr_pos);
		operator.setRightJoinAttrPos(right_join_attr_pos);
		operator.setWindowSizeArray(new long[] { left_window_size,
				right_window_size });
		operator.setInvalidateThreshold(invalidate_threshold);
		operator.setPurgeThreshold(purge_threshold);
		operator.setDebug(debug);
		operator.setPropagateFlag(propagate);

		try {
			SinglePWSingleEquiJoinState leftState = (SinglePWSingleEquiJoinState) Class
					.forName(left_state_class).newInstance();
			// Constructor[] construct =
			// Class.forName(left_state_class).getConstructors();
			// SinglePWSingleEquiJoinState leftState =
			// (SinglePWSingleEquiJoinState)construct[0].newInstance(new
			// Object[]{});
			INodeIndex leftIndex = new HashIndexImp();
			leftState.setIndex(leftIndex);
			leftState.setJoinAttrPos(left_join_attr_pos);

			SinglePWSingleEquiJoinState rightState = (SinglePWSingleEquiJoinState) Class
					.forName(right_state_class).newInstance();
			// construct = Class.forName(right_state_class).getConstructors();
			// SinglePWSingleEquiJoinState rightState =
			// (SinglePWSingleEquiJoinState)construct[0].newInstance(new
			// Object[]{});
			INodeIndex rightIndex = new HashIndexImp();
			rightState.setIndex(rightIndex);
			rightState.setJoinAttrPos(right_join_attr_pos);
			operator.setState(new SinglePWSingleEquiJoinState[] { leftState,
					rightState });
		} catch (Exception e) {
			e.printStackTrace();
		}

		return null;
	}

	public Object visit(BinaryWSingleEquiJoinOperator operator, Node node) {
		String left_state_class = null, right_state_class = null;
		int left_join_attr_pos = 0, right_join_attr_pos = 0;
		int invalidate_threshold = 1;
		long left_window_size = Long.MAX_VALUE, right_window_size = Long.MAX_VALUE;

		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("left_join_pos")) {
					left_join_attr_pos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("right_join_pos")) {
					right_join_attr_pos = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				} else if (name.equals("left_window_size")) {
					String str_left_window_size = ((Node) attrs
							.getNamedItem("value")).getNodeValue();
					if (!str_left_window_size.equals("-1")) {
						left_window_size = Long.parseLong(str_left_window_size);
					}
				} else if (name.equals("right_window_size")) {
					String str_right_window_size = ((Node) attrs
							.getNamedItem("value")).getNodeValue();
					if (!str_right_window_size.equals("-1")) {
						right_window_size = Long
								.parseLong(str_right_window_size);
					}
				} else if (name.equals("left_state")) {
					left_state_class = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
				} else if (name.equals("right_state")) {
					right_state_class = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
				} else if (name.equals("invalidate_threshold")) {
					invalidate_threshold = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
				}
			}
		}
		operator.setLeftJoinAttrPos(left_join_attr_pos);
		operator.setRightJoinAttrPos(right_join_attr_pos);
		operator.setWindowSizeArray(new long[] { left_window_size,
				right_window_size });
		operator.setInvalidateThreshold(invalidate_threshold);

		try {
			WEquiJoinState leftState = (WEquiJoinState) Class.forName(
					left_state_class).newInstance();
			// Constructor[] construct =
			// Class.forName(left_state_class).getConstructors();
			// SinglePWSingleEquiJoinState leftState =
			// (SinglePWSingleEquiJoinState)construct[0].newInstance(new
			// Object[]{});
			leftState.setJoinAttrPos(left_join_attr_pos);
			leftState.setWindowSize(left_window_size);

			WEquiJoinState rightState = (WEquiJoinState) Class.forName(
					right_state_class).newInstance();
			// construct = Class.forName(right_state_class).getConstructors();
			// SinglePWSingleEquiJoinState rightState =
			// (SinglePWSingleEquiJoinState)construct[0].newInstance(new
			// Object[]{});
			rightState.setJoinAttrPos(right_join_attr_pos);
			rightState.setWindowSize(right_window_size);
			operator.setState(new WEquiJoinState[] { leftState, rightState });
		} catch (Exception e) {
			e.printStackTrace();
		}

		return null;
	}

	public Object visit(StreamProjectOperator operator, Node node) {
		Vector project_col_array = new Vector();
		boolean debug = false;
		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("project_attr")) {
					project_col_array.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.equals("debug")) {
					String str_debug = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (str_debug.equals("true")) {
						debug = true;
					} else {
						debug = false;
					}
					// debug = Boolean.getBoolean(((Node)
					// attrs.getNamedItem("value")).getNodeValue());
				}
			}
		}

		String[] retainAttrNames = (String[]) project_col_array
				.toArray(new String[] {});
		operator.setRetainAttrNames(retainAttrNames);
		operator.setDebug(debug);

		return null;
	}

	public Object visit(StreamProjectFunctionOperator operator, Node node) {
		Vector project_col_array = new Vector();
		boolean debug = false;
		NodeList variableList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		Vector expr_id_array = new Vector();

		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {

				if (next.getNodeName().equals("expressions")) {
					try {
						expressionTable = parseExpression(next);
					} catch (Exception e) {
						e.printStackTrace();
					}
				} else if (next.getNodeName().equals("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("project_attr")) {
						project_col_array.add(((Node) attrs
								.getNamedItem("value")).getNodeValue());
					} else if (name.equals("expression_id")) {
						expr_id_array.add(((Node) attrs.getNamedItem("value"))
								.getNodeValue());
					} else if (name.equals("debug")) {
						String str_debug = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						if (str_debug.equals("true")) {
							debug = true;
						} else {
							debug = false;
						}
					}
				}
			}
		}

		String[] retainAttrNames = (String[]) project_col_array
				.toArray(new String[] {});
		operator.setRetainAttrNames(retainAttrNames);
		operator.setDebug(debug);
		ExpressionStr[] expressions = new ExpressionStr[expr_id_array.size()];
		Iterator it = expr_id_array.iterator();
		int cursor = 0;
		while (it.hasNext()) {
			String expr_id = (String) it.next();
			ExpressionStr expr = (ExpressionStr) expressionTable.get(expr_id);
			expr.setName("expr_" + expr_id);
			expressions[cursor] = expr;
			cursor++;
		}
		operator.setExpression(expressions);
		return null;
	}

	public Object visit(XATMultiQueueWindowStreamOperator operator, Node node) {
		long increment = 0;
		long time_window = 0;

		NodeList variableList = node.getChildNodes();
		for (int i = 0; i < variableList.getLength(); i++) {
			Node next = variableList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equals("increment")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					operator.setIncrement(value);
				} else if (name.equals("time_window")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					operator.setWindowSize(value);
				}
			}
		}
		return null;
	}

	public Object visit(SchemaNameChangeOperator operator, Node node) {
		NodeList classList = node.getChildNodes();
		String streamName = null;
		Vector colNames = new Vector();

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();
				if (name.equals("stream_name")) {
					operator.setStreamName(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				} else if (name.equals("col_name")) {
					colNames.add(((Node) attrs.getNamedItem("value"))
							.getNodeValue());
				}
			}
		}
		operator.setColNames((String[]) colNames.toArray(new String[] {}));
		return null;
	}

	public Object visit(ChangingWBJoinOperatorImp operator, Node node) {
		NodeList classList = node.getChildNodes();

		// System.out.println("Visiting ChangingWBJoinOperatorImp!");

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {

				if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equalsIgnoreCase("time_window")) {
						long window = Long.parseLong(((Node) attrs
								.getNamedItem("value")).getNodeValue());
						operator.setTimeWindow(window);
						continue;
					}

					if (name.equalsIgnoreCase("select_rand_seed")) {
						operator.setSelectRandSeed(((Node) attrs
								.getNamedItem("value")).getNodeValue());
					}

					if (name.equalsIgnoreCase("select_trend")) {
						operator.setSelectTrend(((Node) attrs
								.getNamedItem("value")).getNodeValue());
					}
				}
			}
		}
		return null;
	}

	public Object visit(WMJoinOperator op, Node node) {
		NodeList classList = node.getChildNodes();
		int numinputs = 0;
		boolean ifSetNumInputs = false;
		double[][] selectivities = null;
		double[] arrivalRates = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {

				if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equalsIgnoreCase("numinput")) {
						numinputs = Integer.parseInt(((Node) attrs
								.getNamedItem("value")).getNodeValue());
						op.setNumOfInputs(numinputs);
						ifSetNumInputs = true;
						continue;
					}

					if (name.equalsIgnoreCase("running_mode")) {
						String mode = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						op.setRunningMode(mode);
						continue;
					}

					if (name.equalsIgnoreCase("optimization_method")) {
						String opmethod = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						op.setOptimizationMethod(opmethod);
						continue;
					}

					if (name.equalsIgnoreCase("usecartesianproduct")) {
						String value = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						if (value.equalsIgnoreCase("yes"))
							op.setCartesianProductStatus(true);
						else
							op.setCartesianProductStatus(false);
						continue;
					}

					if (name.equalsIgnoreCase("updateselectivity")) {
						String value = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						if (value.equalsIgnoreCase("yes"))
							op.setUpdateSelectivityStatus(true);
						else
							op.setUpdateSelectivityStatus(false);
						continue;
					}

					if (name.equalsIgnoreCase("time_window")) {
						long window = Long.parseLong(((Node) attrs
								.getNamedItem("value")).getNodeValue());
						op.setTimeWindow(window);
						continue;
					}

					if (name.equalsIgnoreCase("state_type")) {
						String value = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						try {
							op.setProperty("STATE_TYPE", value);
						} catch (Exception e) {
							e.printStackTrace();
						}
						continue;
					}

				}
				/* pass selectivity into a selectivity matrix */
				else if (next.getNodeName().equalsIgnoreCase("selectivities")) {
					if (ifSetNumInputs) {
						selectivities = parseSelectivity(next, numinputs);
						op.setSelectivityMatrix(selectivities);
					} else {
						System.out
								.println("The class variable number of inputs needs to be configured as the first class variable in the query plan config file.");
						System.out
								.println("ERROR!! Wrong query plan config file.");
						break;
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase(
						"arrivalintervals")) {
					if (ifSetNumInputs) {
						try {
							arrivalRates = parseArrivalRates(next, numinputs);
							op.setArrivalRates(arrivalRates);
						} catch (Exception e) {
							e.printStackTrace();
						}
					} else {
						System.out
								.println("The class variable number of inputs needs to be configured as the first class variable in the query plan config file.");
						System.out
								.println("ERROR!! Wrong query plan config file.");
						break;
					}
					continue;
				}
			}
		}

		// op.init();
		op.setupStates();
		op.computeProbeSequence();

		return null;
	}

	// Added by Yali Zhu @ Feb 20, 2006
	public Object visit(WTransitiveHashJoinOperator op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		// String expr_id = null;
		Vector exprIDs = new Vector();

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						// only for debug.
						expressionTable = parseExpression(next);
						// op.addJoinExpression(expression);
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						String expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
						exprIDs.addElement(expr_id);
					}
				}
				/* pass other class vairables if necessary */
				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equalsIgnoreCase("number_of_partition")) {
					int value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					// op.setNumberOfPartitions(value);
					continue;
				}

				if (name.equalsIgnoreCase("time_window")) {
					long value = Long.parseLong(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setWindowSize(value);
					continue;
				}

				// if(name.equalsIgnoreCase("invalidate_interval")) {
				// long value = Long.parseLong(((Node)
				// attrs.getNamedItem("value")).getNodeValue());
				// op.setInvalidateInterval(value);
				// continue;
				// }
				if (name.equalsIgnoreCase("statistics_gathering")) {
					String val = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (val.equalsIgnoreCase("on"))
						op.turnonStatisticsCollecter();
					continue;
				}

				if (name.equalsIgnoreCase("fastpurge_during_PTRedistribution")) {
					String val = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (val.equalsIgnoreCase("true"))
						op.turnonFastPurge();
					continue;
				}

				if (name.equalsIgnoreCase("fastpurge_count_interval")) {
					String val = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.setFastPurgeCountInterval(Integer.parseInt(val));
					continue;
				}

				if (name.equalsIgnoreCase("is_only_join")) {
					String val = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					if (val.equalsIgnoreCase("true"))
						op.setIsOnlyJoinInPlan(true);
					continue;
				}

			} // end if ELELMENT_NODE
		}
		for (int j = 0; j < exprIDs.size(); j++) {
			String expr_id = (String) exprIDs.elementAt(j);
			op.addJoinExpression((ExpressionStr) expressionTable.get(expr_id));
		}
		return null;
	}

	// Added by Karen Works @ Sept, 2007
	public Object visit(edu.wpi.cs.dsrg.eddy.operator.EddyOperatorImp op,
			Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
				}

				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equalsIgnoreCase("Num_Streams")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumStreams(value);
					continue;
				} else if (name.equalsIgnoreCase("Router")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.setRouter(value);
					continue;
				} else if (name.equalsIgnoreCase("Num_Operators")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumOps(value);
					continue;
				} else if (name.equalsIgnoreCase("Operator_STREAMIds")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.setOpStringIds(value);
					continue;
				} else if (name.equalsIgnoreCase("NumTupToProcessPerOp")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumTupToProcessPerOp(value);
					continue;
				} else if (name.equalsIgnoreCase("NumTupToProcess")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumTupToProcess(value);
					continue;
				} else if (name.equalsIgnoreCase("NumLevelsToProcess")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumLevelsToProcess(value);
					continue;
				} else if (name
						.equalsIgnoreCase("UseFlipFlopTupleProcStrategy")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setFlipFlopTupleProcStrategy(value);
					continue;
				} else if (name.equalsIgnoreCase("UseTupleProcTopStrategy")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setUseTupleProcTopStrategy(value);
					continue;
				} else if (name.startsWith("Stream")) {
					Integer streamQueueid = Integer.parseInt(((Node) attrs
							.getNamedItem("QueueId")).getNodeValue());
					Integer windowSize = Integer.parseInt(((Node) attrs
							.getNamedItem("window_size")).getNodeValue());
					op.AddSTREAMWindowCount(streamQueueid, windowSize);
					continue;

				}

			}
		}

		return null;
	}

	// Added by Karen Works @ Sept, 2007
	public Object visit(STeMJoinProbeOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
				}

				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();
				if (name.equalsIgnoreCase("EddyOpBitsPos")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.EddySetOpBitsPos(value);
					continue;
				} else if (name.equalsIgnoreCase("NumSTeMIndex")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.SetNumSTeMIndex(value);
					continue;
				} else if (name.equalsIgnoreCase("NumTupleIndex")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.SetNumTupleIndex(value);
					continue;
				} else if (name.equalsIgnoreCase("IsEddyOp")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.SetIsEddyOp(value);
					continue;
				} else if (name.equalsIgnoreCase("ProbeSTREAMId")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.SetProbeSTREAMId(value);
					continue;
				} else if (name.equalsIgnoreCase("STeMSTREAMId")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.SetDataSTREAMId(value);
					continue;
				} else if (name.equalsIgnoreCase("QMeshOperatorID")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setQMeshOperatorID(value);
					continue;
				}

			}
		}
		return null;
	}

	// Added by Karen Works @ Sept, 2007
	public Object visit(EddyStreamSelectOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
				}
				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();
				if (name.equalsIgnoreCase("EddyOpBitsPos")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.EddySetOpBitsPos(value);
					continue;
				} else if (name.equalsIgnoreCase("StreamID")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.SetStreamID(value);
					continue;
				}

			}
		}

		op.setExpression((ExpressionStr) expressionTable.get(expr_id));
		return null;
	}

	// Rimma V. Nehme - sampling operator (and its input parameters)
	public Object visit(HistogramBuilderOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable histogramsTable = new Hashtable();
		String expr_id = null;
		String sampling_heuristic = "simple_random";
		int num_sample_windows = 1; // default
		int sample_windows_size = 100; // default
		int tuples_per_window_to_sample = 10; // default, but shout be overriden
		String sample_dump_file = "";
		ArrayList decisionTreeAttributes = new ArrayList();

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("tuples_per_window_to_sample")) {
						tuples_per_window_to_sample = Integer
								.parseInt(((Node) attrs.getNamedItem("value"))
										.getNodeValue().trim());
					} else if (name.equals("sample_dump_file")) {
						sample_dump_file = ((Node) attrs.getNamedItem("value"))
								.getNodeValue().trim();
					} else if (name.equals("sample_windows_size")) {
						sample_windows_size = Integer.parseInt(((Node) attrs
								.getNamedItem("value")).getNodeValue().trim());
					} else if (name.equals("num_sample_windows")) {
						num_sample_windows = Integer.parseInt(((Node) attrs
								.getNamedItem("value")).getNodeValue().trim());
					} else if (name.equals("sampling_heuristic")) {
						sampling_heuristic = ((Node) attrs
								.getNamedItem("value")).getNodeValue().trim();
					}
				} else if (next.getNodeName().equalsIgnoreCase(
						"decisionTreeHeader")) {
					try {
						NodeList steps = next.getChildNodes();

						for (int p = 0; p < steps.getLength(); p++) {
							Node nextChild = steps.item(p);
							if (nextChild.getNodeType() == Node.ELEMENT_NODE) {
								NamedNodeMap attrs = nextChild.getAttributes();
								// <attribute name="CompanyName" type="string"
								// use="false" />
								String name = ((Node) attrs
										.getNamedItem("name")).getNodeValue()
										.trim();
								String use = ((Node) attrs.getNamedItem("use"))
										.getNodeValue().trim();
								String is_target = ((Node) attrs
										.getNamedItem("is_target"))
										.getNodeValue().trim();
								DecisionTreeHeader dth = new DecisionTreeHeader(
										name, Boolean.parseBoolean(use),
										Boolean.parseBoolean(is_target));
								decisionTreeAttributes.add(dth);
							}
						}
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				}
				/* histogram parameters */
				else if (next.getNodeName().equalsIgnoreCase("histograms")) {
					try {
						// histogramTable = parseExpression(next);
						NodeList steps = next.getChildNodes();

						for (int p = 0; p < steps.getLength(); p++) {
							Node nextChild = steps.item(p);
							if (nextChild.getNodeType() == Node.ELEMENT_NODE) {
								NamedNodeMap attrs = nextChild.getAttributes();
								// <hist id="1" attr_idx="13" num_buckets="10"
								// min_val="-2" max_val="2" />
								String id = ((Node) attrs.getNamedItem("id"))
										.getNodeValue().trim();
								String attr_idx = ((Node) attrs
										.getNamedItem("attr_idx"))
										.getNodeValue().trim();
								String type = ((Node) attrs
										.getNamedItem("type")).getNodeValue()
										.trim();

								// ----------------------------------------
								// Histogram --> type double
								// ----------------------------------------
								if (type.equalsIgnoreCase("double")) {
									String num_buckets = ((Node) attrs
											.getNamedItem("num_buckets"))
											.getNodeValue().trim();
									String min_val = ((Node) attrs
											.getNamedItem("min_val"))
											.getNodeValue().trim();
									String max_val = ((Node) attrs
											.getNamedItem("max_val"))
											.getNodeValue().trim();
									// HistProperties hp = new
									// HistProperties(id, attr_idx, num_buckets,
									// min_val, max_val);

									BasicHist bh = new BasicHist(
											Integer.parseInt(num_buckets),
											Double.parseDouble(min_val),
											Double.parseDouble(max_val));
									histogramsTable.put(attr_idx, bh);
								}
								// ----------------------------------------
								// Histogram --> type string
								// ----------------------------------------
								else if (type.equalsIgnoreCase("string")) {
									StringBasicHist sbh = new StringBasicHist();
									histogramsTable.put(attr_idx, sbh);
								}
							}
						}
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				}

			}
		}

		op.setSamplingHeuristic(sampling_heuristic);
		op.setNumSampleWindows(num_sample_windows);
		op.setTuplesPerWindowToSample(tuples_per_window_to_sample);
		op.setHistogramsTable((Hashtable) histogramsTable);
		op.setTupleSampleDumpFile(sample_dump_file);
		op.SetDecisionTreeAttributes(decisionTreeAttributes);
		op.setTupleSampleDumpFileHeader();
		return null;
	}

	// STQM: Rimma V. Nehme - training set collector for self-tuning query mesh
	public Object visit(TrainingTupleCollectorOperatorImp op, Node node) {
		String streamId = "-999";
		NodeList classList = node.getChildNodes();
		Hashtable histogramsTable = new Hashtable();
		String expr_id = null;
		String sampling_heuristic = "simple_random";
		int tuples_to_sample = 100; // default, but shout be overriden
		String sample_dump_file = "";
		ArrayList decisionTreeAttributes = new ArrayList();

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("stream_id")) {
						streamId = ((Node) attrs.getNamedItem("value"))
								.getNodeValue().trim();
					} else if (name.equals("tuples_to_sample")) {
						tuples_to_sample = Integer.parseInt(((Node) attrs
								.getNamedItem("value")).getNodeValue().trim());
					} else if (name.equals("sample_dump_file")) {
						sample_dump_file = ((Node) attrs.getNamedItem("value"))
								.getNodeValue().trim();
					} else if (name.equals("sampling_heuristic")) {
						sampling_heuristic = ((Node) attrs
								.getNamedItem("value")).getNodeValue().trim();
					}
				} else if (next.getNodeName().equalsIgnoreCase(
						"decisionTreeHeader")) {
					try {
						NodeList steps = next.getChildNodes();

						for (int p = 0; p < steps.getLength(); p++) {
							Node nextChild = steps.item(p);
							if (nextChild.getNodeType() == Node.ELEMENT_NODE) {
								NamedNodeMap attrs = nextChild.getAttributes();
								// <attribute name="CompanyName" type="string"
								// use="false" />
								String name = ((Node) attrs
										.getNamedItem("name")).getNodeValue()
										.trim();
								String use = ((Node) attrs.getNamedItem("use"))
										.getNodeValue().trim();
								String is_target = ((Node) attrs
										.getNamedItem("is_target"))
										.getNodeValue().trim();
								DecisionTreeHeader dth = new DecisionTreeHeader(
										name, Boolean.parseBoolean(use),
										Boolean.parseBoolean(is_target));
								decisionTreeAttributes.add(dth);
							}
						}
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				}
				/* histogram parameters */
				else if (next.getNodeName().equalsIgnoreCase("histograms")) {
					try {
						// histogramTable = parseExpression(next);
						NodeList steps = next.getChildNodes();

						for (int p = 0; p < steps.getLength(); p++) {
							Node nextChild = steps.item(p);
							if (nextChild.getNodeType() == Node.ELEMENT_NODE) {
								NamedNodeMap attrs = nextChild.getAttributes();
								// <hist id="1" attr_idx="13" num_buckets="10"
								// min_val="-2" max_val="2" />
								String id = ((Node) attrs.getNamedItem("id"))
										.getNodeValue().trim();
								String attr_idx = ((Node) attrs
										.getNamedItem("attr_idx"))
										.getNodeValue().trim();
								String type = ((Node) attrs
										.getNamedItem("type")).getNodeValue()
										.trim();

								// ----------------------------------------
								// Histogram --> type double
								// ----------------------------------------
								if (type.equalsIgnoreCase("double")) {
									String num_buckets = ((Node) attrs
											.getNamedItem("num_buckets"))
											.getNodeValue().trim();
									String min_val = ((Node) attrs
											.getNamedItem("min_val"))
											.getNodeValue().trim();
									String max_val = ((Node) attrs
											.getNamedItem("max_val"))
											.getNodeValue().trim();
									// HistProperties hp = new
									// HistProperties(id, attr_idx, num_buckets,
									// min_val, max_val);

									BasicHist bh = new BasicHist(
											Integer.parseInt(num_buckets),
											Double.parseDouble(min_val),
											Double.parseDouble(max_val));
									histogramsTable.put(attr_idx, bh);
								}
								// ----------------------------------------
								// Histogram --> type string
								// ----------------------------------------
								else if (type.equalsIgnoreCase("string")) {
									StringBasicHist sbh = new StringBasicHist();
									histogramsTable.put(attr_idx, sbh);
								}
							}
						}
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				}

			}
		}

		op.SetStreamID(Integer.parseInt(streamId));
		op.setSamplingHeuristic(sampling_heuristic);
		op.setTuplesToSample(tuples_to_sample);
		op.setHistogramsTable((Hashtable) histogramsTable);
		op.setTupleSampleDumpFile(sample_dump_file);
		op.SetDecisionTreeAttributes(decisionTreeAttributes);
		op.setTupleSampleDumpFileHeader();
		return null;
	}

	// Rimma V. Nehme
	public Object visit(SampleStatsCollectorOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable histogramsTable = new Hashtable();
		String expr_id = null;
		String sampling_heuristic = "simple_random";
		int num_sample_windows = 1; // default
		int sample_windows_size = 100; // default
		int tuples_per_window_to_sample = 10; // default, but shout be overriden
		String sample_dump_file = "";

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("tuples_per_window_to_sample")) {
						tuples_per_window_to_sample = Integer
								.parseInt(((Node) attrs.getNamedItem("value"))
										.getNodeValue().trim());
					} else if (name.equals("sample_dump_file")) {
						sample_dump_file = ((Node) attrs.getNamedItem("value"))
								.getNodeValue().trim();
					} else if (name.equals("sample_windows_size")) {
						sample_windows_size = Integer.parseInt(((Node) attrs
								.getNamedItem("value")).getNodeValue().trim());
					} else if (name.equals("num_sample_windows")) {
						num_sample_windows = Integer.parseInt(((Node) attrs
								.getNamedItem("value")).getNodeValue().trim());
					} else if (name.equals("sampling_heuristic")) {
						sampling_heuristic = ((Node) attrs
								.getNamedItem("value")).getNodeValue().trim();
					}
				}
				/* histogram parameters */
				else if (next.getNodeName().equalsIgnoreCase("histograms")) {
					try {
						// histogramTable = parseExpression(next);
						NodeList steps = next.getChildNodes();

						for (int p = 0; p < steps.getLength(); p++) {
							Node nextChild = steps.item(p);
							if (nextChild.getNodeType() == Node.ELEMENT_NODE) {
								NamedNodeMap attrs = nextChild.getAttributes();
								// <hist id="1" attr_idx="13" num_buckets="10"
								// min_val="-2" max_val="2" />
								String id = ((Node) attrs.getNamedItem("id"))
										.getNodeValue().trim();
								String attr_idx = ((Node) attrs
										.getNamedItem("attr_idx"))
										.getNodeValue().trim();
								String type = ((Node) attrs
										.getNamedItem("type")).getNodeValue()
										.trim();

								// ----------------------------------------
								// Histogram --> type double
								// ----------------------------------------
								if (type.equalsIgnoreCase("double")) {
									String num_buckets = ((Node) attrs
											.getNamedItem("num_buckets"))
											.getNodeValue().trim();
									String min_val = ((Node) attrs
											.getNamedItem("min_val"))
											.getNodeValue().trim();
									String max_val = ((Node) attrs
											.getNamedItem("max_val"))
											.getNodeValue().trim();
									// HistProperties hp = new
									// HistProperties(id, attr_idx, num_buckets,
									// min_val, max_val);

									BasicHist bh = new BasicHist(
											Integer.parseInt(num_buckets),
											Double.parseDouble(min_val),
											Double.parseDouble(max_val));
									histogramsTable.put(attr_idx, bh);
								}
								// ----------------------------------------
								// Histogram --> type string
								// ----------------------------------------
								else if (type.equalsIgnoreCase("string")) {
									StringBasicHist sbh = new StringBasicHist();
									histogramsTable.put(attr_idx, sbh);
								}
							}
						}
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				}

			}
		}

		op.setSamplingHeuristic(sampling_heuristic);
		op.setNumSampleWindows(num_sample_windows);
		op.setTuplesPerWindowToSample(tuples_per_window_to_sample);
		op.setHistogramsTable((Hashtable) histogramsTable);
		op.setTupleSampleDumpFile(sample_dump_file);
		return null;
	}

	// Added by Karen Works @ Oct, 2007
	public Object visit(OnlineClassifierOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		NamedNodeMap attrs = null;
		String name;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					attrs = next.getAttributes();
					name = ((Node) attrs.getNamedItem("name")).getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
					/* pass other class variables */
					attrs = next.getAttributes();
					name = ((Node) attrs.getNamedItem("name")).getNodeValue();

					if (name.equalsIgnoreCase("Num_Streams")) {
						Integer value = Integer.parseInt(((Node) attrs
								.getNamedItem("value")).getNodeValue());
						op.setNumStreams(value);
						continue;
					} else if (name.equalsIgnoreCase("Num_Operators")) {
						Integer value = Integer.parseInt(((Node) attrs
								.getNamedItem("value")).getNodeValue());
						op.setNumOps(value);
						continue;
					} else if (name.equalsIgnoreCase("Num_SendOff")) {
						Integer value = Integer.parseInt(((Node) attrs
								.getNamedItem("value")).getNodeValue());
						op.setSendOff(value);
						continue;
					} else if (name.equalsIgnoreCase("TupleCountThreshold")) {
						Integer value = Integer.parseInt(((Node) attrs
								.getNamedItem("value")).getNodeValue());
						op.setTupleCountThreshold(value);
						continue;
					} else if (name.startsWith("Stream")) {
						Integer streamQueueid = Integer.parseInt(((Node) attrs
								.getNamedItem("QueueId")).getNodeValue());
						Integer windowSize = Integer.parseInt(((Node) attrs
								.getNamedItem("window_size")).getNodeValue());
						op.AddSTREAMWindowCount(streamQueueid, windowSize);
						continue;

					}

				} else if (next.getNodeName().equalsIgnoreCase(
						"globalDecisionTree")) {
					ParseQMExecutionDecisionTree(op, next, attrs);
					continue;
				}
			}
		}

		return null;
	}

	// Rimma - Extracted functionality of parsing execution decision tree (for
	// self-tuning) purposes
	// now it can be called separately (not just when initializing the plan at
	// startup)
	public static void ParseQMExecutionDecisionTree(
			OnlineClassifierOperatorImp op, Node next, NamedNodeMap attrs) {
		try {
			NodeList steps = next.getChildNodes();
			int streamId = 0;

			int id = 0;
			boolean bIsDefault;
			String strPath;

			for (int p = 0; p < steps.getLength(); p++) {
				Node nextChild = steps.item(p);
				// localQM
				if (nextChild.getNodeName().equalsIgnoreCase("localQM")) {
					NodeList LQMsteps = nextChild.getChildNodes();

					for (int LQM = 0; LQM < LQMsteps.getLength(); LQM++) {
						Node nextChildLQM = LQMsteps.item(LQM);

						// localDecisionTree
						if (nextChildLQM.getNodeName().equalsIgnoreCase(
								"localDecisionTree")) {
							attrs = nextChildLQM.getAttributes();

							streamId = Integer.parseInt(((Node) attrs
									.getNamedItem("stream_id")).getNodeValue());
							System.out
									.println("------------------------------------------------------------------------------");
							System.out.println("stream = " + streamId);
							System.out
									.println("------------------------------------------------------------------------------");

							NodeList ldtsteps = nextChildLQM.getChildNodes();
							for (int ldt = 0; ldt < ldtsteps.getLength(); ldt++) {
								Node nextChildldt = ldtsteps.item(ldt);

								// DTnode
								if (nextChildldt.getNodeName()
										.equalsIgnoreCase("DTnode")) {
									attrs = nextChildldt.getAttributes();

									int DTnode_attr_idx = 0;
									int DTnode_bucket_range_start = 0;
									int DTnode_bucket_range_end = 0;
									int DTnode_route_id = 0;
									boolean DTnode_is_bucket_value = false;

									int DTnode_id = Integer
											.parseInt(((Node) attrs
													.getNamedItem("id"))
													.getNodeValue());
									System.out.print("DTnode_id = " + DTnode_id
											+ " ");
									if (attrs.getNamedItem("attr_idx")
											.getNodeValue().length() > 0) {
										DTnode_attr_idx = Integer
												.parseInt(((Node) attrs
														.getNamedItem("attr_idx"))
														.getNodeValue());
									}
									if (attrs
											.getNamedItem("bucket_range_start")
											.getNodeValue().length() > 0) {
										DTnode_bucket_range_start = Integer
												.parseInt(((Node) attrs
														.getNamedItem("bucket_range_start"))
														.getNodeValue());
									}

									if (attrs.getNamedItem("bucket_range_end")
											.getNodeValue().length() > 0) {
										DTnode_bucket_range_end = Integer
												.parseInt(((Node) attrs
														.getNamedItem("bucket_range_end"))
														.getNodeValue());
									}

									if (attrs.getNamedItem("route_id")
											.getNodeValue().length() > 0) {
										// if route value is null (this could
										// happen with DT construction, use
										// default route id
										if (((Node) attrs
												.getNamedItem("route_id"))
												.getNodeValue().toString()
												.equalsIgnoreCase("null")) {
											DTnode_route_id = -1; // -1 route_id
																	// is
																	// reserved
																	// for
																	// default
																	// route

											System.out
													.println(" DTnode_route_id = "
															+ DTnode_route_id);
										} else {
											DTnode_route_id = Integer
													.parseInt(((Node) attrs
															.getNamedItem("route_id"))
															.getNodeValue());
											System.out
													.println(" DTnode_route_id = "
															+ DTnode_route_id);
										}
									}

									String DTnode_attr_name = ((Node) attrs
											.getNamedItem("attr_name"))
											.getNodeValue();
									String DTnode_operation = ((Node) attrs
											.getNamedItem("operation"))
											.getNodeValue();
									String DTnode_test_value = ((Node) attrs
											.getNamedItem("test_value"))
											.getNodeValue();

									if (attrs.getNamedItem("is_bucket_value")
											.getNodeValue().length() > 0) {
										DTnode_is_bucket_value = Boolean
												.parseBoolean(((Node) attrs
														.getNamedItem("is_bucket_value"))
														.getNodeValue());
									}

									DecisionTreeNode dt = new DecisionTreeNode();
									dt.id = DTnode_id;
									dt.attr_idx = DTnode_attr_idx;
									dt.bucket_range_start = DTnode_bucket_range_start;
									dt.bucket_range_end = DTnode_bucket_range_end;
									dt.route_id = DTnode_route_id;
									dt.attr_name = DTnode_attr_name;
									dt.operation = DTnode_operation;
									dt.is_bucket_value = DTnode_is_bucket_value;
									dt.test_value = DTnode_test_value;

									System.out.println();
									System.out
											.print("dt.id = "
													+ dt.id
													+ System.getProperty("line.separator"));
									System.out
											.print("dt.attr_idx = "
													+ dt.attr_idx
													+ System.getProperty("line.separator"));
									System.out
											.print("dt.bucket_range_start = "
													+ dt.bucket_range_start
													+ System.getProperty("line.separator"));
									System.out
											.print("dt.bucket_range_end = "
													+ dt.bucket_range_end
													+ System.getProperty("line.separator"));
									System.out
											.print("dt.route_id = "
													+ dt.route_id
													+ System.getProperty("line.separator"));
									System.out
											.print("dt.attr_name = "
													+ dt.attr_name
													+ System.getProperty("line.separator"));
									System.out
											.print("dt.operation = "
													+ dt.operation
													+ System.getProperty("line.separator"));
									System.out
											.print("dt.is_bucket_value = "
													+ dt.is_bucket_value
													+ System.getProperty("line.separator"));
									System.out
											.print("dt.test_value = "
													+ dt.test_value
													+ System.getProperty("line.separator"));

									op.AddDTNodePerStream(streamId, dt.id, dt);

									// parents/children
									NodeList PCsteps = nextChildldt
											.getChildNodes();
									for (int PC = 0; PC < PCsteps.getLength(); PC++) {
										Node nextPC = PCsteps.item(PC);

										// parents
										if (nextPC.getNodeName()
												.equalsIgnoreCase("parents")) {
											NodeList Parentssteps = nextPC
													.getChildNodes();
											for (int parents = 0; parents < Parentssteps
													.getLength(); parents++) {
												Node nextP = Parentssteps
														.item(parents);

												// parent
												if (nextP.getNodeName()
														.equalsIgnoreCase(
																"parent")) {
													attrs = nextP
															.getAttributes();
													id = Integer
															.parseInt(((Node) attrs
																	.getNamedItem("node_id"))
																	.getNodeValue());
													dt.parents.add(id);
												}
											}

										}

										// children
										else if (nextPC.getNodeName()
												.equalsIgnoreCase("children")) {
											NodeList Childrensteps = nextPC
													.getChildNodes();
											for (int children = 0; children < Childrensteps
													.getLength(); children++) {
												Node nextC = Childrensteps
														.item(children);

												// child
												if (nextC.getNodeName()
														.equalsIgnoreCase(
																"child")) {
													attrs = nextC
															.getAttributes();
													id = Integer
															.parseInt(((Node) attrs
																	.getNamedItem("node_id"))
																	.getNodeValue());
													dt.children.add(id);
												}
											}
										}// end else
									}
								}
							}
						}// end if local decision tree
							// all routes
						else if (nextChildLQM.getNodeName().equalsIgnoreCase(
								"allRoutes")) {
							NodeList routesteps = nextChildLQM.getChildNodes();
							for (int routes = 0; routes < routesteps
									.getLength(); routes++) {
								Node nextChildroutes = routesteps.item(routes);

								// route
								if (nextChildroutes.getNodeName()
										.equalsIgnoreCase("route")) {

									attrs = nextChildroutes.getAttributes();

									id = Integer
											.parseInt(((Node) attrs
													.getNamedItem("id"))
													.getNodeValue());
									bIsDefault = Boolean
											.parseBoolean(((Node) attrs
													.getNamedItem("is_default"))
													.getNodeValue());
									ArrayList<Integer> os = new ArrayList<Integer>();

									strPath = ((Node) attrs
											.getNamedItem("path"))
											.getNodeValue();

									StringTokenizer st = new StringTokenizer(
											strPath, "|");

									int numTokens = st.countTokens();
									ArrayList opTokens = new ArrayList();
									while (st.hasMoreTokens()) {
										opTokens.add(st.nextToken());
									}

									for (int u = 0; u < numTokens; u++) {
										os.add(null);
									}

									for (int k = 0; k < opTokens.size(); k++) {
										os.set(k, Integer
												.parseInt((String) opTokens
														.get(k)));
									}

									RusterNode rn = new RusterNode(os, id,
											bIsDefault);

									op.AddRusterPerStream(streamId, id, rn);

									if (bIsDefault) {
										rn = new RusterNode(os, 0, true);
										op.AddRusterPerStream(streamId, 0, rn);

										// other default node is removed in the
										// execution controller
									}
								}
							} // end all routes
						}
					}// end ldt
				}
			}// gdt
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	// Added by Karen Works @ Oct, 2007
	public Object visit(QMeshStreamSelectOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
				}
				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();
				if (name.equalsIgnoreCase("StreamID")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.SetStreamID(value);
					continue;
				} else if (name.equalsIgnoreCase("QMeshOperatorID")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setQMeshOperatorID(value);
					continue;
				}
			}
		}

		op.setExpression((ExpressionStr) expressionTable.get(expr_id));
		return null;
	}

	// Added by Karen Works @ Nov, 2007
	public Object visit(MJoinProbeOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
				}

				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();
				if (name.equalsIgnoreCase("Num_Streams")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumStreams(value);
					continue;
				} else if (name.startsWith("Eval")) {
					Integer Id = Integer.parseInt(((Node) attrs
							.getNamedItem("Id")).getNodeValue());
					Integer streamId1 = Integer.parseInt(((Node) attrs
							.getNamedItem("streamId1")).getNodeValue());
					String Index1 = ((Node) attrs.getNamedItem("Index1"))
							.getNodeValue();
					Integer streamId2 = Integer.parseInt(((Node) attrs
							.getNamedItem("streamId2")).getNodeValue());
					String Index2 = ((Node) attrs.getNamedItem("Index2"))
							.getNodeValue();
					op.AddEval(Id, streamId1, Index1, streamId2, Index2);
					continue;
				} else if (name.startsWith("STREAMPath")) {
					Integer streamId = Integer.parseInt(((Node) attrs
							.getNamedItem("streamId")).getNodeValue());
					String Path = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.AddSTREAMPath(streamId, Path);
					continue;
				}
			}
		}
		return null;
	}

	// Added by Karen Works @ May, 2008
	public Object visit(STeMPartitionJoinProbeOperatorImp op, Node node) {

		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {

			Node next = classList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {

				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));

					} catch (Exception e) {

						e.printStackTrace();

					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {

					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}

				}

				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equalsIgnoreCase("EddyOpBitsPos")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.EddySetOpBitsPos(value);
					continue;
				} else if (name.equalsIgnoreCase("NumSTeMIndex")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.SetNumSTeMIndex(value);
					continue;
				} else if (name.equalsIgnoreCase("NumTupleIndex")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.SetNumTupleIndex(value);
					continue;
				} else if (name.equalsIgnoreCase("IsEddyOp")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.SetIsEddyOp(value);
					continue;
				} else if (name.equalsIgnoreCase("ProbeSTREAMId")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.SetProbeSTREAMId(value);
					continue;
				} else if (name.equalsIgnoreCase("STeMSTREAMId")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.SetDataSTREAMId(value);
					continue;
				} else if (name.equalsIgnoreCase("QMeshOperatorID")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setQMeshOperatorID(value);
					continue;
				} else if (name.equalsIgnoreCase("CompleteJoinAttrib")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.SetCompleteJoinAttribs(value);
					continue;
				}
			}
		}
		return null;
	}

	// Added by Rimma May, 2008
	public Object visit(edu.wpi.cs.dsrg.eddy.operator.CBREddyOperatorImp op,
			Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
				}

				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				if (name.equalsIgnoreCase("Num_Streams")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumStreams(value);
					continue;
				} else if (name.equalsIgnoreCase("Router")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.setRouter(value);
					continue;
				} else if (name.equalsIgnoreCase("Num_Operators")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumOps(value);
					continue;
				} else if (name.equalsIgnoreCase("Operator_STREAMIds")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.setOpStringIds(value);
					continue;
				} else if (name.equalsIgnoreCase("NumTupToProcessPerOp")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumTupToProcessPerOp(value);
					continue;
				} else if (name.equalsIgnoreCase("NumTupToProcess")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumTupToProcess(value);
					continue;
				} else if (name.equalsIgnoreCase("NumLevelsToProcess")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumLevelsToProcess(value);
					continue;
				} else if (name
						.equalsIgnoreCase("UseFlipFlopTupleProcStrategy")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setFlipFlopTupleProcStrategy(value);
					continue;
				} else if (name.equalsIgnoreCase("UseTupleProcTopStrategy")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setUseTupleProcTopStrategy(value);
					continue;
				} else if (name.startsWith("Stream")) {
					Integer streamQueueid = Integer.parseInt(((Node) attrs
							.getNamedItem("QueueId")).getNodeValue());
					Integer windowSize = Integer.parseInt(((Node) attrs
							.getNamedItem("window_size")).getNodeValue());
					op.AddSTREAMWindowCount(streamQueueid, windowSize);
					continue;
				}
			}
		}
		return null;
	}

	// //Added by KWorks @ May, 2008
	public Object visit(
			edu.wpi.cs.dsrg.eddyBatch.operator.EddyPartitionOperatorImp op,
			Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
				}

				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				System.out.println(name);

				if (name.equalsIgnoreCase("Num_Streams")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumStreams(value);
					continue;
				} else if (name.equalsIgnoreCase("Router")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.setRouter(value);
					continue;
				} else if (name.equalsIgnoreCase("Num_Operators")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumOps(value);
					continue;
				} else if (name.equalsIgnoreCase("Num_Bits")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumBits(value);
					continue;
				}
				// ////////////////////////////////
				else if (name.startsWith("Operator_STREAMIds")) {
					Integer opId = Integer.parseInt(((Node) attrs
							.getNamedItem("opId")).getNodeValue());
					String value = ((Node) attrs.getNamedItem("ProbeStreams"))
							.getNodeValue();
					op.setOpStringIds(opId, value);
					continue;
				} else if (name.startsWith("OperatorStateSTREAMId")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.setSTEMDataSTREAMIds(value);
					continue;
				}
				// ////////////////////////////////////
				else if (name.equalsIgnoreCase("NumTupToProcessPerOp")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumTupToProcessPerOp(value);
					continue;
				} else if (name.equalsIgnoreCase("NumTupToProcess")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumTupToProcess(value);
					continue;
				} else if (name.equalsIgnoreCase("NumLevelsToProcess")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumLevelsToProcess(value);
					continue;
				} else if (name
						.equalsIgnoreCase("UseFlipFlopTupleProcStrategy")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setFlipFlopTupleProcStrategy(value);
					continue;
				} else if (name.equalsIgnoreCase("UseTupleProcTopStrategy")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setUseTupleProcTopStrategy(value);
					continue;
				}
				// /////////////////////////////
				else if (name.startsWith("Stream")) {
					Integer streamQueueid = Integer.parseInt(((Node) attrs
							.getNamedItem("QueueId")).getNodeValue());
					Integer windowSize = Integer.parseInt(((Node) attrs
							.getNamedItem("window_size")).getNodeValue());
					op.AddSTREAMWindowCount(streamQueueid, windowSize);
					continue;

				} else if (name.startsWith("Num_JoinAttrib")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumJoinAttribs(value);
					continue;

				} else if (name.equalsIgnoreCase("AdaptingIndice")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setAdaptingIndice(value);
					continue;
				} else if (name.startsWith("MaxPartitionSize")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setMaxPartitionSize(value);
					continue;
				} else if (name.startsWith("MaxPartitionWindowSize")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setMaxPartitionWindowSize(value);
					continue;
				} else if (name.equalsIgnoreCase("UsePartitions")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setIsPartitioned(value);
					continue;
				} else if (name.equalsIgnoreCase("UseIMPIndex")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setUseIMPIndex(value);
					continue;
				} else if (name.startsWith("NumLimitedIndices")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumLimitedIndices(value);
					continue;
				}
				// ///////////////////////////////////////
				// TrackTimeToSearch
				else if (name.equalsIgnoreCase("TrackTimeToSearch")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setTrackTimeToSearch(value);
					continue;
				} else if (name.equalsIgnoreCase("TrackTimeToSearchOutputFile")) {
					String value = (((Node) attrs.getNamedItem("value"))
							.getNodeValue());
					op.setTrackTimeToSearchOutputFile(value);
					continue;
				}
				// ///////////////////////////////////////
				// TrackOptimalIndices
				else if (name.equalsIgnoreCase("TrackOptimalIndices")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setTrackOptimalIndices(value);
					continue;
				} else if (name
						.equalsIgnoreCase("TrackOptimalIndicesOutputFile")) {
					String value = (((Node) attrs.getNamedItem("value"))
							.getNodeValue());
					op.setTrackOptimalIndicesOutputFile(value);
					continue;
				}
				// ////////////////////////////
				// ///////////////////////////////////////
				// Track count migrations
				else if (name.equalsIgnoreCase("TrackCountMigrations")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setCountMigrations(value);
					continue;
				} else if (name
						.equalsIgnoreCase("TrackCountMigrationsOutputFile")) {
					String value = (((Node) attrs.getNamedItem("value"))
							.getNodeValue());
					op.setCountMigrationsFile(value);
					continue;
				}
				// ////////////////////////////
				// Store Comparison Time
				else if (name.equalsIgnoreCase("TrackComparisonTime")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setStoreComparisonTime(value);
					continue;
				} else if (name
						.equalsIgnoreCase("TrackComparisonTimeOutputFile")) {
					String value = (((Node) attrs.getNamedItem("value"))
							.getNodeValue());
					op.setStoreComparisonTimeFile(value);
					continue;
				}
				// ////////////////////////////

				else if (name.equalsIgnoreCase("UseIndexAssessment")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setIndexAssessment(value);
					continue;
				} else if (name
						.equalsIgnoreCase("UseExhaustiveIndexAssessment")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setExhaustiveAssessment(value);
					continue;
				} else if (name.equalsIgnoreCase("UsePeriodicIndexAssessment")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setPeriodicAssessment(value);
					continue;
				} else if (name.startsWith("PeriodicIndexAssessmentWindow")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setPeriodicAssessmentWindow(value);
					continue;
				} else if (name
						.equalsIgnoreCase("UseContinuousIndexAssessment")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setContinuousAssessment(value);
					continue;
				} else if (name.equalsIgnoreCase("UseTriggeredIndexAssessment")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setTriggeredAssessment(value);
					continue;
				} else if (name.startsWith("TriggeredIndexAssessmentWindow")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setTriggeredAssessmentWindow(value);
					continue;
				}
				// /////////////////////////////////////
				else if (name.equalsIgnoreCase("UseNoSampling")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNoSampling(value);
					continue;
				} else if (name.equalsIgnoreCase("UseSimpleRandomSampling")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setSimpleRandomSampling(value);
					continue;
				} else if (name.startsWith("SimpleRandomPercent")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setSimpleRandomPercent(value);
					continue;
				} else if (name.equalsIgnoreCase("UseStratifiedRandomSampling")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setStratifiedRandomSampling(value);
					continue;
				} else if (name.startsWith("StratifiedRandomPercent")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setStratifiedRandomPercent(value);
					continue;
				} else if (name.startsWith("StratifiedRandomWindow")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setStratifiedRandomWindow(value);
					continue;
				} else if (name.equalsIgnoreCase("UseSystematicSampling")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setSystematicSampling(value);
					continue;
				} else if (name.startsWith("SystematicSamplingInterval")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setSystematicInterval(value);
					continue;
				}
				// ///////////////////////////////////////
				else if (name.equalsIgnoreCase("UseNoMigration")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNoMigration(value);
					continue;
				} else if (name.equalsIgnoreCase("UseSymmetricMigration")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setSymmetricMigration(value);
					continue;
				} else if (name.equalsIgnoreCase("UsePartitionMigration")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setPartitionMigration(value);
					continue;
				}
				// ///////////////////////////////////////
				// SRIA
				else if (name.equalsIgnoreCase("UseSRIA")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setSRIA(value);
					continue;
				} else if (name.equalsIgnoreCase("UseHH")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setHH(value);
					continue;
				}
				// HHH
				else if (name.equalsIgnoreCase("UseHHH")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setHHH(value);
					continue;
				} else if (name.equalsIgnoreCase("UseCombineNodesByPickingOne")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setCombineNodesByPickingOne(value);
					continue;
				} else if (name
						.equalsIgnoreCase("UsePickParentWithHighestFreq")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setPickParentWithHighestFreq(value);
					continue;
				}

				else if (name.equalsIgnoreCase("HHErrorRate")) {
					Double value = Double.parseDouble(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setHHErrorRate(value);
					continue;
				} else if (name.equalsIgnoreCase("CostFactorSignificance")) {
					Double value = Double.parseDouble(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setCostFactorSignificance(value);
					continue;
				}
				// ///////////////////////////////////////
				// Combined stats
				else if (name.equalsIgnoreCase("UseCombinedStats")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setCombinedStats(value);
					continue;
				} else if (name.equalsIgnoreCase("NumCombinedStats")) {
					int value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setNumCombinedStats(value);
					continue;
				} else if (name.equalsIgnoreCase("CombinedStatsFactor")) {
					String value = (String) ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					StringTokenizer st = new StringTokenizer(value, "|");
					// parse string
					int numTokens = st.countTokens();
					double[] val = new double[numTokens];
					int j = 0;
					ArrayList opTokens = new ArrayList();
					while (st.hasMoreTokens()) {
						val[j] = Double.parseDouble(st.nextToken());
						j++;
					}

					op.setCombinedStatsFactor(val);
					continue;
				}
				// ///////////////////////////////////////
				// Index Selection trigger
				// else if(name.equalsIgnoreCase("UseNoIndexSelectionTrigger"))
				// {
				// boolean value = Boolean.parseBoolean(((Node)
				// attrs.getNamedItem("value")).getNodeValue());
				// op.setNoIndexSelectionTrigger(value);
				// continue;
				// }
				// else
				// if(name.equalsIgnoreCase("UseCostIncrIndexSelectionTrigger"))
				// {
				// boolean value = Boolean.parseBoolean(((Node)
				// attrs.getNamedItem("value")).getNodeValue());
				// op.setCostIncrIndexSelectionTrigger(value);
				// continue;
				// }
				// else
				// if(name.equalsIgnoreCase("UseFreqIncrIndexSelectionTrigger"))
				// {
				// boolean value = Boolean.parseBoolean(((Node)
				// attrs.getNamedItem("value")).getNodeValue());
				// op.setFreqIncrIndexSelectionTrigger(value);
				// continue;
				// }
				// else
				// if(name.equalsIgnoreCase("UseCombinedIncrIndexSelectionTrigger"))
				// {
				// boolean value = Boolean.parseBoolean(((Node)
				// attrs.getNamedItem("value")).getNodeValue());
				// op.setCombinedIncrIndexSelectionTrigger(value);
				// continue;
				// }
				else if (name.equalsIgnoreCase("DegreeCostIncr")) {
					double value = Double.parseDouble(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setDegreeCostIncr(value);
					continue;
				} else if (name.equalsIgnoreCase("DegreeFreqIncr")) {
					double value = Double.parseDouble(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setDegreeFreqIncr(value);
					continue;
				}

			}
		}

		return null;
	}

	// Added by Karen Works @ May, 2008
	public Object visit(STeMMultiStreamPartitionJoinProbeOperatorImp op,
			Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {

			Node next = classList.item(i);
			if (next.getNodeType() == Node.ELEMENT_NODE) {

				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));

					} catch (Exception e) {

						e.printStackTrace();

					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {

					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}

				}

				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();

				System.out.println(name);

				if (name.equalsIgnoreCase("EddyOpBitsPos")) {
					String value = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.EddySetOpBitsPos(value);
					continue;
				} else if (name.startsWith("NumTupleIndex")) {
					Integer Id = Integer.parseInt(((Node) attrs
							.getNamedItem("ProbeSTREAMId")).getNodeValue());
					String Index = ((Node) attrs.getNamedItem("Index"))
							.getNodeValue();
					op.SetNumTupleIndex(Id, Index);
					continue;
				} else if (name.startsWith("NumSTeMIndex")) {
					Integer Id = Integer.parseInt(((Node) attrs
							.getNamedItem("STREAMId")).getNodeValue());
					String Index = ((Node) attrs.getNamedItem("Index"))
							.getNodeValue();
					op.SetNumSTeMIndex(Id, Index);
					continue;
				} else if (name.equalsIgnoreCase("IsEddyOp")) {
					boolean value = Boolean.parseBoolean(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.SetIsEddyOp(value);
					continue;
				} else if (name.equalsIgnoreCase("STeMSTREAMId")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.SetDataSTREAMId(value);
					continue;
				} else if (name.equalsIgnoreCase("QMeshOperatorID")) {
					Integer value = Integer.parseInt(((Node) attrs
							.getNamedItem("value")).getNodeValue());
					op.setQMeshOperatorID(value);
					continue;
				} else if (name.startsWith("StandardIndex")) {
					// Integer Index = Integer.parseInt(((Node)
					// attrs.getNamedItem("Index")).getNodeValue());
					String attribs = ((Node) attrs.getNamedItem("AttribPos"))
							.getNodeValue();
					op.setHashKeyIndex(attribs);
					continue;
				} else if (name.startsWith("NumProbeIndex")) {
					Integer Index = Integer.parseInt(((Node) attrs
							.getNamedItem("Index")).getNodeValue());
					String attribs = ((Node) attrs
							.getNamedItem("ProbeSTREAMId")).getNodeValue();
					op.setIndexPos(attribs, Index);
					continue;
				}

			}
		}
		return null;
	}

	// Added by Karen Works @ Sept, 2008
	public Object visit(DoNothingOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		Hashtable expressionTable = new Hashtable();
		String expr_id = null;

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				/* pass expression if there is any */
				if (next.getNodeName().equalsIgnoreCase("expressions")) {
					try {
						expressionTable = parseExpression(next);
						// op.setExpression(parseExpression(next));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				} else if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("expression_id")) {
						expr_id = ((Node) attrs.getNamedItem("value"))
								.getNodeValue();
					}
				}

				/* pass other class vairables */
				NamedNodeMap attrs = next.getAttributes();
				String name = ((Node) attrs.getNamedItem("name"))
						.getNodeValue();
				if (name.equalsIgnoreCase("OutputFile")) {
					String File = ((Node) attrs.getNamedItem("value"))
							.getNodeValue();
					op.SetoutFile(File);
					continue;
				}
			}
		}
		return null;
	}

	// ------------------------------------------------------------------------------------

	// Rimma V. Nehme
	public Object visit(FenceQuerySpaceOperatorImp op, Node node) {
		NodeList classList = node.getChildNodes();
		String expr_id = null;

		String fenceQueryPlanXmlFile = ""; // location of the xml file with
											// specifying operators in the fence
											// query space

		for (int i = 0; i < classList.getLength(); i++) {
			Node next = classList.item(i);

			if (next.getNodeType() == Node.ELEMENT_NODE) {
				if (next.getNodeName().equalsIgnoreCase("variable")) {
					NamedNodeMap attrs = next.getAttributes();
					String name = ((Node) attrs.getNamedItem("name"))
							.getNodeValue();

					if (name.equals("FENCE_QUERY_PLAN_XML")) {
						fenceQueryPlanXmlFile = ((Node) attrs
								.getNamedItem("value")).getNodeValue().trim()
								.toString();
					}
				}
			}
		}

		op.initializeFenceSpaceOperator(fenceQueryPlanXmlFile);

		return null;
	}
}
