/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.queuemanager;

import java.util.ArrayList;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATPersistentQueueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;

/**
 * This class is meant only to test the functionality of the queue manager
 * and the storage manager.
 * 
 * Creation Date: (Jun 8, 2004 10:52:13 AM)
 * @author Natasha Bogdanova
 */
public class StorageManagerTest {

	public static void main(String[] args) {
		
		runMultInstTest();
		
		/*
		XATDataValueImp dv1 = new XATDataValueImp("141.4.1.0");
		XATDataValueImp dv2 = new XATDataValueImp("-");
		XATDataValueImp dv3 = new XATDataValueImp("-");
		XATDataValueImp dv4 = new XATDataValueImp("[04/May/1998:22:00:04 +0000]");
		XATDataValueImp dv5 = new XATDataValueImp("GET /images/11103.gif HTTP/1.0");
		XATDataValueImp dv6 = new XATDataValueImp(new Integer(200));
		XATDataValueImp dv7 = new XATDataValueImp(new Integer(513));
		XATDataValueImp[] dvs = {dv1, dv2, dv3, dv4, dv5, dv6, dv7};
		XATTupleImp tup = new XATTupleImp(dvs);
		XATQueueImp q = new XATQueueImp("natasha", "Q");
		q.enqueue(tup, "x");
		q.printLayout();
		System.out.println(((XATTupleImp)q.getContents().get(0)).toString());
		*/
		// test writing to file using the queue manager
		/*
		// create three queues with 1, 2, and 3 tuples in them, respectively
		// each tuple contains the string value of the queue it belongs to
		// plus its own index entry
		XATDataValueImp[] dv1 = {new XATDataValueImp("one")};
		XATDataValueImp[] dv2 = {new XATDataValueImp("two")};
		XATDataValueImp[] dv3 = {new XATDataValueImp("three")};
		XATDataValueImp[] dv4 = {new XATDataValueImp("four")};
		XATDataValueImp[] dv5 = {new XATDataValueImp("five")};
		XATDataValueImp[] dv6 = {new XATDataValueImp("six")};
		XATDataValueImp[] dv7 = {new XATDataValueImp("file-one")};
		XATDataValueImp[] dv8 = {new XATDataValueImp("file-two")};
		XATDataValueImp[] dv9 = {new XATDataValueImp("file-three")};
		XATDataValueImp[] dv10 = {new XATDataValueImp("file-four")};
		XATTupleImp[] tl1 = {new XATTupleImp(dv1)};
		XATTupleImp[] tl2 = {new XATTupleImp(dv2), new XATTupleImp(dv3)};
		XATTupleImp[] tl3 = {new XATTupleImp(dv4), new XATTupleImp(dv5), new XATTupleImp(dv6)};
		XATQueueImp q1 = new XATQueueImp("natasha", "Q1");
		XATQueueImp q2 = new XATQueueImp("natasha", "Q2");
		XATQueueImp q3 = new XATQueueImp("natasha", "Q3");
		ArrayList qlist = new ArrayList();
		qlist.add(q1);
		qlist.add(q2);
		qlist.add(q3);
		
		XATQueueManager qm = q1.getQueueManager();
		qm.setQueues(qlist);
		qm.printQueues();
		
		q1.enqueue(tl1, new Object());
		q2.enqueue(tl2, new Object());
		q3.enqueue(tl3, new Object());

		System.out.println("After enqueing: ");
		qm.printQueues(); 
		
		
		// test dequeueing
		// will dequeue two tuples from q3, one from q2, and none from q1
		q1.dequeue(0, "natasha");
		q2.dequeue(2, "natasha");
		q3.dequeue(1, "natasha");
		
		System.out.println();
		System.out.println("After dequeing: ");
		qm.printQueues();
		*/
		/*
		XATDataValueImp[] sdv1 = {new XATDataValueImp("sp-one")};
		XATDataValueImp[] sdv2 = {new XATDataValueImp("sp-two")};
		XATDataValueImp[] sdv3 = {new XATDataValueImp("sp-three")};
		XATDataValueImp[] sdv4 = {new XATDataValueImp("sp-four")};
		XATDataValueImp[] sdv5 = {new XATDataValueImp("sp-five")};
		XATDataValueImp[] sdv6 = {new XATDataValueImp("sp-six")};
		XATDataValueImp[] sdv7 = {new XATDataValueImp("sp-seven")};
		XATDataValueImp[] sdv8 = {new XATDataValueImp("sp-eight")};
		XATDataValueImp[] sdv9 = {new XATDataValueImp("sp-nine")};
		XATDataValueImp[] sdv10 = {new XATDataValueImp("sp-ten"), new XATDataValueImp(new Integer(10))};
		
		// special dequeue test
		// create a queue with 10 tuples in the following layout:
		// |T|T|T|T|PH->4|T|T|
		List tuples1 = new ArrayList(); // beginning of queue
		List tuples2 = new ArrayList(); // sent to disk
		List tuples3 = new ArrayList(); // end of queue
		List tuples4 = new ArrayList();
		tuples1.add(new XATTupleImp(sdv1));
		tuples1.add(new XATTupleImp(sdv2));
		tuples1.add(new XATTupleImp(sdv3));
		tuples1.add(new XATTupleImp(sdv4));
		tuples2.add(new XATTupleImp(sdv5));
		tuples2.add(new XATTupleImp(sdv6));
		tuples2.add(new XATTupleImp(sdv7));
		tuples2.add(new XATTupleImp(sdv8));
		tuples3.add(new XATTupleImp(sdv9));
		tuples4.add(new XATTupleImp(sdv10));
		XATQueueImp queue = new XATQueueImp("special-test", "special-queue");
		XATQueueImp queue2 = new XATQueueImp("test", "storage-manager");
		ArrayList l1 = new ArrayList();
		l1.add("field1");
		ArrayList l2 = new ArrayList();
		l2.add("field1");
		l2.add("field2");
		queue.setSchema(new XATQueueSchema(new Vector(l1)));
		queue2.setSchema(new XATQueueSchema(new Vector(l2)));
		queue.enqueue(tuples1, "x");
		queue.enqueue(tuples2, "x");
		queue.enqueue(tuples3, "x");
		queue2.enqueue(tuples4, "y");
		
		//System.out.println();
		//System.out.println(queue.toString());
		//System.out.println();
		
		// print the layout of the queue
		System.out.println();
		System.out.println("ORIGINAL LAYOUT:");
		queue.printLayout();
		System.out.println();
		
		
		System.out.println("DEQUEUE 2");
		XATTuple[] res1 = queue.dequeue(2, "customer1");
		queue.printLayout();
		for (int i = 0; i < res1.length; i++) {
			System.out.println(res1[i]);
		}
		System.out.println();
		
		System.out.println("DEQUEUE 4");
		XATTuple[] res2 = queue.dequeue(4, "customer1");
		queue.printLayout();
		for (int i = 0; i < res2.length; i++) {
			System.out.println(res2[i]);
		}
		System.out.println();
		
		queue.setCursor("customer1", 7);
		System.out.println("DEQUEUE 3");
		XATTuple[] res3 = queue.dequeue(3, "customer1");
		queue.printLayout();
		for (int i = 0; i < res3.length; i++) {
			System.out.println(res3[i]);
		}
		System.out.println();
		
		System.out.println("DEQUEUE 5, NEW CUSTOMER");
		XATTuple[] res4 = queue.dequeue(5, "customer2");
		queue.printLayout();
		for (int i = 0; i < res4.length; i++) {
			System.out.println(res4[i]);
		}
		System.out.println();
		
		/*
		System.out.println("-----------------------");
		System.out.println();
		
		System.out.println("PEEK 2");
		XATTuple[] res5 = queue.peek(2, "customer3");
		queue.printLayout();
		for (int i = 0; i < res5.length; i++) {
			System.out.println(res5[i]);
		}
		System.out.println();
		
		System.out.println("PEEK 5");
		XATTuple[] res6 = queue.peek(5, "customer3");
		queue.printLayout();
		for (int i = 0; i < res6.length; i++) {
			System.out.println(res6[i]);
		}
		System.out.println();
		
		queue.setCursor("customer3", 7);
		System.out.println("PEEK 3");
		XATTuple[] res7 = queue.peek(3, "customer3");
		queue.printLayout();
		for (int i = 0; i < res7.length; i++) {
			System.out.println(res7[i]);
		}
		System.out.println();
		
		System.out.println("PEEK 1, CUSTOMER2");
		XATTuple res8 = queue.peek("customer2");
		queue.printLayout();
		System.out.println(res8);
		System.out.println();
		
		System.out.println("PEEK LAST");
		XATTuple res9 = queue.peekLast();
		queue.printLayout();
		System.out.println(res9);
		System.out.println();
		*/
		/*
		Runtime rt = Runtime.getRuntime();
		java.util.Vector v = new java.util.Vector();
		System.out.println("Max Memory: " + rt.maxMemory());
		while (true) {
		  long size = rt.freeMemory();
		  System.out.println("Total memory = " + rt.totalMemory() 
							 + ", free memory = " + size);
		  byte[] buffer = new byte[(int) size];
		  v.addElement(buffer);
		}*/
	}
	
	public static void runMultInstTest() {
		XATDataValueImp[] dv1 = {new XATDataValueImp("one-field")};
		XATDataValueImp[] dv2 = {new XATDataValueImp("two-fields"), new XATDataValueImp(new Integer(2))};
		
		/*
		List tuples1 = new ArrayList(); // one field
		List tuples2 = new ArrayList(); // two fields

		tuples1.add(new XATTupleImp(dv1));
		tuples2.add(new XATTupleImp(dv2));
		*/
		XATTupleImp[] tuples1 = {new XATTupleImp(dv1)};
		XATTupleImp[] tuples2 = {new XATTupleImp(dv2)};

		XATPersistentQueueImp queue1 = new XATPersistentQueueImp("owner-natasha", "one-field-schema");
		XATPersistentQueueImp queue2 = new XATPersistentQueueImp("owner-natasha", "two-fields-schema");
		
		ArrayList l1 = new ArrayList();
		l1.add("field1");
		ArrayList l2 = new ArrayList();
		l2.add("field1");
		l2.add("field2");
		queue1.setSchema(new XATQueueSchema(new Vector(l1)));
		queue2.setSchema(new XATQueueSchema(new Vector(l2)));
		
		queue1.enqueue(tuples1, "1");
		queue2.enqueue(tuples2, "2");
		
		//System.out.println(queue1.getQueueManager().queueToSMMapping.contains(queue1));
		XATTuple[] readTuples1 = queue1.dequeue(1, "1");
		XATTuple[] readTuples2 = queue2.dequeue(2, "2");
		
		for (int i = 0; i < readTuples1.length; i++) {
			System.out.println(readTuples1[i]);
		}
		
		for (int i = 0; i < readTuples2.length; i++) {
			System.out.println(readTuples2[i]);
		}
	}
}
