/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.xmldb.xat.component.storagemanager;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

/**
 * Used to store the tupe information for an array in the tuple class
 * @author Luping Ding and Nishant Mehta
 */

public abstract class ArraySymbolEntry extends ComplexSymbolEntry {
	/**Stores the length of the array*/
	protected int lengthOfArray;
	/**Stores the reference to the class referred to by this array*/
	private Class theClass = null;
	/**
	 * @param t
	 * @param typeName
	 * @param varName
	 */
	public ArraySymbolEntry(Object t, String typeName, String varName) {
		super(t, typeName, varName);		
		theClass = t.getClass();
	}

	/** 
	 * @see edu.wpi.cs.dsrg.conjoin.storagemanager.SymbolEntry#write(java.lang.Object, java.io.ObjectOutputStream)
	 */
	public void write(Object t, ObjectOutputStream os) {
		Object[] array = (Object[]) t;
		//		System.out.println("In write of Class Symbol Entry");
		for (int i = 0; i < this.childSymbolEntry.size(); i++) {
			//see if u can convert this to an array after 
			//the array list os made completely
			((SymbolEntry) (this.childSymbolEntry.get(i))).write(array[i], os);
		}
	}

	/**
	 * @see edu.wpi.cs.dsrg.conjoin.storagemanager.SymbolEntry#read(java.io.ObjectInputStream)
	 */
	public abstract Object read(ObjectInputStream oi);
		
}
