/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.storagemanager;
/*
 * Created on Apr 27, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;


/**
 * @author Nishant Mehta and Luping Ding
 *
 *
 */
public class BooleanSymbolEntry extends SimpleSymbolEntry {

	/**
	 * @param t	 
	 * @param typeName
	 * @param varName	 
	 */
	public BooleanSymbolEntry(
		Object t,		
		String typeName,
		String varName) {			
		super(t, typeName, varName);	
	}
	/** 
	 * @see edu.wpi.cs.dsrg.conjoin.storagemanager.SymbolEntry#write(java.lang.Object, java.io.ObjectOutputStream)
	 */
	public void write(Object t, ObjectOutputStream os) {				
//		System.out.println("Writing a boolean  ");								
			try {
				os.writeBoolean(((Boolean) t).booleanValue());
			} catch (IOException e) {			
				e.printStackTrace();
			}			
															
	}
	/**
	 * Reads the object from the object input stream
	 */														
		
	public Object read(ObjectInputStream oi)	
		{					
			Boolean b = null;			
			try {
				b = new Boolean(oi.readBoolean());
				//System.out.println("Read a Boolean: " + b);
			} catch (IOException e) {				
				e.printStackTrace();
			}
			return(b);
		}																				
}

