/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.storagemanager;

//import edu.wpi.cs.dsrg.xmldb.xat.component.storagemanager.old.basics.XATMJoinTuple;
//import edu.wpi.cs.dsrg.xmldb.xat.component.storagemanager.old.basics.XATMJoinTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.storagemanager.exceptions.InvalidArgumentException;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStamp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;

/**
 * Just used to test the storage manager
 * @author Nishant Mehta and Abhiskek Kumar
 */
public class Dummy {

	public static void main(String[] args) throws Exception {
		//XATMJoinTuple t = new XATMJoinTupleImp();
		XATTuple t = new XATTupleImp();
		IStore store = null;

		Integer[] intT = new Integer[1];
		 
				

		//XATMJoinTupleImp[] arrayTuple1 = new XATMJoinTupleImp[12];
		//XATMJoinTupleImp[] arrayTuple2 = new XATMJoinTupleImp[5];
		XATTupleImp[] arrayTuple1 = new XATTupleImp[12];
		XATTupleImp[] arrayTuple2 = new XATTupleImp[5];
				
		String[] temp = new String[10];
		temp[0] = "srisri";
		temp[1] = "dinesh";
		temp[2] = "ramesh";
		temp[3] = "bawa";
		temp[4] = "mohan";
		temp[5] = "krishna";
		temp[6] = "govind";
		temp[7] = "parag";
		temp[8] = "gopal";
		temp[9] = "vasudevay";

		for (int i = 0; i < arrayTuple1.length; i++) {
																						
//			XATTimeStamp timeStamp = new XATTimeStampImp();	
//			timeStamp.setTimeStamp(i + 100000, 1, 1);		
			long[] newtime = new long[1];
			newtime[0] = i + 100000;
			
			//arrayTuple1[i] = new XATMJoinTupleImp(new XATTupleImp());
			arrayTuple1[i] = new XATTupleImp();
			
			XATDataValue xatDataValue = new XATDataValueImp(new Integer(i));

			arrayTuple1[i].addCell(xatDataValue);
			
			//arrayTuple1[i].setTimeStamp(timeStamp);
			arrayTuple1[i].setTimeStamp(newtime);
			
			//arrayTuple1[i].setPunctID(i+1);
			
		}
		
		for(int i=10,j=0;j< arrayTuple2.length;j++,i++)
		{		
//			XATTimeStamp timeStamp = new XATTimeStampImp();
//			timeStamp.setTimeStamp(i + 100000, 1, 1);
			long[] newtime = new long[1];
			newtime[0] = i + 100000;
	
			//arrayTuple2[j] = new XATMJoinTupleImp(new XATTupleImp());
			arrayTuple2[j] = new XATTupleImp();
	
			XATDataValue xatDataValue = new XATDataValueImp(new Integer(i));

			arrayTuple2[j].addCell(xatDataValue);
	
			//arrayTuple2[j].setTimeStamp(timeStamp);
			arrayTuple2[j].setTimeStamp(newtime);
			
			//arrayTuple2[j].setPunctID(i+1);
		}		
		
		try {
			store =  new StorageManager(arrayTuple1[0]);
			
			store.saveToDisk(1, arrayTuple1);
			store.saveToDisk(1, arrayTuple2);
			
			System.out.println("Size " + store.size(1));

			//XATMJoinTuple[] retrTuples = store.retrieveFromDisk(1);
			XATTuple[] retrTuples = store.retrieveFromDisk(1, false);

			for (int i = 0; i < retrTuples.length; i++) {
				System.out.println(
					"The value of the retreived Tuples  with time stamp "
						+ retrTuples[i].getCell(0).convertToDouble().intValue()
						+ " "
						//+ retrTuples[i].getTimeStamp().getTimeStamp(1)
						+ " "
						//+ retrTuples[i].getPunctID()
						);

			}

			System.out.println("Size " + store.size(1));

			store.cleanup();

		} catch (InvalidArgumentException e) {
			System.out.println("Exception" + e);
			e.printStackTrace();
		}
		
	}
}
