/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.storagemanager;
/*
 * Created on Apr 27, 2003
 *
 */

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;


/**
 * @author Nishant Mehta and Luping Ding
 * Represents an inte
 *
 */
public class LongSymbolEntry extends SimpleSymbolEntry {

	/**
	 * LongSymbolEntry
	 * @param t
	 * @param typeName
	 * @param varName
	 */
	
	public LongSymbolEntry(
		Object t,		
		String typeName,
		String varName) {			
		super(t, typeName, varName);	
	}
	/** 
	 * @see edu.wpi.cs.dsrg.conjoin.storagemanager.SymbolEntry#write(java.lang.Object, java.io.ObjectOutputStream)
	 */
	public void write(Object t, ObjectOutputStream os) {				
//		System.out.println("Writing an Long");								
			try {
				os.writeLong(((Long) t).longValue());
			} catch (IOException e) {			
				e.printStackTrace();
			}			
															
	}
	/**
	 * @see edu.wpi.cs.dsrg.conjoin.storagemanager.SymbolEntry#read(java.io.ObjectInputStream)
	 */
	
	public Object read(ObjectInputStream oi)	
		{					
			Long l = null;
//			System.out.println("In read of Long Symbol Entry");			
			try {
				l = new Long(oi.readLong());
				//System.out.println("Read a Long value :"+l.longValue());
			} catch (IOException e) {				
				e.printStackTrace();
			}
			return(l);
		}																				
}

