/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.storagemanager;

import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.io.IOException;

/**
 * An edited version of the ObjectOutputStream class which allows 
 * appends to an existing serialized file. This solution was found
 * at: http://java.sun.com/developer/qow/archive/98/.
 * 
 * @author Natasha Bogdanova
 */
public class ObjectOutputStreamNoHeader extends ObjectOutputStream {
	
	public ObjectOutputStreamNoHeader(OutputStream out) throws IOException {
		super(out);
	}
	
	/**
	 * This edit makes the stream not write a header, therefore allowing
	 * new objects to be appended without errors.
	 * 
	 * Creation Date: (Jun 2, 2004 2:43:10 PM)
	 */
	protected void writeStreamHeader() throws IOException {
		// nothing goes here.
	}
}
