/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.storagemanager;

/**
 * @author Nishant Mehta and Abhishekh Kumar
 */
public class PathForPrimitive{
	
	String typeName;
	String varaibleName;
	String pathExpression;
	
	public PathForPrimitive(String typeName,String variableName,String pathExpression)	
	{
		this.typeName = typeName;
		this.varaibleName = variableName;
		this.pathExpression = pathExpression;
		
	}
	
	public void addToPathExpression(String extension)
	{
		pathExpression += extension;
	}	

	/**
	 * Returns the pathExpression.
	 * @return String
	 */
	public String getPathExpression() {
		return pathExpression;
	}

	/**
	 * Returns the typeName.
	 * @return String
	 */
	public String getTypeName() {
		return typeName;
	}

	/**
	 * Returns the varaibleName.
	 * @return String
	 */
	public String getVaraibleName() {
		return varaibleName;
	}

	/**
	 * Sets the pathExpression.
	 * @param pathExpression The pathExpression to set
	 */
	public void setPathExpression(String pathExpression) {
		this.pathExpression = pathExpression;
	}

	/**
	 * Sets the typeName.
	 * @param typeName The typeName to set
	 */
	public void setTypeName(String typeName) {
		this.typeName = typeName;
	}

	/**
	 * Sets the varaibleName.
	 * @param varaibleName The varaibleName to set
	 */
	public void setVaraibleName(String varaibleName) {
		this.varaibleName = varaibleName;
	}

}
