/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.
package edu.wpi.cs.dsrg.xmldb.xat.component.storagemanager;
/*
 * Created on Apr 26, 2003
 * 
 */

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;


/**
 * @author Luping Ding and Nishant Mehta
 */
public abstract class SymbolEntry {
	
/**Stores the the type Name*/	
protected String typeName = null;
/**Stores the variabel name*/
protected String varName = null;


/**
 * @param pathName
 * @param typeName
 * @param varName
 */
public SymbolEntry(Object t, String typeName, String varName) {	
	this.typeName = typeName;
	this.varName = varName;	
	int i = 0;
	
	//Figuring out if it is a primitive type or no	
	Class theClass = t.getClass();
	if (theClass.isArray()) {		
	}		
	Object obj = t;
}

/**
 * @see java.lang.Object#toString()
 */
public String toString()
{
	return(this.varName+"  "+this.typeName+" "+" "+"\n");
}

/**
 * This follows the byte path in the given object and writes the byte representation
 * of the object to the outputStream
 * @param t
 * @param os
 */
public abstract void write(Object t,ObjectOutputStream os);
	
/**
 * Reads from the object input stream creates a new object
 * and returns the reference to that object
 * @param oi
 * @return
 */
public abstract Object read(ObjectInputStream oi);

/**
 * Returns the string representation of this Symbol entry
 * @return
 */
public abstract String returnString();

}

