
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow StreamGenerator 1.0.
//
//  Copyright 2003-2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Bin Liu, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang,Xin Zhang, Yali Zhu, Timothy Sutherland,
//  Bradley Momberger, Ming Li, and Rimma Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the DSRG Development Team: <dsrg@CS.WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;

import java.util.ArrayList;

/**
 * Insert the type's description here.
 * Creation date: (5/22/2003 10:34:09 AM)
 * @author: Yali Zhu
 */
public class ExponentialRandomGenerator extends RandomGenerator 
{
	double mean;
	//double lambda; // the mean arrival rate for a stream
	/**
	 * Insert the method's description here.
	 * Creation date: (5/23/2003 5:01:59 AM)
	 */
	public ExponentialRandomGenerator(ArrayList vecIntervals) 
	{
		super(vecIntervals);
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/22/2003 11:07:42 AM)
	 * @param mean double
	 */
	public ExponentialRandomGenerator(ArrayList vecInterArrivals, long seed) 
	{
	    super(vecInterArrivals, seed);
		//this.lambda = lambda;
	}
	/**
	 * Insert the method's description here.
	 *
	 * This method generates the next inter-arrival time for a stream, given the mean arrival rate of a stream as lambda.
	 *
	 * Returns an exponentially distributed, positive, random deviate of unit mean,  
	 * using ran1(idum) as the source of uniform deviates.
	 *
	 * Creation date: (5/22/2003 10:35:12 AM)
	 * @return double
	 */
	public double exponentialRand() 
	{
		//double ran1(long idum);	
		double dum;
	
		do dum = uniformRand();
		while (dum == 0.0);
	
		return -mean * Math.log(dum);	
	}
	
	/**
	 * Insert the method's description here.
	 * Creation date: (5/22/2003 10:34:09 AM)
	 */
	public double generateRandom(long currentTimeStamp) 
	{
		super.updateIntervals(currentTimeStamp);
		return exponentialRand();
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/22/2003 10:11:47 AM)
	 * @param mean int
	 */
	public void updateMean(double mean) 
	{
		this.mean = mean;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/22/2003 10:11:47 AM)
	 * @param mean int
	 */
	public void updateMean(int mean) 
	{
		this.mean = mean;
	}
	
	/**
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.RandomGenerator#updateMeanInterval(int)
	 */
	public void updateMeanInterval(int avgInterval) 
	{
		this.mean = avgInterval;		
	}
}
