/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow StreamGenerator 1.0.
//
//  Copyright 2003-2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Bin Liu, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang,Xin Zhang, Yali Zhu, Timothy Sutherland,
//  Bradley Momberger, Ming Li, and Rimma Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the DSRG Development Team: <dsrg@CS.WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;
import java.io.FileNotFoundException;

/**
 * @author 
 * This class is used to make the tuple readers
 */
public class Factory {

private static Factory factory = null;
	/**
	* Constructs a new factory 
	*/
	private Factory()
	{}
 	
 	public static Factory getInstance()
 	{
 		if(factory == null)
 		 return(new Factory());
 		else
 			return(factory);
 	}
 	
 
	
	/**
	 * @param attrDelimeter
	 * @param recDelimeter
	 * @param schema
	 * @param rg
	 */
	public StreamTupleReader makeStreamTupleReader(String identifier,String[] inputFileNames,String attrDelimeter, char recDelimeter, Schema schema, RandomGenerator rg) throws FileNotFoundException {
		StreamTupleReader str = new StreamTupleReaderDistImp(identifier,inputFileNames,attrDelimeter,recDelimeter,schema,rg);
		return(str);		
	}

	/**
	 * @param attrDelimeter
	 * @param recDelimeter
	 * @param schema
	 * @param columnName
	 */
	public StreamTupleReader makeStreamTupleReader(String identifier,String[] inputFileNames,String attrDelimeter, char recDelimeter, Schema schema, String columnName,String format) throws FileNotFoundException {
		StreamTupleReader str = new StreamTupleReaderColumnImp(identifier,inputFileNames,attrDelimeter,recDelimeter,schema,columnName,format);
		return(str);		
	}
	
	// make streamTupleReader for random generated data
	public StreamTupleReader makeStreamTupleReader(String identifier,String attrDelimeter, char recDelimeter, Schema schema, RandomGenerator rg, String sourceName)throws FileNotFoundException {
		StreamTupleReader str = new newTupleGeneratorImp(identifier, attrDelimeter, schema, rg, sourceName);
		return (str);
	}
	

 
}
