
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow StreamGenerator 1.0.
//
//  Copyright 2003-2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Bin Liu, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang,Xin Zhang, Yali Zhu, Timothy Sutherland,
//  Bradley Momberger, Ming Li, and Rimma Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the DSRG Development Team: <dsrg@CS.WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////
package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;

import java.io.FileNotFoundException;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStamp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;

/**
 * @author 
 *
 * This class sets the time stamp once it reads the values from the file
 * One main issue to be resolved here is the mapping of the column value to the
 * time stamp 
 */
public class StreamTupleReaderColumnImp
	extends StreamTupleReaderTextImp
	implements StreamTupleReader {
	/**Stores the name of the column that is to be used as the time stamp*/
	private String columnName;
	/**Stores the format of the column which is to be used as time stamp*/
	private String format;
	/**Used to parse the date to convert into a real time stamp*/
	SimpleDateFormat formatter = null;
	/**Stores the timestamp to reference timeStamp all the other time stamps are set with reference to this time stamp*/
	Date refDate= null;
	
	/**
	 * @param inputFileName
	 * @param attrDelimeter
	 * @param recDelimeter
	 * @param schema
	 */
	
	public StreamTupleReaderColumnImp(
		String identifier,
		String[] inputFileNames,
		String attrDelimeter,
		char recDelimeter,
		Schema schema,
		String columnName,
		String format) throws FileNotFoundException {
		super(identifier,inputFileNames, attrDelimeter, recDelimeter, schema);
		this.columnName = columnName;
		this.format = format;	
		if(format.compareTo("long") == 0) {
			System.out.println("TimeStamp Format: "+format);
		}
		else if(format.compareTo("double") == 0) {
			System.out.println("TimeStamp Format: "+format);
		}	
		else {
			System.out.println("Date Format: "+format);
			formatter = new SimpleDateFormat(this.format);		
		}										  
	}

	/**
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server.StreamTupleReaderTextImp#setTimeStamp(long, edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple)
	 * Still have to implement this method the main function
	 * reading the value of the cloumn using the schema 
	 * and then mapping this value into a time stamp and then 
	 * writing this new value
	 */
	public void setTimeStamp(long currentTimeStamp, XATTuple tuple) throws RecordParseException 
	{
		int position = schema.getPosition(columnName);
		XATDataValue value = tuple.getCell(position);
		String date = value.convertToString();
		Date newDate;
		long timeStamp=0;
		
		if(format.compareTo("long") == 0) {
			if (date.equals("")) {
				timeStamp = currentTimeStamp;
			} else {
				//timeStamp = Long.parseLong(date)*5;
				timeStamp = Long.parseLong(date);
			}
		}
		else if(format.compareTo("double") == 0) {
			timeStamp = (long)Double.parseDouble(date);
		}	
		else {
			try {
				//System.out.println("Date: "+date);
				newDate = formatter.parse(date);
			} catch (ParseException e) {
				throw (new RecordParseException(e));
			}
			if (this.refDate == null)
				refDate = newDate;

			timeStamp = newDate.getTime() - this.refDate.getTime();
		}
		//try {
			//XATTimeStamp xast = new XATTimeStampImp();
			//xast.setTimeStamp(timeStamp, tuple);
			tuple.setUniTimeStamp(timeStamp);
		//} catch (XATTimeStampException e) {
		//	e.printStackTrace();
		//}
		
	}

	
}
