
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow StreamGenerator 1.0.
//
//  Copyright 2003-2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Bin Liu, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang,Xin Zhang, Yali Zhu, Timothy Sutherland,
//  Bradley Momberger, Ming Li, and Rimma Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the DSRG Development Team: <dsrg@CS.WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;


import java.io.FileNotFoundException;

//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStamp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * @author Administrator
 * This class sets the time stamps of the XATTuples using the
 * distribution generator. 
 */
public class StreamTupleReaderDistImp
	extends StreamTupleReaderTextImp
	implements StreamTupleReader {

	private RandomGenerator rg = null;
	
	/**
	 * @param inputFileName
	 * @param attrDelimeter
	 * @param recDelimeter
	 * @param schema
	 * @param rg
	 */
	public StreamTupleReaderDistImp(
		String identifier,
		String[] inputFileNames,
		String attrDelimeter,
		char recDelimeter,
		Schema schema,
		RandomGenerator rg) throws FileNotFoundException {
		super(identifier,inputFileNames, attrDelimeter, recDelimeter, schema);
		this.rg = rg;		
	}

	
	/**
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server.StreamTupleReaderTextImp#setTimeStamp(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple)
	 */
	public void setTimeStamp(long currentTimeStamp,XATTuple tuple) {
			double d = rg.generateRandom(currentTimeStamp);
			
			//the timestamp is randomly generated by the random generaator.
			long timeStamp = (long) (d + currentTimeStamp);	
			tuple.setUniTimeStamp(timeStamp);
					
//			XATTimeStamp xast = new XATTimeStampImp();			
//			try {
//				//This method sets the time stamps and uses the current tuple
//				//to set the start and the end time stamps
//				xast.setTimeStamp(timeStamp,tuple);
//				
//				tuple.setTimeStamp(xast);
//								
//			} catch (XATTimeStampException e) {				
//				e.printStackTrace();
//			}	

	}


	

	
}
