/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow StreamGenerator 1.0.
//
//  Copyright 2003-2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Bin Liu, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang,Xin Zhang, Yali Zhu, Timothy Sutherland,
//  Bradley Momberger, Ming Li, and Rimma Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the DSRG Development Team: <dsrg@CS.WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;

import java.io.IOException;
import java.io.StreamTokenizer;
import java.io.StringReader;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;


/**
 * 
 * @author 
 * A class used to test the working of the random generator
 */
public class Tester {

	/**
	 *  
	 */
	public Tester() {
		ArrayList al = new ArrayList();
		double[] arrIntervals = new double[2];
		arrIntervals[0] =  0;
		arrIntervals[1] = 2000;
			al.add(arrIntervals);
		arrIntervals = new double[2];
		arrIntervals[0] = 10000;
		arrIntervals[1] = 500;
			al.add(arrIntervals);
			
		long startTime = -1;
		long globalTime = -1;	
		startTime = System.currentTimeMillis();
		
		RandomGenerator rg = new ExponentialRandomGenerator(al,1);
		
		while(true)
		{
			globalTime = System.currentTimeMillis()- startTime;
			long nextTime =  (long) rg.generateRandom(globalTime)+globalTime;
			System.out.println("Next tuple time = "+ nextTime);
			
				while(globalTime < nextTime)
					globalTime = System.currentTimeMillis()- startTime;
			
			System.out.println("Output a tuple :"+(System.currentTimeMillis()-startTime));
		}
	}
	
	
	public static void main(String[] args)
	{
//		Tester t = new Tester();

		SimpleDateFormat formatter = new SimpleDateFormat(" EEE MMM dd HH-mm-ss yyyy");
		try {
			Date oldDate = formatter.parse(" Tue Aug 22 00-00-00 1995 ");
			long timeStampold = oldDate.getTime();
			  						
			
			
		} catch (ParseException e) {			
			e.printStackTrace();
		}

		try {
				// Create the tokenizer to read from a file
				String newString = new String("141.243.1.172 [29:23:53:25] \"GET /Software.html HTTP/1.0\" 200 1497");
				
				StringReader rd = new StringReader(newString);
								
				StreamTokenizer st = new StreamTokenizer(rd);
				
    			st.wordChars(0,255);				
				
								
    												    				
				// Parse the file
				int token = st.nextToken();
				
				while (token != StreamTokenizer.TT_EOF) {
					token = st.nextToken();
					switch (token) {				
					case StreamTokenizer.TT_WORD:
						// A word was found; the value is in sval
						String word = st.sval;
						System.out.println(" The Word is "+word);
						break;
					case '"':
						// A double-quoted string was found; sval contains the contents
						String dquoteVal = st.sval;
						System.out.println("The token is "+dquoteVal);
						break;
					case '\'':
						// A single-quoted string was found; sval contains the contents
						String squoteVal = st.sval;
						System.out.println("The single quote "+squoteVal);
						break;
					case StreamTokenizer.TT_EOL:
						// End of line character found
						break;
					case StreamTokenizer.TT_EOF:
						// End of file has been reached
						break;
					default:
						// A regular character was found; the value is the token itself
						char ch = (char)st.ttype;
						System.out.println("The char is "+ch);
						break;
					}
				}
				rd.close();
			} catch (IOException e) {
				e.printStackTrace();
			}



	}

}
