/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow StreamGenerator 1.0.
//
//  Copyright 2003-2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Bin Liu, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang,Xin Zhang, Yali Zhu, Timothy Sutherland,
//  Bradley Momberger, Ming Li, and Rimma Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the DSRG Development Team: <dsrg@CS.WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;
import java.io.IOException;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;


/**
 * Defines an interface
 * @author: Yali Zhu
 */
public interface XATStream {

/**
 * This method should make a new Tuple set the time stamp and
 * the return the new XATTuple to the stream controller
 * @param position int
 * @param value int
 */
XATTuple makeNewTuple(long newGlobalTimer) throws IOException,RecordParseException;

/**
 * @param flag
 * @return
 */
boolean setDebug(boolean flag);

/**
 * Returns a String that represents the value of this object.
 * @return a string representation of the receiver
 */
String toString();

/**
 * Called when the stream is to be removed from the system
 * Closes all open files and performs all other necessary cleanup
 * operations 
 */
public void cleanup();

/**
 * Returns true if the stream has ended
 * @return
 */
public boolean isOver();

/**
 * This method is used to start the stream
 */
public void startStream();


/**
 * @return
 */
public String getStreamName();

public int getStreamNumber();
/**
 * This returns the queue schema for the stream
 * @return
 */
public XATQueueSchema getXATSchema();


}
