/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow StreamGenerator 1.0.
//
//  Copyright 2003-2005, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Bin Liu, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang,Xin Zhang, Yali Zhu, Timothy Sutherland,
//  Bradley Momberger, Ming Li, and Rimma Nehme
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the DSRG Development Team: <dsrg@CS.WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////


package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;
import java.io.BufferedWriter;
import java.io.EOFException;
import java.io.IOException;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStamp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * Insert the type's description here.
 * Creation date: (2/4/2003 4:33:04 PM)
 * @author: Yali Zhu
 */
/**
 * Check to see if this works without total run time or else include this
 */
 
public class XATStreamImp implements XATStream {
	
	/**Stores the name of the input file*/
	private String[] fileName = null;
	/**A boolean value set to true when the stream ends*/
	private boolean streamEnded = false;
	/**Indicates the end Of intervals*/	
	private boolean endOfIntervals;
	/**Stores the streamId*/
	private String streamID;
	/**Stores the currentTimeStamp*/	
	private long currentTimeStamp = 0;	
	/**Stores the total run time for the stream*/	
	private long totalRunTime;					
	/**Stores the flag*/
	private boolean debug = false;			
	/**Stores the reference to the tuple reader that reads the tuples from the  input file*/
	private StreamTupleReader tupleReader = null;
	/**Just used for evaluation purposes*/
	private BufferedWriter out = null; 
	private int streamNumber = -1;
	
/**
 * @param streamName
 * @param inputFileName
  * @throws IOException
 */
public XATStreamImp(
	String streamName,
	int streamNumber,
	String[] inputFileNames,
	StreamTupleReader str
	)
	
	throws IOException {
		this.streamID = streamName;
		this.streamNumber = streamNumber;
		fileName = new String[inputFileNames.length];
		for(int i=0; i<inputFileNames.length;i++){
			this.fileName[i] = inputFileNames[i];
		}

		this.tupleReader = str;														
		//out = new BufferedWriter(new FileWriter(streamID+"sta.txt"));  					
	}


/**
 * This method is used to start the stream
 */
public void startStream()
{	
	System.out.println("Starting the stream");
	System.out.println("Implement the start stream method this has not been implemented as yet");
}


/**
 * Insert the method's description here.
 * Creation date: (2/9/2003 5:51:52 PM)
 * @return int
 */
public long getCurrentTimeStamp() {
	return currentTimeStamp;
}

public int getStreamNumber(){
	return this.streamNumber;
}
///**
// * Need to recode this method
// * @return int
// */
//public long getNewTimeStamp() {
//
//	try {
//		//Note end of interval is a just a hack to get the code running
//		//would like to recode the methid. No need of useing an arraylist to store the interval list
//		//you could simlpy store it as a primitve array
//		if(!endOfIntervals)
//		{
//		
//		if (nextIntervalUpdateTime <= currentTimeStamp) {
//			
//			double[] currentInterval = (double [])intervalList.get(nextIntervalUpdateIndex);
//			
//			avgInterval = (int) currentInterval[1];
//			
//			this.randomGenerator.updateMeanInterval(avgInterval);
//			
//			nextIntervalUpdateIndex++;
//			
//			if (nextIntervalUpdateIndex < intervalList.size()) {
//				currentInterval = (double [])intervalList.get(nextIntervalUpdateIndex);
//				nextIntervalUpdateTime = currentInterval[0];
//			} else//This is the last interval you do not
//			//need to update the interval list from here 
//			{
//				endOfIntervals = true;
//			}
//		}
//	}
//	} catch (IndexOutOfBoundsException e) {
//		System.out.println(e.toString());
//		e.printStackTrace();
//	}
//
//	double i = randomGenerator.generateRandom();
//	//System.out.println(streamID + " poisson interval = " + i);
//	long tempTimeStamp = this.getCurrentTimeStamp();
//	tempTimeStamp += (long)i;
//	return(tempTimeStamp);
//}

/**
 * This method generates a new currentTuple, with a new timestamp following the distribution, and a new set of cell values
 * randomly selected according to each cell's default data range. It then enqueue the currentTuple to streamQ.
 * return: If the currentTimestamp is larger than the system running time, the method returns -1, without generating any
 * new tuples.
 * If not, the method generates a new tuple and enqueue it into streamQ associated with this stream.
 *
 */
public XATTuple makeNewTuple(long newGlobalTimer) throws IOException, RecordParseException {

		XATTuple currentTuple = null;
	//	long startTime = System.currentTimeMillis();				
	try
	{																				
		currentTuple = tupleReader.getNextTuple(newGlobalTimer);													
						
	}catch (IOException e) {
	if (e instanceof EOFException) {
			this.streamEnded = true;
			//this means that the stream has ended now
			//therefore we need to do the following
			throw(e);			
		}
	}
								
	
	//long endTime = System.currentTimeMillis();
		
	//out.write("The amount of time ="+ (endTime-startTime));	
	//out.write("\n\n");
	
	/**Returning the new Tuple*/
	return currentTuple;	
}

/**
 * 
 * @return boolean
 * @param flag boolean
 */
public boolean setDebug(boolean flag) {
	debug = flag;
	return debug;
}

/**
 * Sets the time stamp inside tuple
 * @param currentTuple
 */
protected void setTupleTimeStamp(XATTuple currentTuple,long timeStamp) {
	currentTuple.setUniTimeStamp(timeStamp);
//	XATTimeStamp xatTimeStamp = new XATTimeStampImp();	
//	try {
//		xatTimeStamp.setTimeStamp(timeStamp,1,1);
//		currentTuple.setTimeStamp(xatTimeStamp);
//	} catch (Exception e) {
//		e.printStackTrace();
//	}		
}
/**
 * Returns a String that represents the value of this object.
 * @return a string representation of the receiver
 */
public String toString() {
	// Insert code to print the receiver here.
	// This implementation forwards the message to super. You may replace or supplement this.
	//return "\n\nXATStream: " + streamID + " \nTuple in Queue: + " + streamQ.toString();
	String rs = new String();

	String sName = this.getClass().getName();
	//find the last dot.
	int index = 0;
	for(index = sName.length()-1; index >=0; index--)
		if(sName.charAt(index) == '.')
			break;
	rs = sName.substring(index + 1) + " " + hashCode(); // + "  data:";
	return rs;
 }


public void cleanup() 
{
	try {
		out.close();
	} catch (IOException e) {		
		e.printStackTrace();
	}
}

/**
 * @see edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.XATStream#isOver()
 * Note this method implementation is synchronized
 */
public synchronized boolean isOver() {
	return(streamEnded);	
}


/**
 * @see XATStream#getStreamName()
 */
public String getStreamName() {	
	return streamID;
}


/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server.XATStream#getXATSchema()
 */
public XATQueueSchema getXATSchema() {
	return(tupleReader.getXATSchema());		
}
}
