/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Random;
import java.util.UUID;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstate.GroupbyHashEntry;

public class newTupleGeneratorImp implements StreamTupleReader {
	
	private String identifier = null;
	/**Stores the name of the input File*/
	String[] inputFiles = null;
	/**Sores the attribute delimeter*/
	String attrDelimeter = null;
	/**Stores the record delimeter*/
	char recDelimeter;
	/**Stores the reference to the schema*/
	Schema schema  = null;
	int count;
	int recordNo;
	//int cycleLoopNo;
	String couponId;
	int InLoopCounter;
	RandomGenerator rg;
	//Hashtable tab = new Hashtable();
	HashMap tab = new HashMap(); 
	String sourceName;
	
	public enum eventType {create, view, print, redeem};
	
	public newTupleGeneratorImp(String identifier,
			String attrDelimeter,
			Schema schema, RandomGenerator rg, String sourceName) throws FileNotFoundException {
		this.identifier = identifier; //stream name 
		this.attrDelimeter = attrDelimeter; // 
		this.recDelimeter = recDelimeter;
		this.schema = schema;
		this.count =0;
		this.recordNo =0;
		//this.cycleLoopNo =1;
		this.InLoopCounter =0;
		this.rg = rg;
		this.sourceName= sourceName;
		
//gets the input file
/*File f = new File(inputFiles[0]);
double size= f.length()/1048576.0;
System.out.println("Now generating stream " + identifier + " from file " + inputFiles[0]+".");
System.out.println("The size of this file is "+size+"MB.");*/

//reads from the file

}
	/**
	 * Generat a new random value tuple based on the schema
	 * the value. Note this tuple could either be a strExpression tuple
	 * data tuple
	 * @return XATStreamTuple
	 * @throws IOException
	 */
	public XATTuple getNextTuple(long currentTimeStamp) throws IOException,RecordParseException

	{
		String strRecord;
		//recordNo++;
		//String strRecord = genTupleBySchema(schema, recordNo, attrDelimeter);
		if (sourceName.compareToIgnoreCase("bank") ==0) 
		 strRecord = GenBankTupleString();
		else 
		strRecord = GenCouponTupleString();
		//String strRecord =GenUnOrderedTupleString();
		XATTuple tuple = schema.parse(strRecord,this.attrDelimeter);
		
		
		//System.out.println("cycleLoopNo"+ cycleLoopNo);
		System.out.println("recordNo " + recordNo);
		//System.out.println("")
		this.setTimeStamp(currentTimeStamp,tuple);
		System.out.println("Generate tuple " + tuple.toString());
		
		count = count + 1;	
		return tuple;
		
	}
	/**
	 * Returns the XATQueue schema for the tuples that the tuple reader reads
	 */
	public XATQueueSchema getXATSchema() {		
		return this.schema.makeXATSchema();
	}
	
	public void setTimeStamp(long currentTimeStamp,XATTuple tuple) {
		double d = rg.generateRandom(currentTimeStamp);
		
		//the timestamp is randomly generated by the random generaator.
		long timeStamp = (long) (d + currentTimeStamp);	
		tuple.setUniTimeStamp(timeStamp);
				
//		XATTimeStamp xast = new XATTimeStampImp();			
//		try {
//			//This method sets the time stamps and uses the current tuple
//			//to set the start and the end time stamps
//			xast.setTimeStamp(timeStamp,tuple);
//			
//			tuple.setTimeStamp(xast);
//							
//		} catch (XATTimeStampException e) {				
//			e.printStackTrace();
//		}	

}
	
	
	// Generate different event types based on some probablility
	public String  GenCouponTupleString()
	{
		
		Random randomGenerator = new Random(System.currentTimeMillis() );
		int i = 0;
		int j =1;
		long t1 = System.currentTimeMillis();
		//int loopCount = 1000000;
		boolean genSuccess = false;
		String curString=null;
		
		
		while (!genSuccess) {
			double randomDouble = randomGenerator.nextDouble();
			// Arrival rate
			if(randomDouble < 0.5) {
				UUID uuid = UUID.randomUUID();
				couponId = uuid.toString().substring(0, 13); 
				tab.put(couponId, 0);
				InLoopCounter = 0;
			} else {
				// pick from the existing UUIDs in table
				if (tab.size()> 0)
				{
					int index = randomGenerator.nextInt(tab.size());
					couponId = (String)tab.keySet().toArray()[index]; 
					InLoopCounter = ((Integer)tab.get(couponId)).intValue() + 1;
				} else {
					UUID uuid = UUID.randomUUID();
					couponId = uuid.toString().substring(0, 13); 
					tab.put(couponId, 0);
					InLoopCounter = 0;
				}
			}
			//double randomDouble2 = randomGenerator.nextDouble();
			//double randomDouble3 = randomGenerator.nextDouble();
			//double randomDouble4 = randomGenerator.nextDouble();
			System.out.println("InLoopCounter " + InLoopCounter);
			System.out.println("UUID " + couponId);
			//System.out.println("UUID " + couponId);
			switch (InLoopCounter){
				
			case 0:
				recordNo++;
				//cycleLoopNo++;	
				curString = genOrderedTupleBySchema("create");
				//InLoopCounter = (InLoopCounter+1)%4;
				genSuccess = true;
				break;
				
			case 1:
				if (randomDouble< 0.8)
				{
					recordNo++;
					curString =genOrderedTupleBySchema("view");
					genSuccess = true;
					tab.put(couponId, 1);
					//InLoopCounter= (InLoopCounter+1)%4;
					if(randomDouble < 0.2) {
						tab.remove(couponId);
					}
				} 
				break;
				
			case 2:
				if (randomDouble<0.8)
				{
					recordNo++;
					 curString =genOrderedTupleBySchema("print");
					
					genSuccess = true;
					tab.put(couponId, 2);
					//InLoopCounter= (InLoopCounter+1)%4;
					if(randomDouble < 0.2) {
						tab.remove(couponId);
					}
				} 
				break;
			case 3:
				if (randomDouble<0.7)
				{
					recordNo++;
					curString =genOrderedTupleBySchema("redeem");
					genSuccess = true;
					tab.put(couponId, 3);
					//InLoopCounter= (InLoopCounter+1)%4;
					if(randomDouble < 0.2) {
						tab.remove(couponId);
					}
				} 
				break;
			}		
		}
		return curString;

	}
	
//	 Generate different event types based on some probablility
	public String  GenBankTupleString()
	{
		
		Random randomGenerator = new Random(System.currentTimeMillis() );
		int i = 0;
		int j =1;
		long t1 = System.currentTimeMillis();
		//int loopCount = 1000000;
		boolean genSuccess = false;
		String curString=null;
		
		
		while (!genSuccess) {
			double randomDouble = randomGenerator.nextDouble();
			// Arrival rate
			if(randomDouble < 0.5) {
				UUID uuid = UUID.randomUUID();
				couponId = uuid.toString().substring(0, 13); 
				tab.put(couponId, 0);
				InLoopCounter = 0;
			} else {
				// pick from the existing UUIDs in table
				if (tab.size()> 0)
				{
					int index = randomGenerator.nextInt(tab.size());
					couponId = (String)tab.keySet().toArray()[index]; 
					InLoopCounter = ((Integer)tab.get(couponId)).intValue() + 1;
				} else {
					UUID uuid = UUID.randomUUID();
					couponId = uuid.toString().substring(0, 13); 
					tab.put(couponId, 0);
					InLoopCounter = 0;
				}
			}
			//double randomDouble2 = randomGenerator.nextDouble();
			//double randomDouble3 = randomGenerator.nextDouble();
			//double randomDouble4 = randomGenerator.nextDouble();
			System.out.println("InLoopCounter " + InLoopCounter);
			System.out.println("UUID " + couponId);
			//System.out.println("UUID " + couponId);
			switch (InLoopCounter){
				
			case 0:
				recordNo++;
				//cycleLoopNo++;	
				curString = genBankTupleBySchema("CDOffer");
				//InLoopCounter = (InLoopCounter+1)%4;
				genSuccess = true;
				break;
				
			case 1:
				if (randomDouble< 0.9)
				{
					recordNo++;
					curString =genBankTupleBySchema("Deposit");
					genSuccess = true;
					tab.put(couponId, 1);
					//InLoopCounter= (InLoopCounter+1)%4;
					if(randomDouble < 0.2) {
						tab.remove(couponId);
					}
				} 
				break;
				
			case 2:
				if (randomDouble<1)
				{
					recordNo++;
					 curString =genBankTupleBySchema("Withdraw");
					
					genSuccess = true;
					tab.put(couponId, 2);
					//InLoopCounter= (InLoopCounter+1)%4;
					if(randomDouble < 0.2) {
						tab.remove(couponId);
					}
				} 
				break;
			case 3:
				if (randomDouble<0.7)
				{
					recordNo++;
					curString =genBankTupleBySchema("Transfer");
					genSuccess = true;
					tab.put(couponId, 3);
					//InLoopCounter= (InLoopCounter+1)%4;
					if(randomDouble < 0.2) {
						tab.remove(couponId);
					}
				} 
				break;
			}		
		}
		return curString;

	}
	
//	 Generate different event types based on some probablility
	public String  GenSimpleBankTupleString()
	{
		int[] customers= new int[10];
		for(int ii= 0; ii < 10; ii++) 
			customers[ii] = 123450 + ii;
		Random randomGenerator = new Random(System.currentTimeMillis() );
		int i = 0;
		int j =1;
		long t1 = System.currentTimeMillis();
		//int loopCount = 1000000;
		boolean genSuccess = false;
		String curString=null;


		couponId = Integer.toString(customers[randomGenerator.nextInt(10)]);

		// choose a random type from the enum type
		int randomInt1= randomGenerator.nextInt(4);
		switch (randomInt1){
		case 0: 
			curString = genBankTupleBySchema("Withdraw");

			break;
		case 1:
			curString =genBankTupleBySchema("Deposit");

			break;
		case 2:
			curString =genBankTupleBySchema("Transfer");

			break;
		case 3:
			curString =genBankTupleBySchema("CDOffer");

			break;

		}	

		recordNo++;

		
		return curString;

	}
	
	
//	 Generate different event types based on some probablility
	public String  GenUnOrderedTupleString()
	{
		
		Random randomGenerator = new Random(System.currentTimeMillis() );
		int i = 0;
		int j =1;
		long t1 = System.currentTimeMillis();
		int loopCount = 1000000;
		//boolean genSuccess = false;
		String curString=null;
		//while (!genSuccess) {
			double randomDouble = randomGenerator.nextDouble();
			//double randomDouble2 = randomGenerator.nextDouble();
			//double randomDouble3 = randomGenerator.nextDouble();
			//double randomDouble4 = randomGenerator.nextDouble();
			System.out.println("InLoopCounter " + InLoopCounter);
			
			if (randomDouble>0.5 && randomDouble <1)
			{
				recordNo++;
				 curString = genOrderedTupleBySchema("create");
				 //InLoopCounter = (InLoopCounter+1)%4;
				//genSuccess = true;
			}
				
				else if (randomDouble>0.2 && randomDouble <=0.5)
				{					recordNo++;
					 curString =genOrderedTupleBySchema("view");
					
					
				}
				/*else if (randomDouble>0.2 && randomDouble <=0.5)
				InLoopCounter= (InLoopCounter+1)%4;
				break;
				
			case 2:
				if (randomDouble<0.6)
				{
					recordNo++;
					 curString =genOrderedTupleBySchema("print");
					
					
				}
				InLoopCounter= (InLoopCounter+1)%4;
				break;
			
			
			case 3:
				if (randomDouble<0.6)
				{
					recordNo++;
					curString =genOrderedTupleBySchema("redeem");
					
				}
				InLoopCounter= (InLoopCounter+1)%4;
				cycleLoopNo++;
				break;
			}*/
		
		
		return curString;

	}
	
	
	//	public abstract void  setTimeStamp(long currentTimeStamp, XATTuple tuple) throws RecordParseException ;
	
	// put the possible types to a hashtable
	public Hashtable genTypes ()
	{
		Hashtable t = new Hashtable();
		//t.put((Integer), arg1)
		return null;
	}
	
	// Generate new tuple string based on the schema, the delimiter is the attrDelimeter
	public String genTupleBySchema(Schema s, int recordNo, String attrDelimeter){
		// Iterate each column and generate the 
		Iterator it = s.getColumns().iterator();
		String record = new String();
		
		int randomInt1= Integer.MAX_VALUE;
		while (it.hasNext())
		{
			Column c = (Column)it.next();
			Random randomGenerator = new Random(System.currentTimeMillis() );
			// Iterate each column to generate each attribute;
			String colName = c.getColumnName();
			if (colName.equalsIgnoreCase("type"))
			{
				// choose a random type from the enum type
				 randomInt1= randomGenerator.nextInt(3);
				switch (randomInt1){
				case 0: 
					record = record.concat("create"+ attrDelimeter );
					System.out.println("Generate Column: "+  "create");
					break;
				case 1:
					record = record.concat("view" + attrDelimeter);
					System.out.println("Generate Column: "+  "view");
					break;
				case 2:
					record = record.concat("print"+ attrDelimeter);
					System.out.println("Generate Column: "+  "print");
					break;
				case 3:
					record = record.concat("redeem"+ attrDelimeter);
					System.out.println("Generate Column: "+  "redeem");
					break;
								
				}	
			}
			else if (colName.equalsIgnoreCase("id"))
			{
								// generate a random number from 1-10
				int randomInt2= randomGenerator.nextInt(10);
				//record = record.concat(Integer.toString(randomInt2)+attrDelimeter);
				record = record.concat(couponId+attrDelimeter);
				
			}
			else if (colName.equalsIgnoreCase("timestamp"))
			{
				// temporarily use the current recordNo
				//System.out.println("recordNo " + recordNo);
				//System.out.println(attrDelimeter);
				//record.concat(attrDelimeter);
				//System.out.println("timeStamp" + Integer.toString(recordNo));
				record = record.concat(Integer.toString(recordNo)+ attrDelimeter);
				 //record = record.concat(couponId+ attrDelimeter);
				//System.out.println("timeStamp2 " + record);
				
				
			}
			else if (colName.equalsIgnoreCase("channelID"))
			{
				// Suppose we have three channels
				int randomInt2= randomGenerator.nextInt(3);
				record = record.concat(Integer.toString(randomInt2)+attrDelimeter);
				
			}
			else if (colName.equalsIgnoreCase("value"))
			{
				// Generate a random string
				String token = Long.toString(Math.abs(randomGenerator.nextLong()), 36);
				record = record.concat(token+attrDelimeter);
			}
			else 
			{
				// generate some random value, a random string
				String token2 = Long.toString(Math.abs(randomGenerator.nextLong()), 36);
				record = record.concat(token2+attrDelimeter);
				
			}
		
		}
		
		System.out.println("Generate tuple: "+ recordNo +  record.toString());
		return record;
	
	}
	
//	 Generate new tuple string based on the schema, the delimiter is the attrDelimeter
	public String genSimpleTupleBySchema(Schema s, int recordNo, String attrDelimeter){
		// Iterate each column and generate the 
		Iterator it = s.getColumns().iterator();
		String record = new String();
		
		int randomInt1= Integer.MAX_VALUE;
		while (it.hasNext())
		{
			Column c = (Column)it.next();
			Random randomGenerator = new Random(System.currentTimeMillis() );
			// Iterate each column to generate each attribute;
			String colName = c.getColumnName();
			if (colName.equalsIgnoreCase("type"))
			{
				// choose a random type from the enum type
				 randomInt1= randomGenerator.nextInt(3);
				switch (randomInt1){
				case 0: 
					record = record.concat("create"+ attrDelimeter );
					System.out.println("Generate Column: "+  "create");
					break;
				case 1:
					record = record.concat("view" + attrDelimeter);
					System.out.println("Generate Column: "+  "view");
					break;
				case 2:
					record = record.concat("print"+ attrDelimeter);
					System.out.println("Generate Column: "+  "print");
					break;
				case 3:
					record = record.concat("redeem"+ attrDelimeter);
					System.out.println("Generate Column: "+  "redeem");
					break;
								
				}	
			}
			else if (colName.equalsIgnoreCase("id"))
			{
								// generate a random number from 1-10
				int randomInt2= randomGenerator.nextInt(10);
				record = record.concat(Integer.toString(randomInt2)+attrDelimeter);
				
				
			}
			else if (colName.equalsIgnoreCase("timestamp"))
			{
				// temporarily use the current recordNo
				//System.out.println("recordNo " + recordNo);
				//System.out.println(attrDelimeter);
				//record.concat(attrDelimeter);
				//System.out.println("timeStamp" + Integer.toString(recordNo));
				record = record.concat(Integer.toString(recordNo)+ attrDelimeter);
				//System.out.println("timeStamp2 " + record);
				
				
			}
			else if (colName.equalsIgnoreCase("channelID"))
			{
				// Suppose we have three channels
				int randomInt2= randomGenerator.nextInt(3);
				record = record.concat(Integer.toString(randomInt2)+attrDelimeter);
				
			}
			else if (colName.equalsIgnoreCase("value"))
			{
				// Generate a random string
				String token = Long.toString(Math.abs(randomGenerator.nextLong()), 36);
				record = record.concat(token+attrDelimeter);
			}
			else 
			{
				// generate some random value, a random string
				String token2 = Long.toString(Math.abs(randomGenerator.nextLong()), 36);
				record = record.concat(token2+attrDelimeter);
				
			}
		
		}
		
		System.out.println("Generate tuple: "+ recordNo +  record.toString());
		return record;
	
	}
	
//	 Generate new tuple string based on the schema, the delimiter is the attrDelimeter
	public String genOrderedTupleBySchema(String type){
		// Iterate each column and generate the 
		Iterator it = schema.getColumns().iterator();
		String record = new String();
		int randomInt1= Integer.MAX_VALUE;
		while (it.hasNext())
		{
			Column c = (Column)it.next();
			Random randomGenerator = new Random(System.currentTimeMillis() );
			// Iterate each column to generate each attribute;
			String colName = c.getColumnName();
			if (colName.equalsIgnoreCase("type"))
			{
				// choose a random type from the enum type
				record = record.concat(type+ attrDelimeter);
				// randomInt1= randomGenerator.nextInt(3);
				/*switch (randomInt1){
				case 0: 
					record = record.concat("create"+ attrDelimeter );
					System.out.println("Generate Column: "+  "create");
					break;
				case 1:
					record = record.concat("view" + attrDelimeter);
					System.out.println("Generate Column: "+  "view");
					break;
				case 2:
					record = record.concat("print"+ attrDelimeter);
					System.out.println("Generate Column: "+  "print");
					break;
				case 3:
					record = record.concat("redeem"+ attrDelimeter);
					System.out.println("Generate Column: "+  "redeem");
					break;
								
				}*/	
			}
			else if (colName.equalsIgnoreCase("id"))
			{
								// generate a random number from 1-10
				//int randomInt2= randomGenerator.nextInt(10);
				record = record.concat(couponId+attrDelimeter);
				
				
			}
			else if (colName.equalsIgnoreCase("timestamp"))
			{
				// temporarily use the current recordNo
				//System.out.println("recordNo " + recordNo);
				//System.out.println(attrDelimeter);
				//record.concat(attrDelimeter);
				//System.out.println("timeStamp" + Integer.toString(recordNo));
				record = record.concat(Integer.toString(recordNo)+ attrDelimeter);
				//System.out.println("timeStamp2 " + record);
				
				
			}
			else if (colName.equalsIgnoreCase("channelID"))
			{
				// Suppose we have three channels
				int randomInt2= randomGenerator.nextInt(3);
				record = record.concat(Integer.toString(randomInt2)+attrDelimeter);
				
			}
			else if (colName.equalsIgnoreCase("amount"))
			{
				// Generate a random string
				String token = Long.toString(randomGenerator.nextInt(25)*20);
				record = record.concat(token+attrDelimeter);
			}
			else 
			{
				// generate some random value, a random string
				String token2 = Long.toString(Math.abs(randomGenerator.nextLong()), 36);
				record = record.concat(token2+attrDelimeter);
				
			}
		
		}
		
		//System.out.println("Generate tuple: "+ recordNo +  record.toString());
		return record;
	
	}
	
	String[] bankChannels = {"Web", "Teller", "ATM", "CallCenter"};
	
//	 Generate new tuple string based on the schema, the delimiter is the attrDelimeter
	public String genBankTupleBySchema(String type){
		// Iterate each column and generate the 
		Iterator it = schema.getColumns().iterator();
		String record = new String();
		int randomInt1= Integer.MAX_VALUE;
		while (it.hasNext())
		{
			Column c = (Column)it.next();
			Random randomGenerator = new Random(System.currentTimeMillis() );
			// Iterate each column to generate each attribute;
			String colName = c.getColumnName();
			if (colName.equalsIgnoreCase("type"))
			{
				// choose a random type from the enum type
				record = record.concat(type+ attrDelimeter);
				
			}
			else if (colName.equalsIgnoreCase("id"))
			{
								// generate a random number from 1-10
				//int randomInt2= randomGenerator.nextInt(10);
				record = record.concat(couponId+attrDelimeter);
				
				
			}
			else if (colName.equalsIgnoreCase("timestamp"))
			{
				// temporarily use the current recordNo
				//System.out.println("recordNo " + recordNo);
				//System.out.println(attrDelimeter);
				//record.concat(attrDelimeter);
				//System.out.println("timeStamp" + Integer.toString(recordNo));
				record = record.concat(Integer.toString(recordNo)+ attrDelimeter);
				//System.out.println("timeStamp2 " + record);
				
				
			}
			else if (colName.equalsIgnoreCase("channelID"))
			{
				// Suppose we have three channels
				int randomInt2= randomGenerator.nextInt(4);
				//record = record.concat(Integer.toString(randomInt2)+attrDelimeter);
				if (type.compareToIgnoreCase("CDOffer") ==0)
					record = record.concat(bankChannels[0]+attrDelimeter);
				
				else{
					if (type.compareToIgnoreCase("Deposit") ==0)
					record = record.concat(bankChannels[1]+attrDelimeter);
				else
					record = record.concat(bankChannels[randomInt2]+attrDelimeter);
				}
				
			}
			else if (colName.equalsIgnoreCase("amount"))
			{
				// Generate a random string
				String token = Long.toString(randomGenerator.nextInt(25)*20);
				record = record.concat(token+attrDelimeter);
			}
			else 
			{
				// generate some random value, a random string
				String token2 = Long.toString(Math.abs(randomGenerator.nextLong()), 36);
				record = record.concat(token2+attrDelimeter);
				
			}
		
		}
		
		//System.out.println("Generate tuple: "+ recordNo +  record.toString());
		return record;
	
	}
	
	
	// based on some probablity, generate a new tuple
	public void genProbablityTuple()
	{
		// get the next type of event
		
		
	}
	
	
}
