/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils;

/**
 * records the run time of the run core method of an XATStreamOperator
 * Creation date: (4/23/2003 1:42:51 PM)
 * @author: Hong Su
 */
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class ClassExecTimeKeeper extends TimeKeeper implements Serializable {
	// the class whose certain methods the timekeeper records	
	protected Object evaluatedClass;
	protected List allFrozenTimes = new ArrayList();
	protected String methodDesc = null;
	/**
	 * ClassExecTimeKeeper constructor comment.
	 */
	public ClassExecTimeKeeper(Object evaluatedClass) {
		super();
		//all keepers are maintained in the manager
		//need to manually add in
		//ClassExecTimeKeeperMgr.addIntoMgr(this);
		this.evaluatedClass = evaluatedClass;
	}
	/**
	 * ClassExecTimeKeeper constructor comment.
	 */
	public ClassExecTimeKeeper(Object evaluatedClass, String methodDesc) {
		super();
		//all keepers are maintained in the manager
		//ClassExecTimeKeeperMgr.addIntoMgr(this);
		this.evaluatedClass = evaluatedClass;
		this.methodDesc = methodDesc;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/23/2003 5:52:08 PM)
	 * @return long
	 */
	public void addIntoFrozenTimes() {
		allFrozenTimes.add(new Long(lastStamp));
	}
	
	public long getTime(){
		return lastStamp;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/9/2003 10:23:13 PM)
	 * @return java.util.List
	 */
	public List getAllFrozenTimes() {
		return allFrozenTimes;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/9/2003 2:06:18 PM)
	 * @return java.lang.Object
	 */
	public Object getEvaluatedClass() {
		return evaluatedClass;
	}
	
	/**
	 * Insert the method's description here.
	 * Creation date: (5/10/2003 1:17:54 PM)
	 * @return java.lang.String
	 */
	public String getMethodDesc() {
		return methodDesc;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/23/2003 3:49:54 PM)
	 */
	public void reset() {
		lastStamp = 0;
		lastStartRealTime = 0;
	}

	public String toString() {
		return evaluatedClass.toString()+methodDesc;
	}
}
