/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Query Mesh 1.0 - Adaptive Data Stream Query Processing.
//
//  Copyright 2010, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Chuan Lei, Justin Lutz, 
//	Guy D. Mann, Mukesh Mulchandani, Brian Murphy, Rimma Nehme, 
//	Bradford Pielech, Alex Proschitsky, Elke A. Rundensteiner, Ling Wang,
//	Song Wang, Karen Works, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/PROJECTS/QM/index.html
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the QueryMesh Development Team: <QueryMesh@WPI.EDU>.

package edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils;

/**
 * Insert the type's description here.
 * Creation date: (2003-2-6 17:59:43)
 * @author: JinHui Jian
 */
import java.util.Vector;
 
public class TimeKeeper {

	long lastStamp = 0;
	long lastStartRealTime = 0;
	Vector records = new Vector();
/**
 * TimeKeeper constructor comment.
 */
public TimeKeeper() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (2003-2-6 18:00:15)
 * @return int
 */
public long getCurrentTime() {
	long lap = System.currentTimeMillis() - this.lastStartRealTime;
	return this.lastStamp + lap;
}
/**
 * Insert the method's description here.
 * Creation date: (2003-2-9 17:19:32)
 * @return java.util.Vector
 */
public Vector getRecords() {
	return records;
}
/**
 * Insert the method's description here.
 * Creation date: (2003-2-6 18:00:22)
 */
public void pause() {
	this.lastStamp += System.currentTimeMillis() - this.lastStartRealTime;
}
/**
 * Insert the method's description here.
 * Creation date: (2003-2-9 17:17:02)
 * @param outputSize int
 */
public void record(int outputSize) {
	records.add(new Long(getCurrentTime()));
	records.add(new Integer(outputSize));
}
/**
 * Insert the method's description here.
 * Creation date: (2003-2-6 18:00:28)
 */
public void start() {
	this.lastStartRealTime = System.currentTimeMillis();	
}
}
